#[doc = "Reader of register CONFIG"]
pub type R = crate::R<u32, super::CONFIG>;
#[doc = "Writer for register CONFIG"]
pub type W = crate::W<u32, super::CONFIG>;
#[doc = "Register CONFIG `reset()`'s with value 0x2400"]
impl crate::ResetValue for super::CONFIG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x2400
    }
}
#[doc = "Reader of field `TRIGGER_MASK`"]
pub type TRIGGER_MASK_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `TRIGGER_MASK`"]
pub struct TRIGGER_MASK_W<'a> {
    w: &'a mut W,
}
impl<'a> TRIGGER_MASK_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | ((value as u32) & 0x03);
        self.w
    }
}
#[doc = "Reader of field `TRIGGER_MODE`"]
pub type TRIGGER_MODE_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `TRIGGER_MODE`"]
pub struct TRIGGER_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> TRIGGER_MODE_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | (((value as u32) & 0x03) << 2);
        self.w
    }
}
#[doc = "Reader of field `TRIGGER_SYNC`"]
pub type TRIGGER_SYNC_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `TRIGGER_SYNC`"]
pub struct TRIGGER_SYNC_W<'a> {
    w: &'a mut W,
}
impl<'a> TRIGGER_SYNC_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Reader of field `CHANNEL_ID_EN`"]
pub type CHANNEL_ID_EN_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `CHANNEL_ID_EN`"]
pub struct CHANNEL_ID_EN_W<'a> {
    w: &'a mut W,
}
impl<'a> CHANNEL_ID_EN_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Reader of field `RECOVERY_TIME`"]
pub type RECOVERY_TIME_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `RECOVERY_TIME`"]
pub struct RECOVERY_TIME_W<'a> {
    w: &'a mut W,
}
impl<'a> RECOVERY_TIME_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 6)) | (((value as u32) & 0xff) << 6);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - 00 = triggers off 01 = software trigger only 10 = external trigger only 11 = both triggers allowed"]
    #[inline(always)]
    pub fn trigger_mask(&self) -> TRIGGER_MASK_R {
        TRIGGER_MASK_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bits 2:3 - 00 = rising external trigger 01 = falling external trigger 10 = low external trigger 11 = high external trigger"]
    #[inline(always)]
    pub fn trigger_mode(&self) -> TRIGGER_MODE_R {
        TRIGGER_MODE_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bit 4 - 0 = do not synchronize external trigger input 1 = synchronize external trigger input"]
    #[inline(always)]
    pub fn trigger_sync(&self) -> TRIGGER_SYNC_R {
        TRIGGER_SYNC_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - 0 = do not add channel ID to FIFO output data 1 = add channel ID to FIFO output data"]
    #[inline(always)]
    pub fn channel_id_en(&self) -> CHANNEL_ID_EN_R {
        CHANNEL_ID_EN_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bits 6:13 - ADC recovery time from power down"]
    #[inline(always)]
    pub fn recovery_time(&self) -> RECOVERY_TIME_R {
        RECOVERY_TIME_R::new(((self.bits >> 6) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:1 - 00 = triggers off 01 = software trigger only 10 = external trigger only 11 = both triggers allowed"]
    #[inline(always)]
    pub fn trigger_mask(&mut self) -> TRIGGER_MASK_W {
        TRIGGER_MASK_W { w: self }
    }
    #[doc = "Bits 2:3 - 00 = rising external trigger 01 = falling external trigger 10 = low external trigger 11 = high external trigger"]
    #[inline(always)]
    pub fn trigger_mode(&mut self) -> TRIGGER_MODE_W {
        TRIGGER_MODE_W { w: self }
    }
    #[doc = "Bit 4 - 0 = do not synchronize external trigger input 1 = synchronize external trigger input"]
    #[inline(always)]
    pub fn trigger_sync(&mut self) -> TRIGGER_SYNC_W {
        TRIGGER_SYNC_W { w: self }
    }
    #[doc = "Bit 5 - 0 = do not add channel ID to FIFO output data 1 = add channel ID to FIFO output data"]
    #[inline(always)]
    pub fn channel_id_en(&mut self) -> CHANNEL_ID_EN_W {
        CHANNEL_ID_EN_W { w: self }
    }
    #[doc = "Bits 6:13 - ADC recovery time from power down"]
    #[inline(always)]
    pub fn recovery_time(&mut self) -> RECOVERY_TIME_W {
        RECOVERY_TIME_W { w: self }
    }
}
