#[doc = "Reader of register FIFO_CFG"]
pub type R = crate::R<u32, super::FIFO_CFG>;
#[doc = "Writer for register FIFO_CFG"]
pub type W = crate::W<u32, super::FIFO_CFG>;
#[doc = "Register FIFO_CFG `reset()`'s with value 0x10"]
impl crate::ResetValue for super::FIFO_CFG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x10
    }
}
#[doc = "Reader of field `PACKED_READ`"]
pub type PACKED_READ_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `PACKED_READ`"]
pub struct PACKED_READ_W<'a> {
    w: &'a mut W,
}
impl<'a> PACKED_READ_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Reader of field `LEVEL`"]
pub type LEVEL_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `LEVEL`"]
pub struct LEVEL_W<'a> {
    w: &'a mut W,
}
impl<'a> LEVEL_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 1)) | (((value as u32) & 0x1f) << 1);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - 0 = one sample is packed in one 32-bit read cycle 1 = two samples are packed in one 32-bit read cycle"]
    #[inline(always)]
    pub fn packed_read(&self) -> PACKED_READ_R {
        PACKED_READ_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 1:5 - When the FIFO contains more or equal than FIFO_LEVEL samples interrupt flag FIFO_FULL interrupt will be set and DMA_Read_Req will be raised."]
    #[inline(always)]
    pub fn level(&self) -> LEVEL_R {
        LEVEL_R::new(((self.bits >> 1) & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - 0 = one sample is packed in one 32-bit read cycle 1 = two samples are packed in one 32-bit read cycle"]
    #[inline(always)]
    pub fn packed_read(&mut self) -> PACKED_READ_W {
        PACKED_READ_W { w: self }
    }
    #[doc = "Bits 1:5 - When the FIFO contains more or equal than FIFO_LEVEL samples interrupt flag FIFO_FULL interrupt will be set and DMA_Read_Req will be raised."]
    #[inline(always)]
    pub fn level(&mut self) -> LEVEL_W {
        LEVEL_W { w: self }
    }
}
