#[doc = "Reader of register FIFO_OUTPUT[%s]"]
pub type R = crate::R<u32, super::FIFO_OUTPUT>;
#[doc = "Reader of field `SAMPLE`"]
pub type SAMPLE_R = crate::R<u16, u16>;
#[doc = "Reader of field `CHAN_ID`"]
pub type CHAN_ID_R = crate::R<u8, u8>;
#[doc = "Reader of field `EMPTY`"]
pub type EMPTY_R = crate::R<bool, bool>;
#[doc = "Reader of field `SAMPLE2`"]
pub type SAMPLE2_R = crate::R<u16, u16>;
#[doc = "Reader of field `CHAN_ID2`"]
pub type CHAN_ID2_R = crate::R<u8, u8>;
#[doc = "Reader of field `EMPTY2`"]
pub type EMPTY2_R = crate::R<bool, bool>;
impl R {
    #[doc = "Bits 0:11 - Value of first converted sample"]
    #[inline(always)]
    pub fn sample(&self) -> SAMPLE_R {
        SAMPLE_R::new((self.bits & 0x0fff) as u16)
    }
    #[doc = "Bits 12:14 - Channel number of first converted sample: 000: channel _0 or CHANNEL_ID_EN =0 001: channel _1 010: channel _2 011: channel _3 100: channel _4 101: channel _5 110: reserved 111: recovery_ error"]
    #[inline(always)]
    pub fn chan_id(&self) -> CHAN_ID_R {
        CHAN_ID_R::new(((self.bits >> 12) & 0x07) as u8)
    }
    #[doc = "Bit 15 - 0: FIFO not empty 1: FIFO empty"]
    #[inline(always)]
    pub fn empty(&self) -> EMPTY_R {
        EMPTY_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bits 16:27 - Value of second converted sample. This field is only valid if PACKED_READ is set else it is 0x0"]
    #[inline(always)]
    pub fn sample2(&self) -> SAMPLE2_R {
        SAMPLE2_R::new(((self.bits >> 16) & 0x0fff) as u16)
    }
    #[doc = "Bits 28:30 - Channel number of second converted sample This field is only valid if CHANNEL_ID_EN and PACKED_READ are set else it is 0x0"]
    #[inline(always)]
    pub fn chan_id2(&self) -> CHAN_ID2_R {
        CHAN_ID2_R::new(((self.bits >> 28) & 0x07) as u8)
    }
    #[doc = "Bit 31 - 0: FIFO not empty 1: FIFO empty and PACKED_READ is set"]
    #[inline(always)]
    pub fn empty2(&self) -> EMPTY2_R {
        EMPTY2_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
