#[doc = "Reader of register LAST_SAMPLE[%s]"]
pub type R = crate::R<u32, super::LAST_SAMPLE>;
#[doc = "Reader of field `DONE`"]
pub type DONE_R = crate::R<bool, bool>;
#[doc = "Reader of field `OVERRUN`"]
pub type OVERRUN_R = crate::R<bool, bool>;
#[doc = "Reader of field `THCMP_RANGE`"]
pub type THCMP_RANGE_R = crate::R<u8, u8>;
#[doc = "Reader of field `THCMP_CROSS`"]
pub type THCMP_CROSS_R = crate::R<u8, u8>;
#[doc = "Reader of field `SAMPLE`"]
pub type SAMPLE_R = crate::R<u16, u16>;
impl R {
    #[doc = "Bit 0 - This bit is set to 1 when an A/D conversion on this channel completes. This bit is cleared whenever this register is read."]
    #[inline(always)]
    pub fn done(&self) -> DONE_R {
        DONE_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - This bit will be set to a 1 if a new conversion on this channel completes and overwrites the previous contents of the RESULT field before it has been read - i.e. while the DONE bit is set. This bit is cleared, along with the DONE bit, whenever this register is read. This bit (in any of the registers) will cause an overrun interrupt request to be asserted if the overrun interrupt is enabled."]
    #[inline(always)]
    pub fn overrun(&self) -> OVERRUN_R {
        OVERRUN_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bits 2:3 - Threshold Range Comparison result 00: In Range 01: Below Range 10: Above Range 11: Reserved"]
    #[inline(always)]
    pub fn thcmp_range(&self) -> THCMP_RANGE_R {
        THCMP_RANGE_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bits 4:5 - Threshold Crossing Comparison result 00: No Threshold Crossing detected 01: Downward Threshold Crossing detected 10: Upward Threshold Crossing detected 11: Reserved"]
    #[inline(always)]
    pub fn thcmp_cross(&self) -> THCMP_CROSS_R {
        THCMP_CROSS_R::new(((self.bits >> 4) & 0x03) as u8)
    }
    #[doc = "Bits 6:17 - 12-Bit value of last converted sample for this channel"]
    #[inline(always)]
    pub fn sample(&self) -> SAMPLE_R {
        SAMPLE_R::new(((self.bits >> 6) & 0x0fff) as u16)
    }
}
