#[doc = "Reader of register POWER_CONTROL"]
pub type R = crate::R<u32, super::POWER_CONTROL>;
#[doc = "Writer for register POWER_CONTROL"]
pub type W = crate::W<u32, super::POWER_CONTROL>;
#[doc = "Register POWER_CONTROL `reset()`'s with value 0"]
impl crate::ResetValue for super::POWER_CONTROL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `CRS`"]
pub type CRS_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `CRS`"]
pub struct CRS_W<'a> {
    w: &'a mut W,
}
impl<'a> CRS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | ((value as u32) & 0x0f);
        self.w
    }
}
#[doc = "Reader of field `DCINNEG`"]
pub type DCINNEG_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `DCINNEG`"]
pub struct DCINNEG_W<'a> {
    w: &'a mut W,
}
impl<'a> DCINNEG_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x3f << 4)) | (((value as u32) & 0x3f) << 4);
        self.w
    }
}
#[doc = "Reader of field `DCINPOS`"]
pub type DCINPOS_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `DCINPOS`"]
pub struct DCINPOS_W<'a> {
    w: &'a mut W,
}
impl<'a> DCINPOS_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x3f << 10)) | (((value as u32) & 0x3f) << 10);
        self.w
    }
}
#[doc = "Reader of field `TWOS`"]
pub type TWOS_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `TWOS`"]
pub struct TWOS_W<'a> {
    w: &'a mut W,
}
impl<'a> TWOS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Reader of field `POWER_SWITCH`"]
pub type POWER_SWITCH_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `POWER_SWITCH`"]
pub struct POWER_SWITCH_W<'a> {
    w: &'a mut W,
}
impl<'a> POWER_SWITCH_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 17)) | (((value as u32) & 0x01) << 17);
        self.w
    }
}
#[doc = "Reader of field `BGAP_SWITCH`"]
pub type BGAP_SWITCH_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `BGAP_SWITCH`"]
pub struct BGAP_SWITCH_W<'a> {
    w: &'a mut W,
}
impl<'a> BGAP_SWITCH_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 18)) | (((value as u32) & 0x01) << 18);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - current setting for power versus speed programming"]
    #[inline(always)]
    pub fn crs(&self) -> CRS_R {
        CRS_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:9 - AC-DC coupling selection 0 = No dc bias 1 = DC bias on vin_neg side"]
    #[inline(always)]
    pub fn dcinneg(&self) -> DCINNEG_R {
        DCINNEG_R::new(((self.bits >> 4) & 0x3f) as u8)
    }
    #[doc = "Bits 10:15 - AC-DC coupling selection 0 = No dc bias 1 = DC bias on vin_pos side"]
    #[inline(always)]
    pub fn dcinpos(&self) -> DCINPOS_R {
        DCINPOS_R::new(((self.bits >> 10) & 0x3f) as u8)
    }
    #[doc = "Bit 16 - Output data format selection 0 = offset binary 1 = two's complement"]
    #[inline(always)]
    pub fn twos(&self) -> TWOS_R {
        TWOS_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - 0 = ADC is powered down 1 = ADC is active"]
    #[inline(always)]
    pub fn power_switch(&self) -> POWER_SWITCH_R {
        POWER_SWITCH_R::new(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - 0 = ADC band gap reference is powered down 1 = ADC band gap reference is active"]
    #[inline(always)]
    pub fn bgap_switch(&self) -> BGAP_SWITCH_R {
        BGAP_SWITCH_R::new(((self.bits >> 18) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:3 - current setting for power versus speed programming"]
    #[inline(always)]
    pub fn crs(&mut self) -> CRS_W {
        CRS_W { w: self }
    }
    #[doc = "Bits 4:9 - AC-DC coupling selection 0 = No dc bias 1 = DC bias on vin_neg side"]
    #[inline(always)]
    pub fn dcinneg(&mut self) -> DCINNEG_W {
        DCINNEG_W { w: self }
    }
    #[doc = "Bits 10:15 - AC-DC coupling selection 0 = No dc bias 1 = DC bias on vin_pos side"]
    #[inline(always)]
    pub fn dcinpos(&mut self) -> DCINPOS_W {
        DCINPOS_W { w: self }
    }
    #[doc = "Bit 16 - Output data format selection 0 = offset binary 1 = two's complement"]
    #[inline(always)]
    pub fn twos(&mut self) -> TWOS_W {
        TWOS_W { w: self }
    }
    #[doc = "Bit 17 - 0 = ADC is powered down 1 = ADC is active"]
    #[inline(always)]
    pub fn power_switch(&mut self) -> POWER_SWITCH_W {
        POWER_SWITCH_W { w: self }
    }
    #[doc = "Bit 18 - 0 = ADC band gap reference is powered down 1 = ADC band gap reference is active"]
    #[inline(always)]
    pub fn bgap_switch(&mut self) -> BGAP_SWITCH_W {
        BGAP_SWITCH_W { w: self }
    }
}
