#[doc = "Reader of register STATUS0"]
pub type R = crate::R<u32, super::STATUS0>;
#[doc = "Reader of field `FIFO_FULL`"]
pub type FIFO_FULL_R = crate::R<bool, bool>;
#[doc = "Reader of field `FIFO_EMPTY`"]
pub type FIFO_EMPTY_R = crate::R<bool, bool>;
#[doc = "Reader of field `FIFO_OVERFLOW`"]
pub type FIFO_OVERFLOW_R = crate::R<bool, bool>;
#[doc = "Reader of field `DSCR_DONE`"]
pub type DSCR_DONE_R = crate::R<bool, bool>;
#[doc = "Reader of field `DSCR_ERROR`"]
pub type DSCR_ERROR_R = crate::R<bool, bool>;
#[doc = "Reader of field `ADC_OVF`"]
pub type ADC_OVF_R = crate::R<bool, bool>;
#[doc = "Reader of field `ADC_UNF`"]
pub type ADC_UNF_R = crate::R<bool, bool>;
impl R {
    #[doc = "Bit 0 - 0: number of samples in FIFO less than or equal to FIFO_LEVEL 1: number of samples in FIFO is more than FIFO_LEVEL"]
    #[inline(always)]
    pub fn fifo_full(&self) -> FIFO_FULL_R {
        FIFO_FULL_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - 0: FIFO is not empty 1: FIFO is empty"]
    #[inline(always)]
    pub fn fifo_empty(&self) -> FIFO_EMPTY_R {
        FIFO_EMPTY_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - FIFO was full; conversion sample is not stored and lost"]
    #[inline(always)]
    pub fn fifo_overflow(&self) -> FIFO_OVERFLOW_R {
        FIFO_OVERFLOW_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - The descriptor INTERRUPT field was enabled and its sample is converted."]
    #[inline(always)]
    pub fn dscr_done(&self) -> DSCR_DONE_R {
        DSCR_DONE_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - The ADC was not fully woken up when a sample was converted and the conversion results is unreliable"]
    #[inline(always)]
    pub fn dscr_error(&self) -> DSCR_ERROR_R {
        DSCR_ERROR_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Converted sample value was over range of the 12 bit output code."]
    #[inline(always)]
    pub fn adc_ovf(&self) -> ADC_OVF_R {
        ADC_OVF_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Converted sample value was under range of the 12 bit output code."]
    #[inline(always)]
    pub fn adc_unf(&self) -> ADC_UNF_R {
        ADC_UNF_R::new(((self.bits >> 6) & 0x01) != 0)
    }
}
