#[doc = "Reader of register THR_B"]
pub type R = crate::R<u32, super::THR_B>;
#[doc = "Writer for register THR_B"]
pub type W = crate::W<u32, super::THR_B>;
#[doc = "Register THR_B `reset()`'s with value 0x0fff_0000"]
impl crate::ResetValue for super::THR_B {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0fff_0000
    }
}
#[doc = "Reader of field `THR_LOW_B`"]
pub type THR_LOW_B_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `THR_LOW_B`"]
pub struct THR_LOW_B_W<'a> {
    w: &'a mut W,
}
impl<'a> THR_LOW_B_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0fff) | ((value as u32) & 0x0fff);
        self.w
    }
}
#[doc = "Reader of field `THR_HIGH_B`"]
pub type THR_HIGH_B_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `THR_HIGH_B`"]
pub struct THR_HIGH_B_W<'a> {
    w: &'a mut W,
}
impl<'a> THR_HIGH_B_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0fff << 16)) | (((value as u32) & 0x0fff) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:11 - Low Compare Threshold Register B: Contains the lower threshold level for automatic threshold comparison for any channels linked to threshold pair A."]
    #[inline(always)]
    pub fn thr_low_b(&self) -> THR_LOW_B_R {
        THR_LOW_B_R::new((self.bits & 0x0fff) as u16)
    }
    #[doc = "Bits 16:27 - High Compare Threshold Register B: Contains the upper threshold level for automatic threshold comparison for any channels linked to threshold pair A."]
    #[inline(always)]
    pub fn thr_high_b(&self) -> THR_HIGH_B_R {
        THR_HIGH_B_R::new(((self.bits >> 16) & 0x0fff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:11 - Low Compare Threshold Register B: Contains the lower threshold level for automatic threshold comparison for any channels linked to threshold pair A."]
    #[inline(always)]
    pub fn thr_low_b(&mut self) -> THR_LOW_B_W {
        THR_LOW_B_W { w: self }
    }
    #[doc = "Bits 16:27 - High Compare Threshold Register B: Contains the upper threshold level for automatic threshold comparison for any channels linked to threshold pair A."]
    #[inline(always)]
    pub fn thr_high_b(&mut self) -> THR_HIGH_B_W {
        THR_HIGH_B_W { w: self }
    }
}
