#[doc = "Reader of register CNTL"]
pub type R = crate::R<u32, super::CNTL>;
#[doc = "Writer for register CNTL"]
pub type W = crate::W<u32, super::CNTL>;
#[doc = "Register CNTL `reset()`'s with value 0x01"]
impl crate::ResetValue for super::CNTL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x01
    }
}
#[doc = "Initialization\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INIT_A {
    #[doc = "1: Initialization is started. On reset, software needs to initialize the CAN controller."]
    INITIALIZATION_IS_STARTED,
    #[doc = "0: Normal operation."]
    NORMAL_OPERATION,
}
impl From<INIT_A> for bool {
    #[inline(always)]
    fn from(variant: INIT_A) -> Self {
        match variant {
            INIT_A::INITIALIZATION_IS_STARTED => true,
            INIT_A::NORMAL_OPERATION => false,
        }
    }
}
#[doc = "Reader of field `INIT`"]
pub type INIT_R = crate::R<bool, INIT_A>;
impl INIT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INIT_A {
        match self.bits {
            true => INIT_A::INITIALIZATION_IS_STARTED,
            false => INIT_A::NORMAL_OPERATION,
        }
    }
    #[doc = "Checks if the value of the field is `INITIALIZATION_IS_STARTED`"]
    #[inline(always)]
    pub fn is_initialization_is_started(&self) -> bool {
        *self == INIT_A::INITIALIZATION_IS_STARTED
    }
    #[doc = "Checks if the value of the field is `NORMAL_OPERATION`"]
    #[inline(always)]
    pub fn is_normal_operation(&self) -> bool {
        *self == INIT_A::NORMAL_OPERATION
    }
}
#[doc = "Write proxy for field `INIT`"]
pub struct INIT_W<'a> {
    w: &'a mut W,
}
impl<'a> INIT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INIT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Initialization is started. On reset, software needs to initialize the CAN controller."]
    #[inline(always)]
    pub fn initialization_is_started(self) -> &'a mut W {
        self.variant(INIT_A::INITIALIZATION_IS_STARTED)
    }
    #[doc = "Normal operation."]
    #[inline(always)]
    pub fn normal_operation(self) -> &'a mut W {
        self.variant(INIT_A::NORMAL_OPERATION)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Module interrupt enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IE_A {
    #[doc = "1: Enable CAN interrupts. The interrupt line is set to LOW and remains LOW until all pending interrupts are cleared."]
    ENABLE_CAN_INTERRUPTS,
    #[doc = "0: Disable CAN interrupts. The interrupt line is always HIGH."]
    DISABLE_CAN_INTERRUPTS,
}
impl From<IE_A> for bool {
    #[inline(always)]
    fn from(variant: IE_A) -> Self {
        match variant {
            IE_A::ENABLE_CAN_INTERRUPTS => true,
            IE_A::DISABLE_CAN_INTERRUPTS => false,
        }
    }
}
#[doc = "Reader of field `IE`"]
pub type IE_R = crate::R<bool, IE_A>;
impl IE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> IE_A {
        match self.bits {
            true => IE_A::ENABLE_CAN_INTERRUPTS,
            false => IE_A::DISABLE_CAN_INTERRUPTS,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_CAN_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_enable_can_interrupts(&self) -> bool {
        *self == IE_A::ENABLE_CAN_INTERRUPTS
    }
    #[doc = "Checks if the value of the field is `DISABLE_CAN_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_disable_can_interrupts(&self) -> bool {
        *self == IE_A::DISABLE_CAN_INTERRUPTS
    }
}
#[doc = "Write proxy for field `IE`"]
pub struct IE_W<'a> {
    w: &'a mut W,
}
impl<'a> IE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: IE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable CAN interrupts. The interrupt line is set to LOW and remains LOW until all pending interrupts are cleared."]
    #[inline(always)]
    pub fn enable_can_interrupts(self) -> &'a mut W {
        self.variant(IE_A::ENABLE_CAN_INTERRUPTS)
    }
    #[doc = "Disable CAN interrupts. The interrupt line is always HIGH."]
    #[inline(always)]
    pub fn disable_can_interrupts(self) -> &'a mut W {
        self.variant(IE_A::DISABLE_CAN_INTERRUPTS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Status change interrupt enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SIE_A {
    #[doc = "1: Enable status change interrupts. A status change interrupt will be generated when a message transfer is successfully completed or a CAN bus error is detected."]
    ENABLE_STATUS_CHANGE_INTERRUPTS,
    #[doc = "0: Disable status change interrupts. No status change interrupt will be generated."]
    DISABLE_STATUS_CHANGE_INTERRUPTS,
}
impl From<SIE_A> for bool {
    #[inline(always)]
    fn from(variant: SIE_A) -> Self {
        match variant {
            SIE_A::ENABLE_STATUS_CHANGE_INTERRUPTS => true,
            SIE_A::DISABLE_STATUS_CHANGE_INTERRUPTS => false,
        }
    }
}
#[doc = "Reader of field `SIE`"]
pub type SIE_R = crate::R<bool, SIE_A>;
impl SIE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SIE_A {
        match self.bits {
            true => SIE_A::ENABLE_STATUS_CHANGE_INTERRUPTS,
            false => SIE_A::DISABLE_STATUS_CHANGE_INTERRUPTS,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_STATUS_CHANGE_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_enable_status_change_interrupts(&self) -> bool {
        *self == SIE_A::ENABLE_STATUS_CHANGE_INTERRUPTS
    }
    #[doc = "Checks if the value of the field is `DISABLE_STATUS_CHANGE_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_disable_status_change_interrupts(&self) -> bool {
        *self == SIE_A::DISABLE_STATUS_CHANGE_INTERRUPTS
    }
}
#[doc = "Write proxy for field `SIE`"]
pub struct SIE_W<'a> {
    w: &'a mut W,
}
impl<'a> SIE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SIE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable status change interrupts. A status change interrupt will be generated when a message transfer is successfully completed or a CAN bus error is detected."]
    #[inline(always)]
    pub fn enable_status_change_interrupts(self) -> &'a mut W {
        self.variant(SIE_A::ENABLE_STATUS_CHANGE_INTERRUPTS)
    }
    #[doc = "Disable status change interrupts. No status change interrupt will be generated."]
    #[inline(always)]
    pub fn disable_status_change_interrupts(self) -> &'a mut W {
        self.variant(SIE_A::DISABLE_STATUS_CHANGE_INTERRUPTS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Error interrupt enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum EIE_A {
    #[doc = "1: Enable error interrupt. A change in the bits BOFF or EWARN in the CANSTAT registers will generate an interrupt."]
    ENABLE_ERROR_INTERRUPTS,
    #[doc = "0: Disable error interrupt. No error status interrupt will be generated."]
    DISABLE_ERROR_INTERRUPTS,
}
impl From<EIE_A> for bool {
    #[inline(always)]
    fn from(variant: EIE_A) -> Self {
        match variant {
            EIE_A::ENABLE_ERROR_INTERRUPTS => true,
            EIE_A::DISABLE_ERROR_INTERRUPTS => false,
        }
    }
}
#[doc = "Reader of field `EIE`"]
pub type EIE_R = crate::R<bool, EIE_A>;
impl EIE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> EIE_A {
        match self.bits {
            true => EIE_A::ENABLE_ERROR_INTERRUPTS,
            false => EIE_A::DISABLE_ERROR_INTERRUPTS,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_ERROR_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_enable_error_interrupts(&self) -> bool {
        *self == EIE_A::ENABLE_ERROR_INTERRUPTS
    }
    #[doc = "Checks if the value of the field is `DISABLE_ERROR_INTERRUPTS`"]
    #[inline(always)]
    pub fn is_disable_error_interrupts(&self) -> bool {
        *self == EIE_A::DISABLE_ERROR_INTERRUPTS
    }
}
#[doc = "Write proxy for field `EIE`"]
pub struct EIE_W<'a> {
    w: &'a mut W,
}
impl<'a> EIE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: EIE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable error interrupt. A change in the bits BOFF or EWARN in the CANSTAT registers will generate an interrupt."]
    #[inline(always)]
    pub fn enable_error_interrupts(self) -> &'a mut W {
        self.variant(EIE_A::ENABLE_ERROR_INTERRUPTS)
    }
    #[doc = "Disable error interrupt. No error status interrupt will be generated."]
    #[inline(always)]
    pub fn disable_error_interrupts(self) -> &'a mut W {
        self.variant(EIE_A::DISABLE_ERROR_INTERRUPTS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Disable automatic retransmission\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DAR_A {
    #[doc = "1: Automatic retransmission disabled."]
    DISABLED,
    #[doc = "0: Automatic retransmission of disturbed messages enabled."]
    ENABLED,
}
impl From<DAR_A> for bool {
    #[inline(always)]
    fn from(variant: DAR_A) -> Self {
        match variant {
            DAR_A::DISABLED => true,
            DAR_A::ENABLED => false,
        }
    }
}
#[doc = "Reader of field `DAR`"]
pub type DAR_R = crate::R<bool, DAR_A>;
impl DAR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DAR_A {
        match self.bits {
            true => DAR_A::DISABLED,
            false => DAR_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == DAR_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == DAR_A::ENABLED
    }
}
#[doc = "Write proxy for field `DAR`"]
pub struct DAR_W<'a> {
    w: &'a mut W,
}
impl<'a> DAR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DAR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Automatic retransmission disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(DAR_A::DISABLED)
    }
    #[doc = "Automatic retransmission of disturbed messages enabled."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(DAR_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Configuration change enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CCE_A {
    #[doc = "1: The CPU has write access to the CANBT register while the INIT bit is one."]
    THE_CPU_HAS_WRITE_ACCESS,
    #[doc = "0: The CPU has no write access to the bit timing register."]
    THE_CPU_HAS_NO_WRITE_ACCESS,
}
impl From<CCE_A> for bool {
    #[inline(always)]
    fn from(variant: CCE_A) -> Self {
        match variant {
            CCE_A::THE_CPU_HAS_WRITE_ACCESS => true,
            CCE_A::THE_CPU_HAS_NO_WRITE_ACCESS => false,
        }
    }
}
#[doc = "Reader of field `CCE`"]
pub type CCE_R = crate::R<bool, CCE_A>;
impl CCE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CCE_A {
        match self.bits {
            true => CCE_A::THE_CPU_HAS_WRITE_ACCESS,
            false => CCE_A::THE_CPU_HAS_NO_WRITE_ACCESS,
        }
    }
    #[doc = "Checks if the value of the field is `THE_CPU_HAS_WRITE_ACCESS`"]
    #[inline(always)]
    pub fn is_the_cpu_has_write_access(&self) -> bool {
        *self == CCE_A::THE_CPU_HAS_WRITE_ACCESS
    }
    #[doc = "Checks if the value of the field is `THE_CPU_HAS_NO_WRITE_ACCESS`"]
    #[inline(always)]
    pub fn is_the_cpu_has_no_write_access(&self) -> bool {
        *self == CCE_A::THE_CPU_HAS_NO_WRITE_ACCESS
    }
}
#[doc = "Write proxy for field `CCE`"]
pub struct CCE_W<'a> {
    w: &'a mut W,
}
impl<'a> CCE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CCE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The CPU has write access to the CANBT register while the INIT bit is one."]
    #[inline(always)]
    pub fn the_cpu_has_write_access(self) -> &'a mut W {
        self.variant(CCE_A::THE_CPU_HAS_WRITE_ACCESS)
    }
    #[doc = "The CPU has no write access to the bit timing register."]
    #[inline(always)]
    pub fn the_cpu_has_no_write_access(self) -> &'a mut W {
        self.variant(CCE_A::THE_CPU_HAS_NO_WRITE_ACCESS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Test mode enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TEST_A {
    #[doc = "1: Test mode."]
    TEST_MODE,
    #[doc = "0: Normal operation."]
    NORMAL_OPERATION,
}
impl From<TEST_A> for bool {
    #[inline(always)]
    fn from(variant: TEST_A) -> Self {
        match variant {
            TEST_A::TEST_MODE => true,
            TEST_A::NORMAL_OPERATION => false,
        }
    }
}
#[doc = "Reader of field `TEST`"]
pub type TEST_R = crate::R<bool, TEST_A>;
impl TEST_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TEST_A {
        match self.bits {
            true => TEST_A::TEST_MODE,
            false => TEST_A::NORMAL_OPERATION,
        }
    }
    #[doc = "Checks if the value of the field is `TEST_MODE`"]
    #[inline(always)]
    pub fn is_test_mode(&self) -> bool {
        *self == TEST_A::TEST_MODE
    }
    #[doc = "Checks if the value of the field is `NORMAL_OPERATION`"]
    #[inline(always)]
    pub fn is_normal_operation(&self) -> bool {
        *self == TEST_A::NORMAL_OPERATION
    }
}
#[doc = "Write proxy for field `TEST`"]
pub struct TEST_W<'a> {
    w: &'a mut W,
}
impl<'a> TEST_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TEST_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Test mode."]
    #[inline(always)]
    pub fn test_mode(self) -> &'a mut W {
        self.variant(TEST_A::TEST_MODE)
    }
    #[doc = "Normal operation."]
    #[inline(always)]
    pub fn normal_operation(self) -> &'a mut W {
        self.variant(TEST_A::NORMAL_OPERATION)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Initialization"]
    #[inline(always)]
    pub fn init(&self) -> INIT_R {
        INIT_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Module interrupt enable"]
    #[inline(always)]
    pub fn ie(&self) -> IE_R {
        IE_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Status change interrupt enable"]
    #[inline(always)]
    pub fn sie(&self) -> SIE_R {
        SIE_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Error interrupt enable"]
    #[inline(always)]
    pub fn eie(&self) -> EIE_R {
        EIE_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Disable automatic retransmission"]
    #[inline(always)]
    pub fn dar(&self) -> DAR_R {
        DAR_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Configuration change enable"]
    #[inline(always)]
    pub fn cce(&self) -> CCE_R {
        CCE_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Test mode enable"]
    #[inline(always)]
    pub fn test(&self) -> TEST_R {
        TEST_R::new(((self.bits >> 7) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Initialization"]
    #[inline(always)]
    pub fn init(&mut self) -> INIT_W {
        INIT_W { w: self }
    }
    #[doc = "Bit 1 - Module interrupt enable"]
    #[inline(always)]
    pub fn ie(&mut self) -> IE_W {
        IE_W { w: self }
    }
    #[doc = "Bit 2 - Status change interrupt enable"]
    #[inline(always)]
    pub fn sie(&mut self) -> SIE_W {
        SIE_W { w: self }
    }
    #[doc = "Bit 3 - Error interrupt enable"]
    #[inline(always)]
    pub fn eie(&mut self) -> EIE_W {
        EIE_W { w: self }
    }
    #[doc = "Bit 5 - Disable automatic retransmission"]
    #[inline(always)]
    pub fn dar(&mut self) -> DAR_W {
        DAR_W { w: self }
    }
    #[doc = "Bit 6 - Configuration change enable"]
    #[inline(always)]
    pub fn cce(&mut self) -> CCE_W {
        CCE_W { w: self }
    }
    #[doc = "Bit 7 - Test mode enable"]
    #[inline(always)]
    pub fn test(&mut self) -> TEST_W {
        TEST_W { w: self }
    }
}
