#[doc = "Reader of register IF%s_ARB2"]
pub type R = crate::R<u32, super::IF_ARB2>;
#[doc = "Writer for register IF%s_ARB2"]
pub type W = crate::W<u32, super::IF_ARB2>;
#[doc = "Register IF%s_ARB2 `reset()`'s with value 0"]
impl crate::ResetValue for super::IF_ARB2 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `ID28_16`"]
pub type ID28_16_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `ID28_16`"]
pub struct ID28_16_W<'a> {
    w: &'a mut W,
}
impl<'a> ID28_16_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x1fff) | ((value as u32) & 0x1fff);
        self.w
    }
}
#[doc = "Message direction\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DIR_A {
    #[doc = "1: Direction = transmit. On TXRQST, the respective Message Object is transmitted as a Data Frame. On reception of a Remote Frame with matching identifier, the TXRQST bit of this Message Object is set (if RMTEN = one)."]
    DIRECTION_EQ_TRANSMIT,
    #[doc = "0: Direction = receive. On TXRQST, a Remote Frame with the identifier of this Message Object is transmitted. On reception of a Data Frame with matching identifier, that message is stored in this Message Object."]
    DIRECTION_EQ_RECEIVE,
}
impl From<DIR_A> for bool {
    #[inline(always)]
    fn from(variant: DIR_A) -> Self {
        match variant {
            DIR_A::DIRECTION_EQ_TRANSMIT => true,
            DIR_A::DIRECTION_EQ_RECEIVE => false,
        }
    }
}
#[doc = "Reader of field `DIR`"]
pub type DIR_R = crate::R<bool, DIR_A>;
impl DIR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DIR_A {
        match self.bits {
            true => DIR_A::DIRECTION_EQ_TRANSMIT,
            false => DIR_A::DIRECTION_EQ_RECEIVE,
        }
    }
    #[doc = "Checks if the value of the field is `DIRECTION_EQ_TRANSMIT`"]
    #[inline(always)]
    pub fn is_direction_eq_transmit(&self) -> bool {
        *self == DIR_A::DIRECTION_EQ_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `DIRECTION_EQ_RECEIVE`"]
    #[inline(always)]
    pub fn is_direction_eq_receive(&self) -> bool {
        *self == DIR_A::DIRECTION_EQ_RECEIVE
    }
}
#[doc = "Write proxy for field `DIR`"]
pub struct DIR_W<'a> {
    w: &'a mut W,
}
impl<'a> DIR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DIR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Direction = transmit. On TXRQST, the respective Message Object is transmitted as a Data Frame. On reception of a Remote Frame with matching identifier, the TXRQST bit of this Message Object is set (if RMTEN = one)."]
    #[inline(always)]
    pub fn direction_eq_transmit(self) -> &'a mut W {
        self.variant(DIR_A::DIRECTION_EQ_TRANSMIT)
    }
    #[doc = "Direction = receive. On TXRQST, a Remote Frame with the identifier of this Message Object is transmitted. On reception of a Data Frame with matching identifier, that message is stored in this Message Object."]
    #[inline(always)]
    pub fn direction_eq_receive(self) -> &'a mut W {
        self.variant(DIR_A::DIRECTION_EQ_RECEIVE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Extend identifier\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum XTD_A {
    #[doc = "1: The 29-bit extended identifier will be used for this message object."]
    THE_29_BIT_EXTENDED,
    #[doc = "0: The 11-bit standard identifier will be used for this message object."]
    THE_11_BIT_STANDARD,
}
impl From<XTD_A> for bool {
    #[inline(always)]
    fn from(variant: XTD_A) -> Self {
        match variant {
            XTD_A::THE_29_BIT_EXTENDED => true,
            XTD_A::THE_11_BIT_STANDARD => false,
        }
    }
}
#[doc = "Reader of field `XTD`"]
pub type XTD_R = crate::R<bool, XTD_A>;
impl XTD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> XTD_A {
        match self.bits {
            true => XTD_A::THE_29_BIT_EXTENDED,
            false => XTD_A::THE_11_BIT_STANDARD,
        }
    }
    #[doc = "Checks if the value of the field is `THE_29_BIT_EXTENDED`"]
    #[inline(always)]
    pub fn is_the_29_bit_extended(&self) -> bool {
        *self == XTD_A::THE_29_BIT_EXTENDED
    }
    #[doc = "Checks if the value of the field is `THE_11_BIT_STANDARD`"]
    #[inline(always)]
    pub fn is_the_11_bit_standard(&self) -> bool {
        *self == XTD_A::THE_11_BIT_STANDARD
    }
}
#[doc = "Write proxy for field `XTD`"]
pub struct XTD_W<'a> {
    w: &'a mut W,
}
impl<'a> XTD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: XTD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The 29-bit extended identifier will be used for this message object."]
    #[inline(always)]
    pub fn the_29_bit_extended(self) -> &'a mut W {
        self.variant(XTD_A::THE_29_BIT_EXTENDED)
    }
    #[doc = "The 11-bit standard identifier will be used for this message object."]
    #[inline(always)]
    pub fn the_11_bit_standard(self) -> &'a mut W {
        self.variant(XTD_A::THE_11_BIT_STANDARD)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Message valid The CPU must reset the MSGVAL bit of all unused Messages Objects during the initialization before it resets bit INIT in the CAN Control Register. This bit must also be reset before the identifier ID28:0, the control bits XTD, DIR, or the Data Length Code DLC3:0 are modified, or if the Messages Object is no longer required.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MSGVAL_A {
    #[doc = "1: The message object is configured and should be considered by the message handler."]
    THE_MESSAGE_OBJECT_IS_CONFIGURED,
    #[doc = "0: The message object is ignored by the message handler."]
    THE_MESSAGE_OBJECT_IS_NOT_CONFIGURED,
}
impl From<MSGVAL_A> for bool {
    #[inline(always)]
    fn from(variant: MSGVAL_A) -> Self {
        match variant {
            MSGVAL_A::THE_MESSAGE_OBJECT_IS_CONFIGURED => true,
            MSGVAL_A::THE_MESSAGE_OBJECT_IS_NOT_CONFIGURED => false,
        }
    }
}
#[doc = "Reader of field `MSGVAL`"]
pub type MSGVAL_R = crate::R<bool, MSGVAL_A>;
impl MSGVAL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MSGVAL_A {
        match self.bits {
            true => MSGVAL_A::THE_MESSAGE_OBJECT_IS_CONFIGURED,
            false => MSGVAL_A::THE_MESSAGE_OBJECT_IS_NOT_CONFIGURED,
        }
    }
    #[doc = "Checks if the value of the field is `THE_MESSAGE_OBJECT_IS_CONFIGURED`"]
    #[inline(always)]
    pub fn is_the_message_object_is_configured(&self) -> bool {
        *self == MSGVAL_A::THE_MESSAGE_OBJECT_IS_CONFIGURED
    }
    #[doc = "Checks if the value of the field is `THE_MESSAGE_OBJECT_IS_NOT_CONFIGURED`"]
    #[inline(always)]
    pub fn is_the_message_object_is_not_configured(&self) -> bool {
        *self == MSGVAL_A::THE_MESSAGE_OBJECT_IS_NOT_CONFIGURED
    }
}
#[doc = "Write proxy for field `MSGVAL`"]
pub struct MSGVAL_W<'a> {
    w: &'a mut W,
}
impl<'a> MSGVAL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MSGVAL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The message object is configured and should be considered by the message handler."]
    #[inline(always)]
    pub fn the_message_object_is_configured(self) -> &'a mut W {
        self.variant(MSGVAL_A::THE_MESSAGE_OBJECT_IS_CONFIGURED)
    }
    #[doc = "The message object is ignored by the message handler."]
    #[inline(always)]
    pub fn the_message_object_is_not_configured(self) -> &'a mut W {
        self.variant(MSGVAL_A::THE_MESSAGE_OBJECT_IS_NOT_CONFIGURED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:12 - Message identifier 29-bit identifier (extended frame) 11-bit identifier (standard frame)"]
    #[inline(always)]
    pub fn id28_16(&self) -> ID28_16_R {
        ID28_16_R::new((self.bits & 0x1fff) as u16)
    }
    #[doc = "Bit 13 - Message direction"]
    #[inline(always)]
    pub fn dir(&self) -> DIR_R {
        DIR_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Extend identifier"]
    #[inline(always)]
    pub fn xtd(&self) -> XTD_R {
        XTD_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Message valid The CPU must reset the MSGVAL bit of all unused Messages Objects during the initialization before it resets bit INIT in the CAN Control Register. This bit must also be reset before the identifier ID28:0, the control bits XTD, DIR, or the Data Length Code DLC3:0 are modified, or if the Messages Object is no longer required."]
    #[inline(always)]
    pub fn msgval(&self) -> MSGVAL_R {
        MSGVAL_R::new(((self.bits >> 15) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:12 - Message identifier 29-bit identifier (extended frame) 11-bit identifier (standard frame)"]
    #[inline(always)]
    pub fn id28_16(&mut self) -> ID28_16_W {
        ID28_16_W { w: self }
    }
    #[doc = "Bit 13 - Message direction"]
    #[inline(always)]
    pub fn dir(&mut self) -> DIR_W {
        DIR_W { w: self }
    }
    #[doc = "Bit 14 - Extend identifier"]
    #[inline(always)]
    pub fn xtd(&mut self) -> XTD_W {
        XTD_W { w: self }
    }
    #[doc = "Bit 15 - Message valid The CPU must reset the MSGVAL bit of all unused Messages Objects during the initialization before it resets bit INIT in the CAN Control Register. This bit must also be reset before the identifier ID28:0, the control bits XTD, DIR, or the Data Length Code DLC3:0 are modified, or if the Messages Object is no longer required."]
    #[inline(always)]
    pub fn msgval(&mut self) -> MSGVAL_W {
        MSGVAL_W { w: self }
    }
}
