#[doc = "Reader of register TEST"]
pub type R = crate::R<u32, super::TEST>;
#[doc = "Writer for register TEST"]
pub type W = crate::W<u32, super::TEST>;
#[doc = "Register TEST `reset()`'s with value 0"]
impl crate::ResetValue for super::TEST {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Basic mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BASIC_A {
    #[doc = "1: IF1 registers used as TX buffer, IF2 registers used as RX buffer."]
    IF1_TX_IF2_RX,
    #[doc = "0: Basic mode disabled."]
    BASIC_MODE_DISABLED,
}
impl From<BASIC_A> for bool {
    #[inline(always)]
    fn from(variant: BASIC_A) -> Self {
        match variant {
            BASIC_A::IF1_TX_IF2_RX => true,
            BASIC_A::BASIC_MODE_DISABLED => false,
        }
    }
}
#[doc = "Reader of field `BASIC`"]
pub type BASIC_R = crate::R<bool, BASIC_A>;
impl BASIC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BASIC_A {
        match self.bits {
            true => BASIC_A::IF1_TX_IF2_RX,
            false => BASIC_A::BASIC_MODE_DISABLED,
        }
    }
    #[doc = "Checks if the value of the field is `IF1_TX_IF2_RX`"]
    #[inline(always)]
    pub fn is_if1_tx_if2_rx(&self) -> bool {
        *self == BASIC_A::IF1_TX_IF2_RX
    }
    #[doc = "Checks if the value of the field is `BASIC_MODE_DISABLED`"]
    #[inline(always)]
    pub fn is_basic_mode_disabled(&self) -> bool {
        *self == BASIC_A::BASIC_MODE_DISABLED
    }
}
#[doc = "Write proxy for field `BASIC`"]
pub struct BASIC_W<'a> {
    w: &'a mut W,
}
impl<'a> BASIC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BASIC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "IF1 registers used as TX buffer, IF2 registers used as RX buffer."]
    #[inline(always)]
    pub fn if1_tx_if2_rx(self) -> &'a mut W {
        self.variant(BASIC_A::IF1_TX_IF2_RX)
    }
    #[doc = "Basic mode disabled."]
    #[inline(always)]
    pub fn basic_mode_disabled(self) -> &'a mut W {
        self.variant(BASIC_A::BASIC_MODE_DISABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Silent mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SILENT_A {
    #[doc = "1: The module is in silent mode."]
    SILENT,
    #[doc = "0: Normal operation."]
    NORMAL_OPERATION,
}
impl From<SILENT_A> for bool {
    #[inline(always)]
    fn from(variant: SILENT_A) -> Self {
        match variant {
            SILENT_A::SILENT => true,
            SILENT_A::NORMAL_OPERATION => false,
        }
    }
}
#[doc = "Reader of field `SILENT`"]
pub type SILENT_R = crate::R<bool, SILENT_A>;
impl SILENT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SILENT_A {
        match self.bits {
            true => SILENT_A::SILENT,
            false => SILENT_A::NORMAL_OPERATION,
        }
    }
    #[doc = "Checks if the value of the field is `SILENT`"]
    #[inline(always)]
    pub fn is_silent(&self) -> bool {
        *self == SILENT_A::SILENT
    }
    #[doc = "Checks if the value of the field is `NORMAL_OPERATION`"]
    #[inline(always)]
    pub fn is_normal_operation(&self) -> bool {
        *self == SILENT_A::NORMAL_OPERATION
    }
}
#[doc = "Write proxy for field `SILENT`"]
pub struct SILENT_W<'a> {
    w: &'a mut W,
}
impl<'a> SILENT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SILENT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The module is in silent mode."]
    #[inline(always)]
    pub fn silent(self) -> &'a mut W {
        self.variant(SILENT_A::SILENT)
    }
    #[doc = "Normal operation."]
    #[inline(always)]
    pub fn normal_operation(self) -> &'a mut W {
        self.variant(SILENT_A::NORMAL_OPERATION)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Loop back mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LBACK_A {
    #[doc = "1: Loop back mode is enabled."]
    ENABLED,
    #[doc = "0: Loop back mode is disabled."]
    DISABLED,
}
impl From<LBACK_A> for bool {
    #[inline(always)]
    fn from(variant: LBACK_A) -> Self {
        match variant {
            LBACK_A::ENABLED => true,
            LBACK_A::DISABLED => false,
        }
    }
}
#[doc = "Reader of field `LBACK`"]
pub type LBACK_R = crate::R<bool, LBACK_A>;
impl LBACK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> LBACK_A {
        match self.bits {
            true => LBACK_A::ENABLED,
            false => LBACK_A::DISABLED,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == LBACK_A::ENABLED
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == LBACK_A::DISABLED
    }
}
#[doc = "Write proxy for field `LBACK`"]
pub struct LBACK_W<'a> {
    w: &'a mut W,
}
impl<'a> LBACK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: LBACK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Loop back mode is enabled."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(LBACK_A::ENABLED)
    }
    #[doc = "Loop back mode is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(LBACK_A::DISABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Control of TD pins\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TX1_0_A {
    #[doc = "0: Level at the TD pin is controlled by the CAN controller. This is the value at reset."]
    LEVEL_AT_THE_TD_PIN,
    #[doc = "1: The sample point can be monitored at the TD pin."]
    THE_SAMPLE_POINT_CAN_BE_MONITORED,
    #[doc = "2: TD pin is driven LOW/dominant."]
    TD_PIN_IS_DRIVEN_LOW,
    #[doc = "3: TD pin is driven HIGH/recessive."]
    TD_PIN_IS_DRIVEN_HIGH,
}
impl From<TX1_0_A> for u8 {
    #[inline(always)]
    fn from(variant: TX1_0_A) -> Self {
        match variant {
            TX1_0_A::LEVEL_AT_THE_TD_PIN => 0,
            TX1_0_A::THE_SAMPLE_POINT_CAN_BE_MONITORED => 1,
            TX1_0_A::TD_PIN_IS_DRIVEN_LOW => 2,
            TX1_0_A::TD_PIN_IS_DRIVEN_HIGH => 3,
        }
    }
}
#[doc = "Reader of field `TX1_0`"]
pub type TX1_0_R = crate::R<u8, TX1_0_A>;
impl TX1_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TX1_0_A {
        match self.bits {
            0 => TX1_0_A::LEVEL_AT_THE_TD_PIN,
            1 => TX1_0_A::THE_SAMPLE_POINT_CAN_BE_MONITORED,
            2 => TX1_0_A::TD_PIN_IS_DRIVEN_LOW,
            3 => TX1_0_A::TD_PIN_IS_DRIVEN_HIGH,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_AT_THE_TD_PIN`"]
    #[inline(always)]
    pub fn is_level_at_the_td_pin(&self) -> bool {
        *self == TX1_0_A::LEVEL_AT_THE_TD_PIN
    }
    #[doc = "Checks if the value of the field is `THE_SAMPLE_POINT_CAN_BE_MONITORED`"]
    #[inline(always)]
    pub fn is_the_sample_point_can_be_monitored(&self) -> bool {
        *self == TX1_0_A::THE_SAMPLE_POINT_CAN_BE_MONITORED
    }
    #[doc = "Checks if the value of the field is `TD_PIN_IS_DRIVEN_LOW`"]
    #[inline(always)]
    pub fn is_td_pin_is_driven_low(&self) -> bool {
        *self == TX1_0_A::TD_PIN_IS_DRIVEN_LOW
    }
    #[doc = "Checks if the value of the field is `TD_PIN_IS_DRIVEN_HIGH`"]
    #[inline(always)]
    pub fn is_td_pin_is_driven_high(&self) -> bool {
        *self == TX1_0_A::TD_PIN_IS_DRIVEN_HIGH
    }
}
#[doc = "Write proxy for field `TX1_0`"]
pub struct TX1_0_W<'a> {
    w: &'a mut W,
}
impl<'a> TX1_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TX1_0_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Level at the TD pin is controlled by the CAN controller. This is the value at reset."]
    #[inline(always)]
    pub fn level_at_the_td_pin(self) -> &'a mut W {
        self.variant(TX1_0_A::LEVEL_AT_THE_TD_PIN)
    }
    #[doc = "The sample point can be monitored at the TD pin."]
    #[inline(always)]
    pub fn the_sample_point_can_be_monitored(self) -> &'a mut W {
        self.variant(TX1_0_A::THE_SAMPLE_POINT_CAN_BE_MONITORED)
    }
    #[doc = "TD pin is driven LOW/dominant."]
    #[inline(always)]
    pub fn td_pin_is_driven_low(self) -> &'a mut W {
        self.variant(TX1_0_A::TD_PIN_IS_DRIVEN_LOW)
    }
    #[doc = "TD pin is driven HIGH/recessive."]
    #[inline(always)]
    pub fn td_pin_is_driven_high(self) -> &'a mut W {
        self.variant(TX1_0_A::TD_PIN_IS_DRIVEN_HIGH)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 5)) | (((value as u32) & 0x03) << 5);
        self.w
    }
}
#[doc = "Monitors the actual value of the RD Pin\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RX_A {
    #[doc = "1: The CAN bus is recessive (RD = 1)."]
    THE_CAN_BUS_IS_RECESSIVE,
    #[doc = "0: The CAN bus is dominant (RD = 0)."]
    THE_CAN_BUS_IS_DOMINANT,
}
impl From<RX_A> for bool {
    #[inline(always)]
    fn from(variant: RX_A) -> Self {
        match variant {
            RX_A::THE_CAN_BUS_IS_RECESSIVE => true,
            RX_A::THE_CAN_BUS_IS_DOMINANT => false,
        }
    }
}
#[doc = "Reader of field `RX`"]
pub type RX_R = crate::R<bool, RX_A>;
impl RX_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RX_A {
        match self.bits {
            true => RX_A::THE_CAN_BUS_IS_RECESSIVE,
            false => RX_A::THE_CAN_BUS_IS_DOMINANT,
        }
    }
    #[doc = "Checks if the value of the field is `THE_CAN_BUS_IS_RECESSIVE`"]
    #[inline(always)]
    pub fn is_the_can_bus_is_recessive(&self) -> bool {
        *self == RX_A::THE_CAN_BUS_IS_RECESSIVE
    }
    #[doc = "Checks if the value of the field is `THE_CAN_BUS_IS_DOMINANT`"]
    #[inline(always)]
    pub fn is_the_can_bus_is_dominant(&self) -> bool {
        *self == RX_A::THE_CAN_BUS_IS_DOMINANT
    }
}
#[doc = "Write proxy for field `RX`"]
pub struct RX_W<'a> {
    w: &'a mut W,
}
impl<'a> RX_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RX_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The CAN bus is recessive (RD = 1)."]
    #[inline(always)]
    pub fn the_can_bus_is_recessive(self) -> &'a mut W {
        self.variant(RX_A::THE_CAN_BUS_IS_RECESSIVE)
    }
    #[doc = "The CAN bus is dominant (RD = 0)."]
    #[inline(always)]
    pub fn the_can_bus_is_dominant(self) -> &'a mut W {
        self.variant(RX_A::THE_CAN_BUS_IS_DOMINANT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
impl R {
    #[doc = "Bit 2 - Basic mode"]
    #[inline(always)]
    pub fn basic(&self) -> BASIC_R {
        BASIC_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Silent mode"]
    #[inline(always)]
    pub fn silent(&self) -> SILENT_R {
        SILENT_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Loop back mode"]
    #[inline(always)]
    pub fn lback(&self) -> LBACK_R {
        LBACK_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bits 5:6 - Control of TD pins"]
    #[inline(always)]
    pub fn tx1_0(&self) -> TX1_0_R {
        TX1_0_R::new(((self.bits >> 5) & 0x03) as u8)
    }
    #[doc = "Bit 7 - Monitors the actual value of the RD Pin"]
    #[inline(always)]
    pub fn rx(&self) -> RX_R {
        RX_R::new(((self.bits >> 7) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 2 - Basic mode"]
    #[inline(always)]
    pub fn basic(&mut self) -> BASIC_W {
        BASIC_W { w: self }
    }
    #[doc = "Bit 3 - Silent mode"]
    #[inline(always)]
    pub fn silent(&mut self) -> SILENT_W {
        SILENT_W { w: self }
    }
    #[doc = "Bit 4 - Loop back mode"]
    #[inline(always)]
    pub fn lback(&mut self) -> LBACK_W {
        LBACK_W { w: self }
    }
    #[doc = "Bits 5:6 - Control of TD pins"]
    #[inline(always)]
    pub fn tx1_0(&mut self) -> TX1_0_W {
        TX1_0_W { w: self }
    }
    #[doc = "Bit 7 - Monitors the actual value of the RD Pin"]
    #[inline(always)]
    pub fn rx(&mut self) -> RX_W {
        RX_W { w: self }
    }
}
