#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Power mode register"]
    pub pm: PM,
    #[doc = "0x04 - CCU base clocks status register"]
    pub base_stat: BASE_STAT,
    _reserved2: [u8; 248usize],
    #[doc = "0x100 - CLK_AUDIO clock configuration register"]
    pub clk_audio_cfg: CLK_AUDIO_CFG,
    #[doc = "0x104 - CLK_AUDIO clock status register"]
    pub clk_audio_stat: CLK_AUDIO_STAT,
    _reserved4: [u8; 248usize],
    #[doc = "0x200 - CLK_APB2_USART3 clock configuration register"]
    pub clk_apb2_usart3_cfg: CLK_APB2_USART3_CFG,
    #[doc = "0x204 - CLK_APB2_USART3 clock status register"]
    pub clk_apb2_usart3_status: CLK_APB2_USART3_STATUS,
    _reserved6: [u8; 248usize],
    #[doc = "0x300 - CLK_APB2_USART2 clock configuration register"]
    pub clk_apb2_usart2_cfg: CLK_APB2_USART2_CFG,
    #[doc = "0x304 - CLK_APB2_USART clock status register"]
    pub clk_apb2_usart2_status: CLK_APB2_USART2_STATUS,
    _reserved8: [u8; 248usize],
    #[doc = "0x400 - CLK_APB2_UART1 clock configuration register"]
    pub clk_apb0_uart1_bus_cfg: CLK_APB0_UART1_BUS_CFG,
    #[doc = "0x404 - CLK_APB0_UART1 clock status register"]
    pub clk_apb0_uart1_stat: CLK_APB0_UART1_STAT,
    _reserved10: [u8; 248usize],
    #[doc = "0x500 - CLK_APB2_USART0 clock configuration register"]
    pub clk_apb0_usart0_cfg: CLK_APB0_USART0_CFG,
    #[doc = "0x504 - CLK_APB0_USART0 clock status register"]
    pub clk_apb0_usart0_status: CLK_APB0_USART0_STATUS,
    _reserved12: [u8; 248usize],
    #[doc = "0x600 - CLK_APB2_SSP1 clock configuration register"]
    pub clk_apb2_ssp1_cfg: CLK_APB2_SSP1_CFG,
    #[doc = "0x604 - CLK_APB2_SSP1 clock status register"]
    pub clk_apb2_ssp1_stat: CLK_APB2_SSP1_STAT,
    _reserved14: [u8; 248usize],
    #[doc = "0x700 - CLK_APB0_SSP0 clock configuration register"]
    pub clk_apb0_ssp0_cfg: CLK_APB0_SSP0_CFG,
    #[doc = "0x704 - CLK_APB0_SSP0 clock status register"]
    pub clk_apb0_ssp0_stat: CLK_APB0_SSP0_STAT,
    _reserved16: [u8; 248usize],
    #[doc = "0x800 - CLK_SDIO clock configuration register"]
    pub clk_sdio_cfg: CLK_SDIO_CFG,
    #[doc = "0x804 - CLK_SDIO clock status register"]
    pub clk_sdio_stat: CLK_SDIO_STAT,
}
#[doc = "Power mode register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pm](pm) module"]
pub type PM = crate::Reg<u32, _PM>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PM;
#[doc = "`read()` method returns [pm::R](pm::R) reader structure"]
impl crate::Readable for PM {}
#[doc = "`write(|w| ..)` method takes [pm::W](pm::W) writer structure"]
impl crate::Writable for PM {}
#[doc = "Power mode register"]
pub mod pm;
#[doc = "CCU base clocks status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_stat](base_stat) module"]
pub type BASE_STAT = crate::Reg<u32, _BASE_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_STAT;
#[doc = "`read()` method returns [base_stat::R](base_stat::R) reader structure"]
impl crate::Readable for BASE_STAT {}
#[doc = "CCU base clocks status register"]
pub mod base_stat;
#[doc = "CLK_AUDIO clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_audio_cfg](clk_audio_cfg) module"]
pub type CLK_AUDIO_CFG = crate::Reg<u32, _CLK_AUDIO_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_AUDIO_CFG;
#[doc = "`read()` method returns [clk_audio_cfg::R](clk_audio_cfg::R) reader structure"]
impl crate::Readable for CLK_AUDIO_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_audio_cfg::W](clk_audio_cfg::W) writer structure"]
impl crate::Writable for CLK_AUDIO_CFG {}
#[doc = "CLK_AUDIO clock configuration register"]
pub mod clk_audio_cfg;
#[doc = "CLK_APB2_USART3 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb2_usart3_cfg](clk_apb2_usart3_cfg) module"]
pub type CLK_APB2_USART3_CFG = crate::Reg<u32, _CLK_APB2_USART3_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB2_USART3_CFG;
#[doc = "`read()` method returns [clk_apb2_usart3_cfg::R](clk_apb2_usart3_cfg::R) reader structure"]
impl crate::Readable for CLK_APB2_USART3_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb2_usart3_cfg::W](clk_apb2_usart3_cfg::W) writer structure"]
impl crate::Writable for CLK_APB2_USART3_CFG {}
#[doc = "CLK_APB2_USART3 clock configuration register"]
pub mod clk_apb2_usart3_cfg;
#[doc = "CLK_APB2_USART2 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb2_usart2_cfg](clk_apb2_usart2_cfg) module"]
pub type CLK_APB2_USART2_CFG = crate::Reg<u32, _CLK_APB2_USART2_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB2_USART2_CFG;
#[doc = "`read()` method returns [clk_apb2_usart2_cfg::R](clk_apb2_usart2_cfg::R) reader structure"]
impl crate::Readable for CLK_APB2_USART2_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb2_usart2_cfg::W](clk_apb2_usart2_cfg::W) writer structure"]
impl crate::Writable for CLK_APB2_USART2_CFG {}
#[doc = "CLK_APB2_USART2 clock configuration register"]
pub mod clk_apb2_usart2_cfg;
#[doc = "CLK_APB2_UART1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb0_uart1_bus_cfg](clk_apb0_uart1_bus_cfg) module"]
pub type CLK_APB0_UART1_BUS_CFG = crate::Reg<u32, _CLK_APB0_UART1_BUS_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB0_UART1_BUS_CFG;
#[doc = "`read()` method returns [clk_apb0_uart1_bus_cfg::R](clk_apb0_uart1_bus_cfg::R) reader structure"]
impl crate::Readable for CLK_APB0_UART1_BUS_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb0_uart1_bus_cfg::W](clk_apb0_uart1_bus_cfg::W) writer structure"]
impl crate::Writable for CLK_APB0_UART1_BUS_CFG {}
#[doc = "CLK_APB2_UART1 clock configuration register"]
pub mod clk_apb0_uart1_bus_cfg;
#[doc = "CLK_APB2_USART0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb0_usart0_cfg](clk_apb0_usart0_cfg) module"]
pub type CLK_APB0_USART0_CFG = crate::Reg<u32, _CLK_APB0_USART0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB0_USART0_CFG;
#[doc = "`read()` method returns [clk_apb0_usart0_cfg::R](clk_apb0_usart0_cfg::R) reader structure"]
impl crate::Readable for CLK_APB0_USART0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb0_usart0_cfg::W](clk_apb0_usart0_cfg::W) writer structure"]
impl crate::Writable for CLK_APB0_USART0_CFG {}
#[doc = "CLK_APB2_USART0 clock configuration register"]
pub mod clk_apb0_usart0_cfg;
#[doc = "CLK_APB0_SSP0 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb0_ssp0_cfg](clk_apb0_ssp0_cfg) module"]
pub type CLK_APB0_SSP0_CFG = crate::Reg<u32, _CLK_APB0_SSP0_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB0_SSP0_CFG;
#[doc = "`read()` method returns [clk_apb0_ssp0_cfg::R](clk_apb0_ssp0_cfg::R) reader structure"]
impl crate::Readable for CLK_APB0_SSP0_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb0_ssp0_cfg::W](clk_apb0_ssp0_cfg::W) writer structure"]
impl crate::Writable for CLK_APB0_SSP0_CFG {}
#[doc = "CLK_APB0_SSP0 clock configuration register"]
pub mod clk_apb0_ssp0_cfg;
#[doc = "CLK_APB2_SSP1 clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb2_ssp1_cfg](clk_apb2_ssp1_cfg) module"]
pub type CLK_APB2_SSP1_CFG = crate::Reg<u32, _CLK_APB2_SSP1_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB2_SSP1_CFG;
#[doc = "`read()` method returns [clk_apb2_ssp1_cfg::R](clk_apb2_ssp1_cfg::R) reader structure"]
impl crate::Readable for CLK_APB2_SSP1_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_apb2_ssp1_cfg::W](clk_apb2_ssp1_cfg::W) writer structure"]
impl crate::Writable for CLK_APB2_SSP1_CFG {}
#[doc = "CLK_APB2_SSP1 clock configuration register"]
pub mod clk_apb2_ssp1_cfg;
#[doc = "CLK_SDIO clock configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_sdio_cfg](clk_sdio_cfg) module"]
pub type CLK_SDIO_CFG = crate::Reg<u32, _CLK_SDIO_CFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_SDIO_CFG;
#[doc = "`read()` method returns [clk_sdio_cfg::R](clk_sdio_cfg::R) reader structure"]
impl crate::Readable for CLK_SDIO_CFG {}
#[doc = "`write(|w| ..)` method takes [clk_sdio_cfg::W](clk_sdio_cfg::W) writer structure"]
impl crate::Writable for CLK_SDIO_CFG {}
#[doc = "CLK_SDIO clock configuration register"]
pub mod clk_sdio_cfg;
#[doc = "CLK_AUDIO clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_audio_stat](clk_audio_stat) module"]
pub type CLK_AUDIO_STAT = crate::Reg<u32, _CLK_AUDIO_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_AUDIO_STAT;
#[doc = "`read()` method returns [clk_audio_stat::R](clk_audio_stat::R) reader structure"]
impl crate::Readable for CLK_AUDIO_STAT {}
#[doc = "CLK_AUDIO clock status register"]
pub mod clk_audio_stat;
#[doc = "CLK_APB2_USART3 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb2_usart3_status](clk_apb2_usart3_status) module"]
pub type CLK_APB2_USART3_STATUS = crate::Reg<u32, _CLK_APB2_USART3_STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB2_USART3_STATUS;
#[doc = "`read()` method returns [clk_apb2_usart3_status::R](clk_apb2_usart3_status::R) reader structure"]
impl crate::Readable for CLK_APB2_USART3_STATUS {}
#[doc = "CLK_APB2_USART3 clock status register"]
pub mod clk_apb2_usart3_status;
#[doc = "CLK_APB2_USART clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb2_usart2_status](clk_apb2_usart2_status) module"]
pub type CLK_APB2_USART2_STATUS = crate::Reg<u32, _CLK_APB2_USART2_STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB2_USART2_STATUS;
#[doc = "`read()` method returns [clk_apb2_usart2_status::R](clk_apb2_usart2_status::R) reader structure"]
impl crate::Readable for CLK_APB2_USART2_STATUS {}
#[doc = "CLK_APB2_USART clock status register"]
pub mod clk_apb2_usart2_status;
#[doc = "CLK_APB0_UART1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb0_uart1_stat](clk_apb0_uart1_stat) module"]
pub type CLK_APB0_UART1_STAT = crate::Reg<u32, _CLK_APB0_UART1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB0_UART1_STAT;
#[doc = "`read()` method returns [clk_apb0_uart1_stat::R](clk_apb0_uart1_stat::R) reader structure"]
impl crate::Readable for CLK_APB0_UART1_STAT {}
#[doc = "CLK_APB0_UART1 clock status register"]
pub mod clk_apb0_uart1_stat;
#[doc = "CLK_APB0_USART0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb0_usart0_status](clk_apb0_usart0_status) module"]
pub type CLK_APB0_USART0_STATUS = crate::Reg<u32, _CLK_APB0_USART0_STATUS>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB0_USART0_STATUS;
#[doc = "`read()` method returns [clk_apb0_usart0_status::R](clk_apb0_usart0_status::R) reader structure"]
impl crate::Readable for CLK_APB0_USART0_STATUS {}
#[doc = "CLK_APB0_USART0 clock status register"]
pub mod clk_apb0_usart0_status;
#[doc = "CLK_APB2_SSP1 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb2_ssp1_stat](clk_apb2_ssp1_stat) module"]
pub type CLK_APB2_SSP1_STAT = crate::Reg<u32, _CLK_APB2_SSP1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB2_SSP1_STAT;
#[doc = "`read()` method returns [clk_apb2_ssp1_stat::R](clk_apb2_ssp1_stat::R) reader structure"]
impl crate::Readable for CLK_APB2_SSP1_STAT {}
#[doc = "CLK_APB2_SSP1 clock status register"]
pub mod clk_apb2_ssp1_stat;
#[doc = "CLK_APB0_SSP0 clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_apb0_ssp0_stat](clk_apb0_ssp0_stat) module"]
pub type CLK_APB0_SSP0_STAT = crate::Reg<u32, _CLK_APB0_SSP0_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_APB0_SSP0_STAT;
#[doc = "`read()` method returns [clk_apb0_ssp0_stat::R](clk_apb0_ssp0_stat::R) reader structure"]
impl crate::Readable for CLK_APB0_SSP0_STAT {}
#[doc = "CLK_APB0_SSP0 clock status register"]
pub mod clk_apb0_ssp0_stat;
#[doc = "CLK_SDIO clock status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clk_sdio_stat](clk_sdio_stat) module"]
pub type CLK_SDIO_STAT = crate::Reg<u32, _CLK_SDIO_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLK_SDIO_STAT;
#[doc = "`read()` method returns [clk_sdio_stat::R](clk_sdio_stat::R) reader structure"]
impl crate::Readable for CLK_SDIO_STAT {}
#[doc = "CLK_SDIO clock status register"]
pub mod clk_sdio_stat;
