#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    _reserved0: [u8; 20usize],
    #[doc = "0x14 - Frequency monitor register"]
    pub freq_mon: FREQ_MON,
    #[doc = "0x18 - Crystal oscillator control register"]
    pub xtal_osc_ctrl: XTAL_OSC_CTRL,
    #[doc = "0x1c - PLL0USB status register"]
    pub pll0usb_stat: PLL0USB_STAT,
    #[doc = "0x20 - PLL0USB control register"]
    pub pll0usb_ctrl: PLL0USB_CTRL,
    #[doc = "0x24 - PLL0USB M-divider register"]
    pub pll0usb_mdiv: PLL0USB_MDIV,
    #[doc = "0x28 - PLL0USB N/P-divider register"]
    pub pll0usb_np_div: PLL0USB_NP_DIV,
    #[doc = "0x2c - PLL0AUDIO status register"]
    pub pll0audio_stat: PLL0AUDIO_STAT,
    #[doc = "0x30 - PLL0AUDIO control register"]
    pub pll0audio_ctrl: PLL0AUDIO_CTRL,
    #[doc = "0x34 - PLL0AUDIO M-divider register"]
    pub pll0audio_mdiv: PLL0AUDIO_MDIV,
    #[doc = "0x38 - PLL0AUDIO N/P-divider register"]
    pub pll0audio_np_div: PLL0AUDIO_NP_DIV,
    #[doc = "0x3c - PLL0AUDIO fractional divider register"]
    pub pll0audio_frac: PLL0AUDIO_FRAC,
    #[doc = "0x40 - PLL1 status register"]
    pub pll1_stat: PLL1_STAT,
    #[doc = "0x44 - PLL1 control register"]
    pub pll1_ctrl: PLL1_CTRL,
    #[doc = "0x48 - Integer divider A control register"]
    pub idiva_ctrl: IDIVA_CTRL,
    #[doc = "0x4c - Integer divider B control register"]
    pub idivb_ctrl: IDIVB_CTRL,
    #[doc = "0x50 - Integer divider C control register"]
    pub idivc_ctrl: IDIVC_CTRL,
    #[doc = "0x54 - Integer divider D control register"]
    pub idivd_ctrl: IDIVD_CTRL,
    #[doc = "0x58 - Integer divider E control register"]
    pub idive_ctrl: IDIVE_CTRL,
    #[doc = "0x5c - Output stage 0 control register for base clock BASE_SAFE_CLK"]
    pub base_safe_clk: BASE_SAFE_CLK,
    #[doc = "0x60 - Output stage 1 control register for base clock BASE_USB0_CLK"]
    pub base_usb0_clk: BASE_USB0_CLK,
    #[doc = "0x64 - Output stage 2 control register for base clock BASE_PERIPH_CLK"]
    pub base_periph_clk: BASE_PERIPH_CLK,
    #[doc = "0x68 - Output stage 3 control register for base clock BASE_USB1_CLK"]
    pub base_usb1_clk: BASE_USB1_CLK,
    #[doc = "0x6c - Output stage BASE_M4_CLK control register"]
    pub base_m4_clk: BASE_M4_CLK,
    #[doc = "0x70 - Output stage BASE_SPIFI_CLK control register"]
    pub base_spifi_clk: BASE_SPIFI_CLK,
    #[doc = "0x74 - Output stage BASE_SPI_CLK control register"]
    pub base_spi_clk: BASE_SPI_CLK,
    #[doc = "0x78 - Output stage BASE_PHY_RX_CLK control register"]
    pub base_phy_rx_clk: BASE_PHY_RX_CLK,
    #[doc = "0x7c - Output stage BASE_PHY_TX_CLK control register"]
    pub base_phy_tx_clk: BASE_PHY_TX_CLK,
    #[doc = "0x80 - Output stage BASE_APB1_CLK control register"]
    pub base_apb1_clk: BASE_APB1_CLK,
    #[doc = "0x84 - Output stage BASE_APB3_CLK control register"]
    pub base_apb3_clk: BASE_APB3_CLK,
    #[doc = "0x88 - Output stage BASE_LCD_CLK control register"]
    pub base_lcd_clk: BASE_LCD_CLK,
    _reserved30: [u8; 4usize],
    #[doc = "0x90 - Output stage BASE_SDIO_CLK control register"]
    pub base_sdio_clk: BASE_SDIO_CLK,
    #[doc = "0x94 - Output stage BASE_SSP0_CLK control register"]
    pub base_ssp0_clk: BASE_SSP0_CLK,
    #[doc = "0x98 - Output stage BASE_SSP1_CLK control register"]
    pub base_ssp1_clk: BASE_SSP1_CLK,
    #[doc = "0x9c - Output stage BASE_UART0_CLK control register"]
    pub base_uart0_clk: BASE_UART0_CLK,
    #[doc = "0xa0 - Output stage BASE_UART1_CLK control register"]
    pub base_uart1_clk: BASE_UART1_CLK,
    #[doc = "0xa4 - Output stage BASE_UART2_CLK control register"]
    pub base_uart2_clk: BASE_UART2_CLK,
    #[doc = "0xa8 - Output stage BASE_UART3_CLK control register"]
    pub base_uart3_clk: BASE_UART3_CLK,
    #[doc = "0xac - Output stage 20 control register for base clock BASE_OUT_CLK"]
    pub base_out_clk: BASE_OUT_CLK,
    _reserved38: [u8; 16usize],
    #[doc = "0xc0 - Output stage 25 control register for base clock BASE_AUDIO_CLK"]
    pub base_audio_clk: BASE_AUDIO_CLK,
    #[doc = "0xc4 - Output stage 25 control register for base clock BASE_CGU_OUT0_CLK"]
    pub base_cgu_out0_clk: BASE_CGU_OUT0_CLK,
    #[doc = "0xc8 - Output stage 25 control register for base clock BASE_CGU_OUT1_CLK"]
    pub base_cgu_out1_clk: BASE_CGU_OUT1_CLK,
}
#[doc = "Frequency monitor register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [freq_mon](freq_mon) module"]
pub type FREQ_MON = crate::Reg<u32, _FREQ_MON>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FREQ_MON;
#[doc = "`read()` method returns [freq_mon::R](freq_mon::R) reader structure"]
impl crate::Readable for FREQ_MON {}
#[doc = "`write(|w| ..)` method takes [freq_mon::W](freq_mon::W) writer structure"]
impl crate::Writable for FREQ_MON {}
#[doc = "Frequency monitor register"]
pub mod freq_mon;
#[doc = "Crystal oscillator control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [xtal_osc_ctrl](xtal_osc_ctrl) module"]
pub type XTAL_OSC_CTRL = crate::Reg<u32, _XTAL_OSC_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _XTAL_OSC_CTRL;
#[doc = "`read()` method returns [xtal_osc_ctrl::R](xtal_osc_ctrl::R) reader structure"]
impl crate::Readable for XTAL_OSC_CTRL {}
#[doc = "`write(|w| ..)` method takes [xtal_osc_ctrl::W](xtal_osc_ctrl::W) writer structure"]
impl crate::Writable for XTAL_OSC_CTRL {}
#[doc = "Crystal oscillator control register"]
pub mod xtal_osc_ctrl;
#[doc = "PLL0USB status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0usb_stat](pll0usb_stat) module"]
pub type PLL0USB_STAT = crate::Reg<u32, _PLL0USB_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0USB_STAT;
#[doc = "`read()` method returns [pll0usb_stat::R](pll0usb_stat::R) reader structure"]
impl crate::Readable for PLL0USB_STAT {}
#[doc = "PLL0USB status register"]
pub mod pll0usb_stat;
#[doc = "PLL0USB control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0usb_ctrl](pll0usb_ctrl) module"]
pub type PLL0USB_CTRL = crate::Reg<u32, _PLL0USB_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0USB_CTRL;
#[doc = "`read()` method returns [pll0usb_ctrl::R](pll0usb_ctrl::R) reader structure"]
impl crate::Readable for PLL0USB_CTRL {}
#[doc = "`write(|w| ..)` method takes [pll0usb_ctrl::W](pll0usb_ctrl::W) writer structure"]
impl crate::Writable for PLL0USB_CTRL {}
#[doc = "PLL0USB control register"]
pub mod pll0usb_ctrl;
#[doc = "PLL0USB M-divider register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0usb_mdiv](pll0usb_mdiv) module"]
pub type PLL0USB_MDIV = crate::Reg<u32, _PLL0USB_MDIV>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0USB_MDIV;
#[doc = "`read()` method returns [pll0usb_mdiv::R](pll0usb_mdiv::R) reader structure"]
impl crate::Readable for PLL0USB_MDIV {}
#[doc = "`write(|w| ..)` method takes [pll0usb_mdiv::W](pll0usb_mdiv::W) writer structure"]
impl crate::Writable for PLL0USB_MDIV {}
#[doc = "PLL0USB M-divider register"]
pub mod pll0usb_mdiv;
#[doc = "PLL0USB N/P-divider register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0usb_np_div](pll0usb_np_div) module"]
pub type PLL0USB_NP_DIV = crate::Reg<u32, _PLL0USB_NP_DIV>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0USB_NP_DIV;
#[doc = "`read()` method returns [pll0usb_np_div::R](pll0usb_np_div::R) reader structure"]
impl crate::Readable for PLL0USB_NP_DIV {}
#[doc = "`write(|w| ..)` method takes [pll0usb_np_div::W](pll0usb_np_div::W) writer structure"]
impl crate::Writable for PLL0USB_NP_DIV {}
#[doc = "PLL0USB N/P-divider register"]
pub mod pll0usb_np_div;
#[doc = "PLL0AUDIO status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0audio_stat](pll0audio_stat) module"]
pub type PLL0AUDIO_STAT = crate::Reg<u32, _PLL0AUDIO_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0AUDIO_STAT;
#[doc = "`read()` method returns [pll0audio_stat::R](pll0audio_stat::R) reader structure"]
impl crate::Readable for PLL0AUDIO_STAT {}
#[doc = "PLL0AUDIO status register"]
pub mod pll0audio_stat;
#[doc = "PLL0AUDIO control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0audio_ctrl](pll0audio_ctrl) module"]
pub type PLL0AUDIO_CTRL = crate::Reg<u32, _PLL0AUDIO_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0AUDIO_CTRL;
#[doc = "`read()` method returns [pll0audio_ctrl::R](pll0audio_ctrl::R) reader structure"]
impl crate::Readable for PLL0AUDIO_CTRL {}
#[doc = "`write(|w| ..)` method takes [pll0audio_ctrl::W](pll0audio_ctrl::W) writer structure"]
impl crate::Writable for PLL0AUDIO_CTRL {}
#[doc = "PLL0AUDIO control register"]
pub mod pll0audio_ctrl;
#[doc = "PLL0AUDIO M-divider register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0audio_mdiv](pll0audio_mdiv) module"]
pub type PLL0AUDIO_MDIV = crate::Reg<u32, _PLL0AUDIO_MDIV>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0AUDIO_MDIV;
#[doc = "`read()` method returns [pll0audio_mdiv::R](pll0audio_mdiv::R) reader structure"]
impl crate::Readable for PLL0AUDIO_MDIV {}
#[doc = "`write(|w| ..)` method takes [pll0audio_mdiv::W](pll0audio_mdiv::W) writer structure"]
impl crate::Writable for PLL0AUDIO_MDIV {}
#[doc = "PLL0AUDIO M-divider register"]
pub mod pll0audio_mdiv;
#[doc = "PLL0AUDIO N/P-divider register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0audio_np_div](pll0audio_np_div) module"]
pub type PLL0AUDIO_NP_DIV = crate::Reg<u32, _PLL0AUDIO_NP_DIV>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0AUDIO_NP_DIV;
#[doc = "`read()` method returns [pll0audio_np_div::R](pll0audio_np_div::R) reader structure"]
impl crate::Readable for PLL0AUDIO_NP_DIV {}
#[doc = "`write(|w| ..)` method takes [pll0audio_np_div::W](pll0audio_np_div::W) writer structure"]
impl crate::Writable for PLL0AUDIO_NP_DIV {}
#[doc = "PLL0AUDIO N/P-divider register"]
pub mod pll0audio_np_div;
#[doc = "PLL0AUDIO fractional divider register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll0audio_frac](pll0audio_frac) module"]
pub type PLL0AUDIO_FRAC = crate::Reg<u32, _PLL0AUDIO_FRAC>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL0AUDIO_FRAC;
#[doc = "`read()` method returns [pll0audio_frac::R](pll0audio_frac::R) reader structure"]
impl crate::Readable for PLL0AUDIO_FRAC {}
#[doc = "`write(|w| ..)` method takes [pll0audio_frac::W](pll0audio_frac::W) writer structure"]
impl crate::Writable for PLL0AUDIO_FRAC {}
#[doc = "PLL0AUDIO fractional divider register"]
pub mod pll0audio_frac;
#[doc = "PLL1 status register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll1_stat](pll1_stat) module"]
pub type PLL1_STAT = crate::Reg<u32, _PLL1_STAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL1_STAT;
#[doc = "`read()` method returns [pll1_stat::R](pll1_stat::R) reader structure"]
impl crate::Readable for PLL1_STAT {}
#[doc = "PLL1 status register"]
pub mod pll1_stat;
#[doc = "PLL1 control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pll1_ctrl](pll1_ctrl) module"]
pub type PLL1_CTRL = crate::Reg<u32, _PLL1_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PLL1_CTRL;
#[doc = "`read()` method returns [pll1_ctrl::R](pll1_ctrl::R) reader structure"]
impl crate::Readable for PLL1_CTRL {}
#[doc = "`write(|w| ..)` method takes [pll1_ctrl::W](pll1_ctrl::W) writer structure"]
impl crate::Writable for PLL1_CTRL {}
#[doc = "PLL1 control register"]
pub mod pll1_ctrl;
#[doc = "Integer divider A control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [idiva_ctrl](idiva_ctrl) module"]
pub type IDIVA_CTRL = crate::Reg<u32, _IDIVA_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IDIVA_CTRL;
#[doc = "`read()` method returns [idiva_ctrl::R](idiva_ctrl::R) reader structure"]
impl crate::Readable for IDIVA_CTRL {}
#[doc = "`write(|w| ..)` method takes [idiva_ctrl::W](idiva_ctrl::W) writer structure"]
impl crate::Writable for IDIVA_CTRL {}
#[doc = "Integer divider A control register"]
pub mod idiva_ctrl;
#[doc = "Integer divider B control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [idivb_ctrl](idivb_ctrl) module"]
pub type IDIVB_CTRL = crate::Reg<u32, _IDIVB_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IDIVB_CTRL;
#[doc = "`read()` method returns [idivb_ctrl::R](idivb_ctrl::R) reader structure"]
impl crate::Readable for IDIVB_CTRL {}
#[doc = "`write(|w| ..)` method takes [idivb_ctrl::W](idivb_ctrl::W) writer structure"]
impl crate::Writable for IDIVB_CTRL {}
#[doc = "Integer divider B control register"]
pub mod idivb_ctrl;
#[doc = "Integer divider C control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [idivc_ctrl](idivc_ctrl) module"]
pub type IDIVC_CTRL = crate::Reg<u32, _IDIVC_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IDIVC_CTRL;
#[doc = "`read()` method returns [idivc_ctrl::R](idivc_ctrl::R) reader structure"]
impl crate::Readable for IDIVC_CTRL {}
#[doc = "`write(|w| ..)` method takes [idivc_ctrl::W](idivc_ctrl::W) writer structure"]
impl crate::Writable for IDIVC_CTRL {}
#[doc = "Integer divider C control register"]
pub mod idivc_ctrl;
#[doc = "Integer divider D control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [idivd_ctrl](idivd_ctrl) module"]
pub type IDIVD_CTRL = crate::Reg<u32, _IDIVD_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IDIVD_CTRL;
#[doc = "`read()` method returns [idivd_ctrl::R](idivd_ctrl::R) reader structure"]
impl crate::Readable for IDIVD_CTRL {}
#[doc = "`write(|w| ..)` method takes [idivd_ctrl::W](idivd_ctrl::W) writer structure"]
impl crate::Writable for IDIVD_CTRL {}
#[doc = "Integer divider D control register"]
pub mod idivd_ctrl;
#[doc = "Integer divider E control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [idive_ctrl](idive_ctrl) module"]
pub type IDIVE_CTRL = crate::Reg<u32, _IDIVE_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _IDIVE_CTRL;
#[doc = "`read()` method returns [idive_ctrl::R](idive_ctrl::R) reader structure"]
impl crate::Readable for IDIVE_CTRL {}
#[doc = "`write(|w| ..)` method takes [idive_ctrl::W](idive_ctrl::W) writer structure"]
impl crate::Writable for IDIVE_CTRL {}
#[doc = "Integer divider E control register"]
pub mod idive_ctrl;
#[doc = "Output stage 0 control register for base clock BASE_SAFE_CLK\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_safe_clk](base_safe_clk) module"]
pub type BASE_SAFE_CLK = crate::Reg<u32, _BASE_SAFE_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_SAFE_CLK;
#[doc = "`read()` method returns [base_safe_clk::R](base_safe_clk::R) reader structure"]
impl crate::Readable for BASE_SAFE_CLK {}
#[doc = "Output stage 0 control register for base clock BASE_SAFE_CLK"]
pub mod base_safe_clk;
#[doc = "Output stage 1 control register for base clock BASE_USB0_CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_usb0_clk](base_usb0_clk) module"]
pub type BASE_USB0_CLK = crate::Reg<u32, _BASE_USB0_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_USB0_CLK;
#[doc = "`read()` method returns [base_usb0_clk::R](base_usb0_clk::R) reader structure"]
impl crate::Readable for BASE_USB0_CLK {}
#[doc = "`write(|w| ..)` method takes [base_usb0_clk::W](base_usb0_clk::W) writer structure"]
impl crate::Writable for BASE_USB0_CLK {}
#[doc = "Output stage 1 control register for base clock BASE_USB0_CLK"]
pub mod base_usb0_clk;
#[doc = "Output stage 2 control register for base clock BASE_PERIPH_CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_periph_clk](base_periph_clk) module"]
pub type BASE_PERIPH_CLK = crate::Reg<u32, _BASE_PERIPH_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_PERIPH_CLK;
#[doc = "`read()` method returns [base_periph_clk::R](base_periph_clk::R) reader structure"]
impl crate::Readable for BASE_PERIPH_CLK {}
#[doc = "`write(|w| ..)` method takes [base_periph_clk::W](base_periph_clk::W) writer structure"]
impl crate::Writable for BASE_PERIPH_CLK {}
#[doc = "Output stage 2 control register for base clock BASE_PERIPH_CLK"]
pub mod base_periph_clk;
#[doc = "Output stage 3 control register for base clock BASE_USB1_CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_usb1_clk](base_usb1_clk) module"]
pub type BASE_USB1_CLK = crate::Reg<u32, _BASE_USB1_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_USB1_CLK;
#[doc = "`read()` method returns [base_usb1_clk::R](base_usb1_clk::R) reader structure"]
impl crate::Readable for BASE_USB1_CLK {}
#[doc = "`write(|w| ..)` method takes [base_usb1_clk::W](base_usb1_clk::W) writer structure"]
impl crate::Writable for BASE_USB1_CLK {}
#[doc = "Output stage 3 control register for base clock BASE_USB1_CLK"]
pub mod base_usb1_clk;
#[doc = "Output stage BASE_M4_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_m4_clk](base_m4_clk) module"]
pub type BASE_M4_CLK = crate::Reg<u32, _BASE_M4_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_M4_CLK;
#[doc = "`read()` method returns [base_m4_clk::R](base_m4_clk::R) reader structure"]
impl crate::Readable for BASE_M4_CLK {}
#[doc = "`write(|w| ..)` method takes [base_m4_clk::W](base_m4_clk::W) writer structure"]
impl crate::Writable for BASE_M4_CLK {}
#[doc = "Output stage BASE_M4_CLK control register"]
pub mod base_m4_clk;
#[doc = "Output stage BASE_SPIFI_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_spifi_clk](base_spifi_clk) module"]
pub type BASE_SPIFI_CLK = crate::Reg<u32, _BASE_SPIFI_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_SPIFI_CLK;
#[doc = "`read()` method returns [base_spifi_clk::R](base_spifi_clk::R) reader structure"]
impl crate::Readable for BASE_SPIFI_CLK {}
#[doc = "`write(|w| ..)` method takes [base_spifi_clk::W](base_spifi_clk::W) writer structure"]
impl crate::Writable for BASE_SPIFI_CLK {}
#[doc = "Output stage BASE_SPIFI_CLK control register"]
pub mod base_spifi_clk;
#[doc = "Output stage BASE_SPI_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_spi_clk](base_spi_clk) module"]
pub type BASE_SPI_CLK = crate::Reg<u32, _BASE_SPI_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_SPI_CLK;
#[doc = "`read()` method returns [base_spi_clk::R](base_spi_clk::R) reader structure"]
impl crate::Readable for BASE_SPI_CLK {}
#[doc = "`write(|w| ..)` method takes [base_spi_clk::W](base_spi_clk::W) writer structure"]
impl crate::Writable for BASE_SPI_CLK {}
#[doc = "Output stage BASE_SPI_CLK control register"]
pub mod base_spi_clk;
#[doc = "Output stage BASE_PHY_RX_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_phy_rx_clk](base_phy_rx_clk) module"]
pub type BASE_PHY_RX_CLK = crate::Reg<u32, _BASE_PHY_RX_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_PHY_RX_CLK;
#[doc = "`read()` method returns [base_phy_rx_clk::R](base_phy_rx_clk::R) reader structure"]
impl crate::Readable for BASE_PHY_RX_CLK {}
#[doc = "`write(|w| ..)` method takes [base_phy_rx_clk::W](base_phy_rx_clk::W) writer structure"]
impl crate::Writable for BASE_PHY_RX_CLK {}
#[doc = "Output stage BASE_PHY_RX_CLK control register"]
pub mod base_phy_rx_clk;
#[doc = "Output stage BASE_PHY_TX_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_phy_tx_clk](base_phy_tx_clk) module"]
pub type BASE_PHY_TX_CLK = crate::Reg<u32, _BASE_PHY_TX_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_PHY_TX_CLK;
#[doc = "`read()` method returns [base_phy_tx_clk::R](base_phy_tx_clk::R) reader structure"]
impl crate::Readable for BASE_PHY_TX_CLK {}
#[doc = "`write(|w| ..)` method takes [base_phy_tx_clk::W](base_phy_tx_clk::W) writer structure"]
impl crate::Writable for BASE_PHY_TX_CLK {}
#[doc = "Output stage BASE_PHY_TX_CLK control register"]
pub mod base_phy_tx_clk;
#[doc = "Output stage BASE_APB1_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_apb1_clk](base_apb1_clk) module"]
pub type BASE_APB1_CLK = crate::Reg<u32, _BASE_APB1_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_APB1_CLK;
#[doc = "`read()` method returns [base_apb1_clk::R](base_apb1_clk::R) reader structure"]
impl crate::Readable for BASE_APB1_CLK {}
#[doc = "`write(|w| ..)` method takes [base_apb1_clk::W](base_apb1_clk::W) writer structure"]
impl crate::Writable for BASE_APB1_CLK {}
#[doc = "Output stage BASE_APB1_CLK control register"]
pub mod base_apb1_clk;
#[doc = "Output stage BASE_APB3_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_apb3_clk](base_apb3_clk) module"]
pub type BASE_APB3_CLK = crate::Reg<u32, _BASE_APB3_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_APB3_CLK;
#[doc = "`read()` method returns [base_apb3_clk::R](base_apb3_clk::R) reader structure"]
impl crate::Readable for BASE_APB3_CLK {}
#[doc = "`write(|w| ..)` method takes [base_apb3_clk::W](base_apb3_clk::W) writer structure"]
impl crate::Writable for BASE_APB3_CLK {}
#[doc = "Output stage BASE_APB3_CLK control register"]
pub mod base_apb3_clk;
#[doc = "Output stage BASE_LCD_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_lcd_clk](base_lcd_clk) module"]
pub type BASE_LCD_CLK = crate::Reg<u32, _BASE_LCD_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_LCD_CLK;
#[doc = "`read()` method returns [base_lcd_clk::R](base_lcd_clk::R) reader structure"]
impl crate::Readable for BASE_LCD_CLK {}
#[doc = "`write(|w| ..)` method takes [base_lcd_clk::W](base_lcd_clk::W) writer structure"]
impl crate::Writable for BASE_LCD_CLK {}
#[doc = "Output stage BASE_LCD_CLK control register"]
pub mod base_lcd_clk;
#[doc = "Output stage BASE_SDIO_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_sdio_clk](base_sdio_clk) module"]
pub type BASE_SDIO_CLK = crate::Reg<u32, _BASE_SDIO_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_SDIO_CLK;
#[doc = "`read()` method returns [base_sdio_clk::R](base_sdio_clk::R) reader structure"]
impl crate::Readable for BASE_SDIO_CLK {}
#[doc = "`write(|w| ..)` method takes [base_sdio_clk::W](base_sdio_clk::W) writer structure"]
impl crate::Writable for BASE_SDIO_CLK {}
#[doc = "Output stage BASE_SDIO_CLK control register"]
pub mod base_sdio_clk;
#[doc = "Output stage BASE_SSP0_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_ssp0_clk](base_ssp0_clk) module"]
pub type BASE_SSP0_CLK = crate::Reg<u32, _BASE_SSP0_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_SSP0_CLK;
#[doc = "`read()` method returns [base_ssp0_clk::R](base_ssp0_clk::R) reader structure"]
impl crate::Readable for BASE_SSP0_CLK {}
#[doc = "`write(|w| ..)` method takes [base_ssp0_clk::W](base_ssp0_clk::W) writer structure"]
impl crate::Writable for BASE_SSP0_CLK {}
#[doc = "Output stage BASE_SSP0_CLK control register"]
pub mod base_ssp0_clk;
#[doc = "Output stage BASE_SSP1_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_ssp1_clk](base_ssp1_clk) module"]
pub type BASE_SSP1_CLK = crate::Reg<u32, _BASE_SSP1_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_SSP1_CLK;
#[doc = "`read()` method returns [base_ssp1_clk::R](base_ssp1_clk::R) reader structure"]
impl crate::Readable for BASE_SSP1_CLK {}
#[doc = "`write(|w| ..)` method takes [base_ssp1_clk::W](base_ssp1_clk::W) writer structure"]
impl crate::Writable for BASE_SSP1_CLK {}
#[doc = "Output stage BASE_SSP1_CLK control register"]
pub mod base_ssp1_clk;
#[doc = "Output stage BASE_UART0_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_uart0_clk](base_uart0_clk) module"]
pub type BASE_UART0_CLK = crate::Reg<u32, _BASE_UART0_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_UART0_CLK;
#[doc = "`read()` method returns [base_uart0_clk::R](base_uart0_clk::R) reader structure"]
impl crate::Readable for BASE_UART0_CLK {}
#[doc = "`write(|w| ..)` method takes [base_uart0_clk::W](base_uart0_clk::W) writer structure"]
impl crate::Writable for BASE_UART0_CLK {}
#[doc = "Output stage BASE_UART0_CLK control register"]
pub mod base_uart0_clk;
#[doc = "Output stage BASE_UART1_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_uart1_clk](base_uart1_clk) module"]
pub type BASE_UART1_CLK = crate::Reg<u32, _BASE_UART1_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_UART1_CLK;
#[doc = "`read()` method returns [base_uart1_clk::R](base_uart1_clk::R) reader structure"]
impl crate::Readable for BASE_UART1_CLK {}
#[doc = "`write(|w| ..)` method takes [base_uart1_clk::W](base_uart1_clk::W) writer structure"]
impl crate::Writable for BASE_UART1_CLK {}
#[doc = "Output stage BASE_UART1_CLK control register"]
pub mod base_uart1_clk;
#[doc = "Output stage BASE_UART2_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_uart2_clk](base_uart2_clk) module"]
pub type BASE_UART2_CLK = crate::Reg<u32, _BASE_UART2_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_UART2_CLK;
#[doc = "`read()` method returns [base_uart2_clk::R](base_uart2_clk::R) reader structure"]
impl crate::Readable for BASE_UART2_CLK {}
#[doc = "`write(|w| ..)` method takes [base_uart2_clk::W](base_uart2_clk::W) writer structure"]
impl crate::Writable for BASE_UART2_CLK {}
#[doc = "Output stage BASE_UART2_CLK control register"]
pub mod base_uart2_clk;
#[doc = "Output stage BASE_UART3_CLK control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_uart3_clk](base_uart3_clk) module"]
pub type BASE_UART3_CLK = crate::Reg<u32, _BASE_UART3_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_UART3_CLK;
#[doc = "`read()` method returns [base_uart3_clk::R](base_uart3_clk::R) reader structure"]
impl crate::Readable for BASE_UART3_CLK {}
#[doc = "`write(|w| ..)` method takes [base_uart3_clk::W](base_uart3_clk::W) writer structure"]
impl crate::Writable for BASE_UART3_CLK {}
#[doc = "Output stage BASE_UART3_CLK control register"]
pub mod base_uart3_clk;
#[doc = "Output stage 20 control register for base clock BASE_OUT_CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_out_clk](base_out_clk) module"]
pub type BASE_OUT_CLK = crate::Reg<u32, _BASE_OUT_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_OUT_CLK;
#[doc = "`read()` method returns [base_out_clk::R](base_out_clk::R) reader structure"]
impl crate::Readable for BASE_OUT_CLK {}
#[doc = "`write(|w| ..)` method takes [base_out_clk::W](base_out_clk::W) writer structure"]
impl crate::Writable for BASE_OUT_CLK {}
#[doc = "Output stage 20 control register for base clock BASE_OUT_CLK"]
pub mod base_out_clk;
#[doc = "Output stage 25 control register for base clock BASE_AUDIO_CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_audio_clk](base_audio_clk) module"]
pub type BASE_AUDIO_CLK = crate::Reg<u32, _BASE_AUDIO_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_AUDIO_CLK;
#[doc = "`read()` method returns [base_audio_clk::R](base_audio_clk::R) reader structure"]
impl crate::Readable for BASE_AUDIO_CLK {}
#[doc = "`write(|w| ..)` method takes [base_audio_clk::W](base_audio_clk::W) writer structure"]
impl crate::Writable for BASE_AUDIO_CLK {}
#[doc = "Output stage 25 control register for base clock BASE_AUDIO_CLK"]
pub mod base_audio_clk;
#[doc = "Output stage 25 control register for base clock BASE_CGU_OUT0_CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_cgu_out0_clk](base_cgu_out0_clk) module"]
pub type BASE_CGU_OUT0_CLK = crate::Reg<u32, _BASE_CGU_OUT0_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_CGU_OUT0_CLK;
#[doc = "`read()` method returns [base_cgu_out0_clk::R](base_cgu_out0_clk::R) reader structure"]
impl crate::Readable for BASE_CGU_OUT0_CLK {}
#[doc = "`write(|w| ..)` method takes [base_cgu_out0_clk::W](base_cgu_out0_clk::W) writer structure"]
impl crate::Writable for BASE_CGU_OUT0_CLK {}
#[doc = "Output stage 25 control register for base clock BASE_CGU_OUT0_CLK"]
pub mod base_cgu_out0_clk;
#[doc = "Output stage 25 control register for base clock BASE_CGU_OUT1_CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [base_cgu_out1_clk](base_cgu_out1_clk) module"]
pub type BASE_CGU_OUT1_CLK = crate::Reg<u32, _BASE_CGU_OUT1_CLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _BASE_CGU_OUT1_CLK;
#[doc = "`read()` method returns [base_cgu_out1_clk::R](base_cgu_out1_clk::R) reader structure"]
impl crate::Readable for BASE_CGU_OUT1_CLK {}
#[doc = "`write(|w| ..)` method takes [base_cgu_out1_clk::W](base_cgu_out1_clk::W) writer structure"]
impl crate::Writable for BASE_CGU_OUT1_CLK {}
#[doc = "Output stage 25 control register for base clock BASE_CGU_OUT1_CLK"]
pub mod base_cgu_out1_clk;
