#[doc = "Reader of register BASE_SPI_CLK"]
pub type R = crate::R<u32, super::BASE_SPI_CLK>;
#[doc = "Writer for register BASE_SPI_CLK"]
pub type W = crate::W<u32, super::BASE_SPI_CLK>;
#[doc = "Register BASE_SPI_CLK `reset()`'s with value 0x0100_0000"]
impl crate::ResetValue for super::BASE_SPI_CLK {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0100_0000
    }
}
#[doc = "Output stage power down\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PD_A {
    #[doc = "0: Output stage enabled (default)"]
    OUTPUT_STAGE_ENABLED,
    #[doc = "1: power-down"]
    POWER_DOWN,
}
impl From<PD_A> for bool {
    #[inline(always)]
    fn from(variant: PD_A) -> Self {
        match variant {
            PD_A::OUTPUT_STAGE_ENABLED => false,
            PD_A::POWER_DOWN => true,
        }
    }
}
#[doc = "Reader of field `PD`"]
pub type PD_R = crate::R<bool, PD_A>;
impl PD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PD_A {
        match self.bits {
            false => PD_A::OUTPUT_STAGE_ENABLED,
            true => PD_A::POWER_DOWN,
        }
    }
    #[doc = "Checks if the value of the field is `OUTPUT_STAGE_ENABLED`"]
    #[inline(always)]
    pub fn is_output_stage_enabled(&self) -> bool {
        *self == PD_A::OUTPUT_STAGE_ENABLED
    }
    #[doc = "Checks if the value of the field is `POWER_DOWN`"]
    #[inline(always)]
    pub fn is_power_down(&self) -> bool {
        *self == PD_A::POWER_DOWN
    }
}
#[doc = "Write proxy for field `PD`"]
pub struct PD_W<'a> {
    w: &'a mut W,
}
impl<'a> PD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Output stage enabled (default)"]
    #[inline(always)]
    pub fn output_stage_enabled(self) -> &'a mut W {
        self.variant(PD_A::OUTPUT_STAGE_ENABLED)
    }
    #[doc = "power-down"]
    #[inline(always)]
    pub fn power_down(self) -> &'a mut W {
        self.variant(PD_A::POWER_DOWN)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Block clock automatically during frequency change\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AUTOBLOCK_A {
    #[doc = "0: Disabled. Autoblocking disabled"]
    DISABLED,
    #[doc = "1: Enabled. Autoblocking enabled"]
    ENABLED,
}
impl From<AUTOBLOCK_A> for bool {
    #[inline(always)]
    fn from(variant: AUTOBLOCK_A) -> Self {
        match variant {
            AUTOBLOCK_A::DISABLED => false,
            AUTOBLOCK_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `AUTOBLOCK`"]
pub type AUTOBLOCK_R = crate::R<bool, AUTOBLOCK_A>;
impl AUTOBLOCK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> AUTOBLOCK_A {
        match self.bits {
            false => AUTOBLOCK_A::DISABLED,
            true => AUTOBLOCK_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == AUTOBLOCK_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == AUTOBLOCK_A::ENABLED
    }
}
#[doc = "Write proxy for field `AUTOBLOCK`"]
pub struct AUTOBLOCK_W<'a> {
    w: &'a mut W,
}
impl<'a> AUTOBLOCK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: AUTOBLOCK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Autoblocking disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::DISABLED)
    }
    #[doc = "Enabled. Autoblocking enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Clock source selection. All other values are reserved.\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CLK_SEL_A {
    #[doc = "0: 32 kHz oscillator"]
    _32_KHZ_OSCILLATOR,
    #[doc = "1: IRC (default)"]
    IRC_DEFAULT,
    #[doc = "2: ENET_RX_CLK"]
    ENET_RX_CLK,
    #[doc = "3: ENET_TX_CLK"]
    ENET_TX_CLK,
    #[doc = "4: GP_CLKIN"]
    GP_CLKIN,
    #[doc = "6: Crystal oscillator"]
    CRYSTAL_OSCILLATOR,
    #[doc = "8: PLL0 (for audio)"]
    PLL0_FOR_AUDIO,
    #[doc = "9: PLL1"]
    PLL1,
    #[doc = "12: IDIVA"]
    IDIVA,
    #[doc = "13: IDIVB"]
    IDIVB,
    #[doc = "14: IDIVC"]
    IDIVC,
    #[doc = "15: IDIVD"]
    IDIVD,
    #[doc = "16: IDIVE"]
    IDIVE,
}
impl From<CLK_SEL_A> for u8 {
    #[inline(always)]
    fn from(variant: CLK_SEL_A) -> Self {
        match variant {
            CLK_SEL_A::_32_KHZ_OSCILLATOR => 0,
            CLK_SEL_A::IRC_DEFAULT => 1,
            CLK_SEL_A::ENET_RX_CLK => 2,
            CLK_SEL_A::ENET_TX_CLK => 3,
            CLK_SEL_A::GP_CLKIN => 4,
            CLK_SEL_A::CRYSTAL_OSCILLATOR => 6,
            CLK_SEL_A::PLL0_FOR_AUDIO => 8,
            CLK_SEL_A::PLL1 => 9,
            CLK_SEL_A::IDIVA => 12,
            CLK_SEL_A::IDIVB => 13,
            CLK_SEL_A::IDIVC => 14,
            CLK_SEL_A::IDIVD => 15,
            CLK_SEL_A::IDIVE => 16,
        }
    }
}
#[doc = "Reader of field `CLK_SEL`"]
pub type CLK_SEL_R = crate::R<u8, CLK_SEL_A>;
impl CLK_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, CLK_SEL_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(CLK_SEL_A::_32_KHZ_OSCILLATOR),
            1 => Val(CLK_SEL_A::IRC_DEFAULT),
            2 => Val(CLK_SEL_A::ENET_RX_CLK),
            3 => Val(CLK_SEL_A::ENET_TX_CLK),
            4 => Val(CLK_SEL_A::GP_CLKIN),
            6 => Val(CLK_SEL_A::CRYSTAL_OSCILLATOR),
            8 => Val(CLK_SEL_A::PLL0_FOR_AUDIO),
            9 => Val(CLK_SEL_A::PLL1),
            12 => Val(CLK_SEL_A::IDIVA),
            13 => Val(CLK_SEL_A::IDIVB),
            14 => Val(CLK_SEL_A::IDIVC),
            15 => Val(CLK_SEL_A::IDIVD),
            16 => Val(CLK_SEL_A::IDIVE),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `_32_KHZ_OSCILLATOR`"]
    #[inline(always)]
    pub fn is_32_khz_oscillator(&self) -> bool {
        *self == CLK_SEL_A::_32_KHZ_OSCILLATOR
    }
    #[doc = "Checks if the value of the field is `IRC_DEFAULT`"]
    #[inline(always)]
    pub fn is_irc_default(&self) -> bool {
        *self == CLK_SEL_A::IRC_DEFAULT
    }
    #[doc = "Checks if the value of the field is `ENET_RX_CLK`"]
    #[inline(always)]
    pub fn is_enet_rx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_RX_CLK
    }
    #[doc = "Checks if the value of the field is `ENET_TX_CLK`"]
    #[inline(always)]
    pub fn is_enet_tx_clk(&self) -> bool {
        *self == CLK_SEL_A::ENET_TX_CLK
    }
    #[doc = "Checks if the value of the field is `GP_CLKIN`"]
    #[inline(always)]
    pub fn is_gp_clkin(&self) -> bool {
        *self == CLK_SEL_A::GP_CLKIN
    }
    #[doc = "Checks if the value of the field is `CRYSTAL_OSCILLATOR`"]
    #[inline(always)]
    pub fn is_crystal_oscillator(&self) -> bool {
        *self == CLK_SEL_A::CRYSTAL_OSCILLATOR
    }
    #[doc = "Checks if the value of the field is `PLL0_FOR_AUDIO`"]
    #[inline(always)]
    pub fn is_pll0_for_audio(&self) -> bool {
        *self == CLK_SEL_A::PLL0_FOR_AUDIO
    }
    #[doc = "Checks if the value of the field is `PLL1`"]
    #[inline(always)]
    pub fn is_pll1(&self) -> bool {
        *self == CLK_SEL_A::PLL1
    }
    #[doc = "Checks if the value of the field is `IDIVA`"]
    #[inline(always)]
    pub fn is_idiva(&self) -> bool {
        *self == CLK_SEL_A::IDIVA
    }
    #[doc = "Checks if the value of the field is `IDIVB`"]
    #[inline(always)]
    pub fn is_idivb(&self) -> bool {
        *self == CLK_SEL_A::IDIVB
    }
    #[doc = "Checks if the value of the field is `IDIVC`"]
    #[inline(always)]
    pub fn is_idivc(&self) -> bool {
        *self == CLK_SEL_A::IDIVC
    }
    #[doc = "Checks if the value of the field is `IDIVD`"]
    #[inline(always)]
    pub fn is_idivd(&self) -> bool {
        *self == CLK_SEL_A::IDIVD
    }
    #[doc = "Checks if the value of the field is `IDIVE`"]
    #[inline(always)]
    pub fn is_idive(&self) -> bool {
        *self == CLK_SEL_A::IDIVE
    }
}
#[doc = "Write proxy for field `CLK_SEL`"]
pub struct CLK_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_SEL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "32 kHz oscillator"]
    #[inline(always)]
    pub fn _32_khz_oscillator(self) -> &'a mut W {
        self.variant(CLK_SEL_A::_32_KHZ_OSCILLATOR)
    }
    #[doc = "IRC (default)"]
    #[inline(always)]
    pub fn irc_default(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IRC_DEFAULT)
    }
    #[doc = "ENET_RX_CLK"]
    #[inline(always)]
    pub fn enet_rx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_RX_CLK)
    }
    #[doc = "ENET_TX_CLK"]
    #[inline(always)]
    pub fn enet_tx_clk(self) -> &'a mut W {
        self.variant(CLK_SEL_A::ENET_TX_CLK)
    }
    #[doc = "GP_CLKIN"]
    #[inline(always)]
    pub fn gp_clkin(self) -> &'a mut W {
        self.variant(CLK_SEL_A::GP_CLKIN)
    }
    #[doc = "Crystal oscillator"]
    #[inline(always)]
    pub fn crystal_oscillator(self) -> &'a mut W {
        self.variant(CLK_SEL_A::CRYSTAL_OSCILLATOR)
    }
    #[doc = "PLL0 (for audio)"]
    #[inline(always)]
    pub fn pll0_for_audio(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL0_FOR_AUDIO)
    }
    #[doc = "PLL1"]
    #[inline(always)]
    pub fn pll1(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL1)
    }
    #[doc = "IDIVA"]
    #[inline(always)]
    pub fn idiva(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVA)
    }
    #[doc = "IDIVB"]
    #[inline(always)]
    pub fn idivb(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVB)
    }
    #[doc = "IDIVC"]
    #[inline(always)]
    pub fn idivc(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVC)
    }
    #[doc = "IDIVD"]
    #[inline(always)]
    pub fn idivd(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVD)
    }
    #[doc = "IDIVE"]
    #[inline(always)]
    pub fn idive(self) -> &'a mut W {
        self.variant(CLK_SEL_A::IDIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 24)) | (((value as u32) & 0x1f) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Output stage power down"]
    #[inline(always)]
    pub fn pd(&self) -> PD_R {
        PD_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&self) -> AUTOBLOCK_R {
        AUTOBLOCK_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bits 24:28 - Clock source selection. All other values are reserved."]
    #[inline(always)]
    pub fn clk_sel(&self) -> CLK_SEL_R {
        CLK_SEL_R::new(((self.bits >> 24) & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Output stage power down"]
    #[inline(always)]
    pub fn pd(&mut self) -> PD_W {
        PD_W { w: self }
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&mut self) -> AUTOBLOCK_W {
        AUTOBLOCK_W { w: self }
    }
    #[doc = "Bits 24:28 - Clock source selection. All other values are reserved."]
    #[inline(always)]
    pub fn clk_sel(&mut self) -> CLK_SEL_W {
        CLK_SEL_W { w: self }
    }
}
