#[doc = "Reader of register BASE_USB0_CLK"]
pub type R = crate::R<u32, super::BASE_USB0_CLK>;
#[doc = "Writer for register BASE_USB0_CLK"]
pub type W = crate::W<u32, super::BASE_USB0_CLK>;
#[doc = "Register BASE_USB0_CLK `reset()`'s with value 0x0700_0000"]
impl crate::ResetValue for super::BASE_USB0_CLK {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0700_0000
    }
}
#[doc = "Output stage power down\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PD_A {
    #[doc = "0: Enabled. Output stage enabled (default)"]
    ENABLED,
    #[doc = "1: Power-down"]
    POWER_DOWN,
}
impl From<PD_A> for bool {
    #[inline(always)]
    fn from(variant: PD_A) -> Self {
        match variant {
            PD_A::ENABLED => false,
            PD_A::POWER_DOWN => true,
        }
    }
}
#[doc = "Reader of field `PD`"]
pub type PD_R = crate::R<bool, PD_A>;
impl PD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PD_A {
        match self.bits {
            false => PD_A::ENABLED,
            true => PD_A::POWER_DOWN,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == PD_A::ENABLED
    }
    #[doc = "Checks if the value of the field is `POWER_DOWN`"]
    #[inline(always)]
    pub fn is_power_down(&self) -> bool {
        *self == PD_A::POWER_DOWN
    }
}
#[doc = "Write proxy for field `PD`"]
pub struct PD_W<'a> {
    w: &'a mut W,
}
impl<'a> PD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enabled. Output stage enabled (default)"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PD_A::ENABLED)
    }
    #[doc = "Power-down"]
    #[inline(always)]
    pub fn power_down(self) -> &'a mut W {
        self.variant(PD_A::POWER_DOWN)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Block clock automatically during frequency change\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AUTOBLOCK_A {
    #[doc = "0: Disabled. Autoblocking disabled"]
    DISABLED,
    #[doc = "1: Enabled. Autoblocking enabled"]
    ENABLED,
}
impl From<AUTOBLOCK_A> for bool {
    #[inline(always)]
    fn from(variant: AUTOBLOCK_A) -> Self {
        match variant {
            AUTOBLOCK_A::DISABLED => false,
            AUTOBLOCK_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `AUTOBLOCK`"]
pub type AUTOBLOCK_R = crate::R<bool, AUTOBLOCK_A>;
impl AUTOBLOCK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> AUTOBLOCK_A {
        match self.bits {
            false => AUTOBLOCK_A::DISABLED,
            true => AUTOBLOCK_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == AUTOBLOCK_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == AUTOBLOCK_A::ENABLED
    }
}
#[doc = "Write proxy for field `AUTOBLOCK`"]
pub struct AUTOBLOCK_W<'a> {
    w: &'a mut W,
}
impl<'a> AUTOBLOCK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: AUTOBLOCK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Autoblocking disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::DISABLED)
    }
    #[doc = "Enabled. Autoblocking enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AUTOBLOCK_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Clock-source selection.\n\nValue on reset: 7"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CLK_SEL_A {
    #[doc = "7: PLL0USB (default)"]
    PLL0USB,
}
impl From<CLK_SEL_A> for u8 {
    #[inline(always)]
    fn from(variant: CLK_SEL_A) -> Self {
        match variant {
            CLK_SEL_A::PLL0USB => 7,
        }
    }
}
#[doc = "Reader of field `CLK_SEL`"]
pub type CLK_SEL_R = crate::R<u8, CLK_SEL_A>;
impl CLK_SEL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, CLK_SEL_A> {
        use crate::Variant::*;
        match self.bits {
            7 => Val(CLK_SEL_A::PLL0USB),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `PLL0USB`"]
    #[inline(always)]
    pub fn is_pll0usb(&self) -> bool {
        *self == CLK_SEL_A::PLL0USB
    }
}
#[doc = "Write proxy for field `CLK_SEL`"]
pub struct CLK_SEL_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_SEL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_SEL_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "PLL0USB (default)"]
    #[inline(always)]
    pub fn pll0usb(self) -> &'a mut W {
        self.variant(CLK_SEL_A::PLL0USB)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 24)) | (((value as u32) & 0x1f) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Output stage power down"]
    #[inline(always)]
    pub fn pd(&self) -> PD_R {
        PD_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&self) -> AUTOBLOCK_R {
        AUTOBLOCK_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bits 24:28 - Clock-source selection."]
    #[inline(always)]
    pub fn clk_sel(&self) -> CLK_SEL_R {
        CLK_SEL_R::new(((self.bits >> 24) & 0x1f) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Output stage power down"]
    #[inline(always)]
    pub fn pd(&mut self) -> PD_W {
        PD_W { w: self }
    }
    #[doc = "Bit 11 - Block clock automatically during frequency change"]
    #[inline(always)]
    pub fn autoblock(&mut self) -> AUTOBLOCK_W {
        AUTOBLOCK_W { w: self }
    }
    #[doc = "Bits 24:28 - Clock-source selection."]
    #[inline(always)]
    pub fn clk_sel(&mut self) -> CLK_SEL_W {
        CLK_SEL_W { w: self }
    }
}
