#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    _reserved0: [u8; 4usize],
    #[doc = "0x04 - Chip configuration register 32 kHz oscillator output and BOD control register."]
    pub creg0: CREG0,
    _reserved1: [u8; 248usize],
    #[doc = "0x100 - ARM Cortex-M4 memory mapping"]
    pub m4memmap: M4MEMMAP,
    _reserved2: [u8; 20usize],
    #[doc = "0x118 - Chip configuration register 5. Controls JTAG access."]
    pub creg5: CREG5,
    #[doc = "0x11c - DMA mux control"]
    pub dmamux: DMAMUX,
    #[doc = "0x120 - Flash accelerator configuration register for flash bank A"]
    pub flashcfga: FLASHCFGA,
    #[doc = "0x124 - Flash accelerator configuration register for flash bank B"]
    pub flashcfgb: FLASHCFGB,
    #[doc = "0x128 - ETB RAM configuration"]
    pub etbcfg: ETBCFG,
    #[doc = "0x12c - Chip configuration register 6. Controls multiple functions : Ethernet interface, SCT output, I2S0/1 inputs, EMC clock."]
    pub creg6: CREG6,
    #[doc = "0x130 - Cortex-M4 TXEV event clear"]
    pub m4txevent: M4TXEVENT,
    _reserved9: [u8; 204usize],
    #[doc = "0x200 - Part ID"]
    pub chipid: CHIPID,
    _reserved10: [u8; 260usize],
    #[doc = "0x308 - ARM Cortex-M0SUB memory mapping"]
    pub m0submemmap: M0SUBMEMMAP,
    _reserved11: [u8; 8usize],
    #[doc = "0x314 - Cortex-M0SUB TXEV event clear"]
    pub m0subtxevent: M0SUBTXEVENT,
    _reserved12: [u8; 232usize],
    #[doc = "0x400 - Cortex-M0APP TXEV event clear"]
    pub m0apptxevent: M0APPTXEVENT,
    #[doc = "0x404 - ARM Cortex-M0APP memory mapping"]
    pub m0appmemmap: M0APPMEMMAP,
    _reserved14: [u8; 248usize],
    #[doc = "0x500 - USB0 frame length adjust register"]
    pub usb0fladj: USB0FLADJ,
    _reserved15: [u8; 252usize],
    #[doc = "0x600 - USB1 frame length adjust register"]
    pub usb1fladj: USB1FLADJ,
}
#[doc = "Chip configuration register 32 kHz oscillator output and BOD control register.\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [creg0](creg0) module"]
pub type CREG0 = crate::Reg<u32, _CREG0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CREG0;
#[doc = "`read()` method returns [creg0::R](creg0::R) reader structure"]
impl crate::Readable for CREG0 {}
#[doc = "`write(|w| ..)` method takes [creg0::W](creg0::W) writer structure"]
impl crate::Writable for CREG0 {}
#[doc = "Chip configuration register 32 kHz oscillator output and BOD control register."]
pub mod creg0;
#[doc = "ARM Cortex-M4 memory mapping\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [m4memmap](m4memmap) module"]
pub type M4MEMMAP = crate::Reg<u32, _M4MEMMAP>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _M4MEMMAP;
#[doc = "`read()` method returns [m4memmap::R](m4memmap::R) reader structure"]
impl crate::Readable for M4MEMMAP {}
#[doc = "`write(|w| ..)` method takes [m4memmap::W](m4memmap::W) writer structure"]
impl crate::Writable for M4MEMMAP {}
#[doc = "ARM Cortex-M4 memory mapping"]
pub mod m4memmap;
#[doc = "Chip configuration register 5. Controls JTAG access.\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [creg5](creg5) module"]
pub type CREG5 = crate::Reg<u32, _CREG5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CREG5;
#[doc = "`read()` method returns [creg5::R](creg5::R) reader structure"]
impl crate::Readable for CREG5 {}
#[doc = "`write(|w| ..)` method takes [creg5::W](creg5::W) writer structure"]
impl crate::Writable for CREG5 {}
#[doc = "Chip configuration register 5. Controls JTAG access."]
pub mod creg5;
#[doc = "DMA mux control\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [dmamux](dmamux) module"]
pub type DMAMUX = crate::Reg<u32, _DMAMUX>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DMAMUX;
#[doc = "`read()` method returns [dmamux::R](dmamux::R) reader structure"]
impl crate::Readable for DMAMUX {}
#[doc = "`write(|w| ..)` method takes [dmamux::W](dmamux::W) writer structure"]
impl crate::Writable for DMAMUX {}
#[doc = "DMA mux control"]
pub mod dmamux;
#[doc = "Flash accelerator configuration register for flash bank A\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [flashcfga](flashcfga) module"]
pub type FLASHCFGA = crate::Reg<u32, _FLASHCFGA>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FLASHCFGA;
#[doc = "`read()` method returns [flashcfga::R](flashcfga::R) reader structure"]
impl crate::Readable for FLASHCFGA {}
#[doc = "`write(|w| ..)` method takes [flashcfga::W](flashcfga::W) writer structure"]
impl crate::Writable for FLASHCFGA {}
#[doc = "Flash accelerator configuration register for flash bank A"]
pub mod flashcfga;
#[doc = "Flash accelerator configuration register for flash bank B\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [flashcfgb](flashcfgb) module"]
pub type FLASHCFGB = crate::Reg<u32, _FLASHCFGB>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FLASHCFGB;
#[doc = "`read()` method returns [flashcfgb::R](flashcfgb::R) reader structure"]
impl crate::Readable for FLASHCFGB {}
#[doc = "`write(|w| ..)` method takes [flashcfgb::W](flashcfgb::W) writer structure"]
impl crate::Writable for FLASHCFGB {}
#[doc = "Flash accelerator configuration register for flash bank B"]
pub mod flashcfgb;
#[doc = "ETB RAM configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [etbcfg](etbcfg) module"]
pub type ETBCFG = crate::Reg<u32, _ETBCFG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ETBCFG;
#[doc = "`read()` method returns [etbcfg::R](etbcfg::R) reader structure"]
impl crate::Readable for ETBCFG {}
#[doc = "`write(|w| ..)` method takes [etbcfg::W](etbcfg::W) writer structure"]
impl crate::Writable for ETBCFG {}
#[doc = "ETB RAM configuration"]
pub mod etbcfg;
#[doc = "Chip configuration register 6. Controls multiple functions : Ethernet interface, SCT output, I2S0/1 inputs, EMC clock.\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [creg6](creg6) module"]
pub type CREG6 = crate::Reg<u32, _CREG6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CREG6;
#[doc = "`read()` method returns [creg6::R](creg6::R) reader structure"]
impl crate::Readable for CREG6 {}
#[doc = "`write(|w| ..)` method takes [creg6::W](creg6::W) writer structure"]
impl crate::Writable for CREG6 {}
#[doc = "Chip configuration register 6. Controls multiple functions : Ethernet interface, SCT output, I2S0/1 inputs, EMC clock."]
pub mod creg6;
#[doc = "Cortex-M4 TXEV event clear\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [m4txevent](m4txevent) module"]
pub type M4TXEVENT = crate::Reg<u32, _M4TXEVENT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _M4TXEVENT;
#[doc = "`read()` method returns [m4txevent::R](m4txevent::R) reader structure"]
impl crate::Readable for M4TXEVENT {}
#[doc = "`write(|w| ..)` method takes [m4txevent::W](m4txevent::W) writer structure"]
impl crate::Writable for M4TXEVENT {}
#[doc = "Cortex-M4 TXEV event clear"]
pub mod m4txevent;
#[doc = "Part ID\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [chipid](chipid) module"]
pub type CHIPID = crate::Reg<u32, _CHIPID>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CHIPID;
#[doc = "`read()` method returns [chipid::R](chipid::R) reader structure"]
impl crate::Readable for CHIPID {}
#[doc = "Part ID"]
pub mod chipid;
#[doc = "ARM Cortex-M0SUB memory mapping\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [m0submemmap](m0submemmap) module"]
pub type M0SUBMEMMAP = crate::Reg<u32, _M0SUBMEMMAP>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _M0SUBMEMMAP;
#[doc = "`read()` method returns [m0submemmap::R](m0submemmap::R) reader structure"]
impl crate::Readable for M0SUBMEMMAP {}
#[doc = "`write(|w| ..)` method takes [m0submemmap::W](m0submemmap::W) writer structure"]
impl crate::Writable for M0SUBMEMMAP {}
#[doc = "ARM Cortex-M0SUB memory mapping"]
pub mod m0submemmap;
#[doc = "Cortex-M0SUB TXEV event clear\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [m0subtxevent](m0subtxevent) module"]
pub type M0SUBTXEVENT = crate::Reg<u32, _M0SUBTXEVENT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _M0SUBTXEVENT;
#[doc = "`read()` method returns [m0subtxevent::R](m0subtxevent::R) reader structure"]
impl crate::Readable for M0SUBTXEVENT {}
#[doc = "`write(|w| ..)` method takes [m0subtxevent::W](m0subtxevent::W) writer structure"]
impl crate::Writable for M0SUBTXEVENT {}
#[doc = "Cortex-M0SUB TXEV event clear"]
pub mod m0subtxevent;
#[doc = "Cortex-M0APP TXEV event clear\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [m0apptxevent](m0apptxevent) module"]
pub type M0APPTXEVENT = crate::Reg<u32, _M0APPTXEVENT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _M0APPTXEVENT;
#[doc = "`read()` method returns [m0apptxevent::R](m0apptxevent::R) reader structure"]
impl crate::Readable for M0APPTXEVENT {}
#[doc = "`write(|w| ..)` method takes [m0apptxevent::W](m0apptxevent::W) writer structure"]
impl crate::Writable for M0APPTXEVENT {}
#[doc = "Cortex-M0APP TXEV event clear"]
pub mod m0apptxevent;
#[doc = "ARM Cortex-M0APP memory mapping\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [m0appmemmap](m0appmemmap) module"]
pub type M0APPMEMMAP = crate::Reg<u32, _M0APPMEMMAP>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _M0APPMEMMAP;
#[doc = "`read()` method returns [m0appmemmap::R](m0appmemmap::R) reader structure"]
impl crate::Readable for M0APPMEMMAP {}
#[doc = "`write(|w| ..)` method takes [m0appmemmap::W](m0appmemmap::W) writer structure"]
impl crate::Writable for M0APPMEMMAP {}
#[doc = "ARM Cortex-M0APP memory mapping"]
pub mod m0appmemmap;
#[doc = "USB0 frame length adjust register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [usb0fladj](usb0fladj) module"]
pub type USB0FLADJ = crate::Reg<u32, _USB0FLADJ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _USB0FLADJ;
#[doc = "`read()` method returns [usb0fladj::R](usb0fladj::R) reader structure"]
impl crate::Readable for USB0FLADJ {}
#[doc = "`write(|w| ..)` method takes [usb0fladj::W](usb0fladj::W) writer structure"]
impl crate::Writable for USB0FLADJ {}
#[doc = "USB0 frame length adjust register"]
pub mod usb0fladj;
#[doc = "USB1 frame length adjust register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [usb1fladj](usb1fladj) module"]
pub type USB1FLADJ = crate::Reg<u32, _USB1FLADJ>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _USB1FLADJ;
#[doc = "`read()` method returns [usb1fladj::R](usb1fladj::R) reader structure"]
impl crate::Readable for USB1FLADJ {}
#[doc = "`write(|w| ..)` method takes [usb1fladj::W](usb1fladj::W) writer structure"]
impl crate::Writable for USB1FLADJ {}
#[doc = "USB1 frame length adjust register"]
pub mod usb1fladj;
