#[doc = "Reader of register DMAMUX"]
pub type R = crate::R<u32, super::DMAMUX>;
#[doc = "Writer for register DMAMUX"]
pub type W = crate::W<u32, super::DMAMUX>;
#[doc = "Register DMAMUX `reset()`'s with value 0"]
impl crate::ResetValue for super::DMAMUX {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER0_A {
    #[doc = "0: SPIFI"]
    SPIFI,
    #[doc = "1: SCT CTOUT_2"]
    SCT_CTOUT_2,
    #[doc = "2: SGPIO14"]
    SGPIO14,
    #[doc = "3: Timer3 match 1"]
    TIMER3_MATCH_1,
}
impl From<DMAMUXPER0_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER0_A) -> Self {
        match variant {
            DMAMUXPER0_A::SPIFI => 0,
            DMAMUXPER0_A::SCT_CTOUT_2 => 1,
            DMAMUXPER0_A::SGPIO14 => 2,
            DMAMUXPER0_A::TIMER3_MATCH_1 => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER0`"]
pub type DMAMUXPER0_R = crate::R<u8, DMAMUXPER0_A>;
impl DMAMUXPER0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER0_A {
        match self.bits {
            0 => DMAMUXPER0_A::SPIFI,
            1 => DMAMUXPER0_A::SCT_CTOUT_2,
            2 => DMAMUXPER0_A::SGPIO14,
            3 => DMAMUXPER0_A::TIMER3_MATCH_1,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SPIFI`"]
    #[inline(always)]
    pub fn is_spifi(&self) -> bool {
        *self == DMAMUXPER0_A::SPIFI
    }
    #[doc = "Checks if the value of the field is `SCT_CTOUT_2`"]
    #[inline(always)]
    pub fn is_sct_ctout_2(&self) -> bool {
        *self == DMAMUXPER0_A::SCT_CTOUT_2
    }
    #[doc = "Checks if the value of the field is `SGPIO14`"]
    #[inline(always)]
    pub fn is_sgpio14(&self) -> bool {
        *self == DMAMUXPER0_A::SGPIO14
    }
    #[doc = "Checks if the value of the field is `TIMER3_MATCH_1`"]
    #[inline(always)]
    pub fn is_timer3_match_1(&self) -> bool {
        *self == DMAMUXPER0_A::TIMER3_MATCH_1
    }
}
#[doc = "Write proxy for field `DMAMUXPER0`"]
pub struct DMAMUXPER0_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER0_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "SPIFI"]
    #[inline(always)]
    pub fn spifi(self) -> &'a mut W {
        self.variant(DMAMUXPER0_A::SPIFI)
    }
    #[doc = "SCT CTOUT_2"]
    #[inline(always)]
    pub fn sct_ctout_2(self) -> &'a mut W {
        self.variant(DMAMUXPER0_A::SCT_CTOUT_2)
    }
    #[doc = "SGPIO14"]
    #[inline(always)]
    pub fn sgpio14(self) -> &'a mut W {
        self.variant(DMAMUXPER0_A::SGPIO14)
    }
    #[doc = "Timer3 match 1"]
    #[inline(always)]
    pub fn timer3_match_1(self) -> &'a mut W {
        self.variant(DMAMUXPER0_A::TIMER3_MATCH_1)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | ((value as u32) & 0x03);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 1\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER1_A {
    #[doc = "0: Timer0 match 0"]
    TIMER0_MATCH_0,
    #[doc = "1: USART0 transmit"]
    USART0_TRANSMIT,
}
impl From<DMAMUXPER1_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER1_A) -> Self {
        match variant {
            DMAMUXPER1_A::TIMER0_MATCH_0 => 0,
            DMAMUXPER1_A::USART0_TRANSMIT => 1,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER1`"]
pub type DMAMUXPER1_R = crate::R<u8, DMAMUXPER1_A>;
impl DMAMUXPER1_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER1_A {
        match self.bits {
            0 => DMAMUXPER1_A::TIMER0_MATCH_0,
            1 => DMAMUXPER1_A::USART0_TRANSMIT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER0_MATCH_0`"]
    #[inline(always)]
    pub fn is_timer0_match_0(&self) -> bool {
        *self == DMAMUXPER1_A::TIMER0_MATCH_0
    }
    #[doc = "Checks if the value of the field is `USART0_TRANSMIT`"]
    #[inline(always)]
    pub fn is_usart0_transmit(&self) -> bool {
        *self == DMAMUXPER1_A::USART0_TRANSMIT
    }
}
#[doc = "Write proxy for field `DMAMUXPER1`"]
pub struct DMAMUXPER1_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER1_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Timer0 match 0"]
    #[inline(always)]
    pub fn timer0_match_0(self) -> &'a mut W {
        self.variant(DMAMUXPER1_A::TIMER0_MATCH_0)
    }
    #[doc = "USART0 transmit"]
    #[inline(always)]
    pub fn usart0_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER1_A::USART0_TRANSMIT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | (((value as u32) & 0x03) << 2);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 2.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER2_A {
    #[doc = "0: Timer0 match 1"]
    TIMER0_MATCH_1,
    #[doc = "1: USART0 receive"]
    USART0_RECEIVE,
}
impl From<DMAMUXPER2_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER2_A) -> Self {
        match variant {
            DMAMUXPER2_A::TIMER0_MATCH_1 => 0,
            DMAMUXPER2_A::USART0_RECEIVE => 1,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER2`"]
pub type DMAMUXPER2_R = crate::R<u8, DMAMUXPER2_A>;
impl DMAMUXPER2_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER2_A {
        match self.bits {
            0 => DMAMUXPER2_A::TIMER0_MATCH_1,
            1 => DMAMUXPER2_A::USART0_RECEIVE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER0_MATCH_1`"]
    #[inline(always)]
    pub fn is_timer0_match_1(&self) -> bool {
        *self == DMAMUXPER2_A::TIMER0_MATCH_1
    }
    #[doc = "Checks if the value of the field is `USART0_RECEIVE`"]
    #[inline(always)]
    pub fn is_usart0_receive(&self) -> bool {
        *self == DMAMUXPER2_A::USART0_RECEIVE
    }
}
#[doc = "Write proxy for field `DMAMUXPER2`"]
pub struct DMAMUXPER2_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER2_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Timer0 match 1"]
    #[inline(always)]
    pub fn timer0_match_1(self) -> &'a mut W {
        self.variant(DMAMUXPER2_A::TIMER0_MATCH_1)
    }
    #[doc = "USART0 receive"]
    #[inline(always)]
    pub fn usart0_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER2_A::USART0_RECEIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 4)) | (((value as u32) & 0x03) << 4);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 3.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER3_A {
    #[doc = "0: Timer1 match 0"]
    TIMER1_MATCH_0,
    #[doc = "1: UART1 transmit"]
    UART1_TRANSMIT,
    #[doc = "2: I2S1 DMA request 1"]
    I2S1_DMA_REQUEST_1,
    #[doc = "3: SSP1 transmit"]
    SSP1_TRANSMIT,
}
impl From<DMAMUXPER3_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER3_A) -> Self {
        match variant {
            DMAMUXPER3_A::TIMER1_MATCH_0 => 0,
            DMAMUXPER3_A::UART1_TRANSMIT => 1,
            DMAMUXPER3_A::I2S1_DMA_REQUEST_1 => 2,
            DMAMUXPER3_A::SSP1_TRANSMIT => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER3`"]
pub type DMAMUXPER3_R = crate::R<u8, DMAMUXPER3_A>;
impl DMAMUXPER3_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER3_A {
        match self.bits {
            0 => DMAMUXPER3_A::TIMER1_MATCH_0,
            1 => DMAMUXPER3_A::UART1_TRANSMIT,
            2 => DMAMUXPER3_A::I2S1_DMA_REQUEST_1,
            3 => DMAMUXPER3_A::SSP1_TRANSMIT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER1_MATCH_0`"]
    #[inline(always)]
    pub fn is_timer1_match_0(&self) -> bool {
        *self == DMAMUXPER3_A::TIMER1_MATCH_0
    }
    #[doc = "Checks if the value of the field is `UART1_TRANSMIT`"]
    #[inline(always)]
    pub fn is_uart1_transmit(&self) -> bool {
        *self == DMAMUXPER3_A::UART1_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `I2S1_DMA_REQUEST_1`"]
    #[inline(always)]
    pub fn is_i2s1_dma_request_1(&self) -> bool {
        *self == DMAMUXPER3_A::I2S1_DMA_REQUEST_1
    }
    #[doc = "Checks if the value of the field is `SSP1_TRANSMIT`"]
    #[inline(always)]
    pub fn is_ssp1_transmit(&self) -> bool {
        *self == DMAMUXPER3_A::SSP1_TRANSMIT
    }
}
#[doc = "Write proxy for field `DMAMUXPER3`"]
pub struct DMAMUXPER3_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER3_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Timer1 match 0"]
    #[inline(always)]
    pub fn timer1_match_0(self) -> &'a mut W {
        self.variant(DMAMUXPER3_A::TIMER1_MATCH_0)
    }
    #[doc = "UART1 transmit"]
    #[inline(always)]
    pub fn uart1_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER3_A::UART1_TRANSMIT)
    }
    #[doc = "I2S1 DMA request 1"]
    #[inline(always)]
    pub fn i2s1_dma_request_1(self) -> &'a mut W {
        self.variant(DMAMUXPER3_A::I2S1_DMA_REQUEST_1)
    }
    #[doc = "SSP1 transmit"]
    #[inline(always)]
    pub fn ssp1_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER3_A::SSP1_TRANSMIT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 6)) | (((value as u32) & 0x03) << 6);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 4.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER4_A {
    #[doc = "0: Timer1 match 1"]
    TIMER1_MATCH_1,
    #[doc = "1: UART1 receive"]
    UART1_RECEIVE,
    #[doc = "2: I2S1 DMA request 2"]
    I2S1_DMA_REQUEST_2,
    #[doc = "3: SSP1 receive"]
    SSP1_RECEIVE,
}
impl From<DMAMUXPER4_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER4_A) -> Self {
        match variant {
            DMAMUXPER4_A::TIMER1_MATCH_1 => 0,
            DMAMUXPER4_A::UART1_RECEIVE => 1,
            DMAMUXPER4_A::I2S1_DMA_REQUEST_2 => 2,
            DMAMUXPER4_A::SSP1_RECEIVE => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER4`"]
pub type DMAMUXPER4_R = crate::R<u8, DMAMUXPER4_A>;
impl DMAMUXPER4_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER4_A {
        match self.bits {
            0 => DMAMUXPER4_A::TIMER1_MATCH_1,
            1 => DMAMUXPER4_A::UART1_RECEIVE,
            2 => DMAMUXPER4_A::I2S1_DMA_REQUEST_2,
            3 => DMAMUXPER4_A::SSP1_RECEIVE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER1_MATCH_1`"]
    #[inline(always)]
    pub fn is_timer1_match_1(&self) -> bool {
        *self == DMAMUXPER4_A::TIMER1_MATCH_1
    }
    #[doc = "Checks if the value of the field is `UART1_RECEIVE`"]
    #[inline(always)]
    pub fn is_uart1_receive(&self) -> bool {
        *self == DMAMUXPER4_A::UART1_RECEIVE
    }
    #[doc = "Checks if the value of the field is `I2S1_DMA_REQUEST_2`"]
    #[inline(always)]
    pub fn is_i2s1_dma_request_2(&self) -> bool {
        *self == DMAMUXPER4_A::I2S1_DMA_REQUEST_2
    }
    #[doc = "Checks if the value of the field is `SSP1_RECEIVE`"]
    #[inline(always)]
    pub fn is_ssp1_receive(&self) -> bool {
        *self == DMAMUXPER4_A::SSP1_RECEIVE
    }
}
#[doc = "Write proxy for field `DMAMUXPER4`"]
pub struct DMAMUXPER4_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER4_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER4_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Timer1 match 1"]
    #[inline(always)]
    pub fn timer1_match_1(self) -> &'a mut W {
        self.variant(DMAMUXPER4_A::TIMER1_MATCH_1)
    }
    #[doc = "UART1 receive"]
    #[inline(always)]
    pub fn uart1_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER4_A::UART1_RECEIVE)
    }
    #[doc = "I2S1 DMA request 2"]
    #[inline(always)]
    pub fn i2s1_dma_request_2(self) -> &'a mut W {
        self.variant(DMAMUXPER4_A::I2S1_DMA_REQUEST_2)
    }
    #[doc = "SSP1 receive"]
    #[inline(always)]
    pub fn ssp1_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER4_A::SSP1_RECEIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 8)) | (((value as u32) & 0x03) << 8);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 5.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER5_A {
    #[doc = "0: Timer2 match 0"]
    TIMER2_MATCH_0,
    #[doc = "1: USART2 transmit"]
    USART2_TRANSMIT,
    #[doc = "2: SSP1 transmit"]
    SSP1_TRANSMIT,
    #[doc = "3: SGPIO15"]
    SGPIO15,
}
impl From<DMAMUXPER5_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER5_A) -> Self {
        match variant {
            DMAMUXPER5_A::TIMER2_MATCH_0 => 0,
            DMAMUXPER5_A::USART2_TRANSMIT => 1,
            DMAMUXPER5_A::SSP1_TRANSMIT => 2,
            DMAMUXPER5_A::SGPIO15 => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER5`"]
pub type DMAMUXPER5_R = crate::R<u8, DMAMUXPER5_A>;
impl DMAMUXPER5_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER5_A {
        match self.bits {
            0 => DMAMUXPER5_A::TIMER2_MATCH_0,
            1 => DMAMUXPER5_A::USART2_TRANSMIT,
            2 => DMAMUXPER5_A::SSP1_TRANSMIT,
            3 => DMAMUXPER5_A::SGPIO15,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER2_MATCH_0`"]
    #[inline(always)]
    pub fn is_timer2_match_0(&self) -> bool {
        *self == DMAMUXPER5_A::TIMER2_MATCH_0
    }
    #[doc = "Checks if the value of the field is `USART2_TRANSMIT`"]
    #[inline(always)]
    pub fn is_usart2_transmit(&self) -> bool {
        *self == DMAMUXPER5_A::USART2_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `SSP1_TRANSMIT`"]
    #[inline(always)]
    pub fn is_ssp1_transmit(&self) -> bool {
        *self == DMAMUXPER5_A::SSP1_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `SGPIO15`"]
    #[inline(always)]
    pub fn is_sgpio15(&self) -> bool {
        *self == DMAMUXPER5_A::SGPIO15
    }
}
#[doc = "Write proxy for field `DMAMUXPER5`"]
pub struct DMAMUXPER5_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER5_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER5_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Timer2 match 0"]
    #[inline(always)]
    pub fn timer2_match_0(self) -> &'a mut W {
        self.variant(DMAMUXPER5_A::TIMER2_MATCH_0)
    }
    #[doc = "USART2 transmit"]
    #[inline(always)]
    pub fn usart2_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER5_A::USART2_TRANSMIT)
    }
    #[doc = "SSP1 transmit"]
    #[inline(always)]
    pub fn ssp1_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER5_A::SSP1_TRANSMIT)
    }
    #[doc = "SGPIO15"]
    #[inline(always)]
    pub fn sgpio15(self) -> &'a mut W {
        self.variant(DMAMUXPER5_A::SGPIO15)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 10)) | (((value as u32) & 0x03) << 10);
        self.w
    }
}
#[doc = "Selects DMA to peripheral connection for DMA peripheral 6.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER6_A {
    #[doc = "0: Timer2 match 1"]
    TIMER2_MATCH_1,
    #[doc = "1: USART2 receive"]
    USART2_RECEIVE,
    #[doc = "2: SSP1 receive"]
    SSP1_RECEIVE,
    #[doc = "3: SGPIO14"]
    SGPIO14,
}
impl From<DMAMUXPER6_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER6_A) -> Self {
        match variant {
            DMAMUXPER6_A::TIMER2_MATCH_1 => 0,
            DMAMUXPER6_A::USART2_RECEIVE => 1,
            DMAMUXPER6_A::SSP1_RECEIVE => 2,
            DMAMUXPER6_A::SGPIO14 => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER6`"]
pub type DMAMUXPER6_R = crate::R<u8, DMAMUXPER6_A>;
impl DMAMUXPER6_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER6_A {
        match self.bits {
            0 => DMAMUXPER6_A::TIMER2_MATCH_1,
            1 => DMAMUXPER6_A::USART2_RECEIVE,
            2 => DMAMUXPER6_A::SSP1_RECEIVE,
            3 => DMAMUXPER6_A::SGPIO14,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER2_MATCH_1`"]
    #[inline(always)]
    pub fn is_timer2_match_1(&self) -> bool {
        *self == DMAMUXPER6_A::TIMER2_MATCH_1
    }
    #[doc = "Checks if the value of the field is `USART2_RECEIVE`"]
    #[inline(always)]
    pub fn is_usart2_receive(&self) -> bool {
        *self == DMAMUXPER6_A::USART2_RECEIVE
    }
    #[doc = "Checks if the value of the field is `SSP1_RECEIVE`"]
    #[inline(always)]
    pub fn is_ssp1_receive(&self) -> bool {
        *self == DMAMUXPER6_A::SSP1_RECEIVE
    }
    #[doc = "Checks if the value of the field is `SGPIO14`"]
    #[inline(always)]
    pub fn is_sgpio14(&self) -> bool {
        *self == DMAMUXPER6_A::SGPIO14
    }
}
#[doc = "Write proxy for field `DMAMUXPER6`"]
pub struct DMAMUXPER6_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER6_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER6_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Timer2 match 1"]
    #[inline(always)]
    pub fn timer2_match_1(self) -> &'a mut W {
        self.variant(DMAMUXPER6_A::TIMER2_MATCH_1)
    }
    #[doc = "USART2 receive"]
    #[inline(always)]
    pub fn usart2_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER6_A::USART2_RECEIVE)
    }
    #[doc = "SSP1 receive"]
    #[inline(always)]
    pub fn ssp1_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER6_A::SSP1_RECEIVE)
    }
    #[doc = "SGPIO14"]
    #[inline(always)]
    pub fn sgpio14(self) -> &'a mut W {
        self.variant(DMAMUXPER6_A::SGPIO14)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 12)) | (((value as u32) & 0x03) << 12);
        self.w
    }
}
#[doc = "Selects DMA to peripheral connection for DMA peripheral 7.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER7_A {
    #[doc = "0: Timer3 match 0"]
    TIMER3_MATCH_0,
    #[doc = "1: USART3 transmit"]
    USART3_TRANSMIT,
    #[doc = "2: SCT DMA request 0"]
    SCT_DMA_REQUEST_0,
    #[doc = "3: ADCHS write"]
    ADCHS_WRITE,
}
impl From<DMAMUXPER7_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER7_A) -> Self {
        match variant {
            DMAMUXPER7_A::TIMER3_MATCH_0 => 0,
            DMAMUXPER7_A::USART3_TRANSMIT => 1,
            DMAMUXPER7_A::SCT_DMA_REQUEST_0 => 2,
            DMAMUXPER7_A::ADCHS_WRITE => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER7`"]
pub type DMAMUXPER7_R = crate::R<u8, DMAMUXPER7_A>;
impl DMAMUXPER7_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER7_A {
        match self.bits {
            0 => DMAMUXPER7_A::TIMER3_MATCH_0,
            1 => DMAMUXPER7_A::USART3_TRANSMIT,
            2 => DMAMUXPER7_A::SCT_DMA_REQUEST_0,
            3 => DMAMUXPER7_A::ADCHS_WRITE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER3_MATCH_0`"]
    #[inline(always)]
    pub fn is_timer3_match_0(&self) -> bool {
        *self == DMAMUXPER7_A::TIMER3_MATCH_0
    }
    #[doc = "Checks if the value of the field is `USART3_TRANSMIT`"]
    #[inline(always)]
    pub fn is_usart3_transmit(&self) -> bool {
        *self == DMAMUXPER7_A::USART3_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `SCT_DMA_REQUEST_0`"]
    #[inline(always)]
    pub fn is_sct_dma_request_0(&self) -> bool {
        *self == DMAMUXPER7_A::SCT_DMA_REQUEST_0
    }
    #[doc = "Checks if the value of the field is `ADCHS_WRITE`"]
    #[inline(always)]
    pub fn is_adchs_write(&self) -> bool {
        *self == DMAMUXPER7_A::ADCHS_WRITE
    }
}
#[doc = "Write proxy for field `DMAMUXPER7`"]
pub struct DMAMUXPER7_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER7_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER7_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Timer3 match 0"]
    #[inline(always)]
    pub fn timer3_match_0(self) -> &'a mut W {
        self.variant(DMAMUXPER7_A::TIMER3_MATCH_0)
    }
    #[doc = "USART3 transmit"]
    #[inline(always)]
    pub fn usart3_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER7_A::USART3_TRANSMIT)
    }
    #[doc = "SCT DMA request 0"]
    #[inline(always)]
    pub fn sct_dma_request_0(self) -> &'a mut W {
        self.variant(DMAMUXPER7_A::SCT_DMA_REQUEST_0)
    }
    #[doc = "ADCHS write"]
    #[inline(always)]
    pub fn adchs_write(self) -> &'a mut W {
        self.variant(DMAMUXPER7_A::ADCHS_WRITE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 14)) | (((value as u32) & 0x03) << 14);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 8.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER8_A {
    #[doc = "0: Timer3 match 1"]
    TIMER3_MATCH_1,
    #[doc = "1: USART3 receive"]
    USART3_RECEIVE,
    #[doc = "2: SCT DMA request 1"]
    SCT_DMA_REQUEST_1,
    #[doc = "3: ADCHS read"]
    ADCHS_READ,
}
impl From<DMAMUXPER8_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER8_A) -> Self {
        match variant {
            DMAMUXPER8_A::TIMER3_MATCH_1 => 0,
            DMAMUXPER8_A::USART3_RECEIVE => 1,
            DMAMUXPER8_A::SCT_DMA_REQUEST_1 => 2,
            DMAMUXPER8_A::ADCHS_READ => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER8`"]
pub type DMAMUXPER8_R = crate::R<u8, DMAMUXPER8_A>;
impl DMAMUXPER8_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER8_A {
        match self.bits {
            0 => DMAMUXPER8_A::TIMER3_MATCH_1,
            1 => DMAMUXPER8_A::USART3_RECEIVE,
            2 => DMAMUXPER8_A::SCT_DMA_REQUEST_1,
            3 => DMAMUXPER8_A::ADCHS_READ,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `TIMER3_MATCH_1`"]
    #[inline(always)]
    pub fn is_timer3_match_1(&self) -> bool {
        *self == DMAMUXPER8_A::TIMER3_MATCH_1
    }
    #[doc = "Checks if the value of the field is `USART3_RECEIVE`"]
    #[inline(always)]
    pub fn is_usart3_receive(&self) -> bool {
        *self == DMAMUXPER8_A::USART3_RECEIVE
    }
    #[doc = "Checks if the value of the field is `SCT_DMA_REQUEST_1`"]
    #[inline(always)]
    pub fn is_sct_dma_request_1(&self) -> bool {
        *self == DMAMUXPER8_A::SCT_DMA_REQUEST_1
    }
    #[doc = "Checks if the value of the field is `ADCHS_READ`"]
    #[inline(always)]
    pub fn is_adchs_read(&self) -> bool {
        *self == DMAMUXPER8_A::ADCHS_READ
    }
}
#[doc = "Write proxy for field `DMAMUXPER8`"]
pub struct DMAMUXPER8_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER8_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER8_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Timer3 match 1"]
    #[inline(always)]
    pub fn timer3_match_1(self) -> &'a mut W {
        self.variant(DMAMUXPER8_A::TIMER3_MATCH_1)
    }
    #[doc = "USART3 receive"]
    #[inline(always)]
    pub fn usart3_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER8_A::USART3_RECEIVE)
    }
    #[doc = "SCT DMA request 1"]
    #[inline(always)]
    pub fn sct_dma_request_1(self) -> &'a mut W {
        self.variant(DMAMUXPER8_A::SCT_DMA_REQUEST_1)
    }
    #[doc = "ADCHS read"]
    #[inline(always)]
    pub fn adchs_read(self) -> &'a mut W {
        self.variant(DMAMUXPER8_A::ADCHS_READ)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 16)) | (((value as u32) & 0x03) << 16);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 9.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER9_A {
    #[doc = "0: SSP0 receive"]
    SSP0_RECEIVE,
    #[doc = "1: I2S0 DMA request 1"]
    I2S0_DMA_REQUEST_1,
    #[doc = "2: SCT DMA request 1"]
    SCT_DMA_REQUEST_1,
}
impl From<DMAMUXPER9_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER9_A) -> Self {
        match variant {
            DMAMUXPER9_A::SSP0_RECEIVE => 0,
            DMAMUXPER9_A::I2S0_DMA_REQUEST_1 => 1,
            DMAMUXPER9_A::SCT_DMA_REQUEST_1 => 2,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER9`"]
pub type DMAMUXPER9_R = crate::R<u8, DMAMUXPER9_A>;
impl DMAMUXPER9_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER9_A {
        match self.bits {
            0 => DMAMUXPER9_A::SSP0_RECEIVE,
            1 => DMAMUXPER9_A::I2S0_DMA_REQUEST_1,
            2 => DMAMUXPER9_A::SCT_DMA_REQUEST_1,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SSP0_RECEIVE`"]
    #[inline(always)]
    pub fn is_ssp0_receive(&self) -> bool {
        *self == DMAMUXPER9_A::SSP0_RECEIVE
    }
    #[doc = "Checks if the value of the field is `I2S0_DMA_REQUEST_1`"]
    #[inline(always)]
    pub fn is_i2s0_dma_request_1(&self) -> bool {
        *self == DMAMUXPER9_A::I2S0_DMA_REQUEST_1
    }
    #[doc = "Checks if the value of the field is `SCT_DMA_REQUEST_1`"]
    #[inline(always)]
    pub fn is_sct_dma_request_1(&self) -> bool {
        *self == DMAMUXPER9_A::SCT_DMA_REQUEST_1
    }
}
#[doc = "Write proxy for field `DMAMUXPER9`"]
pub struct DMAMUXPER9_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER9_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER9_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "SSP0 receive"]
    #[inline(always)]
    pub fn ssp0_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER9_A::SSP0_RECEIVE)
    }
    #[doc = "I2S0 DMA request 1"]
    #[inline(always)]
    pub fn i2s0_dma_request_1(self) -> &'a mut W {
        self.variant(DMAMUXPER9_A::I2S0_DMA_REQUEST_1)
    }
    #[doc = "SCT DMA request 1"]
    #[inline(always)]
    pub fn sct_dma_request_1(self) -> &'a mut W {
        self.variant(DMAMUXPER9_A::SCT_DMA_REQUEST_1)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 18)) | (((value as u32) & 0x03) << 18);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 10.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER10_A {
    #[doc = "0: SSP0 transmit"]
    SSP0_TRANSMIT,
    #[doc = "1: I2S0 DMA request 2"]
    I2S0_DMA_REQUEST_2,
    #[doc = "2: SCT DMA request 0"]
    SCT_DMA_REQUEST_0,
}
impl From<DMAMUXPER10_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER10_A) -> Self {
        match variant {
            DMAMUXPER10_A::SSP0_TRANSMIT => 0,
            DMAMUXPER10_A::I2S0_DMA_REQUEST_2 => 1,
            DMAMUXPER10_A::SCT_DMA_REQUEST_0 => 2,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER10`"]
pub type DMAMUXPER10_R = crate::R<u8, DMAMUXPER10_A>;
impl DMAMUXPER10_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER10_A {
        match self.bits {
            0 => DMAMUXPER10_A::SSP0_TRANSMIT,
            1 => DMAMUXPER10_A::I2S0_DMA_REQUEST_2,
            2 => DMAMUXPER10_A::SCT_DMA_REQUEST_0,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SSP0_TRANSMIT`"]
    #[inline(always)]
    pub fn is_ssp0_transmit(&self) -> bool {
        *self == DMAMUXPER10_A::SSP0_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `I2S0_DMA_REQUEST_2`"]
    #[inline(always)]
    pub fn is_i2s0_dma_request_2(&self) -> bool {
        *self == DMAMUXPER10_A::I2S0_DMA_REQUEST_2
    }
    #[doc = "Checks if the value of the field is `SCT_DMA_REQUEST_0`"]
    #[inline(always)]
    pub fn is_sct_dma_request_0(&self) -> bool {
        *self == DMAMUXPER10_A::SCT_DMA_REQUEST_0
    }
}
#[doc = "Write proxy for field `DMAMUXPER10`"]
pub struct DMAMUXPER10_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER10_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER10_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "SSP0 transmit"]
    #[inline(always)]
    pub fn ssp0_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER10_A::SSP0_TRANSMIT)
    }
    #[doc = "I2S0 DMA request 2"]
    #[inline(always)]
    pub fn i2s0_dma_request_2(self) -> &'a mut W {
        self.variant(DMAMUXPER10_A::I2S0_DMA_REQUEST_2)
    }
    #[doc = "SCT DMA request 0"]
    #[inline(always)]
    pub fn sct_dma_request_0(self) -> &'a mut W {
        self.variant(DMAMUXPER10_A::SCT_DMA_REQUEST_0)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 20)) | (((value as u32) & 0x03) << 20);
        self.w
    }
}
#[doc = "Selects DMA to peripheral connection for DMA peripheral 11.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER11_A {
    #[doc = "0: SSP1 receive"]
    SSP1_RECEIVE,
    #[doc = "1: SGPIO14"]
    SGPIO14,
    #[doc = "2: USART0 transmit"]
    USART0_TRANSMIT,
}
impl From<DMAMUXPER11_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER11_A) -> Self {
        match variant {
            DMAMUXPER11_A::SSP1_RECEIVE => 0,
            DMAMUXPER11_A::SGPIO14 => 1,
            DMAMUXPER11_A::USART0_TRANSMIT => 2,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER11`"]
pub type DMAMUXPER11_R = crate::R<u8, DMAMUXPER11_A>;
impl DMAMUXPER11_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER11_A {
        match self.bits {
            0 => DMAMUXPER11_A::SSP1_RECEIVE,
            1 => DMAMUXPER11_A::SGPIO14,
            2 => DMAMUXPER11_A::USART0_TRANSMIT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SSP1_RECEIVE`"]
    #[inline(always)]
    pub fn is_ssp1_receive(&self) -> bool {
        *self == DMAMUXPER11_A::SSP1_RECEIVE
    }
    #[doc = "Checks if the value of the field is `SGPIO14`"]
    #[inline(always)]
    pub fn is_sgpio14(&self) -> bool {
        *self == DMAMUXPER11_A::SGPIO14
    }
    #[doc = "Checks if the value of the field is `USART0_TRANSMIT`"]
    #[inline(always)]
    pub fn is_usart0_transmit(&self) -> bool {
        *self == DMAMUXPER11_A::USART0_TRANSMIT
    }
}
#[doc = "Write proxy for field `DMAMUXPER11`"]
pub struct DMAMUXPER11_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER11_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER11_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "SSP1 receive"]
    #[inline(always)]
    pub fn ssp1_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER11_A::SSP1_RECEIVE)
    }
    #[doc = "SGPIO14"]
    #[inline(always)]
    pub fn sgpio14(self) -> &'a mut W {
        self.variant(DMAMUXPER11_A::SGPIO14)
    }
    #[doc = "USART0 transmit"]
    #[inline(always)]
    pub fn usart0_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER11_A::USART0_TRANSMIT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 22)) | (((value as u32) & 0x03) << 22);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 12.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER12_A {
    #[doc = "0: SSP1 transmit"]
    SSP1_TRANSMIT,
    #[doc = "1: SGPIO15"]
    SGPIO15,
    #[doc = "2: USART0 receive"]
    USART0_RECEIVE,
}
impl From<DMAMUXPER12_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER12_A) -> Self {
        match variant {
            DMAMUXPER12_A::SSP1_TRANSMIT => 0,
            DMAMUXPER12_A::SGPIO15 => 1,
            DMAMUXPER12_A::USART0_RECEIVE => 2,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER12`"]
pub type DMAMUXPER12_R = crate::R<u8, DMAMUXPER12_A>;
impl DMAMUXPER12_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER12_A {
        match self.bits {
            0 => DMAMUXPER12_A::SSP1_TRANSMIT,
            1 => DMAMUXPER12_A::SGPIO15,
            2 => DMAMUXPER12_A::USART0_RECEIVE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SSP1_TRANSMIT`"]
    #[inline(always)]
    pub fn is_ssp1_transmit(&self) -> bool {
        *self == DMAMUXPER12_A::SSP1_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `SGPIO15`"]
    #[inline(always)]
    pub fn is_sgpio15(&self) -> bool {
        *self == DMAMUXPER12_A::SGPIO15
    }
    #[doc = "Checks if the value of the field is `USART0_RECEIVE`"]
    #[inline(always)]
    pub fn is_usart0_receive(&self) -> bool {
        *self == DMAMUXPER12_A::USART0_RECEIVE
    }
}
#[doc = "Write proxy for field `DMAMUXPER12`"]
pub struct DMAMUXPER12_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER12_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER12_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "SSP1 transmit"]
    #[inline(always)]
    pub fn ssp1_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER12_A::SSP1_TRANSMIT)
    }
    #[doc = "SGPIO15"]
    #[inline(always)]
    pub fn sgpio15(self) -> &'a mut W {
        self.variant(DMAMUXPER12_A::SGPIO15)
    }
    #[doc = "USART0 receive"]
    #[inline(always)]
    pub fn usart0_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER12_A::USART0_RECEIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 24)) | (((value as u32) & 0x03) << 24);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 13.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER13_A {
    #[doc = "0: ADC0"]
    ADC0,
    #[doc = "2: SSP1 receive"]
    SSP1_RECEIVE,
    #[doc = "3: USART3 receive"]
    USART3_RECEIVE,
}
impl From<DMAMUXPER13_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER13_A) -> Self {
        match variant {
            DMAMUXPER13_A::ADC0 => 0,
            DMAMUXPER13_A::SSP1_RECEIVE => 2,
            DMAMUXPER13_A::USART3_RECEIVE => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER13`"]
pub type DMAMUXPER13_R = crate::R<u8, DMAMUXPER13_A>;
impl DMAMUXPER13_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER13_A {
        match self.bits {
            0 => DMAMUXPER13_A::ADC0,
            2 => DMAMUXPER13_A::SSP1_RECEIVE,
            3 => DMAMUXPER13_A::USART3_RECEIVE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `ADC0`"]
    #[inline(always)]
    pub fn is_adc0(&self) -> bool {
        *self == DMAMUXPER13_A::ADC0
    }
    #[doc = "Checks if the value of the field is `SSP1_RECEIVE`"]
    #[inline(always)]
    pub fn is_ssp1_receive(&self) -> bool {
        *self == DMAMUXPER13_A::SSP1_RECEIVE
    }
    #[doc = "Checks if the value of the field is `USART3_RECEIVE`"]
    #[inline(always)]
    pub fn is_usart3_receive(&self) -> bool {
        *self == DMAMUXPER13_A::USART3_RECEIVE
    }
}
#[doc = "Write proxy for field `DMAMUXPER13`"]
pub struct DMAMUXPER13_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER13_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER13_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "ADC0"]
    #[inline(always)]
    pub fn adc0(self) -> &'a mut W {
        self.variant(DMAMUXPER13_A::ADC0)
    }
    #[doc = "SSP1 receive"]
    #[inline(always)]
    pub fn ssp1_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER13_A::SSP1_RECEIVE)
    }
    #[doc = "USART3 receive"]
    #[inline(always)]
    pub fn usart3_receive(self) -> &'a mut W {
        self.variant(DMAMUXPER13_A::USART3_RECEIVE)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 26)) | (((value as u32) & 0x03) << 26);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 14.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER14_A {
    #[doc = "0: ADC1"]
    ADC1,
    #[doc = "2: SSP1 transmit"]
    SSP1_TRANSMIT,
    #[doc = "3: USART3 transmit"]
    USART3_TRANSMIT,
}
impl From<DMAMUXPER14_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER14_A) -> Self {
        match variant {
            DMAMUXPER14_A::ADC1 => 0,
            DMAMUXPER14_A::SSP1_TRANSMIT => 2,
            DMAMUXPER14_A::USART3_TRANSMIT => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER14`"]
pub type DMAMUXPER14_R = crate::R<u8, DMAMUXPER14_A>;
impl DMAMUXPER14_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER14_A {
        match self.bits {
            0 => DMAMUXPER14_A::ADC1,
            2 => DMAMUXPER14_A::SSP1_TRANSMIT,
            3 => DMAMUXPER14_A::USART3_TRANSMIT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `ADC1`"]
    #[inline(always)]
    pub fn is_adc1(&self) -> bool {
        *self == DMAMUXPER14_A::ADC1
    }
    #[doc = "Checks if the value of the field is `SSP1_TRANSMIT`"]
    #[inline(always)]
    pub fn is_ssp1_transmit(&self) -> bool {
        *self == DMAMUXPER14_A::SSP1_TRANSMIT
    }
    #[doc = "Checks if the value of the field is `USART3_TRANSMIT`"]
    #[inline(always)]
    pub fn is_usart3_transmit(&self) -> bool {
        *self == DMAMUXPER14_A::USART3_TRANSMIT
    }
}
#[doc = "Write proxy for field `DMAMUXPER14`"]
pub struct DMAMUXPER14_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER14_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER14_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "ADC1"]
    #[inline(always)]
    pub fn adc1(self) -> &'a mut W {
        self.variant(DMAMUXPER14_A::ADC1)
    }
    #[doc = "SSP1 transmit"]
    #[inline(always)]
    pub fn ssp1_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER14_A::SSP1_TRANSMIT)
    }
    #[doc = "USART3 transmit"]
    #[inline(always)]
    pub fn usart3_transmit(self) -> &'a mut W {
        self.variant(DMAMUXPER14_A::USART3_TRANSMIT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 28)) | (((value as u32) & 0x03) << 28);
        self.w
    }
}
#[doc = "Select DMA to peripheral connection for DMA peripheral 15.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMAMUXPER15_A {
    #[doc = "0: DAC"]
    DAC,
    #[doc = "1: SCT CTOUT_3"]
    SCT_CTOUT_3,
    #[doc = "2: SGPIO15"]
    SGPIO15,
    #[doc = "3: Timer3 match 0"]
    TIMER3_MATCH_0,
}
impl From<DMAMUXPER15_A> for u8 {
    #[inline(always)]
    fn from(variant: DMAMUXPER15_A) -> Self {
        match variant {
            DMAMUXPER15_A::DAC => 0,
            DMAMUXPER15_A::SCT_CTOUT_3 => 1,
            DMAMUXPER15_A::SGPIO15 => 2,
            DMAMUXPER15_A::TIMER3_MATCH_0 => 3,
        }
    }
}
#[doc = "Reader of field `DMAMUXPER15`"]
pub type DMAMUXPER15_R = crate::R<u8, DMAMUXPER15_A>;
impl DMAMUXPER15_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMAMUXPER15_A {
        match self.bits {
            0 => DMAMUXPER15_A::DAC,
            1 => DMAMUXPER15_A::SCT_CTOUT_3,
            2 => DMAMUXPER15_A::SGPIO15,
            3 => DMAMUXPER15_A::TIMER3_MATCH_0,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DAC`"]
    #[inline(always)]
    pub fn is_dac(&self) -> bool {
        *self == DMAMUXPER15_A::DAC
    }
    #[doc = "Checks if the value of the field is `SCT_CTOUT_3`"]
    #[inline(always)]
    pub fn is_sct_ctout_3(&self) -> bool {
        *self == DMAMUXPER15_A::SCT_CTOUT_3
    }
    #[doc = "Checks if the value of the field is `SGPIO15`"]
    #[inline(always)]
    pub fn is_sgpio15(&self) -> bool {
        *self == DMAMUXPER15_A::SGPIO15
    }
    #[doc = "Checks if the value of the field is `TIMER3_MATCH_0`"]
    #[inline(always)]
    pub fn is_timer3_match_0(&self) -> bool {
        *self == DMAMUXPER15_A::TIMER3_MATCH_0
    }
}
#[doc = "Write proxy for field `DMAMUXPER15`"]
pub struct DMAMUXPER15_W<'a> {
    w: &'a mut W,
}
impl<'a> DMAMUXPER15_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMAMUXPER15_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "DAC"]
    #[inline(always)]
    pub fn dac(self) -> &'a mut W {
        self.variant(DMAMUXPER15_A::DAC)
    }
    #[doc = "SCT CTOUT_3"]
    #[inline(always)]
    pub fn sct_ctout_3(self) -> &'a mut W {
        self.variant(DMAMUXPER15_A::SCT_CTOUT_3)
    }
    #[doc = "SGPIO15"]
    #[inline(always)]
    pub fn sgpio15(self) -> &'a mut W {
        self.variant(DMAMUXPER15_A::SGPIO15)
    }
    #[doc = "Timer3 match 0"]
    #[inline(always)]
    pub fn timer3_match_0(self) -> &'a mut W {
        self.variant(DMAMUXPER15_A::TIMER3_MATCH_0)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 30)) | (((value as u32) & 0x03) << 30);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - Select DMA to peripheral connection for DMA peripheral 0."]
    #[inline(always)]
    pub fn dmamuxper0(&self) -> DMAMUXPER0_R {
        DMAMUXPER0_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bits 2:3 - Select DMA to peripheral connection for DMA peripheral 1"]
    #[inline(always)]
    pub fn dmamuxper1(&self) -> DMAMUXPER1_R {
        DMAMUXPER1_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bits 4:5 - Select DMA to peripheral connection for DMA peripheral 2."]
    #[inline(always)]
    pub fn dmamuxper2(&self) -> DMAMUXPER2_R {
        DMAMUXPER2_R::new(((self.bits >> 4) & 0x03) as u8)
    }
    #[doc = "Bits 6:7 - Select DMA to peripheral connection for DMA peripheral 3."]
    #[inline(always)]
    pub fn dmamuxper3(&self) -> DMAMUXPER3_R {
        DMAMUXPER3_R::new(((self.bits >> 6) & 0x03) as u8)
    }
    #[doc = "Bits 8:9 - Select DMA to peripheral connection for DMA peripheral 4."]
    #[inline(always)]
    pub fn dmamuxper4(&self) -> DMAMUXPER4_R {
        DMAMUXPER4_R::new(((self.bits >> 8) & 0x03) as u8)
    }
    #[doc = "Bits 10:11 - Select DMA to peripheral connection for DMA peripheral 5."]
    #[inline(always)]
    pub fn dmamuxper5(&self) -> DMAMUXPER5_R {
        DMAMUXPER5_R::new(((self.bits >> 10) & 0x03) as u8)
    }
    #[doc = "Bits 12:13 - Selects DMA to peripheral connection for DMA peripheral 6."]
    #[inline(always)]
    pub fn dmamuxper6(&self) -> DMAMUXPER6_R {
        DMAMUXPER6_R::new(((self.bits >> 12) & 0x03) as u8)
    }
    #[doc = "Bits 14:15 - Selects DMA to peripheral connection for DMA peripheral 7."]
    #[inline(always)]
    pub fn dmamuxper7(&self) -> DMAMUXPER7_R {
        DMAMUXPER7_R::new(((self.bits >> 14) & 0x03) as u8)
    }
    #[doc = "Bits 16:17 - Select DMA to peripheral connection for DMA peripheral 8."]
    #[inline(always)]
    pub fn dmamuxper8(&self) -> DMAMUXPER8_R {
        DMAMUXPER8_R::new(((self.bits >> 16) & 0x03) as u8)
    }
    #[doc = "Bits 18:19 - Select DMA to peripheral connection for DMA peripheral 9."]
    #[inline(always)]
    pub fn dmamuxper9(&self) -> DMAMUXPER9_R {
        DMAMUXPER9_R::new(((self.bits >> 18) & 0x03) as u8)
    }
    #[doc = "Bits 20:21 - Select DMA to peripheral connection for DMA peripheral 10."]
    #[inline(always)]
    pub fn dmamuxper10(&self) -> DMAMUXPER10_R {
        DMAMUXPER10_R::new(((self.bits >> 20) & 0x03) as u8)
    }
    #[doc = "Bits 22:23 - Selects DMA to peripheral connection for DMA peripheral 11."]
    #[inline(always)]
    pub fn dmamuxper11(&self) -> DMAMUXPER11_R {
        DMAMUXPER11_R::new(((self.bits >> 22) & 0x03) as u8)
    }
    #[doc = "Bits 24:25 - Select DMA to peripheral connection for DMA peripheral 12."]
    #[inline(always)]
    pub fn dmamuxper12(&self) -> DMAMUXPER12_R {
        DMAMUXPER12_R::new(((self.bits >> 24) & 0x03) as u8)
    }
    #[doc = "Bits 26:27 - Select DMA to peripheral connection for DMA peripheral 13."]
    #[inline(always)]
    pub fn dmamuxper13(&self) -> DMAMUXPER13_R {
        DMAMUXPER13_R::new(((self.bits >> 26) & 0x03) as u8)
    }
    #[doc = "Bits 28:29 - Select DMA to peripheral connection for DMA peripheral 14."]
    #[inline(always)]
    pub fn dmamuxper14(&self) -> DMAMUXPER14_R {
        DMAMUXPER14_R::new(((self.bits >> 28) & 0x03) as u8)
    }
    #[doc = "Bits 30:31 - Select DMA to peripheral connection for DMA peripheral 15."]
    #[inline(always)]
    pub fn dmamuxper15(&self) -> DMAMUXPER15_R {
        DMAMUXPER15_R::new(((self.bits >> 30) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bits 0:1 - Select DMA to peripheral connection for DMA peripheral 0."]
    #[inline(always)]
    pub fn dmamuxper0(&mut self) -> DMAMUXPER0_W {
        DMAMUXPER0_W { w: self }
    }
    #[doc = "Bits 2:3 - Select DMA to peripheral connection for DMA peripheral 1"]
    #[inline(always)]
    pub fn dmamuxper1(&mut self) -> DMAMUXPER1_W {
        DMAMUXPER1_W { w: self }
    }
    #[doc = "Bits 4:5 - Select DMA to peripheral connection for DMA peripheral 2."]
    #[inline(always)]
    pub fn dmamuxper2(&mut self) -> DMAMUXPER2_W {
        DMAMUXPER2_W { w: self }
    }
    #[doc = "Bits 6:7 - Select DMA to peripheral connection for DMA peripheral 3."]
    #[inline(always)]
    pub fn dmamuxper3(&mut self) -> DMAMUXPER3_W {
        DMAMUXPER3_W { w: self }
    }
    #[doc = "Bits 8:9 - Select DMA to peripheral connection for DMA peripheral 4."]
    #[inline(always)]
    pub fn dmamuxper4(&mut self) -> DMAMUXPER4_W {
        DMAMUXPER4_W { w: self }
    }
    #[doc = "Bits 10:11 - Select DMA to peripheral connection for DMA peripheral 5."]
    #[inline(always)]
    pub fn dmamuxper5(&mut self) -> DMAMUXPER5_W {
        DMAMUXPER5_W { w: self }
    }
    #[doc = "Bits 12:13 - Selects DMA to peripheral connection for DMA peripheral 6."]
    #[inline(always)]
    pub fn dmamuxper6(&mut self) -> DMAMUXPER6_W {
        DMAMUXPER6_W { w: self }
    }
    #[doc = "Bits 14:15 - Selects DMA to peripheral connection for DMA peripheral 7."]
    #[inline(always)]
    pub fn dmamuxper7(&mut self) -> DMAMUXPER7_W {
        DMAMUXPER7_W { w: self }
    }
    #[doc = "Bits 16:17 - Select DMA to peripheral connection for DMA peripheral 8."]
    #[inline(always)]
    pub fn dmamuxper8(&mut self) -> DMAMUXPER8_W {
        DMAMUXPER8_W { w: self }
    }
    #[doc = "Bits 18:19 - Select DMA to peripheral connection for DMA peripheral 9."]
    #[inline(always)]
    pub fn dmamuxper9(&mut self) -> DMAMUXPER9_W {
        DMAMUXPER9_W { w: self }
    }
    #[doc = "Bits 20:21 - Select DMA to peripheral connection for DMA peripheral 10."]
    #[inline(always)]
    pub fn dmamuxper10(&mut self) -> DMAMUXPER10_W {
        DMAMUXPER10_W { w: self }
    }
    #[doc = "Bits 22:23 - Selects DMA to peripheral connection for DMA peripheral 11."]
    #[inline(always)]
    pub fn dmamuxper11(&mut self) -> DMAMUXPER11_W {
        DMAMUXPER11_W { w: self }
    }
    #[doc = "Bits 24:25 - Select DMA to peripheral connection for DMA peripheral 12."]
    #[inline(always)]
    pub fn dmamuxper12(&mut self) -> DMAMUXPER12_W {
        DMAMUXPER12_W { w: self }
    }
    #[doc = "Bits 26:27 - Select DMA to peripheral connection for DMA peripheral 13."]
    #[inline(always)]
    pub fn dmamuxper13(&mut self) -> DMAMUXPER13_W {
        DMAMUXPER13_W { w: self }
    }
    #[doc = "Bits 28:29 - Select DMA to peripheral connection for DMA peripheral 14."]
    #[inline(always)]
    pub fn dmamuxper14(&mut self) -> DMAMUXPER14_W {
        DMAMUXPER14_W { w: self }
    }
    #[doc = "Bits 30:31 - Select DMA to peripheral connection for DMA peripheral 15."]
    #[inline(always)]
    pub fn dmamuxper15(&mut self) -> DMAMUXPER15_W {
        DMAMUXPER15_W { w: self }
    }
}
