#[doc = "Reader of register ETBCFG"]
pub type R = crate::R<u32, super::ETBCFG>;
#[doc = "Writer for register ETBCFG"]
pub type W = crate::W<u32, super::ETBCFG>;
#[doc = "Register ETBCFG `reset()`'s with value 0x01"]
impl crate::ResetValue for super::ETBCFG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x01
    }
}
#[doc = "Select SRAM interface\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ETB_A {
    #[doc = "0: ETB accesses SRAM at address 0x2000 C000."]
    ETB_ACCESSES_SRAM_AT_ADDR,
    #[doc = "1: AHB accesses SRAM at address 0x2000 C000."]
    AHB_ACCESSES_SRAM_AT_ADDR,
}
impl From<ETB_A> for bool {
    #[inline(always)]
    fn from(variant: ETB_A) -> Self {
        match variant {
            ETB_A::ETB_ACCESSES_SRAM_AT_ADDR => false,
            ETB_A::AHB_ACCESSES_SRAM_AT_ADDR => true,
        }
    }
}
#[doc = "Reader of field `ETB`"]
pub type ETB_R = crate::R<bool, ETB_A>;
impl ETB_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ETB_A {
        match self.bits {
            false => ETB_A::ETB_ACCESSES_SRAM_AT_ADDR,
            true => ETB_A::AHB_ACCESSES_SRAM_AT_ADDR,
        }
    }
    #[doc = "Checks if the value of the field is `ETB_ACCESSES_SRAM_AT_ADDR`"]
    #[inline(always)]
    pub fn is_etb_accesses_sram_at_addr(&self) -> bool {
        *self == ETB_A::ETB_ACCESSES_SRAM_AT_ADDR
    }
    #[doc = "Checks if the value of the field is `AHB_ACCESSES_SRAM_AT_ADDR`"]
    #[inline(always)]
    pub fn is_ahb_accesses_sram_at_addr(&self) -> bool {
        *self == ETB_A::AHB_ACCESSES_SRAM_AT_ADDR
    }
}
#[doc = "Write proxy for field `ETB`"]
pub struct ETB_W<'a> {
    w: &'a mut W,
}
impl<'a> ETB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ETB_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "ETB accesses SRAM at address 0x2000 C000."]
    #[inline(always)]
    pub fn etb_accesses_sram_at_addr(self) -> &'a mut W {
        self.variant(ETB_A::ETB_ACCESSES_SRAM_AT_ADDR)
    }
    #[doc = "AHB accesses SRAM at address 0x2000 C000."]
    #[inline(always)]
    pub fn ahb_accesses_sram_at_addr(self) -> &'a mut W {
        self.variant(ETB_A::AHB_ACCESSES_SRAM_AT_ADDR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Select SRAM interface"]
    #[inline(always)]
    pub fn etb(&self) -> ETB_R {
        ETB_R::new((self.bits & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Select SRAM interface"]
    #[inline(always)]
    pub fn etb(&mut self) -> ETB_W {
        ETB_W { w: self }
    }
}
