#[doc = "Reader of register FLASHCFGA"]
pub type R = crate::R<u32, super::FLASHCFGA>;
#[doc = "Writer for register FLASHCFGA"]
pub type W = crate::W<u32, super::FLASHCFGA>;
#[doc = "Register FLASHCFGA `reset()`'s with value 0x8000_f03a"]
impl crate::ResetValue for super::FLASHCFGA {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x8000_f03a
    }
}
#[doc = "Flash access time. The value of this field plus 1 gives the number of BASE_M4_CLK clocks used for a flash access. Warning: Improper setting of this value may result in incorrect operation of the device. All other values are allowed but may not be optimal for the supported clock frequencies.\n\nValue on reset: 15"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FLASHTIM_A {
    #[doc = "0: 1 BASE_M4_CLK clock. Use for BASE_M4_CLK up to 21 MHz."]
    _1_BASE_M4_CLK_CLOCK,
    #[doc = "1: 2 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 43 MHz."]
    _2_BASE_M4_CLK_CLOCKS,
    #[doc = "2: 3 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 64 MHz."]
    _3_BASE_M4_CLK_CLOCKS,
    #[doc = "3: 4 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 86 MHz."]
    _4_BASE_M4_CLK_CLOCKS,
    #[doc = "4: 5 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 107 MHz."]
    _5_BASE_M4_CLK_CLOCKS,
    #[doc = "5: 6 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 129 MHz."]
    _6_BASE_M4_CLK_CLOCKS,
    #[doc = "6: 7 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 150 MHz."]
    _7_BASE_M4_CLK_CLOCKS,
    #[doc = "7: 8 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 172 MHz."]
    _8_BASE_M4_CLK_CLOCKS,
    #[doc = "8: 9 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 193 MHz."]
    _9_BASE_M4_CLK_CLOCKS,
    #[doc = "9: 10 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 204 MHz. Safe setting for all allowed conditions."]
    _10_BASE_M4_CLK_CLOCKS,
}
impl From<FLASHTIM_A> for u8 {
    #[inline(always)]
    fn from(variant: FLASHTIM_A) -> Self {
        match variant {
            FLASHTIM_A::_1_BASE_M4_CLK_CLOCK => 0,
            FLASHTIM_A::_2_BASE_M4_CLK_CLOCKS => 1,
            FLASHTIM_A::_3_BASE_M4_CLK_CLOCKS => 2,
            FLASHTIM_A::_4_BASE_M4_CLK_CLOCKS => 3,
            FLASHTIM_A::_5_BASE_M4_CLK_CLOCKS => 4,
            FLASHTIM_A::_6_BASE_M4_CLK_CLOCKS => 5,
            FLASHTIM_A::_7_BASE_M4_CLK_CLOCKS => 6,
            FLASHTIM_A::_8_BASE_M4_CLK_CLOCKS => 7,
            FLASHTIM_A::_9_BASE_M4_CLK_CLOCKS => 8,
            FLASHTIM_A::_10_BASE_M4_CLK_CLOCKS => 9,
        }
    }
}
#[doc = "Reader of field `FLASHTIM`"]
pub type FLASHTIM_R = crate::R<u8, FLASHTIM_A>;
impl FLASHTIM_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, FLASHTIM_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(FLASHTIM_A::_1_BASE_M4_CLK_CLOCK),
            1 => Val(FLASHTIM_A::_2_BASE_M4_CLK_CLOCKS),
            2 => Val(FLASHTIM_A::_3_BASE_M4_CLK_CLOCKS),
            3 => Val(FLASHTIM_A::_4_BASE_M4_CLK_CLOCKS),
            4 => Val(FLASHTIM_A::_5_BASE_M4_CLK_CLOCKS),
            5 => Val(FLASHTIM_A::_6_BASE_M4_CLK_CLOCKS),
            6 => Val(FLASHTIM_A::_7_BASE_M4_CLK_CLOCKS),
            7 => Val(FLASHTIM_A::_8_BASE_M4_CLK_CLOCKS),
            8 => Val(FLASHTIM_A::_9_BASE_M4_CLK_CLOCKS),
            9 => Val(FLASHTIM_A::_10_BASE_M4_CLK_CLOCKS),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `_1_BASE_M4_CLK_CLOCK`"]
    #[inline(always)]
    pub fn is_1_base_m4_clk_clock(&self) -> bool {
        *self == FLASHTIM_A::_1_BASE_M4_CLK_CLOCK
    }
    #[doc = "Checks if the value of the field is `_2_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_2_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_2_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_3_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_3_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_3_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_4_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_4_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_4_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_5_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_5_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_5_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_6_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_6_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_6_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_7_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_7_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_7_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_8_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_8_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_8_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_9_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_9_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_9_BASE_M4_CLK_CLOCKS
    }
    #[doc = "Checks if the value of the field is `_10_BASE_M4_CLK_CLOCKS`"]
    #[inline(always)]
    pub fn is_10_base_m4_clk_clocks(&self) -> bool {
        *self == FLASHTIM_A::_10_BASE_M4_CLK_CLOCKS
    }
}
#[doc = "Write proxy for field `FLASHTIM`"]
pub struct FLASHTIM_W<'a> {
    w: &'a mut W,
}
impl<'a> FLASHTIM_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FLASHTIM_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "1 BASE_M4_CLK clock. Use for BASE_M4_CLK up to 21 MHz."]
    #[inline(always)]
    pub fn _1_base_m4_clk_clock(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_1_BASE_M4_CLK_CLOCK)
    }
    #[doc = "2 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 43 MHz."]
    #[inline(always)]
    pub fn _2_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_2_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "3 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 64 MHz."]
    #[inline(always)]
    pub fn _3_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_3_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "4 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 86 MHz."]
    #[inline(always)]
    pub fn _4_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_4_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "5 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 107 MHz."]
    #[inline(always)]
    pub fn _5_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_5_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "6 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 129 MHz."]
    #[inline(always)]
    pub fn _6_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_6_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "7 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 150 MHz."]
    #[inline(always)]
    pub fn _7_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_7_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "8 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 172 MHz."]
    #[inline(always)]
    pub fn _8_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_8_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "9 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 193 MHz."]
    #[inline(always)]
    pub fn _9_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_9_BASE_M4_CLK_CLOCKS)
    }
    #[doc = "10 BASE_M4_CLK clocks. Use for BASE_M4_CLK up to 204 MHz. Safe setting for all allowed conditions."]
    #[inline(always)]
    pub fn _10_base_m4_clk_clocks(self) -> &'a mut W {
        self.variant(FLASHTIM_A::_10_BASE_M4_CLK_CLOCKS)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 12)) | (((value as u32) & 0x0f) << 12);
        self.w
    }
}
#[doc = "Flash bank A power control\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum POW_A {
    #[doc = "0: Power-down"]
    POWER_DOWN,
    #[doc = "1: Active (Default)"]
    ACTIVE,
}
impl From<POW_A> for bool {
    #[inline(always)]
    fn from(variant: POW_A) -> Self {
        match variant {
            POW_A::POWER_DOWN => false,
            POW_A::ACTIVE => true,
        }
    }
}
#[doc = "Reader of field `POW`"]
pub type POW_R = crate::R<bool, POW_A>;
impl POW_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> POW_A {
        match self.bits {
            false => POW_A::POWER_DOWN,
            true => POW_A::ACTIVE,
        }
    }
    #[doc = "Checks if the value of the field is `POWER_DOWN`"]
    #[inline(always)]
    pub fn is_power_down(&self) -> bool {
        *self == POW_A::POWER_DOWN
    }
    #[doc = "Checks if the value of the field is `ACTIVE`"]
    #[inline(always)]
    pub fn is_active(&self) -> bool {
        *self == POW_A::ACTIVE
    }
}
#[doc = "Write proxy for field `POW`"]
pub struct POW_W<'a> {
    w: &'a mut W,
}
impl<'a> POW_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: POW_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Power-down"]
    #[inline(always)]
    pub fn power_down(self) -> &'a mut W {
        self.variant(POW_A::POWER_DOWN)
    }
    #[doc = "Active (Default)"]
    #[inline(always)]
    pub fn active(self) -> &'a mut W {
        self.variant(POW_A::ACTIVE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 31)) | (((value as u32) & 0x01) << 31);
        self.w
    }
}
impl R {
    #[doc = "Bits 12:15 - Flash access time. The value of this field plus 1 gives the number of BASE_M4_CLK clocks used for a flash access. Warning: Improper setting of this value may result in incorrect operation of the device. All other values are allowed but may not be optimal for the supported clock frequencies."]
    #[inline(always)]
    pub fn flashtim(&self) -> FLASHTIM_R {
        FLASHTIM_R::new(((self.bits >> 12) & 0x0f) as u8)
    }
    #[doc = "Bit 31 - Flash bank A power control"]
    #[inline(always)]
    pub fn pow(&self) -> POW_R {
        POW_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 12:15 - Flash access time. The value of this field plus 1 gives the number of BASE_M4_CLK clocks used for a flash access. Warning: Improper setting of this value may result in incorrect operation of the device. All other values are allowed but may not be optimal for the supported clock frequencies."]
    #[inline(always)]
    pub fn flashtim(&mut self) -> FLASHTIM_W {
        FLASHTIM_W { w: self }
    }
    #[doc = "Bit 31 - Flash bank A power control"]
    #[inline(always)]
    pub fn pow(&mut self) -> POW_W {
        POW_W { w: self }
    }
}
