#[doc = "Reader of register DYNAMICRASCAS%s"]
pub type R = crate::R<u32, super::DYNAMICRASCAS>;
#[doc = "Writer for register DYNAMICRASCAS%s"]
pub type W = crate::W<u32, super::DYNAMICRASCAS>;
#[doc = "Register DYNAMICRASCAS%s `reset()`'s with value 0x0303"]
impl crate::ResetValue for super::DYNAMICRASCAS {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0303
    }
}
#[doc = "RAS latency (active to read/write delay).\n\nValue on reset: 3"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RAS_A {
    #[doc = "1: One EMC_CCLK cycle."]
    ONE_EMC_CCLK_CYCLE,
    #[doc = "2: Two EMC_CCLK cycles."]
    TWO_EMC_CCLK_CYCLES,
    #[doc = "3: Three EMC_CCLK cycles (POR reset value)."]
    THREE_EMC_CCLK_CYCLES,
}
impl From<RAS_A> for u8 {
    #[inline(always)]
    fn from(variant: RAS_A) -> Self {
        match variant {
            RAS_A::ONE_EMC_CCLK_CYCLE => 1,
            RAS_A::TWO_EMC_CCLK_CYCLES => 2,
            RAS_A::THREE_EMC_CCLK_CYCLES => 3,
        }
    }
}
#[doc = "Reader of field `RAS`"]
pub type RAS_R = crate::R<u8, RAS_A>;
impl RAS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RAS_A {
        match self.bits {
            1 => RAS_A::ONE_EMC_CCLK_CYCLE,
            2 => RAS_A::TWO_EMC_CCLK_CYCLES,
            3 => RAS_A::THREE_EMC_CCLK_CYCLES,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `ONE_EMC_CCLK_CYCLE`"]
    #[inline(always)]
    pub fn is_one_emc_cclk_cycle(&self) -> bool {
        *self == RAS_A::ONE_EMC_CCLK_CYCLE
    }
    #[doc = "Checks if the value of the field is `TWO_EMC_CCLK_CYCLES`"]
    #[inline(always)]
    pub fn is_two_emc_cclk_cycles(&self) -> bool {
        *self == RAS_A::TWO_EMC_CCLK_CYCLES
    }
    #[doc = "Checks if the value of the field is `THREE_EMC_CCLK_CYCLES`"]
    #[inline(always)]
    pub fn is_three_emc_cclk_cycles(&self) -> bool {
        *self == RAS_A::THREE_EMC_CCLK_CYCLES
    }
}
#[doc = "Write proxy for field `RAS`"]
pub struct RAS_W<'a> {
    w: &'a mut W,
}
impl<'a> RAS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RAS_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "One EMC_CCLK cycle."]
    #[inline(always)]
    pub fn one_emc_cclk_cycle(self) -> &'a mut W {
        self.variant(RAS_A::ONE_EMC_CCLK_CYCLE)
    }
    #[doc = "Two EMC_CCLK cycles."]
    #[inline(always)]
    pub fn two_emc_cclk_cycles(self) -> &'a mut W {
        self.variant(RAS_A::TWO_EMC_CCLK_CYCLES)
    }
    #[doc = "Three EMC_CCLK cycles (POR reset value)."]
    #[inline(always)]
    pub fn three_emc_cclk_cycles(self) -> &'a mut W {
        self.variant(RAS_A::THREE_EMC_CCLK_CYCLES)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | ((value as u32) & 0x03);
        self.w
    }
}
#[doc = "CAS latency.\n\nValue on reset: 3"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAS_A {
    #[doc = "1: One EMC_CCLK cycle."]
    ONE_EMC_CCLK_CYCLE,
    #[doc = "2: Two EMC_CCLK cycles."]
    TWO_EMC_CCLK_CYCLES,
    #[doc = "3: Three EMC_CCLK cycles (POR reset value)."]
    THREE_EMC_CCLK_CYCLES,
}
impl From<CAS_A> for u8 {
    #[inline(always)]
    fn from(variant: CAS_A) -> Self {
        match variant {
            CAS_A::ONE_EMC_CCLK_CYCLE => 1,
            CAS_A::TWO_EMC_CCLK_CYCLES => 2,
            CAS_A::THREE_EMC_CCLK_CYCLES => 3,
        }
    }
}
#[doc = "Reader of field `CAS`"]
pub type CAS_R = crate::R<u8, CAS_A>;
impl CAS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAS_A {
        match self.bits {
            1 => CAS_A::ONE_EMC_CCLK_CYCLE,
            2 => CAS_A::TWO_EMC_CCLK_CYCLES,
            3 => CAS_A::THREE_EMC_CCLK_CYCLES,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `ONE_EMC_CCLK_CYCLE`"]
    #[inline(always)]
    pub fn is_one_emc_cclk_cycle(&self) -> bool {
        *self == CAS_A::ONE_EMC_CCLK_CYCLE
    }
    #[doc = "Checks if the value of the field is `TWO_EMC_CCLK_CYCLES`"]
    #[inline(always)]
    pub fn is_two_emc_cclk_cycles(&self) -> bool {
        *self == CAS_A::TWO_EMC_CCLK_CYCLES
    }
    #[doc = "Checks if the value of the field is `THREE_EMC_CCLK_CYCLES`"]
    #[inline(always)]
    pub fn is_three_emc_cclk_cycles(&self) -> bool {
        *self == CAS_A::THREE_EMC_CCLK_CYCLES
    }
}
#[doc = "Write proxy for field `CAS`"]
pub struct CAS_W<'a> {
    w: &'a mut W,
}
impl<'a> CAS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAS_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "One EMC_CCLK cycle."]
    #[inline(always)]
    pub fn one_emc_cclk_cycle(self) -> &'a mut W {
        self.variant(CAS_A::ONE_EMC_CCLK_CYCLE)
    }
    #[doc = "Two EMC_CCLK cycles."]
    #[inline(always)]
    pub fn two_emc_cclk_cycles(self) -> &'a mut W {
        self.variant(CAS_A::TWO_EMC_CCLK_CYCLES)
    }
    #[doc = "Three EMC_CCLK cycles (POR reset value)."]
    #[inline(always)]
    pub fn three_emc_cclk_cycles(self) -> &'a mut W {
        self.variant(CAS_A::THREE_EMC_CCLK_CYCLES)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 8)) | (((value as u32) & 0x03) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - RAS latency (active to read/write delay)."]
    #[inline(always)]
    pub fn ras(&self) -> RAS_R {
        RAS_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bits 8:9 - CAS latency."]
    #[inline(always)]
    pub fn cas(&self) -> CAS_R {
        CAS_R::new(((self.bits >> 8) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bits 0:1 - RAS latency (active to read/write delay)."]
    #[inline(always)]
    pub fn ras(&mut self) -> RAS_W {
        RAS_W { w: self }
    }
    #[doc = "Bits 8:9 - CAS latency."]
    #[inline(always)]
    pub fn cas(&mut self) -> CAS_W {
        CAS_W { w: self }
    }
}
