#[doc = "Reader of register DYNAMICREADCONFIG"]
pub type R = crate::R<u32, super::DYNAMICREADCONFIG>;
#[doc = "Writer for register DYNAMICREADCONFIG"]
pub type W = crate::W<u32, super::DYNAMICREADCONFIG>;
#[doc = "Register DYNAMICREADCONFIG `reset()`'s with value 0"]
impl crate::ResetValue for super::DYNAMICREADCONFIG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Read data strategy.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RD_A {
    #[doc = "0: Do not use. POR reset value."]
    DO_NOT_USE,
    #[doc = "1: Command delayed by 1/2 EMC_CCLK."]
    HALF,
    #[doc = "2: Command delayed by 1/2 EMC_CCLK plus one clock cycle."]
    HALFPLUSONE,
    #[doc = "3: Command delayed by1/2 EMC_CCLK plus two clock cycles,"]
    HALFPLUSTWO,
}
impl From<RD_A> for u8 {
    #[inline(always)]
    fn from(variant: RD_A) -> Self {
        match variant {
            RD_A::DO_NOT_USE => 0,
            RD_A::HALF => 1,
            RD_A::HALFPLUSONE => 2,
            RD_A::HALFPLUSTWO => 3,
        }
    }
}
#[doc = "Reader of field `RD`"]
pub type RD_R = crate::R<u8, RD_A>;
impl RD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RD_A {
        match self.bits {
            0 => RD_A::DO_NOT_USE,
            1 => RD_A::HALF,
            2 => RD_A::HALFPLUSONE,
            3 => RD_A::HALFPLUSTWO,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DO_NOT_USE`"]
    #[inline(always)]
    pub fn is_do_not_use(&self) -> bool {
        *self == RD_A::DO_NOT_USE
    }
    #[doc = "Checks if the value of the field is `HALF`"]
    #[inline(always)]
    pub fn is_half(&self) -> bool {
        *self == RD_A::HALF
    }
    #[doc = "Checks if the value of the field is `HALFPLUSONE`"]
    #[inline(always)]
    pub fn is_halfplusone(&self) -> bool {
        *self == RD_A::HALFPLUSONE
    }
    #[doc = "Checks if the value of the field is `HALFPLUSTWO`"]
    #[inline(always)]
    pub fn is_halfplustwo(&self) -> bool {
        *self == RD_A::HALFPLUSTWO
    }
}
#[doc = "Write proxy for field `RD`"]
pub struct RD_W<'a> {
    w: &'a mut W,
}
impl<'a> RD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RD_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Do not use. POR reset value."]
    #[inline(always)]
    pub fn do_not_use(self) -> &'a mut W {
        self.variant(RD_A::DO_NOT_USE)
    }
    #[doc = "Command delayed by 1/2 EMC_CCLK."]
    #[inline(always)]
    pub fn half(self) -> &'a mut W {
        self.variant(RD_A::HALF)
    }
    #[doc = "Command delayed by 1/2 EMC_CCLK plus one clock cycle."]
    #[inline(always)]
    pub fn halfplusone(self) -> &'a mut W {
        self.variant(RD_A::HALFPLUSONE)
    }
    #[doc = "Command delayed by1/2 EMC_CCLK plus two clock cycles,"]
    #[inline(always)]
    pub fn halfplustwo(self) -> &'a mut W {
        self.variant(RD_A::HALFPLUSTWO)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | ((value as u32) & 0x03);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - Read data strategy."]
    #[inline(always)]
    pub fn rd(&self) -> RD_R {
        RD_R::new((self.bits & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bits 0:1 - Read data strategy."]
    #[inline(always)]
    pub fn rd(&mut self) -> RD_W {
        RD_W { w: self }
    }
}
