#[doc = "Reader of register DMA_MFRM_BUFOF"]
pub type R = crate::R<u32, super::DMA_MFRM_BUFOF>;
#[doc = "Reader of field `FMC`"]
pub type FMC_R = crate::R<u16, u16>;
#[doc = "Reader of field `OC`"]
pub type OC_R = crate::R<bool, bool>;
#[doc = "Reader of field `FMA`"]
pub type FMA_R = crate::R<u16, u16>;
#[doc = "Reader of field `OF`"]
pub type OF_R = crate::R<bool, bool>;
impl R {
    #[doc = "Bits 0:15 - Number of frames missed This register field can be read by the application (Read), can be set to 1 by the Ethernet core on a certain internal event (Self Set), and is automatically cleared to 0 on a register read. A register write of 0 has no effect on this field. Indicates the number of frames missed by the controller due to the Host Receive Buffer being unavailable. This counter is incremented each time the DMA discards an incoming frame. The counter is cleared when this register is read with."]
    #[inline(always)]
    pub fn fmc(&self) -> FMC_R {
        FMC_R::new((self.bits & 0xffff) as u16)
    }
    #[doc = "Bit 16 - Overflow bit for missed frame counter This register field can be read by the application (Read), can be set to 1 by the Ethernet core on a certain internal event (Self Set), and is automatically cleared to 0 on a register read. A register write of 0 has no effect on this field."]
    #[inline(always)]
    pub fn oc(&self) -> OC_R {
        OC_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bits 17:27 - Number of frames missed by the application This register field can be read by the application (Read), can be set to 1 by the Ethernet core on a certain internal event (Self Set), and is automatically cleared to 0 on a register read. A register write of 0 has no effect on this field. Indicates the number of frames missed by the application. This counter is incremented each time the MTL asserts the sideband signal. The counter is cleared when this register is read with ."]
    #[inline(always)]
    pub fn fma(&self) -> FMA_R {
        FMA_R::new(((self.bits >> 17) & 0x07ff) as u16)
    }
    #[doc = "Bit 28 - Overflow bit for FIFO overflow counter This register field can be read by the application (Read), can be set to 1 by the Ethernet core on a certain internal event (Self Set), and is automatically cleared to 0 on a register read. A register write of 0 has no effect on this field."]
    #[inline(always)]
    pub fn of(&self) -> OF_R {
        OF_R::new(((self.bits >> 28) & 0x01) != 0)
    }
}
