#[doc = "Reader of register MAC_DEBUG"]
pub type R = crate::R<u32, super::MAC_DEBUG>;
#[doc = "Reader of field `RXIDLESTAT`"]
pub type RXIDLESTAT_R = crate::R<bool, bool>;
#[doc = "Reader of field `FIFOSTAT0`"]
pub type FIFOSTAT0_R = crate::R<u8, u8>;
#[doc = "Reader of field `RXFIFOSTAT1`"]
pub type RXFIFOSTAT1_R = crate::R<bool, bool>;
#[doc = "Reader of field `RXFIFOSTAT`"]
pub type RXFIFOSTAT_R = crate::R<u8, u8>;
#[doc = "Reader of field `RXFIFOLVL`"]
pub type RXFIFOLVL_R = crate::R<u8, u8>;
#[doc = "Reader of field `TXIDLESTAT`"]
pub type TXIDLESTAT_R = crate::R<bool, bool>;
#[doc = "Reader of field `TXSTAT`"]
pub type TXSTAT_R = crate::R<u8, u8>;
#[doc = "Reader of field `PAUSE`"]
pub type PAUSE_R = crate::R<bool, bool>;
#[doc = "Reader of field `TXFIFOSTAT`"]
pub type TXFIFOSTAT_R = crate::R<u8, u8>;
#[doc = "Reader of field `TXFIFOSTAT1`"]
pub type TXFIFOSTAT1_R = crate::R<bool, bool>;
#[doc = "Reader of field `TXFIFOLVL`"]
pub type TXFIFOLVL_R = crate::R<bool, bool>;
#[doc = "Reader of field `TXFIFOFULL`"]
pub type TXFIFOFULL_R = crate::R<bool, bool>;
impl R {
    #[doc = "Bit 0 - When high, it indicates that the MAC MII receive protocol engine is actively receiving data and not in IDLE state."]
    #[inline(always)]
    pub fn rxidlestat(&self) -> RXIDLESTAT_R {
        RXIDLESTAT_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 1:2 - When high, it indicates the active state of the small FIFO Read and Write controllers respectively of the MAC receive Frame Controller module."]
    #[inline(always)]
    pub fn fifostat0(&self) -> FIFOSTAT0_R {
        FIFOSTAT0_R::new(((self.bits >> 1) & 0x03) as u8)
    }
    #[doc = "Bit 4 - When high, it indicates that the MTL RxFIFO Write Controller is active and transferring a received frame to the FIFO."]
    #[inline(always)]
    pub fn rxfifostat1(&self) -> RXFIFOSTAT1_R {
        RXFIFOSTAT1_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bits 5:6 - State of the RxFIFO read Controller: 00 = idle state 01 = reading frame data 10 = reading frame status (or Time stamp) 11 = flushing the frame data and status"]
    #[inline(always)]
    pub fn rxfifostat(&self) -> RXFIFOSTAT_R {
        RXFIFOSTAT_R::new(((self.bits >> 5) & 0x03) as u8)
    }
    #[doc = "Bits 8:9 - Status of the RxFIFO Fill-level 00 = RxFIFO Empty 01 = RxFIFO fill-level below flow-control de-activate threshold 10 = RxFIFO fill-level above flow-control activate threshold 11 = RxFIFO Full"]
    #[inline(always)]
    pub fn rxfifolvl(&self) -> RXFIFOLVL_R {
        RXFIFOLVL_R::new(((self.bits >> 8) & 0x03) as u8)
    }
    #[doc = "Bit 16 - When high, it indicates that the MAC MII transmit protocol engine is actively transmitting data and not in IDLE state."]
    #[inline(always)]
    pub fn txidlestat(&self) -> TXIDLESTAT_R {
        TXIDLESTAT_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bits 17:18 - State of the MAC Transmit Frame Controller module: 00 = idle 01 = Waiting for Status of previous frame or IFG/backoff period to be over 10 = Generating and transmitting a PAUSE control frame (in full duplex mode) 11 = Transferring input frame for transmission"]
    #[inline(always)]
    pub fn txstat(&self) -> TXSTAT_R {
        TXSTAT_R::new(((self.bits >> 17) & 0x03) as u8)
    }
    #[doc = "Bit 19 - When high, it indicates that the MAC transmitter is in PAUSE condition (in full-duplex only) and hence will not schedule any frame for transmission."]
    #[inline(always)]
    pub fn pause(&self) -> PAUSE_R {
        PAUSE_R::new(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bits 20:21 - State of the TxFIFO read Controller 00 = idle state 01 = READ state (transferring data to MAC transmitter) 10 = Waiting for TxStatus from MAC transmitter 11 = Writing the received TxStatus or flushing the TxFIFO"]
    #[inline(always)]
    pub fn txfifostat(&self) -> TXFIFOSTAT_R {
        TXFIFOSTAT_R::new(((self.bits >> 20) & 0x03) as u8)
    }
    #[doc = "Bit 22 - When high, it indicates that the TxFIFO Write Controller is active and transferring data to the TxFIFO."]
    #[inline(always)]
    pub fn txfifostat1(&self) -> TXFIFOSTAT1_R {
        TXFIFOSTAT1_R::new(((self.bits >> 22) & 0x01) != 0)
    }
    #[doc = "Bit 24 - When high, it indicates that the TxFIFO is not empty and has some data left for transmission."]
    #[inline(always)]
    pub fn txfifolvl(&self) -> TXFIFOLVL_R {
        TXFIFOLVL_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bit 25 - When high, it indicates that the TxStatus FIFO is full and hence the controller will not be accepting any more frames for transmission."]
    #[inline(always)]
    pub fn txfifofull(&self) -> TXFIFOFULL_R {
        TXFIFOFULL_R::new(((self.bits >> 25) & 0x01) != 0)
    }
}
