#[doc = "Reader of register MAC_INTR"]
pub type R = crate::R<u32, super::MAC_INTR>;
#[doc = "Reader of field `PMT`"]
pub type PMT_R = crate::R<bool, bool>;
#[doc = "Reader of field `TS`"]
pub type TS_R = crate::R<bool, bool>;
impl R {
    #[doc = "Bit 3 - PMT Interrupt Status This bit is set whenever a Magic packet or Wake-on-LAN frame is received in Power- Down mode (See bits 5 and 6 in Table 560). This bit is cleared when both bits\\[6:5\\] are cleared because of a read operation to the PMT Control and Status register."]
    #[inline(always)]
    pub fn pmt(&self) -> PMT_R {
        PMT_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Timestamp interrupt status When Advanced Timestamp feature is enabled, this bit is set when any of the following conditions is true: - The system time value equals or exceeds the value specified in the Target Time High and Low registers - There is an overflow in the seconds register This bit is cleared on reading the byte 0 of the Timestamp Status register (Table 576). Otherwise, when default Time stamping is enabled, this bit when set indicates that the system time value equals or exceeds the value specified in the Target Time registers. In this mode, this bit is cleared after the completion of the read of this Interrupt Status Register. In all other modes, this bit is reserved."]
    #[inline(always)]
    pub fn ts(&self) -> TS_R {
        TS_R::new(((self.bits >> 9) & 0x01) != 0)
    }
}
