#[doc = "Reader of register EDGE"]
pub type R = crate::R<u32, super::EDGE>;
#[doc = "Writer for register EDGE"]
pub type W = crate::W<u32, super::EDGE>;
#[doc = "Register EDGE `reset()`'s with value 0"]
impl crate::ResetValue for super::EDGE {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Edge detect mode for WAKEUP0 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP0_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of WAKEUP0 pin. Detect falling edge if bit 0 in the HILO register is 0. Detect rising edge if bit 0 in the HILO register is 1."]
    EDGE_DETECT_OF_WAKEUP0,
}
impl From<WAKEUP0_E_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP0_E_A) -> Self {
        match variant {
            WAKEUP0_E_A::LEVEL_DETECT => false,
            WAKEUP0_E_A::EDGE_DETECT_OF_WAKEUP0 => true,
        }
    }
}
#[doc = "Reader of field `WAKEUP0_E`"]
pub type WAKEUP0_E_R = crate::R<bool, WAKEUP0_E_A>;
impl WAKEUP0_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP0_E_A {
        match self.bits {
            false => WAKEUP0_E_A::LEVEL_DETECT,
            true => WAKEUP0_E_A::EDGE_DETECT_OF_WAKEUP0,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == WAKEUP0_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_WAKEUP0`"]
    #[inline(always)]
    pub fn is_edge_detect_of_wakeup0(&self) -> bool {
        *self == WAKEUP0_E_A::EDGE_DETECT_OF_WAKEUP0
    }
}
#[doc = "Write proxy for field `WAKEUP0_E`"]
pub struct WAKEUP0_E_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP0_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP0_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(WAKEUP0_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of WAKEUP0 pin. Detect falling edge if bit 0 in the HILO register is 0. Detect rising edge if bit 0 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_wakeup0(self) -> &'a mut W {
        self.variant(WAKEUP0_E_A::EDGE_DETECT_OF_WAKEUP0)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Edge/level detect mode for WAKEUP1 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP1_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of WAKEUP1 pin. Detect falling edge if bit 1 in the HILO register is 0. Detect rising edge if bit 1 in the HILO register is 1."]
    EDGE_DETECT_OF_WAKEUP1,
}
impl From<WAKEUP1_E_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP1_E_A) -> Self {
        match variant {
            WAKEUP1_E_A::LEVEL_DETECT => false,
            WAKEUP1_E_A::EDGE_DETECT_OF_WAKEUP1 => true,
        }
    }
}
#[doc = "Reader of field `WAKEUP1_E`"]
pub type WAKEUP1_E_R = crate::R<bool, WAKEUP1_E_A>;
impl WAKEUP1_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP1_E_A {
        match self.bits {
            false => WAKEUP1_E_A::LEVEL_DETECT,
            true => WAKEUP1_E_A::EDGE_DETECT_OF_WAKEUP1,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == WAKEUP1_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_WAKEUP1`"]
    #[inline(always)]
    pub fn is_edge_detect_of_wakeup1(&self) -> bool {
        *self == WAKEUP1_E_A::EDGE_DETECT_OF_WAKEUP1
    }
}
#[doc = "Write proxy for field `WAKEUP1_E`"]
pub struct WAKEUP1_E_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP1_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP1_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(WAKEUP1_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of WAKEUP1 pin. Detect falling edge if bit 1 in the HILO register is 0. Detect rising edge if bit 1 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_wakeup1(self) -> &'a mut W {
        self.variant(WAKEUP1_E_A::EDGE_DETECT_OF_WAKEUP1)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Edge/level detect mode for WAKEUP2 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP2_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of WAKEUP2 pin. Detect falling edge if bit 2 in the HILO register is 0. Detect rising edge if bit 2 in the HILO register is 1."]
    EDGE_DETECT_OF_WAKEUP2,
}
impl From<WAKEUP2_E_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP2_E_A) -> Self {
        match variant {
            WAKEUP2_E_A::LEVEL_DETECT => false,
            WAKEUP2_E_A::EDGE_DETECT_OF_WAKEUP2 => true,
        }
    }
}
#[doc = "Reader of field `WAKEUP2_E`"]
pub type WAKEUP2_E_R = crate::R<bool, WAKEUP2_E_A>;
impl WAKEUP2_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP2_E_A {
        match self.bits {
            false => WAKEUP2_E_A::LEVEL_DETECT,
            true => WAKEUP2_E_A::EDGE_DETECT_OF_WAKEUP2,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == WAKEUP2_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_WAKEUP2`"]
    #[inline(always)]
    pub fn is_edge_detect_of_wakeup2(&self) -> bool {
        *self == WAKEUP2_E_A::EDGE_DETECT_OF_WAKEUP2
    }
}
#[doc = "Write proxy for field `WAKEUP2_E`"]
pub struct WAKEUP2_E_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP2_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP2_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(WAKEUP2_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of WAKEUP2 pin. Detect falling edge if bit 2 in the HILO register is 0. Detect rising edge if bit 2 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_wakeup2(self) -> &'a mut W {
        self.variant(WAKEUP2_E_A::EDGE_DETECT_OF_WAKEUP2)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Edge/level detect mode for WAKEUP3 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAKEUP3_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of WAKEUP3 pin. Detect falling edge if bit 30 in the HILO register is 0. Detect rising edge if bit 3 in the HILO register is 1."]
    EDGE_DETECT_OF_WAKEUP3,
}
impl From<WAKEUP3_E_A> for bool {
    #[inline(always)]
    fn from(variant: WAKEUP3_E_A) -> Self {
        match variant {
            WAKEUP3_E_A::LEVEL_DETECT => false,
            WAKEUP3_E_A::EDGE_DETECT_OF_WAKEUP3 => true,
        }
    }
}
#[doc = "Reader of field `WAKEUP3_E`"]
pub type WAKEUP3_E_R = crate::R<bool, WAKEUP3_E_A>;
impl WAKEUP3_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAKEUP3_E_A {
        match self.bits {
            false => WAKEUP3_E_A::LEVEL_DETECT,
            true => WAKEUP3_E_A::EDGE_DETECT_OF_WAKEUP3,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == WAKEUP3_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_WAKEUP3`"]
    #[inline(always)]
    pub fn is_edge_detect_of_wakeup3(&self) -> bool {
        *self == WAKEUP3_E_A::EDGE_DETECT_OF_WAKEUP3
    }
}
#[doc = "Write proxy for field `WAKEUP3_E`"]
pub struct WAKEUP3_E_W<'a> {
    w: &'a mut W,
}
impl<'a> WAKEUP3_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAKEUP3_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(WAKEUP3_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of WAKEUP3 pin. Detect falling edge if bit 30 in the HILO register is 0. Detect rising edge if bit 3 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_wakeup3(self) -> &'a mut W {
        self.variant(WAKEUP3_E_A::EDGE_DETECT_OF_WAKEUP3)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Edge/level detect mode for alarm timer event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ATIMER_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the alarm timer interrupt. Detect falling edge if bit 4 in the HILO register is 0. Detect rising edge if bit 4 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_ALARM_TIMER_INTERRUPT,
}
impl From<ATIMER_E_A> for bool {
    #[inline(always)]
    fn from(variant: ATIMER_E_A) -> Self {
        match variant {
            ATIMER_E_A::LEVEL_DETECT => false,
            ATIMER_E_A::EDGE_DETECT_OF_THE_ALARM_TIMER_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `ATIMER_E`"]
pub type ATIMER_E_R = crate::R<bool, ATIMER_E_A>;
impl ATIMER_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ATIMER_E_A {
        match self.bits {
            false => ATIMER_E_A::LEVEL_DETECT,
            true => ATIMER_E_A::EDGE_DETECT_OF_THE_ALARM_TIMER_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == ATIMER_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_ALARM_TIMER_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_alarm_timer_interrupt(&self) -> bool {
        *self == ATIMER_E_A::EDGE_DETECT_OF_THE_ALARM_TIMER_INTERRUPT
    }
}
#[doc = "Write proxy for field `ATIMER_E`"]
pub struct ATIMER_E_W<'a> {
    w: &'a mut W,
}
impl<'a> ATIMER_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ATIMER_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(ATIMER_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the alarm timer interrupt. Detect falling edge if bit 4 in the HILO register is 0. Detect rising edge if bit 4 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_alarm_timer_interrupt(self) -> &'a mut W {
        self.variant(ATIMER_E_A::EDGE_DETECT_OF_THE_ALARM_TIMER_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Edge/level detect mode for RTC event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RTC_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the RTC interrupt. Detect falling edge if bit 5 in the HILO register is 0. Detect rising edge if bit 5 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_RTC_INTERRUPT,
}
impl From<RTC_E_A> for bool {
    #[inline(always)]
    fn from(variant: RTC_E_A) -> Self {
        match variant {
            RTC_E_A::LEVEL_DETECT => false,
            RTC_E_A::EDGE_DETECT_OF_THE_RTC_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `RTC_E`"]
pub type RTC_E_R = crate::R<bool, RTC_E_A>;
impl RTC_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RTC_E_A {
        match self.bits {
            false => RTC_E_A::LEVEL_DETECT,
            true => RTC_E_A::EDGE_DETECT_OF_THE_RTC_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == RTC_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_RTC_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_rtc_interrupt(&self) -> bool {
        *self == RTC_E_A::EDGE_DETECT_OF_THE_RTC_INTERRUPT
    }
}
#[doc = "Write proxy for field `RTC_E`"]
pub struct RTC_E_W<'a> {
    w: &'a mut W,
}
impl<'a> RTC_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RTC_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(RTC_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the RTC interrupt. Detect falling edge if bit 5 in the HILO register is 0. Detect rising edge if bit 5 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_rtc_interrupt(self) -> &'a mut W {
        self.variant(RTC_E_A::EDGE_DETECT_OF_THE_RTC_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Edge/level detect mode for BOD event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BOD_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the BOD interrupt. Detect falling edge if bit 6 in the HILO register is 0. Detect rising edge if bit 6 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_BOD_INTERRUPT,
}
impl From<BOD_E_A> for bool {
    #[inline(always)]
    fn from(variant: BOD_E_A) -> Self {
        match variant {
            BOD_E_A::LEVEL_DETECT => false,
            BOD_E_A::EDGE_DETECT_OF_THE_BOD_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `BOD_E`"]
pub type BOD_E_R = crate::R<bool, BOD_E_A>;
impl BOD_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BOD_E_A {
        match self.bits {
            false => BOD_E_A::LEVEL_DETECT,
            true => BOD_E_A::EDGE_DETECT_OF_THE_BOD_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == BOD_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_BOD_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_bod_interrupt(&self) -> bool {
        *self == BOD_E_A::EDGE_DETECT_OF_THE_BOD_INTERRUPT
    }
}
#[doc = "Write proxy for field `BOD_E`"]
pub struct BOD_E_W<'a> {
    w: &'a mut W,
}
impl<'a> BOD_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BOD_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(BOD_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the BOD interrupt. Detect falling edge if bit 6 in the HILO register is 0. Detect rising edge if bit 6 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_bod_interrupt(self) -> &'a mut W {
        self.variant(BOD_E_A::EDGE_DETECT_OF_THE_BOD_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Edge/level detect mode for WWDTD event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WWDT_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the WWDT interrupt. Detect falling edge if bit 7 in the HILO register is 0. Detect rising edge if bit 7 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_WWDT_INTERRUPT,
}
impl From<WWDT_E_A> for bool {
    #[inline(always)]
    fn from(variant: WWDT_E_A) -> Self {
        match variant {
            WWDT_E_A::LEVEL_DETECT => false,
            WWDT_E_A::EDGE_DETECT_OF_THE_WWDT_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `WWDT_E`"]
pub type WWDT_E_R = crate::R<bool, WWDT_E_A>;
impl WWDT_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WWDT_E_A {
        match self.bits {
            false => WWDT_E_A::LEVEL_DETECT,
            true => WWDT_E_A::EDGE_DETECT_OF_THE_WWDT_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == WWDT_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_WWDT_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_wwdt_interrupt(&self) -> bool {
        *self == WWDT_E_A::EDGE_DETECT_OF_THE_WWDT_INTERRUPT
    }
}
#[doc = "Write proxy for field `WWDT_E`"]
pub struct WWDT_E_W<'a> {
    w: &'a mut W,
}
impl<'a> WWDT_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WWDT_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(WWDT_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the WWDT interrupt. Detect falling edge if bit 7 in the HILO register is 0. Detect rising edge if bit 7 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_wwdt_interrupt(self) -> &'a mut W {
        self.variant(WWDT_E_A::EDGE_DETECT_OF_THE_WWDT_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Edge/level detect mode for ethernet event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ETH_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the Ethernet interrupt. Detect falling edge if bit 8 in the HILO register is 0. Detect rising edge if bit 8 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_ETH_INTERRUPT,
}
impl From<ETH_E_A> for bool {
    #[inline(always)]
    fn from(variant: ETH_E_A) -> Self {
        match variant {
            ETH_E_A::LEVEL_DETECT => false,
            ETH_E_A::EDGE_DETECT_OF_THE_ETH_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `ETH_E`"]
pub type ETH_E_R = crate::R<bool, ETH_E_A>;
impl ETH_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ETH_E_A {
        match self.bits {
            false => ETH_E_A::LEVEL_DETECT,
            true => ETH_E_A::EDGE_DETECT_OF_THE_ETH_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == ETH_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_ETH_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_eth_interrupt(&self) -> bool {
        *self == ETH_E_A::EDGE_DETECT_OF_THE_ETH_INTERRUPT
    }
}
#[doc = "Write proxy for field `ETH_E`"]
pub struct ETH_E_W<'a> {
    w: &'a mut W,
}
impl<'a> ETH_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ETH_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(ETH_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the Ethernet interrupt. Detect falling edge if bit 8 in the HILO register is 0. Detect rising edge if bit 8 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_eth_interrupt(self) -> &'a mut W {
        self.variant(ETH_E_A::EDGE_DETECT_OF_THE_ETH_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Edge/level detect mode for USB0 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB0_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the USB0 event. Detect falling edge if bit 9 in the HILO register is 0. Detect rising edge if bit 9 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_USB0_EVENT,
}
impl From<USB0_E_A> for bool {
    #[inline(always)]
    fn from(variant: USB0_E_A) -> Self {
        match variant {
            USB0_E_A::LEVEL_DETECT => false,
            USB0_E_A::EDGE_DETECT_OF_THE_USB0_EVENT => true,
        }
    }
}
#[doc = "Reader of field `USB0_E`"]
pub type USB0_E_R = crate::R<bool, USB0_E_A>;
impl USB0_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB0_E_A {
        match self.bits {
            false => USB0_E_A::LEVEL_DETECT,
            true => USB0_E_A::EDGE_DETECT_OF_THE_USB0_EVENT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == USB0_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_USB0_EVENT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_usb0_event(&self) -> bool {
        *self == USB0_E_A::EDGE_DETECT_OF_THE_USB0_EVENT
    }
}
#[doc = "Write proxy for field `USB0_E`"]
pub struct USB0_E_W<'a> {
    w: &'a mut W,
}
impl<'a> USB0_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB0_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(USB0_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the USB0 event. Detect falling edge if bit 9 in the HILO register is 0. Detect rising edge if bit 9 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_usb0_event(self) -> &'a mut W {
        self.variant(USB0_E_A::EDGE_DETECT_OF_THE_USB0_EVENT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "Edge/level detect mode for USB1 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB1_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the USB1 interrupt. Detect falling edge if bit 10 in the HILO register is 0. Detect rising edge if bit 10 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_USB1_EVENT,
}
impl From<USB1_E_A> for bool {
    #[inline(always)]
    fn from(variant: USB1_E_A) -> Self {
        match variant {
            USB1_E_A::LEVEL_DETECT => false,
            USB1_E_A::EDGE_DETECT_OF_THE_USB1_EVENT => true,
        }
    }
}
#[doc = "Reader of field `USB1_E`"]
pub type USB1_E_R = crate::R<bool, USB1_E_A>;
impl USB1_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB1_E_A {
        match self.bits {
            false => USB1_E_A::LEVEL_DETECT,
            true => USB1_E_A::EDGE_DETECT_OF_THE_USB1_EVENT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == USB1_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_USB1_EVENT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_usb1_event(&self) -> bool {
        *self == USB1_E_A::EDGE_DETECT_OF_THE_USB1_EVENT
    }
}
#[doc = "Write proxy for field `USB1_E`"]
pub struct USB1_E_W<'a> {
    w: &'a mut W,
}
impl<'a> USB1_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB1_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(USB1_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the USB1 interrupt. Detect falling edge if bit 10 in the HILO register is 0. Detect rising edge if bit 10 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_usb1_event(self) -> &'a mut W {
        self.variant(USB1_E_A::EDGE_DETECT_OF_THE_USB1_EVENT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "Edge/level detect mode for SD/MMC event.The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDMMC_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the SD/MMC interrupt. Detect falling edge if bit 10 in the HILO register is 0. Detect rising edge if bit 10 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_SD_MMC_INTERRUPT,
}
impl From<SDMMC_E_A> for bool {
    #[inline(always)]
    fn from(variant: SDMMC_E_A) -> Self {
        match variant {
            SDMMC_E_A::LEVEL_DETECT => false,
            SDMMC_E_A::EDGE_DETECT_OF_THE_SD_MMC_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `SDMMC_E`"]
pub type SDMMC_E_R = crate::R<bool, SDMMC_E_A>;
impl SDMMC_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDMMC_E_A {
        match self.bits {
            false => SDMMC_E_A::LEVEL_DETECT,
            true => SDMMC_E_A::EDGE_DETECT_OF_THE_SD_MMC_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == SDMMC_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_SD_MMC_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_sd_mmc_interrupt(&self) -> bool {
        *self == SDMMC_E_A::EDGE_DETECT_OF_THE_SD_MMC_INTERRUPT
    }
}
#[doc = "Write proxy for field `SDMMC_E`"]
pub struct SDMMC_E_W<'a> {
    w: &'a mut W,
}
impl<'a> SDMMC_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDMMC_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(SDMMC_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the SD/MMC interrupt. Detect falling edge if bit 10 in the HILO register is 0. Detect rising edge if bit 10 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_sd_mmc_interrupt(self) -> &'a mut W {
        self.variant(SDMMC_E_A::EDGE_DETECT_OF_THE_SD_MMC_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Edge/level detect mode for C_CAN event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAN_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the combined C_CAN interrupt. Detect falling edge if bit 12 in the HILO register is 0. Detect rising edge if bit 12 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_C_CAN_INTERRUPT,
}
impl From<CAN_E_A> for bool {
    #[inline(always)]
    fn from(variant: CAN_E_A) -> Self {
        match variant {
            CAN_E_A::LEVEL_DETECT => false,
            CAN_E_A::EDGE_DETECT_OF_THE_C_CAN_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `CAN_E`"]
pub type CAN_E_R = crate::R<bool, CAN_E_A>;
impl CAN_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAN_E_A {
        match self.bits {
            false => CAN_E_A::LEVEL_DETECT,
            true => CAN_E_A::EDGE_DETECT_OF_THE_C_CAN_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == CAN_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_C_CAN_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_c_can_interrupt(&self) -> bool {
        *self == CAN_E_A::EDGE_DETECT_OF_THE_C_CAN_INTERRUPT
    }
}
#[doc = "Write proxy for field `CAN_E`"]
pub struct CAN_E_W<'a> {
    w: &'a mut W,
}
impl<'a> CAN_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAN_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(CAN_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the combined C_CAN interrupt. Detect falling edge if bit 12 in the HILO register is 0. Detect rising edge if bit 12 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_c_can_interrupt(self) -> &'a mut W {
        self.variant(CAN_E_A::EDGE_DETECT_OF_THE_C_CAN_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Edge/level detect mode for combined timer output 2 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIM2_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of GIMA output 25. Detect falling edge if bit 13 in the HILO register is 0. Detect rising edge if bit 13 in the HILO register is 1."]
    EDGE_DETECT_OF_GIMA,
}
impl From<TIM2_E_A> for bool {
    #[inline(always)]
    fn from(variant: TIM2_E_A) -> Self {
        match variant {
            TIM2_E_A::LEVEL_DETECT => false,
            TIM2_E_A::EDGE_DETECT_OF_GIMA => true,
        }
    }
}
#[doc = "Reader of field `TIM2_E`"]
pub type TIM2_E_R = crate::R<bool, TIM2_E_A>;
impl TIM2_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TIM2_E_A {
        match self.bits {
            false => TIM2_E_A::LEVEL_DETECT,
            true => TIM2_E_A::EDGE_DETECT_OF_GIMA,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == TIM2_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_GIMA`"]
    #[inline(always)]
    pub fn is_edge_detect_of_gima(&self) -> bool {
        *self == TIM2_E_A::EDGE_DETECT_OF_GIMA
    }
}
#[doc = "Write proxy for field `TIM2_E`"]
pub struct TIM2_E_W<'a> {
    w: &'a mut W,
}
impl<'a> TIM2_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TIM2_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(TIM2_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of GIMA output 25. Detect falling edge if bit 13 in the HILO register is 0. Detect rising edge if bit 13 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_gima(self) -> &'a mut W {
        self.variant(TIM2_E_A::EDGE_DETECT_OF_GIMA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Edge/level detect mode for combined timer output 6 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIM6_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of GIMA output 26. Detect falling edge if bit 14 in the HILO register is 0. Detect rising edge if bit 14 in the HILO register is 1."]
    EDGE_DETECT_OF_GIMA,
}
impl From<TIM6_E_A> for bool {
    #[inline(always)]
    fn from(variant: TIM6_E_A) -> Self {
        match variant {
            TIM6_E_A::LEVEL_DETECT => false,
            TIM6_E_A::EDGE_DETECT_OF_GIMA => true,
        }
    }
}
#[doc = "Reader of field `TIM6_E`"]
pub type TIM6_E_R = crate::R<bool, TIM6_E_A>;
impl TIM6_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TIM6_E_A {
        match self.bits {
            false => TIM6_E_A::LEVEL_DETECT,
            true => TIM6_E_A::EDGE_DETECT_OF_GIMA,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == TIM6_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_GIMA`"]
    #[inline(always)]
    pub fn is_edge_detect_of_gima(&self) -> bool {
        *self == TIM6_E_A::EDGE_DETECT_OF_GIMA
    }
}
#[doc = "Write proxy for field `TIM6_E`"]
pub struct TIM6_E_W<'a> {
    w: &'a mut W,
}
impl<'a> TIM6_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TIM6_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(TIM6_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of GIMA output 26. Detect falling edge if bit 14 in the HILO register is 0. Detect rising edge if bit 14 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_gima(self) -> &'a mut W {
        self.variant(TIM6_E_A::EDGE_DETECT_OF_GIMA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Edge/level detect mode for QEI interrupt signal. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum QEI_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of QEI interrupt. Detect falling edge if bit 15 in the HILO register is 0. Detect rising edge if bit 15 in the HILO register is 1."]
    EDGE_DETECT_OF_QEI_INTERRUPT,
}
impl From<QEI_E_A> for bool {
    #[inline(always)]
    fn from(variant: QEI_E_A) -> Self {
        match variant {
            QEI_E_A::LEVEL_DETECT => false,
            QEI_E_A::EDGE_DETECT_OF_QEI_INTERRUPT => true,
        }
    }
}
#[doc = "Reader of field `QEI_E`"]
pub type QEI_E_R = crate::R<bool, QEI_E_A>;
impl QEI_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> QEI_E_A {
        match self.bits {
            false => QEI_E_A::LEVEL_DETECT,
            true => QEI_E_A::EDGE_DETECT_OF_QEI_INTERRUPT,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == QEI_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_QEI_INTERRUPT`"]
    #[inline(always)]
    pub fn is_edge_detect_of_qei_interrupt(&self) -> bool {
        *self == QEI_E_A::EDGE_DETECT_OF_QEI_INTERRUPT
    }
}
#[doc = "Write proxy for field `QEI_E`"]
pub struct QEI_E_W<'a> {
    w: &'a mut W,
}
impl<'a> QEI_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: QEI_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(QEI_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of QEI interrupt. Detect falling edge if bit 15 in the HILO register is 0. Detect rising edge if bit 15 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_qei_interrupt(self) -> &'a mut W {
        self.variant(QEI_E_A::EDGE_DETECT_OF_QEI_INTERRUPT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
#[doc = "Edge/level detect mode for combined timer output 14 event. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIM14_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of GIMA output 27. Detect falling edge if bit 16 in the HILO register is 0. Detect rising edge if bit 16 in the HILO register is 1."]
    EDGE_DETECT_OF_GIMA,
}
impl From<TIM14_E_A> for bool {
    #[inline(always)]
    fn from(variant: TIM14_E_A) -> Self {
        match variant {
            TIM14_E_A::LEVEL_DETECT => false,
            TIM14_E_A::EDGE_DETECT_OF_GIMA => true,
        }
    }
}
#[doc = "Reader of field `TIM14_E`"]
pub type TIM14_E_R = crate::R<bool, TIM14_E_A>;
impl TIM14_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TIM14_E_A {
        match self.bits {
            false => TIM14_E_A::LEVEL_DETECT,
            true => TIM14_E_A::EDGE_DETECT_OF_GIMA,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == TIM14_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_GIMA`"]
    #[inline(always)]
    pub fn is_edge_detect_of_gima(&self) -> bool {
        *self == TIM14_E_A::EDGE_DETECT_OF_GIMA
    }
}
#[doc = "Write proxy for field `TIM14_E`"]
pub struct TIM14_E_W<'a> {
    w: &'a mut W,
}
impl<'a> TIM14_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TIM14_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(TIM14_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of GIMA output 27. Detect falling edge if bit 16 in the HILO register is 0. Detect rising edge if bit 16 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_gima(self) -> &'a mut W {
        self.variant(TIM14_E_A::EDGE_DETECT_OF_GIMA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Edge/level detect mode for Reset. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RESET_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the reset signal. Detect falling edge if bit 19 in the HILO register is 0. Detect rising edge if bit 19 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_RESET_SIGNAL,
}
impl From<RESET_E_A> for bool {
    #[inline(always)]
    fn from(variant: RESET_E_A) -> Self {
        match variant {
            RESET_E_A::LEVEL_DETECT => false,
            RESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL => true,
        }
    }
}
#[doc = "Reader of field `RESET_E`"]
pub type RESET_E_R = crate::R<bool, RESET_E_A>;
impl RESET_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RESET_E_A {
        match self.bits {
            false => RESET_E_A::LEVEL_DETECT,
            true => RESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == RESET_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_RESET_SIGNAL`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_reset_signal(&self) -> bool {
        *self == RESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL
    }
}
#[doc = "Write proxy for field `RESET_E`"]
pub struct RESET_E_W<'a> {
    w: &'a mut W,
}
impl<'a> RESET_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RESET_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(RESET_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the reset signal. Detect falling edge if bit 19 in the HILO register is 0. Detect rising edge if bit 19 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_reset_signal(self) -> &'a mut W {
        self.variant(RESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 19)) | (((value as u32) & 0x01) << 19);
        self.w
    }
}
#[doc = "Edge detect of the BOD reset signal. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BODRESET_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the reset signal. Detect falling edge if bit 20 in the HILO register is 0. Detect rising edge if bit 19 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_RESET_SIGNAL,
}
impl From<BODRESET_E_A> for bool {
    #[inline(always)]
    fn from(variant: BODRESET_E_A) -> Self {
        match variant {
            BODRESET_E_A::LEVEL_DETECT => false,
            BODRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL => true,
        }
    }
}
#[doc = "Reader of field `BODRESET_E`"]
pub type BODRESET_E_R = crate::R<bool, BODRESET_E_A>;
impl BODRESET_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BODRESET_E_A {
        match self.bits {
            false => BODRESET_E_A::LEVEL_DETECT,
            true => BODRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == BODRESET_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_RESET_SIGNAL`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_reset_signal(&self) -> bool {
        *self == BODRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL
    }
}
#[doc = "Write proxy for field `BODRESET_E`"]
pub struct BODRESET_E_W<'a> {
    w: &'a mut W,
}
impl<'a> BODRESET_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BODRESET_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(BODRESET_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the reset signal. Detect falling edge if bit 20 in the HILO register is 0. Detect rising edge if bit 19 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_reset_signal(self) -> &'a mut W {
        self.variant(BODRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 20)) | (((value as u32) & 0x01) << 20);
        self.w
    }
}
#[doc = "Edge detect of the deep power-down reset signal. The corresponding bit in the EDGE register must be 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DPDRESET_E_A {
    #[doc = "0: Level detect."]
    LEVEL_DETECT,
    #[doc = "1: Edge detect of the reset signal. Detect falling edge if bit 21 in the HILO register is 0. Detect rising edge if bit 21 in the HILO register is 1."]
    EDGE_DETECT_OF_THE_RESET_SIGNAL,
}
impl From<DPDRESET_E_A> for bool {
    #[inline(always)]
    fn from(variant: DPDRESET_E_A) -> Self {
        match variant {
            DPDRESET_E_A::LEVEL_DETECT => false,
            DPDRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL => true,
        }
    }
}
#[doc = "Reader of field `DPDRESET_E`"]
pub type DPDRESET_E_R = crate::R<bool, DPDRESET_E_A>;
impl DPDRESET_E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DPDRESET_E_A {
        match self.bits {
            false => DPDRESET_E_A::LEVEL_DETECT,
            true => DPDRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL,
        }
    }
    #[doc = "Checks if the value of the field is `LEVEL_DETECT`"]
    #[inline(always)]
    pub fn is_level_detect(&self) -> bool {
        *self == DPDRESET_E_A::LEVEL_DETECT
    }
    #[doc = "Checks if the value of the field is `EDGE_DETECT_OF_THE_RESET_SIGNAL`"]
    #[inline(always)]
    pub fn is_edge_detect_of_the_reset_signal(&self) -> bool {
        *self == DPDRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL
    }
}
#[doc = "Write proxy for field `DPDRESET_E`"]
pub struct DPDRESET_E_W<'a> {
    w: &'a mut W,
}
impl<'a> DPDRESET_E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DPDRESET_E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Level detect."]
    #[inline(always)]
    pub fn level_detect(self) -> &'a mut W {
        self.variant(DPDRESET_E_A::LEVEL_DETECT)
    }
    #[doc = "Edge detect of the reset signal. Detect falling edge if bit 21 in the HILO register is 0. Detect rising edge if bit 21 in the HILO register is 1."]
    #[inline(always)]
    pub fn edge_detect_of_the_reset_signal(self) -> &'a mut W {
        self.variant(DPDRESET_E_A::EDGE_DETECT_OF_THE_RESET_SIGNAL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | (((value as u32) & 0x01) << 21);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Edge detect mode for WAKEUP0 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup0_e(&self) -> WAKEUP0_E_R {
        WAKEUP0_E_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Edge/level detect mode for WAKEUP1 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup1_e(&self) -> WAKEUP1_E_R {
        WAKEUP1_E_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Edge/level detect mode for WAKEUP2 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup2_e(&self) -> WAKEUP2_E_R {
        WAKEUP2_E_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Edge/level detect mode for WAKEUP3 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup3_e(&self) -> WAKEUP3_E_R {
        WAKEUP3_E_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Edge/level detect mode for alarm timer event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn atimer_e(&self) -> ATIMER_E_R {
        ATIMER_E_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Edge/level detect mode for RTC event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn rtc_e(&self) -> RTC_E_R {
        RTC_E_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Edge/level detect mode for BOD event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn bod_e(&self) -> BOD_E_R {
        BOD_E_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Edge/level detect mode for WWDTD event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wwdt_e(&self) -> WWDT_E_R {
        WWDT_E_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Edge/level detect mode for ethernet event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn eth_e(&self) -> ETH_E_R {
        ETH_E_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Edge/level detect mode for USB0 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn usb0_e(&self) -> USB0_E_R {
        USB0_E_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Edge/level detect mode for USB1 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn usb1_e(&self) -> USB1_E_R {
        USB1_E_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Edge/level detect mode for SD/MMC event.The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn sdmmc_e(&self) -> SDMMC_E_R {
        SDMMC_E_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Edge/level detect mode for C_CAN event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn can_e(&self) -> CAN_E_R {
        CAN_E_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Edge/level detect mode for combined timer output 2 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn tim2_e(&self) -> TIM2_E_R {
        TIM2_E_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Edge/level detect mode for combined timer output 6 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn tim6_e(&self) -> TIM6_E_R {
        TIM6_E_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Edge/level detect mode for QEI interrupt signal. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn qei_e(&self) -> QEI_E_R {
        QEI_E_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Edge/level detect mode for combined timer output 14 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn tim14_e(&self) -> TIM14_E_R {
        TIM14_E_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 19 - Edge/level detect mode for Reset. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn reset_e(&self) -> RESET_E_R {
        RESET_E_R::new(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - Edge detect of the BOD reset signal. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn bodreset_e(&self) -> BODRESET_E_R {
        BODRESET_E_R::new(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Edge detect of the deep power-down reset signal. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn dpdreset_e(&self) -> DPDRESET_E_R {
        DPDRESET_E_R::new(((self.bits >> 21) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Edge detect mode for WAKEUP0 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup0_e(&mut self) -> WAKEUP0_E_W {
        WAKEUP0_E_W { w: self }
    }
    #[doc = "Bit 1 - Edge/level detect mode for WAKEUP1 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup1_e(&mut self) -> WAKEUP1_E_W {
        WAKEUP1_E_W { w: self }
    }
    #[doc = "Bit 2 - Edge/level detect mode for WAKEUP2 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup2_e(&mut self) -> WAKEUP2_E_W {
        WAKEUP2_E_W { w: self }
    }
    #[doc = "Bit 3 - Edge/level detect mode for WAKEUP3 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wakeup3_e(&mut self) -> WAKEUP3_E_W {
        WAKEUP3_E_W { w: self }
    }
    #[doc = "Bit 4 - Edge/level detect mode for alarm timer event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn atimer_e(&mut self) -> ATIMER_E_W {
        ATIMER_E_W { w: self }
    }
    #[doc = "Bit 5 - Edge/level detect mode for RTC event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn rtc_e(&mut self) -> RTC_E_W {
        RTC_E_W { w: self }
    }
    #[doc = "Bit 6 - Edge/level detect mode for BOD event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn bod_e(&mut self) -> BOD_E_W {
        BOD_E_W { w: self }
    }
    #[doc = "Bit 7 - Edge/level detect mode for WWDTD event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn wwdt_e(&mut self) -> WWDT_E_W {
        WWDT_E_W { w: self }
    }
    #[doc = "Bit 8 - Edge/level detect mode for ethernet event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn eth_e(&mut self) -> ETH_E_W {
        ETH_E_W { w: self }
    }
    #[doc = "Bit 9 - Edge/level detect mode for USB0 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn usb0_e(&mut self) -> USB0_E_W {
        USB0_E_W { w: self }
    }
    #[doc = "Bit 10 - Edge/level detect mode for USB1 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn usb1_e(&mut self) -> USB1_E_W {
        USB1_E_W { w: self }
    }
    #[doc = "Bit 11 - Edge/level detect mode for SD/MMC event.The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn sdmmc_e(&mut self) -> SDMMC_E_W {
        SDMMC_E_W { w: self }
    }
    #[doc = "Bit 12 - Edge/level detect mode for C_CAN event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn can_e(&mut self) -> CAN_E_W {
        CAN_E_W { w: self }
    }
    #[doc = "Bit 13 - Edge/level detect mode for combined timer output 2 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn tim2_e(&mut self) -> TIM2_E_W {
        TIM2_E_W { w: self }
    }
    #[doc = "Bit 14 - Edge/level detect mode for combined timer output 6 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn tim6_e(&mut self) -> TIM6_E_W {
        TIM6_E_W { w: self }
    }
    #[doc = "Bit 15 - Edge/level detect mode for QEI interrupt signal. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn qei_e(&mut self) -> QEI_E_W {
        QEI_E_W { w: self }
    }
    #[doc = "Bit 16 - Edge/level detect mode for combined timer output 14 event. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn tim14_e(&mut self) -> TIM14_E_W {
        TIM14_E_W { w: self }
    }
    #[doc = "Bit 19 - Edge/level detect mode for Reset. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn reset_e(&mut self) -> RESET_E_W {
        RESET_E_W { w: self }
    }
    #[doc = "Bit 20 - Edge detect of the BOD reset signal. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn bodreset_e(&mut self) -> BODRESET_E_W {
        BODRESET_E_W { w: self }
    }
    #[doc = "Bit 21 - Edge detect of the deep power-down reset signal. The corresponding bit in the EDGE register must be 0."]
    #[inline(always)]
    pub fn dpdreset_e(&mut self) -> DPDRESET_E_W {
        DPDRESET_E_W { w: self }
    }
}
