#[doc = "Reader of register C%sCONTROL"]
pub type R = crate::R<u32, super::CCONTROL>;
#[doc = "Writer for register C%sCONTROL"]
pub type W = crate::W<u32, super::CCONTROL>;
#[doc = "Register C%sCONTROL `reset()`'s with value 0"]
impl crate::ResetValue for super::CCONTROL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `TRANSFERSIZE`"]
pub type TRANSFERSIZE_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `TRANSFERSIZE`"]
pub struct TRANSFERSIZE_W<'a> {
    w: &'a mut W,
}
impl<'a> TRANSFERSIZE_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0fff) | ((value as u32) & 0x0fff);
        self.w
    }
}
#[doc = "Source burst size. Indicates the number of transfers that make up a source burst. This value must be set to the burst size of the source peripheral, or if the source is memory, to the memory boundary size (see Figure 3). The burst size is the amount of data that is transferred when the BREQ signal goes active in the source peripheral.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SBSIZE_A {
    #[doc = "0: Source burst size = 1"]
    SOURCE_BURST_1,
    #[doc = "1: Source burst size = 4"]
    SOURCE_BURST_4,
    #[doc = "2: Source burst size = 8"]
    SOURCE_BURST_8,
    #[doc = "3: Source burst size = 16"]
    SOURCE_BURST_16,
    #[doc = "4: Source burst size = 32"]
    SOURCE_BURST_32,
    #[doc = "5: Source burst size = 64"]
    SOURCE_BURST_64,
    #[doc = "6: Source burst size = 128"]
    SOURCE_BURST_128,
    #[doc = "7: Source burst size = 256"]
    SOURCE_BURST_256,
}
impl From<SBSIZE_A> for u8 {
    #[inline(always)]
    fn from(variant: SBSIZE_A) -> Self {
        match variant {
            SBSIZE_A::SOURCE_BURST_1 => 0,
            SBSIZE_A::SOURCE_BURST_4 => 1,
            SBSIZE_A::SOURCE_BURST_8 => 2,
            SBSIZE_A::SOURCE_BURST_16 => 3,
            SBSIZE_A::SOURCE_BURST_32 => 4,
            SBSIZE_A::SOURCE_BURST_64 => 5,
            SBSIZE_A::SOURCE_BURST_128 => 6,
            SBSIZE_A::SOURCE_BURST_256 => 7,
        }
    }
}
#[doc = "Reader of field `SBSIZE`"]
pub type SBSIZE_R = crate::R<u8, SBSIZE_A>;
impl SBSIZE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SBSIZE_A {
        match self.bits {
            0 => SBSIZE_A::SOURCE_BURST_1,
            1 => SBSIZE_A::SOURCE_BURST_4,
            2 => SBSIZE_A::SOURCE_BURST_8,
            3 => SBSIZE_A::SOURCE_BURST_16,
            4 => SBSIZE_A::SOURCE_BURST_32,
            5 => SBSIZE_A::SOURCE_BURST_64,
            6 => SBSIZE_A::SOURCE_BURST_128,
            7 => SBSIZE_A::SOURCE_BURST_256,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_1`"]
    #[inline(always)]
    pub fn is_source_burst_1(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_1
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_4`"]
    #[inline(always)]
    pub fn is_source_burst_4(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_4
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_8`"]
    #[inline(always)]
    pub fn is_source_burst_8(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_8
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_16`"]
    #[inline(always)]
    pub fn is_source_burst_16(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_16
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_32`"]
    #[inline(always)]
    pub fn is_source_burst_32(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_32
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_64`"]
    #[inline(always)]
    pub fn is_source_burst_64(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_64
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_128`"]
    #[inline(always)]
    pub fn is_source_burst_128(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_128
    }
    #[doc = "Checks if the value of the field is `SOURCE_BURST_256`"]
    #[inline(always)]
    pub fn is_source_burst_256(&self) -> bool {
        *self == SBSIZE_A::SOURCE_BURST_256
    }
}
#[doc = "Write proxy for field `SBSIZE`"]
pub struct SBSIZE_W<'a> {
    w: &'a mut W,
}
impl<'a> SBSIZE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SBSIZE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Source burst size = 1"]
    #[inline(always)]
    pub fn source_burst_1(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_1)
    }
    #[doc = "Source burst size = 4"]
    #[inline(always)]
    pub fn source_burst_4(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_4)
    }
    #[doc = "Source burst size = 8"]
    #[inline(always)]
    pub fn source_burst_8(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_8)
    }
    #[doc = "Source burst size = 16"]
    #[inline(always)]
    pub fn source_burst_16(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_16)
    }
    #[doc = "Source burst size = 32"]
    #[inline(always)]
    pub fn source_burst_32(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_32)
    }
    #[doc = "Source burst size = 64"]
    #[inline(always)]
    pub fn source_burst_64(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_64)
    }
    #[doc = "Source burst size = 128"]
    #[inline(always)]
    pub fn source_burst_128(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_128)
    }
    #[doc = "Source burst size = 256"]
    #[inline(always)]
    pub fn source_burst_256(self) -> &'a mut W {
        self.variant(SBSIZE_A::SOURCE_BURST_256)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 12)) | (((value as u32) & 0x07) << 12);
        self.w
    }
}
#[doc = "Destination burst size. Indicates the number of transfers that make up a destination burst transfer request. This value must be set to the burst size of the destination peripheral or, if the destination is memory, to the memory boundary size. The burst size is the amount of data that is transferred when the BREQ signal goes active in the destination peripheral.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DBSIZE_A {
    #[doc = "0: Destination burst size = 1"]
    DESTINATION_BURST_1,
    #[doc = "1: Destination burst size = 4"]
    DESTINATION_BURST_4,
    #[doc = "2: Destination burst size = 8"]
    DESTINATION_BURST_8,
    #[doc = "3: Destination burst size = 16"]
    DESTINATION_BURST_16,
    #[doc = "4: Destination burst size = 32"]
    DESTINATION_BURST_32,
    #[doc = "5: Destination burst size = 64"]
    DESTINATION_BURST_64,
    #[doc = "6: Destination burst size = 128"]
    DESTINATION_BURST_128,
    #[doc = "7: Destination burst size = 256"]
    DESTINATION_BURST_256,
}
impl From<DBSIZE_A> for u8 {
    #[inline(always)]
    fn from(variant: DBSIZE_A) -> Self {
        match variant {
            DBSIZE_A::DESTINATION_BURST_1 => 0,
            DBSIZE_A::DESTINATION_BURST_4 => 1,
            DBSIZE_A::DESTINATION_BURST_8 => 2,
            DBSIZE_A::DESTINATION_BURST_16 => 3,
            DBSIZE_A::DESTINATION_BURST_32 => 4,
            DBSIZE_A::DESTINATION_BURST_64 => 5,
            DBSIZE_A::DESTINATION_BURST_128 => 6,
            DBSIZE_A::DESTINATION_BURST_256 => 7,
        }
    }
}
#[doc = "Reader of field `DBSIZE`"]
pub type DBSIZE_R = crate::R<u8, DBSIZE_A>;
impl DBSIZE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DBSIZE_A {
        match self.bits {
            0 => DBSIZE_A::DESTINATION_BURST_1,
            1 => DBSIZE_A::DESTINATION_BURST_4,
            2 => DBSIZE_A::DESTINATION_BURST_8,
            3 => DBSIZE_A::DESTINATION_BURST_16,
            4 => DBSIZE_A::DESTINATION_BURST_32,
            5 => DBSIZE_A::DESTINATION_BURST_64,
            6 => DBSIZE_A::DESTINATION_BURST_128,
            7 => DBSIZE_A::DESTINATION_BURST_256,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_1`"]
    #[inline(always)]
    pub fn is_destination_burst_1(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_1
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_4`"]
    #[inline(always)]
    pub fn is_destination_burst_4(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_4
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_8`"]
    #[inline(always)]
    pub fn is_destination_burst_8(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_8
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_16`"]
    #[inline(always)]
    pub fn is_destination_burst_16(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_16
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_32`"]
    #[inline(always)]
    pub fn is_destination_burst_32(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_32
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_64`"]
    #[inline(always)]
    pub fn is_destination_burst_64(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_64
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_128`"]
    #[inline(always)]
    pub fn is_destination_burst_128(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_128
    }
    #[doc = "Checks if the value of the field is `DESTINATION_BURST_256`"]
    #[inline(always)]
    pub fn is_destination_burst_256(&self) -> bool {
        *self == DBSIZE_A::DESTINATION_BURST_256
    }
}
#[doc = "Write proxy for field `DBSIZE`"]
pub struct DBSIZE_W<'a> {
    w: &'a mut W,
}
impl<'a> DBSIZE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DBSIZE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Destination burst size = 1"]
    #[inline(always)]
    pub fn destination_burst_1(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_1)
    }
    #[doc = "Destination burst size = 4"]
    #[inline(always)]
    pub fn destination_burst_4(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_4)
    }
    #[doc = "Destination burst size = 8"]
    #[inline(always)]
    pub fn destination_burst_8(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_8)
    }
    #[doc = "Destination burst size = 16"]
    #[inline(always)]
    pub fn destination_burst_16(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_16)
    }
    #[doc = "Destination burst size = 32"]
    #[inline(always)]
    pub fn destination_burst_32(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_32)
    }
    #[doc = "Destination burst size = 64"]
    #[inline(always)]
    pub fn destination_burst_64(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_64)
    }
    #[doc = "Destination burst size = 128"]
    #[inline(always)]
    pub fn destination_burst_128(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_128)
    }
    #[doc = "Destination burst size = 256"]
    #[inline(always)]
    pub fn destination_burst_256(self) -> &'a mut W {
        self.variant(DBSIZE_A::DESTINATION_BURST_256)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 15)) | (((value as u32) & 0x07) << 15);
        self.w
    }
}
#[doc = "Source transfer width. Transfers wider than the AHB master bus width are illegal. The source and destination widths can be different from each other. The hardware automatically packs and unpacks the data as required. 0x3 to 0x7 - Reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SWIDTH_A {
    #[doc = "0: Byte (8-bit)"]
    BYTE_8_BIT,
    #[doc = "1: Halfword (16-bit)"]
    HALFWORD_16_BIT,
    #[doc = "2: Word (32-bit)"]
    WORD_32_BIT,
}
impl From<SWIDTH_A> for u8 {
    #[inline(always)]
    fn from(variant: SWIDTH_A) -> Self {
        match variant {
            SWIDTH_A::BYTE_8_BIT => 0,
            SWIDTH_A::HALFWORD_16_BIT => 1,
            SWIDTH_A::WORD_32_BIT => 2,
        }
    }
}
#[doc = "Reader of field `SWIDTH`"]
pub type SWIDTH_R = crate::R<u8, SWIDTH_A>;
impl SWIDTH_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, SWIDTH_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(SWIDTH_A::BYTE_8_BIT),
            1 => Val(SWIDTH_A::HALFWORD_16_BIT),
            2 => Val(SWIDTH_A::WORD_32_BIT),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `BYTE_8_BIT`"]
    #[inline(always)]
    pub fn is_byte_8_bit(&self) -> bool {
        *self == SWIDTH_A::BYTE_8_BIT
    }
    #[doc = "Checks if the value of the field is `HALFWORD_16_BIT`"]
    #[inline(always)]
    pub fn is_halfword_16_bit(&self) -> bool {
        *self == SWIDTH_A::HALFWORD_16_BIT
    }
    #[doc = "Checks if the value of the field is `WORD_32_BIT`"]
    #[inline(always)]
    pub fn is_word_32_bit(&self) -> bool {
        *self == SWIDTH_A::WORD_32_BIT
    }
}
#[doc = "Write proxy for field `SWIDTH`"]
pub struct SWIDTH_W<'a> {
    w: &'a mut W,
}
impl<'a> SWIDTH_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SWIDTH_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Byte (8-bit)"]
    #[inline(always)]
    pub fn byte_8_bit(self) -> &'a mut W {
        self.variant(SWIDTH_A::BYTE_8_BIT)
    }
    #[doc = "Halfword (16-bit)"]
    #[inline(always)]
    pub fn halfword_16_bit(self) -> &'a mut W {
        self.variant(SWIDTH_A::HALFWORD_16_BIT)
    }
    #[doc = "Word (32-bit)"]
    #[inline(always)]
    pub fn word_32_bit(self) -> &'a mut W {
        self.variant(SWIDTH_A::WORD_32_BIT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 18)) | (((value as u32) & 0x07) << 18);
        self.w
    }
}
#[doc = "Destination transfer width. Transfers wider than the AHB master bus width are not supported. The source and destination widths can be different from each other. The hardware automatically packs and unpacks the data as required. 0x3 to 0x7 - Reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DWIDTH_A {
    #[doc = "0: Byte (8-bit)"]
    BYTE_8_BIT,
    #[doc = "1: Halfword (16-bit)"]
    HALFWORD_16_BIT,
    #[doc = "2: Word (32-bit)"]
    WORD_32_BIT,
}
impl From<DWIDTH_A> for u8 {
    #[inline(always)]
    fn from(variant: DWIDTH_A) -> Self {
        match variant {
            DWIDTH_A::BYTE_8_BIT => 0,
            DWIDTH_A::HALFWORD_16_BIT => 1,
            DWIDTH_A::WORD_32_BIT => 2,
        }
    }
}
#[doc = "Reader of field `DWIDTH`"]
pub type DWIDTH_R = crate::R<u8, DWIDTH_A>;
impl DWIDTH_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, DWIDTH_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(DWIDTH_A::BYTE_8_BIT),
            1 => Val(DWIDTH_A::HALFWORD_16_BIT),
            2 => Val(DWIDTH_A::WORD_32_BIT),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `BYTE_8_BIT`"]
    #[inline(always)]
    pub fn is_byte_8_bit(&self) -> bool {
        *self == DWIDTH_A::BYTE_8_BIT
    }
    #[doc = "Checks if the value of the field is `HALFWORD_16_BIT`"]
    #[inline(always)]
    pub fn is_halfword_16_bit(&self) -> bool {
        *self == DWIDTH_A::HALFWORD_16_BIT
    }
    #[doc = "Checks if the value of the field is `WORD_32_BIT`"]
    #[inline(always)]
    pub fn is_word_32_bit(&self) -> bool {
        *self == DWIDTH_A::WORD_32_BIT
    }
}
#[doc = "Write proxy for field `DWIDTH`"]
pub struct DWIDTH_W<'a> {
    w: &'a mut W,
}
impl<'a> DWIDTH_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DWIDTH_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Byte (8-bit)"]
    #[inline(always)]
    pub fn byte_8_bit(self) -> &'a mut W {
        self.variant(DWIDTH_A::BYTE_8_BIT)
    }
    #[doc = "Halfword (16-bit)"]
    #[inline(always)]
    pub fn halfword_16_bit(self) -> &'a mut W {
        self.variant(DWIDTH_A::HALFWORD_16_BIT)
    }
    #[doc = "Word (32-bit)"]
    #[inline(always)]
    pub fn word_32_bit(self) -> &'a mut W {
        self.variant(DWIDTH_A::WORD_32_BIT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 21)) | (((value as u32) & 0x07) << 21);
        self.w
    }
}
#[doc = "Source AHB master select:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum S_A {
    #[doc = "0: AHB Master 0 selected for source transfer."]
    AHB_MASTER_0_SELECTED,
    #[doc = "1: AHB Master 1 selected for source transfer."]
    AHB_MASTER_1_SELECTED,
}
impl From<S_A> for bool {
    #[inline(always)]
    fn from(variant: S_A) -> Self {
        match variant {
            S_A::AHB_MASTER_0_SELECTED => false,
            S_A::AHB_MASTER_1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `S`"]
pub type S_R = crate::R<bool, S_A>;
impl S_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> S_A {
        match self.bits {
            false => S_A::AHB_MASTER_0_SELECTED,
            true => S_A::AHB_MASTER_1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `AHB_MASTER_0_SELECTED`"]
    #[inline(always)]
    pub fn is_ahb_master_0_selected(&self) -> bool {
        *self == S_A::AHB_MASTER_0_SELECTED
    }
    #[doc = "Checks if the value of the field is `AHB_MASTER_1_SELECTED`"]
    #[inline(always)]
    pub fn is_ahb_master_1_selected(&self) -> bool {
        *self == S_A::AHB_MASTER_1_SELECTED
    }
}
#[doc = "Write proxy for field `S`"]
pub struct S_W<'a> {
    w: &'a mut W,
}
impl<'a> S_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: S_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "AHB Master 0 selected for source transfer."]
    #[inline(always)]
    pub fn ahb_master_0_selected(self) -> &'a mut W {
        self.variant(S_A::AHB_MASTER_0_SELECTED)
    }
    #[doc = "AHB Master 1 selected for source transfer."]
    #[inline(always)]
    pub fn ahb_master_1_selected(self) -> &'a mut W {
        self.variant(S_A::AHB_MASTER_1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | (((value as u32) & 0x01) << 24);
        self.w
    }
}
#[doc = "Destination AHB master select: Only Master1 can access a peripheral. Master0 can only access memory.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum D_A {
    #[doc = "0: AHB Master 0 selected for destination transfer."]
    AHB_MASTER_0_SELECTED,
    #[doc = "1: AHB Master 1 selected for destination transfer."]
    AHB_MASTER_1_SELECTED,
}
impl From<D_A> for bool {
    #[inline(always)]
    fn from(variant: D_A) -> Self {
        match variant {
            D_A::AHB_MASTER_0_SELECTED => false,
            D_A::AHB_MASTER_1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `D`"]
pub type D_R = crate::R<bool, D_A>;
impl D_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> D_A {
        match self.bits {
            false => D_A::AHB_MASTER_0_SELECTED,
            true => D_A::AHB_MASTER_1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `AHB_MASTER_0_SELECTED`"]
    #[inline(always)]
    pub fn is_ahb_master_0_selected(&self) -> bool {
        *self == D_A::AHB_MASTER_0_SELECTED
    }
    #[doc = "Checks if the value of the field is `AHB_MASTER_1_SELECTED`"]
    #[inline(always)]
    pub fn is_ahb_master_1_selected(&self) -> bool {
        *self == D_A::AHB_MASTER_1_SELECTED
    }
}
#[doc = "Write proxy for field `D`"]
pub struct D_W<'a> {
    w: &'a mut W,
}
impl<'a> D_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: D_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "AHB Master 0 selected for destination transfer."]
    #[inline(always)]
    pub fn ahb_master_0_selected(self) -> &'a mut W {
        self.variant(D_A::AHB_MASTER_0_SELECTED)
    }
    #[doc = "AHB Master 1 selected for destination transfer."]
    #[inline(always)]
    pub fn ahb_master_1_selected(self) -> &'a mut W {
        self.variant(D_A::AHB_MASTER_1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 25)) | (((value as u32) & 0x01) << 25);
        self.w
    }
}
#[doc = "Source increment:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SI_A {
    #[doc = "0: The source address is not incremented after each transfer."]
    NOT_INCREMENT,
    #[doc = "1: The source address is incremented after each transfer."]
    INCREMENT,
}
impl From<SI_A> for bool {
    #[inline(always)]
    fn from(variant: SI_A) -> Self {
        match variant {
            SI_A::NOT_INCREMENT => false,
            SI_A::INCREMENT => true,
        }
    }
}
#[doc = "Reader of field `SI`"]
pub type SI_R = crate::R<bool, SI_A>;
impl SI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SI_A {
        match self.bits {
            false => SI_A::NOT_INCREMENT,
            true => SI_A::INCREMENT,
        }
    }
    #[doc = "Checks if the value of the field is `NOT_INCREMENT`"]
    #[inline(always)]
    pub fn is_not_increment(&self) -> bool {
        *self == SI_A::NOT_INCREMENT
    }
    #[doc = "Checks if the value of the field is `INCREMENT`"]
    #[inline(always)]
    pub fn is_increment(&self) -> bool {
        *self == SI_A::INCREMENT
    }
}
#[doc = "Write proxy for field `SI`"]
pub struct SI_W<'a> {
    w: &'a mut W,
}
impl<'a> SI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The source address is not incremented after each transfer."]
    #[inline(always)]
    pub fn not_increment(self) -> &'a mut W {
        self.variant(SI_A::NOT_INCREMENT)
    }
    #[doc = "The source address is incremented after each transfer."]
    #[inline(always)]
    pub fn increment(self) -> &'a mut W {
        self.variant(SI_A::INCREMENT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 26)) | (((value as u32) & 0x01) << 26);
        self.w
    }
}
#[doc = "Destination increment:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DI_A {
    #[doc = "0: The destination address is not incremented after each transfer."]
    THE_DESTINATION_ADDR_IS_NOT_INCREMENTED,
    #[doc = "1: The destination address is incremented after each transfer."]
    THE_DESTINATION_ADDR_IS_INCREMENTED,
}
impl From<DI_A> for bool {
    #[inline(always)]
    fn from(variant: DI_A) -> Self {
        match variant {
            DI_A::THE_DESTINATION_ADDR_IS_NOT_INCREMENTED => false,
            DI_A::THE_DESTINATION_ADDR_IS_INCREMENTED => true,
        }
    }
}
#[doc = "Reader of field `DI`"]
pub type DI_R = crate::R<bool, DI_A>;
impl DI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DI_A {
        match self.bits {
            false => DI_A::THE_DESTINATION_ADDR_IS_NOT_INCREMENTED,
            true => DI_A::THE_DESTINATION_ADDR_IS_INCREMENTED,
        }
    }
    #[doc = "Checks if the value of the field is `THE_DESTINATION_ADDR_IS_NOT_INCREMENTED`"]
    #[inline(always)]
    pub fn is_the_destination_addr_is_not_incremented(&self) -> bool {
        *self == DI_A::THE_DESTINATION_ADDR_IS_NOT_INCREMENTED
    }
    #[doc = "Checks if the value of the field is `THE_DESTINATION_ADDR_IS_INCREMENTED`"]
    #[inline(always)]
    pub fn is_the_destination_addr_is_incremented(&self) -> bool {
        *self == DI_A::THE_DESTINATION_ADDR_IS_INCREMENTED
    }
}
#[doc = "Write proxy for field `DI`"]
pub struct DI_W<'a> {
    w: &'a mut W,
}
impl<'a> DI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The destination address is not incremented after each transfer."]
    #[inline(always)]
    pub fn the_destination_addr_is_not_incremented(self) -> &'a mut W {
        self.variant(DI_A::THE_DESTINATION_ADDR_IS_NOT_INCREMENTED)
    }
    #[doc = "The destination address is incremented after each transfer."]
    #[inline(always)]
    pub fn the_destination_addr_is_incremented(self) -> &'a mut W {
        self.variant(DI_A::THE_DESTINATION_ADDR_IS_INCREMENTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 27)) | (((value as u32) & 0x01) << 27);
        self.w
    }
}
#[doc = "Indicates that the access is in user mode or privileged mode:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PROT1_A {
    #[doc = "0: Access is in user mode"]
    ACCESS_IS_IN_USER_MODE,
    #[doc = "1: Access is in privileged mode."]
    ACCESS_IS_IN_PRIVILEGED_MODE,
}
impl From<PROT1_A> for bool {
    #[inline(always)]
    fn from(variant: PROT1_A) -> Self {
        match variant {
            PROT1_A::ACCESS_IS_IN_USER_MODE => false,
            PROT1_A::ACCESS_IS_IN_PRIVILEGED_MODE => true,
        }
    }
}
#[doc = "Reader of field `PROT1`"]
pub type PROT1_R = crate::R<bool, PROT1_A>;
impl PROT1_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PROT1_A {
        match self.bits {
            false => PROT1_A::ACCESS_IS_IN_USER_MODE,
            true => PROT1_A::ACCESS_IS_IN_PRIVILEGED_MODE,
        }
    }
    #[doc = "Checks if the value of the field is `ACCESS_IS_IN_USER_MODE`"]
    #[inline(always)]
    pub fn is_access_is_in_user_mode(&self) -> bool {
        *self == PROT1_A::ACCESS_IS_IN_USER_MODE
    }
    #[doc = "Checks if the value of the field is `ACCESS_IS_IN_PRIVILEGED_MODE`"]
    #[inline(always)]
    pub fn is_access_is_in_privileged_mode(&self) -> bool {
        *self == PROT1_A::ACCESS_IS_IN_PRIVILEGED_MODE
    }
}
#[doc = "Write proxy for field `PROT1`"]
pub struct PROT1_W<'a> {
    w: &'a mut W,
}
impl<'a> PROT1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PROT1_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Access is in user mode"]
    #[inline(always)]
    pub fn access_is_in_user_mode(self) -> &'a mut W {
        self.variant(PROT1_A::ACCESS_IS_IN_USER_MODE)
    }
    #[doc = "Access is in privileged mode."]
    #[inline(always)]
    pub fn access_is_in_privileged_mode(self) -> &'a mut W {
        self.variant(PROT1_A::ACCESS_IS_IN_PRIVILEGED_MODE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 28)) | (((value as u32) & 0x01) << 28);
        self.w
    }
}
#[doc = "Indicates that the access is bufferable or not bufferable:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PROT2_A {
    #[doc = "0: Access is not bufferable."]
    ACCESS_IS_NOT_BUFFERABLE,
    #[doc = "1: Access is bufferable."]
    ACCESS_IS_BUFFERABLE,
}
impl From<PROT2_A> for bool {
    #[inline(always)]
    fn from(variant: PROT2_A) -> Self {
        match variant {
            PROT2_A::ACCESS_IS_NOT_BUFFERABLE => false,
            PROT2_A::ACCESS_IS_BUFFERABLE => true,
        }
    }
}
#[doc = "Reader of field `PROT2`"]
pub type PROT2_R = crate::R<bool, PROT2_A>;
impl PROT2_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PROT2_A {
        match self.bits {
            false => PROT2_A::ACCESS_IS_NOT_BUFFERABLE,
            true => PROT2_A::ACCESS_IS_BUFFERABLE,
        }
    }
    #[doc = "Checks if the value of the field is `ACCESS_IS_NOT_BUFFERABLE`"]
    #[inline(always)]
    pub fn is_access_is_not_bufferable(&self) -> bool {
        *self == PROT2_A::ACCESS_IS_NOT_BUFFERABLE
    }
    #[doc = "Checks if the value of the field is `ACCESS_IS_BUFFERABLE`"]
    #[inline(always)]
    pub fn is_access_is_bufferable(&self) -> bool {
        *self == PROT2_A::ACCESS_IS_BUFFERABLE
    }
}
#[doc = "Write proxy for field `PROT2`"]
pub struct PROT2_W<'a> {
    w: &'a mut W,
}
impl<'a> PROT2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PROT2_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Access is not bufferable."]
    #[inline(always)]
    pub fn access_is_not_bufferable(self) -> &'a mut W {
        self.variant(PROT2_A::ACCESS_IS_NOT_BUFFERABLE)
    }
    #[doc = "Access is bufferable."]
    #[inline(always)]
    pub fn access_is_bufferable(self) -> &'a mut W {
        self.variant(PROT2_A::ACCESS_IS_BUFFERABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 29)) | (((value as u32) & 0x01) << 29);
        self.w
    }
}
#[doc = "Indicates that the access is cacheable or not cacheable:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PROT3_A {
    #[doc = "0: Access is not cacheable."]
    ACCESS_IS_NOT_CACHEABLE,
    #[doc = "1: Access is cacheable."]
    ACCESS_IS_CACHEABLE,
}
impl From<PROT3_A> for bool {
    #[inline(always)]
    fn from(variant: PROT3_A) -> Self {
        match variant {
            PROT3_A::ACCESS_IS_NOT_CACHEABLE => false,
            PROT3_A::ACCESS_IS_CACHEABLE => true,
        }
    }
}
#[doc = "Reader of field `PROT3`"]
pub type PROT3_R = crate::R<bool, PROT3_A>;
impl PROT3_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PROT3_A {
        match self.bits {
            false => PROT3_A::ACCESS_IS_NOT_CACHEABLE,
            true => PROT3_A::ACCESS_IS_CACHEABLE,
        }
    }
    #[doc = "Checks if the value of the field is `ACCESS_IS_NOT_CACHEABLE`"]
    #[inline(always)]
    pub fn is_access_is_not_cacheable(&self) -> bool {
        *self == PROT3_A::ACCESS_IS_NOT_CACHEABLE
    }
    #[doc = "Checks if the value of the field is `ACCESS_IS_CACHEABLE`"]
    #[inline(always)]
    pub fn is_access_is_cacheable(&self) -> bool {
        *self == PROT3_A::ACCESS_IS_CACHEABLE
    }
}
#[doc = "Write proxy for field `PROT3`"]
pub struct PROT3_W<'a> {
    w: &'a mut W,
}
impl<'a> PROT3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PROT3_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Access is not cacheable."]
    #[inline(always)]
    pub fn access_is_not_cacheable(self) -> &'a mut W {
        self.variant(PROT3_A::ACCESS_IS_NOT_CACHEABLE)
    }
    #[doc = "Access is cacheable."]
    #[inline(always)]
    pub fn access_is_cacheable(self) -> &'a mut W {
        self.variant(PROT3_A::ACCESS_IS_CACHEABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 30)) | (((value as u32) & 0x01) << 30);
        self.w
    }
}
#[doc = "Terminal count interrupt enable bit.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I_A {
    #[doc = "0: The terminal count interrupt is disabled."]
    THE_TERMINAL_COUNT_INTERRUPT_IS_DISABLED,
    #[doc = "1: The terminal count interrupt is enabled."]
    THE_TERMINAL_COUNT_INTERRUPT_IS_ENABLED,
}
impl From<I_A> for bool {
    #[inline(always)]
    fn from(variant: I_A) -> Self {
        match variant {
            I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_DISABLED => false,
            I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_ENABLED => true,
        }
    }
}
#[doc = "Reader of field `I`"]
pub type I_R = crate::R<bool, I_A>;
impl I_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> I_A {
        match self.bits {
            false => I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_DISABLED,
            true => I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `THE_TERMINAL_COUNT_INTERRUPT_IS_DISABLED`"]
    #[inline(always)]
    pub fn is_the_terminal_count_interrupt_is_disabled(&self) -> bool {
        *self == I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_DISABLED
    }
    #[doc = "Checks if the value of the field is `THE_TERMINAL_COUNT_INTERRUPT_IS_ENABLED`"]
    #[inline(always)]
    pub fn is_the_terminal_count_interrupt_is_enabled(&self) -> bool {
        *self == I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_ENABLED
    }
}
#[doc = "Write proxy for field `I`"]
pub struct I_W<'a> {
    w: &'a mut W,
}
impl<'a> I_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: I_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The terminal count interrupt is disabled."]
    #[inline(always)]
    pub fn the_terminal_count_interrupt_is_disabled(self) -> &'a mut W {
        self.variant(I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_DISABLED)
    }
    #[doc = "The terminal count interrupt is enabled."]
    #[inline(always)]
    pub fn the_terminal_count_interrupt_is_enabled(self) -> &'a mut W {
        self.variant(I_A::THE_TERMINAL_COUNT_INTERRUPT_IS_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 31)) | (((value as u32) & 0x01) << 31);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:11 - Transfer size in byte. A write to this field sets the size of the transfer when the DMA Controller is the flow controller. The transfer size value must be set before the channel is enabled. Transfer size is updated as data transfers are completed. A read from this field indicates the number of transfers completed on the destination bus. Reading the register when the channel is active does not give useful information because by the time that the software has processed the value read, the channel might have progressed. It is intended to be used only when a channel is enabled and then disabled. The transfer size value is not used if the DMA Controller is not the flow controller."]
    #[inline(always)]
    pub fn transfersize(&self) -> TRANSFERSIZE_R {
        TRANSFERSIZE_R::new((self.bits & 0x0fff) as u16)
    }
    #[doc = "Bits 12:14 - Source burst size. Indicates the number of transfers that make up a source burst. This value must be set to the burst size of the source peripheral, or if the source is memory, to the memory boundary size (see Figure 3). The burst size is the amount of data that is transferred when the BREQ signal goes active in the source peripheral."]
    #[inline(always)]
    pub fn sbsize(&self) -> SBSIZE_R {
        SBSIZE_R::new(((self.bits >> 12) & 0x07) as u8)
    }
    #[doc = "Bits 15:17 - Destination burst size. Indicates the number of transfers that make up a destination burst transfer request. This value must be set to the burst size of the destination peripheral or, if the destination is memory, to the memory boundary size. The burst size is the amount of data that is transferred when the BREQ signal goes active in the destination peripheral."]
    #[inline(always)]
    pub fn dbsize(&self) -> DBSIZE_R {
        DBSIZE_R::new(((self.bits >> 15) & 0x07) as u8)
    }
    #[doc = "Bits 18:20 - Source transfer width. Transfers wider than the AHB master bus width are illegal. The source and destination widths can be different from each other. The hardware automatically packs and unpacks the data as required. 0x3 to 0x7 - Reserved."]
    #[inline(always)]
    pub fn swidth(&self) -> SWIDTH_R {
        SWIDTH_R::new(((self.bits >> 18) & 0x07) as u8)
    }
    #[doc = "Bits 21:23 - Destination transfer width. Transfers wider than the AHB master bus width are not supported. The source and destination widths can be different from each other. The hardware automatically packs and unpacks the data as required. 0x3 to 0x7 - Reserved."]
    #[inline(always)]
    pub fn dwidth(&self) -> DWIDTH_R {
        DWIDTH_R::new(((self.bits >> 21) & 0x07) as u8)
    }
    #[doc = "Bit 24 - Source AHB master select:"]
    #[inline(always)]
    pub fn s(&self) -> S_R {
        S_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bit 25 - Destination AHB master select: Only Master1 can access a peripheral. Master0 can only access memory."]
    #[inline(always)]
    pub fn d(&self) -> D_R {
        D_R::new(((self.bits >> 25) & 0x01) != 0)
    }
    #[doc = "Bit 26 - Source increment:"]
    #[inline(always)]
    pub fn si(&self) -> SI_R {
        SI_R::new(((self.bits >> 26) & 0x01) != 0)
    }
    #[doc = "Bit 27 - Destination increment:"]
    #[inline(always)]
    pub fn di(&self) -> DI_R {
        DI_R::new(((self.bits >> 27) & 0x01) != 0)
    }
    #[doc = "Bit 28 - Indicates that the access is in user mode or privileged mode:"]
    #[inline(always)]
    pub fn prot1(&self) -> PROT1_R {
        PROT1_R::new(((self.bits >> 28) & 0x01) != 0)
    }
    #[doc = "Bit 29 - Indicates that the access is bufferable or not bufferable:"]
    #[inline(always)]
    pub fn prot2(&self) -> PROT2_R {
        PROT2_R::new(((self.bits >> 29) & 0x01) != 0)
    }
    #[doc = "Bit 30 - Indicates that the access is cacheable or not cacheable:"]
    #[inline(always)]
    pub fn prot3(&self) -> PROT3_R {
        PROT3_R::new(((self.bits >> 30) & 0x01) != 0)
    }
    #[doc = "Bit 31 - Terminal count interrupt enable bit."]
    #[inline(always)]
    pub fn i(&self) -> I_R {
        I_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:11 - Transfer size in byte. A write to this field sets the size of the transfer when the DMA Controller is the flow controller. The transfer size value must be set before the channel is enabled. Transfer size is updated as data transfers are completed. A read from this field indicates the number of transfers completed on the destination bus. Reading the register when the channel is active does not give useful information because by the time that the software has processed the value read, the channel might have progressed. It is intended to be used only when a channel is enabled and then disabled. The transfer size value is not used if the DMA Controller is not the flow controller."]
    #[inline(always)]
    pub fn transfersize(&mut self) -> TRANSFERSIZE_W {
        TRANSFERSIZE_W { w: self }
    }
    #[doc = "Bits 12:14 - Source burst size. Indicates the number of transfers that make up a source burst. This value must be set to the burst size of the source peripheral, or if the source is memory, to the memory boundary size (see Figure 3). The burst size is the amount of data that is transferred when the BREQ signal goes active in the source peripheral."]
    #[inline(always)]
    pub fn sbsize(&mut self) -> SBSIZE_W {
        SBSIZE_W { w: self }
    }
    #[doc = "Bits 15:17 - Destination burst size. Indicates the number of transfers that make up a destination burst transfer request. This value must be set to the burst size of the destination peripheral or, if the destination is memory, to the memory boundary size. The burst size is the amount of data that is transferred when the BREQ signal goes active in the destination peripheral."]
    #[inline(always)]
    pub fn dbsize(&mut self) -> DBSIZE_W {
        DBSIZE_W { w: self }
    }
    #[doc = "Bits 18:20 - Source transfer width. Transfers wider than the AHB master bus width are illegal. The source and destination widths can be different from each other. The hardware automatically packs and unpacks the data as required. 0x3 to 0x7 - Reserved."]
    #[inline(always)]
    pub fn swidth(&mut self) -> SWIDTH_W {
        SWIDTH_W { w: self }
    }
    #[doc = "Bits 21:23 - Destination transfer width. Transfers wider than the AHB master bus width are not supported. The source and destination widths can be different from each other. The hardware automatically packs and unpacks the data as required. 0x3 to 0x7 - Reserved."]
    #[inline(always)]
    pub fn dwidth(&mut self) -> DWIDTH_W {
        DWIDTH_W { w: self }
    }
    #[doc = "Bit 24 - Source AHB master select:"]
    #[inline(always)]
    pub fn s(&mut self) -> S_W {
        S_W { w: self }
    }
    #[doc = "Bit 25 - Destination AHB master select: Only Master1 can access a peripheral. Master0 can only access memory."]
    #[inline(always)]
    pub fn d(&mut self) -> D_W {
        D_W { w: self }
    }
    #[doc = "Bit 26 - Source increment:"]
    #[inline(always)]
    pub fn si(&mut self) -> SI_W {
        SI_W { w: self }
    }
    #[doc = "Bit 27 - Destination increment:"]
    #[inline(always)]
    pub fn di(&mut self) -> DI_W {
        DI_W { w: self }
    }
    #[doc = "Bit 28 - Indicates that the access is in user mode or privileged mode:"]
    #[inline(always)]
    pub fn prot1(&mut self) -> PROT1_W {
        PROT1_W { w: self }
    }
    #[doc = "Bit 29 - Indicates that the access is bufferable or not bufferable:"]
    #[inline(always)]
    pub fn prot2(&mut self) -> PROT2_W {
        PROT2_W { w: self }
    }
    #[doc = "Bit 30 - Indicates that the access is cacheable or not cacheable:"]
    #[inline(always)]
    pub fn prot3(&mut self) -> PROT3_W {
        PROT3_W { w: self }
    }
    #[doc = "Bit 31 - Terminal count interrupt enable bit."]
    #[inline(always)]
    pub fn i(&mut self) -> I_W {
        I_W { w: self }
    }
}
