#[doc = "Reader of register C%sLLI"]
pub type R = crate::R<u32, super::CLLI>;
#[doc = "Writer for register C%sLLI"]
pub type W = crate::W<u32, super::CLLI>;
#[doc = "Register C%sLLI `reset()`'s with value 0"]
impl crate::ResetValue for super::CLLI {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "AHB master select for loading the next LLI:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LM_A {
    #[doc = "0: AHB Master 0."]
    AHB_MASTER_0,
    #[doc = "1: AHB Master 1."]
    AHB_MASTER_1,
}
impl From<LM_A> for bool {
    #[inline(always)]
    fn from(variant: LM_A) -> Self {
        match variant {
            LM_A::AHB_MASTER_0 => false,
            LM_A::AHB_MASTER_1 => true,
        }
    }
}
#[doc = "Reader of field `LM`"]
pub type LM_R = crate::R<bool, LM_A>;
impl LM_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> LM_A {
        match self.bits {
            false => LM_A::AHB_MASTER_0,
            true => LM_A::AHB_MASTER_1,
        }
    }
    #[doc = "Checks if the value of the field is `AHB_MASTER_0`"]
    #[inline(always)]
    pub fn is_ahb_master_0(&self) -> bool {
        *self == LM_A::AHB_MASTER_0
    }
    #[doc = "Checks if the value of the field is `AHB_MASTER_1`"]
    #[inline(always)]
    pub fn is_ahb_master_1(&self) -> bool {
        *self == LM_A::AHB_MASTER_1
    }
}
#[doc = "Write proxy for field `LM`"]
pub struct LM_W<'a> {
    w: &'a mut W,
}
impl<'a> LM_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: LM_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "AHB Master 0."]
    #[inline(always)]
    pub fn ahb_master_0(self) -> &'a mut W {
        self.variant(LM_A::AHB_MASTER_0)
    }
    #[doc = "AHB Master 1."]
    #[inline(always)]
    pub fn ahb_master_1(self) -> &'a mut W {
        self.variant(LM_A::AHB_MASTER_1)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Reader of field `R`"]
pub type R_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `R`"]
pub struct R_W<'a> {
    w: &'a mut W,
}
impl<'a> R_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Reader of field `LLI`"]
pub type LLI_R = crate::R<u32, u32>;
#[doc = "Write proxy for field `LLI`"]
pub struct LLI_W<'a> {
    w: &'a mut W,
}
impl<'a> LLI_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x3fff_ffff << 2)) | (((value as u32) & 0x3fff_ffff) << 2);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - AHB master select for loading the next LLI:"]
    #[inline(always)]
    pub fn lm(&self) -> LM_R {
        LM_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Reserved, and must be written as 0, masked on read."]
    #[inline(always)]
    pub fn r(&self) -> R_R {
        R_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bits 2:31 - Linked list item. Bits \\[31:2\\] of the address for the next LLI. Address bits \\[1:0\\] are 0."]
    #[inline(always)]
    pub fn lli(&self) -> LLI_R {
        LLI_R::new(((self.bits >> 2) & 0x3fff_ffff) as u32)
    }
}
impl W {
    #[doc = "Bit 0 - AHB master select for loading the next LLI:"]
    #[inline(always)]
    pub fn lm(&mut self) -> LM_W {
        LM_W { w: self }
    }
    #[doc = "Bit 1 - Reserved, and must be written as 0, masked on read."]
    #[inline(always)]
    pub fn r(&mut self) -> R_W {
        R_W { w: self }
    }
    #[doc = "Bits 2:31 - Linked list item. Bits \\[31:2\\] of the address for the next LLI. Address bits \\[1:0\\] are 0."]
    #[inline(always)]
    pub fn lli(&mut self) -> LLI_W {
        LLI_W { w: self }
    }
}
