#[doc = "Reader of register CONFIG"]
pub type R = crate::R<u32, super::CONFIG>;
#[doc = "Writer for register CONFIG"]
pub type W = crate::W<u32, super::CONFIG>;
#[doc = "Register CONFIG `reset()`'s with value 0"]
impl crate::ResetValue for super::CONFIG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "DMA Controller enable:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum E_A {
    #[doc = "0: Disabled (default). Disabling the DMA Controller reduces power consumption."]
    DISABLED_DEFAULT,
    #[doc = "1: Enabled"]
    ENABLED,
}
impl From<E_A> for bool {
    #[inline(always)]
    fn from(variant: E_A) -> Self {
        match variant {
            E_A::DISABLED_DEFAULT => false,
            E_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `E`"]
pub type E_R = crate::R<bool, E_A>;
impl E_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> E_A {
        match self.bits {
            false => E_A::DISABLED_DEFAULT,
            true => E_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED_DEFAULT`"]
    #[inline(always)]
    pub fn is_disabled_default(&self) -> bool {
        *self == E_A::DISABLED_DEFAULT
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == E_A::ENABLED
    }
}
#[doc = "Write proxy for field `E`"]
pub struct E_W<'a> {
    w: &'a mut W,
}
impl<'a> E_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: E_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled (default). Disabling the DMA Controller reduces power consumption."]
    #[inline(always)]
    pub fn disabled_default(self) -> &'a mut W {
        self.variant(E_A::DISABLED_DEFAULT)
    }
    #[doc = "Enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(E_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "AHB Master 0 endianness configuration:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum M0_A {
    #[doc = "0: Little-endian mode (default)."]
    LITTLE_ENDIAN_MODE,
    #[doc = "1: Big-endian mode."]
    BIG_ENDIAN_MODE,
}
impl From<M0_A> for bool {
    #[inline(always)]
    fn from(variant: M0_A) -> Self {
        match variant {
            M0_A::LITTLE_ENDIAN_MODE => false,
            M0_A::BIG_ENDIAN_MODE => true,
        }
    }
}
#[doc = "Reader of field `M0`"]
pub type M0_R = crate::R<bool, M0_A>;
impl M0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> M0_A {
        match self.bits {
            false => M0_A::LITTLE_ENDIAN_MODE,
            true => M0_A::BIG_ENDIAN_MODE,
        }
    }
    #[doc = "Checks if the value of the field is `LITTLE_ENDIAN_MODE`"]
    #[inline(always)]
    pub fn is_little_endian_mode(&self) -> bool {
        *self == M0_A::LITTLE_ENDIAN_MODE
    }
    #[doc = "Checks if the value of the field is `BIG_ENDIAN_MODE`"]
    #[inline(always)]
    pub fn is_big_endian_mode(&self) -> bool {
        *self == M0_A::BIG_ENDIAN_MODE
    }
}
#[doc = "Write proxy for field `M0`"]
pub struct M0_W<'a> {
    w: &'a mut W,
}
impl<'a> M0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: M0_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Little-endian mode (default)."]
    #[inline(always)]
    pub fn little_endian_mode(self) -> &'a mut W {
        self.variant(M0_A::LITTLE_ENDIAN_MODE)
    }
    #[doc = "Big-endian mode."]
    #[inline(always)]
    pub fn big_endian_mode(self) -> &'a mut W {
        self.variant(M0_A::BIG_ENDIAN_MODE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "AHB Master 1 endianness configuration:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum M1_A {
    #[doc = "0: Little-endian mode (default)."]
    LITTLE_ENDIAN_MODE,
    #[doc = "1: Big-endian mode."]
    BIG_ENDIAN_MODE,
}
impl From<M1_A> for bool {
    #[inline(always)]
    fn from(variant: M1_A) -> Self {
        match variant {
            M1_A::LITTLE_ENDIAN_MODE => false,
            M1_A::BIG_ENDIAN_MODE => true,
        }
    }
}
#[doc = "Reader of field `M1`"]
pub type M1_R = crate::R<bool, M1_A>;
impl M1_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> M1_A {
        match self.bits {
            false => M1_A::LITTLE_ENDIAN_MODE,
            true => M1_A::BIG_ENDIAN_MODE,
        }
    }
    #[doc = "Checks if the value of the field is `LITTLE_ENDIAN_MODE`"]
    #[inline(always)]
    pub fn is_little_endian_mode(&self) -> bool {
        *self == M1_A::LITTLE_ENDIAN_MODE
    }
    #[doc = "Checks if the value of the field is `BIG_ENDIAN_MODE`"]
    #[inline(always)]
    pub fn is_big_endian_mode(&self) -> bool {
        *self == M1_A::BIG_ENDIAN_MODE
    }
}
#[doc = "Write proxy for field `M1`"]
pub struct M1_W<'a> {
    w: &'a mut W,
}
impl<'a> M1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: M1_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Little-endian mode (default)."]
    #[inline(always)]
    pub fn little_endian_mode(self) -> &'a mut W {
        self.variant(M1_A::LITTLE_ENDIAN_MODE)
    }
    #[doc = "Big-endian mode."]
    #[inline(always)]
    pub fn big_endian_mode(self) -> &'a mut W {
        self.variant(M1_A::BIG_ENDIAN_MODE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - DMA Controller enable:"]
    #[inline(always)]
    pub fn e(&self) -> E_R {
        E_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - AHB Master 0 endianness configuration:"]
    #[inline(always)]
    pub fn m0(&self) -> M0_R {
        M0_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - AHB Master 1 endianness configuration:"]
    #[inline(always)]
    pub fn m1(&self) -> M1_R {
        M1_R::new(((self.bits >> 2) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - DMA Controller enable:"]
    #[inline(always)]
    pub fn e(&mut self) -> E_W {
        E_W { w: self }
    }
    #[doc = "Bit 1 - AHB Master 0 endianness configuration:"]
    #[inline(always)]
    pub fn m0(&mut self) -> M0_W {
        M0_W { w: self }
    }
    #[doc = "Bit 2 - AHB Master 1 endianness configuration:"]
    #[inline(always)]
    pub fn m1(&mut self) -> M1_W {
        M1_W { w: self }
    }
}
