#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Byte pin registers port 0 to 5; pins PIOn_0 to PIOn_31"]
    pub b: [B; 256],
    _reserved1: [u8; 3840usize],
    #[doc = "0x1000 - Word pin registers port 0 to 5"]
    pub w: [W; 256],
    _reserved2: [u8; 3072usize],
    #[doc = "0x2000 - Direction registers port m"]
    pub dir: [DIR; 8],
    _reserved3: [u8; 96usize],
    #[doc = "0x2080 - Mask register port m"]
    pub mask: [MASK; 8],
    _reserved4: [u8; 96usize],
    #[doc = "0x2100 - Port pin register port m"]
    pub pin: [PIN; 8],
    _reserved5: [u8; 96usize],
    #[doc = "0x2180 - Masked port register port m"]
    pub mpin: [MPIN; 8],
    _reserved6: [u8; 96usize],
    #[doc = "0x2200 - Write: Set register for port m Read: output bits for port m"]
    pub set: [SET; 8],
    _reserved7: [u8; 96usize],
    #[doc = "0x2280 - Clear port m"]
    pub clr: [CLR; 8],
    _reserved8: [u8; 96usize],
    #[doc = "0x2300 - Toggle port m"]
    pub not: [NOT; 8],
}
#[doc = "Byte pin registers port 0 to 5; pins PIOn_0 to PIOn_31\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [b](b) module"]
pub type B = crate::Reg<u8, _B>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _B;
#[doc = "`read()` method returns [b::R](b::R) reader structure"]
impl crate::Readable for B {}
#[doc = "`write(|w| ..)` method takes [b::W](b::W) writer structure"]
impl crate::Writable for B {}
#[doc = "Byte pin registers port 0 to 5; pins PIOn_0 to PIOn_31"]
pub mod b;
#[doc = "Word pin registers port 0 to 5\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [w](w) module"]
pub type W = crate::Reg<u32, _W>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _W;
#[doc = "`read()` method returns [w::R](w::R) reader structure"]
impl crate::Readable for W {}
#[doc = "`write(|w| ..)` method takes [w::W](w::W) writer structure"]
impl crate::Writable for W {}
#[doc = "Word pin registers port 0 to 5"]
pub mod w;
#[doc = "Direction registers port m\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [dir](dir) module"]
pub type DIR = crate::Reg<u32, _DIR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DIR;
#[doc = "`read()` method returns [dir::R](dir::R) reader structure"]
impl crate::Readable for DIR {}
#[doc = "`write(|w| ..)` method takes [dir::W](dir::W) writer structure"]
impl crate::Writable for DIR {}
#[doc = "Direction registers port m"]
pub mod dir;
#[doc = "Mask register port m\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [mask](mask) module"]
pub type MASK = crate::Reg<u32, _MASK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MASK;
#[doc = "`read()` method returns [mask::R](mask::R) reader structure"]
impl crate::Readable for MASK {}
#[doc = "`write(|w| ..)` method takes [mask::W](mask::W) writer structure"]
impl crate::Writable for MASK {}
#[doc = "Mask register port m"]
pub mod mask;
#[doc = "Port pin register port m\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pin](pin) module"]
pub type PIN = crate::Reg<u32, _PIN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PIN;
#[doc = "`read()` method returns [pin::R](pin::R) reader structure"]
impl crate::Readable for PIN {}
#[doc = "`write(|w| ..)` method takes [pin::W](pin::W) writer structure"]
impl crate::Writable for PIN {}
#[doc = "Port pin register port m"]
pub mod pin;
#[doc = "Masked port register port m\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [mpin](mpin) module"]
pub type MPIN = crate::Reg<u32, _MPIN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MPIN;
#[doc = "`read()` method returns [mpin::R](mpin::R) reader structure"]
impl crate::Readable for MPIN {}
#[doc = "`write(|w| ..)` method takes [mpin::W](mpin::W) writer structure"]
impl crate::Writable for MPIN {}
#[doc = "Masked port register port m"]
pub mod mpin;
#[doc = "Write: Set register for port m Read: output bits for port m\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [set](set) module"]
pub type SET = crate::Reg<u32, _SET>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SET;
#[doc = "`read()` method returns [set::R](set::R) reader structure"]
impl crate::Readable for SET {}
#[doc = "`write(|w| ..)` method takes [set::W](set::W) writer structure"]
impl crate::Writable for SET {}
#[doc = "Write: Set register for port m Read: output bits for port m"]
pub mod set;
#[doc = "Clear port m\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [clr](clr) module"]
pub type CLR = crate::Reg<u32, _CLR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CLR;
#[doc = "`write(|w| ..)` method takes [clr::W](clr::W) writer structure"]
impl crate::Writable for CLR {}
#[doc = "Clear port m"]
pub mod clr;
#[doc = "Toggle port m\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [not](not) module"]
pub type NOT = crate::Reg<u32, _NOT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _NOT;
#[doc = "`write(|w| ..)` method takes [not::W](not::W) writer structure"]
impl crate::Writable for NOT {}
#[doc = "Toggle port m"]
pub mod not;
