#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    _reserved0: [u8; 256usize],
    #[doc = "0x100 - Reset control register 0"]
    pub reset_ctrl0: RESET_CTRL0,
    #[doc = "0x104 - Reset control register 1"]
    pub reset_ctrl1: RESET_CTRL1,
    _reserved2: [u8; 8usize],
    #[doc = "0x110 - Reset status register 0"]
    pub reset_status0: RESET_STATUS0,
    #[doc = "0x114 - Reset status register 1"]
    pub reset_status1: RESET_STATUS1,
    #[doc = "0x118 - Reset status register 2"]
    pub reset_status2: RESET_STATUS2,
    #[doc = "0x11c - Reset status register 3"]
    pub reset_status3: RESET_STATUS3,
    _reserved6: [u8; 48usize],
    #[doc = "0x150 - Reset active status register 0"]
    pub reset_active_status0: RESET_ACTIVE_STATUS0,
    #[doc = "0x154 - Reset active status register 1"]
    pub reset_active_status1: RESET_ACTIVE_STATUS1,
    _reserved8: [u8; 684usize],
    #[doc = "0x404 - Reset external status register 1 for PERIPH_RST"]
    pub reset_ext_stat1: RESET_EXT_STAT1,
    #[doc = "0x408 - Reset external status register 2 for MASTER_RST"]
    pub reset_ext_stat2: RESET_EXT_STAT2,
    _reserved10: [u8; 8usize],
    #[doc = "0x414 - Reset external status register 5 for CREG_RST"]
    pub reset_ext_stat5: RESET_EXT_STAT5,
    _reserved11: [u8; 8usize],
    #[doc = "0x420 - Reset external status register"]
    pub reset_ext_stat8: RESET_EXT_STAT8,
    #[doc = "0x424 - Reset external status register"]
    pub reset_ext_stat9: RESET_EXT_STAT9,
    _reserved13: [u8; 8usize],
    #[doc = "0x430 - Reset external status register"]
    pub reset_ext_stat12: RESET_EXT_STAT12,
    #[doc = "0x434 - Reset external status register"]
    pub reset_ext_stat13: RESET_EXT_STAT13,
    _reserved15: [u8; 8usize],
    #[doc = "0x440 - Reset external status register"]
    pub reset_ext_stat16: RESET_EXT_STAT16,
    #[doc = "0x444 - Reset external status register"]
    pub reset_ext_stat17: RESET_EXT_STAT17,
    #[doc = "0x448 - Reset external status register"]
    pub reset_ext_stat18: RESET_EXT_STAT18,
    #[doc = "0x44c - Reset external status register"]
    pub reset_ext_stat19: RESET_EXT_STAT19,
    #[doc = "0x450 - Reset external status register"]
    pub reset_ext_stat20: RESET_EXT_STAT20,
    #[doc = "0x454 - Reset external status register"]
    pub reset_ext_stat21: RESET_EXT_STAT21,
    #[doc = "0x458 - Reset external status register"]
    pub reset_ext_stat22: RESET_EXT_STAT22,
    _reserved22: [u8; 8usize],
    #[doc = "0x464 - Reset external status register"]
    pub reset_ext_stat25: RESET_EXT_STAT25,
    _reserved23: [u8; 4usize],
    #[doc = "0x46c - Reset external status register"]
    pub reset_ext_stat27: RESET_EXT_STAT27,
    #[doc = "0x470 - Reset external status register"]
    pub reset_ext_stat28: RESET_EXT_STAT28,
    #[doc = "0x474 - Reset external status register"]
    pub reset_ext_stat29: RESET_EXT_STAT29,
    _reserved26: [u8; 8usize],
    #[doc = "0x480 - Reset external status register"]
    pub reset_ext_stat32: RESET_EXT_STAT32,
    #[doc = "0x484 - Reset external status register"]
    pub reset_ext_stat33: RESET_EXT_STAT33,
    #[doc = "0x488 - Reset external status register"]
    pub reset_ext_stat34: RESET_EXT_STAT34,
    #[doc = "0x48c - Reset external status register"]
    pub reset_ext_stat35: RESET_EXT_STAT35,
    #[doc = "0x490 - Reset external status register"]
    pub reset_ext_stat36: RESET_EXT_STAT36,
    #[doc = "0x494 - Reset external status register"]
    pub reset_ext_stat37: RESET_EXT_STAT37,
    #[doc = "0x498 - Reset external status register"]
    pub reset_ext_stat38: RESET_EXT_STAT38,
    #[doc = "0x49c - Reset external status register"]
    pub reset_ext_stat39: RESET_EXT_STAT39,
    #[doc = "0x4a0 - Reset external status register"]
    pub reset_ext_stat40: RESET_EXT_STAT40,
    #[doc = "0x4a4 - Reset external status register"]
    pub reset_ext_stat41: RESET_EXT_STAT41,
    #[doc = "0x4a8 - Reset external status register"]
    pub reset_ext_stat42: RESET_EXT_STAT42,
    _reserved37: [u8; 4usize],
    #[doc = "0x4b0 - Reset external status register"]
    pub reset_ext_stat44: RESET_EXT_STAT44,
    #[doc = "0x4b4 - Reset external status register"]
    pub reset_ext_stat45: RESET_EXT_STAT45,
    #[doc = "0x4b8 - Reset external status register"]
    pub reset_ext_stat46: RESET_EXT_STAT46,
    #[doc = "0x4bc - Reset external status register"]
    pub reset_ext_stat47: RESET_EXT_STAT47,
    #[doc = "0x4c0 - Reset external status register"]
    pub reset_ext_stat48: RESET_EXT_STAT48,
    #[doc = "0x4c4 - Reset external status register"]
    pub reset_ext_stat49: RESET_EXT_STAT49,
    #[doc = "0x4c8 - Reset external status register"]
    pub reset_ext_stat50: RESET_EXT_STAT50,
    #[doc = "0x4cc - Reset external status register"]
    pub reset_ext_stat51: RESET_EXT_STAT51,
    #[doc = "0x4d0 - Reset external status register"]
    pub reset_ext_stat52: RESET_EXT_STAT52,
    #[doc = "0x4d4 - Reset external status register"]
    pub reset_ext_stat53: RESET_EXT_STAT53,
    #[doc = "0x4d8 - Reset external status register"]
    pub reset_ext_stat54: RESET_EXT_STAT54,
    #[doc = "0x4dc - Reset external status register"]
    pub reset_ext_stat55: RESET_EXT_STAT55,
    #[doc = "0x4e0 - Reset external status register"]
    pub reset_ext_stat56: RESET_EXT_STAT56,
    #[doc = "0x4e4 - Reset external status register"]
    pub reset_ext_stat57: RESET_EXT_STAT57,
    #[doc = "0x4e8 - Reset external status register"]
    pub reset_ext_stat58: RESET_EXT_STAT58,
    _reserved52: [u8; 4usize],
    #[doc = "0x4f0 - Reset external status register"]
    pub reset_ext_stat60: RESET_EXT_STAT60,
}
#[doc = "Reset control register 0\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ctrl0](reset_ctrl0) module"]
pub type RESET_CTRL0 = crate::Reg<u32, _RESET_CTRL0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_CTRL0;
#[doc = "`write(|w| ..)` method takes [reset_ctrl0::W](reset_ctrl0::W) writer structure"]
impl crate::Writable for RESET_CTRL0 {}
#[doc = "Reset control register 0"]
pub mod reset_ctrl0;
#[doc = "Reset control register 1\n\nThis register you can [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ctrl1](reset_ctrl1) module"]
pub type RESET_CTRL1 = crate::Reg<u32, _RESET_CTRL1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_CTRL1;
#[doc = "`write(|w| ..)` method takes [reset_ctrl1::W](reset_ctrl1::W) writer structure"]
impl crate::Writable for RESET_CTRL1 {}
#[doc = "Reset control register 1"]
pub mod reset_ctrl1;
#[doc = "Reset status register 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_status0](reset_status0) module"]
pub type RESET_STATUS0 = crate::Reg<u32, _RESET_STATUS0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_STATUS0;
#[doc = "`read()` method returns [reset_status0::R](reset_status0::R) reader structure"]
impl crate::Readable for RESET_STATUS0 {}
#[doc = "`write(|w| ..)` method takes [reset_status0::W](reset_status0::W) writer structure"]
impl crate::Writable for RESET_STATUS0 {}
#[doc = "Reset status register 0"]
pub mod reset_status0;
#[doc = "Reset status register 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_status1](reset_status1) module"]
pub type RESET_STATUS1 = crate::Reg<u32, _RESET_STATUS1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_STATUS1;
#[doc = "`read()` method returns [reset_status1::R](reset_status1::R) reader structure"]
impl crate::Readable for RESET_STATUS1 {}
#[doc = "`write(|w| ..)` method takes [reset_status1::W](reset_status1::W) writer structure"]
impl crate::Writable for RESET_STATUS1 {}
#[doc = "Reset status register 1"]
pub mod reset_status1;
#[doc = "Reset status register 2\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_status2](reset_status2) module"]
pub type RESET_STATUS2 = crate::Reg<u32, _RESET_STATUS2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_STATUS2;
#[doc = "`read()` method returns [reset_status2::R](reset_status2::R) reader structure"]
impl crate::Readable for RESET_STATUS2 {}
#[doc = "`write(|w| ..)` method takes [reset_status2::W](reset_status2::W) writer structure"]
impl crate::Writable for RESET_STATUS2 {}
#[doc = "Reset status register 2"]
pub mod reset_status2;
#[doc = "Reset status register 3\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_status3](reset_status3) module"]
pub type RESET_STATUS3 = crate::Reg<u32, _RESET_STATUS3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_STATUS3;
#[doc = "`read()` method returns [reset_status3::R](reset_status3::R) reader structure"]
impl crate::Readable for RESET_STATUS3 {}
#[doc = "`write(|w| ..)` method takes [reset_status3::W](reset_status3::W) writer structure"]
impl crate::Writable for RESET_STATUS3 {}
#[doc = "Reset status register 3"]
pub mod reset_status3;
#[doc = "Reset active status register 0\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_active_status0](reset_active_status0) module"]
pub type RESET_ACTIVE_STATUS0 = crate::Reg<u32, _RESET_ACTIVE_STATUS0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_ACTIVE_STATUS0;
#[doc = "`read()` method returns [reset_active_status0::R](reset_active_status0::R) reader structure"]
impl crate::Readable for RESET_ACTIVE_STATUS0 {}
#[doc = "Reset active status register 0"]
pub mod reset_active_status0;
#[doc = "Reset active status register 1\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_active_status1](reset_active_status1) module"]
pub type RESET_ACTIVE_STATUS1 = crate::Reg<u32, _RESET_ACTIVE_STATUS1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_ACTIVE_STATUS1;
#[doc = "`read()` method returns [reset_active_status1::R](reset_active_status1::R) reader structure"]
impl crate::Readable for RESET_ACTIVE_STATUS1 {}
#[doc = "Reset active status register 1"]
pub mod reset_active_status1;
#[doc = "Reset external status register 1 for PERIPH_RST\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat1](reset_ext_stat1) module"]
pub type RESET_EXT_STAT1 = crate::Reg<u32, _RESET_EXT_STAT1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT1;
#[doc = "`read()` method returns [reset_ext_stat1::R](reset_ext_stat1::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT1 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat1::W](reset_ext_stat1::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT1 {}
#[doc = "Reset external status register 1 for PERIPH_RST"]
pub mod reset_ext_stat1;
#[doc = "Reset external status register 2 for MASTER_RST\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat2](reset_ext_stat2) module"]
pub type RESET_EXT_STAT2 = crate::Reg<u32, _RESET_EXT_STAT2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT2;
#[doc = "`read()` method returns [reset_ext_stat2::R](reset_ext_stat2::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT2 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat2::W](reset_ext_stat2::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT2 {}
#[doc = "Reset external status register 2 for MASTER_RST"]
pub mod reset_ext_stat2;
#[doc = "Reset external status register 5 for CREG_RST\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat5](reset_ext_stat5) module"]
pub type RESET_EXT_STAT5 = crate::Reg<u32, _RESET_EXT_STAT5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT5;
#[doc = "`read()` method returns [reset_ext_stat5::R](reset_ext_stat5::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT5 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat5::W](reset_ext_stat5::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT5 {}
#[doc = "Reset external status register 5 for CREG_RST"]
pub mod reset_ext_stat5;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat8](reset_ext_stat8) module"]
pub type RESET_EXT_STAT8 = crate::Reg<u32, _RESET_EXT_STAT8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT8;
#[doc = "`read()` method returns [reset_ext_stat8::R](reset_ext_stat8::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT8 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat8::W](reset_ext_stat8::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT8 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat8;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat9](reset_ext_stat9) module"]
pub type RESET_EXT_STAT9 = crate::Reg<u32, _RESET_EXT_STAT9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT9;
#[doc = "`read()` method returns [reset_ext_stat9::R](reset_ext_stat9::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT9 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat9::W](reset_ext_stat9::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT9 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat9;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat12](reset_ext_stat12) module"]
pub type RESET_EXT_STAT12 = crate::Reg<u32, _RESET_EXT_STAT12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT12;
#[doc = "`read()` method returns [reset_ext_stat12::R](reset_ext_stat12::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT12 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat12::W](reset_ext_stat12::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT12 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat12;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat13](reset_ext_stat13) module"]
pub type RESET_EXT_STAT13 = crate::Reg<u32, _RESET_EXT_STAT13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT13;
#[doc = "`read()` method returns [reset_ext_stat13::R](reset_ext_stat13::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT13 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat13::W](reset_ext_stat13::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT13 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat13;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat16](reset_ext_stat16) module"]
pub type RESET_EXT_STAT16 = crate::Reg<u32, _RESET_EXT_STAT16>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT16;
#[doc = "`read()` method returns [reset_ext_stat16::R](reset_ext_stat16::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT16 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat16::W](reset_ext_stat16::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT16 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat16;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat17](reset_ext_stat17) module"]
pub type RESET_EXT_STAT17 = crate::Reg<u32, _RESET_EXT_STAT17>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT17;
#[doc = "`read()` method returns [reset_ext_stat17::R](reset_ext_stat17::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT17 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat17::W](reset_ext_stat17::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT17 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat17;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat18](reset_ext_stat18) module"]
pub type RESET_EXT_STAT18 = crate::Reg<u32, _RESET_EXT_STAT18>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT18;
#[doc = "`read()` method returns [reset_ext_stat18::R](reset_ext_stat18::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT18 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat18::W](reset_ext_stat18::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT18 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat18;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat19](reset_ext_stat19) module"]
pub type RESET_EXT_STAT19 = crate::Reg<u32, _RESET_EXT_STAT19>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT19;
#[doc = "`read()` method returns [reset_ext_stat19::R](reset_ext_stat19::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT19 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat19::W](reset_ext_stat19::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT19 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat19;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat20](reset_ext_stat20) module"]
pub type RESET_EXT_STAT20 = crate::Reg<u32, _RESET_EXT_STAT20>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT20;
#[doc = "`read()` method returns [reset_ext_stat20::R](reset_ext_stat20::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT20 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat20::W](reset_ext_stat20::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT20 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat20;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat21](reset_ext_stat21) module"]
pub type RESET_EXT_STAT21 = crate::Reg<u32, _RESET_EXT_STAT21>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT21;
#[doc = "`read()` method returns [reset_ext_stat21::R](reset_ext_stat21::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT21 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat21::W](reset_ext_stat21::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT21 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat21;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat22](reset_ext_stat22) module"]
pub type RESET_EXT_STAT22 = crate::Reg<u32, _RESET_EXT_STAT22>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT22;
#[doc = "`read()` method returns [reset_ext_stat22::R](reset_ext_stat22::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT22 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat22::W](reset_ext_stat22::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT22 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat22;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat25](reset_ext_stat25) module"]
pub type RESET_EXT_STAT25 = crate::Reg<u32, _RESET_EXT_STAT25>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT25;
#[doc = "`read()` method returns [reset_ext_stat25::R](reset_ext_stat25::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT25 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat25::W](reset_ext_stat25::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT25 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat25;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat27](reset_ext_stat27) module"]
pub type RESET_EXT_STAT27 = crate::Reg<u32, _RESET_EXT_STAT27>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT27;
#[doc = "`read()` method returns [reset_ext_stat27::R](reset_ext_stat27::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT27 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat27::W](reset_ext_stat27::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT27 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat27;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat28](reset_ext_stat28) module"]
pub type RESET_EXT_STAT28 = crate::Reg<u32, _RESET_EXT_STAT28>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT28;
#[doc = "`read()` method returns [reset_ext_stat28::R](reset_ext_stat28::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT28 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat28::W](reset_ext_stat28::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT28 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat28;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat29](reset_ext_stat29) module"]
pub type RESET_EXT_STAT29 = crate::Reg<u32, _RESET_EXT_STAT29>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT29;
#[doc = "`read()` method returns [reset_ext_stat29::R](reset_ext_stat29::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT29 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat29::W](reset_ext_stat29::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT29 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat29;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat32](reset_ext_stat32) module"]
pub type RESET_EXT_STAT32 = crate::Reg<u32, _RESET_EXT_STAT32>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT32;
#[doc = "`read()` method returns [reset_ext_stat32::R](reset_ext_stat32::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT32 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat32::W](reset_ext_stat32::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT32 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat32;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat33](reset_ext_stat33) module"]
pub type RESET_EXT_STAT33 = crate::Reg<u32, _RESET_EXT_STAT33>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT33;
#[doc = "`read()` method returns [reset_ext_stat33::R](reset_ext_stat33::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT33 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat33::W](reset_ext_stat33::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT33 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat33;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat34](reset_ext_stat34) module"]
pub type RESET_EXT_STAT34 = crate::Reg<u32, _RESET_EXT_STAT34>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT34;
#[doc = "`read()` method returns [reset_ext_stat34::R](reset_ext_stat34::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT34 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat34::W](reset_ext_stat34::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT34 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat34;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat35](reset_ext_stat35) module"]
pub type RESET_EXT_STAT35 = crate::Reg<u32, _RESET_EXT_STAT35>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT35;
#[doc = "`read()` method returns [reset_ext_stat35::R](reset_ext_stat35::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT35 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat35::W](reset_ext_stat35::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT35 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat35;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat36](reset_ext_stat36) module"]
pub type RESET_EXT_STAT36 = crate::Reg<u32, _RESET_EXT_STAT36>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT36;
#[doc = "`read()` method returns [reset_ext_stat36::R](reset_ext_stat36::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT36 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat36::W](reset_ext_stat36::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT36 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat36;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat37](reset_ext_stat37) module"]
pub type RESET_EXT_STAT37 = crate::Reg<u32, _RESET_EXT_STAT37>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT37;
#[doc = "`read()` method returns [reset_ext_stat37::R](reset_ext_stat37::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT37 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat37::W](reset_ext_stat37::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT37 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat37;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat38](reset_ext_stat38) module"]
pub type RESET_EXT_STAT38 = crate::Reg<u32, _RESET_EXT_STAT38>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT38;
#[doc = "`read()` method returns [reset_ext_stat38::R](reset_ext_stat38::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT38 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat38::W](reset_ext_stat38::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT38 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat38;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat39](reset_ext_stat39) module"]
pub type RESET_EXT_STAT39 = crate::Reg<u32, _RESET_EXT_STAT39>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT39;
#[doc = "`read()` method returns [reset_ext_stat39::R](reset_ext_stat39::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT39 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat39::W](reset_ext_stat39::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT39 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat39;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat40](reset_ext_stat40) module"]
pub type RESET_EXT_STAT40 = crate::Reg<u32, _RESET_EXT_STAT40>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT40;
#[doc = "`read()` method returns [reset_ext_stat40::R](reset_ext_stat40::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT40 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat40::W](reset_ext_stat40::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT40 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat40;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat41](reset_ext_stat41) module"]
pub type RESET_EXT_STAT41 = crate::Reg<u32, _RESET_EXT_STAT41>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT41;
#[doc = "`read()` method returns [reset_ext_stat41::R](reset_ext_stat41::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT41 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat41::W](reset_ext_stat41::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT41 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat41;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat42](reset_ext_stat42) module"]
pub type RESET_EXT_STAT42 = crate::Reg<u32, _RESET_EXT_STAT42>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT42;
#[doc = "`read()` method returns [reset_ext_stat42::R](reset_ext_stat42::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT42 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat42::W](reset_ext_stat42::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT42 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat42;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat44](reset_ext_stat44) module"]
pub type RESET_EXT_STAT44 = crate::Reg<u32, _RESET_EXT_STAT44>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT44;
#[doc = "`read()` method returns [reset_ext_stat44::R](reset_ext_stat44::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT44 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat44::W](reset_ext_stat44::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT44 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat44;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat45](reset_ext_stat45) module"]
pub type RESET_EXT_STAT45 = crate::Reg<u32, _RESET_EXT_STAT45>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT45;
#[doc = "`read()` method returns [reset_ext_stat45::R](reset_ext_stat45::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT45 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat45::W](reset_ext_stat45::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT45 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat45;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat46](reset_ext_stat46) module"]
pub type RESET_EXT_STAT46 = crate::Reg<u32, _RESET_EXT_STAT46>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT46;
#[doc = "`read()` method returns [reset_ext_stat46::R](reset_ext_stat46::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT46 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat46::W](reset_ext_stat46::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT46 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat46;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat47](reset_ext_stat47) module"]
pub type RESET_EXT_STAT47 = crate::Reg<u32, _RESET_EXT_STAT47>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT47;
#[doc = "`read()` method returns [reset_ext_stat47::R](reset_ext_stat47::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT47 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat47::W](reset_ext_stat47::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT47 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat47;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat48](reset_ext_stat48) module"]
pub type RESET_EXT_STAT48 = crate::Reg<u32, _RESET_EXT_STAT48>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT48;
#[doc = "`read()` method returns [reset_ext_stat48::R](reset_ext_stat48::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT48 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat48::W](reset_ext_stat48::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT48 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat48;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat49](reset_ext_stat49) module"]
pub type RESET_EXT_STAT49 = crate::Reg<u32, _RESET_EXT_STAT49>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT49;
#[doc = "`read()` method returns [reset_ext_stat49::R](reset_ext_stat49::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT49 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat49::W](reset_ext_stat49::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT49 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat49;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat50](reset_ext_stat50) module"]
pub type RESET_EXT_STAT50 = crate::Reg<u32, _RESET_EXT_STAT50>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT50;
#[doc = "`read()` method returns [reset_ext_stat50::R](reset_ext_stat50::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT50 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat50::W](reset_ext_stat50::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT50 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat50;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat51](reset_ext_stat51) module"]
pub type RESET_EXT_STAT51 = crate::Reg<u32, _RESET_EXT_STAT51>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT51;
#[doc = "`read()` method returns [reset_ext_stat51::R](reset_ext_stat51::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT51 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat51::W](reset_ext_stat51::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT51 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat51;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat52](reset_ext_stat52) module"]
pub type RESET_EXT_STAT52 = crate::Reg<u32, _RESET_EXT_STAT52>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT52;
#[doc = "`read()` method returns [reset_ext_stat52::R](reset_ext_stat52::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT52 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat52::W](reset_ext_stat52::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT52 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat52;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat53](reset_ext_stat53) module"]
pub type RESET_EXT_STAT53 = crate::Reg<u32, _RESET_EXT_STAT53>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT53;
#[doc = "`read()` method returns [reset_ext_stat53::R](reset_ext_stat53::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT53 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat53::W](reset_ext_stat53::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT53 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat53;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat54](reset_ext_stat54) module"]
pub type RESET_EXT_STAT54 = crate::Reg<u32, _RESET_EXT_STAT54>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT54;
#[doc = "`read()` method returns [reset_ext_stat54::R](reset_ext_stat54::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT54 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat54::W](reset_ext_stat54::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT54 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat54;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat55](reset_ext_stat55) module"]
pub type RESET_EXT_STAT55 = crate::Reg<u32, _RESET_EXT_STAT55>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT55;
#[doc = "`read()` method returns [reset_ext_stat55::R](reset_ext_stat55::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT55 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat55::W](reset_ext_stat55::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT55 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat55;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat56](reset_ext_stat56) module"]
pub type RESET_EXT_STAT56 = crate::Reg<u32, _RESET_EXT_STAT56>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT56;
#[doc = "`read()` method returns [reset_ext_stat56::R](reset_ext_stat56::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT56 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat56::W](reset_ext_stat56::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT56 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat56;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat57](reset_ext_stat57) module"]
pub type RESET_EXT_STAT57 = crate::Reg<u32, _RESET_EXT_STAT57>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT57;
#[doc = "`read()` method returns [reset_ext_stat57::R](reset_ext_stat57::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT57 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat57::W](reset_ext_stat57::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT57 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat57;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat58](reset_ext_stat58) module"]
pub type RESET_EXT_STAT58 = crate::Reg<u32, _RESET_EXT_STAT58>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT58;
#[doc = "`read()` method returns [reset_ext_stat58::R](reset_ext_stat58::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT58 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat58::W](reset_ext_stat58::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT58 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat58;
#[doc = "Reset external status register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [reset_ext_stat60](reset_ext_stat60) module"]
pub type RESET_EXT_STAT60 = crate::Reg<u32, _RESET_EXT_STAT60>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RESET_EXT_STAT60;
#[doc = "`read()` method returns [reset_ext_stat60::R](reset_ext_stat60::R) reader structure"]
impl crate::Readable for RESET_EXT_STAT60 {}
#[doc = "`write(|w| ..)` method takes [reset_ext_stat60::W](reset_ext_stat60::W) writer structure"]
impl crate::Writable for RESET_EXT_STAT60 {}
#[doc = "Reset external status register"]
pub mod reset_ext_stat60;
