#[doc = "Reader of register RESET_STATUS0"]
pub type R = crate::R<u32, super::RESET_STATUS0>;
#[doc = "Writer for register RESET_STATUS0"]
pub type W = crate::W<u32, super::RESET_STATUS0>;
#[doc = "Register RESET_STATUS0 `reset()`'s with value 0x5555_0050"]
impl crate::ResetValue for super::RESET_STATUS0 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x5555_0050
    }
}
#[doc = "Reader of field `PERIPH_RST`"]
pub type PERIPH_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `PERIPH_RST`"]
pub struct PERIPH_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> PERIPH_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | (((value as u32) & 0x03) << 2);
        self.w
    }
}
#[doc = "Reader of field `MASTER_RST`"]
pub type MASTER_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `MASTER_RST`"]
pub struct MASTER_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> MASTER_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 4)) | (((value as u32) & 0x03) << 4);
        self.w
    }
}
#[doc = "Reader of field `WWDT_RST`"]
pub type WWDT_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `WWDT_RST`"]
pub struct WWDT_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> WWDT_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 8)) | (((value as u32) & 0x03) << 8);
        self.w
    }
}
#[doc = "Reader of field `CREG_RST`"]
pub type CREG_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `CREG_RST`"]
pub struct CREG_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> CREG_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 10)) | (((value as u32) & 0x03) << 10);
        self.w
    }
}
#[doc = "Reader of field `BUS_RST`"]
pub type BUS_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `BUS_RST`"]
pub struct BUS_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> BUS_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 16)) | (((value as u32) & 0x03) << 16);
        self.w
    }
}
#[doc = "Reader of field `SCU_RST`"]
pub type SCU_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `SCU_RST`"]
pub struct SCU_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> SCU_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 18)) | (((value as u32) & 0x03) << 18);
        self.w
    }
}
#[doc = "Reader of field `M0SUB_RST`"]
pub type M0SUB_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `M0SUB_RST`"]
pub struct M0SUB_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> M0SUB_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 24)) | (((value as u32) & 0x03) << 24);
        self.w
    }
}
#[doc = "Reader of field `M4_RST`"]
pub type M4_RST_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `M4_RST`"]
pub struct M4_RST_W<'a> {
    w: &'a mut W,
}
impl<'a> M4_RST_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 26)) | (((value as u32) & 0x03) << 26);
        self.w
    }
}
impl R {
    #[doc = "Bits 2:3 - Status of the PERIPH_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator - this reset is self-clearing 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn periph_rst(&self) -> PERIPH_RST_R {
        PERIPH_RST_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bits 4:5 - Status of the MASTER_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator - this reset is self-clearing 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn master_rst(&self) -> MASTER_RST_R {
        MASTER_RST_R::new(((self.bits >> 4) & 0x03) as u8)
    }
    #[doc = "Bits 8:9 - Status of the WWDT_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reserved"]
    #[inline(always)]
    pub fn wwdt_rst(&self) -> WWDT_RST_R {
        WWDT_RST_R::new(((self.bits >> 8) & 0x03) as u8)
    }
    #[doc = "Bits 10:11 - Status of the CREG_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reserved"]
    #[inline(always)]
    pub fn creg_rst(&self) -> CREG_RST_R {
        CREG_RST_R::new(((self.bits >> 10) & 0x03) as u8)
    }
    #[doc = "Bits 16:17 - Status of the BUS_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn bus_rst(&self) -> BUS_RST_R {
        BUS_RST_R::new(((self.bits >> 16) & 0x03) as u8)
    }
    #[doc = "Bits 18:19 - Status of the SCU_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn scu_rst(&self) -> SCU_RST_R {
        SCU_RST_R::new(((self.bits >> 18) & 0x03) as u8)
    }
    #[doc = "Bits 24:25 - Status of the M0SUB_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn m0sub_rst(&self) -> M0SUB_RST_R {
        M0SUB_RST_R::new(((self.bits >> 24) & 0x03) as u8)
    }
    #[doc = "Bits 26:27 - Status of the M4_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn m4_rst(&self) -> M4_RST_R {
        M4_RST_R::new(((self.bits >> 26) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bits 2:3 - Status of the PERIPH_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator - this reset is self-clearing 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn periph_rst(&mut self) -> PERIPH_RST_W {
        PERIPH_RST_W { w: self }
    }
    #[doc = "Bits 4:5 - Status of the MASTER_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator - this reset is self-clearing 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn master_rst(&mut self) -> MASTER_RST_W {
        MASTER_RST_W { w: self }
    }
    #[doc = "Bits 8:9 - Status of the WWDT_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reserved"]
    #[inline(always)]
    pub fn wwdt_rst(&mut self) -> WWDT_RST_W {
        WWDT_RST_W { w: self }
    }
    #[doc = "Bits 10:11 - Status of the CREG_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reserved"]
    #[inline(always)]
    pub fn creg_rst(&mut self) -> CREG_RST_W {
        CREG_RST_W { w: self }
    }
    #[doc = "Bits 16:17 - Status of the BUS_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn bus_rst(&mut self) -> BUS_RST_W {
        BUS_RST_W { w: self }
    }
    #[doc = "Bits 18:19 - Status of the SCU_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn scu_rst(&mut self) -> SCU_RST_W {
        SCU_RST_W { w: self }
    }
    #[doc = "Bits 24:25 - Status of the M0SUB_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn m0sub_rst(&mut self) -> M0SUB_RST_W {
        M0SUB_RST_W { w: self }
    }
    #[doc = "Bits 26:27 - Status of the M4_RST reset generator output 00 = No reset activated 01 = Reset output activated by input to the reset generator 10 = Reserved 11 = Reset output activated by software write to RESET_CTRL register"]
    #[inline(always)]
    pub fn m4_rst(&mut self) -> M4_RST_W {
        M4_RST_W { w: self }
    }
}
