#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - SCT configuration register"]
    pub config: CONFIG,
    #[doc = "0x04 - SCT control register"]
    pub ctrl: CTRL,
    #[doc = "0x08 - SCT limit register"]
    pub limit: LIMIT,
    #[doc = "0x0c - SCT halt condition register"]
    pub halt: HALT,
    #[doc = "0x10 - SCT stop condition register"]
    pub stop: STOP,
    #[doc = "0x14 - SCT start condition register"]
    pub start: START,
    #[doc = "0x18 - SCT dither condition register"]
    pub dither: DITHER,
    _reserved7: [u8; 36usize],
    #[doc = "0x40 - SCT counter register"]
    pub count: COUNT,
    #[doc = "0x44 - SCT state register"]
    pub state: STATE,
    #[doc = "0x48 - SCT input register"]
    pub input: INPUT,
    #[doc = "0x4c - SCT match/capture registers mode register"]
    pub regmode: REGMODE,
    #[doc = "0x50 - SCT output register"]
    pub output: OUTPUT,
    #[doc = "0x54 - SCT output counter direction control register"]
    pub outputdirctrl: OUTPUTDIRCTRL,
    #[doc = "0x58 - SCT conflict resolution register"]
    pub res: RES,
    #[doc = "0x5c - SCT DMA request 0 register"]
    pub dmareq0: DMAREQ0,
    #[doc = "0x60 - SCT DMA request 1 register"]
    pub dmareq1: DMAREQ1,
    _reserved16: [u8; 140usize],
    #[doc = "0xf0 - SCT event enable register"]
    pub even: EVEN,
    #[doc = "0xf4 - SCT event flag register"]
    pub evflag: EVFLAG,
    #[doc = "0xf8 - SCT conflict enable register"]
    pub conen: CONEN,
    #[doc = "0xfc - SCT conflict flag register"]
    pub conflag: CONFLAG,
    _reserved_20_cap: [u8; 64usize],
    #[doc = "0x140 - Fractional match registers 0 to 5 for SCT match value registers 0 to 5."]
    pub fracmat: [FRACMAT; 6],
    _reserved22: [u8; 168usize],
    _reserved_22_capctrl: [u8; 64usize],
    #[doc = "0x240 - Fractional match reload registers 0 to 5 for SCT match value registers 0 to 5."]
    pub fracmatrel: [FRACMATREL; 6],
    _reserved24: [u8; 168usize],
    #[doc = "0x300 - SCT event state register 0"]
    pub ev0_state: EV_STATE,
    #[doc = "0x304 - SCT event control register 0"]
    pub ev0_ctrl: EV_CTRL,
    #[doc = "0x308 - SCT event state register 0"]
    pub ev1_state: EV_STATE,
    #[doc = "0x30c - SCT event control register 0"]
    pub ev1_ctrl: EV_CTRL,
    #[doc = "0x310 - SCT event state register 0"]
    pub ev2_state: EV_STATE,
    #[doc = "0x314 - SCT event control register 0"]
    pub ev2_ctrl: EV_CTRL,
    #[doc = "0x318 - SCT event state register 0"]
    pub ev3_state: EV_STATE,
    #[doc = "0x31c - SCT event control register 0"]
    pub ev3_ctrl: EV_CTRL,
    #[doc = "0x320 - SCT event state register 0"]
    pub ev4_state: EV_STATE,
    #[doc = "0x324 - SCT event control register 0"]
    pub ev4_ctrl: EV_CTRL,
    #[doc = "0x328 - SCT event state register 0"]
    pub ev5_state: EV_STATE,
    #[doc = "0x32c - SCT event control register 0"]
    pub ev5_ctrl: EV_CTRL,
    #[doc = "0x330 - SCT event state register 0"]
    pub ev6_state: EV_STATE,
    #[doc = "0x334 - SCT event control register 0"]
    pub ev6_ctrl: EV_CTRL,
    #[doc = "0x338 - SCT event state register 0"]
    pub ev7_state: EV_STATE,
    #[doc = "0x33c - SCT event control register 0"]
    pub ev7_ctrl: EV_CTRL,
    #[doc = "0x340 - SCT event state register 0"]
    pub ev8_state: EV_STATE,
    #[doc = "0x344 - SCT event control register 0"]
    pub ev8_ctrl: EV_CTRL,
    #[doc = "0x348 - SCT event state register 0"]
    pub ev9_state: EV_STATE,
    #[doc = "0x34c - SCT event control register 0"]
    pub ev9_ctrl: EV_CTRL,
    #[doc = "0x350 - SCT event state register 0"]
    pub ev10_state: EV_STATE,
    #[doc = "0x354 - SCT event control register 0"]
    pub ev10_ctrl: EV_CTRL,
    #[doc = "0x358 - SCT event state register 0"]
    pub ev11_state: EV_STATE,
    #[doc = "0x35c - SCT event control register 0"]
    pub ev11_ctrl: EV_CTRL,
    #[doc = "0x360 - SCT event state register 0"]
    pub ev12_state: EV_STATE,
    #[doc = "0x364 - SCT event control register 0"]
    pub ev12_ctrl: EV_CTRL,
    #[doc = "0x368 - SCT event state register 0"]
    pub ev13_state: EV_STATE,
    #[doc = "0x36c - SCT event control register 0"]
    pub ev13_ctrl: EV_CTRL,
    #[doc = "0x370 - SCT event state register 0"]
    pub ev14_state: EV_STATE,
    #[doc = "0x374 - SCT event control register 0"]
    pub ev14_ctrl: EV_CTRL,
    #[doc = "0x378 - SCT event state register 0"]
    pub ev15_state: EV_STATE,
    #[doc = "0x37c - SCT event control register 0"]
    pub ev15_ctrl: EV_CTRL,
    _reserved56: [u8; 384usize],
    #[doc = "0x500 - SCT output 0 set register"]
    pub out0_set: OUT_SET,
    #[doc = "0x504 - SCT output 0 clear register"]
    pub out0_clr: OUT_CLR,
    #[doc = "0x508 - SCT output 0 set register"]
    pub out1_set: OUT_SET,
    #[doc = "0x50c - SCT output 0 clear register"]
    pub out1_clr: OUT_CLR,
    #[doc = "0x510 - SCT output 0 set register"]
    pub out2_set: OUT_SET,
    #[doc = "0x514 - SCT output 0 clear register"]
    pub out2_clr: OUT_CLR,
    #[doc = "0x518 - SCT output 0 set register"]
    pub out3_set: OUT_SET,
    #[doc = "0x51c - SCT output 0 clear register"]
    pub out3_clr: OUT_CLR,
    #[doc = "0x520 - SCT output 0 set register"]
    pub out4_set: OUT_SET,
    #[doc = "0x524 - SCT output 0 clear register"]
    pub out4_clr: OUT_CLR,
    #[doc = "0x528 - SCT output 0 set register"]
    pub out5_set: OUT_SET,
    #[doc = "0x52c - SCT output 0 clear register"]
    pub out5_clr: OUT_CLR,
    #[doc = "0x530 - SCT output 0 set register"]
    pub out6_set: OUT_SET,
    #[doc = "0x534 - SCT output 0 clear register"]
    pub out6_clr: OUT_CLR,
    #[doc = "0x538 - SCT output 0 set register"]
    pub out7_set: OUT_SET,
    #[doc = "0x53c - SCT output 0 clear register"]
    pub out7_clr: OUT_CLR,
    #[doc = "0x540 - SCT output 0 set register"]
    pub out8_set: OUT_SET,
    #[doc = "0x544 - SCT output 0 clear register"]
    pub out8_clr: OUT_CLR,
    #[doc = "0x548 - SCT output 0 set register"]
    pub out9_set: OUT_SET,
    #[doc = "0x54c - SCT output 0 clear register"]
    pub out9_clr: OUT_CLR,
    #[doc = "0x550 - SCT output 0 set register"]
    pub out10_set: OUT_SET,
    #[doc = "0x554 - SCT output 0 clear register"]
    pub out10_clr: OUT_CLR,
    #[doc = "0x558 - SCT output 0 set register"]
    pub out11_set: OUT_SET,
    #[doc = "0x55c - SCT output 0 clear register"]
    pub out11_clr: OUT_CLR,
    #[doc = "0x560 - SCT output 0 set register"]
    pub out12_set: OUT_SET,
    #[doc = "0x564 - SCT output 0 clear register"]
    pub out12_clr: OUT_CLR,
    #[doc = "0x568 - SCT output 0 set register"]
    pub out13_set: OUT_SET,
    #[doc = "0x56c - SCT output 0 clear register"]
    pub out13_clr: OUT_CLR,
    #[doc = "0x570 - SCT output 0 set register"]
    pub out14_set: OUT_SET,
    #[doc = "0x574 - SCT output 0 clear register"]
    pub out14_clr: OUT_CLR,
    #[doc = "0x578 - SCT output 0 set register"]
    pub out15_set: OUT_SET,
    #[doc = "0x57c - SCT output 0 clear register"]
    pub out15_clr: OUT_CLR,
}
impl RegisterBlock {
    #[doc = "0x100 - SCT capture register of capture channel 0 to 15; REGMOD0 to REGMODE15 = 1"]
    #[inline(always)]
    pub fn cap(&self) -> &[CAP; 16] {
        unsafe { &*(((self as *const Self) as *const u8).add(256usize) as *const [CAP; 16]) }
    }
    #[doc = "0x100 - SCT capture register of capture channel 0 to 15; REGMOD0 to REGMODE15 = 1"]
    #[inline(always)]
    pub fn cap_mut(&self) -> &mut [CAP; 16] {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(256usize) as *mut [CAP; 16]) }
    }
    #[doc = "0x100 - SCT match value register of match channels 0 to 15; REGMOD0 to REGMODE15 = 0"]
    #[inline(always)]
    pub fn match_(&self) -> &[MATCH; 16] {
        unsafe { &*(((self as *const Self) as *const u8).add(256usize) as *const [MATCH; 16]) }
    }
    #[doc = "0x100 - SCT match value register of match channels 0 to 15; REGMOD0 to REGMODE15 = 0"]
    #[inline(always)]
    pub fn match__mut(&self) -> &mut [MATCH; 16] {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(256usize) as *mut [MATCH; 16]) }
    }
    #[doc = "0x200 - SCT capture control register 0 to 15; REGMOD0 = 1 to REGMODE15 = 1"]
    #[inline(always)]
    pub fn capctrl(&self) -> &[CAPCTRL; 16] {
        unsafe { &*(((self as *const Self) as *const u8).add(512usize) as *const [CAPCTRL; 16]) }
    }
    #[doc = "0x200 - SCT capture control register 0 to 15; REGMOD0 = 1 to REGMODE15 = 1"]
    #[inline(always)]
    pub fn capctrl_mut(&self) -> &mut [CAPCTRL; 16] {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(512usize) as *mut [CAPCTRL; 16]) }
    }
    #[doc = "0x200 - SCT match reload value register 0 to 15; REGMOD0 = 0 to REGMODE15 = 0"]
    #[inline(always)]
    pub fn matchrel(&self) -> &[MATCHREL; 16] {
        unsafe { &*(((self as *const Self) as *const u8).add(512usize) as *const [MATCHREL; 16]) }
    }
    #[doc = "0x200 - SCT match reload value register 0 to 15; REGMOD0 = 0 to REGMODE15 = 0"]
    #[inline(always)]
    pub fn matchrel_mut(&self) -> &mut [MATCHREL; 16] {
        unsafe { &mut *(((self as *const Self) as *mut u8).add(512usize) as *mut [MATCHREL; 16]) }
    }
}
#[doc = "SCT configuration register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [config](config) module"]
pub type CONFIG = crate::Reg<u32, _CONFIG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CONFIG;
#[doc = "`read()` method returns [config::R](config::R) reader structure"]
impl crate::Readable for CONFIG {}
#[doc = "`write(|w| ..)` method takes [config::W](config::W) writer structure"]
impl crate::Writable for CONFIG {}
#[doc = "SCT configuration register"]
pub mod config;
#[doc = "SCT control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [ctrl](ctrl) module"]
pub type CTRL = crate::Reg<u32, _CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CTRL;
#[doc = "`read()` method returns [ctrl::R](ctrl::R) reader structure"]
impl crate::Readable for CTRL {}
#[doc = "`write(|w| ..)` method takes [ctrl::W](ctrl::W) writer structure"]
impl crate::Writable for CTRL {}
#[doc = "SCT control register"]
pub mod ctrl;
#[doc = "SCT limit register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [limit](limit) module"]
pub type LIMIT = crate::Reg<u32, _LIMIT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _LIMIT;
#[doc = "`read()` method returns [limit::R](limit::R) reader structure"]
impl crate::Readable for LIMIT {}
#[doc = "`write(|w| ..)` method takes [limit::W](limit::W) writer structure"]
impl crate::Writable for LIMIT {}
#[doc = "SCT limit register"]
pub mod limit;
#[doc = "SCT halt condition register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [halt](halt) module"]
pub type HALT = crate::Reg<u32, _HALT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _HALT;
#[doc = "`read()` method returns [halt::R](halt::R) reader structure"]
impl crate::Readable for HALT {}
#[doc = "`write(|w| ..)` method takes [halt::W](halt::W) writer structure"]
impl crate::Writable for HALT {}
#[doc = "SCT halt condition register"]
pub mod halt;
#[doc = "SCT stop condition register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [stop](stop) module"]
pub type STOP = crate::Reg<u32, _STOP>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _STOP;
#[doc = "`read()` method returns [stop::R](stop::R) reader structure"]
impl crate::Readable for STOP {}
#[doc = "`write(|w| ..)` method takes [stop::W](stop::W) writer structure"]
impl crate::Writable for STOP {}
#[doc = "SCT stop condition register"]
pub mod stop;
#[doc = "SCT start condition register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [start](start) module"]
pub type START = crate::Reg<u32, _START>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _START;
#[doc = "`read()` method returns [start::R](start::R) reader structure"]
impl crate::Readable for START {}
#[doc = "`write(|w| ..)` method takes [start::W](start::W) writer structure"]
impl crate::Writable for START {}
#[doc = "SCT start condition register"]
pub mod start;
#[doc = "SCT dither condition register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [dither](dither) module"]
pub type DITHER = crate::Reg<u32, _DITHER>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DITHER;
#[doc = "`read()` method returns [dither::R](dither::R) reader structure"]
impl crate::Readable for DITHER {}
#[doc = "`write(|w| ..)` method takes [dither::W](dither::W) writer structure"]
impl crate::Writable for DITHER {}
#[doc = "SCT dither condition register"]
pub mod dither;
#[doc = "SCT counter register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [count](count) module"]
pub type COUNT = crate::Reg<u32, _COUNT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _COUNT;
#[doc = "`read()` method returns [count::R](count::R) reader structure"]
impl crate::Readable for COUNT {}
#[doc = "`write(|w| ..)` method takes [count::W](count::W) writer structure"]
impl crate::Writable for COUNT {}
#[doc = "SCT counter register"]
pub mod count;
#[doc = "SCT state register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [state](state) module"]
pub type STATE = crate::Reg<u32, _STATE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _STATE;
#[doc = "`read()` method returns [state::R](state::R) reader structure"]
impl crate::Readable for STATE {}
#[doc = "`write(|w| ..)` method takes [state::W](state::W) writer structure"]
impl crate::Writable for STATE {}
#[doc = "SCT state register"]
pub mod state;
#[doc = "SCT input register\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [input](input) module"]
pub type INPUT = crate::Reg<u32, _INPUT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _INPUT;
#[doc = "`read()` method returns [input::R](input::R) reader structure"]
impl crate::Readable for INPUT {}
#[doc = "SCT input register"]
pub mod input;
#[doc = "SCT match/capture registers mode register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [regmode](regmode) module"]
pub type REGMODE = crate::Reg<u32, _REGMODE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _REGMODE;
#[doc = "`read()` method returns [regmode::R](regmode::R) reader structure"]
impl crate::Readable for REGMODE {}
#[doc = "`write(|w| ..)` method takes [regmode::W](regmode::W) writer structure"]
impl crate::Writable for REGMODE {}
#[doc = "SCT match/capture registers mode register"]
pub mod regmode;
#[doc = "SCT output register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [output](output) module"]
pub type OUTPUT = crate::Reg<u32, _OUTPUT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _OUTPUT;
#[doc = "`read()` method returns [output::R](output::R) reader structure"]
impl crate::Readable for OUTPUT {}
#[doc = "`write(|w| ..)` method takes [output::W](output::W) writer structure"]
impl crate::Writable for OUTPUT {}
#[doc = "SCT output register"]
pub mod output;
#[doc = "SCT output counter direction control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [outputdirctrl](outputdirctrl) module"]
pub type OUTPUTDIRCTRL = crate::Reg<u32, _OUTPUTDIRCTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _OUTPUTDIRCTRL;
#[doc = "`read()` method returns [outputdirctrl::R](outputdirctrl::R) reader structure"]
impl crate::Readable for OUTPUTDIRCTRL {}
#[doc = "`write(|w| ..)` method takes [outputdirctrl::W](outputdirctrl::W) writer structure"]
impl crate::Writable for OUTPUTDIRCTRL {}
#[doc = "SCT output counter direction control register"]
pub mod outputdirctrl;
#[doc = "SCT conflict resolution register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [res](res) module"]
pub type RES = crate::Reg<u32, _RES>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _RES;
#[doc = "`read()` method returns [res::R](res::R) reader structure"]
impl crate::Readable for RES {}
#[doc = "`write(|w| ..)` method takes [res::W](res::W) writer structure"]
impl crate::Writable for RES {}
#[doc = "SCT conflict resolution register"]
pub mod res;
#[doc = "SCT DMA request 0 register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [dmareq0](dmareq0) module"]
pub type DMAREQ0 = crate::Reg<u32, _DMAREQ0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DMAREQ0;
#[doc = "`read()` method returns [dmareq0::R](dmareq0::R) reader structure"]
impl crate::Readable for DMAREQ0 {}
#[doc = "`write(|w| ..)` method takes [dmareq0::W](dmareq0::W) writer structure"]
impl crate::Writable for DMAREQ0 {}
#[doc = "SCT DMA request 0 register"]
pub mod dmareq0;
#[doc = "SCT DMA request 1 register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [dmareq1](dmareq1) module"]
pub type DMAREQ1 = crate::Reg<u32, _DMAREQ1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _DMAREQ1;
#[doc = "`read()` method returns [dmareq1::R](dmareq1::R) reader structure"]
impl crate::Readable for DMAREQ1 {}
#[doc = "`write(|w| ..)` method takes [dmareq1::W](dmareq1::W) writer structure"]
impl crate::Writable for DMAREQ1 {}
#[doc = "SCT DMA request 1 register"]
pub mod dmareq1;
#[doc = "SCT event enable register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [even](even) module"]
pub type EVEN = crate::Reg<u32, _EVEN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EVEN;
#[doc = "`read()` method returns [even::R](even::R) reader structure"]
impl crate::Readable for EVEN {}
#[doc = "`write(|w| ..)` method takes [even::W](even::W) writer structure"]
impl crate::Writable for EVEN {}
#[doc = "SCT event enable register"]
pub mod even;
#[doc = "SCT event flag register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [evflag](evflag) module"]
pub type EVFLAG = crate::Reg<u32, _EVFLAG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EVFLAG;
#[doc = "`read()` method returns [evflag::R](evflag::R) reader structure"]
impl crate::Readable for EVFLAG {}
#[doc = "`write(|w| ..)` method takes [evflag::W](evflag::W) writer structure"]
impl crate::Writable for EVFLAG {}
#[doc = "SCT event flag register"]
pub mod evflag;
#[doc = "SCT conflict enable register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [conen](conen) module"]
pub type CONEN = crate::Reg<u32, _CONEN>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CONEN;
#[doc = "`read()` method returns [conen::R](conen::R) reader structure"]
impl crate::Readable for CONEN {}
#[doc = "`write(|w| ..)` method takes [conen::W](conen::W) writer structure"]
impl crate::Writable for CONEN {}
#[doc = "SCT conflict enable register"]
pub mod conen;
#[doc = "SCT conflict flag register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [conflag](conflag) module"]
pub type CONFLAG = crate::Reg<u32, _CONFLAG>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CONFLAG;
#[doc = "`read()` method returns [conflag::R](conflag::R) reader structure"]
impl crate::Readable for CONFLAG {}
#[doc = "`write(|w| ..)` method takes [conflag::W](conflag::W) writer structure"]
impl crate::Writable for CONFLAG {}
#[doc = "SCT conflict flag register"]
pub mod conflag;
#[doc = "SCT match value register of match channels 0 to 15; REGMOD0 to REGMODE15 = 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [match_](match_) module"]
pub type MATCH = crate::Reg<u32, _MATCH>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MATCH;
#[doc = "`read()` method returns [match_::R](match_::R) reader structure"]
impl crate::Readable for MATCH {}
#[doc = "`write(|w| ..)` method takes [match_::W](match_::W) writer structure"]
impl crate::Writable for MATCH {}
#[doc = "SCT match value register of match channels 0 to 15; REGMOD0 to REGMODE15 = 0"]
pub mod match_;
#[doc = "Fractional match registers 0 to 5 for SCT match value registers 0 to 5.\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [fracmat](fracmat) module"]
pub type FRACMAT = crate::Reg<u32, _FRACMAT>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FRACMAT;
#[doc = "`read()` method returns [fracmat::R](fracmat::R) reader structure"]
impl crate::Readable for FRACMAT {}
#[doc = "`write(|w| ..)` method takes [fracmat::W](fracmat::W) writer structure"]
impl crate::Writable for FRACMAT {}
#[doc = "Fractional match registers 0 to 5 for SCT match value registers 0 to 5."]
pub mod fracmat;
#[doc = "SCT capture register of capture channel 0 to 15; REGMOD0 to REGMODE15 = 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [cap](cap) module"]
pub type CAP = crate::Reg<u32, _CAP>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAP;
#[doc = "`read()` method returns [cap::R](cap::R) reader structure"]
impl crate::Readable for CAP {}
#[doc = "`write(|w| ..)` method takes [cap::W](cap::W) writer structure"]
impl crate::Writable for CAP {}
#[doc = "SCT capture register of capture channel 0 to 15; REGMOD0 to REGMODE15 = 1"]
pub mod cap;
#[doc = "SCT match reload value register 0 to 15; REGMOD0 = 0 to REGMODE15 = 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [matchrel](matchrel) module"]
pub type MATCHREL = crate::Reg<u32, _MATCHREL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _MATCHREL;
#[doc = "`read()` method returns [matchrel::R](matchrel::R) reader structure"]
impl crate::Readable for MATCHREL {}
#[doc = "`write(|w| ..)` method takes [matchrel::W](matchrel::W) writer structure"]
impl crate::Writable for MATCHREL {}
#[doc = "SCT match reload value register 0 to 15; REGMOD0 = 0 to REGMODE15 = 0"]
pub mod matchrel;
#[doc = "Fractional match reload registers 0 to 5 for SCT match value registers 0 to 5.\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [fracmatrel](fracmatrel) module"]
pub type FRACMATREL = crate::Reg<u32, _FRACMATREL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _FRACMATREL;
#[doc = "`read()` method returns [fracmatrel::R](fracmatrel::R) reader structure"]
impl crate::Readable for FRACMATREL {}
#[doc = "`write(|w| ..)` method takes [fracmatrel::W](fracmatrel::W) writer structure"]
impl crate::Writable for FRACMATREL {}
#[doc = "Fractional match reload registers 0 to 5 for SCT match value registers 0 to 5."]
pub mod fracmatrel;
#[doc = "SCT capture control register 0 to 15; REGMOD0 = 1 to REGMODE15 = 1\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [capctrl](capctrl) module"]
pub type CAPCTRL = crate::Reg<u32, _CAPCTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _CAPCTRL;
#[doc = "`read()` method returns [capctrl::R](capctrl::R) reader structure"]
impl crate::Readable for CAPCTRL {}
#[doc = "`write(|w| ..)` method takes [capctrl::W](capctrl::W) writer structure"]
impl crate::Writable for CAPCTRL {}
#[doc = "SCT capture control register 0 to 15; REGMOD0 = 1 to REGMODE15 = 1"]
pub mod capctrl;
#[doc = "SCT event state register 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [ev_state](ev_state) module"]
pub type EV_STATE = crate::Reg<u32, _EV_STATE>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EV_STATE;
#[doc = "`read()` method returns [ev_state::R](ev_state::R) reader structure"]
impl crate::Readable for EV_STATE {}
#[doc = "`write(|w| ..)` method takes [ev_state::W](ev_state::W) writer structure"]
impl crate::Writable for EV_STATE {}
#[doc = "SCT event state register 0"]
pub mod ev_state;
#[doc = "SCT event control register 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [ev_ctrl](ev_ctrl) module"]
pub type EV_CTRL = crate::Reg<u32, _EV_CTRL>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EV_CTRL;
#[doc = "`read()` method returns [ev_ctrl::R](ev_ctrl::R) reader structure"]
impl crate::Readable for EV_CTRL {}
#[doc = "`write(|w| ..)` method takes [ev_ctrl::W](ev_ctrl::W) writer structure"]
impl crate::Writable for EV_CTRL {}
#[doc = "SCT event control register 0"]
pub mod ev_ctrl;
#[doc = "SCT output 0 set register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [out_set](out_set) module"]
pub type OUT_SET = crate::Reg<u32, _OUT_SET>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _OUT_SET;
#[doc = "`read()` method returns [out_set::R](out_set::R) reader structure"]
impl crate::Readable for OUT_SET {}
#[doc = "`write(|w| ..)` method takes [out_set::W](out_set::W) writer structure"]
impl crate::Writable for OUT_SET {}
#[doc = "SCT output 0 set register"]
pub mod out_set;
#[doc = "SCT output 0 clear register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [out_clr](out_clr) module"]
pub type OUT_CLR = crate::Reg<u32, _OUT_CLR>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _OUT_CLR;
#[doc = "`read()` method returns [out_clr::R](out_clr::R) reader structure"]
impl crate::Readable for OUT_CLR {}
#[doc = "`write(|w| ..)` method takes [out_clr::W](out_clr::W) writer structure"]
impl crate::Writable for OUT_CLR {}
#[doc = "SCT output 0 clear register"]
pub mod out_clr;
