#[doc = "Reader of register DITHER"]
pub type R = crate::R<u32, super::DITHER>;
#[doc = "Writer for register DITHER"]
pub type W = crate::W<u32, super::DITHER>;
#[doc = "Register DITHER `reset()`'s with value 0"]
impl crate::ResetValue for super::DITHER {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `DITHMSK_L`"]
pub type DITHMSK_L_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `DITHMSK_L`"]
pub struct DITHMSK_L_W<'a> {
    w: &'a mut W,
}
impl<'a> DITHMSK_L_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff) | ((value as u32) & 0xffff);
        self.w
    }
}
#[doc = "Reader of field `DITHMSK_H`"]
pub type DITHMSK_H_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `DITHMSK_H`"]
pub struct DITHMSK_H_W<'a> {
    w: &'a mut W,
}
impl<'a> DITHMSK_H_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xffff << 16)) | (((value as u32) & 0xffff) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:15 - If bit n is one, the event n causes the dither engine to advance to the next element in the dither pattern at the start of the next counter cycle of the 16-bit low counter or the unified counter (event 0 = bit 0, event 1 = bit 1, event 15 = bit 15). If all bits are set to 0, the dither pattern automatically advances at the start of every new counter cycle."]
    #[inline(always)]
    pub fn dithmsk_l(&self) -> DITHMSK_L_R {
        DITHMSK_L_R::new((self.bits & 0xffff) as u16)
    }
    #[doc = "Bits 16:31 - If bit n is one, the event n causes the dither engine to advance to the next element in the dither pattern at the start of the next counter cycle of the 16-bit high counter (event 0 = bit 0, event 1 = bit 1, event 15 = bit 15). If all bits are set to 0, the dither pattern automatically advances at the start of every new counter cycle."]
    #[inline(always)]
    pub fn dithmsk_h(&self) -> DITHMSK_H_R {
        DITHMSK_H_R::new(((self.bits >> 16) & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:15 - If bit n is one, the event n causes the dither engine to advance to the next element in the dither pattern at the start of the next counter cycle of the 16-bit low counter or the unified counter (event 0 = bit 0, event 1 = bit 1, event 15 = bit 15). If all bits are set to 0, the dither pattern automatically advances at the start of every new counter cycle."]
    #[inline(always)]
    pub fn dithmsk_l(&mut self) -> DITHMSK_L_W {
        DITHMSK_L_W { w: self }
    }
    #[doc = "Bits 16:31 - If bit n is one, the event n causes the dither engine to advance to the next element in the dither pattern at the start of the next counter cycle of the 16-bit high counter (event 0 = bit 0, event 1 = bit 1, event 15 = bit 15). If all bits are set to 0, the dither pattern automatically advances at the start of every new counter cycle."]
    #[inline(always)]
    pub fn dithmsk_h(&mut self) -> DITHMSK_H_W {
        DITHMSK_H_W { w: self }
    }
}
