#[doc = "Reader of register FRACMAT%s"]
pub type R = crate::R<u32, super::FRACMAT>;
#[doc = "Writer for register FRACMAT%s"]
pub type W = crate::W<u32, super::FRACMAT>;
#[doc = "Register FRACMAT%s `reset()`'s with value 0"]
impl crate::ResetValue for super::FRACMAT {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `FRACMAT_L`"]
pub type FRACMAT_L_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `FRACMAT_L`"]
pub struct FRACMAT_L_W<'a> {
    w: &'a mut W,
}
impl<'a> FRACMAT_L_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | ((value as u32) & 0x0f);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_0`"]
pub type RESERVED_0_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `RESERVED_0`"]
pub struct RESERVED_0_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0fff << 4)) | (((value as u32) & 0x0fff) << 4);
        self.w
    }
}
#[doc = "Reader of field `FRACMAT_H`"]
pub type FRACMAT_H_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `FRACMAT_H`"]
pub struct FRACMAT_H_W<'a> {
    w: &'a mut W,
}
impl<'a> FRACMAT_H_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 16)) | (((value as u32) & 0x0f) << 16);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_1`"]
pub type RESERVED_1_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `RESERVED_1`"]
pub struct RESERVED_1_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0fff << 20)) | (((value as u32) & 0x0fff) << 20);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - When UNIFY = 0, read or write the 4-bit value specifying the dither pattern to be applied to the corresponding MATCHn_L register (n = 0 to 5). When UNIFY = 1, the value applies to the unified, 32-bit fractional match register."]
    #[inline(always)]
    pub fn fracmat_l(&self) -> FRACMAT_L_R {
        FRACMAT_L_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:15 - Reserved."]
    #[inline(always)]
    pub fn reserved_0(&self) -> RESERVED_0_R {
        RESERVED_0_R::new(((self.bits >> 4) & 0x0fff) as u16)
    }
    #[doc = "Bits 16:19 - When UNIFY = 0, read or write 4-bit value specifying the dither pattern to be applied to the corresponding MATCHn_H register (n = 0 to 5)."]
    #[inline(always)]
    pub fn fracmat_h(&self) -> FRACMAT_H_R {
        FRACMAT_H_R::new(((self.bits >> 16) & 0x0f) as u8)
    }
    #[doc = "Bits 20:31 - Reserved."]
    #[inline(always)]
    pub fn reserved_1(&self) -> RESERVED_1_R {
        RESERVED_1_R::new(((self.bits >> 20) & 0x0fff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:3 - When UNIFY = 0, read or write the 4-bit value specifying the dither pattern to be applied to the corresponding MATCHn_L register (n = 0 to 5). When UNIFY = 1, the value applies to the unified, 32-bit fractional match register."]
    #[inline(always)]
    pub fn fracmat_l(&mut self) -> FRACMAT_L_W {
        FRACMAT_L_W { w: self }
    }
    #[doc = "Bits 4:15 - Reserved."]
    #[inline(always)]
    pub fn reserved_0(&mut self) -> RESERVED_0_W {
        RESERVED_0_W { w: self }
    }
    #[doc = "Bits 16:19 - When UNIFY = 0, read or write 4-bit value specifying the dither pattern to be applied to the corresponding MATCHn_H register (n = 0 to 5)."]
    #[inline(always)]
    pub fn fracmat_h(&mut self) -> FRACMAT_H_W {
        FRACMAT_H_W { w: self }
    }
    #[doc = "Bits 20:31 - Reserved."]
    #[inline(always)]
    pub fn reserved_1(&mut self) -> RESERVED_1_W {
        RESERVED_1_W { w: self }
    }
}
