#[doc = "Reader of register ENAIO1"]
pub type R = crate::R<u32, super::ENAIO1>;
#[doc = "Writer for register ENAIO1"]
pub type W = crate::W<u32, super::ENAIO1>;
#[doc = "Register ENAIO1 `reset()`'s with value 0"]
impl crate::ResetValue for super::ENAIO1 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Select ADC1_0\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_0_A {
    #[doc = "0: Digital function selected on pin PC_3."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_0 selected on pin PC_3."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_0_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_0_A) -> Self {
        match variant {
            ADC1_0_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_0_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_0`"]
pub type ADC1_0_R = crate::R<bool, ADC1_0_A>;
impl ADC1_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_0_A {
        match self.bits {
            false => ADC1_0_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_0_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_0_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_0_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_0`"]
pub struct ADC1_0_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_0_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PC_3."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_0_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_0 selected on pin PC_3."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_0_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Select ADC1_1\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_1_A {
    #[doc = "0: Digital function selected on pin PC_0."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_1 selected on pin PC_0."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_1_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_1_A) -> Self {
        match variant {
            ADC1_1_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_1_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_1`"]
pub type ADC1_1_R = crate::R<bool, ADC1_1_A>;
impl ADC1_1_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_1_A {
        match self.bits {
            false => ADC1_1_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_1_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_1_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_1_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_1`"]
pub struct ADC1_1_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_1_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PC_0."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_1_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_1 selected on pin PC_0."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_1_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Select ADC1_2\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_2_A {
    #[doc = "0: Digital function selected on pin PF_9."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_2 selected on pin PF_9."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_2_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_2_A) -> Self {
        match variant {
            ADC1_2_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_2_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_2`"]
pub type ADC1_2_R = crate::R<bool, ADC1_2_A>;
impl ADC1_2_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_2_A {
        match self.bits {
            false => ADC1_2_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_2_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_2_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_2_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_2`"]
pub struct ADC1_2_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_2_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_9."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_2_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_2 selected on pin PF_9."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_2_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Select ADC1_3\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_3_A {
    #[doc = "0: Digital function selected on pin PF_6."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_3 selected on pin PF_6."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_3_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_3_A) -> Self {
        match variant {
            ADC1_3_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_3_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_3`"]
pub type ADC1_3_R = crate::R<bool, ADC1_3_A>;
impl ADC1_3_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_3_A {
        match self.bits {
            false => ADC1_3_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_3_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_3_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_3_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_3`"]
pub struct ADC1_3_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_3_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_6."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_3_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_3 selected on pin PF_6."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_3_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Select ADC1_4\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_4_A {
    #[doc = "0: Digital function selected on pin PF_5."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_4 selected on pin PF_5."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_4_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_4_A) -> Self {
        match variant {
            ADC1_4_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_4_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_4`"]
pub type ADC1_4_R = crate::R<bool, ADC1_4_A>;
impl ADC1_4_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_4_A {
        match self.bits {
            false => ADC1_4_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_4_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_4_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_4_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_4`"]
pub struct ADC1_4_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_4_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_4_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_5."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_4_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_4 selected on pin PF_5."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_4_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Select ADC1_5\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_5_A {
    #[doc = "0: Digital function selected on pin PF_11."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_5 selected on pin PF_11."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_5_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_5_A) -> Self {
        match variant {
            ADC1_5_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_5_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_5`"]
pub type ADC1_5_R = crate::R<bool, ADC1_5_A>;
impl ADC1_5_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_5_A {
        match self.bits {
            false => ADC1_5_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_5_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_5_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_5_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_5`"]
pub struct ADC1_5_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_5_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_5_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_11."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_5_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_5 selected on pin PF_11."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_5_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Select ADC1_6\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_6_A {
    #[doc = "0: Digital function selected on pin P7_7."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_6 selected on pin P7_7."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_6_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_6_A) -> Self {
        match variant {
            ADC1_6_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_6_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_6`"]
pub type ADC1_6_R = crate::R<bool, ADC1_6_A>;
impl ADC1_6_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_6_A {
        match self.bits {
            false => ADC1_6_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_6_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_6_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_6_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_6`"]
pub struct ADC1_6_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_6_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_6_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin P7_7."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_6_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_6 selected on pin P7_7."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_6_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Select ADC1_7.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ADC1_7_A {
    #[doc = "0: Digital function selected on pin PF_7."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function ADC1_7 selected on pin PF_7."]
    ANALOG_FUNCTION_ADC1_SELECTED,
}
impl From<ADC1_7_A> for bool {
    #[inline(always)]
    fn from(variant: ADC1_7_A) -> Self {
        match variant {
            ADC1_7_A::DIGITAL_FUNCTION_SELECTED => false,
            ADC1_7_A::ANALOG_FUNCTION_ADC1_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `ADC1_7`"]
pub type ADC1_7_R = crate::R<bool, ADC1_7_A>;
impl ADC1_7_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ADC1_7_A {
        match self.bits {
            false => ADC1_7_A::DIGITAL_FUNCTION_SELECTED,
            true => ADC1_7_A::ANALOG_FUNCTION_ADC1_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == ADC1_7_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_ADC1_SELECTED`"]
    #[inline(always)]
    pub fn is_analog_function_adc1_selected(&self) -> bool {
        *self == ADC1_7_A::ANALOG_FUNCTION_ADC1_SELECTED
    }
}
#[doc = "Write proxy for field `ADC1_7`"]
pub struct ADC1_7_W<'a> {
    w: &'a mut W,
}
impl<'a> ADC1_7_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ADC1_7_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_7."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(ADC1_7_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function ADC1_7 selected on pin PF_7."]
    #[inline(always)]
    pub fn analog_function_adc1_selected(self) -> &'a mut W {
        self.variant(ADC1_7_A::ANALOG_FUNCTION_ADC1_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Select ADC1_0"]
    #[inline(always)]
    pub fn adc1_0(&self) -> ADC1_0_R {
        ADC1_0_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Select ADC1_1"]
    #[inline(always)]
    pub fn adc1_1(&self) -> ADC1_1_R {
        ADC1_1_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Select ADC1_2"]
    #[inline(always)]
    pub fn adc1_2(&self) -> ADC1_2_R {
        ADC1_2_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Select ADC1_3"]
    #[inline(always)]
    pub fn adc1_3(&self) -> ADC1_3_R {
        ADC1_3_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Select ADC1_4"]
    #[inline(always)]
    pub fn adc1_4(&self) -> ADC1_4_R {
        ADC1_4_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Select ADC1_5"]
    #[inline(always)]
    pub fn adc1_5(&self) -> ADC1_5_R {
        ADC1_5_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Select ADC1_6"]
    #[inline(always)]
    pub fn adc1_6(&self) -> ADC1_6_R {
        ADC1_6_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Select ADC1_7."]
    #[inline(always)]
    pub fn adc1_7(&self) -> ADC1_7_R {
        ADC1_7_R::new(((self.bits >> 7) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Select ADC1_0"]
    #[inline(always)]
    pub fn adc1_0(&mut self) -> ADC1_0_W {
        ADC1_0_W { w: self }
    }
    #[doc = "Bit 1 - Select ADC1_1"]
    #[inline(always)]
    pub fn adc1_1(&mut self) -> ADC1_1_W {
        ADC1_1_W { w: self }
    }
    #[doc = "Bit 2 - Select ADC1_2"]
    #[inline(always)]
    pub fn adc1_2(&mut self) -> ADC1_2_W {
        ADC1_2_W { w: self }
    }
    #[doc = "Bit 3 - Select ADC1_3"]
    #[inline(always)]
    pub fn adc1_3(&mut self) -> ADC1_3_W {
        ADC1_3_W { w: self }
    }
    #[doc = "Bit 4 - Select ADC1_4"]
    #[inline(always)]
    pub fn adc1_4(&mut self) -> ADC1_4_W {
        ADC1_4_W { w: self }
    }
    #[doc = "Bit 5 - Select ADC1_5"]
    #[inline(always)]
    pub fn adc1_5(&mut self) -> ADC1_5_W {
        ADC1_5_W { w: self }
    }
    #[doc = "Bit 6 - Select ADC1_6"]
    #[inline(always)]
    pub fn adc1_6(&mut self) -> ADC1_6_W {
        ADC1_6_W { w: self }
    }
    #[doc = "Bit 7 - Select ADC1_7."]
    #[inline(always)]
    pub fn adc1_7(&mut self) -> ADC1_7_W {
        ADC1_7_W { w: self }
    }
}
