#[doc = "Reader of register ENAIO2"]
pub type R = crate::R<u32, super::ENAIO2>;
#[doc = "Writer for register ENAIO2"]
pub type W = crate::W<u32, super::ENAIO2>;
#[doc = "Register ENAIO2 `reset()`'s with value 0"]
impl crate::ResetValue for super::ENAIO2 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Select DAC\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DAC_A {
    #[doc = "0: Digital function selected on pin P4_4."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Analog function DAC selected on pin P4_4."]
    ANALOG_FUNCTION_DAC,
}
impl From<DAC_A> for bool {
    #[inline(always)]
    fn from(variant: DAC_A) -> Self {
        match variant {
            DAC_A::DIGITAL_FUNCTION_SELECTED => false,
            DAC_A::ANALOG_FUNCTION_DAC => true,
        }
    }
}
#[doc = "Reader of field `DAC`"]
pub type DAC_R = crate::R<bool, DAC_A>;
impl DAC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DAC_A {
        match self.bits {
            false => DAC_A::DIGITAL_FUNCTION_SELECTED,
            true => DAC_A::ANALOG_FUNCTION_DAC,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == DAC_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `ANALOG_FUNCTION_DAC`"]
    #[inline(always)]
    pub fn is_analog_function_dac(&self) -> bool {
        *self == DAC_A::ANALOG_FUNCTION_DAC
    }
}
#[doc = "Write proxy for field `DAC`"]
pub struct DAC_W<'a> {
    w: &'a mut W,
}
impl<'a> DAC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DAC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin P4_4."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(DAC_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Analog function DAC selected on pin P4_4."]
    #[inline(always)]
    pub fn analog_function_dac(self) -> &'a mut W {
        self.variant(DAC_A::ANALOG_FUNCTION_DAC)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Select band gap output. To measure the band gap, disable the pull-up on pin PF_7 and connect PF_7 to the digital pad. Do not use the digital pad nor the ADC1_7 on the board when measuring the band gap (see Section 15.4.8.1).\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BG_A {
    #[doc = "0: Digital function selected on pin PF_7."]
    DIGITAL_FUNCTION_SELECTED,
    #[doc = "1: Band gap output selected for pin PF_7."]
    BAND_GAP_OUTPUT_SELECTED,
}
impl From<BG_A> for bool {
    #[inline(always)]
    fn from(variant: BG_A) -> Self {
        match variant {
            BG_A::DIGITAL_FUNCTION_SELECTED => false,
            BG_A::BAND_GAP_OUTPUT_SELECTED => true,
        }
    }
}
#[doc = "Reader of field `BG`"]
pub type BG_R = crate::R<bool, BG_A>;
impl BG_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BG_A {
        match self.bits {
            false => BG_A::DIGITAL_FUNCTION_SELECTED,
            true => BG_A::BAND_GAP_OUTPUT_SELECTED,
        }
    }
    #[doc = "Checks if the value of the field is `DIGITAL_FUNCTION_SELECTED`"]
    #[inline(always)]
    pub fn is_digital_function_selected(&self) -> bool {
        *self == BG_A::DIGITAL_FUNCTION_SELECTED
    }
    #[doc = "Checks if the value of the field is `BAND_GAP_OUTPUT_SELECTED`"]
    #[inline(always)]
    pub fn is_band_gap_output_selected(&self) -> bool {
        *self == BG_A::BAND_GAP_OUTPUT_SELECTED
    }
}
#[doc = "Write proxy for field `BG`"]
pub struct BG_W<'a> {
    w: &'a mut W,
}
impl<'a> BG_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BG_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Digital function selected on pin PF_7."]
    #[inline(always)]
    pub fn digital_function_selected(self) -> &'a mut W {
        self.variant(BG_A::DIGITAL_FUNCTION_SELECTED)
    }
    #[doc = "Band gap output selected for pin PF_7."]
    #[inline(always)]
    pub fn band_gap_output_selected(self) -> &'a mut W {
        self.variant(BG_A::BAND_GAP_OUTPUT_SELECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Select DAC"]
    #[inline(always)]
    pub fn dac(&self) -> DAC_R {
        DAC_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 4 - Select band gap output. To measure the band gap, disable the pull-up on pin PF_7 and connect PF_7 to the digital pad. Do not use the digital pad nor the ADC1_7 on the board when measuring the band gap (see Section 15.4.8.1)."]
    #[inline(always)]
    pub fn bg(&self) -> BG_R {
        BG_R::new(((self.bits >> 4) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Select DAC"]
    #[inline(always)]
    pub fn dac(&mut self) -> DAC_W {
        DAC_W { w: self }
    }
    #[doc = "Bit 4 - Select band gap output. To measure the band gap, disable the pull-up on pin PF_7 and connect PF_7 to the digital pad. Do not use the digital pad nor the ADC1_7 on the board when measuring the band gap (see Section 15.4.8.1)."]
    #[inline(always)]
    pub fn bg(&mut self) -> BG_W {
        BG_W { w: self }
    }
}
