#[doc = "Reader of register SDDELAY"]
pub type R = crate::R<u32, super::SDDELAY>;
#[doc = "Writer for register SDDELAY"]
pub type W = crate::W<u32, super::SDDELAY>;
#[doc = "Register SDDELAY `reset()`'s with value 0"]
impl crate::ResetValue for super::SDDELAY {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `SAMPLE_DELAY`"]
pub type SAMPLE_DELAY_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `SAMPLE_DELAY`"]
pub struct SAMPLE_DELAY_W<'a> {
    w: &'a mut W,
}
impl<'a> SAMPLE_DELAY_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | ((value as u32) & 0x0f);
        self.w
    }
}
#[doc = "Reader of field `DRV_DELAY`"]
pub type DRV_DELAY_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `DRV_DELAY`"]
pub struct DRV_DELAY_W<'a> {
    w: &'a mut W,
}
impl<'a> DRV_DELAY_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 8)) | (((value as u32) & 0x0f) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - SD/MMC sample delay. The delay value is SAMPLE_DELAY x 0.5 ns."]
    #[inline(always)]
    pub fn sample_delay(&self) -> SAMPLE_DELAY_R {
        SAMPLE_DELAY_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 8:11 - SD/MMC drive delay. The delay value is DRV_DELAY x 0.5 ns. The values DRV_DELAY = 0 and DRV_DELAY = 1 are not allowed."]
    #[inline(always)]
    pub fn drv_delay(&self) -> DRV_DELAY_R {
        DRV_DELAY_R::new(((self.bits >> 8) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:3 - SD/MMC sample delay. The delay value is SAMPLE_DELAY x 0.5 ns."]
    #[inline(always)]
    pub fn sample_delay(&mut self) -> SAMPLE_DELAY_W {
        SAMPLE_DELAY_W { w: self }
    }
    #[doc = "Bits 8:11 - SD/MMC drive delay. The delay value is DRV_DELAY x 0.5 ns. The values DRV_DELAY = 0 and DRV_DELAY = 1 are not allowed."]
    #[inline(always)]
    pub fn drv_delay(&mut self) -> DRV_DELAY_W {
        DRV_DELAY_W { w: self }
    }
}
