#[doc = "Reader of register SFSI2C0"]
pub type R = crate::R<u32, super::SFSI2C0>;
#[doc = "Writer for register SFSI2C0"]
pub type W = crate::W<u32, super::SFSI2C0>;
#[doc = "Register SFSI2C0 `reset()`'s with value 0"]
impl crate::ResetValue for super::SFSI2C0 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Select input glitch filter time constant for the SCL pin.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SCL_EFP_A {
    #[doc = "0: 50 ns glitch filter"]
    _50_NS_GLITCH_FILTER,
    #[doc = "1: 3 ns glitch filter"]
    _3_NS_GLITCH_FILTER,
}
impl From<SCL_EFP_A> for bool {
    #[inline(always)]
    fn from(variant: SCL_EFP_A) -> Self {
        match variant {
            SCL_EFP_A::_50_NS_GLITCH_FILTER => false,
            SCL_EFP_A::_3_NS_GLITCH_FILTER => true,
        }
    }
}
#[doc = "Reader of field `SCL_EFP`"]
pub type SCL_EFP_R = crate::R<bool, SCL_EFP_A>;
impl SCL_EFP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SCL_EFP_A {
        match self.bits {
            false => SCL_EFP_A::_50_NS_GLITCH_FILTER,
            true => SCL_EFP_A::_3_NS_GLITCH_FILTER,
        }
    }
    #[doc = "Checks if the value of the field is `_50_NS_GLITCH_FILTER`"]
    #[inline(always)]
    pub fn is_50_ns_glitch_filter(&self) -> bool {
        *self == SCL_EFP_A::_50_NS_GLITCH_FILTER
    }
    #[doc = "Checks if the value of the field is `_3_NS_GLITCH_FILTER`"]
    #[inline(always)]
    pub fn is_3_ns_glitch_filter(&self) -> bool {
        *self == SCL_EFP_A::_3_NS_GLITCH_FILTER
    }
}
#[doc = "Write proxy for field `SCL_EFP`"]
pub struct SCL_EFP_W<'a> {
    w: &'a mut W,
}
impl<'a> SCL_EFP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SCL_EFP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "50 ns glitch filter"]
    #[inline(always)]
    pub fn _50_ns_glitch_filter(self) -> &'a mut W {
        self.variant(SCL_EFP_A::_50_NS_GLITCH_FILTER)
    }
    #[doc = "3 ns glitch filter"]
    #[inline(always)]
    pub fn _3_ns_glitch_filter(self) -> &'a mut W {
        self.variant(SCL_EFP_A::_3_NS_GLITCH_FILTER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Select I2C mode for the SCL pin.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SCL_EHD_A {
    #[doc = "0: Standard/Fast mode transmit"]
    STANDARDFAST_MODE,
    #[doc = "1: Fast-mode Plus transmit"]
    FAST_MODE_PLUS_TRANSMIT,
}
impl From<SCL_EHD_A> for bool {
    #[inline(always)]
    fn from(variant: SCL_EHD_A) -> Self {
        match variant {
            SCL_EHD_A::STANDARDFAST_MODE => false,
            SCL_EHD_A::FAST_MODE_PLUS_TRANSMIT => true,
        }
    }
}
#[doc = "Reader of field `SCL_EHD`"]
pub type SCL_EHD_R = crate::R<bool, SCL_EHD_A>;
impl SCL_EHD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SCL_EHD_A {
        match self.bits {
            false => SCL_EHD_A::STANDARDFAST_MODE,
            true => SCL_EHD_A::FAST_MODE_PLUS_TRANSMIT,
        }
    }
    #[doc = "Checks if the value of the field is `STANDARDFAST_MODE`"]
    #[inline(always)]
    pub fn is_standardfast_mode(&self) -> bool {
        *self == SCL_EHD_A::STANDARDFAST_MODE
    }
    #[doc = "Checks if the value of the field is `FAST_MODE_PLUS_TRANSMIT`"]
    #[inline(always)]
    pub fn is_fast_mode_plus_transmit(&self) -> bool {
        *self == SCL_EHD_A::FAST_MODE_PLUS_TRANSMIT
    }
}
#[doc = "Write proxy for field `SCL_EHD`"]
pub struct SCL_EHD_W<'a> {
    w: &'a mut W,
}
impl<'a> SCL_EHD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SCL_EHD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Standard/Fast mode transmit"]
    #[inline(always)]
    pub fn standardfast_mode(self) -> &'a mut W {
        self.variant(SCL_EHD_A::STANDARDFAST_MODE)
    }
    #[doc = "Fast-mode Plus transmit"]
    #[inline(always)]
    pub fn fast_mode_plus_transmit(self) -> &'a mut W {
        self.variant(SCL_EHD_A::FAST_MODE_PLUS_TRANSMIT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Enable the input receiver for the SCL pin. Always write a 1 to this bit when using the I2C0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SCL_EZI_A {
    #[doc = "0: Disabled"]
    DISABLED,
    #[doc = "1: Enabled"]
    ENABLED,
}
impl From<SCL_EZI_A> for bool {
    #[inline(always)]
    fn from(variant: SCL_EZI_A) -> Self {
        match variant {
            SCL_EZI_A::DISABLED => false,
            SCL_EZI_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `SCL_EZI`"]
pub type SCL_EZI_R = crate::R<bool, SCL_EZI_A>;
impl SCL_EZI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SCL_EZI_A {
        match self.bits {
            false => SCL_EZI_A::DISABLED,
            true => SCL_EZI_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == SCL_EZI_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == SCL_EZI_A::ENABLED
    }
}
#[doc = "Write proxy for field `SCL_EZI`"]
pub struct SCL_EZI_W<'a> {
    w: &'a mut W,
}
impl<'a> SCL_EZI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SCL_EZI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(SCL_EZI_A::DISABLED)
    }
    #[doc = "Enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(SCL_EZI_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Enable or disable input glitch filter for the SCL pin. The filter time constant is determined by bit EFP.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SCL_ZIF_A {
    #[doc = "0: Enable input filter"]
    ENABLE_INPUT_FILTER,
    #[doc = "1: Disable input filter"]
    DISABLE_INPUT_FILTER,
}
impl From<SCL_ZIF_A> for bool {
    #[inline(always)]
    fn from(variant: SCL_ZIF_A) -> Self {
        match variant {
            SCL_ZIF_A::ENABLE_INPUT_FILTER => false,
            SCL_ZIF_A::DISABLE_INPUT_FILTER => true,
        }
    }
}
#[doc = "Reader of field `SCL_ZIF`"]
pub type SCL_ZIF_R = crate::R<bool, SCL_ZIF_A>;
impl SCL_ZIF_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SCL_ZIF_A {
        match self.bits {
            false => SCL_ZIF_A::ENABLE_INPUT_FILTER,
            true => SCL_ZIF_A::DISABLE_INPUT_FILTER,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_INPUT_FILTER`"]
    #[inline(always)]
    pub fn is_enable_input_filter(&self) -> bool {
        *self == SCL_ZIF_A::ENABLE_INPUT_FILTER
    }
    #[doc = "Checks if the value of the field is `DISABLE_INPUT_FILTER`"]
    #[inline(always)]
    pub fn is_disable_input_filter(&self) -> bool {
        *self == SCL_ZIF_A::DISABLE_INPUT_FILTER
    }
}
#[doc = "Write proxy for field `SCL_ZIF`"]
pub struct SCL_ZIF_W<'a> {
    w: &'a mut W,
}
impl<'a> SCL_ZIF_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SCL_ZIF_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable input filter"]
    #[inline(always)]
    pub fn enable_input_filter(self) -> &'a mut W {
        self.variant(SCL_ZIF_A::ENABLE_INPUT_FILTER)
    }
    #[doc = "Disable input filter"]
    #[inline(always)]
    pub fn disable_input_filter(self) -> &'a mut W {
        self.variant(SCL_ZIF_A::DISABLE_INPUT_FILTER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Select input glitch filter time constant for the SDA pin.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDA_EFP_A {
    #[doc = "0: 50 ns glitch filter"]
    _50_NS_GLITCH_FILTER,
    #[doc = "1: 3 ns glitch filter"]
    _3_NS_GLITCH_FILTER,
}
impl From<SDA_EFP_A> for bool {
    #[inline(always)]
    fn from(variant: SDA_EFP_A) -> Self {
        match variant {
            SDA_EFP_A::_50_NS_GLITCH_FILTER => false,
            SDA_EFP_A::_3_NS_GLITCH_FILTER => true,
        }
    }
}
#[doc = "Reader of field `SDA_EFP`"]
pub type SDA_EFP_R = crate::R<bool, SDA_EFP_A>;
impl SDA_EFP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDA_EFP_A {
        match self.bits {
            false => SDA_EFP_A::_50_NS_GLITCH_FILTER,
            true => SDA_EFP_A::_3_NS_GLITCH_FILTER,
        }
    }
    #[doc = "Checks if the value of the field is `_50_NS_GLITCH_FILTER`"]
    #[inline(always)]
    pub fn is_50_ns_glitch_filter(&self) -> bool {
        *self == SDA_EFP_A::_50_NS_GLITCH_FILTER
    }
    #[doc = "Checks if the value of the field is `_3_NS_GLITCH_FILTER`"]
    #[inline(always)]
    pub fn is_3_ns_glitch_filter(&self) -> bool {
        *self == SDA_EFP_A::_3_NS_GLITCH_FILTER
    }
}
#[doc = "Write proxy for field `SDA_EFP`"]
pub struct SDA_EFP_W<'a> {
    w: &'a mut W,
}
impl<'a> SDA_EFP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDA_EFP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "50 ns glitch filter"]
    #[inline(always)]
    pub fn _50_ns_glitch_filter(self) -> &'a mut W {
        self.variant(SDA_EFP_A::_50_NS_GLITCH_FILTER)
    }
    #[doc = "3 ns glitch filter"]
    #[inline(always)]
    pub fn _3_ns_glitch_filter(self) -> &'a mut W {
        self.variant(SDA_EFP_A::_3_NS_GLITCH_FILTER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Select I2C mode for the SDA pin.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDA_EHD_A {
    #[doc = "0: Standard/Fast mode transmit"]
    STANDARDFAST_MODE,
    #[doc = "1: Fast-mode Plus transmit"]
    FAST_MODE_PLUS_TRANSMIT,
}
impl From<SDA_EHD_A> for bool {
    #[inline(always)]
    fn from(variant: SDA_EHD_A) -> Self {
        match variant {
            SDA_EHD_A::STANDARDFAST_MODE => false,
            SDA_EHD_A::FAST_MODE_PLUS_TRANSMIT => true,
        }
    }
}
#[doc = "Reader of field `SDA_EHD`"]
pub type SDA_EHD_R = crate::R<bool, SDA_EHD_A>;
impl SDA_EHD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDA_EHD_A {
        match self.bits {
            false => SDA_EHD_A::STANDARDFAST_MODE,
            true => SDA_EHD_A::FAST_MODE_PLUS_TRANSMIT,
        }
    }
    #[doc = "Checks if the value of the field is `STANDARDFAST_MODE`"]
    #[inline(always)]
    pub fn is_standardfast_mode(&self) -> bool {
        *self == SDA_EHD_A::STANDARDFAST_MODE
    }
    #[doc = "Checks if the value of the field is `FAST_MODE_PLUS_TRANSMIT`"]
    #[inline(always)]
    pub fn is_fast_mode_plus_transmit(&self) -> bool {
        *self == SDA_EHD_A::FAST_MODE_PLUS_TRANSMIT
    }
}
#[doc = "Write proxy for field `SDA_EHD`"]
pub struct SDA_EHD_W<'a> {
    w: &'a mut W,
}
impl<'a> SDA_EHD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDA_EHD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Standard/Fast mode transmit"]
    #[inline(always)]
    pub fn standardfast_mode(self) -> &'a mut W {
        self.variant(SDA_EHD_A::STANDARDFAST_MODE)
    }
    #[doc = "Fast-mode Plus transmit"]
    #[inline(always)]
    pub fn fast_mode_plus_transmit(self) -> &'a mut W {
        self.variant(SDA_EHD_A::FAST_MODE_PLUS_TRANSMIT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "Enable the input receiver for the SDA pin. Always write a 1 to this bit when using the I2C0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDA_EZI_A {
    #[doc = "0: Disabled"]
    DISABLED,
    #[doc = "1: Enabled"]
    ENABLED,
}
impl From<SDA_EZI_A> for bool {
    #[inline(always)]
    fn from(variant: SDA_EZI_A) -> Self {
        match variant {
            SDA_EZI_A::DISABLED => false,
            SDA_EZI_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `SDA_EZI`"]
pub type SDA_EZI_R = crate::R<bool, SDA_EZI_A>;
impl SDA_EZI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDA_EZI_A {
        match self.bits {
            false => SDA_EZI_A::DISABLED,
            true => SDA_EZI_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == SDA_EZI_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == SDA_EZI_A::ENABLED
    }
}
#[doc = "Write proxy for field `SDA_EZI`"]
pub struct SDA_EZI_W<'a> {
    w: &'a mut W,
}
impl<'a> SDA_EZI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDA_EZI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(SDA_EZI_A::DISABLED)
    }
    #[doc = "Enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(SDA_EZI_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Enable or disable input glitch filter for the SDA pin. The filter time constant is determined by bit SDA_EFP.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDA_ZIF_A {
    #[doc = "0: Enable input filter"]
    ENABLE_INPUT_FILTER,
    #[doc = "1: Disable input filter"]
    DISABLE_INPUT_FILTER,
}
impl From<SDA_ZIF_A> for bool {
    #[inline(always)]
    fn from(variant: SDA_ZIF_A) -> Self {
        match variant {
            SDA_ZIF_A::ENABLE_INPUT_FILTER => false,
            SDA_ZIF_A::DISABLE_INPUT_FILTER => true,
        }
    }
}
#[doc = "Reader of field `SDA_ZIF`"]
pub type SDA_ZIF_R = crate::R<bool, SDA_ZIF_A>;
impl SDA_ZIF_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDA_ZIF_A {
        match self.bits {
            false => SDA_ZIF_A::ENABLE_INPUT_FILTER,
            true => SDA_ZIF_A::DISABLE_INPUT_FILTER,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_INPUT_FILTER`"]
    #[inline(always)]
    pub fn is_enable_input_filter(&self) -> bool {
        *self == SDA_ZIF_A::ENABLE_INPUT_FILTER
    }
    #[doc = "Checks if the value of the field is `DISABLE_INPUT_FILTER`"]
    #[inline(always)]
    pub fn is_disable_input_filter(&self) -> bool {
        *self == SDA_ZIF_A::DISABLE_INPUT_FILTER
    }
}
#[doc = "Write proxy for field `SDA_ZIF`"]
pub struct SDA_ZIF_W<'a> {
    w: &'a mut W,
}
impl<'a> SDA_ZIF_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDA_ZIF_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enable input filter"]
    #[inline(always)]
    pub fn enable_input_filter(self) -> &'a mut W {
        self.variant(SDA_ZIF_A::ENABLE_INPUT_FILTER)
    }
    #[doc = "Disable input filter"]
    #[inline(always)]
    pub fn disable_input_filter(self) -> &'a mut W {
        self.variant(SDA_ZIF_A::DISABLE_INPUT_FILTER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Select input glitch filter time constant for the SCL pin."]
    #[inline(always)]
    pub fn scl_efp(&self) -> SCL_EFP_R {
        SCL_EFP_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 2 - Select I2C mode for the SCL pin."]
    #[inline(always)]
    pub fn scl_ehd(&self) -> SCL_EHD_R {
        SCL_EHD_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Enable the input receiver for the SCL pin. Always write a 1 to this bit when using the I2C0."]
    #[inline(always)]
    pub fn scl_ezi(&self) -> SCL_EZI_R {
        SCL_EZI_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Enable or disable input glitch filter for the SCL pin. The filter time constant is determined by bit EFP."]
    #[inline(always)]
    pub fn scl_zif(&self) -> SCL_ZIF_R {
        SCL_ZIF_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Select input glitch filter time constant for the SDA pin."]
    #[inline(always)]
    pub fn sda_efp(&self) -> SDA_EFP_R {
        SDA_EFP_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Select I2C mode for the SDA pin."]
    #[inline(always)]
    pub fn sda_ehd(&self) -> SDA_EHD_R {
        SDA_EHD_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Enable the input receiver for the SDA pin. Always write a 1 to this bit when using the I2C0."]
    #[inline(always)]
    pub fn sda_ezi(&self) -> SDA_EZI_R {
        SDA_EZI_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Enable or disable input glitch filter for the SDA pin. The filter time constant is determined by bit SDA_EFP."]
    #[inline(always)]
    pub fn sda_zif(&self) -> SDA_ZIF_R {
        SDA_ZIF_R::new(((self.bits >> 15) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Select input glitch filter time constant for the SCL pin."]
    #[inline(always)]
    pub fn scl_efp(&mut self) -> SCL_EFP_W {
        SCL_EFP_W { w: self }
    }
    #[doc = "Bit 2 - Select I2C mode for the SCL pin."]
    #[inline(always)]
    pub fn scl_ehd(&mut self) -> SCL_EHD_W {
        SCL_EHD_W { w: self }
    }
    #[doc = "Bit 3 - Enable the input receiver for the SCL pin. Always write a 1 to this bit when using the I2C0."]
    #[inline(always)]
    pub fn scl_ezi(&mut self) -> SCL_EZI_W {
        SCL_EZI_W { w: self }
    }
    #[doc = "Bit 7 - Enable or disable input glitch filter for the SCL pin. The filter time constant is determined by bit EFP."]
    #[inline(always)]
    pub fn scl_zif(&mut self) -> SCL_ZIF_W {
        SCL_ZIF_W { w: self }
    }
    #[doc = "Bit 8 - Select input glitch filter time constant for the SDA pin."]
    #[inline(always)]
    pub fn sda_efp(&mut self) -> SDA_EFP_W {
        SDA_EFP_W { w: self }
    }
    #[doc = "Bit 10 - Select I2C mode for the SDA pin."]
    #[inline(always)]
    pub fn sda_ehd(&mut self) -> SDA_EHD_W {
        SDA_EHD_W { w: self }
    }
    #[doc = "Bit 11 - Enable the input receiver for the SDA pin. Always write a 1 to this bit when using the I2C0."]
    #[inline(always)]
    pub fn sda_ezi(&mut self) -> SDA_EZI_W {
        SDA_EZI_W { w: self }
    }
    #[doc = "Bit 15 - Enable or disable input glitch filter for the SDA pin. The filter time constant is determined by bit SDA_EFP."]
    #[inline(always)]
    pub fn sda_zif(&mut self) -> SDA_ZIF_W {
        SDA_ZIF_W { w: self }
    }
}
