#[doc = "Reader of register SFSUSB"]
pub type R = crate::R<u32, super::SFSUSB>;
#[doc = "Writer for register SFSUSB"]
pub type W = crate::W<u32, super::SFSUSB>;
#[doc = "Register SFSUSB `reset()`'s with value 0x02"]
impl crate::ResetValue for super::SFSUSB {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x02
    }
}
#[doc = "Differential data input AIP/AIM.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB_AIM_A {
    #[doc = "0: Going LOW with full speed edge rate"]
    GOING_LOW_WITH_FULL,
    #[doc = "1: Going HIGH with full speed edge rate"]
    GOING_HIGH_WITH_FULL_SPEED_EDGE_RATE,
}
impl From<USB_AIM_A> for bool {
    #[inline(always)]
    fn from(variant: USB_AIM_A) -> Self {
        match variant {
            USB_AIM_A::GOING_LOW_WITH_FULL => false,
            USB_AIM_A::GOING_HIGH_WITH_FULL_SPEED_EDGE_RATE => true,
        }
    }
}
#[doc = "Reader of field `USB_AIM`"]
pub type USB_AIM_R = crate::R<bool, USB_AIM_A>;
impl USB_AIM_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB_AIM_A {
        match self.bits {
            false => USB_AIM_A::GOING_LOW_WITH_FULL,
            true => USB_AIM_A::GOING_HIGH_WITH_FULL_SPEED_EDGE_RATE,
        }
    }
    #[doc = "Checks if the value of the field is `GOING_LOW_WITH_FULL`"]
    #[inline(always)]
    pub fn is_going_low_with_full(&self) -> bool {
        *self == USB_AIM_A::GOING_LOW_WITH_FULL
    }
    #[doc = "Checks if the value of the field is `GOING_HIGH_WITH_FULL_SPEED_EDGE_RATE`"]
    #[inline(always)]
    pub fn is_going_high_with_full_speed_edge_rate(&self) -> bool {
        *self == USB_AIM_A::GOING_HIGH_WITH_FULL_SPEED_EDGE_RATE
    }
}
#[doc = "Write proxy for field `USB_AIM`"]
pub struct USB_AIM_W<'a> {
    w: &'a mut W,
}
impl<'a> USB_AIM_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB_AIM_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Going LOW with full speed edge rate"]
    #[inline(always)]
    pub fn going_low_with_full(self) -> &'a mut W {
        self.variant(USB_AIM_A::GOING_LOW_WITH_FULL)
    }
    #[doc = "Going HIGH with full speed edge rate"]
    #[inline(always)]
    pub fn going_high_with_full_speed_edge_rate(self) -> &'a mut W {
        self.variant(USB_AIM_A::GOING_HIGH_WITH_FULL_SPEED_EDGE_RATE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Control signal for differential input or single input.\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB_ESEA_A {
    #[doc = "1: Single input. Enables USB1. Use with the on-chip full-speed PHY."]
    SINGLE_INPUT,
}
impl From<USB_ESEA_A> for bool {
    #[inline(always)]
    fn from(variant: USB_ESEA_A) -> Self {
        match variant {
            USB_ESEA_A::SINGLE_INPUT => true,
        }
    }
}
#[doc = "Reader of field `USB_ESEA`"]
pub type USB_ESEA_R = crate::R<bool, USB_ESEA_A>;
impl USB_ESEA_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB_ESEA_A {
        match self.bits {
            true => USB_ESEA_A::SINGLE_INPUT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SINGLE_INPUT`"]
    #[inline(always)]
    pub fn is_single_input(&self) -> bool {
        *self == USB_ESEA_A::SINGLE_INPUT
    }
}
#[doc = "Write proxy for field `USB_ESEA`"]
pub struct USB_ESEA_W<'a> {
    w: &'a mut W,
}
impl<'a> USB_ESEA_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB_ESEA_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Single input. Enables USB1. Use with the on-chip full-speed PHY."]
    #[inline(always)]
    pub fn single_input(self) -> &'a mut W {
        self.variant(USB_ESEA_A::SINGLE_INPUT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Enable pull-down connect.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB_EPD_A {
    #[doc = "0: Pull-down disconnected"]
    PULL_DOWN_DISCONNECTED,
    #[doc = "1: Pull-down connected"]
    PULL_DOWN_CONNECTED,
}
impl From<USB_EPD_A> for bool {
    #[inline(always)]
    fn from(variant: USB_EPD_A) -> Self {
        match variant {
            USB_EPD_A::PULL_DOWN_DISCONNECTED => false,
            USB_EPD_A::PULL_DOWN_CONNECTED => true,
        }
    }
}
#[doc = "Reader of field `USB_EPD`"]
pub type USB_EPD_R = crate::R<bool, USB_EPD_A>;
impl USB_EPD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB_EPD_A {
        match self.bits {
            false => USB_EPD_A::PULL_DOWN_DISCONNECTED,
            true => USB_EPD_A::PULL_DOWN_CONNECTED,
        }
    }
    #[doc = "Checks if the value of the field is `PULL_DOWN_DISCONNECTED`"]
    #[inline(always)]
    pub fn is_pull_down_disconnected(&self) -> bool {
        *self == USB_EPD_A::PULL_DOWN_DISCONNECTED
    }
    #[doc = "Checks if the value of the field is `PULL_DOWN_CONNECTED`"]
    #[inline(always)]
    pub fn is_pull_down_connected(&self) -> bool {
        *self == USB_EPD_A::PULL_DOWN_CONNECTED
    }
}
#[doc = "Write proxy for field `USB_EPD`"]
pub struct USB_EPD_W<'a> {
    w: &'a mut W,
}
impl<'a> USB_EPD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB_EPD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Pull-down disconnected"]
    #[inline(always)]
    pub fn pull_down_disconnected(self) -> &'a mut W {
        self.variant(USB_EPD_A::PULL_DOWN_DISCONNECTED)
    }
    #[doc = "Pull-down connected"]
    #[inline(always)]
    pub fn pull_down_connected(self) -> &'a mut W {
        self.variant(USB_EPD_A::PULL_DOWN_CONNECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Power mode.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB_EPWR_A {
    #[doc = "0: Power saving mode (Suspend mode)"]
    POWER_SAVING_MODE_S,
    #[doc = "1: Normal mode"]
    NORMAL_MODE,
}
impl From<USB_EPWR_A> for bool {
    #[inline(always)]
    fn from(variant: USB_EPWR_A) -> Self {
        match variant {
            USB_EPWR_A::POWER_SAVING_MODE_S => false,
            USB_EPWR_A::NORMAL_MODE => true,
        }
    }
}
#[doc = "Reader of field `USB_EPWR`"]
pub type USB_EPWR_R = crate::R<bool, USB_EPWR_A>;
impl USB_EPWR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB_EPWR_A {
        match self.bits {
            false => USB_EPWR_A::POWER_SAVING_MODE_S,
            true => USB_EPWR_A::NORMAL_MODE,
        }
    }
    #[doc = "Checks if the value of the field is `POWER_SAVING_MODE_S`"]
    #[inline(always)]
    pub fn is_power_saving_mode_s(&self) -> bool {
        *self == USB_EPWR_A::POWER_SAVING_MODE_S
    }
    #[doc = "Checks if the value of the field is `NORMAL_MODE`"]
    #[inline(always)]
    pub fn is_normal_mode(&self) -> bool {
        *self == USB_EPWR_A::NORMAL_MODE
    }
}
#[doc = "Write proxy for field `USB_EPWR`"]
pub struct USB_EPWR_W<'a> {
    w: &'a mut W,
}
impl<'a> USB_EPWR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB_EPWR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Power saving mode (Suspend mode)"]
    #[inline(always)]
    pub fn power_saving_mode_s(self) -> &'a mut W {
        self.variant(USB_EPWR_A::POWER_SAVING_MODE_S)
    }
    #[doc = "Normal mode"]
    #[inline(always)]
    pub fn normal_mode(self) -> &'a mut W {
        self.variant(USB_EPWR_A::NORMAL_MODE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Enable the vbus_valid signal. This signal is monitored by the USB1 block. Use this bit for software de-bouncing of the VBUS sense signal or to indicate the VBUS state to the USB1 controller when the VBUS signal is present but the USB1_VBUS function is not connected in the SFSP2_5 register. The setting of this bit has no effect if the USB1_VBUS function of pin P2_5 is enabled through the SFSP2_5 register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USB_VBUS_A {
    #[doc = "0: VBUS signal LOW or inactive"]
    VBUS_SIGNAL_LOW_OR_INACTIVE,
    #[doc = "1: VBUS signal HIGH or active"]
    VBUS_SIGNAL_HIGH_OR_ACTIVE,
}
impl From<USB_VBUS_A> for bool {
    #[inline(always)]
    fn from(variant: USB_VBUS_A) -> Self {
        match variant {
            USB_VBUS_A::VBUS_SIGNAL_LOW_OR_INACTIVE => false,
            USB_VBUS_A::VBUS_SIGNAL_HIGH_OR_ACTIVE => true,
        }
    }
}
#[doc = "Reader of field `USB_VBUS`"]
pub type USB_VBUS_R = crate::R<bool, USB_VBUS_A>;
impl USB_VBUS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USB_VBUS_A {
        match self.bits {
            false => USB_VBUS_A::VBUS_SIGNAL_LOW_OR_INACTIVE,
            true => USB_VBUS_A::VBUS_SIGNAL_HIGH_OR_ACTIVE,
        }
    }
    #[doc = "Checks if the value of the field is `VBUS_SIGNAL_LOW_OR_INACTIVE`"]
    #[inline(always)]
    pub fn is_vbus_signal_low_or_inactive(&self) -> bool {
        *self == USB_VBUS_A::VBUS_SIGNAL_LOW_OR_INACTIVE
    }
    #[doc = "Checks if the value of the field is `VBUS_SIGNAL_HIGH_OR_ACTIVE`"]
    #[inline(always)]
    pub fn is_vbus_signal_high_or_active(&self) -> bool {
        *self == USB_VBUS_A::VBUS_SIGNAL_HIGH_OR_ACTIVE
    }
}
#[doc = "Write proxy for field `USB_VBUS`"]
pub struct USB_VBUS_W<'a> {
    w: &'a mut W,
}
impl<'a> USB_VBUS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USB_VBUS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "VBUS signal LOW or inactive"]
    #[inline(always)]
    pub fn vbus_signal_low_or_inactive(self) -> &'a mut W {
        self.variant(USB_VBUS_A::VBUS_SIGNAL_LOW_OR_INACTIVE)
    }
    #[doc = "VBUS signal HIGH or active"]
    #[inline(always)]
    pub fn vbus_signal_high_or_active(self) -> &'a mut W {
        self.variant(USB_VBUS_A::VBUS_SIGNAL_HIGH_OR_ACTIVE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Differential data input AIP/AIM."]
    #[inline(always)]
    pub fn usb_aim(&self) -> USB_AIM_R {
        USB_AIM_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Control signal for differential input or single input."]
    #[inline(always)]
    pub fn usb_esea(&self) -> USB_ESEA_R {
        USB_ESEA_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Enable pull-down connect."]
    #[inline(always)]
    pub fn usb_epd(&self) -> USB_EPD_R {
        USB_EPD_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Power mode."]
    #[inline(always)]
    pub fn usb_epwr(&self) -> USB_EPWR_R {
        USB_EPWR_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Enable the vbus_valid signal. This signal is monitored by the USB1 block. Use this bit for software de-bouncing of the VBUS sense signal or to indicate the VBUS state to the USB1 controller when the VBUS signal is present but the USB1_VBUS function is not connected in the SFSP2_5 register. The setting of this bit has no effect if the USB1_VBUS function of pin P2_5 is enabled through the SFSP2_5 register."]
    #[inline(always)]
    pub fn usb_vbus(&self) -> USB_VBUS_R {
        USB_VBUS_R::new(((self.bits >> 5) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Differential data input AIP/AIM."]
    #[inline(always)]
    pub fn usb_aim(&mut self) -> USB_AIM_W {
        USB_AIM_W { w: self }
    }
    #[doc = "Bit 1 - Control signal for differential input or single input."]
    #[inline(always)]
    pub fn usb_esea(&mut self) -> USB_ESEA_W {
        USB_ESEA_W { w: self }
    }
    #[doc = "Bit 2 - Enable pull-down connect."]
    #[inline(always)]
    pub fn usb_epd(&mut self) -> USB_EPD_W {
        USB_EPD_W { w: self }
    }
    #[doc = "Bit 4 - Power mode."]
    #[inline(always)]
    pub fn usb_epwr(&mut self) -> USB_EPWR_W {
        USB_EPWR_W { w: self }
    }
    #[doc = "Bit 5 - Enable the vbus_valid signal. This signal is monitored by the USB1 block. Use this bit for software de-bouncing of the VBUS sense signal or to indicate the VBUS state to the USB1 controller when the VBUS signal is present but the USB1_VBUS function is not connected in the SFSP2_5 register. The setting of this bit has no effect if the USB1_VBUS function of pin P2_5 is enabled through the SFSP2_5 register."]
    #[inline(always)]
    pub fn usb_vbus(&mut self) -> USB_VBUS_W {
        USB_VBUS_W { w: self }
    }
}
