#[doc = "Reader of register BMOD"]
pub type R = crate::R<u32, super::BMOD>;
#[doc = "Writer for register BMOD"]
pub type W = crate::W<u32, super::BMOD>;
#[doc = "Register BMOD `reset()`'s with value 0"]
impl crate::ResetValue for super::BMOD {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `SWR`"]
pub type SWR_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `SWR`"]
pub struct SWR_W<'a> {
    w: &'a mut W,
}
impl<'a> SWR_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Reader of field `FB`"]
pub type FB_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `FB`"]
pub struct FB_W<'a> {
    w: &'a mut W,
}
impl<'a> FB_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Reader of field `DSL`"]
pub type DSL_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `DSL`"]
pub struct DSL_W<'a> {
    w: &'a mut W,
}
impl<'a> DSL_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 2)) | (((value as u32) & 0x1f) << 2);
        self.w
    }
}
#[doc = "Reader of field `DE`"]
pub type DE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DE`"]
pub struct DE_W<'a> {
    w: &'a mut W,
}
impl<'a> DE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Programmable Burst Length. These bits indicate the maximum number of beats to be performed in one SD/MMC DMA transaction. The SD/MMC DMA will always attempt to burst as specified in PBL each time it starts a Burst transfer on the host bus. The permissible values are 1, 4, 8, 16, 32, 64, 128 and 256. This value is the mirror of MSIZE of FIFOTH register. In order to change this value, write the required value to FIFOTH register. This is an encode value as follows.Transfer unit is 32 bit. PBL is a read-only value.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PBL_A {
    #[doc = "0: 1 transfer"]
    _1_TRANSFER,
    #[doc = "1: 4 transfers"]
    _4_TRANSFERS,
    #[doc = "2: 8 transfers"]
    _8_TRANSFERS,
    #[doc = "3: 16 transfers"]
    _16_TRANSFERS,
    #[doc = "4: 32 transfers"]
    _32_TRANSFERS,
    #[doc = "5: 64 transfers"]
    _64_TRANSFERS,
    #[doc = "6: 128 transfers"]
    _128_TRANSFERS,
    #[doc = "7: 256 transfers"]
    _256_TRANSFERS,
}
impl From<PBL_A> for u8 {
    #[inline(always)]
    fn from(variant: PBL_A) -> Self {
        match variant {
            PBL_A::_1_TRANSFER => 0,
            PBL_A::_4_TRANSFERS => 1,
            PBL_A::_8_TRANSFERS => 2,
            PBL_A::_16_TRANSFERS => 3,
            PBL_A::_32_TRANSFERS => 4,
            PBL_A::_64_TRANSFERS => 5,
            PBL_A::_128_TRANSFERS => 6,
            PBL_A::_256_TRANSFERS => 7,
        }
    }
}
#[doc = "Reader of field `PBL`"]
pub type PBL_R = crate::R<u8, PBL_A>;
impl PBL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PBL_A {
        match self.bits {
            0 => PBL_A::_1_TRANSFER,
            1 => PBL_A::_4_TRANSFERS,
            2 => PBL_A::_8_TRANSFERS,
            3 => PBL_A::_16_TRANSFERS,
            4 => PBL_A::_32_TRANSFERS,
            5 => PBL_A::_64_TRANSFERS,
            6 => PBL_A::_128_TRANSFERS,
            7 => PBL_A::_256_TRANSFERS,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `_1_TRANSFER`"]
    #[inline(always)]
    pub fn is_1_transfer(&self) -> bool {
        *self == PBL_A::_1_TRANSFER
    }
    #[doc = "Checks if the value of the field is `_4_TRANSFERS`"]
    #[inline(always)]
    pub fn is_4_transfers(&self) -> bool {
        *self == PBL_A::_4_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_8_TRANSFERS`"]
    #[inline(always)]
    pub fn is_8_transfers(&self) -> bool {
        *self == PBL_A::_8_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_16_TRANSFERS`"]
    #[inline(always)]
    pub fn is_16_transfers(&self) -> bool {
        *self == PBL_A::_16_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_32_TRANSFERS`"]
    #[inline(always)]
    pub fn is_32_transfers(&self) -> bool {
        *self == PBL_A::_32_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_64_TRANSFERS`"]
    #[inline(always)]
    pub fn is_64_transfers(&self) -> bool {
        *self == PBL_A::_64_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_128_TRANSFERS`"]
    #[inline(always)]
    pub fn is_128_transfers(&self) -> bool {
        *self == PBL_A::_128_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_256_TRANSFERS`"]
    #[inline(always)]
    pub fn is_256_transfers(&self) -> bool {
        *self == PBL_A::_256_TRANSFERS
    }
}
#[doc = "Write proxy for field `PBL`"]
pub struct PBL_W<'a> {
    w: &'a mut W,
}
impl<'a> PBL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PBL_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "1 transfer"]
    #[inline(always)]
    pub fn _1_transfer(self) -> &'a mut W {
        self.variant(PBL_A::_1_TRANSFER)
    }
    #[doc = "4 transfers"]
    #[inline(always)]
    pub fn _4_transfers(self) -> &'a mut W {
        self.variant(PBL_A::_4_TRANSFERS)
    }
    #[doc = "8 transfers"]
    #[inline(always)]
    pub fn _8_transfers(self) -> &'a mut W {
        self.variant(PBL_A::_8_TRANSFERS)
    }
    #[doc = "16 transfers"]
    #[inline(always)]
    pub fn _16_transfers(self) -> &'a mut W {
        self.variant(PBL_A::_16_TRANSFERS)
    }
    #[doc = "32 transfers"]
    #[inline(always)]
    pub fn _32_transfers(self) -> &'a mut W {
        self.variant(PBL_A::_32_TRANSFERS)
    }
    #[doc = "64 transfers"]
    #[inline(always)]
    pub fn _64_transfers(self) -> &'a mut W {
        self.variant(PBL_A::_64_TRANSFERS)
    }
    #[doc = "128 transfers"]
    #[inline(always)]
    pub fn _128_transfers(self) -> &'a mut W {
        self.variant(PBL_A::_128_TRANSFERS)
    }
    #[doc = "256 transfers"]
    #[inline(always)]
    pub fn _256_transfers(self) -> &'a mut W {
        self.variant(PBL_A::_256_TRANSFERS)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 8)) | (((value as u32) & 0x07) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Software Reset. When set, the DMA Controller resets all its internal registers. SWR is read/write. It is automatically cleared after 1 clock cycle."]
    #[inline(always)]
    pub fn swr(&self) -> SWR_R {
        SWR_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Fixed Burst. Controls whether the AHB Master interface performs fixed burst transfers or not. When set, the AHB will use only SINGLE, INCR4, INCR8 or INCR16 during start of normal burst transfers. When reset, the AHB will use SINGLE and INCR burst transfer operations. FB is read/write."]
    #[inline(always)]
    pub fn fb(&self) -> FB_R {
        FB_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bits 2:6 - Descriptor Skip Length. Specifies the number of HWord/Word/Dword to skip between two unchained descriptors. This is applicable only for dual buffer structure. DSL is read/write."]
    #[inline(always)]
    pub fn dsl(&self) -> DSL_R {
        DSL_R::new(((self.bits >> 2) & 0x1f) as u8)
    }
    #[doc = "Bit 7 - SD/MMC DMA Enable. When set, the SD/MMC DMA is enabled. DE is read/write."]
    #[inline(always)]
    pub fn de(&self) -> DE_R {
        DE_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bits 8:10 - Programmable Burst Length. These bits indicate the maximum number of beats to be performed in one SD/MMC DMA transaction. The SD/MMC DMA will always attempt to burst as specified in PBL each time it starts a Burst transfer on the host bus. The permissible values are 1, 4, 8, 16, 32, 64, 128 and 256. This value is the mirror of MSIZE of FIFOTH register. In order to change this value, write the required value to FIFOTH register. This is an encode value as follows.Transfer unit is 32 bit. PBL is a read-only value."]
    #[inline(always)]
    pub fn pbl(&self) -> PBL_R {
        PBL_R::new(((self.bits >> 8) & 0x07) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Software Reset. When set, the DMA Controller resets all its internal registers. SWR is read/write. It is automatically cleared after 1 clock cycle."]
    #[inline(always)]
    pub fn swr(&mut self) -> SWR_W {
        SWR_W { w: self }
    }
    #[doc = "Bit 1 - Fixed Burst. Controls whether the AHB Master interface performs fixed burst transfers or not. When set, the AHB will use only SINGLE, INCR4, INCR8 or INCR16 during start of normal burst transfers. When reset, the AHB will use SINGLE and INCR burst transfer operations. FB is read/write."]
    #[inline(always)]
    pub fn fb(&mut self) -> FB_W {
        FB_W { w: self }
    }
    #[doc = "Bits 2:6 - Descriptor Skip Length. Specifies the number of HWord/Word/Dword to skip between two unchained descriptors. This is applicable only for dual buffer structure. DSL is read/write."]
    #[inline(always)]
    pub fn dsl(&mut self) -> DSL_W {
        DSL_W { w: self }
    }
    #[doc = "Bit 7 - SD/MMC DMA Enable. When set, the SD/MMC DMA is enabled. DE is read/write."]
    #[inline(always)]
    pub fn de(&mut self) -> DE_W {
        DE_W { w: self }
    }
    #[doc = "Bits 8:10 - Programmable Burst Length. These bits indicate the maximum number of beats to be performed in one SD/MMC DMA transaction. The SD/MMC DMA will always attempt to burst as specified in PBL each time it starts a Burst transfer on the host bus. The permissible values are 1, 4, 8, 16, 32, 64, 128 and 256. This value is the mirror of MSIZE of FIFOTH register. In order to change this value, write the required value to FIFOTH register. This is an encode value as follows.Transfer unit is 32 bit. PBL is a read-only value."]
    #[inline(always)]
    pub fn pbl(&mut self) -> PBL_W {
        PBL_W { w: self }
    }
}
