#[doc = "Reader of register CLKDIV"]
pub type R = crate::R<u32, super::CLKDIV>;
#[doc = "Writer for register CLKDIV"]
pub type W = crate::W<u32, super::CLKDIV>;
#[doc = "Register CLKDIV `reset()`'s with value 0"]
impl crate::ResetValue for super::CLKDIV {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `CLK_DIVIDER0`"]
pub type CLK_DIVIDER0_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `CLK_DIVIDER0`"]
pub struct CLK_DIVIDER0_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_DIVIDER0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | ((value as u32) & 0xff);
        self.w
    }
}
#[doc = "Reader of field `CLK_DIVIDER1`"]
pub type CLK_DIVIDER1_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `CLK_DIVIDER1`"]
pub struct CLK_DIVIDER1_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_DIVIDER1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | (((value as u32) & 0xff) << 8);
        self.w
    }
}
#[doc = "Reader of field `CLK_DIVIDER2`"]
pub type CLK_DIVIDER2_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `CLK_DIVIDER2`"]
pub struct CLK_DIVIDER2_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_DIVIDER2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 16)) | (((value as u32) & 0xff) << 16);
        self.w
    }
}
#[doc = "Reader of field `CLK_DIVIDER3`"]
pub type CLK_DIVIDER3_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `CLK_DIVIDER3`"]
pub struct CLK_DIVIDER3_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_DIVIDER3_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 24)) | (((value as u32) & 0xff) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Clock divider-0 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on."]
    #[inline(always)]
    pub fn clk_divider0(&self) -> CLK_DIVIDER0_R {
        CLK_DIVIDER0_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Clock divider-1 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported."]
    #[inline(always)]
    pub fn clk_divider1(&self) -> CLK_DIVIDER1_R {
        CLK_DIVIDER1_R::new(((self.bits >> 8) & 0xff) as u8)
    }
    #[doc = "Bits 16:23 - Clock divider-2 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported."]
    #[inline(always)]
    pub fn clk_divider2(&self) -> CLK_DIVIDER2_R {
        CLK_DIVIDER2_R::new(((self.bits >> 16) & 0xff) as u8)
    }
    #[doc = "Bits 24:31 - Clock divider-3 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), a value of 1 means divide by 2*1 = 2, a value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported. divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported."]
    #[inline(always)]
    pub fn clk_divider3(&self) -> CLK_DIVIDER3_R {
        CLK_DIVIDER3_R::new(((self.bits >> 24) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Clock divider-0 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on."]
    #[inline(always)]
    pub fn clk_divider0(&mut self) -> CLK_DIVIDER0_W {
        CLK_DIVIDER0_W { w: self }
    }
    #[doc = "Bits 8:15 - Clock divider-1 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported."]
    #[inline(always)]
    pub fn clk_divider1(&mut self) -> CLK_DIVIDER1_W {
        CLK_DIVIDER1_W { w: self }
    }
    #[doc = "Bits 16:23 - Clock divider-2 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported."]
    #[inline(always)]
    pub fn clk_divider2(&mut self) -> CLK_DIVIDER2_W {
        CLK_DIVIDER2_W { w: self }
    }
    #[doc = "Bits 24:31 - Clock divider-3 value. Clock division is 2*n. For example, value of 0 means divide by 2*0 = 0 (no division, bypass), a value of 1 means divide by 2*1 = 2, a value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported. divide by 2*0 = 0 (no division, bypass), value of 1 means divide by 2*1 = 2, value of ff means divide by 2*255 = 510, and so on. In MMC-Ver3.3-only mode, bits not implemented because only one clock divider is supported."]
    #[inline(always)]
    pub fn clk_divider3(&mut self) -> CLK_DIVIDER3_W {
        CLK_DIVIDER3_W { w: self }
    }
}
