#[doc = "Reader of register CLKENA"]
pub type R = crate::R<u32, super::CLKENA>;
#[doc = "Writer for register CLKENA"]
pub type W = crate::W<u32, super::CLKENA>;
#[doc = "Register CLKENA `reset()`'s with value 0"]
impl crate::ResetValue for super::CLKENA {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `CCLK_ENABLE`"]
pub type CCLK_ENABLE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `CCLK_ENABLE`"]
pub struct CCLK_ENABLE_W<'a> {
    w: &'a mut W,
}
impl<'a> CCLK_ENABLE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_0`"]
pub type RESERVED_0_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `RESERVED_0`"]
pub struct RESERVED_0_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x7fff << 1)) | (((value as u32) & 0x7fff) << 1);
        self.w
    }
}
#[doc = "Reader of field `CCLK_LOW_POWER`"]
pub type CCLK_LOW_POWER_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `CCLK_LOW_POWER`"]
pub struct CCLK_LOW_POWER_W<'a> {
    w: &'a mut W,
}
impl<'a> CCLK_LOW_POWER_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Reader of field `RESERVED_1`"]
pub type RESERVED_1_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `RESERVED_1`"]
pub struct RESERVED_1_W<'a> {
    w: &'a mut W,
}
impl<'a> RESERVED_1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x7fff << 17)) | (((value as u32) & 0x7fff) << 17);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Clock-enable control for SD card clock. One MMC card clock supported. 0 - Clock disabled 1 - Clock enabled"]
    #[inline(always)]
    pub fn cclk_enable(&self) -> CCLK_ENABLE_R {
        CCLK_ENABLE_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 1:15 - Reserved"]
    #[inline(always)]
    pub fn reserved_0(&self) -> RESERVED_0_R {
        RESERVED_0_R::new(((self.bits >> 1) & 0x7fff) as u16)
    }
    #[doc = "Bit 16 - Low-power control for SD card clock. One MMC card clock supported. 0 - Non-low-power mode 1 - Low-power mode; stop clock when card in IDLE (should be normally set to only MMC and SD memory cards; for SDIO cards, if interrupts must be detected, clock should not be stopped)."]
    #[inline(always)]
    pub fn cclk_low_power(&self) -> CCLK_LOW_POWER_R {
        CCLK_LOW_POWER_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bits 17:31 - Reserved"]
    #[inline(always)]
    pub fn reserved_1(&self) -> RESERVED_1_R {
        RESERVED_1_R::new(((self.bits >> 17) & 0x7fff) as u16)
    }
}
impl W {
    #[doc = "Bit 0 - Clock-enable control for SD card clock. One MMC card clock supported. 0 - Clock disabled 1 - Clock enabled"]
    #[inline(always)]
    pub fn cclk_enable(&mut self) -> CCLK_ENABLE_W {
        CCLK_ENABLE_W { w: self }
    }
    #[doc = "Bits 1:15 - Reserved"]
    #[inline(always)]
    pub fn reserved_0(&mut self) -> RESERVED_0_W {
        RESERVED_0_W { w: self }
    }
    #[doc = "Bit 16 - Low-power control for SD card clock. One MMC card clock supported. 0 - Non-low-power mode 1 - Low-power mode; stop clock when card in IDLE (should be normally set to only MMC and SD memory cards; for SDIO cards, if interrupts must be detected, clock should not be stopped)."]
    #[inline(always)]
    pub fn cclk_low_power(&mut self) -> CCLK_LOW_POWER_W {
        CCLK_LOW_POWER_W { w: self }
    }
    #[doc = "Bits 17:31 - Reserved"]
    #[inline(always)]
    pub fn reserved_1(&mut self) -> RESERVED_1_W {
        RESERVED_1_W { w: self }
    }
}
