#[doc = "Reader of register CMD"]
pub type R = crate::R<u32, super::CMD>;
#[doc = "Writer for register CMD"]
pub type W = crate::W<u32, super::CMD>;
#[doc = "Register CMD `reset()`'s with value 0"]
impl crate::ResetValue for super::CMD {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `CMD_INDEX`"]
pub type CMD_INDEX_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `CMD_INDEX`"]
pub struct CMD_INDEX_W<'a> {
    w: &'a mut W,
}
impl<'a> CMD_INDEX_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x3f) | ((value as u32) & 0x3f);
        self.w
    }
}
#[doc = "Response expect\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RESPONSE_EXPECT_A {
    #[doc = "0: None. No response expected from card"]
    NONE,
    #[doc = "1: Expected. Response expected from card"]
    EXPECTED,
}
impl From<RESPONSE_EXPECT_A> for bool {
    #[inline(always)]
    fn from(variant: RESPONSE_EXPECT_A) -> Self {
        match variant {
            RESPONSE_EXPECT_A::NONE => false,
            RESPONSE_EXPECT_A::EXPECTED => true,
        }
    }
}
#[doc = "Reader of field `RESPONSE_EXPECT`"]
pub type RESPONSE_EXPECT_R = crate::R<bool, RESPONSE_EXPECT_A>;
impl RESPONSE_EXPECT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RESPONSE_EXPECT_A {
        match self.bits {
            false => RESPONSE_EXPECT_A::NONE,
            true => RESPONSE_EXPECT_A::EXPECTED,
        }
    }
    #[doc = "Checks if the value of the field is `NONE`"]
    #[inline(always)]
    pub fn is_none(&self) -> bool {
        *self == RESPONSE_EXPECT_A::NONE
    }
    #[doc = "Checks if the value of the field is `EXPECTED`"]
    #[inline(always)]
    pub fn is_expected(&self) -> bool {
        *self == RESPONSE_EXPECT_A::EXPECTED
    }
}
#[doc = "Write proxy for field `RESPONSE_EXPECT`"]
pub struct RESPONSE_EXPECT_W<'a> {
    w: &'a mut W,
}
impl<'a> RESPONSE_EXPECT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RESPONSE_EXPECT_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "None. No response expected from card"]
    #[inline(always)]
    pub fn none(self) -> &'a mut W {
        self.variant(RESPONSE_EXPECT_A::NONE)
    }
    #[doc = "Expected. Response expected from card"]
    #[inline(always)]
    pub fn expected(self) -> &'a mut W {
        self.variant(RESPONSE_EXPECT_A::EXPECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Response length\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RESPONSE_LENGTH_A {
    #[doc = "0: Short. Short response expected from card"]
    SHORT,
    #[doc = "1: Long. Long response expected from card"]
    LONG,
}
impl From<RESPONSE_LENGTH_A> for bool {
    #[inline(always)]
    fn from(variant: RESPONSE_LENGTH_A) -> Self {
        match variant {
            RESPONSE_LENGTH_A::SHORT => false,
            RESPONSE_LENGTH_A::LONG => true,
        }
    }
}
#[doc = "Reader of field `RESPONSE_LENGTH`"]
pub type RESPONSE_LENGTH_R = crate::R<bool, RESPONSE_LENGTH_A>;
impl RESPONSE_LENGTH_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RESPONSE_LENGTH_A {
        match self.bits {
            false => RESPONSE_LENGTH_A::SHORT,
            true => RESPONSE_LENGTH_A::LONG,
        }
    }
    #[doc = "Checks if the value of the field is `SHORT`"]
    #[inline(always)]
    pub fn is_short(&self) -> bool {
        *self == RESPONSE_LENGTH_A::SHORT
    }
    #[doc = "Checks if the value of the field is `LONG`"]
    #[inline(always)]
    pub fn is_long(&self) -> bool {
        *self == RESPONSE_LENGTH_A::LONG
    }
}
#[doc = "Write proxy for field `RESPONSE_LENGTH`"]
pub struct RESPONSE_LENGTH_W<'a> {
    w: &'a mut W,
}
impl<'a> RESPONSE_LENGTH_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RESPONSE_LENGTH_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Short. Short response expected from card"]
    #[inline(always)]
    pub fn short(self) -> &'a mut W {
        self.variant(RESPONSE_LENGTH_A::SHORT)
    }
    #[doc = "Long. Long response expected from card"]
    #[inline(always)]
    pub fn long(self) -> &'a mut W {
        self.variant(RESPONSE_LENGTH_A::LONG)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Check response crc. Some of command responses do not return valid CRC bits. Software should disable CRC checks for those commands in order to disable CRC checking by controller.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CHECK_RESPONSE_CRC_A {
    #[doc = "0: Do not check response CRC"]
    DO_NOT_CHECK_RESPONSE_CRC,
    #[doc = "1: Check response CRC"]
    CHECK_RESPONSE_CRC,
}
impl From<CHECK_RESPONSE_CRC_A> for bool {
    #[inline(always)]
    fn from(variant: CHECK_RESPONSE_CRC_A) -> Self {
        match variant {
            CHECK_RESPONSE_CRC_A::DO_NOT_CHECK_RESPONSE_CRC => false,
            CHECK_RESPONSE_CRC_A::CHECK_RESPONSE_CRC => true,
        }
    }
}
#[doc = "Reader of field `CHECK_RESPONSE_CRC`"]
pub type CHECK_RESPONSE_CRC_R = crate::R<bool, CHECK_RESPONSE_CRC_A>;
impl CHECK_RESPONSE_CRC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CHECK_RESPONSE_CRC_A {
        match self.bits {
            false => CHECK_RESPONSE_CRC_A::DO_NOT_CHECK_RESPONSE_CRC,
            true => CHECK_RESPONSE_CRC_A::CHECK_RESPONSE_CRC,
        }
    }
    #[doc = "Checks if the value of the field is `DO_NOT_CHECK_RESPONSE_CRC`"]
    #[inline(always)]
    pub fn is_do_not_check_response_crc(&self) -> bool {
        *self == CHECK_RESPONSE_CRC_A::DO_NOT_CHECK_RESPONSE_CRC
    }
    #[doc = "Checks if the value of the field is `CHECK_RESPONSE_CRC`"]
    #[inline(always)]
    pub fn is_check_response_crc(&self) -> bool {
        *self == CHECK_RESPONSE_CRC_A::CHECK_RESPONSE_CRC
    }
}
#[doc = "Write proxy for field `CHECK_RESPONSE_CRC`"]
pub struct CHECK_RESPONSE_CRC_W<'a> {
    w: &'a mut W,
}
impl<'a> CHECK_RESPONSE_CRC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CHECK_RESPONSE_CRC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Do not check response CRC"]
    #[inline(always)]
    pub fn do_not_check_response_crc(self) -> &'a mut W {
        self.variant(CHECK_RESPONSE_CRC_A::DO_NOT_CHECK_RESPONSE_CRC)
    }
    #[doc = "Check response CRC"]
    #[inline(always)]
    pub fn check_response_crc(self) -> &'a mut W {
        self.variant(CHECK_RESPONSE_CRC_A::CHECK_RESPONSE_CRC)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Data expected\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DATA_EXPECTED_A {
    #[doc = "0: None. No data transfer expected (read/write)"]
    NONE,
    #[doc = "1: Data. Data transfer expected (read/write)"]
    DATA,
}
impl From<DATA_EXPECTED_A> for bool {
    #[inline(always)]
    fn from(variant: DATA_EXPECTED_A) -> Self {
        match variant {
            DATA_EXPECTED_A::NONE => false,
            DATA_EXPECTED_A::DATA => true,
        }
    }
}
#[doc = "Reader of field `DATA_EXPECTED`"]
pub type DATA_EXPECTED_R = crate::R<bool, DATA_EXPECTED_A>;
impl DATA_EXPECTED_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DATA_EXPECTED_A {
        match self.bits {
            false => DATA_EXPECTED_A::NONE,
            true => DATA_EXPECTED_A::DATA,
        }
    }
    #[doc = "Checks if the value of the field is `NONE`"]
    #[inline(always)]
    pub fn is_none(&self) -> bool {
        *self == DATA_EXPECTED_A::NONE
    }
    #[doc = "Checks if the value of the field is `DATA`"]
    #[inline(always)]
    pub fn is_data(&self) -> bool {
        *self == DATA_EXPECTED_A::DATA
    }
}
#[doc = "Write proxy for field `DATA_EXPECTED`"]
pub struct DATA_EXPECTED_W<'a> {
    w: &'a mut W,
}
impl<'a> DATA_EXPECTED_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DATA_EXPECTED_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "None. No data transfer expected (read/write)"]
    #[inline(always)]
    pub fn none(self) -> &'a mut W {
        self.variant(DATA_EXPECTED_A::NONE)
    }
    #[doc = "Data. Data transfer expected (read/write)"]
    #[inline(always)]
    pub fn data(self) -> &'a mut W {
        self.variant(DATA_EXPECTED_A::DATA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "read/write. Don't care if no data expected from card.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum READ_WRITE_A {
    #[doc = "0: Read from card"]
    READ_FROM_CARD,
    #[doc = "1: Write to card"]
    WRITE_TO_CARD,
}
impl From<READ_WRITE_A> for bool {
    #[inline(always)]
    fn from(variant: READ_WRITE_A) -> Self {
        match variant {
            READ_WRITE_A::READ_FROM_CARD => false,
            READ_WRITE_A::WRITE_TO_CARD => true,
        }
    }
}
#[doc = "Reader of field `READ_WRITE`"]
pub type READ_WRITE_R = crate::R<bool, READ_WRITE_A>;
impl READ_WRITE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> READ_WRITE_A {
        match self.bits {
            false => READ_WRITE_A::READ_FROM_CARD,
            true => READ_WRITE_A::WRITE_TO_CARD,
        }
    }
    #[doc = "Checks if the value of the field is `READ_FROM_CARD`"]
    #[inline(always)]
    pub fn is_read_from_card(&self) -> bool {
        *self == READ_WRITE_A::READ_FROM_CARD
    }
    #[doc = "Checks if the value of the field is `WRITE_TO_CARD`"]
    #[inline(always)]
    pub fn is_write_to_card(&self) -> bool {
        *self == READ_WRITE_A::WRITE_TO_CARD
    }
}
#[doc = "Write proxy for field `READ_WRITE`"]
pub struct READ_WRITE_W<'a> {
    w: &'a mut W,
}
impl<'a> READ_WRITE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: READ_WRITE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Read from card"]
    #[inline(always)]
    pub fn read_from_card(self) -> &'a mut W {
        self.variant(READ_WRITE_A::READ_FROM_CARD)
    }
    #[doc = "Write to card"]
    #[inline(always)]
    pub fn write_to_card(self) -> &'a mut W {
        self.variant(READ_WRITE_A::WRITE_TO_CARD)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "Transfer mode. Don't care if no data expected.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TRANSFER_MODE_A {
    #[doc = "0: Block data transfer command"]
    BLOCK_DATA_TRANSFER,
    #[doc = "1: Stream data transfer command"]
    STREAM_DATA_TRANSFER_COMMAND,
}
impl From<TRANSFER_MODE_A> for bool {
    #[inline(always)]
    fn from(variant: TRANSFER_MODE_A) -> Self {
        match variant {
            TRANSFER_MODE_A::BLOCK_DATA_TRANSFER => false,
            TRANSFER_MODE_A::STREAM_DATA_TRANSFER_COMMAND => true,
        }
    }
}
#[doc = "Reader of field `TRANSFER_MODE`"]
pub type TRANSFER_MODE_R = crate::R<bool, TRANSFER_MODE_A>;
impl TRANSFER_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TRANSFER_MODE_A {
        match self.bits {
            false => TRANSFER_MODE_A::BLOCK_DATA_TRANSFER,
            true => TRANSFER_MODE_A::STREAM_DATA_TRANSFER_COMMAND,
        }
    }
    #[doc = "Checks if the value of the field is `BLOCK_DATA_TRANSFER`"]
    #[inline(always)]
    pub fn is_block_data_transfer(&self) -> bool {
        *self == TRANSFER_MODE_A::BLOCK_DATA_TRANSFER
    }
    #[doc = "Checks if the value of the field is `STREAM_DATA_TRANSFER_COMMAND`"]
    #[inline(always)]
    pub fn is_stream_data_transfer_command(&self) -> bool {
        *self == TRANSFER_MODE_A::STREAM_DATA_TRANSFER_COMMAND
    }
}
#[doc = "Write proxy for field `TRANSFER_MODE`"]
pub struct TRANSFER_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> TRANSFER_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TRANSFER_MODE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Block data transfer command"]
    #[inline(always)]
    pub fn block_data_transfer(self) -> &'a mut W {
        self.variant(TRANSFER_MODE_A::BLOCK_DATA_TRANSFER)
    }
    #[doc = "Stream data transfer command"]
    #[inline(always)]
    pub fn stream_data_transfer_command(self) -> &'a mut W {
        self.variant(TRANSFER_MODE_A::STREAM_DATA_TRANSFER_COMMAND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Send auto stop. When set, the SD/MMC interface sends stop command to SD_MMC_CEATA cards at end of data transfer. Refer to Table 339 to determine: - when send_auto_stop bit should be set, since some data transfers do not need explicit stop commands - open-ended transfers that software should explicitly send to stop command Additionally, when resume is sent to resume - suspended memory access of SD-Combo card - bit should be set correctly if suspended data transfer needs send_auto_stop. Don't care if no data expected from card.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SEND_AUTO_STOP_A {
    #[doc = "0: No stop command sent at end of data transfer"]
    NO_STOP_COMMAND_SENT_AT_END_OF_TRANSFER,
    #[doc = "1: Send stop command at end of data transfer"]
    SEND_STOP_COMMAND_AT_END_OF_TRANSFER,
}
impl From<SEND_AUTO_STOP_A> for bool {
    #[inline(always)]
    fn from(variant: SEND_AUTO_STOP_A) -> Self {
        match variant {
            SEND_AUTO_STOP_A::NO_STOP_COMMAND_SENT_AT_END_OF_TRANSFER => false,
            SEND_AUTO_STOP_A::SEND_STOP_COMMAND_AT_END_OF_TRANSFER => true,
        }
    }
}
#[doc = "Reader of field `SEND_AUTO_STOP`"]
pub type SEND_AUTO_STOP_R = crate::R<bool, SEND_AUTO_STOP_A>;
impl SEND_AUTO_STOP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SEND_AUTO_STOP_A {
        match self.bits {
            false => SEND_AUTO_STOP_A::NO_STOP_COMMAND_SENT_AT_END_OF_TRANSFER,
            true => SEND_AUTO_STOP_A::SEND_STOP_COMMAND_AT_END_OF_TRANSFER,
        }
    }
    #[doc = "Checks if the value of the field is `NO_STOP_COMMAND_SENT_AT_END_OF_TRANSFER`"]
    #[inline(always)]
    pub fn is_no_stop_command_sent_at_end_of_transfer(&self) -> bool {
        *self == SEND_AUTO_STOP_A::NO_STOP_COMMAND_SENT_AT_END_OF_TRANSFER
    }
    #[doc = "Checks if the value of the field is `SEND_STOP_COMMAND_AT_END_OF_TRANSFER`"]
    #[inline(always)]
    pub fn is_send_stop_command_at_end_of_transfer(&self) -> bool {
        *self == SEND_AUTO_STOP_A::SEND_STOP_COMMAND_AT_END_OF_TRANSFER
    }
}
#[doc = "Write proxy for field `SEND_AUTO_STOP`"]
pub struct SEND_AUTO_STOP_W<'a> {
    w: &'a mut W,
}
impl<'a> SEND_AUTO_STOP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SEND_AUTO_STOP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No stop command sent at end of data transfer"]
    #[inline(always)]
    pub fn no_stop_command_sent_at_end_of_transfer(self) -> &'a mut W {
        self.variant(SEND_AUTO_STOP_A::NO_STOP_COMMAND_SENT_AT_END_OF_TRANSFER)
    }
    #[doc = "Send stop command at end of data transfer"]
    #[inline(always)]
    pub fn send_stop_command_at_end_of_transfer(self) -> &'a mut W {
        self.variant(SEND_AUTO_STOP_A::SEND_STOP_COMMAND_AT_END_OF_TRANSFER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Wait prvdata complete. The wait_prvdata_complete = 0 option typically used to query status of card during data transfer or to stop current data transfer; card_number should be same as in previous command.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WAIT_PRVDATA_COMPLETE_A {
    #[doc = "0: Send. Send command at once, even if previous data transfer has not completed."]
    SEND,
    #[doc = "1: Wait. Wait for previous data transfer completion before sending command."]
    WAIT,
}
impl From<WAIT_PRVDATA_COMPLETE_A> for bool {
    #[inline(always)]
    fn from(variant: WAIT_PRVDATA_COMPLETE_A) -> Self {
        match variant {
            WAIT_PRVDATA_COMPLETE_A::SEND => false,
            WAIT_PRVDATA_COMPLETE_A::WAIT => true,
        }
    }
}
#[doc = "Reader of field `WAIT_PRVDATA_COMPLETE`"]
pub type WAIT_PRVDATA_COMPLETE_R = crate::R<bool, WAIT_PRVDATA_COMPLETE_A>;
impl WAIT_PRVDATA_COMPLETE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WAIT_PRVDATA_COMPLETE_A {
        match self.bits {
            false => WAIT_PRVDATA_COMPLETE_A::SEND,
            true => WAIT_PRVDATA_COMPLETE_A::WAIT,
        }
    }
    #[doc = "Checks if the value of the field is `SEND`"]
    #[inline(always)]
    pub fn is_send(&self) -> bool {
        *self == WAIT_PRVDATA_COMPLETE_A::SEND
    }
    #[doc = "Checks if the value of the field is `WAIT`"]
    #[inline(always)]
    pub fn is_wait(&self) -> bool {
        *self == WAIT_PRVDATA_COMPLETE_A::WAIT
    }
}
#[doc = "Write proxy for field `WAIT_PRVDATA_COMPLETE`"]
pub struct WAIT_PRVDATA_COMPLETE_W<'a> {
    w: &'a mut W,
}
impl<'a> WAIT_PRVDATA_COMPLETE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WAIT_PRVDATA_COMPLETE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Send. Send command at once, even if previous data transfer has not completed."]
    #[inline(always)]
    pub fn send(self) -> &'a mut W {
        self.variant(WAIT_PRVDATA_COMPLETE_A::SEND)
    }
    #[doc = "Wait. Wait for previous data transfer completion before sending command."]
    #[inline(always)]
    pub fn wait(self) -> &'a mut W {
        self.variant(WAIT_PRVDATA_COMPLETE_A::WAIT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Stop abort command. When open-ended or predefined data transfer is in progress, and host issues stop or abort command to stop data transfer, bit should be set so that command/data state-machines of CIU can return correctly to idle state. This is also applicable for Boot mode transfers. To Abort boot mode, this bit should be set along with CMD\\[26\\] = disable_boot.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum STOP_ABORT_CMD_A {
    #[doc = "0: Disabled. Neither stop nor abort command to stop current data transfer in progress. If abort is sent to function-number currently selected or not in data-transfer mode, then bit should be set to 0."]
    DISABLED,
    #[doc = "1: Enabled. Stop or abort command intended to stop current data transfer in progress."]
    ENABLED,
}
impl From<STOP_ABORT_CMD_A> for bool {
    #[inline(always)]
    fn from(variant: STOP_ABORT_CMD_A) -> Self {
        match variant {
            STOP_ABORT_CMD_A::DISABLED => false,
            STOP_ABORT_CMD_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `STOP_ABORT_CMD`"]
pub type STOP_ABORT_CMD_R = crate::R<bool, STOP_ABORT_CMD_A>;
impl STOP_ABORT_CMD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> STOP_ABORT_CMD_A {
        match self.bits {
            false => STOP_ABORT_CMD_A::DISABLED,
            true => STOP_ABORT_CMD_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == STOP_ABORT_CMD_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == STOP_ABORT_CMD_A::ENABLED
    }
}
#[doc = "Write proxy for field `STOP_ABORT_CMD`"]
pub struct STOP_ABORT_CMD_W<'a> {
    w: &'a mut W,
}
impl<'a> STOP_ABORT_CMD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: STOP_ABORT_CMD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Neither stop nor abort command to stop current data transfer in progress. If abort is sent to function-number currently selected or not in data-transfer mode, then bit should be set to 0."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(STOP_ABORT_CMD_A::DISABLED)
    }
    #[doc = "Enabled. Stop or abort command intended to stop current data transfer in progress."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(STOP_ABORT_CMD_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Send initialization. After power on, 80 clocks must be sent to card for initialization before sending any commands to card. Bit should be set while sending first command to card so that controller will initialize clocks before sending command to card. This bit should not be set for either of the boot modes (alternate or mandatory).\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SEND_INITIALIZATION_A {
    #[doc = "0: No. Do not send initialization sequence (80 clocks of 1) before sending this command."]
    NO,
    #[doc = "1: Send. Send initialization sequence before sending this command."]
    SEND,
}
impl From<SEND_INITIALIZATION_A> for bool {
    #[inline(always)]
    fn from(variant: SEND_INITIALIZATION_A) -> Self {
        match variant {
            SEND_INITIALIZATION_A::NO => false,
            SEND_INITIALIZATION_A::SEND => true,
        }
    }
}
#[doc = "Reader of field `SEND_INITIALIZATION`"]
pub type SEND_INITIALIZATION_R = crate::R<bool, SEND_INITIALIZATION_A>;
impl SEND_INITIALIZATION_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SEND_INITIALIZATION_A {
        match self.bits {
            false => SEND_INITIALIZATION_A::NO,
            true => SEND_INITIALIZATION_A::SEND,
        }
    }
    #[doc = "Checks if the value of the field is `NO`"]
    #[inline(always)]
    pub fn is_no(&self) -> bool {
        *self == SEND_INITIALIZATION_A::NO
    }
    #[doc = "Checks if the value of the field is `SEND`"]
    #[inline(always)]
    pub fn is_send(&self) -> bool {
        *self == SEND_INITIALIZATION_A::SEND
    }
}
#[doc = "Write proxy for field `SEND_INITIALIZATION`"]
pub struct SEND_INITIALIZATION_W<'a> {
    w: &'a mut W,
}
impl<'a> SEND_INITIALIZATION_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SEND_INITIALIZATION_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No. Do not send initialization sequence (80 clocks of 1) before sending this command."]
    #[inline(always)]
    pub fn no(self) -> &'a mut W {
        self.variant(SEND_INITIALIZATION_A::NO)
    }
    #[doc = "Send. Send initialization sequence before sending this command."]
    #[inline(always)]
    pub fn send(self) -> &'a mut W {
        self.variant(SEND_INITIALIZATION_A::SEND)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
#[doc = "Update clock registers only. Following register values transferred into card clock domain: CLKDIV, CLRSRC, CLKENA. Changes card clocks (change frequency, truncate off or on, and set low-frequency mode); provided in order to change clock frequency or stop clock without having to send command to cards. During normal command sequence, when update_clock_registers_only = 0, following control registers are transferred from BIU to CIU: CMD, CMDARG, TMOUT, CTYPE, BLKSIZ, BYTCNT. CIU uses new register values for new command sequence to card(s). When bit is set, there are no Command Done interrupts because no command is sent to SD_MMC_CEATA cards.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UPDATE_CLOCK_REGISTERS_ONLY_A {
    #[doc = "0: Normal. Normal command sequence"]
    NORMAL,
    #[doc = "1: No. Do not send commands, just update clock register value into card clock domain"]
    NO,
}
impl From<UPDATE_CLOCK_REGISTERS_ONLY_A> for bool {
    #[inline(always)]
    fn from(variant: UPDATE_CLOCK_REGISTERS_ONLY_A) -> Self {
        match variant {
            UPDATE_CLOCK_REGISTERS_ONLY_A::NORMAL => false,
            UPDATE_CLOCK_REGISTERS_ONLY_A::NO => true,
        }
    }
}
#[doc = "Reader of field `UPDATE_CLOCK_REGISTERS_ONLY`"]
pub type UPDATE_CLOCK_REGISTERS_ONLY_R = crate::R<bool, UPDATE_CLOCK_REGISTERS_ONLY_A>;
impl UPDATE_CLOCK_REGISTERS_ONLY_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UPDATE_CLOCK_REGISTERS_ONLY_A {
        match self.bits {
            false => UPDATE_CLOCK_REGISTERS_ONLY_A::NORMAL,
            true => UPDATE_CLOCK_REGISTERS_ONLY_A::NO,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        *self == UPDATE_CLOCK_REGISTERS_ONLY_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `NO`"]
    #[inline(always)]
    pub fn is_no(&self) -> bool {
        *self == UPDATE_CLOCK_REGISTERS_ONLY_A::NO
    }
}
#[doc = "Write proxy for field `UPDATE_CLOCK_REGISTERS_ONLY`"]
pub struct UPDATE_CLOCK_REGISTERS_ONLY_W<'a> {
    w: &'a mut W,
}
impl<'a> UPDATE_CLOCK_REGISTERS_ONLY_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UPDATE_CLOCK_REGISTERS_ONLY_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Normal. Normal command sequence"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(UPDATE_CLOCK_REGISTERS_ONLY_A::NORMAL)
    }
    #[doc = "No. Do not send commands, just update clock register value into card clock domain"]
    #[inline(always)]
    pub fn no(self) -> &'a mut W {
        self.variant(UPDATE_CLOCK_REGISTERS_ONLY_A::NO)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | (((value as u32) & 0x01) << 21);
        self.w
    }
}
#[doc = "Read ceata device. Software should set this bit to indicate that CE-ATA device is being accessed for read transfer. This bit is used to disable read data time-out indication while performing CE-ATA read transfers. Maximum value of I/O transmission delay can be no less than 10 seconds.The SD/MMC interface should not indicate read data time-out while waiting for data from CE-ATA device.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum READ_CEATA_DEVICE_A {
    #[doc = "0: No read. Host is not performing read access (RW_REG or RW_BLK) towards CE-ATA device."]
    NO_READ,
    #[doc = "1: Read. Host is performing read access (RW_REG or RW_BLK) towards CE-ATA device."]
    READ,
}
impl From<READ_CEATA_DEVICE_A> for bool {
    #[inline(always)]
    fn from(variant: READ_CEATA_DEVICE_A) -> Self {
        match variant {
            READ_CEATA_DEVICE_A::NO_READ => false,
            READ_CEATA_DEVICE_A::READ => true,
        }
    }
}
#[doc = "Reader of field `READ_CEATA_DEVICE`"]
pub type READ_CEATA_DEVICE_R = crate::R<bool, READ_CEATA_DEVICE_A>;
impl READ_CEATA_DEVICE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> READ_CEATA_DEVICE_A {
        match self.bits {
            false => READ_CEATA_DEVICE_A::NO_READ,
            true => READ_CEATA_DEVICE_A::READ,
        }
    }
    #[doc = "Checks if the value of the field is `NO_READ`"]
    #[inline(always)]
    pub fn is_no_read(&self) -> bool {
        *self == READ_CEATA_DEVICE_A::NO_READ
    }
    #[doc = "Checks if the value of the field is `READ`"]
    #[inline(always)]
    pub fn is_read(&self) -> bool {
        *self == READ_CEATA_DEVICE_A::READ
    }
}
#[doc = "Write proxy for field `READ_CEATA_DEVICE`"]
pub struct READ_CEATA_DEVICE_W<'a> {
    w: &'a mut W,
}
impl<'a> READ_CEATA_DEVICE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: READ_CEATA_DEVICE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No read. Host is not performing read access (RW_REG or RW_BLK) towards CE-ATA device."]
    #[inline(always)]
    pub fn no_read(self) -> &'a mut W {
        self.variant(READ_CEATA_DEVICE_A::NO_READ)
    }
    #[doc = "Read. Host is performing read access (RW_REG or RW_BLK) towards CE-ATA device."]
    #[inline(always)]
    pub fn read(self) -> &'a mut W {
        self.variant(READ_CEATA_DEVICE_A::READ)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 22)) | (((value as u32) & 0x01) << 22);
        self.w
    }
}
#[doc = "CCS expected. If the command expects Command Completion Signal (CCS) from the CE-ATA device, the software should set this control bit. The SD/MMC controller sets the Data Transfer Over (DTO) bit in the RINTSTS register and generates an interrupt to the host if the Data Transfer Over interrupt is not masked.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CCS_EXPECTED_A {
    #[doc = "0: Disabled. Interrupts are not enabled in CE-ATA device (nIEN = 1 in ATA control register), or command does not expect CCS from device."]
    DISABLED,
    #[doc = "1: Enabled. Interrupts are enabled in CE-ATA device (nIEN = 0), and RW_BLK command expects command completion signal from CE-ATA device."]
    ENABLED,
}
impl From<CCS_EXPECTED_A> for bool {
    #[inline(always)]
    fn from(variant: CCS_EXPECTED_A) -> Self {
        match variant {
            CCS_EXPECTED_A::DISABLED => false,
            CCS_EXPECTED_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `CCS_EXPECTED`"]
pub type CCS_EXPECTED_R = crate::R<bool, CCS_EXPECTED_A>;
impl CCS_EXPECTED_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CCS_EXPECTED_A {
        match self.bits {
            false => CCS_EXPECTED_A::DISABLED,
            true => CCS_EXPECTED_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CCS_EXPECTED_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == CCS_EXPECTED_A::ENABLED
    }
}
#[doc = "Write proxy for field `CCS_EXPECTED`"]
pub struct CCS_EXPECTED_W<'a> {
    w: &'a mut W,
}
impl<'a> CCS_EXPECTED_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CCS_EXPECTED_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Interrupts are not enabled in CE-ATA device (nIEN = 1 in ATA control register), or command does not expect CCS from device."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CCS_EXPECTED_A::DISABLED)
    }
    #[doc = "Enabled. Interrupts are enabled in CE-ATA device (nIEN = 0), and RW_BLK command expects command completion signal from CE-ATA device."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(CCS_EXPECTED_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 23)) | (((value as u32) & 0x01) << 23);
        self.w
    }
}
#[doc = "Reader of field `ENABLE_BOOT`"]
pub type ENABLE_BOOT_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `ENABLE_BOOT`"]
pub struct ENABLE_BOOT_W<'a> {
    w: &'a mut W,
}
impl<'a> ENABLE_BOOT_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | (((value as u32) & 0x01) << 24);
        self.w
    }
}
#[doc = "Reader of field `EXPECT_BOOT_ACK`"]
pub type EXPECT_BOOT_ACK_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `EXPECT_BOOT_ACK`"]
pub struct EXPECT_BOOT_ACK_W<'a> {
    w: &'a mut W,
}
impl<'a> EXPECT_BOOT_ACK_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 25)) | (((value as u32) & 0x01) << 25);
        self.w
    }
}
#[doc = "Reader of field `DISABLE_BOOT`"]
pub type DISABLE_BOOT_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `DISABLE_BOOT`"]
pub struct DISABLE_BOOT_W<'a> {
    w: &'a mut W,
}
impl<'a> DISABLE_BOOT_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 26)) | (((value as u32) & 0x01) << 26);
        self.w
    }
}
#[doc = "Boot Mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BOOT_MODE_A {
    #[doc = "0: Mandatory Boot operation"]
    MANDATORY_BOOT_OPERATION,
    #[doc = "1: Alternate Boot operation"]
    ALTERNATE_BOOT_OPERATION,
}
impl From<BOOT_MODE_A> for bool {
    #[inline(always)]
    fn from(variant: BOOT_MODE_A) -> Self {
        match variant {
            BOOT_MODE_A::MANDATORY_BOOT_OPERATION => false,
            BOOT_MODE_A::ALTERNATE_BOOT_OPERATION => true,
        }
    }
}
#[doc = "Reader of field `BOOT_MODE`"]
pub type BOOT_MODE_R = crate::R<bool, BOOT_MODE_A>;
impl BOOT_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BOOT_MODE_A {
        match self.bits {
            false => BOOT_MODE_A::MANDATORY_BOOT_OPERATION,
            true => BOOT_MODE_A::ALTERNATE_BOOT_OPERATION,
        }
    }
    #[doc = "Checks if the value of the field is `MANDATORY_BOOT_OPERATION`"]
    #[inline(always)]
    pub fn is_mandatory_boot_operation(&self) -> bool {
        *self == BOOT_MODE_A::MANDATORY_BOOT_OPERATION
    }
    #[doc = "Checks if the value of the field is `ALTERNATE_BOOT_OPERATION`"]
    #[inline(always)]
    pub fn is_alternate_boot_operation(&self) -> bool {
        *self == BOOT_MODE_A::ALTERNATE_BOOT_OPERATION
    }
}
#[doc = "Write proxy for field `BOOT_MODE`"]
pub struct BOOT_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> BOOT_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BOOT_MODE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Mandatory Boot operation"]
    #[inline(always)]
    pub fn mandatory_boot_operation(self) -> &'a mut W {
        self.variant(BOOT_MODE_A::MANDATORY_BOOT_OPERATION)
    }
    #[doc = "Alternate Boot operation"]
    #[inline(always)]
    pub fn alternate_boot_operation(self) -> &'a mut W {
        self.variant(BOOT_MODE_A::ALTERNATE_BOOT_OPERATION)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 27)) | (((value as u32) & 0x01) << 27);
        self.w
    }
}
#[doc = "Voltage switch bit\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum VOLT_SWITCH_A {
    #[doc = "0: Disabled. No voltage switching"]
    DISABLED,
    #[doc = "1: Enabled. Voltage switching enabled; must be set for CMD11 only"]
    ENABLED,
}
impl From<VOLT_SWITCH_A> for bool {
    #[inline(always)]
    fn from(variant: VOLT_SWITCH_A) -> Self {
        match variant {
            VOLT_SWITCH_A::DISABLED => false,
            VOLT_SWITCH_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `VOLT_SWITCH`"]
pub type VOLT_SWITCH_R = crate::R<bool, VOLT_SWITCH_A>;
impl VOLT_SWITCH_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> VOLT_SWITCH_A {
        match self.bits {
            false => VOLT_SWITCH_A::DISABLED,
            true => VOLT_SWITCH_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == VOLT_SWITCH_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == VOLT_SWITCH_A::ENABLED
    }
}
#[doc = "Write proxy for field `VOLT_SWITCH`"]
pub struct VOLT_SWITCH_W<'a> {
    w: &'a mut W,
}
impl<'a> VOLT_SWITCH_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: VOLT_SWITCH_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. No voltage switching"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(VOLT_SWITCH_A::DISABLED)
    }
    #[doc = "Enabled. Voltage switching enabled; must be set for CMD11 only"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(VOLT_SWITCH_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 28)) | (((value as u32) & 0x01) << 28);
        self.w
    }
}
#[doc = "Reader of field `START_CMD`"]
pub type START_CMD_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `START_CMD`"]
pub struct START_CMD_W<'a> {
    w: &'a mut W,
}
impl<'a> START_CMD_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 31)) | (((value as u32) & 0x01) << 31);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:5 - Command index"]
    #[inline(always)]
    pub fn cmd_index(&self) -> CMD_INDEX_R {
        CMD_INDEX_R::new((self.bits & 0x3f) as u8)
    }
    #[doc = "Bit 6 - Response expect"]
    #[inline(always)]
    pub fn response_expect(&self) -> RESPONSE_EXPECT_R {
        RESPONSE_EXPECT_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Response length"]
    #[inline(always)]
    pub fn response_length(&self) -> RESPONSE_LENGTH_R {
        RESPONSE_LENGTH_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Check response crc. Some of command responses do not return valid CRC bits. Software should disable CRC checks for those commands in order to disable CRC checking by controller."]
    #[inline(always)]
    pub fn check_response_crc(&self) -> CHECK_RESPONSE_CRC_R {
        CHECK_RESPONSE_CRC_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Data expected"]
    #[inline(always)]
    pub fn data_expected(&self) -> DATA_EXPECTED_R {
        DATA_EXPECTED_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - read/write. Don't care if no data expected from card."]
    #[inline(always)]
    pub fn read_write(&self) -> READ_WRITE_R {
        READ_WRITE_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Transfer mode. Don't care if no data expected."]
    #[inline(always)]
    pub fn transfer_mode(&self) -> TRANSFER_MODE_R {
        TRANSFER_MODE_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Send auto stop. When set, the SD/MMC interface sends stop command to SD_MMC_CEATA cards at end of data transfer. Refer to Table 339 to determine: - when send_auto_stop bit should be set, since some data transfers do not need explicit stop commands - open-ended transfers that software should explicitly send to stop command Additionally, when resume is sent to resume - suspended memory access of SD-Combo card - bit should be set correctly if suspended data transfer needs send_auto_stop. Don't care if no data expected from card."]
    #[inline(always)]
    pub fn send_auto_stop(&self) -> SEND_AUTO_STOP_R {
        SEND_AUTO_STOP_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Wait prvdata complete. The wait_prvdata_complete = 0 option typically used to query status of card during data transfer or to stop current data transfer; card_number should be same as in previous command."]
    #[inline(always)]
    pub fn wait_prvdata_complete(&self) -> WAIT_PRVDATA_COMPLETE_R {
        WAIT_PRVDATA_COMPLETE_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Stop abort command. When open-ended or predefined data transfer is in progress, and host issues stop or abort command to stop data transfer, bit should be set so that command/data state-machines of CIU can return correctly to idle state. This is also applicable for Boot mode transfers. To Abort boot mode, this bit should be set along with CMD\\[26\\] = disable_boot."]
    #[inline(always)]
    pub fn stop_abort_cmd(&self) -> STOP_ABORT_CMD_R {
        STOP_ABORT_CMD_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Send initialization. After power on, 80 clocks must be sent to card for initialization before sending any commands to card. Bit should be set while sending first command to card so that controller will initialize clocks before sending command to card. This bit should not be set for either of the boot modes (alternate or mandatory)."]
    #[inline(always)]
    pub fn send_initialization(&self) -> SEND_INITIALIZATION_R {
        SEND_INITIALIZATION_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Update clock registers only. Following register values transferred into card clock domain: CLKDIV, CLRSRC, CLKENA. Changes card clocks (change frequency, truncate off or on, and set low-frequency mode); provided in order to change clock frequency or stop clock without having to send command to cards. During normal command sequence, when update_clock_registers_only = 0, following control registers are transferred from BIU to CIU: CMD, CMDARG, TMOUT, CTYPE, BLKSIZ, BYTCNT. CIU uses new register values for new command sequence to card(s). When bit is set, there are no Command Done interrupts because no command is sent to SD_MMC_CEATA cards."]
    #[inline(always)]
    pub fn update_clock_registers_only(&self) -> UPDATE_CLOCK_REGISTERS_ONLY_R {
        UPDATE_CLOCK_REGISTERS_ONLY_R::new(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Read ceata device. Software should set this bit to indicate that CE-ATA device is being accessed for read transfer. This bit is used to disable read data time-out indication while performing CE-ATA read transfers. Maximum value of I/O transmission delay can be no less than 10 seconds.The SD/MMC interface should not indicate read data time-out while waiting for data from CE-ATA device."]
    #[inline(always)]
    pub fn read_ceata_device(&self) -> READ_CEATA_DEVICE_R {
        READ_CEATA_DEVICE_R::new(((self.bits >> 22) & 0x01) != 0)
    }
    #[doc = "Bit 23 - CCS expected. If the command expects Command Completion Signal (CCS) from the CE-ATA device, the software should set this control bit. The SD/MMC controller sets the Data Transfer Over (DTO) bit in the RINTSTS register and generates an interrupt to the host if the Data Transfer Over interrupt is not masked."]
    #[inline(always)]
    pub fn ccs_expected(&self) -> CCS_EXPECTED_R {
        CCS_EXPECTED_R::new(((self.bits >> 23) & 0x01) != 0)
    }
    #[doc = "Bit 24 - Enable Boot - this bit should be set only for mandatory boot mode. When Software sets this bit along with start_cmd, CIU starts the boot sequence for the corresponding card by asserting the CMD line low. Do NOT set disable_boot and enable_boot together."]
    #[inline(always)]
    pub fn enable_boot(&self) -> ENABLE_BOOT_R {
        ENABLE_BOOT_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bit 25 - Expect Boot Acknowledge. When Software sets this bit along with enable_boot, CIU expects a boot acknowledge start pattern of 0-1-0 from the selected card."]
    #[inline(always)]
    pub fn expect_boot_ack(&self) -> EXPECT_BOOT_ACK_R {
        EXPECT_BOOT_ACK_R::new(((self.bits >> 25) & 0x01) != 0)
    }
    #[doc = "Bit 26 - Disable Boot. When software sets this bit along with start_cmd, CIU terminates the boot operation. Do NOT set disable_boot and enable_boot together."]
    #[inline(always)]
    pub fn disable_boot(&self) -> DISABLE_BOOT_R {
        DISABLE_BOOT_R::new(((self.bits >> 26) & 0x01) != 0)
    }
    #[doc = "Bit 27 - Boot Mode"]
    #[inline(always)]
    pub fn boot_mode(&self) -> BOOT_MODE_R {
        BOOT_MODE_R::new(((self.bits >> 27) & 0x01) != 0)
    }
    #[doc = "Bit 28 - Voltage switch bit"]
    #[inline(always)]
    pub fn volt_switch(&self) -> VOLT_SWITCH_R {
        VOLT_SWITCH_R::new(((self.bits >> 28) & 0x01) != 0)
    }
    #[doc = "Bit 31 - Start command. Once command is taken by CIU, this bit is cleared. When bit is set, host should not attempt to write to any command registers. If write is attempted, hardware lock error is set in raw interrupt register. Once command is sent and response is received from SD_MMC_CEATA cards, Command Done bit is set in the raw interrupt register."]
    #[inline(always)]
    pub fn start_cmd(&self) -> START_CMD_R {
        START_CMD_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:5 - Command index"]
    #[inline(always)]
    pub fn cmd_index(&mut self) -> CMD_INDEX_W {
        CMD_INDEX_W { w: self }
    }
    #[doc = "Bit 6 - Response expect"]
    #[inline(always)]
    pub fn response_expect(&mut self) -> RESPONSE_EXPECT_W {
        RESPONSE_EXPECT_W { w: self }
    }
    #[doc = "Bit 7 - Response length"]
    #[inline(always)]
    pub fn response_length(&mut self) -> RESPONSE_LENGTH_W {
        RESPONSE_LENGTH_W { w: self }
    }
    #[doc = "Bit 8 - Check response crc. Some of command responses do not return valid CRC bits. Software should disable CRC checks for those commands in order to disable CRC checking by controller."]
    #[inline(always)]
    pub fn check_response_crc(&mut self) -> CHECK_RESPONSE_CRC_W {
        CHECK_RESPONSE_CRC_W { w: self }
    }
    #[doc = "Bit 9 - Data expected"]
    #[inline(always)]
    pub fn data_expected(&mut self) -> DATA_EXPECTED_W {
        DATA_EXPECTED_W { w: self }
    }
    #[doc = "Bit 10 - read/write. Don't care if no data expected from card."]
    #[inline(always)]
    pub fn read_write(&mut self) -> READ_WRITE_W {
        READ_WRITE_W { w: self }
    }
    #[doc = "Bit 11 - Transfer mode. Don't care if no data expected."]
    #[inline(always)]
    pub fn transfer_mode(&mut self) -> TRANSFER_MODE_W {
        TRANSFER_MODE_W { w: self }
    }
    #[doc = "Bit 12 - Send auto stop. When set, the SD/MMC interface sends stop command to SD_MMC_CEATA cards at end of data transfer. Refer to Table 339 to determine: - when send_auto_stop bit should be set, since some data transfers do not need explicit stop commands - open-ended transfers that software should explicitly send to stop command Additionally, when resume is sent to resume - suspended memory access of SD-Combo card - bit should be set correctly if suspended data transfer needs send_auto_stop. Don't care if no data expected from card."]
    #[inline(always)]
    pub fn send_auto_stop(&mut self) -> SEND_AUTO_STOP_W {
        SEND_AUTO_STOP_W { w: self }
    }
    #[doc = "Bit 13 - Wait prvdata complete. The wait_prvdata_complete = 0 option typically used to query status of card during data transfer or to stop current data transfer; card_number should be same as in previous command."]
    #[inline(always)]
    pub fn wait_prvdata_complete(&mut self) -> WAIT_PRVDATA_COMPLETE_W {
        WAIT_PRVDATA_COMPLETE_W { w: self }
    }
    #[doc = "Bit 14 - Stop abort command. When open-ended or predefined data transfer is in progress, and host issues stop or abort command to stop data transfer, bit should be set so that command/data state-machines of CIU can return correctly to idle state. This is also applicable for Boot mode transfers. To Abort boot mode, this bit should be set along with CMD\\[26\\] = disable_boot."]
    #[inline(always)]
    pub fn stop_abort_cmd(&mut self) -> STOP_ABORT_CMD_W {
        STOP_ABORT_CMD_W { w: self }
    }
    #[doc = "Bit 15 - Send initialization. After power on, 80 clocks must be sent to card for initialization before sending any commands to card. Bit should be set while sending first command to card so that controller will initialize clocks before sending command to card. This bit should not be set for either of the boot modes (alternate or mandatory)."]
    #[inline(always)]
    pub fn send_initialization(&mut self) -> SEND_INITIALIZATION_W {
        SEND_INITIALIZATION_W { w: self }
    }
    #[doc = "Bit 21 - Update clock registers only. Following register values transferred into card clock domain: CLKDIV, CLRSRC, CLKENA. Changes card clocks (change frequency, truncate off or on, and set low-frequency mode); provided in order to change clock frequency or stop clock without having to send command to cards. During normal command sequence, when update_clock_registers_only = 0, following control registers are transferred from BIU to CIU: CMD, CMDARG, TMOUT, CTYPE, BLKSIZ, BYTCNT. CIU uses new register values for new command sequence to card(s). When bit is set, there are no Command Done interrupts because no command is sent to SD_MMC_CEATA cards."]
    #[inline(always)]
    pub fn update_clock_registers_only(&mut self) -> UPDATE_CLOCK_REGISTERS_ONLY_W {
        UPDATE_CLOCK_REGISTERS_ONLY_W { w: self }
    }
    #[doc = "Bit 22 - Read ceata device. Software should set this bit to indicate that CE-ATA device is being accessed for read transfer. This bit is used to disable read data time-out indication while performing CE-ATA read transfers. Maximum value of I/O transmission delay can be no less than 10 seconds.The SD/MMC interface should not indicate read data time-out while waiting for data from CE-ATA device."]
    #[inline(always)]
    pub fn read_ceata_device(&mut self) -> READ_CEATA_DEVICE_W {
        READ_CEATA_DEVICE_W { w: self }
    }
    #[doc = "Bit 23 - CCS expected. If the command expects Command Completion Signal (CCS) from the CE-ATA device, the software should set this control bit. The SD/MMC controller sets the Data Transfer Over (DTO) bit in the RINTSTS register and generates an interrupt to the host if the Data Transfer Over interrupt is not masked."]
    #[inline(always)]
    pub fn ccs_expected(&mut self) -> CCS_EXPECTED_W {
        CCS_EXPECTED_W { w: self }
    }
    #[doc = "Bit 24 - Enable Boot - this bit should be set only for mandatory boot mode. When Software sets this bit along with start_cmd, CIU starts the boot sequence for the corresponding card by asserting the CMD line low. Do NOT set disable_boot and enable_boot together."]
    #[inline(always)]
    pub fn enable_boot(&mut self) -> ENABLE_BOOT_W {
        ENABLE_BOOT_W { w: self }
    }
    #[doc = "Bit 25 - Expect Boot Acknowledge. When Software sets this bit along with enable_boot, CIU expects a boot acknowledge start pattern of 0-1-0 from the selected card."]
    #[inline(always)]
    pub fn expect_boot_ack(&mut self) -> EXPECT_BOOT_ACK_W {
        EXPECT_BOOT_ACK_W { w: self }
    }
    #[doc = "Bit 26 - Disable Boot. When software sets this bit along with start_cmd, CIU terminates the boot operation. Do NOT set disable_boot and enable_boot together."]
    #[inline(always)]
    pub fn disable_boot(&mut self) -> DISABLE_BOOT_W {
        DISABLE_BOOT_W { w: self }
    }
    #[doc = "Bit 27 - Boot Mode"]
    #[inline(always)]
    pub fn boot_mode(&mut self) -> BOOT_MODE_W {
        BOOT_MODE_W { w: self }
    }
    #[doc = "Bit 28 - Voltage switch bit"]
    #[inline(always)]
    pub fn volt_switch(&mut self) -> VOLT_SWITCH_W {
        VOLT_SWITCH_W { w: self }
    }
    #[doc = "Bit 31 - Start command. Once command is taken by CIU, this bit is cleared. When bit is set, host should not attempt to write to any command registers. If write is attempted, hardware lock error is set in raw interrupt register. Once command is sent and response is received from SD_MMC_CEATA cards, Command Done bit is set in the raw interrupt register."]
    #[inline(always)]
    pub fn start_cmd(&mut self) -> START_CMD_W {
        START_CMD_W { w: self }
    }
}
