#[doc = "Reader of register FIFOTH"]
pub type R = crate::R<u32, super::FIFOTH>;
#[doc = "Writer for register FIFOTH"]
pub type W = crate::W<u32, super::FIFOTH>;
#[doc = "Register FIFOTH `reset()`'s with value 0x0f80_0000"]
impl crate::ResetValue for super::FIFOTH {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0f80_0000
    }
}
#[doc = "Reader of field `TX_WMARK`"]
pub type TX_WMARK_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `TX_WMARK`"]
pub struct TX_WMARK_W<'a> {
    w: &'a mut W,
}
impl<'a> TX_WMARK_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0fff) | ((value as u32) & 0x0fff);
        self.w
    }
}
#[doc = "Reader of field `RX_WMARK`"]
pub type RX_WMARK_R = crate::R<u16, u16>;
#[doc = "Write proxy for field `RX_WMARK`"]
pub struct RX_WMARK_W<'a> {
    w: &'a mut W,
}
impl<'a> RX_WMARK_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0fff << 16)) | (((value as u32) & 0x0fff) << 16);
        self.w
    }
}
#[doc = "Burst size of multiple transaction; should be programmed same as DW-DMA controller multiple-transaction-size SRC/DEST_MSIZE.The units for transfers is the H_DATA_WIDTH parameter. A single transfer (dw_dma_single assertion in case of Non DW DMA interface) would be signalled based on this value. Value should be sub-multiple of (RX_WMark + 1) and (32 - TX_WMark). For example, if FIFO_DEPTH = 16, FDATA_WIDTH = H_DATA_WIDTH Allowed combinations for MSize and TX_WMark are: MSize = 1, TX_WMARK = 1-15 MSize = 4, TX_WMark = 8 MSize = 4, TX_WMark = 4 MSize = 4, TX_WMark = 12 MSize = 8, TX_WMark = 8 MSize = 8, TX_WMark = 4. Allowed combinations for MSize and RX_WMark are: MSize = 1, RX_WMARK = 0-14 MSize = 4, RX_WMark = 3 MSize = 4, RX_WMark = 7 MSize = 4, RX_WMark = 11 MSize = 8, RX_WMark = 7 MSize = 8, RX_WMark = 11 Recommended: MSize = 8, TX_WMark = 8, RX_WMark = 7\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DMA_MTS_A {
    #[doc = "0: 1 transfer"]
    _1_TRANSFER,
    #[doc = "1: 4 transfers"]
    _4_TRANSFERS,
    #[doc = "2: 8 transfers"]
    _8_TRANSFERS,
    #[doc = "3: 16 transfers"]
    _16_TRANSFERS,
    #[doc = "4: 32 transfers"]
    _32_TRANSFERS,
    #[doc = "5: 64 transfers"]
    _64_TRANSFERS,
    #[doc = "6: 128 transfers"]
    _128_TRANSFERS,
    #[doc = "7: 256 transfers"]
    _256_TRANSFERS,
}
impl From<DMA_MTS_A> for u8 {
    #[inline(always)]
    fn from(variant: DMA_MTS_A) -> Self {
        match variant {
            DMA_MTS_A::_1_TRANSFER => 0,
            DMA_MTS_A::_4_TRANSFERS => 1,
            DMA_MTS_A::_8_TRANSFERS => 2,
            DMA_MTS_A::_16_TRANSFERS => 3,
            DMA_MTS_A::_32_TRANSFERS => 4,
            DMA_MTS_A::_64_TRANSFERS => 5,
            DMA_MTS_A::_128_TRANSFERS => 6,
            DMA_MTS_A::_256_TRANSFERS => 7,
        }
    }
}
#[doc = "Reader of field `DMA_MTS`"]
pub type DMA_MTS_R = crate::R<u8, DMA_MTS_A>;
impl DMA_MTS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DMA_MTS_A {
        match self.bits {
            0 => DMA_MTS_A::_1_TRANSFER,
            1 => DMA_MTS_A::_4_TRANSFERS,
            2 => DMA_MTS_A::_8_TRANSFERS,
            3 => DMA_MTS_A::_16_TRANSFERS,
            4 => DMA_MTS_A::_32_TRANSFERS,
            5 => DMA_MTS_A::_64_TRANSFERS,
            6 => DMA_MTS_A::_128_TRANSFERS,
            7 => DMA_MTS_A::_256_TRANSFERS,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `_1_TRANSFER`"]
    #[inline(always)]
    pub fn is_1_transfer(&self) -> bool {
        *self == DMA_MTS_A::_1_TRANSFER
    }
    #[doc = "Checks if the value of the field is `_4_TRANSFERS`"]
    #[inline(always)]
    pub fn is_4_transfers(&self) -> bool {
        *self == DMA_MTS_A::_4_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_8_TRANSFERS`"]
    #[inline(always)]
    pub fn is_8_transfers(&self) -> bool {
        *self == DMA_MTS_A::_8_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_16_TRANSFERS`"]
    #[inline(always)]
    pub fn is_16_transfers(&self) -> bool {
        *self == DMA_MTS_A::_16_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_32_TRANSFERS`"]
    #[inline(always)]
    pub fn is_32_transfers(&self) -> bool {
        *self == DMA_MTS_A::_32_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_64_TRANSFERS`"]
    #[inline(always)]
    pub fn is_64_transfers(&self) -> bool {
        *self == DMA_MTS_A::_64_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_128_TRANSFERS`"]
    #[inline(always)]
    pub fn is_128_transfers(&self) -> bool {
        *self == DMA_MTS_A::_128_TRANSFERS
    }
    #[doc = "Checks if the value of the field is `_256_TRANSFERS`"]
    #[inline(always)]
    pub fn is_256_transfers(&self) -> bool {
        *self == DMA_MTS_A::_256_TRANSFERS
    }
}
#[doc = "Write proxy for field `DMA_MTS`"]
pub struct DMA_MTS_W<'a> {
    w: &'a mut W,
}
impl<'a> DMA_MTS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DMA_MTS_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "1 transfer"]
    #[inline(always)]
    pub fn _1_transfer(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_1_TRANSFER)
    }
    #[doc = "4 transfers"]
    #[inline(always)]
    pub fn _4_transfers(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_4_TRANSFERS)
    }
    #[doc = "8 transfers"]
    #[inline(always)]
    pub fn _8_transfers(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_8_TRANSFERS)
    }
    #[doc = "16 transfers"]
    #[inline(always)]
    pub fn _16_transfers(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_16_TRANSFERS)
    }
    #[doc = "32 transfers"]
    #[inline(always)]
    pub fn _32_transfers(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_32_TRANSFERS)
    }
    #[doc = "64 transfers"]
    #[inline(always)]
    pub fn _64_transfers(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_64_TRANSFERS)
    }
    #[doc = "128 transfers"]
    #[inline(always)]
    pub fn _128_transfers(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_128_TRANSFERS)
    }
    #[doc = "256 transfers"]
    #[inline(always)]
    pub fn _256_transfers(self) -> &'a mut W {
        self.variant(DMA_MTS_A::_256_TRANSFERS)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x07 << 28)) | (((value as u32) & 0x07) << 28);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:11 - FIFO threshold watermark level when transmitting data to card. When FIFO data count is less than or equal to this number, DMA/FIFO request is raised. If Interrupt is enabled, then interrupt occurs. During end of packet, request or interrupt is generated, regardless of threshold programming. In non-DMA mode, when transmit FIFO threshold (TXDR) interrupt is enabled, then interrupt is generated instead of DMA request. During end of packet, on last interrupt, host is responsible for filling FIFO with only required remaining bytes (not before FIFO is full or after CIU completes data transfers, because FIFO may not be empty). In DMA mode, at end of packet, if last transfer is less than burst size, DMA controller does single cycles until required bytes are transferred. 12 bits - 1 bit less than FIFO-count of status register, which is 13 bits. Limitation: TX_WMark >= 1; Recommended value: TX_WMARK = 16; (means less than or equal to FIFO_DEPTH/2)."]
    #[inline(always)]
    pub fn tx_wmark(&self) -> TX_WMARK_R {
        TX_WMARK_R::new((self.bits & 0x0fff) as u16)
    }
    #[doc = "Bits 16:27 - FIFO threshold watermark level when receiving data to card. When FIFO data count reaches greater than this number, DMA/FIFO request is raised. During end of packet, request is generated regardless of threshold programming in order to complete any remaining data. In non-DMA mode, when receiver FIFO threshold (RXDR) interrupt is enabled, then interrupt is generated instead of DMA request. During end of packet, interrupt is not generated if threshold programming is larger than any remaining data. It is responsibility of host to read remaining bytes on seeing Data Transfer Done interrupt. In DMA mode, at end of packet, even if remaining bytes are less than threshold, DMA request does single transfers to flush out any remaining bytes before Data Transfer Done interrupt is set. 12 bits - 1 bit less than FIFO-count of status register, which is 13 bits. Limitation: RX_WMark less than FIFO_DEPTH-2 Recommended: RX_WMARK = 15; (means greater than (FIFO_DEPTH/2) - 1) NOTE: In DMA mode during CCS time-out, the DMA does not generate the request at the end of packet, even if remaining bytes are less than threshold. In this case, there will be some data left in the FIFO. It is the responsibility of the application to reset the FIFO after the CCS time-out."]
    #[inline(always)]
    pub fn rx_wmark(&self) -> RX_WMARK_R {
        RX_WMARK_R::new(((self.bits >> 16) & 0x0fff) as u16)
    }
    #[doc = "Bits 28:30 - Burst size of multiple transaction; should be programmed same as DW-DMA controller multiple-transaction-size SRC/DEST_MSIZE.The units for transfers is the H_DATA_WIDTH parameter. A single transfer (dw_dma_single assertion in case of Non DW DMA interface) would be signalled based on this value. Value should be sub-multiple of (RX_WMark + 1) and (32 - TX_WMark). For example, if FIFO_DEPTH = 16, FDATA_WIDTH = H_DATA_WIDTH Allowed combinations for MSize and TX_WMark are: MSize = 1, TX_WMARK = 1-15 MSize = 4, TX_WMark = 8 MSize = 4, TX_WMark = 4 MSize = 4, TX_WMark = 12 MSize = 8, TX_WMark = 8 MSize = 8, TX_WMark = 4. Allowed combinations for MSize and RX_WMark are: MSize = 1, RX_WMARK = 0-14 MSize = 4, RX_WMark = 3 MSize = 4, RX_WMark = 7 MSize = 4, RX_WMark = 11 MSize = 8, RX_WMark = 7 MSize = 8, RX_WMark = 11 Recommended: MSize = 8, TX_WMark = 8, RX_WMark = 7"]
    #[inline(always)]
    pub fn dma_mts(&self) -> DMA_MTS_R {
        DMA_MTS_R::new(((self.bits >> 28) & 0x07) as u8)
    }
}
impl W {
    #[doc = "Bits 0:11 - FIFO threshold watermark level when transmitting data to card. When FIFO data count is less than or equal to this number, DMA/FIFO request is raised. If Interrupt is enabled, then interrupt occurs. During end of packet, request or interrupt is generated, regardless of threshold programming. In non-DMA mode, when transmit FIFO threshold (TXDR) interrupt is enabled, then interrupt is generated instead of DMA request. During end of packet, on last interrupt, host is responsible for filling FIFO with only required remaining bytes (not before FIFO is full or after CIU completes data transfers, because FIFO may not be empty). In DMA mode, at end of packet, if last transfer is less than burst size, DMA controller does single cycles until required bytes are transferred. 12 bits - 1 bit less than FIFO-count of status register, which is 13 bits. Limitation: TX_WMark >= 1; Recommended value: TX_WMARK = 16; (means less than or equal to FIFO_DEPTH/2)."]
    #[inline(always)]
    pub fn tx_wmark(&mut self) -> TX_WMARK_W {
        TX_WMARK_W { w: self }
    }
    #[doc = "Bits 16:27 - FIFO threshold watermark level when receiving data to card. When FIFO data count reaches greater than this number, DMA/FIFO request is raised. During end of packet, request is generated regardless of threshold programming in order to complete any remaining data. In non-DMA mode, when receiver FIFO threshold (RXDR) interrupt is enabled, then interrupt is generated instead of DMA request. During end of packet, interrupt is not generated if threshold programming is larger than any remaining data. It is responsibility of host to read remaining bytes on seeing Data Transfer Done interrupt. In DMA mode, at end of packet, even if remaining bytes are less than threshold, DMA request does single transfers to flush out any remaining bytes before Data Transfer Done interrupt is set. 12 bits - 1 bit less than FIFO-count of status register, which is 13 bits. Limitation: RX_WMark less than FIFO_DEPTH-2 Recommended: RX_WMARK = 15; (means greater than (FIFO_DEPTH/2) - 1) NOTE: In DMA mode during CCS time-out, the DMA does not generate the request at the end of packet, even if remaining bytes are less than threshold. In this case, there will be some data left in the FIFO. It is the responsibility of the application to reset the FIFO after the CCS time-out."]
    #[inline(always)]
    pub fn rx_wmark(&mut self) -> RX_WMARK_W {
        RX_WMARK_W { w: self }
    }
    #[doc = "Bits 28:30 - Burst size of multiple transaction; should be programmed same as DW-DMA controller multiple-transaction-size SRC/DEST_MSIZE.The units for transfers is the H_DATA_WIDTH parameter. A single transfer (dw_dma_single assertion in case of Non DW DMA interface) would be signalled based on this value. Value should be sub-multiple of (RX_WMark + 1) and (32 - TX_WMark). For example, if FIFO_DEPTH = 16, FDATA_WIDTH = H_DATA_WIDTH Allowed combinations for MSize and TX_WMark are: MSize = 1, TX_WMARK = 1-15 MSize = 4, TX_WMark = 8 MSize = 4, TX_WMark = 4 MSize = 4, TX_WMark = 12 MSize = 8, TX_WMark = 8 MSize = 8, TX_WMark = 4. Allowed combinations for MSize and RX_WMark are: MSize = 1, RX_WMARK = 0-14 MSize = 4, RX_WMark = 3 MSize = 4, RX_WMark = 7 MSize = 4, RX_WMark = 11 MSize = 8, RX_WMark = 7 MSize = 8, RX_WMark = 11 Recommended: MSize = 8, TX_WMark = 8, RX_WMark = 7"]
    #[inline(always)]
    pub fn dma_mts(&mut self) -> DMA_MTS_W {
        DMA_MTS_W { w: self }
    }
}
