#[doc = "Reader of register MINTSTS"]
pub type R = crate::R<u32, super::MINTSTS>;
#[doc = "Reader of field `CDET`"]
pub type CDET_R = crate::R<bool, bool>;
#[doc = "Reader of field `RE`"]
pub type RE_R = crate::R<bool, bool>;
#[doc = "Reader of field `CDONE`"]
pub type CDONE_R = crate::R<bool, bool>;
#[doc = "Reader of field `DTO`"]
pub type DTO_R = crate::R<bool, bool>;
#[doc = "Reader of field `TXDR`"]
pub type TXDR_R = crate::R<bool, bool>;
#[doc = "Reader of field `RXDR`"]
pub type RXDR_R = crate::R<bool, bool>;
#[doc = "Reader of field `RCRC`"]
pub type RCRC_R = crate::R<bool, bool>;
#[doc = "Reader of field `DCRC`"]
pub type DCRC_R = crate::R<bool, bool>;
#[doc = "Reader of field `RTO`"]
pub type RTO_R = crate::R<bool, bool>;
#[doc = "Reader of field `DRTO`"]
pub type DRTO_R = crate::R<bool, bool>;
#[doc = "Reader of field `HTO`"]
pub type HTO_R = crate::R<bool, bool>;
#[doc = "Reader of field `FRUN`"]
pub type FRUN_R = crate::R<bool, bool>;
#[doc = "Reader of field `HLE`"]
pub type HLE_R = crate::R<bool, bool>;
#[doc = "Reader of field `SBE`"]
pub type SBE_R = crate::R<bool, bool>;
#[doc = "Reader of field `ACD`"]
pub type ACD_R = crate::R<bool, bool>;
#[doc = "Reader of field `EBE`"]
pub type EBE_R = crate::R<bool, bool>;
#[doc = "Reader of field `SDIO_INTERRUPT`"]
pub type SDIO_INTERRUPT_R = crate::R<bool, bool>;
impl R {
    #[doc = "Bit 0 - Card detect. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn cdet(&self) -> CDET_R {
        CDET_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Response error. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn re(&self) -> RE_R {
        RE_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Command done. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn cdone(&self) -> CDONE_R {
        CDONE_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Data transfer over. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn dto(&self) -> DTO_R {
        DTO_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Transmit FIFO data request. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn txdr(&self) -> TXDR_R {
        TXDR_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Receive FIFO data request. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn rxdr(&self) -> RXDR_R {
        RXDR_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Response CRC error. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn rcrc(&self) -> RCRC_R {
        RCRC_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Data CRC error. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn dcrc(&self) -> DCRC_R {
        DCRC_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Response time-out. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn rto(&self) -> RTO_R {
        RTO_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Data read time-out. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn drto(&self) -> DRTO_R {
        DRTO_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Data starvation-by-host time-out (HTO). Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn hto(&self) -> HTO_R {
        HTO_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - FIFO underrun/overrun error. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn frun(&self) -> FRUN_R {
        FRUN_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Hardware locked write error. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn hle(&self) -> HLE_R {
        HLE_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Start-bit error. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn sbe(&self) -> SBE_R {
        SBE_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Auto command done. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn acd(&self) -> ACD_R {
        ACD_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - End-bit error (read)/write no CRC. Interrupt enabled only if corresponding bit in interrupt mask register is set."]
    #[inline(always)]
    pub fn ebe(&self) -> EBE_R {
        EBE_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Interrupt from SDIO card. SDIO interrupt for card enabled only if corresponding sdio_int_mask bit is set in Interrupt mask register (mask bit 1 enables interrupt; 0 masks interrupt). 0 - No SDIO interrupt from card 1 - SDIO interrupt from card In MMC-Ver3.3-only mode, this bit is always 0."]
    #[inline(always)]
    pub fn sdio_interrupt(&self) -> SDIO_INTERRUPT_R {
        SDIO_INTERRUPT_R::new(((self.bits >> 16) & 0x01) != 0)
    }
}
