#[doc = "Reader of register SLICE_MUX_CFG[%s]"]
pub type R = crate::R<u32, super::SLICE_MUX_CFG>;
#[doc = "Writer for register SLICE_MUX_CFG[%s]"]
pub type W = crate::W<u32, super::SLICE_MUX_CFG>;
#[doc = "Register SLICE_MUX_CFG[%s] `reset()`'s with value 0"]
impl crate::ResetValue for super::SLICE_MUX_CFG {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Match mode. Selects whether the match filter is active or whether data is captured.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum MATCH_MODE_A {
    #[doc = "0: Do not match data."]
    DO_NOT_MATCH_DATA,
    #[doc = "1: Match data."]
    MATCH_DATA,
}
impl From<MATCH_MODE_A> for bool {
    #[inline(always)]
    fn from(variant: MATCH_MODE_A) -> Self {
        match variant {
            MATCH_MODE_A::DO_NOT_MATCH_DATA => false,
            MATCH_MODE_A::MATCH_DATA => true,
        }
    }
}
#[doc = "Reader of field `MATCH_MODE`"]
pub type MATCH_MODE_R = crate::R<bool, MATCH_MODE_A>;
impl MATCH_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> MATCH_MODE_A {
        match self.bits {
            false => MATCH_MODE_A::DO_NOT_MATCH_DATA,
            true => MATCH_MODE_A::MATCH_DATA,
        }
    }
    #[doc = "Checks if the value of the field is `DO_NOT_MATCH_DATA`"]
    #[inline(always)]
    pub fn is_do_not_match_data(&self) -> bool {
        *self == MATCH_MODE_A::DO_NOT_MATCH_DATA
    }
    #[doc = "Checks if the value of the field is `MATCH_DATA`"]
    #[inline(always)]
    pub fn is_match_data(&self) -> bool {
        *self == MATCH_MODE_A::MATCH_DATA
    }
}
#[doc = "Write proxy for field `MATCH_MODE`"]
pub struct MATCH_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> MATCH_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: MATCH_MODE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Do not match data."]
    #[inline(always)]
    pub fn do_not_match_data(self) -> &'a mut W {
        self.variant(MATCH_MODE_A::DO_NOT_MATCH_DATA)
    }
    #[doc = "Match data."]
    #[inline(always)]
    pub fn match_data(self) -> &'a mut W {
        self.variant(MATCH_MODE_A::MATCH_DATA)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Capture clock mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CLK_CAPTURE_MODE_A {
    #[doc = "0: Use rising clock edge."]
    USE_RISING_CLOCK_EDGE,
    #[doc = "1: Use falling clock edge."]
    USE_FALLING_CLOCK_EDGE,
}
impl From<CLK_CAPTURE_MODE_A> for bool {
    #[inline(always)]
    fn from(variant: CLK_CAPTURE_MODE_A) -> Self {
        match variant {
            CLK_CAPTURE_MODE_A::USE_RISING_CLOCK_EDGE => false,
            CLK_CAPTURE_MODE_A::USE_FALLING_CLOCK_EDGE => true,
        }
    }
}
#[doc = "Reader of field `CLK_CAPTURE_MODE`"]
pub type CLK_CAPTURE_MODE_R = crate::R<bool, CLK_CAPTURE_MODE_A>;
impl CLK_CAPTURE_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CLK_CAPTURE_MODE_A {
        match self.bits {
            false => CLK_CAPTURE_MODE_A::USE_RISING_CLOCK_EDGE,
            true => CLK_CAPTURE_MODE_A::USE_FALLING_CLOCK_EDGE,
        }
    }
    #[doc = "Checks if the value of the field is `USE_RISING_CLOCK_EDGE`"]
    #[inline(always)]
    pub fn is_use_rising_clock_edge(&self) -> bool {
        *self == CLK_CAPTURE_MODE_A::USE_RISING_CLOCK_EDGE
    }
    #[doc = "Checks if the value of the field is `USE_FALLING_CLOCK_EDGE`"]
    #[inline(always)]
    pub fn is_use_falling_clock_edge(&self) -> bool {
        *self == CLK_CAPTURE_MODE_A::USE_FALLING_CLOCK_EDGE
    }
}
#[doc = "Write proxy for field `CLK_CAPTURE_MODE`"]
pub struct CLK_CAPTURE_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> CLK_CAPTURE_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLK_CAPTURE_MODE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Use rising clock edge."]
    #[inline(always)]
    pub fn use_rising_clock_edge(self) -> &'a mut W {
        self.variant(CLK_CAPTURE_MODE_A::USE_RISING_CLOCK_EDGE)
    }
    #[doc = "Use falling clock edge."]
    #[inline(always)]
    pub fn use_falling_clock_edge(self) -> &'a mut W {
        self.variant(CLK_CAPTURE_MODE_A::USE_FALLING_CLOCK_EDGE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Clock generation mode. Selects the clock generated by the slice counter or by an external pin or other slice as shift clock.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CLKGEN_MODE_A {
    #[doc = "0: Use clock internally generated by COUNTER."]
    USE_INTERNAL_CLOCK,
    #[doc = "1: Use external clock from a pin or other slice."]
    USE_EXTERNAL_CLOCK,
}
impl From<CLKGEN_MODE_A> for bool {
    #[inline(always)]
    fn from(variant: CLKGEN_MODE_A) -> Self {
        match variant {
            CLKGEN_MODE_A::USE_INTERNAL_CLOCK => false,
            CLKGEN_MODE_A::USE_EXTERNAL_CLOCK => true,
        }
    }
}
#[doc = "Reader of field `CLKGEN_MODE`"]
pub type CLKGEN_MODE_R = crate::R<bool, CLKGEN_MODE_A>;
impl CLKGEN_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CLKGEN_MODE_A {
        match self.bits {
            false => CLKGEN_MODE_A::USE_INTERNAL_CLOCK,
            true => CLKGEN_MODE_A::USE_EXTERNAL_CLOCK,
        }
    }
    #[doc = "Checks if the value of the field is `USE_INTERNAL_CLOCK`"]
    #[inline(always)]
    pub fn is_use_internal_clock(&self) -> bool {
        *self == CLKGEN_MODE_A::USE_INTERNAL_CLOCK
    }
    #[doc = "Checks if the value of the field is `USE_EXTERNAL_CLOCK`"]
    #[inline(always)]
    pub fn is_use_external_clock(&self) -> bool {
        *self == CLKGEN_MODE_A::USE_EXTERNAL_CLOCK
    }
}
#[doc = "Write proxy for field `CLKGEN_MODE`"]
pub struct CLKGEN_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> CLKGEN_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CLKGEN_MODE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Use clock internally generated by COUNTER."]
    #[inline(always)]
    pub fn use_internal_clock(self) -> &'a mut W {
        self.variant(CLKGEN_MODE_A::USE_INTERNAL_CLOCK)
    }
    #[doc = "Use external clock from a pin or other slice."]
    #[inline(always)]
    pub fn use_external_clock(self) -> &'a mut W {
        self.variant(CLKGEN_MODE_A::USE_EXTERNAL_CLOCK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Invert output clock\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INV_OUT_CLK_A {
    #[doc = "0: Normal clock."]
    NORMAL_CLOCK,
    #[doc = "1: Inverted clock."]
    INVERTED_CLOCK,
}
impl From<INV_OUT_CLK_A> for bool {
    #[inline(always)]
    fn from(variant: INV_OUT_CLK_A) -> Self {
        match variant {
            INV_OUT_CLK_A::NORMAL_CLOCK => false,
            INV_OUT_CLK_A::INVERTED_CLOCK => true,
        }
    }
}
#[doc = "Reader of field `INV_OUT_CLK`"]
pub type INV_OUT_CLK_R = crate::R<bool, INV_OUT_CLK_A>;
impl INV_OUT_CLK_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INV_OUT_CLK_A {
        match self.bits {
            false => INV_OUT_CLK_A::NORMAL_CLOCK,
            true => INV_OUT_CLK_A::INVERTED_CLOCK,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL_CLOCK`"]
    #[inline(always)]
    pub fn is_normal_clock(&self) -> bool {
        *self == INV_OUT_CLK_A::NORMAL_CLOCK
    }
    #[doc = "Checks if the value of the field is `INVERTED_CLOCK`"]
    #[inline(always)]
    pub fn is_inverted_clock(&self) -> bool {
        *self == INV_OUT_CLK_A::INVERTED_CLOCK
    }
}
#[doc = "Write proxy for field `INV_OUT_CLK`"]
pub struct INV_OUT_CLK_W<'a> {
    w: &'a mut W,
}
impl<'a> INV_OUT_CLK_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INV_OUT_CLK_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Normal clock."]
    #[inline(always)]
    pub fn normal_clock(self) -> &'a mut W {
        self.variant(INV_OUT_CLK_A::NORMAL_CLOCK)
    }
    #[doc = "Inverted clock."]
    #[inline(always)]
    pub fn inverted_clock(self) -> &'a mut W {
        self.variant(INV_OUT_CLK_A::INVERTED_CLOCK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Condition for input bit match interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DATA_CAPTURE_MODE_A {
    #[doc = "0: Detect rising edge."]
    DETECT_RISING_EDGE,
    #[doc = "1: Detect falling edge."]
    DETECT_FALLING_EDGE,
    #[doc = "2: Detect LOW level."]
    DETECT_LOW_LEVEL,
    #[doc = "3: Detect HIGH level."]
    DETECT_HIGH_LEVEL,
}
impl From<DATA_CAPTURE_MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: DATA_CAPTURE_MODE_A) -> Self {
        match variant {
            DATA_CAPTURE_MODE_A::DETECT_RISING_EDGE => 0,
            DATA_CAPTURE_MODE_A::DETECT_FALLING_EDGE => 1,
            DATA_CAPTURE_MODE_A::DETECT_LOW_LEVEL => 2,
            DATA_CAPTURE_MODE_A::DETECT_HIGH_LEVEL => 3,
        }
    }
}
#[doc = "Reader of field `DATA_CAPTURE_MODE`"]
pub type DATA_CAPTURE_MODE_R = crate::R<u8, DATA_CAPTURE_MODE_A>;
impl DATA_CAPTURE_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DATA_CAPTURE_MODE_A {
        match self.bits {
            0 => DATA_CAPTURE_MODE_A::DETECT_RISING_EDGE,
            1 => DATA_CAPTURE_MODE_A::DETECT_FALLING_EDGE,
            2 => DATA_CAPTURE_MODE_A::DETECT_LOW_LEVEL,
            3 => DATA_CAPTURE_MODE_A::DETECT_HIGH_LEVEL,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DETECT_RISING_EDGE`"]
    #[inline(always)]
    pub fn is_detect_rising_edge(&self) -> bool {
        *self == DATA_CAPTURE_MODE_A::DETECT_RISING_EDGE
    }
    #[doc = "Checks if the value of the field is `DETECT_FALLING_EDGE`"]
    #[inline(always)]
    pub fn is_detect_falling_edge(&self) -> bool {
        *self == DATA_CAPTURE_MODE_A::DETECT_FALLING_EDGE
    }
    #[doc = "Checks if the value of the field is `DETECT_LOW_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_low_level(&self) -> bool {
        *self == DATA_CAPTURE_MODE_A::DETECT_LOW_LEVEL
    }
    #[doc = "Checks if the value of the field is `DETECT_HIGH_LEVEL`"]
    #[inline(always)]
    pub fn is_detect_high_level(&self) -> bool {
        *self == DATA_CAPTURE_MODE_A::DETECT_HIGH_LEVEL
    }
}
#[doc = "Write proxy for field `DATA_CAPTURE_MODE`"]
pub struct DATA_CAPTURE_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> DATA_CAPTURE_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DATA_CAPTURE_MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Detect rising edge."]
    #[inline(always)]
    pub fn detect_rising_edge(self) -> &'a mut W {
        self.variant(DATA_CAPTURE_MODE_A::DETECT_RISING_EDGE)
    }
    #[doc = "Detect falling edge."]
    #[inline(always)]
    pub fn detect_falling_edge(self) -> &'a mut W {
        self.variant(DATA_CAPTURE_MODE_A::DETECT_FALLING_EDGE)
    }
    #[doc = "Detect LOW level."]
    #[inline(always)]
    pub fn detect_low_level(self) -> &'a mut W {
        self.variant(DATA_CAPTURE_MODE_A::DETECT_LOW_LEVEL)
    }
    #[doc = "Detect HIGH level."]
    #[inline(always)]
    pub fn detect_high_level(self) -> &'a mut W {
        self.variant(DATA_CAPTURE_MODE_A::DETECT_HIGH_LEVEL)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 4)) | (((value as u32) & 0x03) << 4);
        self.w
    }
}
#[doc = "Parallel mode\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PARALLEL_MODE_A {
    #[doc = "0: Shift 1 bit per clock."]
    SHIFT_1_BIT_PER_CLOCK,
    #[doc = "1: Shift 2 bits per clock."]
    SHIFT_2_BITS_PER_CLOCK,
    #[doc = "2: Shift 4 bits per clock."]
    SHIFT_4_BITS_PER_CLOCK,
    #[doc = "3: Shift 1 byte per clock."]
    SHIFT_1_BYTE_PER_CLOCK,
}
impl From<PARALLEL_MODE_A> for u8 {
    #[inline(always)]
    fn from(variant: PARALLEL_MODE_A) -> Self {
        match variant {
            PARALLEL_MODE_A::SHIFT_1_BIT_PER_CLOCK => 0,
            PARALLEL_MODE_A::SHIFT_2_BITS_PER_CLOCK => 1,
            PARALLEL_MODE_A::SHIFT_4_BITS_PER_CLOCK => 2,
            PARALLEL_MODE_A::SHIFT_1_BYTE_PER_CLOCK => 3,
        }
    }
}
#[doc = "Reader of field `PARALLEL_MODE`"]
pub type PARALLEL_MODE_R = crate::R<u8, PARALLEL_MODE_A>;
impl PARALLEL_MODE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PARALLEL_MODE_A {
        match self.bits {
            0 => PARALLEL_MODE_A::SHIFT_1_BIT_PER_CLOCK,
            1 => PARALLEL_MODE_A::SHIFT_2_BITS_PER_CLOCK,
            2 => PARALLEL_MODE_A::SHIFT_4_BITS_PER_CLOCK,
            3 => PARALLEL_MODE_A::SHIFT_1_BYTE_PER_CLOCK,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SHIFT_1_BIT_PER_CLOCK`"]
    #[inline(always)]
    pub fn is_shift_1_bit_per_clock(&self) -> bool {
        *self == PARALLEL_MODE_A::SHIFT_1_BIT_PER_CLOCK
    }
    #[doc = "Checks if the value of the field is `SHIFT_2_BITS_PER_CLOCK`"]
    #[inline(always)]
    pub fn is_shift_2_bits_per_clock(&self) -> bool {
        *self == PARALLEL_MODE_A::SHIFT_2_BITS_PER_CLOCK
    }
    #[doc = "Checks if the value of the field is `SHIFT_4_BITS_PER_CLOCK`"]
    #[inline(always)]
    pub fn is_shift_4_bits_per_clock(&self) -> bool {
        *self == PARALLEL_MODE_A::SHIFT_4_BITS_PER_CLOCK
    }
    #[doc = "Checks if the value of the field is `SHIFT_1_BYTE_PER_CLOCK`"]
    #[inline(always)]
    pub fn is_shift_1_byte_per_clock(&self) -> bool {
        *self == PARALLEL_MODE_A::SHIFT_1_BYTE_PER_CLOCK
    }
}
#[doc = "Write proxy for field `PARALLEL_MODE`"]
pub struct PARALLEL_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> PARALLEL_MODE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PARALLEL_MODE_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Shift 1 bit per clock."]
    #[inline(always)]
    pub fn shift_1_bit_per_clock(self) -> &'a mut W {
        self.variant(PARALLEL_MODE_A::SHIFT_1_BIT_PER_CLOCK)
    }
    #[doc = "Shift 2 bits per clock."]
    #[inline(always)]
    pub fn shift_2_bits_per_clock(self) -> &'a mut W {
        self.variant(PARALLEL_MODE_A::SHIFT_2_BITS_PER_CLOCK)
    }
    #[doc = "Shift 4 bits per clock."]
    #[inline(always)]
    pub fn shift_4_bits_per_clock(self) -> &'a mut W {
        self.variant(PARALLEL_MODE_A::SHIFT_4_BITS_PER_CLOCK)
    }
    #[doc = "Shift 1 byte per clock."]
    #[inline(always)]
    pub fn shift_1_byte_per_clock(self) -> &'a mut W {
        self.variant(PARALLEL_MODE_A::SHIFT_1_BYTE_PER_CLOCK)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 6)) | (((value as u32) & 0x03) << 6);
        self.w
    }
}
#[doc = "Inversion qualifier\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INV_QUALIFIER_A {
    #[doc = "0: Use normal qualifier."]
    USE_NORMAL_QUALIFIER,
    #[doc = "1: Use inverted qualifier."]
    USE_INVERTED_QUALIFIER,
}
impl From<INV_QUALIFIER_A> for bool {
    #[inline(always)]
    fn from(variant: INV_QUALIFIER_A) -> Self {
        match variant {
            INV_QUALIFIER_A::USE_NORMAL_QUALIFIER => false,
            INV_QUALIFIER_A::USE_INVERTED_QUALIFIER => true,
        }
    }
}
#[doc = "Reader of field `INV_QUALIFIER`"]
pub type INV_QUALIFIER_R = crate::R<bool, INV_QUALIFIER_A>;
impl INV_QUALIFIER_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INV_QUALIFIER_A {
        match self.bits {
            false => INV_QUALIFIER_A::USE_NORMAL_QUALIFIER,
            true => INV_QUALIFIER_A::USE_INVERTED_QUALIFIER,
        }
    }
    #[doc = "Checks if the value of the field is `USE_NORMAL_QUALIFIER`"]
    #[inline(always)]
    pub fn is_use_normal_qualifier(&self) -> bool {
        *self == INV_QUALIFIER_A::USE_NORMAL_QUALIFIER
    }
    #[doc = "Checks if the value of the field is `USE_INVERTED_QUALIFIER`"]
    #[inline(always)]
    pub fn is_use_inverted_qualifier(&self) -> bool {
        *self == INV_QUALIFIER_A::USE_INVERTED_QUALIFIER
    }
}
#[doc = "Write proxy for field `INV_QUALIFIER`"]
pub struct INV_QUALIFIER_W<'a> {
    w: &'a mut W,
}
impl<'a> INV_QUALIFIER_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INV_QUALIFIER_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Use normal qualifier."]
    #[inline(always)]
    pub fn use_normal_qualifier(self) -> &'a mut W {
        self.variant(INV_QUALIFIER_A::USE_NORMAL_QUALIFIER)
    }
    #[doc = "Use inverted qualifier."]
    #[inline(always)]
    pub fn use_inverted_qualifier(self) -> &'a mut W {
        self.variant(INV_QUALIFIER_A::USE_INVERTED_QUALIFIER)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Match mode. Selects whether the match filter is active or whether data is captured."]
    #[inline(always)]
    pub fn match_mode(&self) -> MATCH_MODE_R {
        MATCH_MODE_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Capture clock mode"]
    #[inline(always)]
    pub fn clk_capture_mode(&self) -> CLK_CAPTURE_MODE_R {
        CLK_CAPTURE_MODE_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Clock generation mode. Selects the clock generated by the slice counter or by an external pin or other slice as shift clock."]
    #[inline(always)]
    pub fn clkgen_mode(&self) -> CLKGEN_MODE_R {
        CLKGEN_MODE_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Invert output clock"]
    #[inline(always)]
    pub fn inv_out_clk(&self) -> INV_OUT_CLK_R {
        INV_OUT_CLK_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bits 4:5 - Condition for input bit match interrupt"]
    #[inline(always)]
    pub fn data_capture_mode(&self) -> DATA_CAPTURE_MODE_R {
        DATA_CAPTURE_MODE_R::new(((self.bits >> 4) & 0x03) as u8)
    }
    #[doc = "Bits 6:7 - Parallel mode"]
    #[inline(always)]
    pub fn parallel_mode(&self) -> PARALLEL_MODE_R {
        PARALLEL_MODE_R::new(((self.bits >> 6) & 0x03) as u8)
    }
    #[doc = "Bit 8 - Inversion qualifier"]
    #[inline(always)]
    pub fn inv_qualifier(&self) -> INV_QUALIFIER_R {
        INV_QUALIFIER_R::new(((self.bits >> 8) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Match mode. Selects whether the match filter is active or whether data is captured."]
    #[inline(always)]
    pub fn match_mode(&mut self) -> MATCH_MODE_W {
        MATCH_MODE_W { w: self }
    }
    #[doc = "Bit 1 - Capture clock mode"]
    #[inline(always)]
    pub fn clk_capture_mode(&mut self) -> CLK_CAPTURE_MODE_W {
        CLK_CAPTURE_MODE_W { w: self }
    }
    #[doc = "Bit 2 - Clock generation mode. Selects the clock generated by the slice counter or by an external pin or other slice as shift clock."]
    #[inline(always)]
    pub fn clkgen_mode(&mut self) -> CLKGEN_MODE_W {
        CLKGEN_MODE_W { w: self }
    }
    #[doc = "Bit 3 - Invert output clock"]
    #[inline(always)]
    pub fn inv_out_clk(&mut self) -> INV_OUT_CLK_W {
        INV_OUT_CLK_W { w: self }
    }
    #[doc = "Bits 4:5 - Condition for input bit match interrupt"]
    #[inline(always)]
    pub fn data_capture_mode(&mut self) -> DATA_CAPTURE_MODE_W {
        DATA_CAPTURE_MODE_W { w: self }
    }
    #[doc = "Bits 6:7 - Parallel mode"]
    #[inline(always)]
    pub fn parallel_mode(&mut self) -> PARALLEL_MODE_W {
        PARALLEL_MODE_W { w: self }
    }
    #[doc = "Bit 8 - Inversion qualifier"]
    #[inline(always)]
    pub fn inv_qualifier(&mut self) -> INV_QUALIFIER_W {
        INV_QUALIFIER_W { w: self }
    }
}
