#[doc = "Reader of register CCR"]
pub type R = crate::R<u32, super::CCR>;
#[doc = "Writer for register CCR"]
pub type W = crate::W<u32, super::CCR>;
#[doc = "Register CCR `reset()`'s with value 0"]
impl crate::ResetValue for super::CCR {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Capture on CAPn.0 rising edge\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP0RE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Low to high. A sequence of 0 then 1 on CAPn.0 will cause CR0 to be loaded with the contents of TC."]
    LOW_TO_HIGH,
}
impl From<CAP0RE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP0RE_A) -> Self {
        match variant {
            CAP0RE_A::DISABLED => false,
            CAP0RE_A::LOW_TO_HIGH => true,
        }
    }
}
#[doc = "Reader of field `CAP0RE`"]
pub type CAP0RE_R = crate::R<bool, CAP0RE_A>;
impl CAP0RE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP0RE_A {
        match self.bits {
            false => CAP0RE_A::DISABLED,
            true => CAP0RE_A::LOW_TO_HIGH,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP0RE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOW_TO_HIGH`"]
    #[inline(always)]
    pub fn is_low_to_high(&self) -> bool {
        *self == CAP0RE_A::LOW_TO_HIGH
    }
}
#[doc = "Write proxy for field `CAP0RE`"]
pub struct CAP0RE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP0RE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP0RE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP0RE_A::DISABLED)
    }
    #[doc = "Low to high. A sequence of 0 then 1 on CAPn.0 will cause CR0 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn low_to_high(self) -> &'a mut W {
        self.variant(CAP0RE_A::LOW_TO_HIGH)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Capture on CAPn.0 falling edge\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP0FE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: High to low. A sequence of 1 then 0 on CAPn.0 will cause CR0 to be loaded with the contents of TC."]
    HIGH_TO_LOW,
}
impl From<CAP0FE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP0FE_A) -> Self {
        match variant {
            CAP0FE_A::DISABLED => false,
            CAP0FE_A::HIGH_TO_LOW => true,
        }
    }
}
#[doc = "Reader of field `CAP0FE`"]
pub type CAP0FE_R = crate::R<bool, CAP0FE_A>;
impl CAP0FE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP0FE_A {
        match self.bits {
            false => CAP0FE_A::DISABLED,
            true => CAP0FE_A::HIGH_TO_LOW,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP0FE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `HIGH_TO_LOW`"]
    #[inline(always)]
    pub fn is_high_to_low(&self) -> bool {
        *self == CAP0FE_A::HIGH_TO_LOW
    }
}
#[doc = "Write proxy for field `CAP0FE`"]
pub struct CAP0FE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP0FE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP0FE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP0FE_A::DISABLED)
    }
    #[doc = "High to low. A sequence of 1 then 0 on CAPn.0 will cause CR0 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn high_to_low(self) -> &'a mut W {
        self.variant(CAP0FE_A::HIGH_TO_LOW)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Interrupt on CAPn.0 event\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP0I_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Load. A CR0 load due to a CAPn.0 event will generate an interrupt."]
    LOAD,
}
impl From<CAP0I_A> for bool {
    #[inline(always)]
    fn from(variant: CAP0I_A) -> Self {
        match variant {
            CAP0I_A::DISABLED => false,
            CAP0I_A::LOAD => true,
        }
    }
}
#[doc = "Reader of field `CAP0I`"]
pub type CAP0I_R = crate::R<bool, CAP0I_A>;
impl CAP0I_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP0I_A {
        match self.bits {
            false => CAP0I_A::DISABLED,
            true => CAP0I_A::LOAD,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP0I_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOAD`"]
    #[inline(always)]
    pub fn is_load(&self) -> bool {
        *self == CAP0I_A::LOAD
    }
}
#[doc = "Write proxy for field `CAP0I`"]
pub struct CAP0I_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP0I_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP0I_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP0I_A::DISABLED)
    }
    #[doc = "Load. A CR0 load due to a CAPn.0 event will generate an interrupt."]
    #[inline(always)]
    pub fn load(self) -> &'a mut W {
        self.variant(CAP0I_A::LOAD)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Capture on CAPn.1 rising edge\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP1RE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Low to high. A sequence of 0 then 1 on CAPn.1 will cause CR1 to be loaded with the contents of TC."]
    LOW_TO_HIGH,
}
impl From<CAP1RE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP1RE_A) -> Self {
        match variant {
            CAP1RE_A::DISABLED => false,
            CAP1RE_A::LOW_TO_HIGH => true,
        }
    }
}
#[doc = "Reader of field `CAP1RE`"]
pub type CAP1RE_R = crate::R<bool, CAP1RE_A>;
impl CAP1RE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP1RE_A {
        match self.bits {
            false => CAP1RE_A::DISABLED,
            true => CAP1RE_A::LOW_TO_HIGH,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP1RE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOW_TO_HIGH`"]
    #[inline(always)]
    pub fn is_low_to_high(&self) -> bool {
        *self == CAP1RE_A::LOW_TO_HIGH
    }
}
#[doc = "Write proxy for field `CAP1RE`"]
pub struct CAP1RE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP1RE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP1RE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP1RE_A::DISABLED)
    }
    #[doc = "Low to high. A sequence of 0 then 1 on CAPn.1 will cause CR1 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn low_to_high(self) -> &'a mut W {
        self.variant(CAP1RE_A::LOW_TO_HIGH)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Capture on CAPn.1 falling edge\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP1FE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: High to low. A sequence of 1 then 0 on CAPn.1 will cause CR1 to be loaded with the contents of TC."]
    HIGH_TO_LOW,
}
impl From<CAP1FE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP1FE_A) -> Self {
        match variant {
            CAP1FE_A::DISABLED => false,
            CAP1FE_A::HIGH_TO_LOW => true,
        }
    }
}
#[doc = "Reader of field `CAP1FE`"]
pub type CAP1FE_R = crate::R<bool, CAP1FE_A>;
impl CAP1FE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP1FE_A {
        match self.bits {
            false => CAP1FE_A::DISABLED,
            true => CAP1FE_A::HIGH_TO_LOW,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP1FE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `HIGH_TO_LOW`"]
    #[inline(always)]
    pub fn is_high_to_low(&self) -> bool {
        *self == CAP1FE_A::HIGH_TO_LOW
    }
}
#[doc = "Write proxy for field `CAP1FE`"]
pub struct CAP1FE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP1FE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP1FE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP1FE_A::DISABLED)
    }
    #[doc = "High to low. A sequence of 1 then 0 on CAPn.1 will cause CR1 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn high_to_low(self) -> &'a mut W {
        self.variant(CAP1FE_A::HIGH_TO_LOW)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Interrupt on CAPn.1 event\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP1I_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Load. A CR1 load due to a CAPn.1 event will generate an interrupt."]
    LOAD,
}
impl From<CAP1I_A> for bool {
    #[inline(always)]
    fn from(variant: CAP1I_A) -> Self {
        match variant {
            CAP1I_A::DISABLED => false,
            CAP1I_A::LOAD => true,
        }
    }
}
#[doc = "Reader of field `CAP1I`"]
pub type CAP1I_R = crate::R<bool, CAP1I_A>;
impl CAP1I_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP1I_A {
        match self.bits {
            false => CAP1I_A::DISABLED,
            true => CAP1I_A::LOAD,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP1I_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOAD`"]
    #[inline(always)]
    pub fn is_load(&self) -> bool {
        *self == CAP1I_A::LOAD
    }
}
#[doc = "Write proxy for field `CAP1I`"]
pub struct CAP1I_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP1I_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP1I_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP1I_A::DISABLED)
    }
    #[doc = "Load. A CR1 load due to a CAPn.1 event will generate an interrupt."]
    #[inline(always)]
    pub fn load(self) -> &'a mut W {
        self.variant(CAP1I_A::LOAD)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Capture on CAPn.2 rising edge\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP2RE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Low to high. A sequence of 0 then 1 on CAPn.2 will cause CR2 to be loaded with the contents of TC."]
    LOW_TO_HIGH,
}
impl From<CAP2RE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP2RE_A) -> Self {
        match variant {
            CAP2RE_A::DISABLED => false,
            CAP2RE_A::LOW_TO_HIGH => true,
        }
    }
}
#[doc = "Reader of field `CAP2RE`"]
pub type CAP2RE_R = crate::R<bool, CAP2RE_A>;
impl CAP2RE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP2RE_A {
        match self.bits {
            false => CAP2RE_A::DISABLED,
            true => CAP2RE_A::LOW_TO_HIGH,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP2RE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOW_TO_HIGH`"]
    #[inline(always)]
    pub fn is_low_to_high(&self) -> bool {
        *self == CAP2RE_A::LOW_TO_HIGH
    }
}
#[doc = "Write proxy for field `CAP2RE`"]
pub struct CAP2RE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP2RE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP2RE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP2RE_A::DISABLED)
    }
    #[doc = "Low to high. A sequence of 0 then 1 on CAPn.2 will cause CR2 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn low_to_high(self) -> &'a mut W {
        self.variant(CAP2RE_A::LOW_TO_HIGH)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Capture on CAPn.2 falling edge:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP2FE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: High to low. A sequence of 1 then 0 on CAPn.2 will cause CR2 to be loaded with the contents of TC."]
    HIGH_TO_LOW,
}
impl From<CAP2FE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP2FE_A) -> Self {
        match variant {
            CAP2FE_A::DISABLED => false,
            CAP2FE_A::HIGH_TO_LOW => true,
        }
    }
}
#[doc = "Reader of field `CAP2FE`"]
pub type CAP2FE_R = crate::R<bool, CAP2FE_A>;
impl CAP2FE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP2FE_A {
        match self.bits {
            false => CAP2FE_A::DISABLED,
            true => CAP2FE_A::HIGH_TO_LOW,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP2FE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `HIGH_TO_LOW`"]
    #[inline(always)]
    pub fn is_high_to_low(&self) -> bool {
        *self == CAP2FE_A::HIGH_TO_LOW
    }
}
#[doc = "Write proxy for field `CAP2FE`"]
pub struct CAP2FE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP2FE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP2FE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP2FE_A::DISABLED)
    }
    #[doc = "High to low. A sequence of 1 then 0 on CAPn.2 will cause CR2 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn high_to_low(self) -> &'a mut W {
        self.variant(CAP2FE_A::HIGH_TO_LOW)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Interrupt on CAPn.2 event\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP2I_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Load. A CR2 load due to a CAPn.2 event will generate an interrupt."]
    LOAD,
}
impl From<CAP2I_A> for bool {
    #[inline(always)]
    fn from(variant: CAP2I_A) -> Self {
        match variant {
            CAP2I_A::DISABLED => false,
            CAP2I_A::LOAD => true,
        }
    }
}
#[doc = "Reader of field `CAP2I`"]
pub type CAP2I_R = crate::R<bool, CAP2I_A>;
impl CAP2I_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP2I_A {
        match self.bits {
            false => CAP2I_A::DISABLED,
            true => CAP2I_A::LOAD,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP2I_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOAD`"]
    #[inline(always)]
    pub fn is_load(&self) -> bool {
        *self == CAP2I_A::LOAD
    }
}
#[doc = "Write proxy for field `CAP2I`"]
pub struct CAP2I_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP2I_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP2I_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP2I_A::DISABLED)
    }
    #[doc = "Load. A CR2 load due to a CAPn.2 event will generate an interrupt."]
    #[inline(always)]
    pub fn load(self) -> &'a mut W {
        self.variant(CAP2I_A::LOAD)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "Capture on CAPn.3 rising edge\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP3RE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Low to high. A sequence of 0 then 1 on CAPn.3 will cause CR3 to be loaded with the contents of TC."]
    LOW_TO_HIGH,
}
impl From<CAP3RE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP3RE_A) -> Self {
        match variant {
            CAP3RE_A::DISABLED => false,
            CAP3RE_A::LOW_TO_HIGH => true,
        }
    }
}
#[doc = "Reader of field `CAP3RE`"]
pub type CAP3RE_R = crate::R<bool, CAP3RE_A>;
impl CAP3RE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP3RE_A {
        match self.bits {
            false => CAP3RE_A::DISABLED,
            true => CAP3RE_A::LOW_TO_HIGH,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP3RE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOW_TO_HIGH`"]
    #[inline(always)]
    pub fn is_low_to_high(&self) -> bool {
        *self == CAP3RE_A::LOW_TO_HIGH
    }
}
#[doc = "Write proxy for field `CAP3RE`"]
pub struct CAP3RE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP3RE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP3RE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP3RE_A::DISABLED)
    }
    #[doc = "Low to high. A sequence of 0 then 1 on CAPn.3 will cause CR3 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn low_to_high(self) -> &'a mut W {
        self.variant(CAP3RE_A::LOW_TO_HIGH)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "High to low. Capture on CAPn.3 falling edge\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP3FE_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: A sequence of 1 then 0 on CAPn.3 will cause CR3 to be loaded with the contents of TC."]
    HIGH_TO_LOW,
}
impl From<CAP3FE_A> for bool {
    #[inline(always)]
    fn from(variant: CAP3FE_A) -> Self {
        match variant {
            CAP3FE_A::DISABLED => false,
            CAP3FE_A::HIGH_TO_LOW => true,
        }
    }
}
#[doc = "Reader of field `CAP3FE`"]
pub type CAP3FE_R = crate::R<bool, CAP3FE_A>;
impl CAP3FE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP3FE_A {
        match self.bits {
            false => CAP3FE_A::DISABLED,
            true => CAP3FE_A::HIGH_TO_LOW,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP3FE_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `HIGH_TO_LOW`"]
    #[inline(always)]
    pub fn is_high_to_low(&self) -> bool {
        *self == CAP3FE_A::HIGH_TO_LOW
    }
}
#[doc = "Write proxy for field `CAP3FE`"]
pub struct CAP3FE_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP3FE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP3FE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP3FE_A::DISABLED)
    }
    #[doc = "A sequence of 1 then 0 on CAPn.3 will cause CR3 to be loaded with the contents of TC."]
    #[inline(always)]
    pub fn high_to_low(self) -> &'a mut W {
        self.variant(CAP3FE_A::HIGH_TO_LOW)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | (((value as u32) & 0x01) << 10);
        self.w
    }
}
#[doc = "Interrupt on CAPn.3 event:\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CAP3I_A {
    #[doc = "0: Disabled. This feature is disabled."]
    DISABLED,
    #[doc = "1: Load. A CR3 load due to a CAPn.3 event will generate an interrupt."]
    LOAD,
}
impl From<CAP3I_A> for bool {
    #[inline(always)]
    fn from(variant: CAP3I_A) -> Self {
        match variant {
            CAP3I_A::DISABLED => false,
            CAP3I_A::LOAD => true,
        }
    }
}
#[doc = "Reader of field `CAP3I`"]
pub type CAP3I_R = crate::R<bool, CAP3I_A>;
impl CAP3I_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CAP3I_A {
        match self.bits {
            false => CAP3I_A::DISABLED,
            true => CAP3I_A::LOAD,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == CAP3I_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `LOAD`"]
    #[inline(always)]
    pub fn is_load(&self) -> bool {
        *self == CAP3I_A::LOAD
    }
}
#[doc = "Write proxy for field `CAP3I`"]
pub struct CAP3I_W<'a> {
    w: &'a mut W,
}
impl<'a> CAP3I_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CAP3I_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. This feature is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(CAP3I_A::DISABLED)
    }
    #[doc = "Load. A CR3 load due to a CAPn.3 event will generate an interrupt."]
    #[inline(always)]
    pub fn load(self) -> &'a mut W {
        self.variant(CAP3I_A::LOAD)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Capture on CAPn.0 rising edge"]
    #[inline(always)]
    pub fn cap0re(&self) -> CAP0RE_R {
        CAP0RE_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Capture on CAPn.0 falling edge"]
    #[inline(always)]
    pub fn cap0fe(&self) -> CAP0FE_R {
        CAP0FE_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Interrupt on CAPn.0 event"]
    #[inline(always)]
    pub fn cap0i(&self) -> CAP0I_R {
        CAP0I_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Capture on CAPn.1 rising edge"]
    #[inline(always)]
    pub fn cap1re(&self) -> CAP1RE_R {
        CAP1RE_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Capture on CAPn.1 falling edge"]
    #[inline(always)]
    pub fn cap1fe(&self) -> CAP1FE_R {
        CAP1FE_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Interrupt on CAPn.1 event"]
    #[inline(always)]
    pub fn cap1i(&self) -> CAP1I_R {
        CAP1I_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Capture on CAPn.2 rising edge"]
    #[inline(always)]
    pub fn cap2re(&self) -> CAP2RE_R {
        CAP2RE_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Capture on CAPn.2 falling edge:"]
    #[inline(always)]
    pub fn cap2fe(&self) -> CAP2FE_R {
        CAP2FE_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Interrupt on CAPn.2 event"]
    #[inline(always)]
    pub fn cap2i(&self) -> CAP2I_R {
        CAP2I_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - Capture on CAPn.3 rising edge"]
    #[inline(always)]
    pub fn cap3re(&self) -> CAP3RE_R {
        CAP3RE_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - High to low. Capture on CAPn.3 falling edge"]
    #[inline(always)]
    pub fn cap3fe(&self) -> CAP3FE_R {
        CAP3FE_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - Interrupt on CAPn.3 event:"]
    #[inline(always)]
    pub fn cap3i(&self) -> CAP3I_R {
        CAP3I_R::new(((self.bits >> 11) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Capture on CAPn.0 rising edge"]
    #[inline(always)]
    pub fn cap0re(&mut self) -> CAP0RE_W {
        CAP0RE_W { w: self }
    }
    #[doc = "Bit 1 - Capture on CAPn.0 falling edge"]
    #[inline(always)]
    pub fn cap0fe(&mut self) -> CAP0FE_W {
        CAP0FE_W { w: self }
    }
    #[doc = "Bit 2 - Interrupt on CAPn.0 event"]
    #[inline(always)]
    pub fn cap0i(&mut self) -> CAP0I_W {
        CAP0I_W { w: self }
    }
    #[doc = "Bit 3 - Capture on CAPn.1 rising edge"]
    #[inline(always)]
    pub fn cap1re(&mut self) -> CAP1RE_W {
        CAP1RE_W { w: self }
    }
    #[doc = "Bit 4 - Capture on CAPn.1 falling edge"]
    #[inline(always)]
    pub fn cap1fe(&mut self) -> CAP1FE_W {
        CAP1FE_W { w: self }
    }
    #[doc = "Bit 5 - Interrupt on CAPn.1 event"]
    #[inline(always)]
    pub fn cap1i(&mut self) -> CAP1I_W {
        CAP1I_W { w: self }
    }
    #[doc = "Bit 6 - Capture on CAPn.2 rising edge"]
    #[inline(always)]
    pub fn cap2re(&mut self) -> CAP2RE_W {
        CAP2RE_W { w: self }
    }
    #[doc = "Bit 7 - Capture on CAPn.2 falling edge:"]
    #[inline(always)]
    pub fn cap2fe(&mut self) -> CAP2FE_W {
        CAP2FE_W { w: self }
    }
    #[doc = "Bit 8 - Interrupt on CAPn.2 event"]
    #[inline(always)]
    pub fn cap2i(&mut self) -> CAP2I_W {
        CAP2I_W { w: self }
    }
    #[doc = "Bit 9 - Capture on CAPn.3 rising edge"]
    #[inline(always)]
    pub fn cap3re(&mut self) -> CAP3RE_W {
        CAP3RE_W { w: self }
    }
    #[doc = "Bit 10 - High to low. Capture on CAPn.3 falling edge"]
    #[inline(always)]
    pub fn cap3fe(&mut self) -> CAP3FE_W {
        CAP3FE_W { w: self }
    }
    #[doc = "Bit 11 - Interrupt on CAPn.3 event:"]
    #[inline(always)]
    pub fn cap3i(&mut self) -> CAP3I_W {
        CAP3I_W { w: self }
    }
}
