#[doc = "Reader of register LCR"]
pub type R = crate::R<u32, super::LCR>;
#[doc = "Writer for register LCR"]
pub type W = crate::W<u32, super::LCR>;
#[doc = "Register LCR `reset()`'s with value 0"]
impl crate::ResetValue for super::LCR {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Word Length Select.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WLS_A {
    #[doc = "0: 5-bit character length."]
    _5_BIT_CHARACTER_LENGTH,
    #[doc = "1: 6-bit character length."]
    _6_BIT_CHARACTER_LENGTH,
    #[doc = "2: 7-bit character length."]
    _7_BIT_CHARACTER_LENGTH,
    #[doc = "3: 8-bit character length."]
    _8_BIT_CHARACTER_LENGTH,
}
impl From<WLS_A> for u8 {
    #[inline(always)]
    fn from(variant: WLS_A) -> Self {
        match variant {
            WLS_A::_5_BIT_CHARACTER_LENGTH => 0,
            WLS_A::_6_BIT_CHARACTER_LENGTH => 1,
            WLS_A::_7_BIT_CHARACTER_LENGTH => 2,
            WLS_A::_8_BIT_CHARACTER_LENGTH => 3,
        }
    }
}
#[doc = "Reader of field `WLS`"]
pub type WLS_R = crate::R<u8, WLS_A>;
impl WLS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WLS_A {
        match self.bits {
            0 => WLS_A::_5_BIT_CHARACTER_LENGTH,
            1 => WLS_A::_6_BIT_CHARACTER_LENGTH,
            2 => WLS_A::_7_BIT_CHARACTER_LENGTH,
            3 => WLS_A::_8_BIT_CHARACTER_LENGTH,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `_5_BIT_CHARACTER_LENGTH`"]
    #[inline(always)]
    pub fn is_5_bit_character_length(&self) -> bool {
        *self == WLS_A::_5_BIT_CHARACTER_LENGTH
    }
    #[doc = "Checks if the value of the field is `_6_BIT_CHARACTER_LENGTH`"]
    #[inline(always)]
    pub fn is_6_bit_character_length(&self) -> bool {
        *self == WLS_A::_6_BIT_CHARACTER_LENGTH
    }
    #[doc = "Checks if the value of the field is `_7_BIT_CHARACTER_LENGTH`"]
    #[inline(always)]
    pub fn is_7_bit_character_length(&self) -> bool {
        *self == WLS_A::_7_BIT_CHARACTER_LENGTH
    }
    #[doc = "Checks if the value of the field is `_8_BIT_CHARACTER_LENGTH`"]
    #[inline(always)]
    pub fn is_8_bit_character_length(&self) -> bool {
        *self == WLS_A::_8_BIT_CHARACTER_LENGTH
    }
}
#[doc = "Write proxy for field `WLS`"]
pub struct WLS_W<'a> {
    w: &'a mut W,
}
impl<'a> WLS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WLS_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "5-bit character length."]
    #[inline(always)]
    pub fn _5_bit_character_length(self) -> &'a mut W {
        self.variant(WLS_A::_5_BIT_CHARACTER_LENGTH)
    }
    #[doc = "6-bit character length."]
    #[inline(always)]
    pub fn _6_bit_character_length(self) -> &'a mut W {
        self.variant(WLS_A::_6_BIT_CHARACTER_LENGTH)
    }
    #[doc = "7-bit character length."]
    #[inline(always)]
    pub fn _7_bit_character_length(self) -> &'a mut W {
        self.variant(WLS_A::_7_BIT_CHARACTER_LENGTH)
    }
    #[doc = "8-bit character length."]
    #[inline(always)]
    pub fn _8_bit_character_length(self) -> &'a mut W {
        self.variant(WLS_A::_8_BIT_CHARACTER_LENGTH)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | ((value as u32) & 0x03);
        self.w
    }
}
#[doc = "Stop Bit Select.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SBS_A {
    #[doc = "0: 1 stop bit."]
    _1_STOP_BIT,
    #[doc = "1: 2 stop bits (1.5 if LCR\\[1:0\\]=00)."]
    _2_STOP_BITS_1,
}
impl From<SBS_A> for bool {
    #[inline(always)]
    fn from(variant: SBS_A) -> Self {
        match variant {
            SBS_A::_1_STOP_BIT => false,
            SBS_A::_2_STOP_BITS_1 => true,
        }
    }
}
#[doc = "Reader of field `SBS`"]
pub type SBS_R = crate::R<bool, SBS_A>;
impl SBS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SBS_A {
        match self.bits {
            false => SBS_A::_1_STOP_BIT,
            true => SBS_A::_2_STOP_BITS_1,
        }
    }
    #[doc = "Checks if the value of the field is `_1_STOP_BIT`"]
    #[inline(always)]
    pub fn is_1_stop_bit(&self) -> bool {
        *self == SBS_A::_1_STOP_BIT
    }
    #[doc = "Checks if the value of the field is `_2_STOP_BITS_1`"]
    #[inline(always)]
    pub fn is_2_stop_bits_1(&self) -> bool {
        *self == SBS_A::_2_STOP_BITS_1
    }
}
#[doc = "Write proxy for field `SBS`"]
pub struct SBS_W<'a> {
    w: &'a mut W,
}
impl<'a> SBS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SBS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "1 stop bit."]
    #[inline(always)]
    pub fn _1_stop_bit(self) -> &'a mut W {
        self.variant(SBS_A::_1_STOP_BIT)
    }
    #[doc = "2 stop bits (1.5 if LCR\\[1:0\\]=00)."]
    #[inline(always)]
    pub fn _2_stop_bits_1(self) -> &'a mut W {
        self.variant(SBS_A::_2_STOP_BITS_1)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Parity Enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PE_A {
    #[doc = "0: Disable parity generation and checking."]
    DISABLE_PARITY_GENERERATION,
    #[doc = "1: Enable parity generation and checking."]
    ENABLE_PARITY_GENERATION,
}
impl From<PE_A> for bool {
    #[inline(always)]
    fn from(variant: PE_A) -> Self {
        match variant {
            PE_A::DISABLE_PARITY_GENERERATION => false,
            PE_A::ENABLE_PARITY_GENERATION => true,
        }
    }
}
#[doc = "Reader of field `PE`"]
pub type PE_R = crate::R<bool, PE_A>;
impl PE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PE_A {
        match self.bits {
            false => PE_A::DISABLE_PARITY_GENERERATION,
            true => PE_A::ENABLE_PARITY_GENERATION,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE_PARITY_GENERERATION`"]
    #[inline(always)]
    pub fn is_disable_parity_genereration(&self) -> bool {
        *self == PE_A::DISABLE_PARITY_GENERERATION
    }
    #[doc = "Checks if the value of the field is `ENABLE_PARITY_GENERATION`"]
    #[inline(always)]
    pub fn is_enable_parity_generation(&self) -> bool {
        *self == PE_A::ENABLE_PARITY_GENERATION
    }
}
#[doc = "Write proxy for field `PE`"]
pub struct PE_W<'a> {
    w: &'a mut W,
}
impl<'a> PE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disable parity generation and checking."]
    #[inline(always)]
    pub fn disable_parity_genereration(self) -> &'a mut W {
        self.variant(PE_A::DISABLE_PARITY_GENERERATION)
    }
    #[doc = "Enable parity generation and checking."]
    #[inline(always)]
    pub fn enable_parity_generation(self) -> &'a mut W {
        self.variant(PE_A::ENABLE_PARITY_GENERATION)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Parity Select.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PS_A {
    #[doc = "0: Odd parity. Number of 1s in the transmitted character and the attached parity bit will be odd."]
    ODD_PARITY,
    #[doc = "1: Even Parity. Number of 1s in the transmitted character and the attached parity bit will be even."]
    EVEN_PARITY,
    #[doc = "2: Force HIGH. Forced 1 stick parity."]
    FORCE_HIGH,
    #[doc = "3: Force LOW. Forced 0 stick parity."]
    FORCE_LOW,
}
impl From<PS_A> for u8 {
    #[inline(always)]
    fn from(variant: PS_A) -> Self {
        match variant {
            PS_A::ODD_PARITY => 0,
            PS_A::EVEN_PARITY => 1,
            PS_A::FORCE_HIGH => 2,
            PS_A::FORCE_LOW => 3,
        }
    }
}
#[doc = "Reader of field `PS`"]
pub type PS_R = crate::R<u8, PS_A>;
impl PS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PS_A {
        match self.bits {
            0 => PS_A::ODD_PARITY,
            1 => PS_A::EVEN_PARITY,
            2 => PS_A::FORCE_HIGH,
            3 => PS_A::FORCE_LOW,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `ODD_PARITY`"]
    #[inline(always)]
    pub fn is_odd_parity(&self) -> bool {
        *self == PS_A::ODD_PARITY
    }
    #[doc = "Checks if the value of the field is `EVEN_PARITY`"]
    #[inline(always)]
    pub fn is_even_parity(&self) -> bool {
        *self == PS_A::EVEN_PARITY
    }
    #[doc = "Checks if the value of the field is `FORCE_HIGH`"]
    #[inline(always)]
    pub fn is_force_high(&self) -> bool {
        *self == PS_A::FORCE_HIGH
    }
    #[doc = "Checks if the value of the field is `FORCE_LOW`"]
    #[inline(always)]
    pub fn is_force_low(&self) -> bool {
        *self == PS_A::FORCE_LOW
    }
}
#[doc = "Write proxy for field `PS`"]
pub struct PS_W<'a> {
    w: &'a mut W,
}
impl<'a> PS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PS_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Odd parity. Number of 1s in the transmitted character and the attached parity bit will be odd."]
    #[inline(always)]
    pub fn odd_parity(self) -> &'a mut W {
        self.variant(PS_A::ODD_PARITY)
    }
    #[doc = "Even Parity. Number of 1s in the transmitted character and the attached parity bit will be even."]
    #[inline(always)]
    pub fn even_parity(self) -> &'a mut W {
        self.variant(PS_A::EVEN_PARITY)
    }
    #[doc = "Force HIGH. Forced 1 stick parity."]
    #[inline(always)]
    pub fn force_high(self) -> &'a mut W {
        self.variant(PS_A::FORCE_HIGH)
    }
    #[doc = "Force LOW. Forced 0 stick parity."]
    #[inline(always)]
    pub fn force_low(self) -> &'a mut W {
        self.variant(PS_A::FORCE_LOW)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 4)) | (((value as u32) & 0x03) << 4);
        self.w
    }
}
#[doc = "Break Control.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum BC_A {
    #[doc = "0: Disabled. Disable break transmission."]
    DISABLED,
    #[doc = "1: Enabled. Enable break transmission. Output pin USART TXD is forced to logic 0 when LCR is active high."]
    ENABLED,
}
impl From<BC_A> for bool {
    #[inline(always)]
    fn from(variant: BC_A) -> Self {
        match variant {
            BC_A::DISABLED => false,
            BC_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `BC`"]
pub type BC_R = crate::R<bool, BC_A>;
impl BC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> BC_A {
        match self.bits {
            false => BC_A::DISABLED,
            true => BC_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == BC_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == BC_A::ENABLED
    }
}
#[doc = "Write proxy for field `BC`"]
pub struct BC_W<'a> {
    w: &'a mut W,
}
impl<'a> BC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: BC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Disable break transmission."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(BC_A::DISABLED)
    }
    #[doc = "Enabled. Enable break transmission. Output pin USART TXD is forced to logic 0 when LCR is active high."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(BC_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Divisor Latch Access Bit.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DLAB_A {
    #[doc = "0: Disabled. Disable access to Divisor Latches."]
    DISABLED,
    #[doc = "1: Enabled. Enable access to Divisor Latches."]
    ENABLED,
}
impl From<DLAB_A> for bool {
    #[inline(always)]
    fn from(variant: DLAB_A) -> Self {
        match variant {
            DLAB_A::DISABLED => false,
            DLAB_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `DLAB`"]
pub type DLAB_R = crate::R<bool, DLAB_A>;
impl DLAB_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> DLAB_A {
        match self.bits {
            false => DLAB_A::DISABLED,
            true => DLAB_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == DLAB_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == DLAB_A::ENABLED
    }
}
#[doc = "Write proxy for field `DLAB`"]
pub struct DLAB_W<'a> {
    w: &'a mut W,
}
impl<'a> DLAB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: DLAB_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled. Disable access to Divisor Latches."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(DLAB_A::DISABLED)
    }
    #[doc = "Enabled. Enable access to Divisor Latches."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(DLAB_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - Word Length Select."]
    #[inline(always)]
    pub fn wls(&self) -> WLS_R {
        WLS_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bit 2 - Stop Bit Select."]
    #[inline(always)]
    pub fn sbs(&self) -> SBS_R {
        SBS_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Parity Enable"]
    #[inline(always)]
    pub fn pe(&self) -> PE_R {
        PE_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bits 4:5 - Parity Select."]
    #[inline(always)]
    pub fn ps(&self) -> PS_R {
        PS_R::new(((self.bits >> 4) & 0x03) as u8)
    }
    #[doc = "Bit 6 - Break Control."]
    #[inline(always)]
    pub fn bc(&self) -> BC_R {
        BC_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Divisor Latch Access Bit."]
    #[inline(always)]
    pub fn dlab(&self) -> DLAB_R {
        DLAB_R::new(((self.bits >> 7) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:1 - Word Length Select."]
    #[inline(always)]
    pub fn wls(&mut self) -> WLS_W {
        WLS_W { w: self }
    }
    #[doc = "Bit 2 - Stop Bit Select."]
    #[inline(always)]
    pub fn sbs(&mut self) -> SBS_W {
        SBS_W { w: self }
    }
    #[doc = "Bit 3 - Parity Enable"]
    #[inline(always)]
    pub fn pe(&mut self) -> PE_W {
        PE_W { w: self }
    }
    #[doc = "Bits 4:5 - Parity Select."]
    #[inline(always)]
    pub fn ps(&mut self) -> PS_W {
        PS_W { w: self }
    }
    #[doc = "Bit 6 - Break Control."]
    #[inline(always)]
    pub fn bc(&mut self) -> BC_W {
        BC_W { w: self }
    }
    #[doc = "Bit 7 - Divisor Latch Access Bit."]
    #[inline(always)]
    pub fn dlab(&mut self) -> DLAB_W {
        DLAB_W { w: self }
    }
}
