#[doc = "Reader of register DEVICEADDR"]
pub type R = crate::R<u32, super::DEVICEADDR>;
#[doc = "Writer for register DEVICEADDR"]
pub type W = crate::W<u32, super::DEVICEADDR>;
#[doc = "Register DEVICEADDR `reset()`'s with value 0"]
impl crate::ResetValue for super::DEVICEADDR {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Device address advance\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum USBADRA_A {
    #[doc = "0: Any write to USBADR are instantaneous."]
    INSTANTANEOUS,
    #[doc = "1: When the user writes a one to this bit at the same time or before USBADR is written, the write to USBADR fields is staged and held in a hidden register. After an IN occurs on endpoint 0 and is acknowledged, USBADR will be loaded from the holding register. Hardware will automatically clear this bit on the following conditions: IN is ACKed to endpoint 0. USBADR is updated from the staging register. OUT/SETUP occurs on endpoint 0. USBADR is not updated. Device reset occurs. USBADR is set to 0. After the status phase of the SET_ADDRESS descriptor, the DCD has 2 ms to program the USBADR field. This mechanism will ensure this specification is met when the DCD can not write the device address within 2 ms from the SET_ADDRESS status phase. If the DCD writes the USBADR with USBADRA=1 after the SET_ADDRESS data phase (before the prime of the status phase), the USBADR will be programmed instantly at the correct time and meet the 2 ms USB requirement."]
    DELAYED,
}
impl From<USBADRA_A> for bool {
    #[inline(always)]
    fn from(variant: USBADRA_A) -> Self {
        match variant {
            USBADRA_A::INSTANTANEOUS => false,
            USBADRA_A::DELAYED => true,
        }
    }
}
#[doc = "Reader of field `USBADRA`"]
pub type USBADRA_R = crate::R<bool, USBADRA_A>;
impl USBADRA_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> USBADRA_A {
        match self.bits {
            false => USBADRA_A::INSTANTANEOUS,
            true => USBADRA_A::DELAYED,
        }
    }
    #[doc = "Checks if the value of the field is `INSTANTANEOUS`"]
    #[inline(always)]
    pub fn is_instantaneous(&self) -> bool {
        *self == USBADRA_A::INSTANTANEOUS
    }
    #[doc = "Checks if the value of the field is `DELAYED`"]
    #[inline(always)]
    pub fn is_delayed(&self) -> bool {
        *self == USBADRA_A::DELAYED
    }
}
#[doc = "Write proxy for field `USBADRA`"]
pub struct USBADRA_W<'a> {
    w: &'a mut W,
}
impl<'a> USBADRA_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: USBADRA_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Any write to USBADR are instantaneous."]
    #[inline(always)]
    pub fn instantaneous(self) -> &'a mut W {
        self.variant(USBADRA_A::INSTANTANEOUS)
    }
    #[doc = "When the user writes a one to this bit at the same time or before USBADR is written, the write to USBADR fields is staged and held in a hidden register. After an IN occurs on endpoint 0 and is acknowledged, USBADR will be loaded from the holding register. Hardware will automatically clear this bit on the following conditions: IN is ACKed to endpoint 0. USBADR is updated from the staging register. OUT/SETUP occurs on endpoint 0. USBADR is not updated. Device reset occurs. USBADR is set to 0. After the status phase of the SET_ADDRESS descriptor, the DCD has 2 ms to program the USBADR field. This mechanism will ensure this specification is met when the DCD can not write the device address within 2 ms from the SET_ADDRESS status phase. If the DCD writes the USBADR with USBADRA=1 after the SET_ADDRESS data phase (before the prime of the status phase), the USBADR will be programmed instantly at the correct time and meet the 2 ms USB requirement."]
    #[inline(always)]
    pub fn delayed(self) -> &'a mut W {
        self.variant(USBADRA_A::DELAYED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | (((value as u32) & 0x01) << 24);
        self.w
    }
}
#[doc = "Reader of field `USBADR`"]
pub type USBADR_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `USBADR`"]
pub struct USBADR_W<'a> {
    w: &'a mut W,
}
impl<'a> USBADR_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x7f << 25)) | (((value as u32) & 0x7f) << 25);
        self.w
    }
}
impl R {
    #[doc = "Bit 24 - Device address advance"]
    #[inline(always)]
    pub fn usbadra(&self) -> USBADRA_R {
        USBADRA_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bits 25:31 - USB device address"]
    #[inline(always)]
    pub fn usbadr(&self) -> USBADR_R {
        USBADR_R::new(((self.bits >> 25) & 0x7f) as u8)
    }
}
impl W {
    #[doc = "Bit 24 - Device address advance"]
    #[inline(always)]
    pub fn usbadra(&mut self) -> USBADRA_W {
        USBADRA_W { w: self }
    }
    #[doc = "Bits 25:31 - USB device address"]
    #[inline(always)]
    pub fn usbadr(&mut self) -> USBADR_W {
        USBADR_W { w: self }
    }
}
