#[doc = "Reader of register USBMODE_D"]
pub type R = crate::R<u32, super::USBMODE_D>;
#[doc = "Writer for register USBMODE_D"]
pub type W = crate::W<u32, super::USBMODE_D>;
#[doc = "Register USBMODE_D `reset()`'s with value 0"]
impl crate::ResetValue for super::USBMODE_D {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Controller mode The controller defaults to an idle state and needs to be initialized to the desired operating mode after reset. This register can only be written once after reset. If it is necessary to switch modes, software must reset the controller by writing to the RESET bit in the USBCMD register before reprogramming this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CM1_0_A {
    #[doc = "0: Idle"]
    IDLE,
    #[doc = "2: Device controller"]
    DEVICE_CONTROLLER,
    #[doc = "3: Host controller"]
    HOST_CONTROLLER,
}
impl From<CM1_0_A> for u8 {
    #[inline(always)]
    fn from(variant: CM1_0_A) -> Self {
        match variant {
            CM1_0_A::IDLE => 0,
            CM1_0_A::DEVICE_CONTROLLER => 2,
            CM1_0_A::HOST_CONTROLLER => 3,
        }
    }
}
#[doc = "Reader of field `CM1_0`"]
pub type CM1_0_R = crate::R<u8, CM1_0_A>;
impl CM1_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CM1_0_A {
        match self.bits {
            0 => CM1_0_A::IDLE,
            2 => CM1_0_A::DEVICE_CONTROLLER,
            3 => CM1_0_A::HOST_CONTROLLER,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `IDLE`"]
    #[inline(always)]
    pub fn is_idle(&self) -> bool {
        *self == CM1_0_A::IDLE
    }
    #[doc = "Checks if the value of the field is `DEVICE_CONTROLLER`"]
    #[inline(always)]
    pub fn is_device_controller(&self) -> bool {
        *self == CM1_0_A::DEVICE_CONTROLLER
    }
    #[doc = "Checks if the value of the field is `HOST_CONTROLLER`"]
    #[inline(always)]
    pub fn is_host_controller(&self) -> bool {
        *self == CM1_0_A::HOST_CONTROLLER
    }
}
#[doc = "Write proxy for field `CM1_0`"]
pub struct CM1_0_W<'a> {
    w: &'a mut W,
}
impl<'a> CM1_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CM1_0_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Idle"]
    #[inline(always)]
    pub fn idle(self) -> &'a mut W {
        self.variant(CM1_0_A::IDLE)
    }
    #[doc = "Device controller"]
    #[inline(always)]
    pub fn device_controller(self) -> &'a mut W {
        self.variant(CM1_0_A::DEVICE_CONTROLLER)
    }
    #[doc = "Host controller"]
    #[inline(always)]
    pub fn host_controller(self) -> &'a mut W {
        self.variant(CM1_0_A::HOST_CONTROLLER)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | ((value as u32) & 0x03);
        self.w
    }
}
#[doc = "Endian select This bit can change the byte ordering of the transfer buffers to match the host microprocessor bus architecture. The bit fields in the microprocessor interface and the DMA data structures (including the setup buffer within the device QH) are unaffected by the value of this bit, because they are based upon 32-bit words.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ES_A {
    #[doc = "0: Little endian: first byte referenced in least significant byte of 32-bit word."]
    LITTLE_ENDIAN_FIRST,
    #[doc = "1: Big endian: first byte referenced in most significant byte of 32-bit word."]
    BIG_ENDIAN_FIRST_BY,
}
impl From<ES_A> for bool {
    #[inline(always)]
    fn from(variant: ES_A) -> Self {
        match variant {
            ES_A::LITTLE_ENDIAN_FIRST => false,
            ES_A::BIG_ENDIAN_FIRST_BY => true,
        }
    }
}
#[doc = "Reader of field `ES`"]
pub type ES_R = crate::R<bool, ES_A>;
impl ES_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ES_A {
        match self.bits {
            false => ES_A::LITTLE_ENDIAN_FIRST,
            true => ES_A::BIG_ENDIAN_FIRST_BY,
        }
    }
    #[doc = "Checks if the value of the field is `LITTLE_ENDIAN_FIRST`"]
    #[inline(always)]
    pub fn is_little_endian_first(&self) -> bool {
        *self == ES_A::LITTLE_ENDIAN_FIRST
    }
    #[doc = "Checks if the value of the field is `BIG_ENDIAN_FIRST_BY`"]
    #[inline(always)]
    pub fn is_big_endian_first_by(&self) -> bool {
        *self == ES_A::BIG_ENDIAN_FIRST_BY
    }
}
#[doc = "Write proxy for field `ES`"]
pub struct ES_W<'a> {
    w: &'a mut W,
}
impl<'a> ES_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ES_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Little endian: first byte referenced in least significant byte of 32-bit word."]
    #[inline(always)]
    pub fn little_endian_first(self) -> &'a mut W {
        self.variant(ES_A::LITTLE_ENDIAN_FIRST)
    }
    #[doc = "Big endian: first byte referenced in most significant byte of 32-bit word."]
    #[inline(always)]
    pub fn big_endian_first_by(self) -> &'a mut W {
        self.variant(ES_A::BIG_ENDIAN_FIRST_BY)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Setup Lockout mode In device mode, this bit controls behavior of the setup lock mechanism. See Section 18.10.8.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SLOM_A {
    #[doc = "0: Setup Lockouts on"]
    SETUP_LOCKOUTS_ON,
    #[doc = "1: Setup Lockouts Off (DCD requires the use of Setup Buffer Tripwire in USBCMD)"]
    SETUP_LOCKOUTS_OFF,
}
impl From<SLOM_A> for bool {
    #[inline(always)]
    fn from(variant: SLOM_A) -> Self {
        match variant {
            SLOM_A::SETUP_LOCKOUTS_ON => false,
            SLOM_A::SETUP_LOCKOUTS_OFF => true,
        }
    }
}
#[doc = "Reader of field `SLOM`"]
pub type SLOM_R = crate::R<bool, SLOM_A>;
impl SLOM_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SLOM_A {
        match self.bits {
            false => SLOM_A::SETUP_LOCKOUTS_ON,
            true => SLOM_A::SETUP_LOCKOUTS_OFF,
        }
    }
    #[doc = "Checks if the value of the field is `SETUP_LOCKOUTS_ON`"]
    #[inline(always)]
    pub fn is_setup_lockouts_on(&self) -> bool {
        *self == SLOM_A::SETUP_LOCKOUTS_ON
    }
    #[doc = "Checks if the value of the field is `SETUP_LOCKOUTS_OFF`"]
    #[inline(always)]
    pub fn is_setup_lockouts_off(&self) -> bool {
        *self == SLOM_A::SETUP_LOCKOUTS_OFF
    }
}
#[doc = "Write proxy for field `SLOM`"]
pub struct SLOM_W<'a> {
    w: &'a mut W,
}
impl<'a> SLOM_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SLOM_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Setup Lockouts on"]
    #[inline(always)]
    pub fn setup_lockouts_on(self) -> &'a mut W {
        self.variant(SLOM_A::SETUP_LOCKOUTS_ON)
    }
    #[doc = "Setup Lockouts Off (DCD requires the use of Setup Buffer Tripwire in USBCMD)"]
    #[inline(always)]
    pub fn setup_lockouts_off(self) -> &'a mut W {
        self.variant(SLOM_A::SETUP_LOCKOUTS_OFF)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Stream disable mode The use of this feature substantially limits the overall USB performance that can be achieved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDIS_A {
    #[doc = "0: Not disabled"]
    NOT_DISABLED,
    #[doc = "1: Disabled. Setting this bit to one disables double priming on both RX and TX for low bandwidth systems. This mode ensures that when the RX and TX buffers are sufficient to contain an entire packet that the standard double buffering scheme is disabled to prevent overruns/underruns in bandwidth limited systems. Note: In High Speed Mode, all packets received will be responded to with a NYET handshake when stream disable is active."]
    DISABLED_SETTING_TH,
}
impl From<SDIS_A> for bool {
    #[inline(always)]
    fn from(variant: SDIS_A) -> Self {
        match variant {
            SDIS_A::NOT_DISABLED => false,
            SDIS_A::DISABLED_SETTING_TH => true,
        }
    }
}
#[doc = "Reader of field `SDIS`"]
pub type SDIS_R = crate::R<bool, SDIS_A>;
impl SDIS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDIS_A {
        match self.bits {
            false => SDIS_A::NOT_DISABLED,
            true => SDIS_A::DISABLED_SETTING_TH,
        }
    }
    #[doc = "Checks if the value of the field is `NOT_DISABLED`"]
    #[inline(always)]
    pub fn is_not_disabled(&self) -> bool {
        *self == SDIS_A::NOT_DISABLED
    }
    #[doc = "Checks if the value of the field is `DISABLED_SETTING_TH`"]
    #[inline(always)]
    pub fn is_disabled_setting_th(&self) -> bool {
        *self == SDIS_A::DISABLED_SETTING_TH
    }
}
#[doc = "Write proxy for field `SDIS`"]
pub struct SDIS_W<'a> {
    w: &'a mut W,
}
impl<'a> SDIS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDIS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Not disabled"]
    #[inline(always)]
    pub fn not_disabled(self) -> &'a mut W {
        self.variant(SDIS_A::NOT_DISABLED)
    }
    #[doc = "Disabled. Setting this bit to one disables double priming on both RX and TX for low bandwidth systems. This mode ensures that when the RX and TX buffers are sufficient to contain an entire packet that the standard double buffering scheme is disabled to prevent overruns/underruns in bandwidth limited systems. Note: In High Speed Mode, all packets received will be responded to with a NYET handshake when stream disable is active."]
    #[inline(always)]
    pub fn disabled_setting_th(self) -> &'a mut W {
        self.variant(SDIS_A::DISABLED_SETTING_TH)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - Controller mode The controller defaults to an idle state and needs to be initialized to the desired operating mode after reset. This register can only be written once after reset. If it is necessary to switch modes, software must reset the controller by writing to the RESET bit in the USBCMD register before reprogramming this register."]
    #[inline(always)]
    pub fn cm1_0(&self) -> CM1_0_R {
        CM1_0_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bit 2 - Endian select This bit can change the byte ordering of the transfer buffers to match the host microprocessor bus architecture. The bit fields in the microprocessor interface and the DMA data structures (including the setup buffer within the device QH) are unaffected by the value of this bit, because they are based upon 32-bit words."]
    #[inline(always)]
    pub fn es(&self) -> ES_R {
        ES_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Setup Lockout mode In device mode, this bit controls behavior of the setup lock mechanism. See Section 18.10.8."]
    #[inline(always)]
    pub fn slom(&self) -> SLOM_R {
        SLOM_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Stream disable mode The use of this feature substantially limits the overall USB performance that can be achieved."]
    #[inline(always)]
    pub fn sdis(&self) -> SDIS_R {
        SDIS_R::new(((self.bits >> 4) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:1 - Controller mode The controller defaults to an idle state and needs to be initialized to the desired operating mode after reset. This register can only be written once after reset. If it is necessary to switch modes, software must reset the controller by writing to the RESET bit in the USBCMD register before reprogramming this register."]
    #[inline(always)]
    pub fn cm1_0(&mut self) -> CM1_0_W {
        CM1_0_W { w: self }
    }
    #[doc = "Bit 2 - Endian select This bit can change the byte ordering of the transfer buffers to match the host microprocessor bus architecture. The bit fields in the microprocessor interface and the DMA data structures (including the setup buffer within the device QH) are unaffected by the value of this bit, because they are based upon 32-bit words."]
    #[inline(always)]
    pub fn es(&mut self) -> ES_W {
        ES_W { w: self }
    }
    #[doc = "Bit 3 - Setup Lockout mode In device mode, this bit controls behavior of the setup lock mechanism. See Section 18.10.8."]
    #[inline(always)]
    pub fn slom(&mut self) -> SLOM_W {
        SLOM_W { w: self }
    }
    #[doc = "Bit 4 - Stream disable mode The use of this feature substantially limits the overall USB performance that can be achieved."]
    #[inline(always)]
    pub fn sdis(&mut self) -> SDIS_W {
        SDIS_W { w: self }
    }
}
