#[doc = "Reader of register ENDPTCTRL%s"]
pub type R = crate::R<u32, super::ENDPTCTRL>;
#[doc = "Writer for register ENDPTCTRL%s"]
pub type W = crate::W<u32, super::ENDPTCTRL>;
#[doc = "Register ENDPTCTRL%s `reset()`'s with value 0"]
impl crate::ResetValue for super::ENDPTCTRL {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Rx endpoint stall\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RXS_A {
    #[doc = "0: Endpoint ok. This bit will be cleared automatically upon receipt of a SETUP request if this Endpoint is configured as a Control Endpoint and this bit will continue to be cleared by hardware until the associated ENDPTSETUPSTAT bit is cleared."]
    ENDPOINT_OK_THIS_BI,
    #[doc = "1: Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request."]
    ENDPOINT_STALLED_SOFTWARE,
}
impl From<RXS_A> for bool {
    #[inline(always)]
    fn from(variant: RXS_A) -> Self {
        match variant {
            RXS_A::ENDPOINT_OK_THIS_BI => false,
            RXS_A::ENDPOINT_STALLED_SOFTWARE => true,
        }
    }
}
#[doc = "Reader of field `RXS`"]
pub type RXS_R = crate::R<bool, RXS_A>;
impl RXS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RXS_A {
        match self.bits {
            false => RXS_A::ENDPOINT_OK_THIS_BI,
            true => RXS_A::ENDPOINT_STALLED_SOFTWARE,
        }
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_OK_THIS_BI`"]
    #[inline(always)]
    pub fn is_endpoint_ok_this_bi(&self) -> bool {
        *self == RXS_A::ENDPOINT_OK_THIS_BI
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_STALLED_SOFTWARE`"]
    #[inline(always)]
    pub fn is_endpoint_stalled_software(&self) -> bool {
        *self == RXS_A::ENDPOINT_STALLED_SOFTWARE
    }
}
#[doc = "Write proxy for field `RXS`"]
pub struct RXS_W<'a> {
    w: &'a mut W,
}
impl<'a> RXS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RXS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Endpoint ok. This bit will be cleared automatically upon receipt of a SETUP request if this Endpoint is configured as a Control Endpoint and this bit will continue to be cleared by hardware until the associated ENDPTSETUPSTAT bit is cleared."]
    #[inline(always)]
    pub fn endpoint_ok_this_bi(self) -> &'a mut W {
        self.variant(RXS_A::ENDPOINT_OK_THIS_BI)
    }
    #[doc = "Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request."]
    #[inline(always)]
    pub fn endpoint_stalled_software(self) -> &'a mut W {
        self.variant(RXS_A::ENDPOINT_STALLED_SOFTWARE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Endpoint type\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RXT_A {
    #[doc = "0: Control"]
    CONTROL,
    #[doc = "1: Isochronous"]
    ISOCHRONOUS,
    #[doc = "2: Bulk"]
    BULK,
}
impl From<RXT_A> for u8 {
    #[inline(always)]
    fn from(variant: RXT_A) -> Self {
        match variant {
            RXT_A::CONTROL => 0,
            RXT_A::ISOCHRONOUS => 1,
            RXT_A::BULK => 2,
        }
    }
}
#[doc = "Reader of field `RXT`"]
pub type RXT_R = crate::R<u8, RXT_A>;
impl RXT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RXT_A {
        match self.bits {
            0 => RXT_A::CONTROL,
            1 => RXT_A::ISOCHRONOUS,
            2 => RXT_A::BULK,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `CONTROL`"]
    #[inline(always)]
    pub fn is_control(&self) -> bool {
        *self == RXT_A::CONTROL
    }
    #[doc = "Checks if the value of the field is `ISOCHRONOUS`"]
    #[inline(always)]
    pub fn is_isochronous(&self) -> bool {
        *self == RXT_A::ISOCHRONOUS
    }
    #[doc = "Checks if the value of the field is `BULK`"]
    #[inline(always)]
    pub fn is_bulk(&self) -> bool {
        *self == RXT_A::BULK
    }
}
#[doc = "Write proxy for field `RXT`"]
pub struct RXT_W<'a> {
    w: &'a mut W,
}
impl<'a> RXT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RXT_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Control"]
    #[inline(always)]
    pub fn control(self) -> &'a mut W {
        self.variant(RXT_A::CONTROL)
    }
    #[doc = "Isochronous"]
    #[inline(always)]
    pub fn isochronous(self) -> &'a mut W {
        self.variant(RXT_A::ISOCHRONOUS)
    }
    #[doc = "Bulk"]
    #[inline(always)]
    pub fn bulk(self) -> &'a mut W {
        self.variant(RXT_A::BULK)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | (((value as u32) & 0x03) << 2);
        self.w
    }
}
#[doc = "Rx data toggle inhibit This bit is only used for test and should always be written as zero. Writing a one to this bit will cause this endpoint to ignore the data toggle sequence and always accept data packets regardless of their data PID.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RXI_A {
    #[doc = "0: Disabled"]
    DISABLED,
    #[doc = "1: Enabled"]
    ENABLED,
}
impl From<RXI_A> for bool {
    #[inline(always)]
    fn from(variant: RXI_A) -> Self {
        match variant {
            RXI_A::DISABLED => false,
            RXI_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `RXI`"]
pub type RXI_R = crate::R<bool, RXI_A>;
impl RXI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RXI_A {
        match self.bits {
            false => RXI_A::DISABLED,
            true => RXI_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == RXI_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == RXI_A::ENABLED
    }
}
#[doc = "Write proxy for field `RXI`"]
pub struct RXI_W<'a> {
    w: &'a mut W,
}
impl<'a> RXI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RXI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(RXI_A::DISABLED)
    }
    #[doc = "Enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(RXI_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Reader of field `RXR`"]
pub type RXR_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `RXR`"]
pub struct RXR_W<'a> {
    w: &'a mut W,
}
impl<'a> RXR_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Rx endpoint enable An endpoint should be enabled only after it has been configured.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RXE_A {
    #[doc = "0: Endpoint disabled."]
    ENDPOINT_DISABLED,
    #[doc = "1: Endpoint enabled."]
    ENDPOINT_ENABLED,
}
impl From<RXE_A> for bool {
    #[inline(always)]
    fn from(variant: RXE_A) -> Self {
        match variant {
            RXE_A::ENDPOINT_DISABLED => false,
            RXE_A::ENDPOINT_ENABLED => true,
        }
    }
}
#[doc = "Reader of field `RXE`"]
pub type RXE_R = crate::R<bool, RXE_A>;
impl RXE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RXE_A {
        match self.bits {
            false => RXE_A::ENDPOINT_DISABLED,
            true => RXE_A::ENDPOINT_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_DISABLED`"]
    #[inline(always)]
    pub fn is_endpoint_disabled(&self) -> bool {
        *self == RXE_A::ENDPOINT_DISABLED
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_ENABLED`"]
    #[inline(always)]
    pub fn is_endpoint_enabled(&self) -> bool {
        *self == RXE_A::ENDPOINT_ENABLED
    }
}
#[doc = "Write proxy for field `RXE`"]
pub struct RXE_W<'a> {
    w: &'a mut W,
}
impl<'a> RXE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RXE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Endpoint disabled."]
    #[inline(always)]
    pub fn endpoint_disabled(self) -> &'a mut W {
        self.variant(RXE_A::ENDPOINT_DISABLED)
    }
    #[doc = "Endpoint enabled."]
    #[inline(always)]
    pub fn endpoint_enabled(self) -> &'a mut W {
        self.variant(RXE_A::ENDPOINT_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Tx endpoint stall\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXS_A {
    #[doc = "0: Endpoint ok. This bit will be cleared automatically upon receipt of a SETUP request if this Endpoint is configured as a Control Endpoint, and this bit will continue to be cleared by hardware until the associated ENDPTSETUPSTAT bit is cleared."]
    ENDPOINT_OK_THIS_BI,
    #[doc = "1: Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request."]
    ENDPOINT_STALLED_SOFTWARE,
}
impl From<TXS_A> for bool {
    #[inline(always)]
    fn from(variant: TXS_A) -> Self {
        match variant {
            TXS_A::ENDPOINT_OK_THIS_BI => false,
            TXS_A::ENDPOINT_STALLED_SOFTWARE => true,
        }
    }
}
#[doc = "Reader of field `TXS`"]
pub type TXS_R = crate::R<bool, TXS_A>;
impl TXS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXS_A {
        match self.bits {
            false => TXS_A::ENDPOINT_OK_THIS_BI,
            true => TXS_A::ENDPOINT_STALLED_SOFTWARE,
        }
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_OK_THIS_BI`"]
    #[inline(always)]
    pub fn is_endpoint_ok_this_bi(&self) -> bool {
        *self == TXS_A::ENDPOINT_OK_THIS_BI
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_STALLED_SOFTWARE`"]
    #[inline(always)]
    pub fn is_endpoint_stalled_software(&self) -> bool {
        *self == TXS_A::ENDPOINT_STALLED_SOFTWARE
    }
}
#[doc = "Write proxy for field `TXS`"]
pub struct TXS_W<'a> {
    w: &'a mut W,
}
impl<'a> TXS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Endpoint ok. This bit will be cleared automatically upon receipt of a SETUP request if this Endpoint is configured as a Control Endpoint, and this bit will continue to be cleared by hardware until the associated ENDPTSETUPSTAT bit is cleared."]
    #[inline(always)]
    pub fn endpoint_ok_this_bi(self) -> &'a mut W {
        self.variant(TXS_A::ENDPOINT_OK_THIS_BI)
    }
    #[doc = "Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request."]
    #[inline(always)]
    pub fn endpoint_stalled_software(self) -> &'a mut W {
        self.variant(TXS_A::ENDPOINT_STALLED_SOFTWARE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Tx endpoint type\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXT_A {
    #[doc = "0: Control"]
    CONTROL,
    #[doc = "1: Isochronous"]
    ISOCHRONOUS,
    #[doc = "2: Bulk"]
    BULK,
    #[doc = "3: Interrupt"]
    INTERRUPT,
}
impl From<TXT_A> for u8 {
    #[inline(always)]
    fn from(variant: TXT_A) -> Self {
        match variant {
            TXT_A::CONTROL => 0,
            TXT_A::ISOCHRONOUS => 1,
            TXT_A::BULK => 2,
            TXT_A::INTERRUPT => 3,
        }
    }
}
#[doc = "Reader of field `TXT`"]
pub type TXT_R = crate::R<u8, TXT_A>;
impl TXT_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXT_A {
        match self.bits {
            0 => TXT_A::CONTROL,
            1 => TXT_A::ISOCHRONOUS,
            2 => TXT_A::BULK,
            3 => TXT_A::INTERRUPT,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `CONTROL`"]
    #[inline(always)]
    pub fn is_control(&self) -> bool {
        *self == TXT_A::CONTROL
    }
    #[doc = "Checks if the value of the field is `ISOCHRONOUS`"]
    #[inline(always)]
    pub fn is_isochronous(&self) -> bool {
        *self == TXT_A::ISOCHRONOUS
    }
    #[doc = "Checks if the value of the field is `BULK`"]
    #[inline(always)]
    pub fn is_bulk(&self) -> bool {
        *self == TXT_A::BULK
    }
    #[doc = "Checks if the value of the field is `INTERRUPT`"]
    #[inline(always)]
    pub fn is_interrupt(&self) -> bool {
        *self == TXT_A::INTERRUPT
    }
}
#[doc = "Write proxy for field `TXT`"]
pub struct TXT_W<'a> {
    w: &'a mut W,
}
impl<'a> TXT_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXT_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Control"]
    #[inline(always)]
    pub fn control(self) -> &'a mut W {
        self.variant(TXT_A::CONTROL)
    }
    #[doc = "Isochronous"]
    #[inline(always)]
    pub fn isochronous(self) -> &'a mut W {
        self.variant(TXT_A::ISOCHRONOUS)
    }
    #[doc = "Bulk"]
    #[inline(always)]
    pub fn bulk(self) -> &'a mut W {
        self.variant(TXT_A::BULK)
    }
    #[doc = "Interrupt"]
    #[inline(always)]
    pub fn interrupt(self) -> &'a mut W {
        self.variant(TXT_A::INTERRUPT)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 18)) | (((value as u32) & 0x03) << 18);
        self.w
    }
}
#[doc = "Tx data toggle inhibit This bit is only used for test and should always be written as zero. Writing a one to this bit will cause this endpoint to ignore the data toggle sequence and always accept data packets regardless of their data PID.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXI_A {
    #[doc = "0: Enabled"]
    ENABLED,
    #[doc = "1: Disabled"]
    DISABLED,
}
impl From<TXI_A> for bool {
    #[inline(always)]
    fn from(variant: TXI_A) -> Self {
        match variant {
            TXI_A::ENABLED => false,
            TXI_A::DISABLED => true,
        }
    }
}
#[doc = "Reader of field `TXI`"]
pub type TXI_R = crate::R<bool, TXI_A>;
impl TXI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXI_A {
        match self.bits {
            false => TXI_A::ENABLED,
            true => TXI_A::DISABLED,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == TXI_A::ENABLED
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == TXI_A::DISABLED
    }
}
#[doc = "Write proxy for field `TXI`"]
pub struct TXI_W<'a> {
    w: &'a mut W,
}
impl<'a> TXI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Enabled"]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(TXI_A::ENABLED)
    }
    #[doc = "Disabled"]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(TXI_A::DISABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | (((value as u32) & 0x01) << 21);
        self.w
    }
}
#[doc = "Reader of field `TXR`"]
pub type TXR_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `TXR`"]
pub struct TXR_W<'a> {
    w: &'a mut W,
}
impl<'a> TXR_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 22)) | (((value as u32) & 0x01) << 22);
        self.w
    }
}
#[doc = "Tx endpoint enable An endpoint should be enabled only after it has been configured\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXE_A {
    #[doc = "0: Endpoint disabled."]
    ENDPOINT_DISABLED,
    #[doc = "1: Endpoint enabled."]
    ENDPOINT_ENABLED,
}
impl From<TXE_A> for bool {
    #[inline(always)]
    fn from(variant: TXE_A) -> Self {
        match variant {
            TXE_A::ENDPOINT_DISABLED => false,
            TXE_A::ENDPOINT_ENABLED => true,
        }
    }
}
#[doc = "Reader of field `TXE`"]
pub type TXE_R = crate::R<bool, TXE_A>;
impl TXE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXE_A {
        match self.bits {
            false => TXE_A::ENDPOINT_DISABLED,
            true => TXE_A::ENDPOINT_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_DISABLED`"]
    #[inline(always)]
    pub fn is_endpoint_disabled(&self) -> bool {
        *self == TXE_A::ENDPOINT_DISABLED
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_ENABLED`"]
    #[inline(always)]
    pub fn is_endpoint_enabled(&self) -> bool {
        *self == TXE_A::ENDPOINT_ENABLED
    }
}
#[doc = "Write proxy for field `TXE`"]
pub struct TXE_W<'a> {
    w: &'a mut W,
}
impl<'a> TXE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Endpoint disabled."]
    #[inline(always)]
    pub fn endpoint_disabled(self) -> &'a mut W {
        self.variant(TXE_A::ENDPOINT_DISABLED)
    }
    #[doc = "Endpoint enabled."]
    #[inline(always)]
    pub fn endpoint_enabled(self) -> &'a mut W {
        self.variant(TXE_A::ENDPOINT_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 23)) | (((value as u32) & 0x01) << 23);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Rx endpoint stall"]
    #[inline(always)]
    pub fn rxs(&self) -> RXS_R {
        RXS_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 2:3 - Endpoint type"]
    #[inline(always)]
    pub fn rxt(&self) -> RXT_R {
        RXT_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bit 5 - Rx data toggle inhibit This bit is only used for test and should always be written as zero. Writing a one to this bit will cause this endpoint to ignore the data toggle sequence and always accept data packets regardless of their data PID."]
    #[inline(always)]
    pub fn rxi(&self) -> RXI_R {
        RXI_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Rx data toggle reset Write 1 to reset the PID sequence. Whenever a configuration event is received for this Endpoint, software must write a one to this bit in order to synchronize the data PIDs between the host and device."]
    #[inline(always)]
    pub fn rxr(&self) -> RXR_R {
        RXR_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Rx endpoint enable An endpoint should be enabled only after it has been configured."]
    #[inline(always)]
    pub fn rxe(&self) -> RXE_R {
        RXE_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Tx endpoint stall"]
    #[inline(always)]
    pub fn txs(&self) -> TXS_R {
        TXS_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bits 18:19 - Tx endpoint type"]
    #[inline(always)]
    pub fn txt(&self) -> TXT_R {
        TXT_R::new(((self.bits >> 18) & 0x03) as u8)
    }
    #[doc = "Bit 21 - Tx data toggle inhibit This bit is only used for test and should always be written as zero. Writing a one to this bit will cause this endpoint to ignore the data toggle sequence and always accept data packets regardless of their data PID."]
    #[inline(always)]
    pub fn txi(&self) -> TXI_R {
        TXI_R::new(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Tx data toggle reset Write 1 to reset the PID sequence. Whenever a configuration event is received for this Endpoint, software must write a one to this bit in order to synchronize the data PIDs between the host and device."]
    #[inline(always)]
    pub fn txr(&self) -> TXR_R {
        TXR_R::new(((self.bits >> 22) & 0x01) != 0)
    }
    #[doc = "Bit 23 - Tx endpoint enable An endpoint should be enabled only after it has been configured"]
    #[inline(always)]
    pub fn txe(&self) -> TXE_R {
        TXE_R::new(((self.bits >> 23) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Rx endpoint stall"]
    #[inline(always)]
    pub fn rxs(&mut self) -> RXS_W {
        RXS_W { w: self }
    }
    #[doc = "Bits 2:3 - Endpoint type"]
    #[inline(always)]
    pub fn rxt(&mut self) -> RXT_W {
        RXT_W { w: self }
    }
    #[doc = "Bit 5 - Rx data toggle inhibit This bit is only used for test and should always be written as zero. Writing a one to this bit will cause this endpoint to ignore the data toggle sequence and always accept data packets regardless of their data PID."]
    #[inline(always)]
    pub fn rxi(&mut self) -> RXI_W {
        RXI_W { w: self }
    }
    #[doc = "Bit 6 - Rx data toggle reset Write 1 to reset the PID sequence. Whenever a configuration event is received for this Endpoint, software must write a one to this bit in order to synchronize the data PIDs between the host and device."]
    #[inline(always)]
    pub fn rxr(&mut self) -> RXR_W {
        RXR_W { w: self }
    }
    #[doc = "Bit 7 - Rx endpoint enable An endpoint should be enabled only after it has been configured."]
    #[inline(always)]
    pub fn rxe(&mut self) -> RXE_W {
        RXE_W { w: self }
    }
    #[doc = "Bit 16 - Tx endpoint stall"]
    #[inline(always)]
    pub fn txs(&mut self) -> TXS_W {
        TXS_W { w: self }
    }
    #[doc = "Bits 18:19 - Tx endpoint type"]
    #[inline(always)]
    pub fn txt(&mut self) -> TXT_W {
        TXT_W { w: self }
    }
    #[doc = "Bit 21 - Tx data toggle inhibit This bit is only used for test and should always be written as zero. Writing a one to this bit will cause this endpoint to ignore the data toggle sequence and always accept data packets regardless of their data PID."]
    #[inline(always)]
    pub fn txi(&mut self) -> TXI_W {
        TXI_W { w: self }
    }
    #[doc = "Bit 22 - Tx data toggle reset Write 1 to reset the PID sequence. Whenever a configuration event is received for this Endpoint, software must write a one to this bit in order to synchronize the data PIDs between the host and device."]
    #[inline(always)]
    pub fn txr(&mut self) -> TXR_W {
        TXR_W { w: self }
    }
    #[doc = "Bit 23 - Tx endpoint enable An endpoint should be enabled only after it has been configured"]
    #[inline(always)]
    pub fn txe(&mut self) -> TXE_W {
        TXE_W { w: self }
    }
}
