#[doc = "Reader of register ENDPTCTRL0"]
pub type R = crate::R<u32, super::ENDPTCTRL0>;
#[doc = "Writer for register ENDPTCTRL0"]
pub type W = crate::W<u32, super::ENDPTCTRL0>;
#[doc = "Register ENDPTCTRL0 `reset()`'s with value 0"]
impl crate::ResetValue for super::ENDPTCTRL0 {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Rx endpoint stall\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RXS_A {
    #[doc = "0: Endpoint ok."]
    ENDPOINT_OK,
    #[doc = "1: Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request. After receiving a SETUP request, this bit will continue to be cleared by hardware until the associated ENDSETUPSTAT bit is cleared."]
    ENDPOINT_STALLED_SOFTWARE,
}
impl From<RXS_A> for bool {
    #[inline(always)]
    fn from(variant: RXS_A) -> Self {
        match variant {
            RXS_A::ENDPOINT_OK => false,
            RXS_A::ENDPOINT_STALLED_SOFTWARE => true,
        }
    }
}
#[doc = "Reader of field `RXS`"]
pub type RXS_R = crate::R<bool, RXS_A>;
impl RXS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RXS_A {
        match self.bits {
            false => RXS_A::ENDPOINT_OK,
            true => RXS_A::ENDPOINT_STALLED_SOFTWARE,
        }
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_OK`"]
    #[inline(always)]
    pub fn is_endpoint_ok(&self) -> bool {
        *self == RXS_A::ENDPOINT_OK
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_STALLED_SOFTWARE`"]
    #[inline(always)]
    pub fn is_endpoint_stalled_software(&self) -> bool {
        *self == RXS_A::ENDPOINT_STALLED_SOFTWARE
    }
}
#[doc = "Write proxy for field `RXS`"]
pub struct RXS_W<'a> {
    w: &'a mut W,
}
impl<'a> RXS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RXS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Endpoint ok."]
    #[inline(always)]
    pub fn endpoint_ok(self) -> &'a mut W {
        self.variant(RXS_A::ENDPOINT_OK)
    }
    #[doc = "Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request. After receiving a SETUP request, this bit will continue to be cleared by hardware until the associated ENDSETUPSTAT bit is cleared."]
    #[inline(always)]
    pub fn endpoint_stalled_software(self) -> &'a mut W {
        self.variant(RXS_A::ENDPOINT_STALLED_SOFTWARE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Reader of field `RXT`"]
pub type RXT_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `RXT`"]
pub struct RXT_W<'a> {
    w: &'a mut W,
}
impl<'a> RXT_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | (((value as u32) & 0x03) << 2);
        self.w
    }
}
#[doc = "Reader of field `RXE`"]
pub type RXE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `RXE`"]
pub struct RXE_W<'a> {
    w: &'a mut W,
}
impl<'a> RXE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Tx endpoint stall\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TXS_A {
    #[doc = "0: Endpoint ok."]
    ENDPOINT_OK,
    #[doc = "1: Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request. After receiving a SETUP request, this bit will continue to be cleared by hardware until the associated ENDSETUPSTAT bit is cleared."]
    ENDPOINT_STALLED_SOFTWARE,
}
impl From<TXS_A> for bool {
    #[inline(always)]
    fn from(variant: TXS_A) -> Self {
        match variant {
            TXS_A::ENDPOINT_OK => false,
            TXS_A::ENDPOINT_STALLED_SOFTWARE => true,
        }
    }
}
#[doc = "Reader of field `TXS`"]
pub type TXS_R = crate::R<bool, TXS_A>;
impl TXS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> TXS_A {
        match self.bits {
            false => TXS_A::ENDPOINT_OK,
            true => TXS_A::ENDPOINT_STALLED_SOFTWARE,
        }
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_OK`"]
    #[inline(always)]
    pub fn is_endpoint_ok(&self) -> bool {
        *self == TXS_A::ENDPOINT_OK
    }
    #[doc = "Checks if the value of the field is `ENDPOINT_STALLED_SOFTWARE`"]
    #[inline(always)]
    pub fn is_endpoint_stalled_software(&self) -> bool {
        *self == TXS_A::ENDPOINT_STALLED_SOFTWARE
    }
}
#[doc = "Write proxy for field `TXS`"]
pub struct TXS_W<'a> {
    w: &'a mut W,
}
impl<'a> TXS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: TXS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Endpoint ok."]
    #[inline(always)]
    pub fn endpoint_ok(self) -> &'a mut W {
        self.variant(TXS_A::ENDPOINT_OK)
    }
    #[doc = "Endpoint stalled Software can write a one to this bit to force the endpoint to return a STALL handshake to the Host. It will continue returning STALL until the bit is cleared by software, or it will automatically be cleared upon receipt of a new SETUP request. After receiving a SETUP request, this bit will continue to be cleared by hardware until the associated ENDSETUPSTAT bit is cleared."]
    #[inline(always)]
    pub fn endpoint_stalled_software(self) -> &'a mut W {
        self.variant(TXS_A::ENDPOINT_STALLED_SOFTWARE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | (((value as u32) & 0x01) << 16);
        self.w
    }
}
#[doc = "Reader of field `TXT`"]
pub type TXT_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `TXT`"]
pub struct TXT_W<'a> {
    w: &'a mut W,
}
impl<'a> TXT_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 18)) | (((value as u32) & 0x03) << 18);
        self.w
    }
}
#[doc = "Reader of field `TXE`"]
pub type TXE_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `TXE`"]
pub struct TXE_W<'a> {
    w: &'a mut W,
}
impl<'a> TXE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 23)) | (((value as u32) & 0x01) << 23);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Rx endpoint stall"]
    #[inline(always)]
    pub fn rxs(&self) -> RXS_R {
        RXS_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bits 2:3 - Endpoint type Endpoint 0 is always a control endpoint."]
    #[inline(always)]
    pub fn rxt(&self) -> RXT_R {
        RXT_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bit 7 - Rx endpoint enable Endpoint enabled. Control endpoint 0 is always enabled. This bit is always 1."]
    #[inline(always)]
    pub fn rxe(&self) -> RXE_R {
        RXE_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Tx endpoint stall"]
    #[inline(always)]
    pub fn txs(&self) -> TXS_R {
        TXS_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bits 18:19 - Endpoint type Endpoint 0 is always a control endpoint."]
    #[inline(always)]
    pub fn txt(&self) -> TXT_R {
        TXT_R::new(((self.bits >> 18) & 0x03) as u8)
    }
    #[doc = "Bit 23 - Tx endpoint enable Endpoint enabled. Control endpoint 0 is always enabled. This bit is always 1."]
    #[inline(always)]
    pub fn txe(&self) -> TXE_R {
        TXE_R::new(((self.bits >> 23) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Rx endpoint stall"]
    #[inline(always)]
    pub fn rxs(&mut self) -> RXS_W {
        RXS_W { w: self }
    }
    #[doc = "Bits 2:3 - Endpoint type Endpoint 0 is always a control endpoint."]
    #[inline(always)]
    pub fn rxt(&mut self) -> RXT_W {
        RXT_W { w: self }
    }
    #[doc = "Bit 7 - Rx endpoint enable Endpoint enabled. Control endpoint 0 is always enabled. This bit is always 1."]
    #[inline(always)]
    pub fn rxe(&mut self) -> RXE_W {
        RXE_W { w: self }
    }
    #[doc = "Bit 16 - Tx endpoint stall"]
    #[inline(always)]
    pub fn txs(&mut self) -> TXS_W {
        TXS_W { w: self }
    }
    #[doc = "Bits 18:19 - Endpoint type Endpoint 0 is always a control endpoint."]
    #[inline(always)]
    pub fn txt(&mut self) -> TXT_W {
        TXT_W { w: self }
    }
    #[doc = "Bit 23 - Tx endpoint enable Endpoint enabled. Control endpoint 0 is always enabled. This bit is always 1."]
    #[inline(always)]
    pub fn txe(&mut self) -> TXE_W {
        TXE_W { w: self }
    }
}
