#[doc = "Reader of register ENDPTSTAT"]
pub type R = crate::R<u32, super::ENDPTSTAT>;
#[doc = "Reader of field `ERBR0`"]
pub type ERBR0_R = crate::R<bool, bool>;
#[doc = "Reader of field `ERBR1`"]
pub type ERBR1_R = crate::R<bool, bool>;
#[doc = "Reader of field `ERBR2`"]
pub type ERBR2_R = crate::R<bool, bool>;
#[doc = "Reader of field `ERBR3`"]
pub type ERBR3_R = crate::R<bool, bool>;
#[doc = "Reader of field `ETBR0`"]
pub type ETBR0_R = crate::R<bool, bool>;
#[doc = "Reader of field `ETBR1`"]
pub type ETBR1_R = crate::R<bool, bool>;
#[doc = "Reader of field `ETBR2`"]
pub type ETBR2_R = crate::R<bool, bool>;
#[doc = "Reader of field `ETBR3`"]
pub type ETBR3_R = crate::R<bool, bool>;
impl R {
    #[doc = "Bit 0 - Endpoint receive buffer ready for physical OUT endpoints. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ERBR0 = endpoint 0 ... ERBR3 = endpoint 3"]
    #[inline(always)]
    pub fn erbr0(&self) -> ERBR0_R {
        ERBR0_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Endpoint receive buffer ready for physical OUT endpoints. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ERBR0 = endpoint 0 ... ERBR3 = endpoint 3"]
    #[inline(always)]
    pub fn erbr1(&self) -> ERBR1_R {
        ERBR1_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Endpoint receive buffer ready for physical OUT endpoints. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ERBR0 = endpoint 0 ... ERBR3 = endpoint 3"]
    #[inline(always)]
    pub fn erbr2(&self) -> ERBR2_R {
        ERBR2_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Endpoint receive buffer ready for physical OUT endpoints. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ERBR0 = endpoint 0 ... ERBR3 = endpoint 3"]
    #[inline(always)]
    pub fn erbr3(&self) -> ERBR3_R {
        ERBR3_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 16 - Endpoint transmit buffer ready for physical IN endpoints 3 to 0. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ETBR0 = endpoint 0 ... ETBR3 = endpoint 3"]
    #[inline(always)]
    pub fn etbr0(&self) -> ETBR0_R {
        ETBR0_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - Endpoint transmit buffer ready for physical IN endpoints 3 to 0. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ETBR0 = endpoint 0 ... ETBR3 = endpoint 3"]
    #[inline(always)]
    pub fn etbr1(&self) -> ETBR1_R {
        ETBR1_R::new(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - Endpoint transmit buffer ready for physical IN endpoints 3 to 0. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ETBR0 = endpoint 0 ... ETBR3 = endpoint 3"]
    #[inline(always)]
    pub fn etbr2(&self) -> ETBR2_R {
        ETBR2_R::new(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - Endpoint transmit buffer ready for physical IN endpoints 3 to 0. This bit is set to 1 by hardware as a response to receiving a command from a corresponding bit in the ENDPTPRIME register. ETBR0 = endpoint 0 ... ETBR3 = endpoint 3"]
    #[inline(always)]
    pub fn etbr3(&self) -> ETBR3_R {
        ETBR3_R::new(((self.bits >> 19) & 0x01) != 0)
    }
}
