#[doc = "Reader of register PORTSC1_H"]
pub type R = crate::R<u32, super::PORTSC1_H>;
#[doc = "Writer for register PORTSC1_H"]
pub type W = crate::W<u32, super::PORTSC1_H>;
#[doc = "Register PORTSC1_H `reset()`'s with value 0"]
impl crate::ResetValue for super::PORTSC1_H {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Current connect status This value reflects the current state of the port and may not correspond directly to the event that caused the CSC bit to be set. This bit is 0 if PP (Port Power bit) is 0. Software clears this bit by writing a 1 to it.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CCS_A {
    #[doc = "0: No device is present."]
    NO_DEVICE_IS_PRESENT,
    #[doc = "1: Device is present on the port."]
    DEVICE_IS_PRESENT_ON_PORT,
}
impl From<CCS_A> for bool {
    #[inline(always)]
    fn from(variant: CCS_A) -> Self {
        match variant {
            CCS_A::NO_DEVICE_IS_PRESENT => false,
            CCS_A::DEVICE_IS_PRESENT_ON_PORT => true,
        }
    }
}
#[doc = "Reader of field `CCS`"]
pub type CCS_R = crate::R<bool, CCS_A>;
impl CCS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CCS_A {
        match self.bits {
            false => CCS_A::NO_DEVICE_IS_PRESENT,
            true => CCS_A::DEVICE_IS_PRESENT_ON_PORT,
        }
    }
    #[doc = "Checks if the value of the field is `NO_DEVICE_IS_PRESENT`"]
    #[inline(always)]
    pub fn is_no_device_is_present(&self) -> bool {
        *self == CCS_A::NO_DEVICE_IS_PRESENT
    }
    #[doc = "Checks if the value of the field is `DEVICE_IS_PRESENT_ON_PORT`"]
    #[inline(always)]
    pub fn is_device_is_present_on_port(&self) -> bool {
        *self == CCS_A::DEVICE_IS_PRESENT_ON_PORT
    }
}
#[doc = "Write proxy for field `CCS`"]
pub struct CCS_W<'a> {
    w: &'a mut W,
}
impl<'a> CCS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CCS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No device is present."]
    #[inline(always)]
    pub fn no_device_is_present(self) -> &'a mut W {
        self.variant(CCS_A::NO_DEVICE_IS_PRESENT)
    }
    #[doc = "Device is present on the port."]
    #[inline(always)]
    pub fn device_is_present_on_port(self) -> &'a mut W {
        self.variant(CCS_A::DEVICE_IS_PRESENT_ON_PORT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Connect status change Indicates a change has occurred in the port's Current Connect Status. The host/device controller sets this bit for all changes to the port device connect status, even if system software has not cleared an existing connect status change. For example, the insertion status changes twice before system software has cleared the changed condition, hub hardware will be setting an already-set bit (i.e., the bit will remain set). Software clears this bit by writing a one to it. This bit is 0 if PP (Port Power bit) is 0\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CSC_A {
    #[doc = "0: No change in current status."]
    NO_CHANGE_IN_CURRENT_STATUS,
    #[doc = "1: Change in current status."]
    CHANGE_IN_CURRENT_STATUS,
}
impl From<CSC_A> for bool {
    #[inline(always)]
    fn from(variant: CSC_A) -> Self {
        match variant {
            CSC_A::NO_CHANGE_IN_CURRENT_STATUS => false,
            CSC_A::CHANGE_IN_CURRENT_STATUS => true,
        }
    }
}
#[doc = "Reader of field `CSC`"]
pub type CSC_R = crate::R<bool, CSC_A>;
impl CSC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CSC_A {
        match self.bits {
            false => CSC_A::NO_CHANGE_IN_CURRENT_STATUS,
            true => CSC_A::CHANGE_IN_CURRENT_STATUS,
        }
    }
    #[doc = "Checks if the value of the field is `NO_CHANGE_IN_CURRENT_STATUS`"]
    #[inline(always)]
    pub fn is_no_change_in_current_status(&self) -> bool {
        *self == CSC_A::NO_CHANGE_IN_CURRENT_STATUS
    }
    #[doc = "Checks if the value of the field is `CHANGE_IN_CURRENT_STATUS`"]
    #[inline(always)]
    pub fn is_change_in_current_status(&self) -> bool {
        *self == CSC_A::CHANGE_IN_CURRENT_STATUS
    }
}
#[doc = "Write proxy for field `CSC`"]
pub struct CSC_W<'a> {
    w: &'a mut W,
}
impl<'a> CSC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CSC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No change in current status."]
    #[inline(always)]
    pub fn no_change_in_current_status(self) -> &'a mut W {
        self.variant(CSC_A::NO_CHANGE_IN_CURRENT_STATUS)
    }
    #[doc = "Change in current status."]
    #[inline(always)]
    pub fn change_in_current_status(self) -> &'a mut W {
        self.variant(CSC_A::CHANGE_IN_CURRENT_STATUS)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Port enable. Ports can only be enabled by the host controller as a part of the reset and enable. Software cannot enable a port by writing a one to this field. Ports can be disabled by either a fault condition (disconnect event or other fault condition) or by the host software. Note that the bit status does not change until the port state actually changes. There may be a delay in disabling or enabling a port due to other host controller and bus events. When the port is disabled. downstream propagation of data is blocked except for reset. This bit is 0 if PP (Port Power bit) is 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PE_A {
    #[doc = "0: Port disabled."]
    PORT_DISABLED,
    #[doc = "1: Port enabled."]
    PORT_ENABLED,
}
impl From<PE_A> for bool {
    #[inline(always)]
    fn from(variant: PE_A) -> Self {
        match variant {
            PE_A::PORT_DISABLED => false,
            PE_A::PORT_ENABLED => true,
        }
    }
}
#[doc = "Reader of field `PE`"]
pub type PE_R = crate::R<bool, PE_A>;
impl PE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PE_A {
        match self.bits {
            false => PE_A::PORT_DISABLED,
            true => PE_A::PORT_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `PORT_DISABLED`"]
    #[inline(always)]
    pub fn is_port_disabled(&self) -> bool {
        *self == PE_A::PORT_DISABLED
    }
    #[doc = "Checks if the value of the field is `PORT_ENABLED`"]
    #[inline(always)]
    pub fn is_port_enabled(&self) -> bool {
        *self == PE_A::PORT_ENABLED
    }
}
#[doc = "Write proxy for field `PE`"]
pub struct PE_W<'a> {
    w: &'a mut W,
}
impl<'a> PE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port disabled."]
    #[inline(always)]
    pub fn port_disabled(self) -> &'a mut W {
        self.variant(PE_A::PORT_DISABLED)
    }
    #[doc = "Port enabled."]
    #[inline(always)]
    pub fn port_enabled(self) -> &'a mut W {
        self.variant(PE_A::PORT_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Port disable/enable change For the root hub, this bit gets set to a one only when a port is disabled due to disconnect on the port or due to the appropriate conditions existing at the EOF2 point (See Chapter 11 of the USB Specification). Software clears this by writing a one to it. This bit is 0 if PP (Port Power bit) is 0,\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PEC_A {
    #[doc = "0: No change."]
    NO_CHANGE,
    #[doc = "1: Port enabled/disabled status has changed."]
    CHANGED,
}
impl From<PEC_A> for bool {
    #[inline(always)]
    fn from(variant: PEC_A) -> Self {
        match variant {
            PEC_A::NO_CHANGE => false,
            PEC_A::CHANGED => true,
        }
    }
}
#[doc = "Reader of field `PEC`"]
pub type PEC_R = crate::R<bool, PEC_A>;
impl PEC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PEC_A {
        match self.bits {
            false => PEC_A::NO_CHANGE,
            true => PEC_A::CHANGED,
        }
    }
    #[doc = "Checks if the value of the field is `NO_CHANGE`"]
    #[inline(always)]
    pub fn is_no_change(&self) -> bool {
        *self == PEC_A::NO_CHANGE
    }
    #[doc = "Checks if the value of the field is `CHANGED`"]
    #[inline(always)]
    pub fn is_changed(&self) -> bool {
        *self == PEC_A::CHANGED
    }
}
#[doc = "Write proxy for field `PEC`"]
pub struct PEC_W<'a> {
    w: &'a mut W,
}
impl<'a> PEC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PEC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No change."]
    #[inline(always)]
    pub fn no_change(self) -> &'a mut W {
        self.variant(PEC_A::NO_CHANGE)
    }
    #[doc = "Port enabled/disabled status has changed."]
    #[inline(always)]
    pub fn changed(self) -> &'a mut W {
        self.variant(PEC_A::CHANGED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Over-current active This bit will automatically transition from 1 to 0 when the over-current condition is removed.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum OCA_A {
    #[doc = "0: The port does not have an over-current condition."]
    THE_PORT_DOES_NOT_HAVE_OVERCURRENT_CONDITION,
    #[doc = "1: The port has currently an over-current condition."]
    THE_PORT_HAS_CURRENT_AN_OVERCURRENT_CONDITION,
}
impl From<OCA_A> for bool {
    #[inline(always)]
    fn from(variant: OCA_A) -> Self {
        match variant {
            OCA_A::THE_PORT_DOES_NOT_HAVE_OVERCURRENT_CONDITION => false,
            OCA_A::THE_PORT_HAS_CURRENT_AN_OVERCURRENT_CONDITION => true,
        }
    }
}
#[doc = "Reader of field `OCA`"]
pub type OCA_R = crate::R<bool, OCA_A>;
impl OCA_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> OCA_A {
        match self.bits {
            false => OCA_A::THE_PORT_DOES_NOT_HAVE_OVERCURRENT_CONDITION,
            true => OCA_A::THE_PORT_HAS_CURRENT_AN_OVERCURRENT_CONDITION,
        }
    }
    #[doc = "Checks if the value of the field is `THE_PORT_DOES_NOT_HAVE_OVERCURRENT_CONDITION`"]
    #[inline(always)]
    pub fn is_the_port_does_not_have_overcurrent_condition(&self) -> bool {
        *self == OCA_A::THE_PORT_DOES_NOT_HAVE_OVERCURRENT_CONDITION
    }
    #[doc = "Checks if the value of the field is `THE_PORT_HAS_CURRENT_AN_OVERCURRENT_CONDITION`"]
    #[inline(always)]
    pub fn is_the_port_has_current_an_overcurrent_condition(&self) -> bool {
        *self == OCA_A::THE_PORT_HAS_CURRENT_AN_OVERCURRENT_CONDITION
    }
}
#[doc = "Write proxy for field `OCA`"]
pub struct OCA_W<'a> {
    w: &'a mut W,
}
impl<'a> OCA_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: OCA_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The port does not have an over-current condition."]
    #[inline(always)]
    pub fn the_port_does_not_have_overcurrent_condition(self) -> &'a mut W {
        self.variant(OCA_A::THE_PORT_DOES_NOT_HAVE_OVERCURRENT_CONDITION)
    }
    #[doc = "The port has currently an over-current condition."]
    #[inline(always)]
    pub fn the_port_has_current_an_overcurrent_condition(self) -> &'a mut W {
        self.variant(OCA_A::THE_PORT_HAS_CURRENT_AN_OVERCURRENT_CONDITION)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "Reader of field `OCC`"]
pub type OCC_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `OCC`"]
pub struct OCC_W<'a> {
    w: &'a mut W,
}
impl<'a> OCC_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "Force port resume Software sets this bit to one to drive resume signaling. The Host Controller sets this bit to one if a J-to-K transition is detected while the port is in the Suspend state. When this bit transitions to a one because a J-to-K transition is detected, the Port Change Detect bit in the USBSTS register is also set to one. This bit will automatically change to zero after the resume sequence is complete. This behavior is different from EHCI where the host controller driver is required to set this bit to a zero after the resume duration is timed in the driver. Note that when the Host controller owns the port, the resume sequence follows the defined sequence documented in the USB Specification Revision 2.0. The resume signaling (Full-speed K) is driven on the port as long as this bit remains a one. This bit will remain a one until the port has switched to the high-speed idle. Writing a zero has no affect because the port controller will time the resume operation clear the bit the port control state switches to HS or FS idle. This bit is 0 if PP (Port Power bit) is 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FPR_A {
    #[doc = "0: No resume (K-state) detected/driven on port."]
    NO_RESUME,
    #[doc = "1: Resume detected/driven on port."]
    RESUME_DETECTED,
}
impl From<FPR_A> for bool {
    #[inline(always)]
    fn from(variant: FPR_A) -> Self {
        match variant {
            FPR_A::NO_RESUME => false,
            FPR_A::RESUME_DETECTED => true,
        }
    }
}
#[doc = "Reader of field `FPR`"]
pub type FPR_R = crate::R<bool, FPR_A>;
impl FPR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FPR_A {
        match self.bits {
            false => FPR_A::NO_RESUME,
            true => FPR_A::RESUME_DETECTED,
        }
    }
    #[doc = "Checks if the value of the field is `NO_RESUME`"]
    #[inline(always)]
    pub fn is_no_resume(&self) -> bool {
        *self == FPR_A::NO_RESUME
    }
    #[doc = "Checks if the value of the field is `RESUME_DETECTED`"]
    #[inline(always)]
    pub fn is_resume_detected(&self) -> bool {
        *self == FPR_A::RESUME_DETECTED
    }
}
#[doc = "Write proxy for field `FPR`"]
pub struct FPR_W<'a> {
    w: &'a mut W,
}
impl<'a> FPR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FPR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No resume (K-state) detected/driven on port."]
    #[inline(always)]
    pub fn no_resume(self) -> &'a mut W {
        self.variant(FPR_A::NO_RESUME)
    }
    #[doc = "Resume detected/driven on port."]
    #[inline(always)]
    pub fn resume_detected(self) -> &'a mut W {
        self.variant(FPR_A::RESUME_DETECTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Suspend Together with the PE (Port enabled bit), this bit describes the port states, see Table 302 Port states as described by the PE and SUSP bits in the PORTSC1 register. The host controller will unconditionally set this bit to zero when software sets the Force Port Resume bit to zero. The host controller ignores a write of zero to this bit. If host software sets this bit to a one when the port is not enabled (i.e. Port enabled bit is a zero) the results are undefined. This bit is 0 if PP (Port Power bit) is 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SUSP_A {
    #[doc = "0: Port not in suspend state"]
    PORT_NOT_IN_SUSPEND,
    #[doc = "1: Port in suspend state When in suspend state, downstream propagation of data is blocked on this port, except for port reset. The blocking occurs at the end of the current transaction if a transaction was in progress when this bit was written to 1. In the suspend state, the port is sensitive to resume detection. Note that the bit status does not change until the port is suspended and that there may be a delay in suspending a port if there is a transaction currently in progress on the USB."]
    PORT_IN_SUSPEND_STATE,
}
impl From<SUSP_A> for bool {
    #[inline(always)]
    fn from(variant: SUSP_A) -> Self {
        match variant {
            SUSP_A::PORT_NOT_IN_SUSPEND => false,
            SUSP_A::PORT_IN_SUSPEND_STATE => true,
        }
    }
}
#[doc = "Reader of field `SUSP`"]
pub type SUSP_R = crate::R<bool, SUSP_A>;
impl SUSP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SUSP_A {
        match self.bits {
            false => SUSP_A::PORT_NOT_IN_SUSPEND,
            true => SUSP_A::PORT_IN_SUSPEND_STATE,
        }
    }
    #[doc = "Checks if the value of the field is `PORT_NOT_IN_SUSPEND`"]
    #[inline(always)]
    pub fn is_port_not_in_suspend(&self) -> bool {
        *self == SUSP_A::PORT_NOT_IN_SUSPEND
    }
    #[doc = "Checks if the value of the field is `PORT_IN_SUSPEND_STATE`"]
    #[inline(always)]
    pub fn is_port_in_suspend_state(&self) -> bool {
        *self == SUSP_A::PORT_IN_SUSPEND_STATE
    }
}
#[doc = "Write proxy for field `SUSP`"]
pub struct SUSP_W<'a> {
    w: &'a mut W,
}
impl<'a> SUSP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SUSP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port not in suspend state"]
    #[inline(always)]
    pub fn port_not_in_suspend(self) -> &'a mut W {
        self.variant(SUSP_A::PORT_NOT_IN_SUSPEND)
    }
    #[doc = "Port in suspend state When in suspend state, downstream propagation of data is blocked on this port, except for port reset. The blocking occurs at the end of the current transaction if a transaction was in progress when this bit was written to 1. In the suspend state, the port is sensitive to resume detection. Note that the bit status does not change until the port is suspended and that there may be a delay in suspending a port if there is a transaction currently in progress on the USB."]
    #[inline(always)]
    pub fn port_in_suspend_state(self) -> &'a mut W {
        self.variant(SUSP_A::PORT_IN_SUSPEND_STATE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Port reset When software writes a one to this bit the bus-reset sequence as defined in the USB Specification Revision 2.0 is started. This bit will automatically change to zero after the reset sequence is complete. This behavior is different from EHCI where the host controller driver is required to set this bit to a zero after the reset duration is timed in the driver. This bit is 0 if PP (Port Power bit) is 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PR_A {
    #[doc = "0: Port is not in the reset state."]
    NOT_IN_RESET,
    #[doc = "1: Port is in the reset state."]
    PORT_IS_IN_THE_RESET_STATE,
}
impl From<PR_A> for bool {
    #[inline(always)]
    fn from(variant: PR_A) -> Self {
        match variant {
            PR_A::NOT_IN_RESET => false,
            PR_A::PORT_IS_IN_THE_RESET_STATE => true,
        }
    }
}
#[doc = "Reader of field `PR`"]
pub type PR_R = crate::R<bool, PR_A>;
impl PR_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PR_A {
        match self.bits {
            false => PR_A::NOT_IN_RESET,
            true => PR_A::PORT_IS_IN_THE_RESET_STATE,
        }
    }
    #[doc = "Checks if the value of the field is `NOT_IN_RESET`"]
    #[inline(always)]
    pub fn is_not_in_reset(&self) -> bool {
        *self == PR_A::NOT_IN_RESET
    }
    #[doc = "Checks if the value of the field is `PORT_IS_IN_THE_RESET_STATE`"]
    #[inline(always)]
    pub fn is_port_is_in_the_reset_state(&self) -> bool {
        *self == PR_A::PORT_IS_IN_THE_RESET_STATE
    }
}
#[doc = "Write proxy for field `PR`"]
pub struct PR_W<'a> {
    w: &'a mut W,
}
impl<'a> PR_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PR_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port is not in the reset state."]
    #[inline(always)]
    pub fn not_in_reset(self) -> &'a mut W {
        self.variant(PR_A::NOT_IN_RESET)
    }
    #[doc = "Port is in the reset state."]
    #[inline(always)]
    pub fn port_is_in_the_reset_state(self) -> &'a mut W {
        self.variant(PR_A::PORT_IS_IN_THE_RESET_STATE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "High-speed status\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HSP_A {
    #[doc = "0: Host/device connected to the port is not in High-speed mode."]
    NOHIGHSPEED,
    #[doc = "1: Host/device connected to the port is in High-speed mode."]
    HIGHSPEED,
}
impl From<HSP_A> for bool {
    #[inline(always)]
    fn from(variant: HSP_A) -> Self {
        match variant {
            HSP_A::NOHIGHSPEED => false,
            HSP_A::HIGHSPEED => true,
        }
    }
}
#[doc = "Reader of field `HSP`"]
pub type HSP_R = crate::R<bool, HSP_A>;
impl HSP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> HSP_A {
        match self.bits {
            false => HSP_A::NOHIGHSPEED,
            true => HSP_A::HIGHSPEED,
        }
    }
    #[doc = "Checks if the value of the field is `NOHIGHSPEED`"]
    #[inline(always)]
    pub fn is_nohighspeed(&self) -> bool {
        *self == HSP_A::NOHIGHSPEED
    }
    #[doc = "Checks if the value of the field is `HIGHSPEED`"]
    #[inline(always)]
    pub fn is_highspeed(&self) -> bool {
        *self == HSP_A::HIGHSPEED
    }
}
#[doc = "Write proxy for field `HSP`"]
pub struct HSP_W<'a> {
    w: &'a mut W,
}
impl<'a> HSP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: HSP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Host/device connected to the port is not in High-speed mode."]
    #[inline(always)]
    pub fn nohighspeed(self) -> &'a mut W {
        self.variant(HSP_A::NOHIGHSPEED)
    }
    #[doc = "Host/device connected to the port is in High-speed mode."]
    #[inline(always)]
    pub fn highspeed(self) -> &'a mut W {
        self.variant(HSP_A::HIGHSPEED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | (((value as u32) & 0x01) << 9);
        self.w
    }
}
#[doc = "Line status These bits reflect the current logical levels of the USB_DP and USB_DM signal lines. USB_DP corresponds to bit 11 and USB_DM to bit 10. In host mode, the use of linestate by the host controller driver is not necessary for this controller (unlike EHCI) because the controller hardware manages the connection of LS and FS.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LS_A {
    #[doc = "0: SE0 (USB_DP and USB_DM LOW)"]
    SE0,
    #[doc = "1: J-state (USB_DP HIGH and USB_DM LOW)"]
    J_STATE,
    #[doc = "2: K-state (USB_DP LOW and USB_DM HIGH)"]
    K_STATE,
    #[doc = "3: Undefined"]
    UNDEFINED,
}
impl From<LS_A> for u8 {
    #[inline(always)]
    fn from(variant: LS_A) -> Self {
        match variant {
            LS_A::SE0 => 0,
            LS_A::J_STATE => 1,
            LS_A::K_STATE => 2,
            LS_A::UNDEFINED => 3,
        }
    }
}
#[doc = "Reader of field `LS`"]
pub type LS_R = crate::R<u8, LS_A>;
impl LS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> LS_A {
        match self.bits {
            0 => LS_A::SE0,
            1 => LS_A::J_STATE,
            2 => LS_A::K_STATE,
            3 => LS_A::UNDEFINED,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `SE0`"]
    #[inline(always)]
    pub fn is_se0(&self) -> bool {
        *self == LS_A::SE0
    }
    #[doc = "Checks if the value of the field is `J_STATE`"]
    #[inline(always)]
    pub fn is_j_state(&self) -> bool {
        *self == LS_A::J_STATE
    }
    #[doc = "Checks if the value of the field is `K_STATE`"]
    #[inline(always)]
    pub fn is_k_state(&self) -> bool {
        *self == LS_A::K_STATE
    }
    #[doc = "Checks if the value of the field is `UNDEFINED`"]
    #[inline(always)]
    pub fn is_undefined(&self) -> bool {
        *self == LS_A::UNDEFINED
    }
}
#[doc = "Write proxy for field `LS`"]
pub struct LS_W<'a> {
    w: &'a mut W,
}
impl<'a> LS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: LS_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "SE0 (USB_DP and USB_DM LOW)"]
    #[inline(always)]
    pub fn se0(self) -> &'a mut W {
        self.variant(LS_A::SE0)
    }
    #[doc = "J-state (USB_DP HIGH and USB_DM LOW)"]
    #[inline(always)]
    pub fn j_state(self) -> &'a mut W {
        self.variant(LS_A::J_STATE)
    }
    #[doc = "K-state (USB_DP LOW and USB_DM HIGH)"]
    #[inline(always)]
    pub fn k_state(self) -> &'a mut W {
        self.variant(LS_A::K_STATE)
    }
    #[doc = "Undefined"]
    #[inline(always)]
    pub fn undefined(self) -> &'a mut W {
        self.variant(LS_A::UNDEFINED)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 10)) | (((value as u32) & 0x03) << 10);
        self.w
    }
}
#[doc = "Port power control Host controller requires port power control switches. This bit represents the current setting of the switch (0=off, 1=on). When power is not available on a port (i.e. PP equals a 0), the port is non-functional and will not report attaches, detaches, etc. When an over-current condition is detected on a powered port and PPC is a one, the PP bit in each affected port may be transitioned by the host controller driver from a one to a zero (removing power from the port).\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PP_A {
    #[doc = "0: Port power off."]
    PORT_POWER_OFF,
    #[doc = "1: Port power on."]
    PORT_POWER_ON,
}
impl From<PP_A> for bool {
    #[inline(always)]
    fn from(variant: PP_A) -> Self {
        match variant {
            PP_A::PORT_POWER_OFF => false,
            PP_A::PORT_POWER_ON => true,
        }
    }
}
#[doc = "Reader of field `PP`"]
pub type PP_R = crate::R<bool, PP_A>;
impl PP_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PP_A {
        match self.bits {
            false => PP_A::PORT_POWER_OFF,
            true => PP_A::PORT_POWER_ON,
        }
    }
    #[doc = "Checks if the value of the field is `PORT_POWER_OFF`"]
    #[inline(always)]
    pub fn is_port_power_off(&self) -> bool {
        *self == PP_A::PORT_POWER_OFF
    }
    #[doc = "Checks if the value of the field is `PORT_POWER_ON`"]
    #[inline(always)]
    pub fn is_port_power_on(&self) -> bool {
        *self == PP_A::PORT_POWER_ON
    }
}
#[doc = "Write proxy for field `PP`"]
pub struct PP_W<'a> {
    w: &'a mut W,
}
impl<'a> PP_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PP_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port power off."]
    #[inline(always)]
    pub fn port_power_off(self) -> &'a mut W {
        self.variant(PP_A::PORT_POWER_OFF)
    }
    #[doc = "Port power on."]
    #[inline(always)]
    pub fn port_power_on(self) -> &'a mut W {
        self.variant(PP_A::PORT_POWER_ON)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Port indicator control Writing to this field controls the value of the pins USB1_IND1 and USB1_IND0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PIC1_0_A {
    #[doc = "0: Port indicators are off."]
    OFF,
    #[doc = "1: Amber"]
    AMBER,
    #[doc = "2: Green"]
    GREEN,
    #[doc = "3: Undefined"]
    UNDEFINED,
}
impl From<PIC1_0_A> for u8 {
    #[inline(always)]
    fn from(variant: PIC1_0_A) -> Self {
        match variant {
            PIC1_0_A::OFF => 0,
            PIC1_0_A::AMBER => 1,
            PIC1_0_A::GREEN => 2,
            PIC1_0_A::UNDEFINED => 3,
        }
    }
}
#[doc = "Reader of field `PIC1_0`"]
pub type PIC1_0_R = crate::R<u8, PIC1_0_A>;
impl PIC1_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PIC1_0_A {
        match self.bits {
            0 => PIC1_0_A::OFF,
            1 => PIC1_0_A::AMBER,
            2 => PIC1_0_A::GREEN,
            3 => PIC1_0_A::UNDEFINED,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `OFF`"]
    #[inline(always)]
    pub fn is_off(&self) -> bool {
        *self == PIC1_0_A::OFF
    }
    #[doc = "Checks if the value of the field is `AMBER`"]
    #[inline(always)]
    pub fn is_amber(&self) -> bool {
        *self == PIC1_0_A::AMBER
    }
    #[doc = "Checks if the value of the field is `GREEN`"]
    #[inline(always)]
    pub fn is_green(&self) -> bool {
        *self == PIC1_0_A::GREEN
    }
    #[doc = "Checks if the value of the field is `UNDEFINED`"]
    #[inline(always)]
    pub fn is_undefined(&self) -> bool {
        *self == PIC1_0_A::UNDEFINED
    }
}
#[doc = "Write proxy for field `PIC1_0`"]
pub struct PIC1_0_W<'a> {
    w: &'a mut W,
}
impl<'a> PIC1_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PIC1_0_A) -> &'a mut W {
        {
            self.bits(variant.into())
        }
    }
    #[doc = "Port indicators are off."]
    #[inline(always)]
    pub fn off(self) -> &'a mut W {
        self.variant(PIC1_0_A::OFF)
    }
    #[doc = "Amber"]
    #[inline(always)]
    pub fn amber(self) -> &'a mut W {
        self.variant(PIC1_0_A::AMBER)
    }
    #[doc = "Green"]
    #[inline(always)]
    pub fn green(self) -> &'a mut W {
        self.variant(PIC1_0_A::GREEN)
    }
    #[doc = "Undefined"]
    #[inline(always)]
    pub fn undefined(self) -> &'a mut W {
        self.variant(PIC1_0_A::UNDEFINED)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 14)) | (((value as u32) & 0x03) << 14);
        self.w
    }
}
#[doc = "Port test control Any value other than 0000 indicates that the port is operating in test mode. The FORCE_ENABLE_FS and FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI specification. Writing the PTC field to any of the FORCE_ENABLE_{HS/FS/LS} values will force the port into the connected and enabled state at the selected speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state machines to progress normally from that point. Values 0x8 to 0xF are reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PTC3_0_A {
    #[doc = "0: TEST_MODE_DISABLE"]
    TEST_MODE_DISABLE,
    #[doc = "1: J_STATE"]
    J_STATE,
    #[doc = "2: K_STATE"]
    K_STATE,
    #[doc = "3: SE0 (host)/NAK (device)"]
    SE0_NAK,
    #[doc = "4: Packet"]
    PACKET,
    #[doc = "5: FORCE_ENABLE_HS"]
    FORCE_ENABLE_HS,
    #[doc = "6: FORCE_ENABLE_FS"]
    FORCE_ENABLE_FS,
    #[doc = "7: FORCE_ENABLE_LS"]
    FORCE_ENABLE_LS,
}
impl From<PTC3_0_A> for u8 {
    #[inline(always)]
    fn from(variant: PTC3_0_A) -> Self {
        match variant {
            PTC3_0_A::TEST_MODE_DISABLE => 0,
            PTC3_0_A::J_STATE => 1,
            PTC3_0_A::K_STATE => 2,
            PTC3_0_A::SE0_NAK => 3,
            PTC3_0_A::PACKET => 4,
            PTC3_0_A::FORCE_ENABLE_HS => 5,
            PTC3_0_A::FORCE_ENABLE_FS => 6,
            PTC3_0_A::FORCE_ENABLE_LS => 7,
        }
    }
}
#[doc = "Reader of field `PTC3_0`"]
pub type PTC3_0_R = crate::R<u8, PTC3_0_A>;
impl PTC3_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, PTC3_0_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(PTC3_0_A::TEST_MODE_DISABLE),
            1 => Val(PTC3_0_A::J_STATE),
            2 => Val(PTC3_0_A::K_STATE),
            3 => Val(PTC3_0_A::SE0_NAK),
            4 => Val(PTC3_0_A::PACKET),
            5 => Val(PTC3_0_A::FORCE_ENABLE_HS),
            6 => Val(PTC3_0_A::FORCE_ENABLE_FS),
            7 => Val(PTC3_0_A::FORCE_ENABLE_LS),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `TEST_MODE_DISABLE`"]
    #[inline(always)]
    pub fn is_test_mode_disable(&self) -> bool {
        *self == PTC3_0_A::TEST_MODE_DISABLE
    }
    #[doc = "Checks if the value of the field is `J_STATE`"]
    #[inline(always)]
    pub fn is_j_state(&self) -> bool {
        *self == PTC3_0_A::J_STATE
    }
    #[doc = "Checks if the value of the field is `K_STATE`"]
    #[inline(always)]
    pub fn is_k_state(&self) -> bool {
        *self == PTC3_0_A::K_STATE
    }
    #[doc = "Checks if the value of the field is `SE0_NAK`"]
    #[inline(always)]
    pub fn is_se0_nak(&self) -> bool {
        *self == PTC3_0_A::SE0_NAK
    }
    #[doc = "Checks if the value of the field is `PACKET`"]
    #[inline(always)]
    pub fn is_packet(&self) -> bool {
        *self == PTC3_0_A::PACKET
    }
    #[doc = "Checks if the value of the field is `FORCE_ENABLE_HS`"]
    #[inline(always)]
    pub fn is_force_enable_hs(&self) -> bool {
        *self == PTC3_0_A::FORCE_ENABLE_HS
    }
    #[doc = "Checks if the value of the field is `FORCE_ENABLE_FS`"]
    #[inline(always)]
    pub fn is_force_enable_fs(&self) -> bool {
        *self == PTC3_0_A::FORCE_ENABLE_FS
    }
    #[doc = "Checks if the value of the field is `FORCE_ENABLE_LS`"]
    #[inline(always)]
    pub fn is_force_enable_ls(&self) -> bool {
        *self == PTC3_0_A::FORCE_ENABLE_LS
    }
}
#[doc = "Write proxy for field `PTC3_0`"]
pub struct PTC3_0_W<'a> {
    w: &'a mut W,
}
impl<'a> PTC3_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PTC3_0_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "TEST_MODE_DISABLE"]
    #[inline(always)]
    pub fn test_mode_disable(self) -> &'a mut W {
        self.variant(PTC3_0_A::TEST_MODE_DISABLE)
    }
    #[doc = "J_STATE"]
    #[inline(always)]
    pub fn j_state(self) -> &'a mut W {
        self.variant(PTC3_0_A::J_STATE)
    }
    #[doc = "K_STATE"]
    #[inline(always)]
    pub fn k_state(self) -> &'a mut W {
        self.variant(PTC3_0_A::K_STATE)
    }
    #[doc = "SE0 (host)/NAK (device)"]
    #[inline(always)]
    pub fn se0_nak(self) -> &'a mut W {
        self.variant(PTC3_0_A::SE0_NAK)
    }
    #[doc = "Packet"]
    #[inline(always)]
    pub fn packet(self) -> &'a mut W {
        self.variant(PTC3_0_A::PACKET)
    }
    #[doc = "FORCE_ENABLE_HS"]
    #[inline(always)]
    pub fn force_enable_hs(self) -> &'a mut W {
        self.variant(PTC3_0_A::FORCE_ENABLE_HS)
    }
    #[doc = "FORCE_ENABLE_FS"]
    #[inline(always)]
    pub fn force_enable_fs(self) -> &'a mut W {
        self.variant(PTC3_0_A::FORCE_ENABLE_FS)
    }
    #[doc = "FORCE_ENABLE_LS"]
    #[inline(always)]
    pub fn force_enable_ls(self) -> &'a mut W {
        self.variant(PTC3_0_A::FORCE_ENABLE_LS)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 16)) | (((value as u32) & 0x0f) << 16);
        self.w
    }
}
#[doc = "Wake on connect enable (WKCNNT_E) This bit is 0 if PP (Port Power bit) is 0\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WKCN_A {
    #[doc = "0: Disables the port to wake up on device connects."]
    DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_CONNECTS,
    #[doc = "1: Writing this bit to a one enables the port to be sensitive to device connects as wake-up events."]
    ENABLE_DEVICE_CON,
}
impl From<WKCN_A> for bool {
    #[inline(always)]
    fn from(variant: WKCN_A) -> Self {
        match variant {
            WKCN_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_CONNECTS => false,
            WKCN_A::ENABLE_DEVICE_CON => true,
        }
    }
}
#[doc = "Reader of field `WKCN`"]
pub type WKCN_R = crate::R<bool, WKCN_A>;
impl WKCN_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WKCN_A {
        match self.bits {
            false => WKCN_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_CONNECTS,
            true => WKCN_A::ENABLE_DEVICE_CON,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_CONNECTS`"]
    #[inline(always)]
    pub fn is_disables_the_port_to_wake_up_on_device_connects(&self) -> bool {
        *self == WKCN_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_CONNECTS
    }
    #[doc = "Checks if the value of the field is `ENABLE_DEVICE_CON`"]
    #[inline(always)]
    pub fn is_enable_device_con(&self) -> bool {
        *self == WKCN_A::ENABLE_DEVICE_CON
    }
}
#[doc = "Write proxy for field `WKCN`"]
pub struct WKCN_W<'a> {
    w: &'a mut W,
}
impl<'a> WKCN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WKCN_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disables the port to wake up on device connects."]
    #[inline(always)]
    pub fn disables_the_port_to_wake_up_on_device_connects(self) -> &'a mut W {
        self.variant(WKCN_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_CONNECTS)
    }
    #[doc = "Writing this bit to a one enables the port to be sensitive to device connects as wake-up events."]
    #[inline(always)]
    pub fn enable_device_con(self) -> &'a mut W {
        self.variant(WKCN_A::ENABLE_DEVICE_CON)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 20)) | (((value as u32) & 0x01) << 20);
        self.w
    }
}
#[doc = "Wake on disconnect enable (WKDSCNNT_E) This bit is 0 if PP (Port Power bit) is 0.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WKDC_A {
    #[doc = "0: Disables the port to wake up on device disconnects."]
    DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_DISCONNECTS,
    #[doc = "1: Writing this bit to a one enables the port to be sensitive to device disconnects as wake-up events."]
    ENABLE_DEVICE_CON,
}
impl From<WKDC_A> for bool {
    #[inline(always)]
    fn from(variant: WKDC_A) -> Self {
        match variant {
            WKDC_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_DISCONNECTS => false,
            WKDC_A::ENABLE_DEVICE_CON => true,
        }
    }
}
#[doc = "Reader of field `WKDC`"]
pub type WKDC_R = crate::R<bool, WKDC_A>;
impl WKDC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WKDC_A {
        match self.bits {
            false => WKDC_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_DISCONNECTS,
            true => WKDC_A::ENABLE_DEVICE_CON,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_DISCONNECTS`"]
    #[inline(always)]
    pub fn is_disables_the_port_to_wake_up_on_device_disconnects(&self) -> bool {
        *self == WKDC_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_DISCONNECTS
    }
    #[doc = "Checks if the value of the field is `ENABLE_DEVICE_CON`"]
    #[inline(always)]
    pub fn is_enable_device_con(&self) -> bool {
        *self == WKDC_A::ENABLE_DEVICE_CON
    }
}
#[doc = "Write proxy for field `WKDC`"]
pub struct WKDC_W<'a> {
    w: &'a mut W,
}
impl<'a> WKDC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WKDC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disables the port to wake up on device disconnects."]
    #[inline(always)]
    pub fn disables_the_port_to_wake_up_on_device_disconnects(self) -> &'a mut W {
        self.variant(WKDC_A::DISABLES_THE_PORT_TO_WAKE_UP_ON_DEVICE_DISCONNECTS)
    }
    #[doc = "Writing this bit to a one enables the port to be sensitive to device disconnects as wake-up events."]
    #[inline(always)]
    pub fn enable_device_con(self) -> &'a mut W {
        self.variant(WKDC_A::ENABLE_DEVICE_CON)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | (((value as u32) & 0x01) << 21);
        self.w
    }
}
#[doc = "Wake on over-current enable (WKOC_E)\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum WKOC_A {
    #[doc = "0: Disables the port to wake up on over-current events."]
    DISABLES_OVERCURRENT_WAKEUP,
    #[doc = "1: Writing a one to this bit enabled the port to be sensitive to over-current conditions as wake-up events."]
    ENABLE_OVERCURRENT,
}
impl From<WKOC_A> for bool {
    #[inline(always)]
    fn from(variant: WKOC_A) -> Self {
        match variant {
            WKOC_A::DISABLES_OVERCURRENT_WAKEUP => false,
            WKOC_A::ENABLE_OVERCURRENT => true,
        }
    }
}
#[doc = "Reader of field `WKOC`"]
pub type WKOC_R = crate::R<bool, WKOC_A>;
impl WKOC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> WKOC_A {
        match self.bits {
            false => WKOC_A::DISABLES_OVERCURRENT_WAKEUP,
            true => WKOC_A::ENABLE_OVERCURRENT,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLES_OVERCURRENT_WAKEUP`"]
    #[inline(always)]
    pub fn is_disables_overcurrent_wakeup(&self) -> bool {
        *self == WKOC_A::DISABLES_OVERCURRENT_WAKEUP
    }
    #[doc = "Checks if the value of the field is `ENABLE_OVERCURRENT`"]
    #[inline(always)]
    pub fn is_enable_overcurrent(&self) -> bool {
        *self == WKOC_A::ENABLE_OVERCURRENT
    }
}
#[doc = "Write proxy for field `WKOC`"]
pub struct WKOC_W<'a> {
    w: &'a mut W,
}
impl<'a> WKOC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: WKOC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Disables the port to wake up on over-current events."]
    #[inline(always)]
    pub fn disables_overcurrent_wakeup(self) -> &'a mut W {
        self.variant(WKOC_A::DISABLES_OVERCURRENT_WAKEUP)
    }
    #[doc = "Writing a one to this bit enabled the port to be sensitive to over-current conditions as wake-up events."]
    #[inline(always)]
    pub fn enable_overcurrent(self) -> &'a mut W {
        self.variant(WKOC_A::ENABLE_OVERCURRENT)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 22)) | (((value as u32) & 0x01) << 22);
        self.w
    }
}
#[doc = "PHY low power suspend - clock disable (PLPSCD) In host mode, the PHY can be put into Low Power Suspend - Clock Disable when the downstream device has been put into suspend mode or when no downstream device is connected. Low power suspend is completely under the control of software.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PHCD_A {
    #[doc = "0: Writing a 0 enables the PHY clock. Reading a 0 indicates the status of the PHY clock (enabled)."]
    ENABLE_PHY_CLK,
    #[doc = "1: Writing a 1 disables the PHY clock. Reading a 1 indicates the status of the PHY clock (disabled)."]
    DISABLE_PHY_CLK,
}
impl From<PHCD_A> for bool {
    #[inline(always)]
    fn from(variant: PHCD_A) -> Self {
        match variant {
            PHCD_A::ENABLE_PHY_CLK => false,
            PHCD_A::DISABLE_PHY_CLK => true,
        }
    }
}
#[doc = "Reader of field `PHCD`"]
pub type PHCD_R = crate::R<bool, PHCD_A>;
impl PHCD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PHCD_A {
        match self.bits {
            false => PHCD_A::ENABLE_PHY_CLK,
            true => PHCD_A::DISABLE_PHY_CLK,
        }
    }
    #[doc = "Checks if the value of the field is `ENABLE_PHY_CLK`"]
    #[inline(always)]
    pub fn is_enable_phy_clk(&self) -> bool {
        *self == PHCD_A::ENABLE_PHY_CLK
    }
    #[doc = "Checks if the value of the field is `DISABLE_PHY_CLK`"]
    #[inline(always)]
    pub fn is_disable_phy_clk(&self) -> bool {
        *self == PHCD_A::DISABLE_PHY_CLK
    }
}
#[doc = "Write proxy for field `PHCD`"]
pub struct PHCD_W<'a> {
    w: &'a mut W,
}
impl<'a> PHCD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PHCD_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Writing a 0 enables the PHY clock. Reading a 0 indicates the status of the PHY clock (enabled)."]
    #[inline(always)]
    pub fn enable_phy_clk(self) -> &'a mut W {
        self.variant(PHCD_A::ENABLE_PHY_CLK)
    }
    #[doc = "Writing a 1 disables the PHY clock. Reading a 1 indicates the status of the PHY clock (disabled)."]
    #[inline(always)]
    pub fn disable_phy_clk(self) -> &'a mut W {
        self.variant(PHCD_A::DISABLE_PHY_CLK)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 23)) | (((value as u32) & 0x01) << 23);
        self.w
    }
}
#[doc = "Port force full speed connect\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PFSC_A {
    #[doc = "0: Port connects at any speed."]
    ANYSPEED,
    #[doc = "1: Writing this bit to a 1 will force the port to only connect at Full Speed. It disables the chirp sequence that allows the port to identify itself as High Speed. This is useful for testing FS configurations with a HS host, hub or device."]
    FULLSPEED,
}
impl From<PFSC_A> for bool {
    #[inline(always)]
    fn from(variant: PFSC_A) -> Self {
        match variant {
            PFSC_A::ANYSPEED => false,
            PFSC_A::FULLSPEED => true,
        }
    }
}
#[doc = "Reader of field `PFSC`"]
pub type PFSC_R = crate::R<bool, PFSC_A>;
impl PFSC_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PFSC_A {
        match self.bits {
            false => PFSC_A::ANYSPEED,
            true => PFSC_A::FULLSPEED,
        }
    }
    #[doc = "Checks if the value of the field is `ANYSPEED`"]
    #[inline(always)]
    pub fn is_anyspeed(&self) -> bool {
        *self == PFSC_A::ANYSPEED
    }
    #[doc = "Checks if the value of the field is `FULLSPEED`"]
    #[inline(always)]
    pub fn is_fullspeed(&self) -> bool {
        *self == PFSC_A::FULLSPEED
    }
}
#[doc = "Write proxy for field `PFSC`"]
pub struct PFSC_W<'a> {
    w: &'a mut W,
}
impl<'a> PFSC_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PFSC_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Port connects at any speed."]
    #[inline(always)]
    pub fn anyspeed(self) -> &'a mut W {
        self.variant(PFSC_A::ANYSPEED)
    }
    #[doc = "Writing this bit to a 1 will force the port to only connect at Full Speed. It disables the chirp sequence that allows the port to identify itself as High Speed. This is useful for testing FS configurations with a HS host, hub or device."]
    #[inline(always)]
    pub fn fullspeed(self) -> &'a mut W {
        self.variant(PFSC_A::FULLSPEED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | (((value as u32) & 0x01) << 24);
        self.w
    }
}
#[doc = "Port speed This register field indicates the speed at which the port is operating. For HS mode operation in the host controller and HS/FS operation in the device controller the port routing steers data to the Protocol engine. For FS and LS mode operation in the host controller, the port routing steers data to the Protocol Engine w/ Embedded Transaction Translator.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PSPD_A {
    #[doc = "0: Full-speed"]
    FULL_SPEED,
    #[doc = "1: Low-speed"]
    LOW_SPEED,
    #[doc = "2: High-speed"]
    HIGH_SPEED,
}
impl From<PSPD_A> for u8 {
    #[inline(always)]
    fn from(variant: PSPD_A) -> Self {
        match variant {
            PSPD_A::FULL_SPEED => 0,
            PSPD_A::LOW_SPEED => 1,
            PSPD_A::HIGH_SPEED => 2,
        }
    }
}
#[doc = "Reader of field `PSPD`"]
pub type PSPD_R = crate::R<u8, PSPD_A>;
impl PSPD_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, PSPD_A> {
        use crate::Variant::*;
        match self.bits {
            0 => Val(PSPD_A::FULL_SPEED),
            1 => Val(PSPD_A::LOW_SPEED),
            2 => Val(PSPD_A::HIGH_SPEED),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `FULL_SPEED`"]
    #[inline(always)]
    pub fn is_full_speed(&self) -> bool {
        *self == PSPD_A::FULL_SPEED
    }
    #[doc = "Checks if the value of the field is `LOW_SPEED`"]
    #[inline(always)]
    pub fn is_low_speed(&self) -> bool {
        *self == PSPD_A::LOW_SPEED
    }
    #[doc = "Checks if the value of the field is `HIGH_SPEED`"]
    #[inline(always)]
    pub fn is_high_speed(&self) -> bool {
        *self == PSPD_A::HIGH_SPEED
    }
}
#[doc = "Write proxy for field `PSPD`"]
pub struct PSPD_W<'a> {
    w: &'a mut W,
}
impl<'a> PSPD_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PSPD_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Full-speed"]
    #[inline(always)]
    pub fn full_speed(self) -> &'a mut W {
        self.variant(PSPD_A::FULL_SPEED)
    }
    #[doc = "Low-speed"]
    #[inline(always)]
    pub fn low_speed(self) -> &'a mut W {
        self.variant(PSPD_A::LOW_SPEED)
    }
    #[doc = "High-speed"]
    #[inline(always)]
    pub fn high_speed(self) -> &'a mut W {
        self.variant(PSPD_A::HIGH_SPEED)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 26)) | (((value as u32) & 0x03) << 26);
        self.w
    }
}
#[doc = "Parallel transceiver select. All other values are reserved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PTS_A {
    #[doc = "2: ULPI"]
    ULPI,
    #[doc = "3: Serial/ 1.1 PHY (Full-speed only)"]
    SERIAL,
}
impl From<PTS_A> for u8 {
    #[inline(always)]
    fn from(variant: PTS_A) -> Self {
        match variant {
            PTS_A::ULPI => 2,
            PTS_A::SERIAL => 3,
        }
    }
}
#[doc = "Reader of field `PTS`"]
pub type PTS_R = crate::R<u8, PTS_A>;
impl PTS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> crate::Variant<u8, PTS_A> {
        use crate::Variant::*;
        match self.bits {
            2 => Val(PTS_A::ULPI),
            3 => Val(PTS_A::SERIAL),
            i => Res(i),
        }
    }
    #[doc = "Checks if the value of the field is `ULPI`"]
    #[inline(always)]
    pub fn is_ulpi(&self) -> bool {
        *self == PTS_A::ULPI
    }
    #[doc = "Checks if the value of the field is `SERIAL`"]
    #[inline(always)]
    pub fn is_serial(&self) -> bool {
        *self == PTS_A::SERIAL
    }
}
#[doc = "Write proxy for field `PTS`"]
pub struct PTS_W<'a> {
    w: &'a mut W,
}
impl<'a> PTS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PTS_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "ULPI"]
    #[inline(always)]
    pub fn ulpi(self) -> &'a mut W {
        self.variant(PTS_A::ULPI)
    }
    #[doc = "Serial/ 1.1 PHY (Full-speed only)"]
    #[inline(always)]
    pub fn serial(self) -> &'a mut W {
        self.variant(PTS_A::SERIAL)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 30)) | (((value as u32) & 0x03) << 30);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Current connect status This value reflects the current state of the port and may not correspond directly to the event that caused the CSC bit to be set. This bit is 0 if PP (Port Power bit) is 0. Software clears this bit by writing a 1 to it."]
    #[inline(always)]
    pub fn ccs(&self) -> CCS_R {
        CCS_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Connect status change Indicates a change has occurred in the port's Current Connect Status. The host/device controller sets this bit for all changes to the port device connect status, even if system software has not cleared an existing connect status change. For example, the insertion status changes twice before system software has cleared the changed condition, hub hardware will be setting an already-set bit (i.e., the bit will remain set). Software clears this bit by writing a one to it. This bit is 0 if PP (Port Power bit) is 0"]
    #[inline(always)]
    pub fn csc(&self) -> CSC_R {
        CSC_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Port enable. Ports can only be enabled by the host controller as a part of the reset and enable. Software cannot enable a port by writing a one to this field. Ports can be disabled by either a fault condition (disconnect event or other fault condition) or by the host software. Note that the bit status does not change until the port state actually changes. There may be a delay in disabling or enabling a port due to other host controller and bus events. When the port is disabled. downstream propagation of data is blocked except for reset. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn pe(&self) -> PE_R {
        PE_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Port disable/enable change For the root hub, this bit gets set to a one only when a port is disabled due to disconnect on the port or due to the appropriate conditions existing at the EOF2 point (See Chapter 11 of the USB Specification). Software clears this by writing a one to it. This bit is 0 if PP (Port Power bit) is 0,"]
    #[inline(always)]
    pub fn pec(&self) -> PEC_R {
        PEC_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Over-current active This bit will automatically transition from 1 to 0 when the over-current condition is removed."]
    #[inline(always)]
    pub fn oca(&self) -> OCA_R {
        OCA_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Over-current change This bit gets set to one when there is a change to Over-current Active. Software clears this bit by writing a one to this bit position."]
    #[inline(always)]
    pub fn occ(&self) -> OCC_R {
        OCC_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Force port resume Software sets this bit to one to drive resume signaling. The Host Controller sets this bit to one if a J-to-K transition is detected while the port is in the Suspend state. When this bit transitions to a one because a J-to-K transition is detected, the Port Change Detect bit in the USBSTS register is also set to one. This bit will automatically change to zero after the resume sequence is complete. This behavior is different from EHCI where the host controller driver is required to set this bit to a zero after the resume duration is timed in the driver. Note that when the Host controller owns the port, the resume sequence follows the defined sequence documented in the USB Specification Revision 2.0. The resume signaling (Full-speed K) is driven on the port as long as this bit remains a one. This bit will remain a one until the port has switched to the high-speed idle. Writing a zero has no affect because the port controller will time the resume operation clear the bit the port control state switches to HS or FS idle. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn fpr(&self) -> FPR_R {
        FPR_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - Suspend Together with the PE (Port enabled bit), this bit describes the port states, see Table 302 Port states as described by the PE and SUSP bits in the PORTSC1 register. The host controller will unconditionally set this bit to zero when software sets the Force Port Resume bit to zero. The host controller ignores a write of zero to this bit. If host software sets this bit to a one when the port is not enabled (i.e. Port enabled bit is a zero) the results are undefined. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn susp(&self) -> SUSP_R {
        SUSP_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Port reset When software writes a one to this bit the bus-reset sequence as defined in the USB Specification Revision 2.0 is started. This bit will automatically change to zero after the reset sequence is complete. This behavior is different from EHCI where the host controller driver is required to set this bit to a zero after the reset duration is timed in the driver. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn pr(&self) -> PR_R {
        PR_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - High-speed status"]
    #[inline(always)]
    pub fn hsp(&self) -> HSP_R {
        HSP_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bits 10:11 - Line status These bits reflect the current logical levels of the USB_DP and USB_DM signal lines. USB_DP corresponds to bit 11 and USB_DM to bit 10. In host mode, the use of linestate by the host controller driver is not necessary for this controller (unlike EHCI) because the controller hardware manages the connection of LS and FS."]
    #[inline(always)]
    pub fn ls(&self) -> LS_R {
        LS_R::new(((self.bits >> 10) & 0x03) as u8)
    }
    #[doc = "Bit 12 - Port power control Host controller requires port power control switches. This bit represents the current setting of the switch (0=off, 1=on). When power is not available on a port (i.e. PP equals a 0), the port is non-functional and will not report attaches, detaches, etc. When an over-current condition is detected on a powered port and PPC is a one, the PP bit in each affected port may be transitioned by the host controller driver from a one to a zero (removing power from the port)."]
    #[inline(always)]
    pub fn pp(&self) -> PP_R {
        PP_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bits 14:15 - Port indicator control Writing to this field controls the value of the pins USB1_IND1 and USB1_IND0."]
    #[inline(always)]
    pub fn pic1_0(&self) -> PIC1_0_R {
        PIC1_0_R::new(((self.bits >> 14) & 0x03) as u8)
    }
    #[doc = "Bits 16:19 - Port test control Any value other than 0000 indicates that the port is operating in test mode. The FORCE_ENABLE_FS and FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI specification. Writing the PTC field to any of the FORCE_ENABLE_{HS/FS/LS} values will force the port into the connected and enabled state at the selected speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state machines to progress normally from that point. Values 0x8 to 0xF are reserved."]
    #[inline(always)]
    pub fn ptc3_0(&self) -> PTC3_0_R {
        PTC3_0_R::new(((self.bits >> 16) & 0x0f) as u8)
    }
    #[doc = "Bit 20 - Wake on connect enable (WKCNNT_E) This bit is 0 if PP (Port Power bit) is 0"]
    #[inline(always)]
    pub fn wkcn(&self) -> WKCN_R {
        WKCN_R::new(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Wake on disconnect enable (WKDSCNNT_E) This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn wkdc(&self) -> WKDC_R {
        WKDC_R::new(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 22 - Wake on over-current enable (WKOC_E)"]
    #[inline(always)]
    pub fn wkoc(&self) -> WKOC_R {
        WKOC_R::new(((self.bits >> 22) & 0x01) != 0)
    }
    #[doc = "Bit 23 - PHY low power suspend - clock disable (PLPSCD) In host mode, the PHY can be put into Low Power Suspend - Clock Disable when the downstream device has been put into suspend mode or when no downstream device is connected. Low power suspend is completely under the control of software."]
    #[inline(always)]
    pub fn phcd(&self) -> PHCD_R {
        PHCD_R::new(((self.bits >> 23) & 0x01) != 0)
    }
    #[doc = "Bit 24 - Port force full speed connect"]
    #[inline(always)]
    pub fn pfsc(&self) -> PFSC_R {
        PFSC_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bits 26:27 - Port speed This register field indicates the speed at which the port is operating. For HS mode operation in the host controller and HS/FS operation in the device controller the port routing steers data to the Protocol engine. For FS and LS mode operation in the host controller, the port routing steers data to the Protocol Engine w/ Embedded Transaction Translator."]
    #[inline(always)]
    pub fn pspd(&self) -> PSPD_R {
        PSPD_R::new(((self.bits >> 26) & 0x03) as u8)
    }
    #[doc = "Bits 30:31 - Parallel transceiver select. All other values are reserved."]
    #[inline(always)]
    pub fn pts(&self) -> PTS_R {
        PTS_R::new(((self.bits >> 30) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Current connect status This value reflects the current state of the port and may not correspond directly to the event that caused the CSC bit to be set. This bit is 0 if PP (Port Power bit) is 0. Software clears this bit by writing a 1 to it."]
    #[inline(always)]
    pub fn ccs(&mut self) -> CCS_W {
        CCS_W { w: self }
    }
    #[doc = "Bit 1 - Connect status change Indicates a change has occurred in the port's Current Connect Status. The host/device controller sets this bit for all changes to the port device connect status, even if system software has not cleared an existing connect status change. For example, the insertion status changes twice before system software has cleared the changed condition, hub hardware will be setting an already-set bit (i.e., the bit will remain set). Software clears this bit by writing a one to it. This bit is 0 if PP (Port Power bit) is 0"]
    #[inline(always)]
    pub fn csc(&mut self) -> CSC_W {
        CSC_W { w: self }
    }
    #[doc = "Bit 2 - Port enable. Ports can only be enabled by the host controller as a part of the reset and enable. Software cannot enable a port by writing a one to this field. Ports can be disabled by either a fault condition (disconnect event or other fault condition) or by the host software. Note that the bit status does not change until the port state actually changes. There may be a delay in disabling or enabling a port due to other host controller and bus events. When the port is disabled. downstream propagation of data is blocked except for reset. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn pe(&mut self) -> PE_W {
        PE_W { w: self }
    }
    #[doc = "Bit 3 - Port disable/enable change For the root hub, this bit gets set to a one only when a port is disabled due to disconnect on the port or due to the appropriate conditions existing at the EOF2 point (See Chapter 11 of the USB Specification). Software clears this by writing a one to it. This bit is 0 if PP (Port Power bit) is 0,"]
    #[inline(always)]
    pub fn pec(&mut self) -> PEC_W {
        PEC_W { w: self }
    }
    #[doc = "Bit 4 - Over-current active This bit will automatically transition from 1 to 0 when the over-current condition is removed."]
    #[inline(always)]
    pub fn oca(&mut self) -> OCA_W {
        OCA_W { w: self }
    }
    #[doc = "Bit 5 - Over-current change This bit gets set to one when there is a change to Over-current Active. Software clears this bit by writing a one to this bit position."]
    #[inline(always)]
    pub fn occ(&mut self) -> OCC_W {
        OCC_W { w: self }
    }
    #[doc = "Bit 6 - Force port resume Software sets this bit to one to drive resume signaling. The Host Controller sets this bit to one if a J-to-K transition is detected while the port is in the Suspend state. When this bit transitions to a one because a J-to-K transition is detected, the Port Change Detect bit in the USBSTS register is also set to one. This bit will automatically change to zero after the resume sequence is complete. This behavior is different from EHCI where the host controller driver is required to set this bit to a zero after the resume duration is timed in the driver. Note that when the Host controller owns the port, the resume sequence follows the defined sequence documented in the USB Specification Revision 2.0. The resume signaling (Full-speed K) is driven on the port as long as this bit remains a one. This bit will remain a one until the port has switched to the high-speed idle. Writing a zero has no affect because the port controller will time the resume operation clear the bit the port control state switches to HS or FS idle. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn fpr(&mut self) -> FPR_W {
        FPR_W { w: self }
    }
    #[doc = "Bit 7 - Suspend Together with the PE (Port enabled bit), this bit describes the port states, see Table 302 Port states as described by the PE and SUSP bits in the PORTSC1 register. The host controller will unconditionally set this bit to zero when software sets the Force Port Resume bit to zero. The host controller ignores a write of zero to this bit. If host software sets this bit to a one when the port is not enabled (i.e. Port enabled bit is a zero) the results are undefined. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn susp(&mut self) -> SUSP_W {
        SUSP_W { w: self }
    }
    #[doc = "Bit 8 - Port reset When software writes a one to this bit the bus-reset sequence as defined in the USB Specification Revision 2.0 is started. This bit will automatically change to zero after the reset sequence is complete. This behavior is different from EHCI where the host controller driver is required to set this bit to a zero after the reset duration is timed in the driver. This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn pr(&mut self) -> PR_W {
        PR_W { w: self }
    }
    #[doc = "Bit 9 - High-speed status"]
    #[inline(always)]
    pub fn hsp(&mut self) -> HSP_W {
        HSP_W { w: self }
    }
    #[doc = "Bits 10:11 - Line status These bits reflect the current logical levels of the USB_DP and USB_DM signal lines. USB_DP corresponds to bit 11 and USB_DM to bit 10. In host mode, the use of linestate by the host controller driver is not necessary for this controller (unlike EHCI) because the controller hardware manages the connection of LS and FS."]
    #[inline(always)]
    pub fn ls(&mut self) -> LS_W {
        LS_W { w: self }
    }
    #[doc = "Bit 12 - Port power control Host controller requires port power control switches. This bit represents the current setting of the switch (0=off, 1=on). When power is not available on a port (i.e. PP equals a 0), the port is non-functional and will not report attaches, detaches, etc. When an over-current condition is detected on a powered port and PPC is a one, the PP bit in each affected port may be transitioned by the host controller driver from a one to a zero (removing power from the port)."]
    #[inline(always)]
    pub fn pp(&mut self) -> PP_W {
        PP_W { w: self }
    }
    #[doc = "Bits 14:15 - Port indicator control Writing to this field controls the value of the pins USB1_IND1 and USB1_IND0."]
    #[inline(always)]
    pub fn pic1_0(&mut self) -> PIC1_0_W {
        PIC1_0_W { w: self }
    }
    #[doc = "Bits 16:19 - Port test control Any value other than 0000 indicates that the port is operating in test mode. The FORCE_ENABLE_FS and FORCE ENABLE_LS are extensions to the test mode support specified in the EHCI specification. Writing the PTC field to any of the FORCE_ENABLE_{HS/FS/LS} values will force the port into the connected and enabled state at the selected speed. Writing the PTC field back to TEST_MODE_DISABLE will allow the port state machines to progress normally from that point. Values 0x8 to 0xF are reserved."]
    #[inline(always)]
    pub fn ptc3_0(&mut self) -> PTC3_0_W {
        PTC3_0_W { w: self }
    }
    #[doc = "Bit 20 - Wake on connect enable (WKCNNT_E) This bit is 0 if PP (Port Power bit) is 0"]
    #[inline(always)]
    pub fn wkcn(&mut self) -> WKCN_W {
        WKCN_W { w: self }
    }
    #[doc = "Bit 21 - Wake on disconnect enable (WKDSCNNT_E) This bit is 0 if PP (Port Power bit) is 0."]
    #[inline(always)]
    pub fn wkdc(&mut self) -> WKDC_W {
        WKDC_W { w: self }
    }
    #[doc = "Bit 22 - Wake on over-current enable (WKOC_E)"]
    #[inline(always)]
    pub fn wkoc(&mut self) -> WKOC_W {
        WKOC_W { w: self }
    }
    #[doc = "Bit 23 - PHY low power suspend - clock disable (PLPSCD) In host mode, the PHY can be put into Low Power Suspend - Clock Disable when the downstream device has been put into suspend mode or when no downstream device is connected. Low power suspend is completely under the control of software."]
    #[inline(always)]
    pub fn phcd(&mut self) -> PHCD_W {
        PHCD_W { w: self }
    }
    #[doc = "Bit 24 - Port force full speed connect"]
    #[inline(always)]
    pub fn pfsc(&mut self) -> PFSC_W {
        PFSC_W { w: self }
    }
    #[doc = "Bits 26:27 - Port speed This register field indicates the speed at which the port is operating. For HS mode operation in the host controller and HS/FS operation in the device controller the port routing steers data to the Protocol engine. For FS and LS mode operation in the host controller, the port routing steers data to the Protocol Engine w/ Embedded Transaction Translator."]
    #[inline(always)]
    pub fn pspd(&mut self) -> PSPD_W {
        PSPD_W { w: self }
    }
    #[doc = "Bits 30:31 - Parallel transceiver select. All other values are reserved."]
    #[inline(always)]
    pub fn pts(&mut self) -> PTS_W {
        PTS_W { w: self }
    }
}
