#[doc = "Reader of register TXFILLTUNING"]
pub type R = crate::R<u32, super::TXFILLTUNING>;
#[doc = "Writer for register TXFILLTUNING"]
pub type W = crate::W<u32, super::TXFILLTUNING>;
#[doc = "Register TXFILLTUNING `reset()`'s with value 0"]
impl crate::ResetValue for super::TXFILLTUNING {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Reader of field `TXSCHOH`"]
pub type TXSCHOH_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `TXSCHOH`"]
pub struct TXSCHOH_W<'a> {
    w: &'a mut W,
}
impl<'a> TXSCHOH_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | ((value as u32) & 0xff);
        self.w
    }
}
#[doc = "Reader of field `TXSCHEATLTH`"]
pub type TXSCHEATLTH_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `TXSCHEATLTH`"]
pub struct TXSCHEATLTH_W<'a> {
    w: &'a mut W,
}
impl<'a> TXSCHEATLTH_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x1f << 8)) | (((value as u32) & 0x1f) << 8);
        self.w
    }
}
#[doc = "Reader of field `TXFIFOTHRES`"]
pub type TXFIFOTHRES_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `TXFIFOTHRES`"]
pub struct TXFIFOTHRES_W<'a> {
    w: &'a mut W,
}
impl<'a> TXFIFOTHRES_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x3f << 16)) | (((value as u32) & 0x3f) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - FIFO burst threshold This register controls the number of data bursts that are posted to the TX latency FIFO in host mode before the packet begins on to the bus. The minimum value is 2 and this value should be a low as possible to maximize USB performance. A higher value can be used in systems with unpredictable latency and/or insufficient bandwidth where the FIFO may underrun because the data transferred from the latency FIFO to USB occurs before it can be replenished from system memory. This value is ignored if the Stream Disable bit in USBMODE register is set."]
    #[inline(always)]
    pub fn txschoh(&self) -> TXSCHOH_R {
        TXSCHOH_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:12 - Scheduler health counter This register increments when the host controller fails to fill the TX latency FIFO to the level programmed by TXFIFOTHRES before running out of time to send the packet before the next Start-Of-Frame . This health counter measures the number of times this occurs to provide feedback to selecting a proper TXSCHOH. Writing to this register will clear the counter. The maximum value is 31."]
    #[inline(always)]
    pub fn txscheatlth(&self) -> TXSCHEATLTH_R {
        TXSCHEATLTH_R::new(((self.bits >> 8) & 0x1f) as u8)
    }
    #[doc = "Bits 16:21 - Scheduler overhead This register adds an additional fixed offset to the schedule time estimator described above as Tff. As an approximation, the value chosen for this register should limit the number of back-off events captured in the TXSCHHEALTH to less than 10 per second in a highly utilized bus. Choosing a value that is too high for this register is not desired as it can needlessly reduce USB utilization. The time unit represented in this register is 1.267 ms when a device is connected in High-Speed Mode. The time unit represented in this register is 6.333 ms when a device is connected in Low/Full Speed Mode."]
    #[inline(always)]
    pub fn txfifothres(&self) -> TXFIFOTHRES_R {
        TXFIFOTHRES_R::new(((self.bits >> 16) & 0x3f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - FIFO burst threshold This register controls the number of data bursts that are posted to the TX latency FIFO in host mode before the packet begins on to the bus. The minimum value is 2 and this value should be a low as possible to maximize USB performance. A higher value can be used in systems with unpredictable latency and/or insufficient bandwidth where the FIFO may underrun because the data transferred from the latency FIFO to USB occurs before it can be replenished from system memory. This value is ignored if the Stream Disable bit in USBMODE register is set."]
    #[inline(always)]
    pub fn txschoh(&mut self) -> TXSCHOH_W {
        TXSCHOH_W { w: self }
    }
    #[doc = "Bits 8:12 - Scheduler health counter This register increments when the host controller fails to fill the TX latency FIFO to the level programmed by TXFIFOTHRES before running out of time to send the packet before the next Start-Of-Frame . This health counter measures the number of times this occurs to provide feedback to selecting a proper TXSCHOH. Writing to this register will clear the counter. The maximum value is 31."]
    #[inline(always)]
    pub fn txscheatlth(&mut self) -> TXSCHEATLTH_W {
        TXSCHEATLTH_W { w: self }
    }
    #[doc = "Bits 16:21 - Scheduler overhead This register adds an additional fixed offset to the schedule time estimator described above as Tff. As an approximation, the value chosen for this register should limit the number of back-off events captured in the TXSCHHEALTH to less than 10 per second in a highly utilized bus. Choosing a value that is too high for this register is not desired as it can needlessly reduce USB utilization. The time unit represented in this register is 1.267 ms when a device is connected in High-Speed Mode. The time unit represented in this register is 6.333 ms when a device is connected in Low/Full Speed Mode."]
    #[inline(always)]
    pub fn txfifothres(&mut self) -> TXFIFOTHRES_W {
        TXFIFOTHRES_W { w: self }
    }
}
