#[doc = "Reader of register USBCMD_H"]
pub type R = crate::R<u32, super::USBCMD_H>;
#[doc = "Writer for register USBCMD_H"]
pub type W = crate::W<u32, super::USBCMD_H>;
#[doc = "Register USBCMD_H `reset()`'s with value 0x0004_00b0"]
impl crate::ResetValue for super::USBCMD_H {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x0004_00b0
    }
}
#[doc = "Run/Stop\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RS_A {
    #[doc = "0: When this bit is set to 0, the Host Controller completes the current transaction on the USB and then halts. The HC Halted bit in the status register indicates when the Host Controller has finished the transaction and has entered the stopped state. Software should not write a one to this field unless the host controller is in the Halted state (i.e. HCHalted in the USBSTS register is a one)."]
    HALT,
    #[doc = "1: When set to a 1, the Host Controller proceeds with the execution of the schedule. The Host Controller continues execution as long as this bit is set to a one."]
    PROCEED,
}
impl From<RS_A> for bool {
    #[inline(always)]
    fn from(variant: RS_A) -> Self {
        match variant {
            RS_A::HALT => false,
            RS_A::PROCEED => true,
        }
    }
}
#[doc = "Reader of field `RS`"]
pub type RS_R = crate::R<bool, RS_A>;
impl RS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RS_A {
        match self.bits {
            false => RS_A::HALT,
            true => RS_A::PROCEED,
        }
    }
    #[doc = "Checks if the value of the field is `HALT`"]
    #[inline(always)]
    pub fn is_halt(&self) -> bool {
        *self == RS_A::HALT
    }
    #[doc = "Checks if the value of the field is `PROCEED`"]
    #[inline(always)]
    pub fn is_proceed(&self) -> bool {
        *self == RS_A::PROCEED
    }
}
#[doc = "Write proxy for field `RS`"]
pub struct RS_W<'a> {
    w: &'a mut W,
}
impl<'a> RS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "When this bit is set to 0, the Host Controller completes the current transaction on the USB and then halts. The HC Halted bit in the status register indicates when the Host Controller has finished the transaction and has entered the stopped state. Software should not write a one to this field unless the host controller is in the Halted state (i.e. HCHalted in the USBSTS register is a one)."]
    #[inline(always)]
    pub fn halt(self) -> &'a mut W {
        self.variant(RS_A::HALT)
    }
    #[doc = "When set to a 1, the Host Controller proceeds with the execution of the schedule. The Host Controller continues execution as long as this bit is set to a one."]
    #[inline(always)]
    pub fn proceed(self) -> &'a mut W {
        self.variant(RS_A::PROCEED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "Controller reset. Software uses this bit to reset the controller. This bit is set to zero by the Host/Device Controller when the reset process is complete. Software cannot terminate the reset process early by writing a zero to this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RST_A {
    #[doc = "0: This bit is set to zero by hardware when the reset process is complete."]
    RESETCOMPLETE,
    #[doc = "1: When software writes a one to this bit, the Host Controller resets its internal pipelines, timers, counters, state machines etc. to their initial value. Any transaction currently in progress on USB is immediately terminated. A USB reset is not driven on downstream ports. Software should not set this bit to a one when the HCHalted bit in the USBSTS register is a zero. Attempting to reset an actively running host controller will result in undefined behavior."]
    RESET,
}
impl From<RST_A> for bool {
    #[inline(always)]
    fn from(variant: RST_A) -> Self {
        match variant {
            RST_A::RESETCOMPLETE => false,
            RST_A::RESET => true,
        }
    }
}
#[doc = "Reader of field `RST`"]
pub type RST_R = crate::R<bool, RST_A>;
impl RST_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RST_A {
        match self.bits {
            false => RST_A::RESETCOMPLETE,
            true => RST_A::RESET,
        }
    }
    #[doc = "Checks if the value of the field is `RESETCOMPLETE`"]
    #[inline(always)]
    pub fn is_resetcomplete(&self) -> bool {
        *self == RST_A::RESETCOMPLETE
    }
    #[doc = "Checks if the value of the field is `RESET`"]
    #[inline(always)]
    pub fn is_reset(&self) -> bool {
        *self == RST_A::RESET
    }
}
#[doc = "Write proxy for field `RST`"]
pub struct RST_W<'a> {
    w: &'a mut W,
}
impl<'a> RST_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RST_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is set to zero by hardware when the reset process is complete."]
    #[inline(always)]
    pub fn resetcomplete(self) -> &'a mut W {
        self.variant(RST_A::RESETCOMPLETE)
    }
    #[doc = "When software writes a one to this bit, the Host Controller resets its internal pipelines, timers, counters, state machines etc. to their initial value. Any transaction currently in progress on USB is immediately terminated. A USB reset is not driven on downstream ports. Software should not set this bit to a one when the HCHalted bit in the USBSTS register is a zero. Attempting to reset an actively running host controller will result in undefined behavior."]
    #[inline(always)]
    pub fn reset(self) -> &'a mut W {
        self.variant(RST_A::RESET)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Reader of field `FS0`"]
pub type FS0_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `FS0`"]
pub struct FS0_W<'a> {
    w: &'a mut W,
}
impl<'a> FS0_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Reader of field `FS1`"]
pub type FS1_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `FS1`"]
pub struct FS1_W<'a> {
    w: &'a mut W,
}
impl<'a> FS1_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "This bit controls whether the host controller skips processing the periodic schedule.\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PSE_A {
    #[doc = "0: Do not process the periodic schedule."]
    DO_NOT_PROCESS_THE_PERIODIC_SCHEDULE,
    #[doc = "1: Use the PERIODICLISTBASE register to access the periodic schedule."]
    USE_THE_PERIODICLISTBASE,
}
impl From<PSE_A> for bool {
    #[inline(always)]
    fn from(variant: PSE_A) -> Self {
        match variant {
            PSE_A::DO_NOT_PROCESS_THE_PERIODIC_SCHEDULE => false,
            PSE_A::USE_THE_PERIODICLISTBASE => true,
        }
    }
}
#[doc = "Reader of field `PSE`"]
pub type PSE_R = crate::R<bool, PSE_A>;
impl PSE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PSE_A {
        match self.bits {
            false => PSE_A::DO_NOT_PROCESS_THE_PERIODIC_SCHEDULE,
            true => PSE_A::USE_THE_PERIODICLISTBASE,
        }
    }
    #[doc = "Checks if the value of the field is `DO_NOT_PROCESS_THE_PERIODIC_SCHEDULE`"]
    #[inline(always)]
    pub fn is_do_not_process_the_periodic_schedule(&self) -> bool {
        *self == PSE_A::DO_NOT_PROCESS_THE_PERIODIC_SCHEDULE
    }
    #[doc = "Checks if the value of the field is `USE_THE_PERIODICLISTBASE`"]
    #[inline(always)]
    pub fn is_use_the_periodiclistbase(&self) -> bool {
        *self == PSE_A::USE_THE_PERIODICLISTBASE
    }
}
#[doc = "Write proxy for field `PSE`"]
pub struct PSE_W<'a> {
    w: &'a mut W,
}
impl<'a> PSE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PSE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Do not process the periodic schedule."]
    #[inline(always)]
    pub fn do_not_process_the_periodic_schedule(self) -> &'a mut W {
        self.variant(PSE_A::DO_NOT_PROCESS_THE_PERIODIC_SCHEDULE)
    }
    #[doc = "Use the PERIODICLISTBASE register to access the periodic schedule."]
    #[inline(always)]
    pub fn use_the_periodiclistbase(self) -> &'a mut W {
        self.variant(PSE_A::USE_THE_PERIODICLISTBASE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "This bit controls whether the host controller skips processing the asynchronous schedule.\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ASE_A {
    #[doc = "0: Do not process the asynchronous schedule."]
    DO_NOT_PROCESS_THE_ASYNC_SCHEDULE,
    #[doc = "1: Use the ASYNCLISTADDR to access the asynchronous schedule."]
    USE_THE_ASYNCLISTADDR,
}
impl From<ASE_A> for bool {
    #[inline(always)]
    fn from(variant: ASE_A) -> Self {
        match variant {
            ASE_A::DO_NOT_PROCESS_THE_ASYNC_SCHEDULE => false,
            ASE_A::USE_THE_ASYNCLISTADDR => true,
        }
    }
}
#[doc = "Reader of field `ASE`"]
pub type ASE_R = crate::R<bool, ASE_A>;
impl ASE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ASE_A {
        match self.bits {
            false => ASE_A::DO_NOT_PROCESS_THE_ASYNC_SCHEDULE,
            true => ASE_A::USE_THE_ASYNCLISTADDR,
        }
    }
    #[doc = "Checks if the value of the field is `DO_NOT_PROCESS_THE_ASYNC_SCHEDULE`"]
    #[inline(always)]
    pub fn is_do_not_process_the_async_schedule(&self) -> bool {
        *self == ASE_A::DO_NOT_PROCESS_THE_ASYNC_SCHEDULE
    }
    #[doc = "Checks if the value of the field is `USE_THE_ASYNCLISTADDR`"]
    #[inline(always)]
    pub fn is_use_the_asynclistaddr(&self) -> bool {
        *self == ASE_A::USE_THE_ASYNCLISTADDR
    }
}
#[doc = "Write proxy for field `ASE`"]
pub struct ASE_W<'a> {
    w: &'a mut W,
}
impl<'a> ASE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ASE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Do not process the asynchronous schedule."]
    #[inline(always)]
    pub fn do_not_process_the_async_schedule(self) -> &'a mut W {
        self.variant(ASE_A::DO_NOT_PROCESS_THE_ASYNC_SCHEDULE)
    }
    #[doc = "Use the ASYNCLISTADDR to access the asynchronous schedule."]
    #[inline(always)]
    pub fn use_the_asynclistaddr(self) -> &'a mut W {
        self.variant(ASE_A::USE_THE_ASYNCLISTADDR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "This bit is used as a doorbell by software to tell the host controller to issue an interrupt the next time it advances asynchronous schedule.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IAA_A {
    #[doc = "0: The host controller sets this bit to zero after it has set the Interrupt on Sync Advance status bit in the USBSTS register to one."]
    ST,
    #[doc = "1: Software must write a 1 to this bit to ring the doorbell. When the host controller has evicted all appropriate cached schedule states, it sets the Interrupt on Async Advance status bit in the USBSTS register. If the Interrupt on Sync Advance Enable bit in the USBINTR register is one, then the host controller will assert an interrupt at the next interrupt threshold. Software should not write a one to this bit when the asynchronous schedule is inactive. Doing so will yield undefined results."]
    DOORBELL,
}
impl From<IAA_A> for bool {
    #[inline(always)]
    fn from(variant: IAA_A) -> Self {
        match variant {
            IAA_A::ST => false,
            IAA_A::DOORBELL => true,
        }
    }
}
#[doc = "Reader of field `IAA`"]
pub type IAA_R = crate::R<bool, IAA_A>;
impl IAA_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> IAA_A {
        match self.bits {
            false => IAA_A::ST,
            true => IAA_A::DOORBELL,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == IAA_A::ST
    }
    #[doc = "Checks if the value of the field is `DOORBELL`"]
    #[inline(always)]
    pub fn is_doorbell(&self) -> bool {
        *self == IAA_A::DOORBELL
    }
}
#[doc = "Write proxy for field `IAA`"]
pub struct IAA_W<'a> {
    w: &'a mut W,
}
impl<'a> IAA_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: IAA_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The host controller sets this bit to zero after it has set the Interrupt on Sync Advance status bit in the USBSTS register to one."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(IAA_A::ST)
    }
    #[doc = "Software must write a 1 to this bit to ring the doorbell. When the host controller has evicted all appropriate cached schedule states, it sets the Interrupt on Async Advance status bit in the USBSTS register. If the Interrupt on Sync Advance Enable bit in the USBINTR register is one, then the host controller will assert an interrupt at the next interrupt threshold. Software should not write a one to this bit when the asynchronous schedule is inactive. Doing so will yield undefined results."]
    #[inline(always)]
    pub fn doorbell(self) -> &'a mut W {
        self.variant(IAA_A::DOORBELL)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | (((value as u32) & 0x01) << 6);
        self.w
    }
}
#[doc = "Reader of field `ASP1_0`"]
pub type ASP1_0_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `ASP1_0`"]
pub struct ASP1_0_W<'a> {
    w: &'a mut W,
}
impl<'a> ASP1_0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 8)) | (((value as u32) & 0x03) << 8);
        self.w
    }
}
#[doc = "Asynchronous Schedule Park Mode Enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ASPE_A {
    #[doc = "0: Park mode is disabled."]
    PARK_MODE_IS_DISABLED,
    #[doc = "1: Park mode is enabled."]
    PARK_MODE_IS_ENABLED,
}
impl From<ASPE_A> for bool {
    #[inline(always)]
    fn from(variant: ASPE_A) -> Self {
        match variant {
            ASPE_A::PARK_MODE_IS_DISABLED => false,
            ASPE_A::PARK_MODE_IS_ENABLED => true,
        }
    }
}
#[doc = "Reader of field `ASPE`"]
pub type ASPE_R = crate::R<bool, ASPE_A>;
impl ASPE_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ASPE_A {
        match self.bits {
            false => ASPE_A::PARK_MODE_IS_DISABLED,
            true => ASPE_A::PARK_MODE_IS_ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `PARK_MODE_IS_DISABLED`"]
    #[inline(always)]
    pub fn is_park_mode_is_disabled(&self) -> bool {
        *self == ASPE_A::PARK_MODE_IS_DISABLED
    }
    #[doc = "Checks if the value of the field is `PARK_MODE_IS_ENABLED`"]
    #[inline(always)]
    pub fn is_park_mode_is_enabled(&self) -> bool {
        *self == ASPE_A::PARK_MODE_IS_ENABLED
    }
}
#[doc = "Write proxy for field `ASPE`"]
pub struct ASPE_W<'a> {
    w: &'a mut W,
}
impl<'a> ASPE_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ASPE_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Park mode is disabled."]
    #[inline(always)]
    pub fn park_mode_is_disabled(self) -> &'a mut W {
        self.variant(ASPE_A::PARK_MODE_IS_DISABLED)
    }
    #[doc = "Park mode is enabled."]
    #[inline(always)]
    pub fn park_mode_is_enabled(self) -> &'a mut W {
        self.variant(ASPE_A::PARK_MODE_IS_ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | (((value as u32) & 0x01) << 11);
        self.w
    }
}
#[doc = "Reader of field `FS2`"]
pub type FS2_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `FS2`"]
pub struct FS2_W<'a> {
    w: &'a mut W,
}
impl<'a> FS2_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
#[doc = "Reader of field `ITC`"]
pub type ITC_R = crate::R<u8, u8>;
#[doc = "Write proxy for field `ITC`"]
pub struct ITC_W<'a> {
    w: &'a mut W,
}
impl<'a> ITC_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 16)) | (((value as u32) & 0xff) << 16);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Run/Stop"]
    #[inline(always)]
    pub fn rs(&self) -> RS_R {
        RS_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Controller reset. Software uses this bit to reset the controller. This bit is set to zero by the Host/Device Controller when the reset process is complete. Software cannot terminate the reset process early by writing a zero to this register."]
    #[inline(always)]
    pub fn rst(&self) -> RST_R {
        RST_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Bit 0 of the Frame List Size bits. See Table 281. This field specifies the size of the frame list that controls which bits in the Frame Index Register should be used for the Frame List Current index. Note that this field is made up from USBCMD bits 15, 3, and 2."]
    #[inline(always)]
    pub fn fs0(&self) -> FS0_R {
        FS0_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Bit 1 of the Frame List Size bits. See Table 281"]
    #[inline(always)]
    pub fn fs1(&self) -> FS1_R {
        FS1_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - This bit controls whether the host controller skips processing the periodic schedule."]
    #[inline(always)]
    pub fn pse(&self) -> PSE_R {
        PSE_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - This bit controls whether the host controller skips processing the asynchronous schedule."]
    #[inline(always)]
    pub fn ase(&self) -> ASE_R {
        ASE_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - This bit is used as a doorbell by software to tell the host controller to issue an interrupt the next time it advances asynchronous schedule."]
    #[inline(always)]
    pub fn iaa(&self) -> IAA_R {
        IAA_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bits 8:9 - Asynchronous schedule park mode. Contains a count of the number of successive transactions the host controller is allowed to execute from a high-speed queue head on the Asynchronous schedule before continuing traversal of the Asynchronous schedule. Valid values are 0x1 to 0x3. Software must not write 00 to this bit when Park Mode Enable is one as this will result in undefined behavior."]
    #[inline(always)]
    pub fn asp1_0(&self) -> ASP1_0_R {
        ASP1_0_R::new(((self.bits >> 8) & 0x03) as u8)
    }
    #[doc = "Bit 11 - Asynchronous Schedule Park Mode Enable"]
    #[inline(always)]
    pub fn aspe(&self) -> ASPE_R {
        ASPE_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Bit 2 of the Frame List Size bits. See Table 281."]
    #[inline(always)]
    pub fn fs2(&self) -> FS2_R {
        FS2_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bits 16:23 - Interrupt threshold control. The system software uses this field to set the maximum rate at which the host/device controller will issue interrupts. ITC contains the maximum interrupt interval measured in micro-frames. Valid values are shown below. All other values are reserved. 0x0 = Immediate (no threshold) 0x1 = 1 micro frame. 0x2 = 2 micro frames. 0x8 = 8 micro frames. 0x10 = 16 micro frames. 0x20 = 32 micro frames. 0x40 = 64 micro frames."]
    #[inline(always)]
    pub fn itc(&self) -> ITC_R {
        ITC_R::new(((self.bits >> 16) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bit 0 - Run/Stop"]
    #[inline(always)]
    pub fn rs(&mut self) -> RS_W {
        RS_W { w: self }
    }
    #[doc = "Bit 1 - Controller reset. Software uses this bit to reset the controller. This bit is set to zero by the Host/Device Controller when the reset process is complete. Software cannot terminate the reset process early by writing a zero to this register."]
    #[inline(always)]
    pub fn rst(&mut self) -> RST_W {
        RST_W { w: self }
    }
    #[doc = "Bit 2 - Bit 0 of the Frame List Size bits. See Table 281. This field specifies the size of the frame list that controls which bits in the Frame Index Register should be used for the Frame List Current index. Note that this field is made up from USBCMD bits 15, 3, and 2."]
    #[inline(always)]
    pub fn fs0(&mut self) -> FS0_W {
        FS0_W { w: self }
    }
    #[doc = "Bit 3 - Bit 1 of the Frame List Size bits. See Table 281"]
    #[inline(always)]
    pub fn fs1(&mut self) -> FS1_W {
        FS1_W { w: self }
    }
    #[doc = "Bit 4 - This bit controls whether the host controller skips processing the periodic schedule."]
    #[inline(always)]
    pub fn pse(&mut self) -> PSE_W {
        PSE_W { w: self }
    }
    #[doc = "Bit 5 - This bit controls whether the host controller skips processing the asynchronous schedule."]
    #[inline(always)]
    pub fn ase(&mut self) -> ASE_W {
        ASE_W { w: self }
    }
    #[doc = "Bit 6 - This bit is used as a doorbell by software to tell the host controller to issue an interrupt the next time it advances asynchronous schedule."]
    #[inline(always)]
    pub fn iaa(&mut self) -> IAA_W {
        IAA_W { w: self }
    }
    #[doc = "Bits 8:9 - Asynchronous schedule park mode. Contains a count of the number of successive transactions the host controller is allowed to execute from a high-speed queue head on the Asynchronous schedule before continuing traversal of the Asynchronous schedule. Valid values are 0x1 to 0x3. Software must not write 00 to this bit when Park Mode Enable is one as this will result in undefined behavior."]
    #[inline(always)]
    pub fn asp1_0(&mut self) -> ASP1_0_W {
        ASP1_0_W { w: self }
    }
    #[doc = "Bit 11 - Asynchronous Schedule Park Mode Enable"]
    #[inline(always)]
    pub fn aspe(&mut self) -> ASPE_W {
        ASPE_W { w: self }
    }
    #[doc = "Bit 15 - Bit 2 of the Frame List Size bits. See Table 281."]
    #[inline(always)]
    pub fn fs2(&mut self) -> FS2_W {
        FS2_W { w: self }
    }
    #[doc = "Bits 16:23 - Interrupt threshold control. The system software uses this field to set the maximum rate at which the host/device controller will issue interrupts. ITC contains the maximum interrupt interval measured in micro-frames. Valid values are shown below. All other values are reserved. 0x0 = Immediate (no threshold) 0x1 = 1 micro frame. 0x2 = 2 micro frames. 0x8 = 8 micro frames. 0x10 = 16 micro frames. 0x20 = 32 micro frames. 0x40 = 64 micro frames."]
    #[inline(always)]
    pub fn itc(&mut self) -> ITC_W {
        ITC_W { w: self }
    }
}
