#[doc = "Reader of register USBMODE_H"]
pub type R = crate::R<u32, super::USBMODE_H>;
#[doc = "Writer for register USBMODE_H"]
pub type W = crate::W<u32, super::USBMODE_H>;
#[doc = "Register USBMODE_H `reset()`'s with value 0"]
impl crate::ResetValue for super::USBMODE_H {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0
    }
}
#[doc = "Controller mode The controller defaults to an idle state and needs to be initialized to the desired operating mode after reset. This register can only be written once after reset. If it is necessary to switch modes, software must reset the controller by writing to the RESET bit in the USBCMD register before reprogramming this register.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CM1_0_A {
    #[doc = "0: Idle"]
    IDLE,
    #[doc = "2: Device controller"]
    DEVICE_CONTROLLER,
    #[doc = "3: Host controller"]
    HOST_CONTROLLER,
}
impl From<CM1_0_A> for u8 {
    #[inline(always)]
    fn from(variant: CM1_0_A) -> Self {
        match variant {
            CM1_0_A::IDLE => 0,
            CM1_0_A::DEVICE_CONTROLLER => 2,
            CM1_0_A::HOST_CONTROLLER => 3,
        }
    }
}
#[doc = "Reader of field `CM1_0`"]
pub type CM1_0_R = crate::R<u8, CM1_0_A>;
impl CM1_0_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CM1_0_A {
        match self.bits {
            0 => CM1_0_A::IDLE,
            2 => CM1_0_A::DEVICE_CONTROLLER,
            3 => CM1_0_A::HOST_CONTROLLER,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `IDLE`"]
    #[inline(always)]
    pub fn is_idle(&self) -> bool {
        *self == CM1_0_A::IDLE
    }
    #[doc = "Checks if the value of the field is `DEVICE_CONTROLLER`"]
    #[inline(always)]
    pub fn is_device_controller(&self) -> bool {
        *self == CM1_0_A::DEVICE_CONTROLLER
    }
    #[doc = "Checks if the value of the field is `HOST_CONTROLLER`"]
    #[inline(always)]
    pub fn is_host_controller(&self) -> bool {
        *self == CM1_0_A::HOST_CONTROLLER
    }
}
#[doc = "Write proxy for field `CM1_0`"]
pub struct CM1_0_W<'a> {
    w: &'a mut W,
}
impl<'a> CM1_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CM1_0_A) -> &'a mut W {
        unsafe { self.bits(variant.into()) }
    }
    #[doc = "Idle"]
    #[inline(always)]
    pub fn idle(self) -> &'a mut W {
        self.variant(CM1_0_A::IDLE)
    }
    #[doc = "Device controller"]
    #[inline(always)]
    pub fn device_controller(self) -> &'a mut W {
        self.variant(CM1_0_A::DEVICE_CONTROLLER)
    }
    #[doc = "Host controller"]
    #[inline(always)]
    pub fn host_controller(self) -> &'a mut W {
        self.variant(CM1_0_A::HOST_CONTROLLER)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | ((value as u32) & 0x03);
        self.w
    }
}
#[doc = "Endian select This bit can change the byte ordering of the transfer buffers. The bit fields in the microprocessor interface and the DMA data structures (including the setup buffer within the device QH) are unaffected by the value of this bit, because they are based upon 32-bit words.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum ES_A {
    #[doc = "0: Little endian: first byte referenced in least significant byte of 32-bit word."]
    LITTLE_ENDIAN_FIRST,
    #[doc = "1: Big endian: first byte referenced in most significant byte of 32-bit word."]
    BIG_ENDIAN_FIRST_BY,
}
impl From<ES_A> for bool {
    #[inline(always)]
    fn from(variant: ES_A) -> Self {
        match variant {
            ES_A::LITTLE_ENDIAN_FIRST => false,
            ES_A::BIG_ENDIAN_FIRST_BY => true,
        }
    }
}
#[doc = "Reader of field `ES`"]
pub type ES_R = crate::R<bool, ES_A>;
impl ES_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> ES_A {
        match self.bits {
            false => ES_A::LITTLE_ENDIAN_FIRST,
            true => ES_A::BIG_ENDIAN_FIRST_BY,
        }
    }
    #[doc = "Checks if the value of the field is `LITTLE_ENDIAN_FIRST`"]
    #[inline(always)]
    pub fn is_little_endian_first(&self) -> bool {
        *self == ES_A::LITTLE_ENDIAN_FIRST
    }
    #[doc = "Checks if the value of the field is `BIG_ENDIAN_FIRST_BY`"]
    #[inline(always)]
    pub fn is_big_endian_first_by(&self) -> bool {
        *self == ES_A::BIG_ENDIAN_FIRST_BY
    }
}
#[doc = "Write proxy for field `ES`"]
pub struct ES_W<'a> {
    w: &'a mut W,
}
impl<'a> ES_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: ES_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Little endian: first byte referenced in least significant byte of 32-bit word."]
    #[inline(always)]
    pub fn little_endian_first(self) -> &'a mut W {
        self.variant(ES_A::LITTLE_ENDIAN_FIRST)
    }
    #[doc = "Big endian: first byte referenced in most significant byte of 32-bit word."]
    #[inline(always)]
    pub fn big_endian_first_by(self) -> &'a mut W {
        self.variant(ES_A::BIG_ENDIAN_FIRST_BY)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Stream disable mode The use of this feature substantially limits the overall USB performance that can be achieved.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDIS_A {
    #[doc = "0: Not disabled"]
    NOT_DISABLED,
    #[doc = "1: Disabled. Setting to a 1 ensures that overruns/underruns of the latency FIFO are eliminated for low bandwidth systems where the RX and TX buffers are sufficient to contain the entire packet. Enabling stream disable also has the effect of ensuring the the TX latency is filled to capacity before the packet is launched onto the USB. Note: Time duration to pre-fill the FIFO becomes significant when stream disable is active. See TXFILLTUNING to characterize the adjustments needed for the scheduler when using this feature."]
    DISABLED_SETTING_TO,
}
impl From<SDIS_A> for bool {
    #[inline(always)]
    fn from(variant: SDIS_A) -> Self {
        match variant {
            SDIS_A::NOT_DISABLED => false,
            SDIS_A::DISABLED_SETTING_TO => true,
        }
    }
}
#[doc = "Reader of field `SDIS`"]
pub type SDIS_R = crate::R<bool, SDIS_A>;
impl SDIS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SDIS_A {
        match self.bits {
            false => SDIS_A::NOT_DISABLED,
            true => SDIS_A::DISABLED_SETTING_TO,
        }
    }
    #[doc = "Checks if the value of the field is `NOT_DISABLED`"]
    #[inline(always)]
    pub fn is_not_disabled(&self) -> bool {
        *self == SDIS_A::NOT_DISABLED
    }
    #[doc = "Checks if the value of the field is `DISABLED_SETTING_TO`"]
    #[inline(always)]
    pub fn is_disabled_setting_to(&self) -> bool {
        *self == SDIS_A::DISABLED_SETTING_TO
    }
}
#[doc = "Write proxy for field `SDIS`"]
pub struct SDIS_W<'a> {
    w: &'a mut W,
}
impl<'a> SDIS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SDIS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Not disabled"]
    #[inline(always)]
    pub fn not_disabled(self) -> &'a mut W {
        self.variant(SDIS_A::NOT_DISABLED)
    }
    #[doc = "Disabled. Setting to a 1 ensures that overruns/underruns of the latency FIFO are eliminated for low bandwidth systems where the RX and TX buffers are sufficient to contain the entire packet. Enabling stream disable also has the effect of ensuring the the TX latency is filled to capacity before the packet is launched onto the USB. Note: Time duration to pre-fill the FIFO becomes significant when stream disable is active. See TXFILLTUNING to characterize the adjustments needed for the scheduler when using this feature."]
    #[inline(always)]
    pub fn disabled_setting_to(self) -> &'a mut W {
        self.variant(SDIS_A::DISABLED_SETTING_TO)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | (((value as u32) & 0x01) << 4);
        self.w
    }
}
#[doc = "VBUS power select\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum VBPS_A {
    #[doc = "0: vbus_pwr_select is set LOW."]
    LOW,
    #[doc = "1: vbus_pwr_select is set HIGH"]
    HIGH,
}
impl From<VBPS_A> for bool {
    #[inline(always)]
    fn from(variant: VBPS_A) -> Self {
        match variant {
            VBPS_A::LOW => false,
            VBPS_A::HIGH => true,
        }
    }
}
#[doc = "Reader of field `VBPS`"]
pub type VBPS_R = crate::R<bool, VBPS_A>;
impl VBPS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> VBPS_A {
        match self.bits {
            false => VBPS_A::LOW,
            true => VBPS_A::HIGH,
        }
    }
    #[doc = "Checks if the value of the field is `LOW`"]
    #[inline(always)]
    pub fn is_low(&self) -> bool {
        *self == VBPS_A::LOW
    }
    #[doc = "Checks if the value of the field is `HIGH`"]
    #[inline(always)]
    pub fn is_high(&self) -> bool {
        *self == VBPS_A::HIGH
    }
}
#[doc = "Write proxy for field `VBPS`"]
pub struct VBPS_W<'a> {
    w: &'a mut W,
}
impl<'a> VBPS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: VBPS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "vbus_pwr_select is set LOW."]
    #[inline(always)]
    pub fn low(self) -> &'a mut W {
        self.variant(VBPS_A::LOW)
    }
    #[doc = "vbus_pwr_select is set HIGH"]
    #[inline(always)]
    pub fn high(self) -> &'a mut W {
        self.variant(VBPS_A::HIGH)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - Controller mode The controller defaults to an idle state and needs to be initialized to the desired operating mode after reset. This register can only be written once after reset. If it is necessary to switch modes, software must reset the controller by writing to the RESET bit in the USBCMD register before reprogramming this register."]
    #[inline(always)]
    pub fn cm1_0(&self) -> CM1_0_R {
        CM1_0_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bit 2 - Endian select This bit can change the byte ordering of the transfer buffers. The bit fields in the microprocessor interface and the DMA data structures (including the setup buffer within the device QH) are unaffected by the value of this bit, because they are based upon 32-bit words."]
    #[inline(always)]
    pub fn es(&self) -> ES_R {
        ES_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Stream disable mode The use of this feature substantially limits the overall USB performance that can be achieved."]
    #[inline(always)]
    pub fn sdis(&self) -> SDIS_R {
        SDIS_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - VBUS power select"]
    #[inline(always)]
    pub fn vbps(&self) -> VBPS_R {
        VBPS_R::new(((self.bits >> 5) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:1 - Controller mode The controller defaults to an idle state and needs to be initialized to the desired operating mode after reset. This register can only be written once after reset. If it is necessary to switch modes, software must reset the controller by writing to the RESET bit in the USBCMD register before reprogramming this register."]
    #[inline(always)]
    pub fn cm1_0(&mut self) -> CM1_0_W {
        CM1_0_W { w: self }
    }
    #[doc = "Bit 2 - Endian select This bit can change the byte ordering of the transfer buffers. The bit fields in the microprocessor interface and the DMA data structures (including the setup buffer within the device QH) are unaffected by the value of this bit, because they are based upon 32-bit words."]
    #[inline(always)]
    pub fn es(&mut self) -> ES_W {
        ES_W { w: self }
    }
    #[doc = "Bit 4 - Stream disable mode The use of this feature substantially limits the overall USB performance that can be achieved."]
    #[inline(always)]
    pub fn sdis(&mut self) -> SDIS_W {
        SDIS_W { w: self }
    }
    #[doc = "Bit 5 - VBUS power select"]
    #[inline(always)]
    pub fn vbps(&mut self) -> VBPS_W {
        VBPS_W { w: self }
    }
}
