#[doc = "Reader of register USBSTS_H"]
pub type R = crate::R<u32, super::USBSTS_H>;
#[doc = "Writer for register USBSTS_H"]
pub type W = crate::W<u32, super::USBSTS_H>;
#[doc = "Register USBSTS_H `reset()`'s with value 0x1000"]
impl crate::ResetValue for super::USBSTS_H {
    type Type = u32;
    #[inline(always)]
    fn reset_value() -> Self::Type {
        0x1000
    }
}
#[doc = "USB interrupt (USBINT)\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: This bit is set by the Host/Device Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit is also set by the Host/Device Controller when a short packet is detected. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    CLEAR,
}
impl From<UI_A> for bool {
    #[inline(always)]
    fn from(variant: UI_A) -> Self {
        match variant {
            UI_A::ST => false,
            UI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `UI`"]
pub type UI_R = crate::R<bool, UI_A>;
impl UI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UI_A {
        match self.bits {
            false => UI_A::ST,
            true => UI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == UI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == UI_A::CLEAR
    }
}
#[doc = "Write proxy for field `UI`"]
pub struct UI_W<'a> {
    w: &'a mut W,
}
impl<'a> UI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(UI_A::ST)
    }
    #[doc = "This bit is set by the Host/Device Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set. This bit is also set by the Host/Device Controller when a short packet is detected. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(UI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | ((value as u32) & 0x01);
        self.w
    }
}
#[doc = "USB error interrupt (USBERRINT)\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UEI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: When completion of a USB transaction results in an error condition, this bit is set by the Host/Device Controller. This bit is set along with the USBINT bit, if the TD on which the error interrupt occurred also had its interrupt on complete (IOC) bit set."]
    CLEAR,
}
impl From<UEI_A> for bool {
    #[inline(always)]
    fn from(variant: UEI_A) -> Self {
        match variant {
            UEI_A::ST => false,
            UEI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `UEI`"]
pub type UEI_R = crate::R<bool, UEI_A>;
impl UEI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UEI_A {
        match self.bits {
            false => UEI_A::ST,
            true => UEI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == UEI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == UEI_A::CLEAR
    }
}
#[doc = "Write proxy for field `UEI`"]
pub struct UEI_W<'a> {
    w: &'a mut W,
}
impl<'a> UEI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UEI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(UEI_A::ST)
    }
    #[doc = "When completion of a USB transaction results in an error condition, this bit is set by the Host/Device Controller. This bit is set along with the USBINT bit, if the TD on which the error interrupt occurred also had its interrupt on complete (IOC) bit set."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(UEI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | (((value as u32) & 0x01) << 1);
        self.w
    }
}
#[doc = "Port change detect.\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PCI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: The Host Controller sets this bit to a one when on any port a Connect Status occurs, a Port Enable/Disable Change occurs, or the Force Port Resume bit is set as the result of a J-K transition on the suspended port."]
    CLEAR,
}
impl From<PCI_A> for bool {
    #[inline(always)]
    fn from(variant: PCI_A) -> Self {
        match variant {
            PCI_A::ST => false,
            PCI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `PCI`"]
pub type PCI_R = crate::R<bool, PCI_A>;
impl PCI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PCI_A {
        match self.bits {
            false => PCI_A::ST,
            true => PCI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == PCI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == PCI_A::CLEAR
    }
}
#[doc = "Write proxy for field `PCI`"]
pub struct PCI_W<'a> {
    w: &'a mut W,
}
impl<'a> PCI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PCI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(PCI_A::ST)
    }
    #[doc = "The Host Controller sets this bit to a one when on any port a Connect Status occurs, a Port Enable/Disable Change occurs, or the Force Port Resume bit is set as the result of a J-K transition on the suspended port."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(PCI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | (((value as u32) & 0x01) << 2);
        self.w
    }
}
#[doc = "Frame list roll-over\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FRI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: The Host Controller sets this bit to a one when the Frame List Index rolls over from its maximum value to zero. The exact value at which the rollover occurs depends on the frame list size. For example, if the frame list size (as programmed in the Frame List Size field of the USBCMD register) is 1024, the Frame Index Register rolls over every time FRINDEX \\[13\\] toggles. Similarly, if the size is 512, the Host Controller sets this bit to a one every time FRINDEX bit 12 toggles (see Section 19.6.5)."]
    CLEAR,
}
impl From<FRI_A> for bool {
    #[inline(always)]
    fn from(variant: FRI_A) -> Self {
        match variant {
            FRI_A::ST => false,
            FRI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `FRI`"]
pub type FRI_R = crate::R<bool, FRI_A>;
impl FRI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FRI_A {
        match self.bits {
            false => FRI_A::ST,
            true => FRI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == FRI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == FRI_A::CLEAR
    }
}
#[doc = "Write proxy for field `FRI`"]
pub struct FRI_W<'a> {
    w: &'a mut W,
}
impl<'a> FRI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FRI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(FRI_A::ST)
    }
    #[doc = "The Host Controller sets this bit to a one when the Frame List Index rolls over from its maximum value to zero. The exact value at which the rollover occurs depends on the frame list size. For example, if the frame list size (as programmed in the Frame List Size field of the USBCMD register) is 1024, the Frame Index Register rolls over every time FRINDEX \\[13\\] toggles. Similarly, if the size is 512, the Host Controller sets this bit to a one every time FRINDEX bit 12 toggles (see Section 19.6.5)."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FRI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | (((value as u32) & 0x01) << 3);
        self.w
    }
}
#[doc = "Interrupt on async advance\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AAI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: System software can force the host controller to issue an interrupt the next time the host controller advances the asynchronous schedule by writing a one to the Interrupt on Async Advance Doorbell bit in the USBCMD register. This status bit indicates the assertion of that interrupt source."]
    CLEAR,
}
impl From<AAI_A> for bool {
    #[inline(always)]
    fn from(variant: AAI_A) -> Self {
        match variant {
            AAI_A::ST => false,
            AAI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `AAI`"]
pub type AAI_R = crate::R<bool, AAI_A>;
impl AAI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> AAI_A {
        match self.bits {
            false => AAI_A::ST,
            true => AAI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == AAI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == AAI_A::CLEAR
    }
}
#[doc = "Write proxy for field `AAI`"]
pub struct AAI_W<'a> {
    w: &'a mut W,
}
impl<'a> AAI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: AAI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(AAI_A::ST)
    }
    #[doc = "System software can force the host controller to issue an interrupt the next time the host controller advances the asynchronous schedule by writing a one to the Interrupt on Async Advance Doorbell bit in the USBCMD register. This status bit indicates the assertion of that interrupt source."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(AAI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | (((value as u32) & 0x01) << 5);
        self.w
    }
}
#[doc = "SOF received\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SRI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: In host mode, this bit will be set every 125 ms and can be used by host controller driver as a time base."]
    CLEAR,
}
impl From<SRI_A> for bool {
    #[inline(always)]
    fn from(variant: SRI_A) -> Self {
        match variant {
            SRI_A::ST => false,
            SRI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `SRI`"]
pub type SRI_R = crate::R<bool, SRI_A>;
impl SRI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> SRI_A {
        match self.bits {
            false => SRI_A::ST,
            true => SRI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == SRI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == SRI_A::CLEAR
    }
}
#[doc = "Write proxy for field `SRI`"]
pub struct SRI_W<'a> {
    w: &'a mut W,
}
impl<'a> SRI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: SRI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(SRI_A::ST)
    }
    #[doc = "In host mode, this bit will be set every 125 ms and can be used by host controller driver as a time base."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(SRI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | (((value as u32) & 0x01) << 7);
        self.w
    }
}
#[doc = "Reader of field `SLI`"]
pub type SLI_R = crate::R<bool, bool>;
#[doc = "Write proxy for field `SLI`"]
pub struct SLI_W<'a> {
    w: &'a mut W,
}
impl<'a> SLI_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | (((value as u32) & 0x01) << 8);
        self.w
    }
}
#[doc = "HCHalted\n\nValue on reset: 1"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum HCH_A {
    #[doc = "0: The RS bit in USBCMD is set to zero. Set by the host controller."]
    RS,
    #[doc = "1: The Host Controller sets this bit to one after it has stopped executing because of the Run/Stop bit being set to 0, either by software or by the Host Controller hardware (e.g. because of an internal error)."]
    STOP,
}
impl From<HCH_A> for bool {
    #[inline(always)]
    fn from(variant: HCH_A) -> Self {
        match variant {
            HCH_A::RS => false,
            HCH_A::STOP => true,
        }
    }
}
#[doc = "Reader of field `HCH`"]
pub type HCH_R = crate::R<bool, HCH_A>;
impl HCH_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> HCH_A {
        match self.bits {
            false => HCH_A::RS,
            true => HCH_A::STOP,
        }
    }
    #[doc = "Checks if the value of the field is `RS`"]
    #[inline(always)]
    pub fn is_rs(&self) -> bool {
        *self == HCH_A::RS
    }
    #[doc = "Checks if the value of the field is `STOP`"]
    #[inline(always)]
    pub fn is_stop(&self) -> bool {
        *self == HCH_A::STOP
    }
}
#[doc = "Write proxy for field `HCH`"]
pub struct HCH_W<'a> {
    w: &'a mut W,
}
impl<'a> HCH_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: HCH_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The RS bit in USBCMD is set to zero. Set by the host controller."]
    #[inline(always)]
    pub fn rs(self) -> &'a mut W {
        self.variant(HCH_A::RS)
    }
    #[doc = "The Host Controller sets this bit to one after it has stopped executing because of the Run/Stop bit being set to 0, either by software or by the Host Controller hardware (e.g. because of an internal error)."]
    #[inline(always)]
    pub fn stop(self) -> &'a mut W {
        self.variant(HCH_A::STOP)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | (((value as u32) & 0x01) << 12);
        self.w
    }
}
#[doc = "Reclamation\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum RCL_A {
    #[doc = "0: No empty asynchronous schedule detected."]
    NO_EMPTY_ASYNCHRONOUS_SCHEDULE,
    #[doc = "1: An empty asynchronous schedule is detected. Set by the host controller."]
    EMPTY_ASYNCHRONOUS_SCHEDULE,
}
impl From<RCL_A> for bool {
    #[inline(always)]
    fn from(variant: RCL_A) -> Self {
        match variant {
            RCL_A::NO_EMPTY_ASYNCHRONOUS_SCHEDULE => false,
            RCL_A::EMPTY_ASYNCHRONOUS_SCHEDULE => true,
        }
    }
}
#[doc = "Reader of field `RCL`"]
pub type RCL_R = crate::R<bool, RCL_A>;
impl RCL_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> RCL_A {
        match self.bits {
            false => RCL_A::NO_EMPTY_ASYNCHRONOUS_SCHEDULE,
            true => RCL_A::EMPTY_ASYNCHRONOUS_SCHEDULE,
        }
    }
    #[doc = "Checks if the value of the field is `NO_EMPTY_ASYNCHRONOUS_SCHEDULE`"]
    #[inline(always)]
    pub fn is_no_empty_asynchronous_schedule(&self) -> bool {
        *self == RCL_A::NO_EMPTY_ASYNCHRONOUS_SCHEDULE
    }
    #[doc = "Checks if the value of the field is `EMPTY_ASYNCHRONOUS_SCHEDULE`"]
    #[inline(always)]
    pub fn is_empty_asynchronous_schedule(&self) -> bool {
        *self == RCL_A::EMPTY_ASYNCHRONOUS_SCHEDULE
    }
}
#[doc = "Write proxy for field `RCL`"]
pub struct RCL_W<'a> {
    w: &'a mut W,
}
impl<'a> RCL_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: RCL_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "No empty asynchronous schedule detected."]
    #[inline(always)]
    pub fn no_empty_asynchronous_schedule(self) -> &'a mut W {
        self.variant(RCL_A::NO_EMPTY_ASYNCHRONOUS_SCHEDULE)
    }
    #[doc = "An empty asynchronous schedule is detected. Set by the host controller."]
    #[inline(always)]
    pub fn empty_asynchronous_schedule(self) -> &'a mut W {
        self.variant(RCL_A::EMPTY_ASYNCHRONOUS_SCHEDULE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | (((value as u32) & 0x01) << 13);
        self.w
    }
}
#[doc = "Periodic schedule status This bit reports the current real status of the Periodic Schedule. The Host Controller is not required to immediately disable or enable the Periodic Schedule when software transitions the Periodic Schedule Enable bit in the USBCMD register. When this bit and the Periodic Schedule Enable bit are the same value, the Periodic Schedule is either enabled (if both are 1) or disabled (if both are 0).\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PS_A {
    #[doc = "0: The periodic schedule status is disabled."]
    DISABLED,
    #[doc = "1: The periodic schedule status is enabled."]
    ENABLED,
}
impl From<PS_A> for bool {
    #[inline(always)]
    fn from(variant: PS_A) -> Self {
        match variant {
            PS_A::DISABLED => false,
            PS_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `PS`"]
pub type PS_R = crate::R<bool, PS_A>;
impl PS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PS_A {
        match self.bits {
            false => PS_A::DISABLED,
            true => PS_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == PS_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == PS_A::ENABLED
    }
}
#[doc = "Write proxy for field `PS`"]
pub struct PS_W<'a> {
    w: &'a mut W,
}
impl<'a> PS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "The periodic schedule status is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(PS_A::DISABLED)
    }
    #[doc = "The periodic schedule status is enabled."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(PS_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | (((value as u32) & 0x01) << 14);
        self.w
    }
}
#[doc = "Asynchronous schedule status This bit reports the current real status of the Asynchronous Schedule. The Host Controller is not required to immediately disable or enable the Asynchronous Schedule when software transitions the Asynchronous Schedule Enable bit in the USBCMD register. When this bit and the Asynchronous Schedule Enable bit are the same value, the Asynchronous Schedule is either enabled (if both are 1) or disabled (if both are 0).\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum AS_A {
    #[doc = "0: Asynchronous schedule status is disabled."]
    DISABLED,
    #[doc = "1: Asynchronous schedule status is enabled."]
    ENABLED,
}
impl From<AS_A> for bool {
    #[inline(always)]
    fn from(variant: AS_A) -> Self {
        match variant {
            AS_A::DISABLED => false,
            AS_A::ENABLED => true,
        }
    }
}
#[doc = "Reader of field `AS`"]
pub type AS_R = crate::R<bool, AS_A>;
impl AS_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> AS_A {
        match self.bits {
            false => AS_A::DISABLED,
            true => AS_A::ENABLED,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLED`"]
    #[inline(always)]
    pub fn is_disabled(&self) -> bool {
        *self == AS_A::DISABLED
    }
    #[doc = "Checks if the value of the field is `ENABLED`"]
    #[inline(always)]
    pub fn is_enabled(&self) -> bool {
        *self == AS_A::ENABLED
    }
}
#[doc = "Write proxy for field `AS`"]
pub struct AS_W<'a> {
    w: &'a mut W,
}
impl<'a> AS_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: AS_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "Asynchronous schedule status is disabled."]
    #[inline(always)]
    pub fn disabled(self) -> &'a mut W {
        self.variant(AS_A::DISABLED)
    }
    #[doc = "Asynchronous schedule status is enabled."]
    #[inline(always)]
    pub fn enabled(self) -> &'a mut W {
        self.variant(AS_A::ENABLED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | (((value as u32) & 0x01) << 15);
        self.w
    }
}
#[doc = "USB host asynchronous interrupt (USBHSTASYNCINT)\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UAI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: This bit is set by the Host Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set and the TD was from the asynchronous schedule. This bit is also set by the Host when a short packet is detected and the packet is on the asynchronous schedule. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    CLEAR,
}
impl From<UAI_A> for bool {
    #[inline(always)]
    fn from(variant: UAI_A) -> Self {
        match variant {
            UAI_A::ST => false,
            UAI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `UAI`"]
pub type UAI_R = crate::R<bool, UAI_A>;
impl UAI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UAI_A {
        match self.bits {
            false => UAI_A::ST,
            true => UAI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == UAI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == UAI_A::CLEAR
    }
}
#[doc = "Write proxy for field `UAI`"]
pub struct UAI_W<'a> {
    w: &'a mut W,
}
impl<'a> UAI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UAI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(UAI_A::ST)
    }
    #[doc = "This bit is set by the Host Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set and the TD was from the asynchronous schedule. This bit is also set by the Host when a short packet is detected and the packet is on the asynchronous schedule. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(UAI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 18)) | (((value as u32) & 0x01) << 18);
        self.w
    }
}
#[doc = "USB host periodic interrupt (USBHSTPERINT)\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum UPI_A {
    #[doc = "0: This bit is cleared by software writing a one to it."]
    ST,
    #[doc = "1: This bit is set by the Host Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set and the TD was from the periodic schedule. This bit is also set by the Host Controller when a short packet is detected and the packet is on the periodic schedule. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    CLEAR,
}
impl From<UPI_A> for bool {
    #[inline(always)]
    fn from(variant: UPI_A) -> Self {
        match variant {
            UPI_A::ST => false,
            UPI_A::CLEAR => true,
        }
    }
}
#[doc = "Reader of field `UPI`"]
pub type UPI_R = crate::R<bool, UPI_A>;
impl UPI_R {
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> UPI_A {
        match self.bits {
            false => UPI_A::ST,
            true => UPI_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `ST`"]
    #[inline(always)]
    pub fn is_st(&self) -> bool {
        *self == UPI_A::ST
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        *self == UPI_A::CLEAR
    }
}
#[doc = "Write proxy for field `UPI`"]
pub struct UPI_W<'a> {
    w: &'a mut W,
}
impl<'a> UPI_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: UPI_A) -> &'a mut W {
        {
            self.bit(variant.into())
        }
    }
    #[doc = "This bit is cleared by software writing a one to it."]
    #[inline(always)]
    pub fn st(self) -> &'a mut W {
        self.variant(UPI_A::ST)
    }
    #[doc = "This bit is set by the Host Controller when the cause of an interrupt is a completion of a USB transaction where the Transfer Descriptor (TD) has an interrupt on complete (IOC) bit set and the TD was from the periodic schedule. This bit is also set by the Host Controller when a short packet is detected and the packet is on the periodic schedule. A short packet is when the actual number of bytes received was less than the expected number of bytes."]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(UPI_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 19)) | (((value as u32) & 0x01) << 19);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - USB interrupt (USBINT)"]
    #[inline(always)]
    pub fn ui(&self) -> UI_R {
        UI_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - USB error interrupt (USBERRINT)"]
    #[inline(always)]
    pub fn uei(&self) -> UEI_R {
        UEI_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Port change detect."]
    #[inline(always)]
    pub fn pci(&self) -> PCI_R {
        PCI_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - Frame list roll-over"]
    #[inline(always)]
    pub fn fri(&self) -> FRI_R {
        FRI_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Interrupt on async advance"]
    #[inline(always)]
    pub fn aai(&self) -> AAI_R {
        AAI_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 7 - SOF received"]
    #[inline(always)]
    pub fn sri(&self) -> SRI_R {
        SRI_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Not used by the Host controller."]
    #[inline(always)]
    pub fn sli(&self) -> SLI_R {
        SLI_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 12 - HCHalted"]
    #[inline(always)]
    pub fn hch(&self) -> HCH_R {
        HCH_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Reclamation"]
    #[inline(always)]
    pub fn rcl(&self) -> RCL_R {
        RCL_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Periodic schedule status This bit reports the current real status of the Periodic Schedule. The Host Controller is not required to immediately disable or enable the Periodic Schedule when software transitions the Periodic Schedule Enable bit in the USBCMD register. When this bit and the Periodic Schedule Enable bit are the same value, the Periodic Schedule is either enabled (if both are 1) or disabled (if both are 0)."]
    #[inline(always)]
    pub fn ps(&self) -> PS_R {
        PS_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - Asynchronous schedule status This bit reports the current real status of the Asynchronous Schedule. The Host Controller is not required to immediately disable or enable the Asynchronous Schedule when software transitions the Asynchronous Schedule Enable bit in the USBCMD register. When this bit and the Asynchronous Schedule Enable bit are the same value, the Asynchronous Schedule is either enabled (if both are 1) or disabled (if both are 0)."]
    #[inline(always)]
    pub fn as_(&self) -> AS_R {
        AS_R::new(((self.bits >> 15) & 0x01) != 0)
    }
    #[doc = "Bit 18 - USB host asynchronous interrupt (USBHSTASYNCINT)"]
    #[inline(always)]
    pub fn uai(&self) -> UAI_R {
        UAI_R::new(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - USB host periodic interrupt (USBHSTPERINT)"]
    #[inline(always)]
    pub fn upi(&self) -> UPI_R {
        UPI_R::new(((self.bits >> 19) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - USB interrupt (USBINT)"]
    #[inline(always)]
    pub fn ui(&mut self) -> UI_W {
        UI_W { w: self }
    }
    #[doc = "Bit 1 - USB error interrupt (USBERRINT)"]
    #[inline(always)]
    pub fn uei(&mut self) -> UEI_W {
        UEI_W { w: self }
    }
    #[doc = "Bit 2 - Port change detect."]
    #[inline(always)]
    pub fn pci(&mut self) -> PCI_W {
        PCI_W { w: self }
    }
    #[doc = "Bit 3 - Frame list roll-over"]
    #[inline(always)]
    pub fn fri(&mut self) -> FRI_W {
        FRI_W { w: self }
    }
    #[doc = "Bit 5 - Interrupt on async advance"]
    #[inline(always)]
    pub fn aai(&mut self) -> AAI_W {
        AAI_W { w: self }
    }
    #[doc = "Bit 7 - SOF received"]
    #[inline(always)]
    pub fn sri(&mut self) -> SRI_W {
        SRI_W { w: self }
    }
    #[doc = "Bit 8 - Not used by the Host controller."]
    #[inline(always)]
    pub fn sli(&mut self) -> SLI_W {
        SLI_W { w: self }
    }
    #[doc = "Bit 12 - HCHalted"]
    #[inline(always)]
    pub fn hch(&mut self) -> HCH_W {
        HCH_W { w: self }
    }
    #[doc = "Bit 13 - Reclamation"]
    #[inline(always)]
    pub fn rcl(&mut self) -> RCL_W {
        RCL_W { w: self }
    }
    #[doc = "Bit 14 - Periodic schedule status This bit reports the current real status of the Periodic Schedule. The Host Controller is not required to immediately disable or enable the Periodic Schedule when software transitions the Periodic Schedule Enable bit in the USBCMD register. When this bit and the Periodic Schedule Enable bit are the same value, the Periodic Schedule is either enabled (if both are 1) or disabled (if both are 0)."]
    #[inline(always)]
    pub fn ps(&mut self) -> PS_W {
        PS_W { w: self }
    }
    #[doc = "Bit 15 - Asynchronous schedule status This bit reports the current real status of the Asynchronous Schedule. The Host Controller is not required to immediately disable or enable the Asynchronous Schedule when software transitions the Asynchronous Schedule Enable bit in the USBCMD register. When this bit and the Asynchronous Schedule Enable bit are the same value, the Asynchronous Schedule is either enabled (if both are 1) or disabled (if both are 0)."]
    #[inline(always)]
    pub fn as_(&mut self) -> AS_W {
        AS_W { w: self }
    }
    #[doc = "Bit 18 - USB host asynchronous interrupt (USBHSTASYNCINT)"]
    #[inline(always)]
    pub fn uai(&mut self) -> UAI_W {
        UAI_W { w: self }
    }
    #[doc = "Bit 19 - USB host periodic interrupt (USBHSTPERINT)"]
    #[inline(always)]
    pub fn upi(&mut self) -> UPI_W {
        UPI_W { w: self }
    }
}
