#[doc = r"Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - Pin configuration register for a normal-drive pin"]
    pub sfsp0_0: SFSP0_0,
    #[doc = "0x04 - Pin configuration register for a normal-drive pin"]
    pub sfsp0_1: SFSP0_1,
    _reserved2: [u8; 120usize],
    #[doc = "0x80 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_0: SFSP1_0,
    #[doc = "0x84 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_1: SFSP1_1,
    #[doc = "0x88 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_2: SFSP1_2,
    #[doc = "0x8c - Pin configuration register for a normal-drive pin"]
    pub sfsp1_3: SFSP1_3,
    #[doc = "0x90 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_4: SFSP1_4,
    #[doc = "0x94 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_5: SFSP1_5,
    #[doc = "0x98 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_6: SFSP1_6,
    #[doc = "0x9c - Pin configuration register for a normal-drive pin"]
    pub sfsp1_7: SFSP1_7,
    #[doc = "0xa0 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_8: SFSP1_8,
    #[doc = "0xa4 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_9: SFSP1_9,
    #[doc = "0xa8 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_10: SFSP1_10,
    #[doc = "0xac - Pin configuration register for a normal-drive pin"]
    pub sfsp1_11: SFSP1_11,
    #[doc = "0xb0 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_12: SFSP1_12,
    #[doc = "0xb4 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_13: SFSP1_13,
    #[doc = "0xb8 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_14: SFSP1_14,
    #[doc = "0xbc - Pin configuration register for a normal-drive pin"]
    pub sfsp1_15: SFSP1_15,
    #[doc = "0xc0 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_16: SFSP1_16,
    #[doc = "0xc4 - Pin configuration register for a high-drive pin"]
    pub sfsp1_17: SFSP1_17,
    #[doc = "0xc8 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_18: SFSP1_18,
    #[doc = "0xcc - Pin configuration register for a normal-drive pin"]
    pub sfsp1_19: SFSP1_19,
    #[doc = "0xd0 - Pin configuration register for a normal-drive pin"]
    pub sfsp1_20: SFSP1_20,
    _reserved23: [u8; 44usize],
    #[doc = "0x100 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_0: SFSP2_0,
    #[doc = "0x104 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_1: SFSP2_1,
    #[doc = "0x108 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_2: SFSP2_2,
    #[doc = "0x10c - Pin configuration register for a high-drive pin"]
    pub sfsp2_3: SFSP2_3,
    #[doc = "0x110 - Pin configuration register for a high-drive pin"]
    pub sfsp2_4: SFSP2_4,
    #[doc = "0x114 - Pin configuration register for a high-drive pin"]
    pub sfsp2_5: SFSP2_5,
    #[doc = "0x118 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_6: SFSP2_6,
    #[doc = "0x11c - Pin configuration register for a normal-drive pin"]
    pub sfsp2_7: SFSP2_7,
    #[doc = "0x120 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_8: SFSP2_8,
    #[doc = "0x124 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_9: SFSP2_9,
    #[doc = "0x128 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_10: SFSP2_10,
    #[doc = "0x12c - Pin configuration register for a normal-drive pin"]
    pub sfsp2_11: SFSP2_11,
    #[doc = "0x130 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_12: SFSP2_12,
    #[doc = "0x134 - Pin configuration register for a normal-drive pin"]
    pub sfsp2_13: SFSP2_13,
    _reserved37: [u8; 72usize],
    #[doc = "0x180 - Pin configuration register for a normal-drive pin"]
    pub sfsp3_0: SFSP3_0,
    #[doc = "0x184 - Pin configuration register for a normal-drive pin"]
    pub sfsp3_1: SFSP3_1,
    #[doc = "0x188 - Pin configuration register for a normal-drive pin"]
    pub sfsp3_2: SFSP3_2,
    #[doc = "0x18c - Pin configuration register for a high-speed pin"]
    pub sfsp3_3: SFSP3_3,
    #[doc = "0x190 - Pin configuration register for a normal-drive pin"]
    pub sfsp3_4: SFSP3_4,
    #[doc = "0x194 - Pin configuration register for a normal-drive pin"]
    pub sfsp3_5: SFSP3_5,
    #[doc = "0x198 - Pin configuration register for a normal-drive pin"]
    pub sfsp3_6: SFSP3_6,
    #[doc = "0x19c - Pin configuration register for a normal-drive pin"]
    pub sfsp3_7: SFSP3_7,
    #[doc = "0x1a0 - Pin configuration register for a normal-drive pin"]
    pub sfsp3_8: SFSP3_8,
    _reserved46: [u8; 92usize],
    #[doc = "0x200 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_0: SFSP4_0,
    #[doc = "0x204 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_1: SFSP4_1,
    #[doc = "0x208 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_2: SFSP4_2,
    #[doc = "0x20c - Pin configuration register for a normal-drive pin"]
    pub sfsp4_3: SFSP4_3,
    #[doc = "0x210 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_4: SFSP4_4,
    #[doc = "0x214 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_5: SFSP4_5,
    #[doc = "0x218 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_6: SFSP4_6,
    #[doc = "0x21c - Pin configuration register for a normal-drive pin"]
    pub sfsp4_7: SFSP4_7,
    #[doc = "0x220 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_8: SFSP4_8,
    #[doc = "0x224 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_9: SFSP4_9,
    #[doc = "0x228 - Pin configuration register for a normal-drive pin"]
    pub sfsp4_10: SFSP4_10,
    _reserved57: [u8; 84usize],
    #[doc = "0x280 - Pin configuration register for a normal-drive pin"]
    pub sfsp5_0: SFSP5_0,
    #[doc = "0x284 - Pin configuration register for a normal-drive pin"]
    pub sfsp5_1: SFSP5_1,
    #[doc = "0x288 - Pin configuration register for a normal-drive pin"]
    pub sfsp5_2: SFSP5_2,
    #[doc = "0x28c - Pin configuration register for a normal-drive pin"]
    pub sfsp5_3: SFSP5_3,
    #[doc = "0x290 - Pin configuration register for a normal-drive pin"]
    pub sfsp5_4: SFSP5_4,
    #[doc = "0x294 - Pin configuration register for a normal-drive pin"]
    pub sfsp5_5: SFSP5_5,
    #[doc = "0x298 - Pin configuration register for a normal-drive pin"]
    pub sfsp5_6: SFSP5_6,
    #[doc = "0x29c - Pin configuration register for a normal-drive pin"]
    pub sfsp5_7: SFSP5_7,
    _reserved65: [u8; 96usize],
    #[doc = "0x300 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_0: SFSP6_0,
    #[doc = "0x304 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_1: SFSP6_1,
    #[doc = "0x308 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_2: SFSP6_2,
    #[doc = "0x30c - Pin configuration register for a normal-drive pin"]
    pub sfsp6_3: SFSP6_3,
    #[doc = "0x310 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_4: SFSP6_4,
    #[doc = "0x314 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_5: SFSP6_5,
    #[doc = "0x318 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_6: SFSP6_6,
    #[doc = "0x31c - Pin configuration register for a normal-drive pin"]
    pub sfsp6_7: SFSP6_7,
    #[doc = "0x320 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_8: SFSP6_8,
    #[doc = "0x324 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_9: SFSP6_9,
    #[doc = "0x328 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_10: SFSP6_10,
    #[doc = "0x32c - Pin configuration register for a normal-drive pin"]
    pub sfsp6_11: SFSP6_11,
    #[doc = "0x330 - Pin configuration register for a normal-drive pin"]
    pub sfsp6_12: SFSP6_12,
    _reserved78: [u8; 76usize],
    #[doc = "0x380 - Pin configuration register for a normal-drive pin"]
    pub sfsp7_0: SFSP7_0,
    #[doc = "0x384 - Pin configuration register for a normal-drive pin"]
    pub sfsp7_1: SFSP7_1,
    #[doc = "0x388 - Pin configuration register for a normal-drive pin"]
    pub sfsp7_2: SFSP7_2,
    #[doc = "0x38c - Pin configuration register for a normal-drive pin"]
    pub sfsp7_3: SFSP7_3,
    #[doc = "0x390 - Pin configuration register for a normal-drive pin"]
    pub sfsp7_4: SFSP7_4,
    #[doc = "0x394 - Pin configuration register for a normal-drive pin"]
    pub sfsp7_5: SFSP7_5,
    #[doc = "0x398 - Pin configuration register for a normal-drive pin"]
    pub sfsp7_6: SFSP7_6,
    #[doc = "0x39c - Pin configuration register for a normal-drive pin"]
    pub sfsp7_7: SFSP7_7,
    _reserved86: [u8; 96usize],
    #[doc = "0x400 - Pin configuration register for a normal-drive pin"]
    pub sfsp8_0: SFSP8_0,
    #[doc = "0x404 - Pin configuration register for a normal-drive pin"]
    pub sfsp8_1: SFSP8_1,
    #[doc = "0x408 - Pin configuration register for a normal-drive pin"]
    pub sfsp8_2: SFSP8_2,
    #[doc = "0x40c - Pin configuration register for a normal-drive pin"]
    pub sfsp8_3: SFSP8_3,
    #[doc = "0x410 - Pin configuration register for a normal-drive pin"]
    pub sfsp8_4: SFSP8_4,
    #[doc = "0x414 - Pin configuration register for a normal-drive pin"]
    pub sfsp8_5: SFSP8_5,
    #[doc = "0x418 - Pin configuration register for a normal-drive pin"]
    pub sfsp8_6: SFSP8_6,
    #[doc = "0x41c - Pin configuration register for a normal-drive pin"]
    pub sfsp8_7: SFSP8_7,
    #[doc = "0x420 - Pin configuration register for a normal-drive pin"]
    pub sfsp8_8: SFSP8_8,
    _reserved95: [u8; 92usize],
    #[doc = "0x480 - Pin configuration register for a normal-drive pin"]
    pub sfsp9_0: SFSP9_0,
    #[doc = "0x484 - Pin configuration register for a normal-drive pin"]
    pub sfsp9_1: SFSP9_1,
    #[doc = "0x488 - Pin configuration register for a normal-drive pin"]
    pub sfsp9_2: SFSP9_2,
    #[doc = "0x48c - Pin configuration register for a normal-drive pin"]
    pub sfsp9_3: SFSP9_3,
    #[doc = "0x490 - Pin configuration register for a normal-drive pin"]
    pub sfsp9_4: SFSP9_4,
    #[doc = "0x494 - Pin configuration register for a normal-drive pin"]
    pub sfsp9_5: SFSP9_5,
    #[doc = "0x498 - Pin configuration register for a normal-drive pin"]
    pub sfsp9_6: SFSP9_6,
    _reserved102: [u8; 100usize],
    #[doc = "0x500 - Pin configuration register for a normal-drive pin"]
    pub sfspa_0: SFSPA_0,
    #[doc = "0x504 - Pin configuration register for a high-drive pin"]
    pub sfspa_1: SFSPA_1,
    #[doc = "0x508 - Pin configuration register for a high-drive pin"]
    pub sfspa_2: SFSPA_2,
    #[doc = "0x50c - Pin configuration register for a high-drive pin"]
    pub sfspa_3: SFSPA_3,
    #[doc = "0x510 - Pin configuration register for a normal-drive pin"]
    pub sfspa_4: SFSPA_4,
    _reserved107: [u8; 108usize],
    #[doc = "0x580 - Pin configuration register for a normal-drive pin"]
    pub sfspb_0: SFSPB_0,
    #[doc = "0x584 - Pin configuration register for a normal-drive pin"]
    pub sfspb_1: SFSPB_1,
    #[doc = "0x588 - Pin configuration register for a normal-drive pin"]
    pub sfspb_2: SFSPB_2,
    #[doc = "0x58c - Pin configuration register for a normal-drive pin"]
    pub sfspb_3: SFSPB_3,
    #[doc = "0x590 - Pin configuration register for a normal-drive pin"]
    pub sfspb_4: SFSPB_4,
    #[doc = "0x594 - Pin configuration register for a normal-drive pin"]
    pub sfspb_5: SFSPB_5,
    #[doc = "0x598 - Pin configuration register for a normal-drive pin"]
    pub sfspb_6: SFSPB_6,
    _reserved114: [u8; 100usize],
    #[doc = "0x600 - Pin configuration register for a normal-drive pin"]
    pub sfspc_0: SFSPC_0,
    #[doc = "0x604 - Pin configuration register for a normal-drive pin"]
    pub sfspc_1: SFSPC_1,
    #[doc = "0x608 - Pin configuration register for a normal-drive pin"]
    pub sfspc_2: SFSPC_2,
    #[doc = "0x60c - Pin configuration register for a normal-drive pin"]
    pub sfspc_3: SFSPC_3,
    #[doc = "0x610 - Pin configuration register for a normal-drive pin"]
    pub sfspc_4: SFSPC_4,
    #[doc = "0x614 - Pin configuration register for a normal-drive pin"]
    pub sfspc_5: SFSPC_5,
    #[doc = "0x618 - Pin configuration register for a normal-drive pin"]
    pub sfspc_6: SFSPC_6,
    #[doc = "0x61c - Pin configuration register for a normal-drive pin"]
    pub sfspc_7: SFSPC_7,
    #[doc = "0x620 - Pin configuration register for a normal-drive pin"]
    pub sfspc_8: SFSPC_8,
    #[doc = "0x624 - Pin configuration register for a normal-drive pin"]
    pub sfspc_9: SFSPC_9,
    #[doc = "0x628 - Pin configuration register for a normal-drive pin"]
    pub sfspc_10: SFSPC_10,
    #[doc = "0x62c - Pin configuration register for a normal-drive pin"]
    pub sfspc_11: SFSPC_11,
    #[doc = "0x630 - Pin configuration register for a normal-drive pin"]
    pub sfspc_12: SFSPC_12,
    #[doc = "0x634 - Pin configuration register for a normal-drive pin"]
    pub sfspc_13: SFSPC_13,
    #[doc = "0x638 - Pin configuration register for a normal-drive pin"]
    pub sfspc_14: SFSPC_14,
    _reserved129: [u8; 68usize],
    #[doc = "0x680 - Pin configuration register for a normal-drive pin"]
    pub sfspd_0: SFSPD_0,
    #[doc = "0x684 - Pin configuration register for a normal-drive pin"]
    pub sfspd_1: SFSPD_1,
    #[doc = "0x688 - Pin configuration register for a normal-drive pin"]
    pub sfspd_2: SFSPD_2,
    #[doc = "0x68c - Pin configuration register for a normal-drive pin"]
    pub sfspd_3: SFSPD_3,
    #[doc = "0x690 - Pin configuration register for a normal-drive pin"]
    pub sfspd_4: SFSPD_4,
    #[doc = "0x694 - Pin configuration register for a normal-drive pin"]
    pub sfspd_5: SFSPD_5,
    #[doc = "0x698 - Pin configuration register for a normal-drive pin"]
    pub sfspd_6: SFSPD_6,
    #[doc = "0x69c - Pin configuration register for a normal-drive pin"]
    pub sfspd_7: SFSPD_7,
    #[doc = "0x6a0 - Pin configuration register for a normal-drive pin"]
    pub sfspd_8: SFSPD_8,
    #[doc = "0x6a4 - Pin configuration register for a normal-drive pin"]
    pub sfspd_9: SFSPD_9,
    #[doc = "0x6a8 - Pin configuration register for a normal-drive pin"]
    pub sfspd_10: SFSPD_10,
    #[doc = "0x6ac - Pin configuration register for a normal-drive pin"]
    pub sfspd_11: SFSPD_11,
    #[doc = "0x6b0 - Pin configuration register for a normal-drive pin"]
    pub sfspd_12: SFSPD_12,
    #[doc = "0x6b4 - Pin configuration register for a normal-drive pin"]
    pub sfspd_13: SFSPD_13,
    #[doc = "0x6b8 - Pin configuration register for a normal-drive pin"]
    pub sfspd_14: SFSPD_14,
    #[doc = "0x6bc - Pin configuration register for a normal-drive pin"]
    pub sfspd_15: SFSPD_15,
    #[doc = "0x6c0 - Pin configuration register for a normal-drive pin"]
    pub sfspd_16: SFSPD_16,
    _reserved146: [u8; 60usize],
    #[doc = "0x700 - Pin configuration register for a normal-drive pin"]
    pub sfspe_0: SFSPE_0,
    #[doc = "0x704 - Pin configuration register for a normal-drive pin"]
    pub sfspe_1: SFSPE_1,
    #[doc = "0x708 - Pin configuration register for a normal-drive pin"]
    pub sfspe_2: SFSPE_2,
    #[doc = "0x70c - Pin configuration register for a normal-drive pin"]
    pub sfspe_3: SFSPE_3,
    #[doc = "0x710 - Pin configuration register for a normal-drive pin"]
    pub sfspe_4: SFSPE_4,
    #[doc = "0x714 - Pin configuration register for a normal-drive pin"]
    pub sfspe_5: SFSPE_5,
    #[doc = "0x718 - Pin configuration register for a normal-drive pin"]
    pub sfspe_6: SFSPE_6,
    #[doc = "0x71c - Pin configuration register for a normal-drive pin"]
    pub sfspe_7: SFSPE_7,
    #[doc = "0x720 - Pin configuration register for a normal-drive pin"]
    pub sfspe_8: SFSPE_8,
    #[doc = "0x724 - Pin configuration register for a normal-drive pin"]
    pub sfspe_9: SFSPE_9,
    #[doc = "0x728 - Pin configuration register for a normal-drive pin"]
    pub sfspe_10: SFSPE_10,
    #[doc = "0x72c - Pin configuration register for a normal-drive pin"]
    pub sfspe_11: SFSPE_11,
    #[doc = "0x730 - Pin configuration register for a normal-drive pin"]
    pub sfspe_12: SFSPE_12,
    #[doc = "0x734 - Pin configuration register for a normal-drive pin"]
    pub sfspe_13: SFSPE_13,
    #[doc = "0x738 - Pin configuration register for a normal-drive pin"]
    pub sfspe_14: SFSPE_14,
    #[doc = "0x73c - Pin configuration register for a normal-drive pin"]
    pub sfspe_15: SFSPE_15,
    _reserved162: [u8; 64usize],
    #[doc = "0x780 - Pin configuration register for a normal-drive pin"]
    pub sfspf_0: SFSPF_0,
    #[doc = "0x784 - Pin configuration register for a normal-drive pin"]
    pub sfspf_1: SFSPF_1,
    #[doc = "0x788 - Pin configuration register for a normal-drive pin"]
    pub sfspf_2: SFSPF_2,
    #[doc = "0x78c - Pin configuration register for a normal-drive pin"]
    pub sfspf_3: SFSPF_3,
    #[doc = "0x790 - Pin configuration register for a normal-drive pin"]
    pub sfspf_4: SFSPF_4,
    #[doc = "0x794 - Pin configuration register for a normal-drive pin"]
    pub sfspf_5: SFSPF_5,
    #[doc = "0x798 - Pin configuration register for a normal-drive pin"]
    pub sfspf_6: SFSPF_6,
    #[doc = "0x79c - Pin configuration register for a normal-drive pin"]
    pub sfspf_7: SFSPF_7,
    #[doc = "0x7a0 - Pin configuration register for a normal-drive pin"]
    pub sfspf_8: SFSPF_8,
    #[doc = "0x7a4 - Pin configuration register for a normal-drive pin"]
    pub sfspf_9: SFSPF_9,
    #[doc = "0x7a8 - Pin configuration register for a normal-drive pin"]
    pub sfspf_10: SFSPF_10,
    #[doc = "0x7ac - Pin configuration register for a normal-drive pin"]
    pub sfspf_11: SFSPF_11,
    _reserved174: [u8; 1104usize],
    #[doc = "0xc00 - Pin configuration register for pins CLK"]
    pub sfsclk_: [SFSCLK_; 4],
    _reserved175: [u8; 112usize],
    #[doc = "0xc80 - Pin configuration register for pins USB1_DM and USB1_DP"]
    pub sfsusb: SFSUSB,
    #[doc = "0xc84 - Pin configuration register for I2C0-bus pins"]
    pub sfsi2c0: SFSI2C0,
    #[doc = "0xc88 - ADC0 function select register"]
    pub enaio0: ENAIO0,
    #[doc = "0xc8c - ADC1 function select register"]
    pub enaio1: ENAIO1,
    #[doc = "0xc90 - Analog function select register"]
    pub enaio2: ENAIO2,
    _reserved180: [u8; 108usize],
    #[doc = "0xd00 - EMC clock delay register"]
    pub emcdelayclk: EMCDELAYCLK,
    _reserved181: [u8; 124usize],
    #[doc = "0xd80 - SD/MMC sample and drive delay register"]
    pub sddelay: SDDELAY,
    _reserved182: [u8; 124usize],
    #[doc = "0xe00 - Pin interrupt select register for pin interrupts 0 to 3."]
    pub pintsel0: PINTSEL0,
    #[doc = "0xe04 - Pin interrupt select register for pin interrupts 4 to 7."]
    pub pintsel1: PINTSEL1,
}
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp0_0](sfsp0_0) module"]
pub type SFSP0_0 = crate::Reg<u32, _SFSP0_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP0_0;
#[doc = "`read()` method returns [sfsp0_0::R](sfsp0_0::R) reader structure"]
impl crate::Readable for SFSP0_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp0_0::W](sfsp0_0::W) writer structure"]
impl crate::Writable for SFSP0_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp0_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp0_1](sfsp0_1) module"]
pub type SFSP0_1 = crate::Reg<u32, _SFSP0_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP0_1;
#[doc = "`read()` method returns [sfsp0_1::R](sfsp0_1::R) reader structure"]
impl crate::Readable for SFSP0_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp0_1::W](sfsp0_1::W) writer structure"]
impl crate::Writable for SFSP0_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp0_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_0](sfsp1_0) module"]
pub type SFSP1_0 = crate::Reg<u32, _SFSP1_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_0;
#[doc = "`read()` method returns [sfsp1_0::R](sfsp1_0::R) reader structure"]
impl crate::Readable for SFSP1_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_0::W](sfsp1_0::W) writer structure"]
impl crate::Writable for SFSP1_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_1](sfsp1_1) module"]
pub type SFSP1_1 = crate::Reg<u32, _SFSP1_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_1;
#[doc = "`read()` method returns [sfsp1_1::R](sfsp1_1::R) reader structure"]
impl crate::Readable for SFSP1_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_1::W](sfsp1_1::W) writer structure"]
impl crate::Writable for SFSP1_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_2](sfsp1_2) module"]
pub type SFSP1_2 = crate::Reg<u32, _SFSP1_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_2;
#[doc = "`read()` method returns [sfsp1_2::R](sfsp1_2::R) reader structure"]
impl crate::Readable for SFSP1_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_2::W](sfsp1_2::W) writer structure"]
impl crate::Writable for SFSP1_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_3](sfsp1_3) module"]
pub type SFSP1_3 = crate::Reg<u32, _SFSP1_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_3;
#[doc = "`read()` method returns [sfsp1_3::R](sfsp1_3::R) reader structure"]
impl crate::Readable for SFSP1_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_3::W](sfsp1_3::W) writer structure"]
impl crate::Writable for SFSP1_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_4](sfsp1_4) module"]
pub type SFSP1_4 = crate::Reg<u32, _SFSP1_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_4;
#[doc = "`read()` method returns [sfsp1_4::R](sfsp1_4::R) reader structure"]
impl crate::Readable for SFSP1_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_4::W](sfsp1_4::W) writer structure"]
impl crate::Writable for SFSP1_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_5](sfsp1_5) module"]
pub type SFSP1_5 = crate::Reg<u32, _SFSP1_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_5;
#[doc = "`read()` method returns [sfsp1_5::R](sfsp1_5::R) reader structure"]
impl crate::Readable for SFSP1_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_5::W](sfsp1_5::W) writer structure"]
impl crate::Writable for SFSP1_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_6](sfsp1_6) module"]
pub type SFSP1_6 = crate::Reg<u32, _SFSP1_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_6;
#[doc = "`read()` method returns [sfsp1_6::R](sfsp1_6::R) reader structure"]
impl crate::Readable for SFSP1_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_6::W](sfsp1_6::W) writer structure"]
impl crate::Writable for SFSP1_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_7](sfsp1_7) module"]
pub type SFSP1_7 = crate::Reg<u32, _SFSP1_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_7;
#[doc = "`read()` method returns [sfsp1_7::R](sfsp1_7::R) reader structure"]
impl crate::Readable for SFSP1_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_7::W](sfsp1_7::W) writer structure"]
impl crate::Writable for SFSP1_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_8](sfsp1_8) module"]
pub type SFSP1_8 = crate::Reg<u32, _SFSP1_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_8;
#[doc = "`read()` method returns [sfsp1_8::R](sfsp1_8::R) reader structure"]
impl crate::Readable for SFSP1_8 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_8::W](sfsp1_8::W) writer structure"]
impl crate::Writable for SFSP1_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_9](sfsp1_9) module"]
pub type SFSP1_9 = crate::Reg<u32, _SFSP1_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_9;
#[doc = "`read()` method returns [sfsp1_9::R](sfsp1_9::R) reader structure"]
impl crate::Readable for SFSP1_9 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_9::W](sfsp1_9::W) writer structure"]
impl crate::Writable for SFSP1_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_10](sfsp1_10) module"]
pub type SFSP1_10 = crate::Reg<u32, _SFSP1_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_10;
#[doc = "`read()` method returns [sfsp1_10::R](sfsp1_10::R) reader structure"]
impl crate::Readable for SFSP1_10 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_10::W](sfsp1_10::W) writer structure"]
impl crate::Writable for SFSP1_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_11](sfsp1_11) module"]
pub type SFSP1_11 = crate::Reg<u32, _SFSP1_11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_11;
#[doc = "`read()` method returns [sfsp1_11::R](sfsp1_11::R) reader structure"]
impl crate::Readable for SFSP1_11 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_11::W](sfsp1_11::W) writer structure"]
impl crate::Writable for SFSP1_11 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_11;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_12](sfsp1_12) module"]
pub type SFSP1_12 = crate::Reg<u32, _SFSP1_12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_12;
#[doc = "`read()` method returns [sfsp1_12::R](sfsp1_12::R) reader structure"]
impl crate::Readable for SFSP1_12 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_12::W](sfsp1_12::W) writer structure"]
impl crate::Writable for SFSP1_12 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_12;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_13](sfsp1_13) module"]
pub type SFSP1_13 = crate::Reg<u32, _SFSP1_13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_13;
#[doc = "`read()` method returns [sfsp1_13::R](sfsp1_13::R) reader structure"]
impl crate::Readable for SFSP1_13 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_13::W](sfsp1_13::W) writer structure"]
impl crate::Writable for SFSP1_13 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_13;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_14](sfsp1_14) module"]
pub type SFSP1_14 = crate::Reg<u32, _SFSP1_14>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_14;
#[doc = "`read()` method returns [sfsp1_14::R](sfsp1_14::R) reader structure"]
impl crate::Readable for SFSP1_14 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_14::W](sfsp1_14::W) writer structure"]
impl crate::Writable for SFSP1_14 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_14;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_15](sfsp1_15) module"]
pub type SFSP1_15 = crate::Reg<u32, _SFSP1_15>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_15;
#[doc = "`read()` method returns [sfsp1_15::R](sfsp1_15::R) reader structure"]
impl crate::Readable for SFSP1_15 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_15::W](sfsp1_15::W) writer structure"]
impl crate::Writable for SFSP1_15 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_15;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_16](sfsp1_16) module"]
pub type SFSP1_16 = crate::Reg<u32, _SFSP1_16>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_16;
#[doc = "`read()` method returns [sfsp1_16::R](sfsp1_16::R) reader structure"]
impl crate::Readable for SFSP1_16 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_16::W](sfsp1_16::W) writer structure"]
impl crate::Writable for SFSP1_16 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_16;
#[doc = "Pin configuration register for a high-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_17](sfsp1_17) module"]
pub type SFSP1_17 = crate::Reg<u32, _SFSP1_17>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_17;
#[doc = "`read()` method returns [sfsp1_17::R](sfsp1_17::R) reader structure"]
impl crate::Readable for SFSP1_17 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_17::W](sfsp1_17::W) writer structure"]
impl crate::Writable for SFSP1_17 {}
#[doc = "Pin configuration register for a high-drive pin"]
pub mod sfsp1_17;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_18](sfsp1_18) module"]
pub type SFSP1_18 = crate::Reg<u32, _SFSP1_18>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_18;
#[doc = "`read()` method returns [sfsp1_18::R](sfsp1_18::R) reader structure"]
impl crate::Readable for SFSP1_18 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_18::W](sfsp1_18::W) writer structure"]
impl crate::Writable for SFSP1_18 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_18;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_19](sfsp1_19) module"]
pub type SFSP1_19 = crate::Reg<u32, _SFSP1_19>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_19;
#[doc = "`read()` method returns [sfsp1_19::R](sfsp1_19::R) reader structure"]
impl crate::Readable for SFSP1_19 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_19::W](sfsp1_19::W) writer structure"]
impl crate::Writable for SFSP1_19 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_19;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp1_20](sfsp1_20) module"]
pub type SFSP1_20 = crate::Reg<u32, _SFSP1_20>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP1_20;
#[doc = "`read()` method returns [sfsp1_20::R](sfsp1_20::R) reader structure"]
impl crate::Readable for SFSP1_20 {}
#[doc = "`write(|w| ..)` method takes [sfsp1_20::W](sfsp1_20::W) writer structure"]
impl crate::Writable for SFSP1_20 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp1_20;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_0](sfsp2_0) module"]
pub type SFSP2_0 = crate::Reg<u32, _SFSP2_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_0;
#[doc = "`read()` method returns [sfsp2_0::R](sfsp2_0::R) reader structure"]
impl crate::Readable for SFSP2_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_0::W](sfsp2_0::W) writer structure"]
impl crate::Writable for SFSP2_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_1](sfsp2_1) module"]
pub type SFSP2_1 = crate::Reg<u32, _SFSP2_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_1;
#[doc = "`read()` method returns [sfsp2_1::R](sfsp2_1::R) reader structure"]
impl crate::Readable for SFSP2_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_1::W](sfsp2_1::W) writer structure"]
impl crate::Writable for SFSP2_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_2](sfsp2_2) module"]
pub type SFSP2_2 = crate::Reg<u32, _SFSP2_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_2;
#[doc = "`read()` method returns [sfsp2_2::R](sfsp2_2::R) reader structure"]
impl crate::Readable for SFSP2_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_2::W](sfsp2_2::W) writer structure"]
impl crate::Writable for SFSP2_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_2;
#[doc = "Pin configuration register for a high-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_3](sfsp2_3) module"]
pub type SFSP2_3 = crate::Reg<u32, _SFSP2_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_3;
#[doc = "`read()` method returns [sfsp2_3::R](sfsp2_3::R) reader structure"]
impl crate::Readable for SFSP2_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_3::W](sfsp2_3::W) writer structure"]
impl crate::Writable for SFSP2_3 {}
#[doc = "Pin configuration register for a high-drive pin"]
pub mod sfsp2_3;
#[doc = "Pin configuration register for a high-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_4](sfsp2_4) module"]
pub type SFSP2_4 = crate::Reg<u32, _SFSP2_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_4;
#[doc = "`read()` method returns [sfsp2_4::R](sfsp2_4::R) reader structure"]
impl crate::Readable for SFSP2_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_4::W](sfsp2_4::W) writer structure"]
impl crate::Writable for SFSP2_4 {}
#[doc = "Pin configuration register for a high-drive pin"]
pub mod sfsp2_4;
#[doc = "Pin configuration register for a high-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_5](sfsp2_5) module"]
pub type SFSP2_5 = crate::Reg<u32, _SFSP2_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_5;
#[doc = "`read()` method returns [sfsp2_5::R](sfsp2_5::R) reader structure"]
impl crate::Readable for SFSP2_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_5::W](sfsp2_5::W) writer structure"]
impl crate::Writable for SFSP2_5 {}
#[doc = "Pin configuration register for a high-drive pin"]
pub mod sfsp2_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_6](sfsp2_6) module"]
pub type SFSP2_6 = crate::Reg<u32, _SFSP2_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_6;
#[doc = "`read()` method returns [sfsp2_6::R](sfsp2_6::R) reader structure"]
impl crate::Readable for SFSP2_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_6::W](sfsp2_6::W) writer structure"]
impl crate::Writable for SFSP2_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_7](sfsp2_7) module"]
pub type SFSP2_7 = crate::Reg<u32, _SFSP2_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_7;
#[doc = "`read()` method returns [sfsp2_7::R](sfsp2_7::R) reader structure"]
impl crate::Readable for SFSP2_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_7::W](sfsp2_7::W) writer structure"]
impl crate::Writable for SFSP2_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_8](sfsp2_8) module"]
pub type SFSP2_8 = crate::Reg<u32, _SFSP2_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_8;
#[doc = "`read()` method returns [sfsp2_8::R](sfsp2_8::R) reader structure"]
impl crate::Readable for SFSP2_8 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_8::W](sfsp2_8::W) writer structure"]
impl crate::Writable for SFSP2_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_9](sfsp2_9) module"]
pub type SFSP2_9 = crate::Reg<u32, _SFSP2_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_9;
#[doc = "`read()` method returns [sfsp2_9::R](sfsp2_9::R) reader structure"]
impl crate::Readable for SFSP2_9 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_9::W](sfsp2_9::W) writer structure"]
impl crate::Writable for SFSP2_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_10](sfsp2_10) module"]
pub type SFSP2_10 = crate::Reg<u32, _SFSP2_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_10;
#[doc = "`read()` method returns [sfsp2_10::R](sfsp2_10::R) reader structure"]
impl crate::Readable for SFSP2_10 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_10::W](sfsp2_10::W) writer structure"]
impl crate::Writable for SFSP2_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_11](sfsp2_11) module"]
pub type SFSP2_11 = crate::Reg<u32, _SFSP2_11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_11;
#[doc = "`read()` method returns [sfsp2_11::R](sfsp2_11::R) reader structure"]
impl crate::Readable for SFSP2_11 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_11::W](sfsp2_11::W) writer structure"]
impl crate::Writable for SFSP2_11 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_11;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_12](sfsp2_12) module"]
pub type SFSP2_12 = crate::Reg<u32, _SFSP2_12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_12;
#[doc = "`read()` method returns [sfsp2_12::R](sfsp2_12::R) reader structure"]
impl crate::Readable for SFSP2_12 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_12::W](sfsp2_12::W) writer structure"]
impl crate::Writable for SFSP2_12 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_12;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp2_13](sfsp2_13) module"]
pub type SFSP2_13 = crate::Reg<u32, _SFSP2_13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP2_13;
#[doc = "`read()` method returns [sfsp2_13::R](sfsp2_13::R) reader structure"]
impl crate::Readable for SFSP2_13 {}
#[doc = "`write(|w| ..)` method takes [sfsp2_13::W](sfsp2_13::W) writer structure"]
impl crate::Writable for SFSP2_13 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp2_13;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_0](sfsp3_0) module"]
pub type SFSP3_0 = crate::Reg<u32, _SFSP3_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_0;
#[doc = "`read()` method returns [sfsp3_0::R](sfsp3_0::R) reader structure"]
impl crate::Readable for SFSP3_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_0::W](sfsp3_0::W) writer structure"]
impl crate::Writable for SFSP3_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_1](sfsp3_1) module"]
pub type SFSP3_1 = crate::Reg<u32, _SFSP3_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_1;
#[doc = "`read()` method returns [sfsp3_1::R](sfsp3_1::R) reader structure"]
impl crate::Readable for SFSP3_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_1::W](sfsp3_1::W) writer structure"]
impl crate::Writable for SFSP3_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_2](sfsp3_2) module"]
pub type SFSP3_2 = crate::Reg<u32, _SFSP3_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_2;
#[doc = "`read()` method returns [sfsp3_2::R](sfsp3_2::R) reader structure"]
impl crate::Readable for SFSP3_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_2::W](sfsp3_2::W) writer structure"]
impl crate::Writable for SFSP3_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_2;
#[doc = "Pin configuration register for a high-speed pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_3](sfsp3_3) module"]
pub type SFSP3_3 = crate::Reg<u32, _SFSP3_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_3;
#[doc = "`read()` method returns [sfsp3_3::R](sfsp3_3::R) reader structure"]
impl crate::Readable for SFSP3_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_3::W](sfsp3_3::W) writer structure"]
impl crate::Writable for SFSP3_3 {}
#[doc = "Pin configuration register for a high-speed pin"]
pub mod sfsp3_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_4](sfsp3_4) module"]
pub type SFSP3_4 = crate::Reg<u32, _SFSP3_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_4;
#[doc = "`read()` method returns [sfsp3_4::R](sfsp3_4::R) reader structure"]
impl crate::Readable for SFSP3_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_4::W](sfsp3_4::W) writer structure"]
impl crate::Writable for SFSP3_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_5](sfsp3_5) module"]
pub type SFSP3_5 = crate::Reg<u32, _SFSP3_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_5;
#[doc = "`read()` method returns [sfsp3_5::R](sfsp3_5::R) reader structure"]
impl crate::Readable for SFSP3_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_5::W](sfsp3_5::W) writer structure"]
impl crate::Writable for SFSP3_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_6](sfsp3_6) module"]
pub type SFSP3_6 = crate::Reg<u32, _SFSP3_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_6;
#[doc = "`read()` method returns [sfsp3_6::R](sfsp3_6::R) reader structure"]
impl crate::Readable for SFSP3_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_6::W](sfsp3_6::W) writer structure"]
impl crate::Writable for SFSP3_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_7](sfsp3_7) module"]
pub type SFSP3_7 = crate::Reg<u32, _SFSP3_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_7;
#[doc = "`read()` method returns [sfsp3_7::R](sfsp3_7::R) reader structure"]
impl crate::Readable for SFSP3_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_7::W](sfsp3_7::W) writer structure"]
impl crate::Writable for SFSP3_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp3_8](sfsp3_8) module"]
pub type SFSP3_8 = crate::Reg<u32, _SFSP3_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP3_8;
#[doc = "`read()` method returns [sfsp3_8::R](sfsp3_8::R) reader structure"]
impl crate::Readable for SFSP3_8 {}
#[doc = "`write(|w| ..)` method takes [sfsp3_8::W](sfsp3_8::W) writer structure"]
impl crate::Writable for SFSP3_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp3_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_0](sfsp4_0) module"]
pub type SFSP4_0 = crate::Reg<u32, _SFSP4_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_0;
#[doc = "`read()` method returns [sfsp4_0::R](sfsp4_0::R) reader structure"]
impl crate::Readable for SFSP4_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_0::W](sfsp4_0::W) writer structure"]
impl crate::Writable for SFSP4_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_1](sfsp4_1) module"]
pub type SFSP4_1 = crate::Reg<u32, _SFSP4_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_1;
#[doc = "`read()` method returns [sfsp4_1::R](sfsp4_1::R) reader structure"]
impl crate::Readable for SFSP4_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_1::W](sfsp4_1::W) writer structure"]
impl crate::Writable for SFSP4_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_2](sfsp4_2) module"]
pub type SFSP4_2 = crate::Reg<u32, _SFSP4_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_2;
#[doc = "`read()` method returns [sfsp4_2::R](sfsp4_2::R) reader structure"]
impl crate::Readable for SFSP4_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_2::W](sfsp4_2::W) writer structure"]
impl crate::Writable for SFSP4_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_3](sfsp4_3) module"]
pub type SFSP4_3 = crate::Reg<u32, _SFSP4_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_3;
#[doc = "`read()` method returns [sfsp4_3::R](sfsp4_3::R) reader structure"]
impl crate::Readable for SFSP4_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_3::W](sfsp4_3::W) writer structure"]
impl crate::Writable for SFSP4_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_4](sfsp4_4) module"]
pub type SFSP4_4 = crate::Reg<u32, _SFSP4_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_4;
#[doc = "`read()` method returns [sfsp4_4::R](sfsp4_4::R) reader structure"]
impl crate::Readable for SFSP4_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_4::W](sfsp4_4::W) writer structure"]
impl crate::Writable for SFSP4_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_5](sfsp4_5) module"]
pub type SFSP4_5 = crate::Reg<u32, _SFSP4_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_5;
#[doc = "`read()` method returns [sfsp4_5::R](sfsp4_5::R) reader structure"]
impl crate::Readable for SFSP4_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_5::W](sfsp4_5::W) writer structure"]
impl crate::Writable for SFSP4_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_6](sfsp4_6) module"]
pub type SFSP4_6 = crate::Reg<u32, _SFSP4_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_6;
#[doc = "`read()` method returns [sfsp4_6::R](sfsp4_6::R) reader structure"]
impl crate::Readable for SFSP4_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_6::W](sfsp4_6::W) writer structure"]
impl crate::Writable for SFSP4_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_7](sfsp4_7) module"]
pub type SFSP4_7 = crate::Reg<u32, _SFSP4_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_7;
#[doc = "`read()` method returns [sfsp4_7::R](sfsp4_7::R) reader structure"]
impl crate::Readable for SFSP4_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_7::W](sfsp4_7::W) writer structure"]
impl crate::Writable for SFSP4_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_8](sfsp4_8) module"]
pub type SFSP4_8 = crate::Reg<u32, _SFSP4_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_8;
#[doc = "`read()` method returns [sfsp4_8::R](sfsp4_8::R) reader structure"]
impl crate::Readable for SFSP4_8 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_8::W](sfsp4_8::W) writer structure"]
impl crate::Writable for SFSP4_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_9](sfsp4_9) module"]
pub type SFSP4_9 = crate::Reg<u32, _SFSP4_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_9;
#[doc = "`read()` method returns [sfsp4_9::R](sfsp4_9::R) reader structure"]
impl crate::Readable for SFSP4_9 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_9::W](sfsp4_9::W) writer structure"]
impl crate::Writable for SFSP4_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp4_10](sfsp4_10) module"]
pub type SFSP4_10 = crate::Reg<u32, _SFSP4_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP4_10;
#[doc = "`read()` method returns [sfsp4_10::R](sfsp4_10::R) reader structure"]
impl crate::Readable for SFSP4_10 {}
#[doc = "`write(|w| ..)` method takes [sfsp4_10::W](sfsp4_10::W) writer structure"]
impl crate::Writable for SFSP4_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp4_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_0](sfsp5_0) module"]
pub type SFSP5_0 = crate::Reg<u32, _SFSP5_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_0;
#[doc = "`read()` method returns [sfsp5_0::R](sfsp5_0::R) reader structure"]
impl crate::Readable for SFSP5_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_0::W](sfsp5_0::W) writer structure"]
impl crate::Writable for SFSP5_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_1](sfsp5_1) module"]
pub type SFSP5_1 = crate::Reg<u32, _SFSP5_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_1;
#[doc = "`read()` method returns [sfsp5_1::R](sfsp5_1::R) reader structure"]
impl crate::Readable for SFSP5_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_1::W](sfsp5_1::W) writer structure"]
impl crate::Writable for SFSP5_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_2](sfsp5_2) module"]
pub type SFSP5_2 = crate::Reg<u32, _SFSP5_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_2;
#[doc = "`read()` method returns [sfsp5_2::R](sfsp5_2::R) reader structure"]
impl crate::Readable for SFSP5_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_2::W](sfsp5_2::W) writer structure"]
impl crate::Writable for SFSP5_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_3](sfsp5_3) module"]
pub type SFSP5_3 = crate::Reg<u32, _SFSP5_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_3;
#[doc = "`read()` method returns [sfsp5_3::R](sfsp5_3::R) reader structure"]
impl crate::Readable for SFSP5_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_3::W](sfsp5_3::W) writer structure"]
impl crate::Writable for SFSP5_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_4](sfsp5_4) module"]
pub type SFSP5_4 = crate::Reg<u32, _SFSP5_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_4;
#[doc = "`read()` method returns [sfsp5_4::R](sfsp5_4::R) reader structure"]
impl crate::Readable for SFSP5_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_4::W](sfsp5_4::W) writer structure"]
impl crate::Writable for SFSP5_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_5](sfsp5_5) module"]
pub type SFSP5_5 = crate::Reg<u32, _SFSP5_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_5;
#[doc = "`read()` method returns [sfsp5_5::R](sfsp5_5::R) reader structure"]
impl crate::Readable for SFSP5_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_5::W](sfsp5_5::W) writer structure"]
impl crate::Writable for SFSP5_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_6](sfsp5_6) module"]
pub type SFSP5_6 = crate::Reg<u32, _SFSP5_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_6;
#[doc = "`read()` method returns [sfsp5_6::R](sfsp5_6::R) reader structure"]
impl crate::Readable for SFSP5_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_6::W](sfsp5_6::W) writer structure"]
impl crate::Writable for SFSP5_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp5_7](sfsp5_7) module"]
pub type SFSP5_7 = crate::Reg<u32, _SFSP5_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP5_7;
#[doc = "`read()` method returns [sfsp5_7::R](sfsp5_7::R) reader structure"]
impl crate::Readable for SFSP5_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp5_7::W](sfsp5_7::W) writer structure"]
impl crate::Writable for SFSP5_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp5_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_0](sfsp6_0) module"]
pub type SFSP6_0 = crate::Reg<u32, _SFSP6_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_0;
#[doc = "`read()` method returns [sfsp6_0::R](sfsp6_0::R) reader structure"]
impl crate::Readable for SFSP6_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_0::W](sfsp6_0::W) writer structure"]
impl crate::Writable for SFSP6_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_1](sfsp6_1) module"]
pub type SFSP6_1 = crate::Reg<u32, _SFSP6_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_1;
#[doc = "`read()` method returns [sfsp6_1::R](sfsp6_1::R) reader structure"]
impl crate::Readable for SFSP6_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_1::W](sfsp6_1::W) writer structure"]
impl crate::Writable for SFSP6_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_2](sfsp6_2) module"]
pub type SFSP6_2 = crate::Reg<u32, _SFSP6_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_2;
#[doc = "`read()` method returns [sfsp6_2::R](sfsp6_2::R) reader structure"]
impl crate::Readable for SFSP6_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_2::W](sfsp6_2::W) writer structure"]
impl crate::Writable for SFSP6_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_3](sfsp6_3) module"]
pub type SFSP6_3 = crate::Reg<u32, _SFSP6_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_3;
#[doc = "`read()` method returns [sfsp6_3::R](sfsp6_3::R) reader structure"]
impl crate::Readable for SFSP6_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_3::W](sfsp6_3::W) writer structure"]
impl crate::Writable for SFSP6_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_4](sfsp6_4) module"]
pub type SFSP6_4 = crate::Reg<u32, _SFSP6_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_4;
#[doc = "`read()` method returns [sfsp6_4::R](sfsp6_4::R) reader structure"]
impl crate::Readable for SFSP6_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_4::W](sfsp6_4::W) writer structure"]
impl crate::Writable for SFSP6_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_5](sfsp6_5) module"]
pub type SFSP6_5 = crate::Reg<u32, _SFSP6_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_5;
#[doc = "`read()` method returns [sfsp6_5::R](sfsp6_5::R) reader structure"]
impl crate::Readable for SFSP6_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_5::W](sfsp6_5::W) writer structure"]
impl crate::Writable for SFSP6_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_6](sfsp6_6) module"]
pub type SFSP6_6 = crate::Reg<u32, _SFSP6_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_6;
#[doc = "`read()` method returns [sfsp6_6::R](sfsp6_6::R) reader structure"]
impl crate::Readable for SFSP6_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_6::W](sfsp6_6::W) writer structure"]
impl crate::Writable for SFSP6_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_7](sfsp6_7) module"]
pub type SFSP6_7 = crate::Reg<u32, _SFSP6_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_7;
#[doc = "`read()` method returns [sfsp6_7::R](sfsp6_7::R) reader structure"]
impl crate::Readable for SFSP6_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_7::W](sfsp6_7::W) writer structure"]
impl crate::Writable for SFSP6_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_8](sfsp6_8) module"]
pub type SFSP6_8 = crate::Reg<u32, _SFSP6_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_8;
#[doc = "`read()` method returns [sfsp6_8::R](sfsp6_8::R) reader structure"]
impl crate::Readable for SFSP6_8 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_8::W](sfsp6_8::W) writer structure"]
impl crate::Writable for SFSP6_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_9](sfsp6_9) module"]
pub type SFSP6_9 = crate::Reg<u32, _SFSP6_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_9;
#[doc = "`read()` method returns [sfsp6_9::R](sfsp6_9::R) reader structure"]
impl crate::Readable for SFSP6_9 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_9::W](sfsp6_9::W) writer structure"]
impl crate::Writable for SFSP6_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_10](sfsp6_10) module"]
pub type SFSP6_10 = crate::Reg<u32, _SFSP6_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_10;
#[doc = "`read()` method returns [sfsp6_10::R](sfsp6_10::R) reader structure"]
impl crate::Readable for SFSP6_10 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_10::W](sfsp6_10::W) writer structure"]
impl crate::Writable for SFSP6_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_11](sfsp6_11) module"]
pub type SFSP6_11 = crate::Reg<u32, _SFSP6_11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_11;
#[doc = "`read()` method returns [sfsp6_11::R](sfsp6_11::R) reader structure"]
impl crate::Readable for SFSP6_11 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_11::W](sfsp6_11::W) writer structure"]
impl crate::Writable for SFSP6_11 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_11;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp6_12](sfsp6_12) module"]
pub type SFSP6_12 = crate::Reg<u32, _SFSP6_12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP6_12;
#[doc = "`read()` method returns [sfsp6_12::R](sfsp6_12::R) reader structure"]
impl crate::Readable for SFSP6_12 {}
#[doc = "`write(|w| ..)` method takes [sfsp6_12::W](sfsp6_12::W) writer structure"]
impl crate::Writable for SFSP6_12 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp6_12;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_0](sfsp7_0) module"]
pub type SFSP7_0 = crate::Reg<u32, _SFSP7_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_0;
#[doc = "`read()` method returns [sfsp7_0::R](sfsp7_0::R) reader structure"]
impl crate::Readable for SFSP7_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_0::W](sfsp7_0::W) writer structure"]
impl crate::Writable for SFSP7_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_1](sfsp7_1) module"]
pub type SFSP7_1 = crate::Reg<u32, _SFSP7_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_1;
#[doc = "`read()` method returns [sfsp7_1::R](sfsp7_1::R) reader structure"]
impl crate::Readable for SFSP7_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_1::W](sfsp7_1::W) writer structure"]
impl crate::Writable for SFSP7_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_2](sfsp7_2) module"]
pub type SFSP7_2 = crate::Reg<u32, _SFSP7_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_2;
#[doc = "`read()` method returns [sfsp7_2::R](sfsp7_2::R) reader structure"]
impl crate::Readable for SFSP7_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_2::W](sfsp7_2::W) writer structure"]
impl crate::Writable for SFSP7_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_3](sfsp7_3) module"]
pub type SFSP7_3 = crate::Reg<u32, _SFSP7_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_3;
#[doc = "`read()` method returns [sfsp7_3::R](sfsp7_3::R) reader structure"]
impl crate::Readable for SFSP7_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_3::W](sfsp7_3::W) writer structure"]
impl crate::Writable for SFSP7_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_4](sfsp7_4) module"]
pub type SFSP7_4 = crate::Reg<u32, _SFSP7_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_4;
#[doc = "`read()` method returns [sfsp7_4::R](sfsp7_4::R) reader structure"]
impl crate::Readable for SFSP7_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_4::W](sfsp7_4::W) writer structure"]
impl crate::Writable for SFSP7_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_5](sfsp7_5) module"]
pub type SFSP7_5 = crate::Reg<u32, _SFSP7_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_5;
#[doc = "`read()` method returns [sfsp7_5::R](sfsp7_5::R) reader structure"]
impl crate::Readable for SFSP7_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_5::W](sfsp7_5::W) writer structure"]
impl crate::Writable for SFSP7_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_6](sfsp7_6) module"]
pub type SFSP7_6 = crate::Reg<u32, _SFSP7_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_6;
#[doc = "`read()` method returns [sfsp7_6::R](sfsp7_6::R) reader structure"]
impl crate::Readable for SFSP7_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_6::W](sfsp7_6::W) writer structure"]
impl crate::Writable for SFSP7_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp7_7](sfsp7_7) module"]
pub type SFSP7_7 = crate::Reg<u32, _SFSP7_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP7_7;
#[doc = "`read()` method returns [sfsp7_7::R](sfsp7_7::R) reader structure"]
impl crate::Readable for SFSP7_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp7_7::W](sfsp7_7::W) writer structure"]
impl crate::Writable for SFSP7_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp7_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_0](sfsp8_0) module"]
pub type SFSP8_0 = crate::Reg<u32, _SFSP8_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_0;
#[doc = "`read()` method returns [sfsp8_0::R](sfsp8_0::R) reader structure"]
impl crate::Readable for SFSP8_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_0::W](sfsp8_0::W) writer structure"]
impl crate::Writable for SFSP8_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_1](sfsp8_1) module"]
pub type SFSP8_1 = crate::Reg<u32, _SFSP8_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_1;
#[doc = "`read()` method returns [sfsp8_1::R](sfsp8_1::R) reader structure"]
impl crate::Readable for SFSP8_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_1::W](sfsp8_1::W) writer structure"]
impl crate::Writable for SFSP8_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_2](sfsp8_2) module"]
pub type SFSP8_2 = crate::Reg<u32, _SFSP8_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_2;
#[doc = "`read()` method returns [sfsp8_2::R](sfsp8_2::R) reader structure"]
impl crate::Readable for SFSP8_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_2::W](sfsp8_2::W) writer structure"]
impl crate::Writable for SFSP8_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_3](sfsp8_3) module"]
pub type SFSP8_3 = crate::Reg<u32, _SFSP8_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_3;
#[doc = "`read()` method returns [sfsp8_3::R](sfsp8_3::R) reader structure"]
impl crate::Readable for SFSP8_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_3::W](sfsp8_3::W) writer structure"]
impl crate::Writable for SFSP8_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_4](sfsp8_4) module"]
pub type SFSP8_4 = crate::Reg<u32, _SFSP8_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_4;
#[doc = "`read()` method returns [sfsp8_4::R](sfsp8_4::R) reader structure"]
impl crate::Readable for SFSP8_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_4::W](sfsp8_4::W) writer structure"]
impl crate::Writable for SFSP8_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_5](sfsp8_5) module"]
pub type SFSP8_5 = crate::Reg<u32, _SFSP8_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_5;
#[doc = "`read()` method returns [sfsp8_5::R](sfsp8_5::R) reader structure"]
impl crate::Readable for SFSP8_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_5::W](sfsp8_5::W) writer structure"]
impl crate::Writable for SFSP8_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_6](sfsp8_6) module"]
pub type SFSP8_6 = crate::Reg<u32, _SFSP8_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_6;
#[doc = "`read()` method returns [sfsp8_6::R](sfsp8_6::R) reader structure"]
impl crate::Readable for SFSP8_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_6::W](sfsp8_6::W) writer structure"]
impl crate::Writable for SFSP8_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_7](sfsp8_7) module"]
pub type SFSP8_7 = crate::Reg<u32, _SFSP8_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_7;
#[doc = "`read()` method returns [sfsp8_7::R](sfsp8_7::R) reader structure"]
impl crate::Readable for SFSP8_7 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_7::W](sfsp8_7::W) writer structure"]
impl crate::Writable for SFSP8_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp8_8](sfsp8_8) module"]
pub type SFSP8_8 = crate::Reg<u32, _SFSP8_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP8_8;
#[doc = "`read()` method returns [sfsp8_8::R](sfsp8_8::R) reader structure"]
impl crate::Readable for SFSP8_8 {}
#[doc = "`write(|w| ..)` method takes [sfsp8_8::W](sfsp8_8::W) writer structure"]
impl crate::Writable for SFSP8_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp8_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp9_0](sfsp9_0) module"]
pub type SFSP9_0 = crate::Reg<u32, _SFSP9_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP9_0;
#[doc = "`read()` method returns [sfsp9_0::R](sfsp9_0::R) reader structure"]
impl crate::Readable for SFSP9_0 {}
#[doc = "`write(|w| ..)` method takes [sfsp9_0::W](sfsp9_0::W) writer structure"]
impl crate::Writable for SFSP9_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp9_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp9_1](sfsp9_1) module"]
pub type SFSP9_1 = crate::Reg<u32, _SFSP9_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP9_1;
#[doc = "`read()` method returns [sfsp9_1::R](sfsp9_1::R) reader structure"]
impl crate::Readable for SFSP9_1 {}
#[doc = "`write(|w| ..)` method takes [sfsp9_1::W](sfsp9_1::W) writer structure"]
impl crate::Writable for SFSP9_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp9_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp9_2](sfsp9_2) module"]
pub type SFSP9_2 = crate::Reg<u32, _SFSP9_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP9_2;
#[doc = "`read()` method returns [sfsp9_2::R](sfsp9_2::R) reader structure"]
impl crate::Readable for SFSP9_2 {}
#[doc = "`write(|w| ..)` method takes [sfsp9_2::W](sfsp9_2::W) writer structure"]
impl crate::Writable for SFSP9_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp9_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp9_3](sfsp9_3) module"]
pub type SFSP9_3 = crate::Reg<u32, _SFSP9_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP9_3;
#[doc = "`read()` method returns [sfsp9_3::R](sfsp9_3::R) reader structure"]
impl crate::Readable for SFSP9_3 {}
#[doc = "`write(|w| ..)` method takes [sfsp9_3::W](sfsp9_3::W) writer structure"]
impl crate::Writable for SFSP9_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp9_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp9_4](sfsp9_4) module"]
pub type SFSP9_4 = crate::Reg<u32, _SFSP9_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP9_4;
#[doc = "`read()` method returns [sfsp9_4::R](sfsp9_4::R) reader structure"]
impl crate::Readable for SFSP9_4 {}
#[doc = "`write(|w| ..)` method takes [sfsp9_4::W](sfsp9_4::W) writer structure"]
impl crate::Writable for SFSP9_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp9_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp9_5](sfsp9_5) module"]
pub type SFSP9_5 = crate::Reg<u32, _SFSP9_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP9_5;
#[doc = "`read()` method returns [sfsp9_5::R](sfsp9_5::R) reader structure"]
impl crate::Readable for SFSP9_5 {}
#[doc = "`write(|w| ..)` method takes [sfsp9_5::W](sfsp9_5::W) writer structure"]
impl crate::Writable for SFSP9_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp9_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsp9_6](sfsp9_6) module"]
pub type SFSP9_6 = crate::Reg<u32, _SFSP9_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSP9_6;
#[doc = "`read()` method returns [sfsp9_6::R](sfsp9_6::R) reader structure"]
impl crate::Readable for SFSP9_6 {}
#[doc = "`write(|w| ..)` method takes [sfsp9_6::W](sfsp9_6::W) writer structure"]
impl crate::Writable for SFSP9_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfsp9_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspa_0](sfspa_0) module"]
pub type SFSPA_0 = crate::Reg<u32, _SFSPA_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPA_0;
#[doc = "`read()` method returns [sfspa_0::R](sfspa_0::R) reader structure"]
impl crate::Readable for SFSPA_0 {}
#[doc = "`write(|w| ..)` method takes [sfspa_0::W](sfspa_0::W) writer structure"]
impl crate::Writable for SFSPA_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspa_0;
#[doc = "Pin configuration register for a high-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspa_1](sfspa_1) module"]
pub type SFSPA_1 = crate::Reg<u32, _SFSPA_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPA_1;
#[doc = "`read()` method returns [sfspa_1::R](sfspa_1::R) reader structure"]
impl crate::Readable for SFSPA_1 {}
#[doc = "`write(|w| ..)` method takes [sfspa_1::W](sfspa_1::W) writer structure"]
impl crate::Writable for SFSPA_1 {}
#[doc = "Pin configuration register for a high-drive pin"]
pub mod sfspa_1;
#[doc = "Pin configuration register for a high-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspa_2](sfspa_2) module"]
pub type SFSPA_2 = crate::Reg<u32, _SFSPA_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPA_2;
#[doc = "`read()` method returns [sfspa_2::R](sfspa_2::R) reader structure"]
impl crate::Readable for SFSPA_2 {}
#[doc = "`write(|w| ..)` method takes [sfspa_2::W](sfspa_2::W) writer structure"]
impl crate::Writable for SFSPA_2 {}
#[doc = "Pin configuration register for a high-drive pin"]
pub mod sfspa_2;
#[doc = "Pin configuration register for a high-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspa_3](sfspa_3) module"]
pub type SFSPA_3 = crate::Reg<u32, _SFSPA_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPA_3;
#[doc = "`read()` method returns [sfspa_3::R](sfspa_3::R) reader structure"]
impl crate::Readable for SFSPA_3 {}
#[doc = "`write(|w| ..)` method takes [sfspa_3::W](sfspa_3::W) writer structure"]
impl crate::Writable for SFSPA_3 {}
#[doc = "Pin configuration register for a high-drive pin"]
pub mod sfspa_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspa_4](sfspa_4) module"]
pub type SFSPA_4 = crate::Reg<u32, _SFSPA_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPA_4;
#[doc = "`read()` method returns [sfspa_4::R](sfspa_4::R) reader structure"]
impl crate::Readable for SFSPA_4 {}
#[doc = "`write(|w| ..)` method takes [sfspa_4::W](sfspa_4::W) writer structure"]
impl crate::Writable for SFSPA_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspa_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspb_0](sfspb_0) module"]
pub type SFSPB_0 = crate::Reg<u32, _SFSPB_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPB_0;
#[doc = "`read()` method returns [sfspb_0::R](sfspb_0::R) reader structure"]
impl crate::Readable for SFSPB_0 {}
#[doc = "`write(|w| ..)` method takes [sfspb_0::W](sfspb_0::W) writer structure"]
impl crate::Writable for SFSPB_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspb_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspb_1](sfspb_1) module"]
pub type SFSPB_1 = crate::Reg<u32, _SFSPB_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPB_1;
#[doc = "`read()` method returns [sfspb_1::R](sfspb_1::R) reader structure"]
impl crate::Readable for SFSPB_1 {}
#[doc = "`write(|w| ..)` method takes [sfspb_1::W](sfspb_1::W) writer structure"]
impl crate::Writable for SFSPB_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspb_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspb_2](sfspb_2) module"]
pub type SFSPB_2 = crate::Reg<u32, _SFSPB_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPB_2;
#[doc = "`read()` method returns [sfspb_2::R](sfspb_2::R) reader structure"]
impl crate::Readable for SFSPB_2 {}
#[doc = "`write(|w| ..)` method takes [sfspb_2::W](sfspb_2::W) writer structure"]
impl crate::Writable for SFSPB_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspb_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspb_3](sfspb_3) module"]
pub type SFSPB_3 = crate::Reg<u32, _SFSPB_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPB_3;
#[doc = "`read()` method returns [sfspb_3::R](sfspb_3::R) reader structure"]
impl crate::Readable for SFSPB_3 {}
#[doc = "`write(|w| ..)` method takes [sfspb_3::W](sfspb_3::W) writer structure"]
impl crate::Writable for SFSPB_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspb_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspb_4](sfspb_4) module"]
pub type SFSPB_4 = crate::Reg<u32, _SFSPB_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPB_4;
#[doc = "`read()` method returns [sfspb_4::R](sfspb_4::R) reader structure"]
impl crate::Readable for SFSPB_4 {}
#[doc = "`write(|w| ..)` method takes [sfspb_4::W](sfspb_4::W) writer structure"]
impl crate::Writable for SFSPB_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspb_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspb_5](sfspb_5) module"]
pub type SFSPB_5 = crate::Reg<u32, _SFSPB_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPB_5;
#[doc = "`read()` method returns [sfspb_5::R](sfspb_5::R) reader structure"]
impl crate::Readable for SFSPB_5 {}
#[doc = "`write(|w| ..)` method takes [sfspb_5::W](sfspb_5::W) writer structure"]
impl crate::Writable for SFSPB_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspb_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspb_6](sfspb_6) module"]
pub type SFSPB_6 = crate::Reg<u32, _SFSPB_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPB_6;
#[doc = "`read()` method returns [sfspb_6::R](sfspb_6::R) reader structure"]
impl crate::Readable for SFSPB_6 {}
#[doc = "`write(|w| ..)` method takes [sfspb_6::W](sfspb_6::W) writer structure"]
impl crate::Writable for SFSPB_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspb_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_0](sfspc_0) module"]
pub type SFSPC_0 = crate::Reg<u32, _SFSPC_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_0;
#[doc = "`read()` method returns [sfspc_0::R](sfspc_0::R) reader structure"]
impl crate::Readable for SFSPC_0 {}
#[doc = "`write(|w| ..)` method takes [sfspc_0::W](sfspc_0::W) writer structure"]
impl crate::Writable for SFSPC_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_1](sfspc_1) module"]
pub type SFSPC_1 = crate::Reg<u32, _SFSPC_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_1;
#[doc = "`read()` method returns [sfspc_1::R](sfspc_1::R) reader structure"]
impl crate::Readable for SFSPC_1 {}
#[doc = "`write(|w| ..)` method takes [sfspc_1::W](sfspc_1::W) writer structure"]
impl crate::Writable for SFSPC_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_2](sfspc_2) module"]
pub type SFSPC_2 = crate::Reg<u32, _SFSPC_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_2;
#[doc = "`read()` method returns [sfspc_2::R](sfspc_2::R) reader structure"]
impl crate::Readable for SFSPC_2 {}
#[doc = "`write(|w| ..)` method takes [sfspc_2::W](sfspc_2::W) writer structure"]
impl crate::Writable for SFSPC_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_3](sfspc_3) module"]
pub type SFSPC_3 = crate::Reg<u32, _SFSPC_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_3;
#[doc = "`read()` method returns [sfspc_3::R](sfspc_3::R) reader structure"]
impl crate::Readable for SFSPC_3 {}
#[doc = "`write(|w| ..)` method takes [sfspc_3::W](sfspc_3::W) writer structure"]
impl crate::Writable for SFSPC_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_4](sfspc_4) module"]
pub type SFSPC_4 = crate::Reg<u32, _SFSPC_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_4;
#[doc = "`read()` method returns [sfspc_4::R](sfspc_4::R) reader structure"]
impl crate::Readable for SFSPC_4 {}
#[doc = "`write(|w| ..)` method takes [sfspc_4::W](sfspc_4::W) writer structure"]
impl crate::Writable for SFSPC_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_5](sfspc_5) module"]
pub type SFSPC_5 = crate::Reg<u32, _SFSPC_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_5;
#[doc = "`read()` method returns [sfspc_5::R](sfspc_5::R) reader structure"]
impl crate::Readable for SFSPC_5 {}
#[doc = "`write(|w| ..)` method takes [sfspc_5::W](sfspc_5::W) writer structure"]
impl crate::Writable for SFSPC_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_6](sfspc_6) module"]
pub type SFSPC_6 = crate::Reg<u32, _SFSPC_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_6;
#[doc = "`read()` method returns [sfspc_6::R](sfspc_6::R) reader structure"]
impl crate::Readable for SFSPC_6 {}
#[doc = "`write(|w| ..)` method takes [sfspc_6::W](sfspc_6::W) writer structure"]
impl crate::Writable for SFSPC_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_7](sfspc_7) module"]
pub type SFSPC_7 = crate::Reg<u32, _SFSPC_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_7;
#[doc = "`read()` method returns [sfspc_7::R](sfspc_7::R) reader structure"]
impl crate::Readable for SFSPC_7 {}
#[doc = "`write(|w| ..)` method takes [sfspc_7::W](sfspc_7::W) writer structure"]
impl crate::Writable for SFSPC_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_8](sfspc_8) module"]
pub type SFSPC_8 = crate::Reg<u32, _SFSPC_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_8;
#[doc = "`read()` method returns [sfspc_8::R](sfspc_8::R) reader structure"]
impl crate::Readable for SFSPC_8 {}
#[doc = "`write(|w| ..)` method takes [sfspc_8::W](sfspc_8::W) writer structure"]
impl crate::Writable for SFSPC_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_9](sfspc_9) module"]
pub type SFSPC_9 = crate::Reg<u32, _SFSPC_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_9;
#[doc = "`read()` method returns [sfspc_9::R](sfspc_9::R) reader structure"]
impl crate::Readable for SFSPC_9 {}
#[doc = "`write(|w| ..)` method takes [sfspc_9::W](sfspc_9::W) writer structure"]
impl crate::Writable for SFSPC_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_10](sfspc_10) module"]
pub type SFSPC_10 = crate::Reg<u32, _SFSPC_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_10;
#[doc = "`read()` method returns [sfspc_10::R](sfspc_10::R) reader structure"]
impl crate::Readable for SFSPC_10 {}
#[doc = "`write(|w| ..)` method takes [sfspc_10::W](sfspc_10::W) writer structure"]
impl crate::Writable for SFSPC_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_11](sfspc_11) module"]
pub type SFSPC_11 = crate::Reg<u32, _SFSPC_11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_11;
#[doc = "`read()` method returns [sfspc_11::R](sfspc_11::R) reader structure"]
impl crate::Readable for SFSPC_11 {}
#[doc = "`write(|w| ..)` method takes [sfspc_11::W](sfspc_11::W) writer structure"]
impl crate::Writable for SFSPC_11 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_11;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_12](sfspc_12) module"]
pub type SFSPC_12 = crate::Reg<u32, _SFSPC_12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_12;
#[doc = "`read()` method returns [sfspc_12::R](sfspc_12::R) reader structure"]
impl crate::Readable for SFSPC_12 {}
#[doc = "`write(|w| ..)` method takes [sfspc_12::W](sfspc_12::W) writer structure"]
impl crate::Writable for SFSPC_12 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_12;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_13](sfspc_13) module"]
pub type SFSPC_13 = crate::Reg<u32, _SFSPC_13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_13;
#[doc = "`read()` method returns [sfspc_13::R](sfspc_13::R) reader structure"]
impl crate::Readable for SFSPC_13 {}
#[doc = "`write(|w| ..)` method takes [sfspc_13::W](sfspc_13::W) writer structure"]
impl crate::Writable for SFSPC_13 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_13;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspc_14](sfspc_14) module"]
pub type SFSPC_14 = crate::Reg<u32, _SFSPC_14>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPC_14;
#[doc = "`read()` method returns [sfspc_14::R](sfspc_14::R) reader structure"]
impl crate::Readable for SFSPC_14 {}
#[doc = "`write(|w| ..)` method takes [sfspc_14::W](sfspc_14::W) writer structure"]
impl crate::Writable for SFSPC_14 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspc_14;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_0](sfspd_0) module"]
pub type SFSPD_0 = crate::Reg<u32, _SFSPD_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_0;
#[doc = "`read()` method returns [sfspd_0::R](sfspd_0::R) reader structure"]
impl crate::Readable for SFSPD_0 {}
#[doc = "`write(|w| ..)` method takes [sfspd_0::W](sfspd_0::W) writer structure"]
impl crate::Writable for SFSPD_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_1](sfspd_1) module"]
pub type SFSPD_1 = crate::Reg<u32, _SFSPD_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_1;
#[doc = "`read()` method returns [sfspd_1::R](sfspd_1::R) reader structure"]
impl crate::Readable for SFSPD_1 {}
#[doc = "`write(|w| ..)` method takes [sfspd_1::W](sfspd_1::W) writer structure"]
impl crate::Writable for SFSPD_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_2](sfspd_2) module"]
pub type SFSPD_2 = crate::Reg<u32, _SFSPD_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_2;
#[doc = "`read()` method returns [sfspd_2::R](sfspd_2::R) reader structure"]
impl crate::Readable for SFSPD_2 {}
#[doc = "`write(|w| ..)` method takes [sfspd_2::W](sfspd_2::W) writer structure"]
impl crate::Writable for SFSPD_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_3](sfspd_3) module"]
pub type SFSPD_3 = crate::Reg<u32, _SFSPD_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_3;
#[doc = "`read()` method returns [sfspd_3::R](sfspd_3::R) reader structure"]
impl crate::Readable for SFSPD_3 {}
#[doc = "`write(|w| ..)` method takes [sfspd_3::W](sfspd_3::W) writer structure"]
impl crate::Writable for SFSPD_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_4](sfspd_4) module"]
pub type SFSPD_4 = crate::Reg<u32, _SFSPD_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_4;
#[doc = "`read()` method returns [sfspd_4::R](sfspd_4::R) reader structure"]
impl crate::Readable for SFSPD_4 {}
#[doc = "`write(|w| ..)` method takes [sfspd_4::W](sfspd_4::W) writer structure"]
impl crate::Writable for SFSPD_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_5](sfspd_5) module"]
pub type SFSPD_5 = crate::Reg<u32, _SFSPD_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_5;
#[doc = "`read()` method returns [sfspd_5::R](sfspd_5::R) reader structure"]
impl crate::Readable for SFSPD_5 {}
#[doc = "`write(|w| ..)` method takes [sfspd_5::W](sfspd_5::W) writer structure"]
impl crate::Writable for SFSPD_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_6](sfspd_6) module"]
pub type SFSPD_6 = crate::Reg<u32, _SFSPD_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_6;
#[doc = "`read()` method returns [sfspd_6::R](sfspd_6::R) reader structure"]
impl crate::Readable for SFSPD_6 {}
#[doc = "`write(|w| ..)` method takes [sfspd_6::W](sfspd_6::W) writer structure"]
impl crate::Writable for SFSPD_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_7](sfspd_7) module"]
pub type SFSPD_7 = crate::Reg<u32, _SFSPD_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_7;
#[doc = "`read()` method returns [sfspd_7::R](sfspd_7::R) reader structure"]
impl crate::Readable for SFSPD_7 {}
#[doc = "`write(|w| ..)` method takes [sfspd_7::W](sfspd_7::W) writer structure"]
impl crate::Writable for SFSPD_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_8](sfspd_8) module"]
pub type SFSPD_8 = crate::Reg<u32, _SFSPD_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_8;
#[doc = "`read()` method returns [sfspd_8::R](sfspd_8::R) reader structure"]
impl crate::Readable for SFSPD_8 {}
#[doc = "`write(|w| ..)` method takes [sfspd_8::W](sfspd_8::W) writer structure"]
impl crate::Writable for SFSPD_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_9](sfspd_9) module"]
pub type SFSPD_9 = crate::Reg<u32, _SFSPD_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_9;
#[doc = "`read()` method returns [sfspd_9::R](sfspd_9::R) reader structure"]
impl crate::Readable for SFSPD_9 {}
#[doc = "`write(|w| ..)` method takes [sfspd_9::W](sfspd_9::W) writer structure"]
impl crate::Writable for SFSPD_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_10](sfspd_10) module"]
pub type SFSPD_10 = crate::Reg<u32, _SFSPD_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_10;
#[doc = "`read()` method returns [sfspd_10::R](sfspd_10::R) reader structure"]
impl crate::Readable for SFSPD_10 {}
#[doc = "`write(|w| ..)` method takes [sfspd_10::W](sfspd_10::W) writer structure"]
impl crate::Writable for SFSPD_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_11](sfspd_11) module"]
pub type SFSPD_11 = crate::Reg<u32, _SFSPD_11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_11;
#[doc = "`read()` method returns [sfspd_11::R](sfspd_11::R) reader structure"]
impl crate::Readable for SFSPD_11 {}
#[doc = "`write(|w| ..)` method takes [sfspd_11::W](sfspd_11::W) writer structure"]
impl crate::Writable for SFSPD_11 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_11;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_12](sfspd_12) module"]
pub type SFSPD_12 = crate::Reg<u32, _SFSPD_12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_12;
#[doc = "`read()` method returns [sfspd_12::R](sfspd_12::R) reader structure"]
impl crate::Readable for SFSPD_12 {}
#[doc = "`write(|w| ..)` method takes [sfspd_12::W](sfspd_12::W) writer structure"]
impl crate::Writable for SFSPD_12 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_12;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_13](sfspd_13) module"]
pub type SFSPD_13 = crate::Reg<u32, _SFSPD_13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_13;
#[doc = "`read()` method returns [sfspd_13::R](sfspd_13::R) reader structure"]
impl crate::Readable for SFSPD_13 {}
#[doc = "`write(|w| ..)` method takes [sfspd_13::W](sfspd_13::W) writer structure"]
impl crate::Writable for SFSPD_13 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_13;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_14](sfspd_14) module"]
pub type SFSPD_14 = crate::Reg<u32, _SFSPD_14>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_14;
#[doc = "`read()` method returns [sfspd_14::R](sfspd_14::R) reader structure"]
impl crate::Readable for SFSPD_14 {}
#[doc = "`write(|w| ..)` method takes [sfspd_14::W](sfspd_14::W) writer structure"]
impl crate::Writable for SFSPD_14 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_14;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_15](sfspd_15) module"]
pub type SFSPD_15 = crate::Reg<u32, _SFSPD_15>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_15;
#[doc = "`read()` method returns [sfspd_15::R](sfspd_15::R) reader structure"]
impl crate::Readable for SFSPD_15 {}
#[doc = "`write(|w| ..)` method takes [sfspd_15::W](sfspd_15::W) writer structure"]
impl crate::Writable for SFSPD_15 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_15;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspd_16](sfspd_16) module"]
pub type SFSPD_16 = crate::Reg<u32, _SFSPD_16>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPD_16;
#[doc = "`read()` method returns [sfspd_16::R](sfspd_16::R) reader structure"]
impl crate::Readable for SFSPD_16 {}
#[doc = "`write(|w| ..)` method takes [sfspd_16::W](sfspd_16::W) writer structure"]
impl crate::Writable for SFSPD_16 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspd_16;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_0](sfspe_0) module"]
pub type SFSPE_0 = crate::Reg<u32, _SFSPE_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_0;
#[doc = "`read()` method returns [sfspe_0::R](sfspe_0::R) reader structure"]
impl crate::Readable for SFSPE_0 {}
#[doc = "`write(|w| ..)` method takes [sfspe_0::W](sfspe_0::W) writer structure"]
impl crate::Writable for SFSPE_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_1](sfspe_1) module"]
pub type SFSPE_1 = crate::Reg<u32, _SFSPE_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_1;
#[doc = "`read()` method returns [sfspe_1::R](sfspe_1::R) reader structure"]
impl crate::Readable for SFSPE_1 {}
#[doc = "`write(|w| ..)` method takes [sfspe_1::W](sfspe_1::W) writer structure"]
impl crate::Writable for SFSPE_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_2](sfspe_2) module"]
pub type SFSPE_2 = crate::Reg<u32, _SFSPE_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_2;
#[doc = "`read()` method returns [sfspe_2::R](sfspe_2::R) reader structure"]
impl crate::Readable for SFSPE_2 {}
#[doc = "`write(|w| ..)` method takes [sfspe_2::W](sfspe_2::W) writer structure"]
impl crate::Writable for SFSPE_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_3](sfspe_3) module"]
pub type SFSPE_3 = crate::Reg<u32, _SFSPE_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_3;
#[doc = "`read()` method returns [sfspe_3::R](sfspe_3::R) reader structure"]
impl crate::Readable for SFSPE_3 {}
#[doc = "`write(|w| ..)` method takes [sfspe_3::W](sfspe_3::W) writer structure"]
impl crate::Writable for SFSPE_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_4](sfspe_4) module"]
pub type SFSPE_4 = crate::Reg<u32, _SFSPE_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_4;
#[doc = "`read()` method returns [sfspe_4::R](sfspe_4::R) reader structure"]
impl crate::Readable for SFSPE_4 {}
#[doc = "`write(|w| ..)` method takes [sfspe_4::W](sfspe_4::W) writer structure"]
impl crate::Writable for SFSPE_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_5](sfspe_5) module"]
pub type SFSPE_5 = crate::Reg<u32, _SFSPE_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_5;
#[doc = "`read()` method returns [sfspe_5::R](sfspe_5::R) reader structure"]
impl crate::Readable for SFSPE_5 {}
#[doc = "`write(|w| ..)` method takes [sfspe_5::W](sfspe_5::W) writer structure"]
impl crate::Writable for SFSPE_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_6](sfspe_6) module"]
pub type SFSPE_6 = crate::Reg<u32, _SFSPE_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_6;
#[doc = "`read()` method returns [sfspe_6::R](sfspe_6::R) reader structure"]
impl crate::Readable for SFSPE_6 {}
#[doc = "`write(|w| ..)` method takes [sfspe_6::W](sfspe_6::W) writer structure"]
impl crate::Writable for SFSPE_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_7](sfspe_7) module"]
pub type SFSPE_7 = crate::Reg<u32, _SFSPE_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_7;
#[doc = "`read()` method returns [sfspe_7::R](sfspe_7::R) reader structure"]
impl crate::Readable for SFSPE_7 {}
#[doc = "`write(|w| ..)` method takes [sfspe_7::W](sfspe_7::W) writer structure"]
impl crate::Writable for SFSPE_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_8](sfspe_8) module"]
pub type SFSPE_8 = crate::Reg<u32, _SFSPE_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_8;
#[doc = "`read()` method returns [sfspe_8::R](sfspe_8::R) reader structure"]
impl crate::Readable for SFSPE_8 {}
#[doc = "`write(|w| ..)` method takes [sfspe_8::W](sfspe_8::W) writer structure"]
impl crate::Writable for SFSPE_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_9](sfspe_9) module"]
pub type SFSPE_9 = crate::Reg<u32, _SFSPE_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_9;
#[doc = "`read()` method returns [sfspe_9::R](sfspe_9::R) reader structure"]
impl crate::Readable for SFSPE_9 {}
#[doc = "`write(|w| ..)` method takes [sfspe_9::W](sfspe_9::W) writer structure"]
impl crate::Writable for SFSPE_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_10](sfspe_10) module"]
pub type SFSPE_10 = crate::Reg<u32, _SFSPE_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_10;
#[doc = "`read()` method returns [sfspe_10::R](sfspe_10::R) reader structure"]
impl crate::Readable for SFSPE_10 {}
#[doc = "`write(|w| ..)` method takes [sfspe_10::W](sfspe_10::W) writer structure"]
impl crate::Writable for SFSPE_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_11](sfspe_11) module"]
pub type SFSPE_11 = crate::Reg<u32, _SFSPE_11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_11;
#[doc = "`read()` method returns [sfspe_11::R](sfspe_11::R) reader structure"]
impl crate::Readable for SFSPE_11 {}
#[doc = "`write(|w| ..)` method takes [sfspe_11::W](sfspe_11::W) writer structure"]
impl crate::Writable for SFSPE_11 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_11;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_12](sfspe_12) module"]
pub type SFSPE_12 = crate::Reg<u32, _SFSPE_12>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_12;
#[doc = "`read()` method returns [sfspe_12::R](sfspe_12::R) reader structure"]
impl crate::Readable for SFSPE_12 {}
#[doc = "`write(|w| ..)` method takes [sfspe_12::W](sfspe_12::W) writer structure"]
impl crate::Writable for SFSPE_12 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_12;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_13](sfspe_13) module"]
pub type SFSPE_13 = crate::Reg<u32, _SFSPE_13>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_13;
#[doc = "`read()` method returns [sfspe_13::R](sfspe_13::R) reader structure"]
impl crate::Readable for SFSPE_13 {}
#[doc = "`write(|w| ..)` method takes [sfspe_13::W](sfspe_13::W) writer structure"]
impl crate::Writable for SFSPE_13 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_13;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_14](sfspe_14) module"]
pub type SFSPE_14 = crate::Reg<u32, _SFSPE_14>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_14;
#[doc = "`read()` method returns [sfspe_14::R](sfspe_14::R) reader structure"]
impl crate::Readable for SFSPE_14 {}
#[doc = "`write(|w| ..)` method takes [sfspe_14::W](sfspe_14::W) writer structure"]
impl crate::Writable for SFSPE_14 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_14;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspe_15](sfspe_15) module"]
pub type SFSPE_15 = crate::Reg<u32, _SFSPE_15>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPE_15;
#[doc = "`read()` method returns [sfspe_15::R](sfspe_15::R) reader structure"]
impl crate::Readable for SFSPE_15 {}
#[doc = "`write(|w| ..)` method takes [sfspe_15::W](sfspe_15::W) writer structure"]
impl crate::Writable for SFSPE_15 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspe_15;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_0](sfspf_0) module"]
pub type SFSPF_0 = crate::Reg<u32, _SFSPF_0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_0;
#[doc = "`read()` method returns [sfspf_0::R](sfspf_0::R) reader structure"]
impl crate::Readable for SFSPF_0 {}
#[doc = "`write(|w| ..)` method takes [sfspf_0::W](sfspf_0::W) writer structure"]
impl crate::Writable for SFSPF_0 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_0;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_1](sfspf_1) module"]
pub type SFSPF_1 = crate::Reg<u32, _SFSPF_1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_1;
#[doc = "`read()` method returns [sfspf_1::R](sfspf_1::R) reader structure"]
impl crate::Readable for SFSPF_1 {}
#[doc = "`write(|w| ..)` method takes [sfspf_1::W](sfspf_1::W) writer structure"]
impl crate::Writable for SFSPF_1 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_1;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_2](sfspf_2) module"]
pub type SFSPF_2 = crate::Reg<u32, _SFSPF_2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_2;
#[doc = "`read()` method returns [sfspf_2::R](sfspf_2::R) reader structure"]
impl crate::Readable for SFSPF_2 {}
#[doc = "`write(|w| ..)` method takes [sfspf_2::W](sfspf_2::W) writer structure"]
impl crate::Writable for SFSPF_2 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_2;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_3](sfspf_3) module"]
pub type SFSPF_3 = crate::Reg<u32, _SFSPF_3>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_3;
#[doc = "`read()` method returns [sfspf_3::R](sfspf_3::R) reader structure"]
impl crate::Readable for SFSPF_3 {}
#[doc = "`write(|w| ..)` method takes [sfspf_3::W](sfspf_3::W) writer structure"]
impl crate::Writable for SFSPF_3 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_3;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_4](sfspf_4) module"]
pub type SFSPF_4 = crate::Reg<u32, _SFSPF_4>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_4;
#[doc = "`read()` method returns [sfspf_4::R](sfspf_4::R) reader structure"]
impl crate::Readable for SFSPF_4 {}
#[doc = "`write(|w| ..)` method takes [sfspf_4::W](sfspf_4::W) writer structure"]
impl crate::Writable for SFSPF_4 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_4;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_5](sfspf_5) module"]
pub type SFSPF_5 = crate::Reg<u32, _SFSPF_5>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_5;
#[doc = "`read()` method returns [sfspf_5::R](sfspf_5::R) reader structure"]
impl crate::Readable for SFSPF_5 {}
#[doc = "`write(|w| ..)` method takes [sfspf_5::W](sfspf_5::W) writer structure"]
impl crate::Writable for SFSPF_5 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_5;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_6](sfspf_6) module"]
pub type SFSPF_6 = crate::Reg<u32, _SFSPF_6>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_6;
#[doc = "`read()` method returns [sfspf_6::R](sfspf_6::R) reader structure"]
impl crate::Readable for SFSPF_6 {}
#[doc = "`write(|w| ..)` method takes [sfspf_6::W](sfspf_6::W) writer structure"]
impl crate::Writable for SFSPF_6 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_6;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_7](sfspf_7) module"]
pub type SFSPF_7 = crate::Reg<u32, _SFSPF_7>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_7;
#[doc = "`read()` method returns [sfspf_7::R](sfspf_7::R) reader structure"]
impl crate::Readable for SFSPF_7 {}
#[doc = "`write(|w| ..)` method takes [sfspf_7::W](sfspf_7::W) writer structure"]
impl crate::Writable for SFSPF_7 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_7;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_8](sfspf_8) module"]
pub type SFSPF_8 = crate::Reg<u32, _SFSPF_8>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_8;
#[doc = "`read()` method returns [sfspf_8::R](sfspf_8::R) reader structure"]
impl crate::Readable for SFSPF_8 {}
#[doc = "`write(|w| ..)` method takes [sfspf_8::W](sfspf_8::W) writer structure"]
impl crate::Writable for SFSPF_8 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_8;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_9](sfspf_9) module"]
pub type SFSPF_9 = crate::Reg<u32, _SFSPF_9>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_9;
#[doc = "`read()` method returns [sfspf_9::R](sfspf_9::R) reader structure"]
impl crate::Readable for SFSPF_9 {}
#[doc = "`write(|w| ..)` method takes [sfspf_9::W](sfspf_9::W) writer structure"]
impl crate::Writable for SFSPF_9 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_9;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_10](sfspf_10) module"]
pub type SFSPF_10 = crate::Reg<u32, _SFSPF_10>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_10;
#[doc = "`read()` method returns [sfspf_10::R](sfspf_10::R) reader structure"]
impl crate::Readable for SFSPF_10 {}
#[doc = "`write(|w| ..)` method takes [sfspf_10::W](sfspf_10::W) writer structure"]
impl crate::Writable for SFSPF_10 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_10;
#[doc = "Pin configuration register for a normal-drive pin\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfspf_11](sfspf_11) module"]
pub type SFSPF_11 = crate::Reg<u32, _SFSPF_11>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSPF_11;
#[doc = "`read()` method returns [sfspf_11::R](sfspf_11::R) reader structure"]
impl crate::Readable for SFSPF_11 {}
#[doc = "`write(|w| ..)` method takes [sfspf_11::W](sfspf_11::W) writer structure"]
impl crate::Writable for SFSPF_11 {}
#[doc = "Pin configuration register for a normal-drive pin"]
pub mod sfspf_11;
#[doc = "Pin configuration register for pins CLK\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsclk_](sfsclk_) module"]
pub type SFSCLK_ = crate::Reg<u32, _SFSCLK_>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSCLK_;
#[doc = "`read()` method returns [sfsclk_::R](sfsclk_::R) reader structure"]
impl crate::Readable for SFSCLK_ {}
#[doc = "`write(|w| ..)` method takes [sfsclk_::W](sfsclk_::W) writer structure"]
impl crate::Writable for SFSCLK_ {}
#[doc = "Pin configuration register for pins CLK"]
pub mod sfsclk_;
#[doc = "Pin configuration register for pins USB1_DM and USB1_DP\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsusb](sfsusb) module"]
pub type SFSUSB = crate::Reg<u32, _SFSUSB>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSUSB;
#[doc = "`read()` method returns [sfsusb::R](sfsusb::R) reader structure"]
impl crate::Readable for SFSUSB {}
#[doc = "`write(|w| ..)` method takes [sfsusb::W](sfsusb::W) writer structure"]
impl crate::Writable for SFSUSB {}
#[doc = "Pin configuration register for pins USB1_DM and USB1_DP"]
pub mod sfsusb;
#[doc = "Pin configuration register for I2C0-bus pins\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sfsi2c0](sfsi2c0) module"]
pub type SFSI2C0 = crate::Reg<u32, _SFSI2C0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SFSI2C0;
#[doc = "`read()` method returns [sfsi2c0::R](sfsi2c0::R) reader structure"]
impl crate::Readable for SFSI2C0 {}
#[doc = "`write(|w| ..)` method takes [sfsi2c0::W](sfsi2c0::W) writer structure"]
impl crate::Writable for SFSI2C0 {}
#[doc = "Pin configuration register for I2C0-bus pins"]
pub mod sfsi2c0;
#[doc = "ADC0 function select register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [enaio0](enaio0) module"]
pub type ENAIO0 = crate::Reg<u32, _ENAIO0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ENAIO0;
#[doc = "`read()` method returns [enaio0::R](enaio0::R) reader structure"]
impl crate::Readable for ENAIO0 {}
#[doc = "`write(|w| ..)` method takes [enaio0::W](enaio0::W) writer structure"]
impl crate::Writable for ENAIO0 {}
#[doc = "ADC0 function select register"]
pub mod enaio0;
#[doc = "ADC1 function select register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [enaio1](enaio1) module"]
pub type ENAIO1 = crate::Reg<u32, _ENAIO1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ENAIO1;
#[doc = "`read()` method returns [enaio1::R](enaio1::R) reader structure"]
impl crate::Readable for ENAIO1 {}
#[doc = "`write(|w| ..)` method takes [enaio1::W](enaio1::W) writer structure"]
impl crate::Writable for ENAIO1 {}
#[doc = "ADC1 function select register"]
pub mod enaio1;
#[doc = "Analog function select register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [enaio2](enaio2) module"]
pub type ENAIO2 = crate::Reg<u32, _ENAIO2>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _ENAIO2;
#[doc = "`read()` method returns [enaio2::R](enaio2::R) reader structure"]
impl crate::Readable for ENAIO2 {}
#[doc = "`write(|w| ..)` method takes [enaio2::W](enaio2::W) writer structure"]
impl crate::Writable for ENAIO2 {}
#[doc = "Analog function select register"]
pub mod enaio2;
#[doc = "EMC clock delay register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [emcdelayclk](emcdelayclk) module"]
pub type EMCDELAYCLK = crate::Reg<u32, _EMCDELAYCLK>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _EMCDELAYCLK;
#[doc = "`read()` method returns [emcdelayclk::R](emcdelayclk::R) reader structure"]
impl crate::Readable for EMCDELAYCLK {}
#[doc = "`write(|w| ..)` method takes [emcdelayclk::W](emcdelayclk::W) writer structure"]
impl crate::Writable for EMCDELAYCLK {}
#[doc = "EMC clock delay register"]
pub mod emcdelayclk;
#[doc = "SD/MMC sample and drive delay register\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [sddelay](sddelay) module"]
pub type SDDELAY = crate::Reg<u32, _SDDELAY>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _SDDELAY;
#[doc = "`read()` method returns [sddelay::R](sddelay::R) reader structure"]
impl crate::Readable for SDDELAY {}
#[doc = "`write(|w| ..)` method takes [sddelay::W](sddelay::W) writer structure"]
impl crate::Writable for SDDELAY {}
#[doc = "SD/MMC sample and drive delay register"]
pub mod sddelay;
#[doc = "Pin interrupt select register for pin interrupts 0 to 3.\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pintsel0](pintsel0) module"]
pub type PINTSEL0 = crate::Reg<u32, _PINTSEL0>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PINTSEL0;
#[doc = "`read()` method returns [pintsel0::R](pintsel0::R) reader structure"]
impl crate::Readable for PINTSEL0 {}
#[doc = "`write(|w| ..)` method takes [pintsel0::W](pintsel0::W) writer structure"]
impl crate::Writable for PINTSEL0 {}
#[doc = "Pin interrupt select register for pin interrupts 0 to 3."]
pub mod pintsel0;
#[doc = "Pin interrupt select register for pin interrupts 4 to 7.\n\nThis register you can [`read`](crate::generic::Reg::read), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about avaliable fields see [pintsel1](pintsel1) module"]
pub type PINTSEL1 = crate::Reg<u32, _PINTSEL1>;
#[allow(missing_docs)]
#[doc(hidden)]
pub struct _PINTSEL1;
#[doc = "`read()` method returns [pintsel1::R](pintsel1::R) reader structure"]
impl crate::Readable for PINTSEL1 {}
#[doc = "`write(|w| ..)` method takes [pintsel1::W](pintsel1::W) writer structure"]
impl crate::Writable for PINTSEL1 {}
#[doc = "Pin interrupt select register for pin interrupts 4 to 7."]
pub mod pintsel1;
